/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylval          base_yylval
#define yychar          base_yychar
#define yylloc          base_yylloc

/* First part of user prologue.  */
#line 5 "preproc.y"

#include "postgres_fe.h"

#include "extern.h"
#include "ecpg_config.h"
#include <unistd.h>

/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N)						\
			(Current) = (Rhs)[1];	\
		else						\
			(Current) = (Rhs)[0];	\
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

/*
 * This is only here so the string gets into the POT.  Bison uses it
 * internally.
 */
#define bison_gettext_dummy gettext_noop("syntax error")

/*
 * Variables containing simple states.
 */
int struct_level = 0;
int braces_open; /* brace level counter */
char *current_function;
int ecpg_internal_var = 0;
char	*connection = NULL;
char	*input_filename = NULL;

static int	FoundInto = 0;
static int	initializer = 0;
static int	pacounter = 1;
static char	pacounter_buffer[sizeof(int) * CHAR_BIT * 10 / 3]; /* a rough guess at the size we need */
static struct this_type actual_type[STRUCT_DEPTH];
static char *actual_startline[STRUCT_DEPTH];
static int	varchar_counter = 1;

/* temporarily store struct members while creating the data structure */
struct ECPGstruct_member *struct_member_list[STRUCT_DEPTH] = { NULL };

/* also store struct type so we can do a sizeof() later */
static char *ECPGstruct_sizeof = NULL;

/* for forward declarations we have to store some data as well */
static char *forward_name = NULL;

struct ECPGtype ecpg_no_indicator = {ECPGt_NO_INDICATOR, NULL, NULL, NULL, {NULL}, 0};
struct variable no_indicator = {"no_indicator", &ecpg_no_indicator, 0, NULL};

static struct ECPGtype ecpg_query = {ECPGt_char_variable, NULL, NULL, NULL, {NULL}, 0};

static void vmmerror(int error_code, enum errortype type, const char *error, va_list ap) pg_attribute_printf(3, 0);

/*
 * Handle parsing errors and warnings
 */
static void
vmmerror(int error_code, enum errortype type, const char *error, va_list ap)
{
	/* localize the error message string */
	error = _(error);

	fprintf(stderr, "%s:%d: ", input_filename, base_yylineno);

	switch(type)
	{
		case ET_WARNING:
			fprintf(stderr, _("WARNING: "));
			break;
		case ET_ERROR:
			fprintf(stderr, _("ERROR: "));
			break;
	}

	vfprintf(stderr, error, ap);

	fprintf(stderr, "\n");

	switch(type)
	{
		case ET_WARNING:
			break;
		case ET_ERROR:
			ret_value = error_code;
			break;
	}
}

void
mmerror(int error_code, enum errortype type, const char *error, ...)
{
	va_list		ap;

	va_start(ap, error);
	vmmerror(error_code, type, error, ap);
	va_end(ap);
}

void
mmfatal(int error_code, const char *error, ...)
{
	va_list		ap;

	va_start(ap, error);
	vmmerror(error_code, ET_ERROR, error, ap);
	va_end(ap);

	if (base_yyin)
		fclose(base_yyin);
	if (base_yyout)
		fclose(base_yyout);

	if (strcmp(output_filename, "-") != 0 && unlink(output_filename) != 0)
		fprintf(stderr, _("could not remove output file \"%s\"\n"), output_filename);
	exit(error_code);
}

/*
 * string concatenation
 */

static char *
cat2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 2);

	strcpy(res_str, str1);
	if (strlen(str1) != 0 && strlen(str2) != 0)
		strcat(res_str, " ");
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
cat_str(int count, ...)
{
	va_list		args;
	int			i;
	char		*res_str;

	va_start(args, count);

	res_str = va_arg(args, char *);

	/* now add all other strings */
	for (i = 1; i < count; i++)
		res_str = cat2_str(res_str, va_arg(args, char *));

	va_end(args);

	return(res_str);
}

static char *
make2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
make3_str(char *str1, char *str2, char *str3)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) +strlen(str3) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	strcat(res_str, str3);
	free(str1);
	free(str2);
	free(str3);
	return(res_str);
}

/* and the rest */
static char *
make_name(void)
{
	return mm_strdup(base_yytext);
}

static char *
create_questionmarks(char *name, bool array)
{
	struct variable *p = find_variable(name);
	int count;
	char *result = EMPTY;

	/* In case we have a struct, we have to print as many "?" as there are attributes in the struct
	 * An array is only allowed together with an element argument
	 * This is essentially only used for inserts, but using a struct as input parameter is an error anywhere else
	 * so we don't have to worry here. */

	if (p->type->type == ECPGt_struct || (array && p->type->type == ECPGt_array && p->type->u.element->type == ECPGt_struct))
	{
		struct ECPGstruct_member *m;

		if (p->type->type == ECPGt_struct)
			m = p->type->u.members;
		else
			m = p->type->u.element->u.members;

		for (count = 0; m != NULL; m=m->next, count++);
	}
	else
		count = 1;

	for (; count > 0; count --)
	{
		sprintf(pacounter_buffer, "$%d", pacounter++);
		result = cat_str(3, result, mm_strdup(pacounter_buffer), mm_strdup(" , "));
	}

	/* removed the trailing " ," */

	result[strlen(result)-3] = '\0';
	return(result);
}

static char *
adjust_outofscope_cursor_vars(struct cursor *cur)
{
	/* Informix accepts DECLARE with variables that are out of scope when OPEN is called.
	 * For instance you can DECLARE a cursor in one function, and OPEN/FETCH/CLOSE
	 * it in another functions. This is very useful for e.g. event-driver programming,
	 * but may also lead to dangerous programming. The limitation when this is allowed
	 * and doesn't cause problems have to be documented, like the allocated variables
	 * must not be realloc()'ed.
	 *
	 * We have to change the variables to our own struct and just store the pointer
	 * instead of the variable. Do it only for local variables, not for globals.
	 */

	char *result = EMPTY;
	int insert;

	for (insert = 1; insert >= 0; insert--)
	{
		struct arguments *list;
		struct arguments *ptr;
		struct arguments *newlist = NULL;
		struct variable *newvar, *newind;

		list = (insert ? cur->argsinsert : cur->argsresult);

		for (ptr = list; ptr != NULL; ptr = ptr->next)
		{
			char var_text[20];
			char *original_var;
			bool skip_set_var = false;
			bool var_ptr = false;

			/* change variable name to "ECPGget_var(<counter>)" */
			original_var = ptr->variable->name;
			sprintf(var_text, "%d))", ecpg_internal_var);

			/* Don't emit ECPGset_var() calls for global variables */
			if (ptr->variable->brace_level == 0)
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type == ECPGt_char_variable)
					 && (strncmp(ptr->variable->name, "ECPGprepared_statement", strlen("ECPGprepared_statement")) == 0))
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type != ECPGt_varchar
					  && ptr->variable->type->type != ECPGt_char
					  && ptr->variable->type->type != ECPGt_unsigned_char
					  && ptr->variable->type->type != ECPGt_string)
					 && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, mm_strdup("("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->u.element->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type,
																			   mm_strdup("1"),
																			   ptr->variable->type->u.element->counter),
														  ptr->variable->type->size),
									  0);
			}
			else if ((ptr->variable->type->type == ECPGt_varchar
					  || ptr->variable->type->type == ECPGt_char
					  || ptr->variable->type->type == ECPGt_unsigned_char
					  || ptr->variable->type->type == ECPGt_string)
					 && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, mm_strdup("("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_simple_type(ptr->variable->type->type,
														   ptr->variable->type->size,
														   ptr->variable->type->counter),
									  0);
				if (ptr->variable->type->type == ECPGt_varchar)
					var_ptr = true;
			}
			else if (ptr->variable->type->type == ECPGt_struct
					 || ptr->variable->type->type == ECPGt_union)
			{
				newvar = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->variable->type->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
									  ECPGmake_struct_type(ptr->variable->type->u.members,
														   ptr->variable->type->type,
														   ptr->variable->type->type_name,
														   ptr->variable->type->struct_sizeof),
									  0);
				var_ptr = true;
			}
			else if (ptr->variable->type->type == ECPGt_array)
			{
				if (ptr->variable->type->u.element->type == ECPGt_struct
					|| ptr->variable->type->u.element->type == ECPGt_union)
				{
					newvar = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->variable->type->u.element->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
										  ECPGmake_struct_type(ptr->variable->type->u.element->u.members,
															   ptr->variable->type->u.element->type,
															   ptr->variable->type->u.element->type_name,
															   ptr->variable->type->u.element->struct_sizeof),
										  0);
				}
				else
				{
					newvar = new_variable(cat_str(4, mm_strdup("("),
												  mm_strdup(ecpg_type_name(ptr->variable->type->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type,
																				   ptr->variable->type->u.element->size,
																				   ptr->variable->type->u.element->counter),
															  ptr->variable->type->size),
										  0);
					var_ptr = true;
				}
			}
			else
			{
				newvar = new_variable(cat_str(4, mm_strdup("*("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_simple_type(ptr->variable->type->type,
														   ptr->variable->type->size,
														   ptr->variable->type->counter),
									  0);
				var_ptr = true;
			}

			/* create call to "ECPGset_var(<counter>, <connection>, <pointer>. <line number>)" */
			if (!skip_set_var)
			{
				sprintf(var_text, "%d, %s", ecpg_internal_var++, var_ptr ? "&(" : "(");
				result = cat_str(5, result, mm_strdup("ECPGset_var("),
								 mm_strdup(var_text), mm_strdup(original_var),
								 mm_strdup("), __LINE__);\n"));
			}

			/* now the indicator if there is one and it's not a global variable */
			if ((ptr->indicator->type->type == ECPGt_NO_INDICATOR) || (ptr->indicator->brace_level == 0))
			{
				newind = ptr->indicator;
			}
			else
			{
				/* change variable name to "ECPGget_var(<counter>)" */
				original_var = ptr->indicator->name;
				sprintf(var_text, "%d))", ecpg_internal_var);
				var_ptr = false;

				if (ptr->indicator->type->type == ECPGt_struct
					|| ptr->indicator->type->type == ECPGt_union)
				{
					newind = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->indicator->type->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
										  ECPGmake_struct_type(ptr->indicator->type->u.members,
															   ptr->indicator->type->type,
															   ptr->indicator->type->type_name,
															   ptr->indicator->type->struct_sizeof),
										  0);
					var_ptr = true;
				}
				else if (ptr->indicator->type->type == ECPGt_array)
				{
					if (ptr->indicator->type->u.element->type == ECPGt_struct
						|| ptr->indicator->type->u.element->type == ECPGt_union)
					{
						newind = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->indicator->type->u.element->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
											  ECPGmake_struct_type(ptr->indicator->type->u.element->u.members,
																   ptr->indicator->type->u.element->type,
																   ptr->indicator->type->u.element->type_name,
																   ptr->indicator->type->u.element->struct_sizeof),
											  0);
					}
					else
					{
						newind = new_variable(cat_str(4, mm_strdup("("),
													  mm_strdup(ecpg_type_name(ptr->indicator->type->u.element->type)),
													  mm_strdup(" *)(ECPGget_var("), mm_strdup(var_text)),
											  ECPGmake_array_type(ECPGmake_simple_type(ptr->indicator->type->u.element->type,
																					   ptr->indicator->type->u.element->size,
																					   ptr->indicator->type->u.element->counter),
																  ptr->indicator->type->size),
											  0);
						var_ptr = true;
					}
				}
				else if (atoi(ptr->indicator->type->size) > 1)
				{
					newind = new_variable(cat_str(4, mm_strdup("("),
												  mm_strdup(ecpg_type_name(ptr->indicator->type->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_simple_type(ptr->indicator->type->type,
															   ptr->indicator->type->size,
															   ptr->variable->type->counter),
										  0);
				}
				else
				{
					newind = new_variable(cat_str(4, mm_strdup("*("),
												  mm_strdup(ecpg_type_name(ptr->indicator->type->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_simple_type(ptr->indicator->type->type,
															   ptr->indicator->type->size,
															   ptr->variable->type->counter),
										  0);
					var_ptr = true;
				}

				/* create call to "ECPGset_var(<counter>, <pointer>. <line number>)" */
				sprintf(var_text, "%d, %s", ecpg_internal_var++, var_ptr ? "&(" : "(");
				result = cat_str(5, result, mm_strdup("ECPGset_var("),
								 mm_strdup(var_text), mm_strdup(original_var),
								 mm_strdup("), __LINE__);\n"));
			}

			add_variable_to_tail(&newlist, newvar, newind);
		}

		if (insert)
			cur->argsinsert_oos = newlist;
		else
			cur->argsresult_oos = newlist;
	}

	return result;
}

/* This tests whether the cursor was declared and opened in the same function. */
#define SAMEFUNC(cur)	\
	((cur->function == NULL) ||		\
	 (cur->function != NULL && strcmp(cur->function, current_function) == 0))

static struct cursor *
add_additional_variables(char *name, bool insert)
{
	struct cursor *ptr;
	struct arguments *p;
	int (* strcmp_fn)(const char *, const char *) = ((name[0] == ':' || name[0] == '"') ? strcmp : pg_strcasecmp);

	for (ptr = cur; ptr != NULL; ptr=ptr->next)
	{
		if (strcmp_fn(ptr->name, name) == 0)
			break;
	}

	if (ptr == NULL)
	{
		mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" does not exist", name);
		return NULL;
	}

	if (insert)
	{
		/* add all those input variables that were given earlier
		 * note that we have to append here but have to keep the existing order */
		for (p = (SAMEFUNC(ptr) ? ptr->argsinsert : ptr->argsinsert_oos); p; p = p->next)
			add_variable_to_tail(&argsinsert, p->variable, p->indicator);
	}

	/* add all those output variables that were given earlier */
	for (p = (SAMEFUNC(ptr) ? ptr->argsresult : ptr->argsresult_oos); p; p = p->next)
		add_variable_to_tail(&argsresult, p->variable, p->indicator);

	return ptr;
}

static void
add_typedef(char *name, char *dimension, char *length, enum ECPGttype type_enum,
			char *type_dimension, char *type_index, int initializer, int array)
{
	/* add entry to list */
	struct typedefs *ptr, *this;

	if ((type_enum == ECPGt_struct ||
		 type_enum == ECPGt_union) &&
		initializer == 1)
		mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in type definition");
	else if (INFORMIX_MODE && strcmp(name, "string") == 0)
		mmerror(PARSE_ERROR, ET_ERROR, "type name \"string\" is reserved in Informix mode");
	else
	{
		for (ptr = types; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp(name, ptr->name) == 0)
				/* re-definition is a bug */
				mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", name);
		}
		adjust_array(type_enum, &dimension, &length, type_dimension, type_index, array, true);

		this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

		/* initial definition */
		this->next = types;
		this->name = name;
		this->brace_level = braces_open;
		this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
		this->type->type_enum = type_enum;
		this->type->type_str = mm_strdup(name);
		this->type->type_dimension = dimension; /* dimension of array */
		this->type->type_index = length;	/* length of string */
		this->type->type_sizeof = ECPGstruct_sizeof;
		this->struct_member_list = (type_enum == ECPGt_struct || type_enum == ECPGt_union) ?
		ECPGstruct_member_dup(struct_member_list[struct_level]) : NULL;

		if (type_enum != ECPGt_varchar &&
			type_enum != ECPGt_char &&
			type_enum != ECPGt_unsigned_char &&
			type_enum != ECPGt_string &&
			atoi(this->type->type_index) >= 0)
			mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

		types = this;
	}
}

#line 651 "preproc.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "preproc.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_SQL_ALLOCATE = 3,               /* SQL_ALLOCATE  */
  YYSYMBOL_SQL_AUTOCOMMIT = 4,             /* SQL_AUTOCOMMIT  */
  YYSYMBOL_SQL_BOOL = 5,                   /* SQL_BOOL  */
  YYSYMBOL_SQL_BREAK = 6,                  /* SQL_BREAK  */
  YYSYMBOL_SQL_CALL = 7,                   /* SQL_CALL  */
  YYSYMBOL_SQL_CARDINALITY = 8,            /* SQL_CARDINALITY  */
  YYSYMBOL_SQL_CONNECT = 9,                /* SQL_CONNECT  */
  YYSYMBOL_SQL_COUNT = 10,                 /* SQL_COUNT  */
  YYSYMBOL_SQL_DATETIME_INTERVAL_CODE = 11, /* SQL_DATETIME_INTERVAL_CODE  */
  YYSYMBOL_SQL_DATETIME_INTERVAL_PRECISION = 12, /* SQL_DATETIME_INTERVAL_PRECISION  */
  YYSYMBOL_SQL_DESCRIBE = 13,              /* SQL_DESCRIBE  */
  YYSYMBOL_SQL_DESCRIPTOR = 14,            /* SQL_DESCRIPTOR  */
  YYSYMBOL_SQL_DISCONNECT = 15,            /* SQL_DISCONNECT  */
  YYSYMBOL_SQL_FOUND = 16,                 /* SQL_FOUND  */
  YYSYMBOL_SQL_FREE = 17,                  /* SQL_FREE  */
  YYSYMBOL_SQL_GET = 18,                   /* SQL_GET  */
  YYSYMBOL_SQL_GO = 19,                    /* SQL_GO  */
  YYSYMBOL_SQL_GOTO = 20,                  /* SQL_GOTO  */
  YYSYMBOL_SQL_IDENTIFIED = 21,            /* SQL_IDENTIFIED  */
  YYSYMBOL_SQL_INDICATOR = 22,             /* SQL_INDICATOR  */
  YYSYMBOL_SQL_KEY_MEMBER = 23,            /* SQL_KEY_MEMBER  */
  YYSYMBOL_SQL_LENGTH = 24,                /* SQL_LENGTH  */
  YYSYMBOL_SQL_LONG = 25,                  /* SQL_LONG  */
  YYSYMBOL_SQL_NULLABLE = 26,              /* SQL_NULLABLE  */
  YYSYMBOL_SQL_OCTET_LENGTH = 27,          /* SQL_OCTET_LENGTH  */
  YYSYMBOL_SQL_OPEN = 28,                  /* SQL_OPEN  */
  YYSYMBOL_SQL_OUTPUT = 29,                /* SQL_OUTPUT  */
  YYSYMBOL_SQL_REFERENCE = 30,             /* SQL_REFERENCE  */
  YYSYMBOL_SQL_RETURNED_LENGTH = 31,       /* SQL_RETURNED_LENGTH  */
  YYSYMBOL_SQL_RETURNED_OCTET_LENGTH = 32, /* SQL_RETURNED_OCTET_LENGTH  */
  YYSYMBOL_SQL_SCALE = 33,                 /* SQL_SCALE  */
  YYSYMBOL_SQL_SECTION = 34,               /* SQL_SECTION  */
  YYSYMBOL_SQL_SHORT = 35,                 /* SQL_SHORT  */
  YYSYMBOL_SQL_SIGNED = 36,                /* SQL_SIGNED  */
  YYSYMBOL_SQL_SQLERROR = 37,              /* SQL_SQLERROR  */
  YYSYMBOL_SQL_SQLPRINT = 38,              /* SQL_SQLPRINT  */
  YYSYMBOL_SQL_SQLWARNING = 39,            /* SQL_SQLWARNING  */
  YYSYMBOL_SQL_START = 40,                 /* SQL_START  */
  YYSYMBOL_SQL_STOP = 41,                  /* SQL_STOP  */
  YYSYMBOL_SQL_STRUCT = 42,                /* SQL_STRUCT  */
  YYSYMBOL_SQL_UNSIGNED = 43,              /* SQL_UNSIGNED  */
  YYSYMBOL_SQL_VAR = 44,                   /* SQL_VAR  */
  YYSYMBOL_SQL_WHENEVER = 45,              /* SQL_WHENEVER  */
  YYSYMBOL_S_ADD = 46,                     /* S_ADD  */
  YYSYMBOL_S_AND = 47,                     /* S_AND  */
  YYSYMBOL_S_ANYTHING = 48,                /* S_ANYTHING  */
  YYSYMBOL_S_AUTO = 49,                    /* S_AUTO  */
  YYSYMBOL_S_CONST = 50,                   /* S_CONST  */
  YYSYMBOL_S_DEC = 51,                     /* S_DEC  */
  YYSYMBOL_S_DIV = 52,                     /* S_DIV  */
  YYSYMBOL_S_DOTPOINT = 53,                /* S_DOTPOINT  */
  YYSYMBOL_S_EQUAL = 54,                   /* S_EQUAL  */
  YYSYMBOL_S_EXTERN = 55,                  /* S_EXTERN  */
  YYSYMBOL_S_INC = 56,                     /* S_INC  */
  YYSYMBOL_S_LSHIFT = 57,                  /* S_LSHIFT  */
  YYSYMBOL_S_MEMPOINT = 58,                /* S_MEMPOINT  */
  YYSYMBOL_S_MEMBER = 59,                  /* S_MEMBER  */
  YYSYMBOL_S_MOD = 60,                     /* S_MOD  */
  YYSYMBOL_S_MUL = 61,                     /* S_MUL  */
  YYSYMBOL_S_NEQUAL = 62,                  /* S_NEQUAL  */
  YYSYMBOL_S_OR = 63,                      /* S_OR  */
  YYSYMBOL_S_REGISTER = 64,                /* S_REGISTER  */
  YYSYMBOL_S_RSHIFT = 65,                  /* S_RSHIFT  */
  YYSYMBOL_S_STATIC = 66,                  /* S_STATIC  */
  YYSYMBOL_S_SUB = 67,                     /* S_SUB  */
  YYSYMBOL_S_VOLATILE = 68,                /* S_VOLATILE  */
  YYSYMBOL_S_TYPEDEF = 69,                 /* S_TYPEDEF  */
  YYSYMBOL_CSTRING = 70,                   /* CSTRING  */
  YYSYMBOL_CVARIABLE = 71,                 /* CVARIABLE  */
  YYSYMBOL_CPP_LINE = 72,                  /* CPP_LINE  */
  YYSYMBOL_IP = 73,                        /* IP  */
  YYSYMBOL_DOLCONST = 74,                  /* DOLCONST  */
  YYSYMBOL_ECONST = 75,                    /* ECONST  */
  YYSYMBOL_NCONST = 76,                    /* NCONST  */
  YYSYMBOL_UCONST = 77,                    /* UCONST  */
  YYSYMBOL_UIDENT = 78,                    /* UIDENT  */
  YYSYMBOL_IDENT = 79,                     /* IDENT  */
  YYSYMBOL_FCONST = 80,                    /* FCONST  */
  YYSYMBOL_SCONST = 81,                    /* SCONST  */
  YYSYMBOL_BCONST = 82,                    /* BCONST  */
  YYSYMBOL_XCONST = 83,                    /* XCONST  */
  YYSYMBOL_Op = 84,                        /* Op  */
  YYSYMBOL_ICONST = 85,                    /* ICONST  */
  YYSYMBOL_PARAM = 86,                     /* PARAM  */
  YYSYMBOL_TYPECAST = 87,                  /* TYPECAST  */
  YYSYMBOL_DOT_DOT = 88,                   /* DOT_DOT  */
  YYSYMBOL_COLON_EQUALS = 89,              /* COLON_EQUALS  */
  YYSYMBOL_EQUALS_GREATER = 90,            /* EQUALS_GREATER  */
  YYSYMBOL_LESS_EQUALS = 91,               /* LESS_EQUALS  */
  YYSYMBOL_GREATER_EQUALS = 92,            /* GREATER_EQUALS  */
  YYSYMBOL_NOT_EQUALS = 93,                /* NOT_EQUALS  */
  YYSYMBOL_ABORT_P = 94,                   /* ABORT_P  */
  YYSYMBOL_ABSOLUTE_P = 95,                /* ABSOLUTE_P  */
  YYSYMBOL_ACCESS = 96,                    /* ACCESS  */
  YYSYMBOL_ACTION = 97,                    /* ACTION  */
  YYSYMBOL_ADD_P = 98,                     /* ADD_P  */
  YYSYMBOL_ADMIN = 99,                     /* ADMIN  */
  YYSYMBOL_AFTER = 100,                    /* AFTER  */
  YYSYMBOL_AGGREGATE = 101,                /* AGGREGATE  */
  YYSYMBOL_ALL = 102,                      /* ALL  */
  YYSYMBOL_ALSO = 103,                     /* ALSO  */
  YYSYMBOL_ALTER = 104,                    /* ALTER  */
  YYSYMBOL_ALWAYS = 105,                   /* ALWAYS  */
  YYSYMBOL_ANALYSE = 106,                  /* ANALYSE  */
  YYSYMBOL_ANALYZE = 107,                  /* ANALYZE  */
  YYSYMBOL_AND = 108,                      /* AND  */
  YYSYMBOL_ANY = 109,                      /* ANY  */
  YYSYMBOL_ARRAY = 110,                    /* ARRAY  */
  YYSYMBOL_AS = 111,                       /* AS  */
  YYSYMBOL_ASC = 112,                      /* ASC  */
  YYSYMBOL_ASSERTION = 113,                /* ASSERTION  */
  YYSYMBOL_ASSIGNMENT = 114,               /* ASSIGNMENT  */
  YYSYMBOL_ASYMMETRIC = 115,               /* ASYMMETRIC  */
  YYSYMBOL_AT = 116,                       /* AT  */
  YYSYMBOL_ATTACH = 117,                   /* ATTACH  */
  YYSYMBOL_ATTRIBUTE = 118,                /* ATTRIBUTE  */
  YYSYMBOL_AUDIT = 119,                    /* AUDIT  */
  YYSYMBOL_AUTHORIZATION = 120,            /* AUTHORIZATION  */
  YYSYMBOL_BACKWARD = 121,                 /* BACKWARD  */
  YYSYMBOL_BARRIER = 122,                  /* BARRIER  */
  YYSYMBOL_BEFORE = 123,                   /* BEFORE  */
  YYSYMBOL_BEGIN_P = 124,                  /* BEGIN_P  */
  YYSYMBOL_BEGIN_SUBTXN = 125,             /* BEGIN_SUBTXN  */
  YYSYMBOL_BETWEEN = 126,                  /* BETWEEN  */
  YYSYMBOL_BIGINT = 127,                   /* BIGINT  */
  YYSYMBOL_BINARY = 128,                   /* BINARY  */
  YYSYMBOL_BINARY_FLOAT = 129,             /* BINARY_FLOAT  */
  YYSYMBOL_BINARY_DOUBLE = 130,            /* BINARY_DOUBLE  */
  YYSYMBOL_BIT = 131,                      /* BIT  */
  YYSYMBOL_BOOLEAN_P = 132,                /* BOOLEAN_P  */
  YYSYMBOL_BOTH = 133,                     /* BOTH  */
  YYSYMBOL_BY = 134,                       /* BY  */
  YYSYMBOL_CACHE = 135,                    /* CACHE  */
  YYSYMBOL_CALLED = 136,                   /* CALLED  */
  YYSYMBOL_CASCADE = 137,                  /* CASCADE  */
  YYSYMBOL_CASCADED = 138,                 /* CASCADED  */
  YYSYMBOL_CASE = 139,                     /* CASE  */
  YYSYMBOL_CAST = 140,                     /* CAST  */
  YYSYMBOL_CATALOG_P = 141,                /* CATALOG_P  */
  YYSYMBOL_CHAIN = 142,                    /* CHAIN  */
  YYSYMBOL_CHAR_P = 143,                   /* CHAR_P  */
  YYSYMBOL_CHARACTER = 144,                /* CHARACTER  */
  YYSYMBOL_CHARACTERISTICS = 145,          /* CHARACTERISTICS  */
  YYSYMBOL_CHECK = 146,                    /* CHECK  */
  YYSYMBOL_CHECKPOINT = 147,               /* CHECKPOINT  */
  YYSYMBOL_CLASS = 148,                    /* CLASS  */
  YYSYMBOL_CLEAN = 149,                    /* CLEAN  */
  YYSYMBOL_CLOSE = 150,                    /* CLOSE  */
  YYSYMBOL_CLUSTER = 151,                  /* CLUSTER  */
  YYSYMBOL_COALESCE = 152,                 /* COALESCE  */
  YYSYMBOL_COLLATE = 153,                  /* COLLATE  */
  YYSYMBOL_COLLATION = 154,                /* COLLATION  */
  YYSYMBOL_COLUMN = 155,                   /* COLUMN  */
  YYSYMBOL_COLUMNS = 156,                  /* COLUMNS  */
  YYSYMBOL_COMMENT = 157,                  /* COMMENT  */
  YYSYMBOL_COMMENTS = 158,                 /* COMMENTS  */
  YYSYMBOL_COMMIT = 159,                   /* COMMIT  */
  YYSYMBOL_COMMIT_SUBTXN = 160,            /* COMMIT_SUBTXN  */
  YYSYMBOL_COMMITTED = 161,                /* COMMITTED  */
  YYSYMBOL_CONCURRENTLY = 162,             /* CONCURRENTLY  */
  YYSYMBOL_CONFIGURATION = 163,            /* CONFIGURATION  */
  YYSYMBOL_CONFLICT = 164,                 /* CONFLICT  */
  YYSYMBOL_CONNECTION = 165,               /* CONNECTION  */
  YYSYMBOL_CONSTRAINT = 166,               /* CONSTRAINT  */
  YYSYMBOL_CONSTRAINTS = 167,              /* CONSTRAINTS  */
  YYSYMBOL_CONTENT_P = 168,                /* CONTENT_P  */
  YYSYMBOL_CONTINUE_P = 169,               /* CONTINUE_P  */
  YYSYMBOL_CONVERSION_P = 170,             /* CONVERSION_P  */
  YYSYMBOL_COORDINATOR = 171,              /* COORDINATOR  */
  YYSYMBOL_COPY = 172,                     /* COPY  */
  YYSYMBOL_COST = 173,                     /* COST  */
  YYSYMBOL_CREATE = 174,                   /* CREATE  */
  YYSYMBOL_CROSS = 175,                    /* CROSS  */
  YYSYMBOL_CSV = 176,                      /* CSV  */
  YYSYMBOL_CUBE = 177,                     /* CUBE  */
  YYSYMBOL_CURRENT_P = 178,                /* CURRENT_P  */
  YYSYMBOL_CURRENT_CATALOG = 179,          /* CURRENT_CATALOG  */
  YYSYMBOL_CURRENT_DATE = 180,             /* CURRENT_DATE  */
  YYSYMBOL_CURRENT_ROLE = 181,             /* CURRENT_ROLE  */
  YYSYMBOL_CURRENT_SCHEMA = 182,           /* CURRENT_SCHEMA  */
  YYSYMBOL_CURRENT_TIME = 183,             /* CURRENT_TIME  */
  YYSYMBOL_CURRENT_TIMESTAMP = 184,        /* CURRENT_TIMESTAMP  */
  YYSYMBOL_CURRENT_USER = 185,             /* CURRENT_USER  */
  YYSYMBOL_CURSOR = 186,                   /* CURSOR  */
  YYSYMBOL_CYCLE = 187,                    /* CYCLE  */
  YYSYMBOL_DATA_P = 188,                   /* DATA_P  */
  YYSYMBOL_DATABASE = 189,                 /* DATABASE  */
  YYSYMBOL_DAY_P = 190,                    /* DAY_P  */
  YYSYMBOL_DBTIMEZONE = 191,               /* DBTIMEZONE  */
  YYSYMBOL_DEALLOCATE = 192,               /* DEALLOCATE  */
  YYSYMBOL_DEC = 193,                      /* DEC  */
  YYSYMBOL_DECIMAL_P = 194,                /* DECIMAL_P  */
  YYSYMBOL_DECLARE = 195,                  /* DECLARE  */
  YYSYMBOL_DEFAULT = 196,                  /* DEFAULT  */
  YYSYMBOL_DEFAULTS = 197,                 /* DEFAULTS  */
  YYSYMBOL_DEFERRABLE = 198,               /* DEFERRABLE  */
  YYSYMBOL_DEFERRED = 199,                 /* DEFERRED  */
  YYSYMBOL_DEFINER = 200,                  /* DEFINER  */
  YYSYMBOL_DELETE_P = 201,                 /* DELETE_P  */
  YYSYMBOL_DELIMITER = 202,                /* DELIMITER  */
  YYSYMBOL_DELIMITERS = 203,               /* DELIMITERS  */
  YYSYMBOL_DEPENDS = 204,                  /* DEPENDS  */
  YYSYMBOL_DESC = 205,                     /* DESC  */
  YYSYMBOL_DETACH = 206,                   /* DETACH  */
  YYSYMBOL_DICTIONARY = 207,               /* DICTIONARY  */
  YYSYMBOL_DIRECT = 208,                   /* DIRECT  */
  YYSYMBOL_DISABLE_P = 209,                /* DISABLE_P  */
  YYSYMBOL_DISCARD = 210,                  /* DISCARD  */
  YYSYMBOL_DISTINCT = 211,                 /* DISTINCT  */
  YYSYMBOL_DISTKEY = 212,                  /* DISTKEY  */
  YYSYMBOL_DISTRIBUTE = 213,               /* DISTRIBUTE  */
  YYSYMBOL_DISTRIBUTED = 214,              /* DISTRIBUTED  */
  YYSYMBOL_DISTSTYLE = 215,                /* DISTSTYLE  */
  YYSYMBOL_DO = 216,                       /* DO  */
  YYSYMBOL_DOCUMENT_P = 217,               /* DOCUMENT_P  */
  YYSYMBOL_DOMAIN_P = 218,                 /* DOMAIN_P  */
  YYSYMBOL_DOUBLE_P = 219,                 /* DOUBLE_P  */
  YYSYMBOL_DROP = 220,                     /* DROP  */
  YYSYMBOL_EACH = 221,                     /* EACH  */
  YYSYMBOL_ELSE = 222,                     /* ELSE  */
  YYSYMBOL_ENABLE_P = 223,                 /* ENABLE_P  */
  YYSYMBOL_ENCODING = 224,                 /* ENCODING  */
  YYSYMBOL_ENCRYPTED = 225,                /* ENCRYPTED  */
  YYSYMBOL_END_P = 226,                    /* END_P  */
  YYSYMBOL_ENUM_P = 227,                   /* ENUM_P  */
  YYSYMBOL_ESCAPE = 228,                   /* ESCAPE  */
  YYSYMBOL_EVENT = 229,                    /* EVENT  */
  YYSYMBOL_EXCEPT = 230,                   /* EXCEPT  */
  YYSYMBOL_EXCHANGE = 231,                 /* EXCHANGE  */
  YYSYMBOL_EXCLUDE = 232,                  /* EXCLUDE  */
  YYSYMBOL_EXCLUDING = 233,                /* EXCLUDING  */
  YYSYMBOL_EXCLUSIVE = 234,                /* EXCLUSIVE  */
  YYSYMBOL_EXECUTE = 235,                  /* EXECUTE  */
  YYSYMBOL_EXISTS = 236,                   /* EXISTS  */
  YYSYMBOL_EXPLAIN = 237,                  /* EXPLAIN  */
  YYSYMBOL_EXTENSION = 238,                /* EXTENSION  */
  YYSYMBOL_EXTENT = 239,                   /* EXTENT  */
  YYSYMBOL_EXTERNAL = 240,                 /* EXTERNAL  */
  YYSYMBOL_EXTRACT = 241,                  /* EXTRACT  */
  YYSYMBOL_FALSE_P = 242,                  /* FALSE_P  */
  YYSYMBOL_FAMILY = 243,                   /* FAMILY  */
  YYSYMBOL_FETCH = 244,                    /* FETCH  */
  YYSYMBOL_FILTER = 245,                   /* FILTER  */
  YYSYMBOL_FIRST_P = 246,                  /* FIRST_P  */
  YYSYMBOL_FLOAT_P = 247,                  /* FLOAT_P  */
  YYSYMBOL_FOLLOWING = 248,                /* FOLLOWING  */
  YYSYMBOL_FOR = 249,                      /* FOR  */
  YYSYMBOL_FORCE = 250,                    /* FORCE  */
  YYSYMBOL_FOREIGN = 251,                  /* FOREIGN  */
  YYSYMBOL_FORWARD = 252,                  /* FORWARD  */
  YYSYMBOL_FREEZE = 253,                   /* FREEZE  */
  YYSYMBOL_FROM = 254,                     /* FROM  */
  YYSYMBOL_FULL = 255,                     /* FULL  */
  YYSYMBOL_FUNCTION = 256,                 /* FUNCTION  */
  YYSYMBOL_FUNCTIONS = 257,                /* FUNCTIONS  */
  YYSYMBOL_GENERATED = 258,                /* GENERATED  */
  YYSYMBOL_GLOBAL = 259,                   /* GLOBAL  */
  YYSYMBOL_GRANT = 260,                    /* GRANT  */
  YYSYMBOL_GRANTED = 261,                  /* GRANTED  */
  YYSYMBOL_GREATEST = 262,                 /* GREATEST  */
  YYSYMBOL_GROUP_P = 263,                  /* GROUP_P  */
  YYSYMBOL_GROUPING = 264,                 /* GROUPING  */
  YYSYMBOL_GTM = 265,                      /* GTM  */
  YYSYMBOL_HANDLER = 266,                  /* HANDLER  */
  YYSYMBOL_HAVING = 267,                   /* HAVING  */
  YYSYMBOL_HEADER_P = 268,                 /* HEADER_P  */
  YYSYMBOL_HOLD = 269,                     /* HOLD  */
  YYSYMBOL_HOUR_P = 270,                   /* HOUR_P  */
  YYSYMBOL_IDENTITY_P = 271,               /* IDENTITY_P  */
  YYSYMBOL_IF_P = 272,                     /* IF_P  */
  YYSYMBOL_ILIKE = 273,                    /* ILIKE  */
  YYSYMBOL_IMMEDIATE = 274,                /* IMMEDIATE  */
  YYSYMBOL_IMMUTABLE = 275,                /* IMMUTABLE  */
  YYSYMBOL_IMPLICIT_P = 276,               /* IMPLICIT_P  */
  YYSYMBOL_IMPORT_P = 277,                 /* IMPORT_P  */
  YYSYMBOL_IN_P = 278,                     /* IN_P  */
  YYSYMBOL_INCLUDING = 279,                /* INCLUDING  */
  YYSYMBOL_INCREMENT = 280,                /* INCREMENT  */
  YYSYMBOL_INDEX = 281,                    /* INDEX  */
  YYSYMBOL_INDEXES = 282,                  /* INDEXES  */
  YYSYMBOL_INHERIT = 283,                  /* INHERIT  */
  YYSYMBOL_INHERITS = 284,                 /* INHERITS  */
  YYSYMBOL_INITIALLY = 285,                /* INITIALLY  */
  YYSYMBOL_INLINE_P = 286,                 /* INLINE_P  */
  YYSYMBOL_INNER_P = 287,                  /* INNER_P  */
  YYSYMBOL_INOUT = 288,                    /* INOUT  */
  YYSYMBOL_INPUT_P = 289,                  /* INPUT_P  */
  YYSYMBOL_INSENSITIVE = 290,              /* INSENSITIVE  */
  YYSYMBOL_INSERT = 291,                   /* INSERT  */
  YYSYMBOL_INSTEAD = 292,                  /* INSTEAD  */
  YYSYMBOL_INT_P = 293,                    /* INT_P  */
  YYSYMBOL_INTEGER = 294,                  /* INTEGER  */
  YYSYMBOL_INTERSECT = 295,                /* INTERSECT  */
  YYSYMBOL_INTERVAL = 296,                 /* INTERVAL  */
  YYSYMBOL_INTO = 297,                     /* INTO  */
  YYSYMBOL_INVOKER = 298,                  /* INVOKER  */
  YYSYMBOL_IS = 299,                       /* IS  */
  YYSYMBOL_ISNULL = 300,                   /* ISNULL  */
  YYSYMBOL_ISOLATION = 301,                /* ISOLATION  */
  YYSYMBOL_JOIN = 302,                     /* JOIN  */
  YYSYMBOL_KEY = 303,                      /* KEY  */
  YYSYMBOL_LABEL = 304,                    /* LABEL  */
  YYSYMBOL_LANGUAGE = 305,                 /* LANGUAGE  */
  YYSYMBOL_LARGE_P = 306,                  /* LARGE_P  */
  YYSYMBOL_LAST_P = 307,                   /* LAST_P  */
  YYSYMBOL_LATERAL_P = 308,                /* LATERAL_P  */
  YYSYMBOL_LEADING = 309,                  /* LEADING  */
  YYSYMBOL_LEAKPROOF = 310,                /* LEAKPROOF  */
  YYSYMBOL_LEAST = 311,                    /* LEAST  */
  YYSYMBOL_LEFT = 312,                     /* LEFT  */
  YYSYMBOL_LEVEL = 313,                    /* LEVEL  */
  YYSYMBOL_LIKE = 314,                     /* LIKE  */
  YYSYMBOL_LIMIT = 315,                    /* LIMIT  */
  YYSYMBOL_LISTEN = 316,                   /* LISTEN  */
  YYSYMBOL_LOAD = 317,                     /* LOAD  */
  YYSYMBOL_LOCAL = 318,                    /* LOCAL  */
  YYSYMBOL_LOCALTIME = 319,                /* LOCALTIME  */
  YYSYMBOL_LOCALTIMESTAMP = 320,           /* LOCALTIMESTAMP  */
  YYSYMBOL_LOCATION = 321,                 /* LOCATION  */
  YYSYMBOL_LOCK_P = 322,                   /* LOCK_P  */
  YYSYMBOL_LOCKED = 323,                   /* LOCKED  */
  YYSYMBOL_LOGGED = 324,                   /* LOGGED  */
  YYSYMBOL_MAPPING = 325,                  /* MAPPING  */
  YYSYMBOL_MATCH = 326,                    /* MATCH  */
  YYSYMBOL_MATERIALIZED = 327,             /* MATERIALIZED  */
  YYSYMBOL_MAXVALUE = 328,                 /* MAXVALUE  */
  YYSYMBOL_METHOD = 329,                   /* METHOD  */
  YYSYMBOL_MINUTE_P = 330,                 /* MINUTE_P  */
  YYSYMBOL_MINVALUE = 331,                 /* MINVALUE  */
  YYSYMBOL_MODE = 332,                     /* MODE  */
  YYSYMBOL_MONTH_P = 333,                  /* MONTH_P  */
  YYSYMBOL_MOVE = 334,                     /* MOVE  */
  YYSYMBOL_NAME_P = 335,                   /* NAME_P  */
  YYSYMBOL_NAMES = 336,                    /* NAMES  */
  YYSYMBOL_NATIONAL = 337,                 /* NATIONAL  */
  YYSYMBOL_NATURAL = 338,                  /* NATURAL  */
  YYSYMBOL_NCHAR = 339,                    /* NCHAR  */
  YYSYMBOL_NEW = 340,                      /* NEW  */
  YYSYMBOL_NEXT = 341,                     /* NEXT  */
  YYSYMBOL_NO = 342,                       /* NO  */
  YYSYMBOL_NOAUDIT = 343,                  /* NOAUDIT  */
  YYSYMBOL_NODE = 344,                     /* NODE  */
  YYSYMBOL_NONE = 345,                     /* NONE  */
  YYSYMBOL_NOT = 346,                      /* NOT  */
  YYSYMBOL_NOTHING = 347,                  /* NOTHING  */
  YYSYMBOL_NOTIFY = 348,                   /* NOTIFY  */
  YYSYMBOL_NOTNULL = 349,                  /* NOTNULL  */
  YYSYMBOL_NOWAIT = 350,                   /* NOWAIT  */
  YYSYMBOL_NULL_P = 351,                   /* NULL_P  */
  YYSYMBOL_NULLIF = 352,                   /* NULLIF  */
  YYSYMBOL_NULLS_P = 353,                  /* NULLS_P  */
  YYSYMBOL_NUMBER = 354,                   /* NUMBER  */
  YYSYMBOL_NUMERIC = 355,                  /* NUMERIC  */
  YYSYMBOL_OBJECT_P = 356,                 /* OBJECT_P  */
  YYSYMBOL_OF = 357,                       /* OF  */
  YYSYMBOL_OFF = 358,                      /* OFF  */
  YYSYMBOL_OFFSET = 359,                   /* OFFSET  */
  YYSYMBOL_OID_P = 360,                    /* OID_P  */
  YYSYMBOL_OIDS = 361,                     /* OIDS  */
  YYSYMBOL_OLD = 362,                      /* OLD  */
  YYSYMBOL_ON = 363,                       /* ON  */
  YYSYMBOL_ONLY = 364,                     /* ONLY  */
  YYSYMBOL_OPENTENBASE_P = 365,            /* OPENTENBASE_P  */
  YYSYMBOL_OPERATOR = 366,                 /* OPERATOR  */
  YYSYMBOL_OPTION = 367,                   /* OPTION  */
  YYSYMBOL_OPTIONS = 368,                  /* OPTIONS  */
  YYSYMBOL_OR = 369,                       /* OR  */
  YYSYMBOL_ORDER = 370,                    /* ORDER  */
  YYSYMBOL_ORDINALITY = 371,               /* ORDINALITY  */
  YYSYMBOL_OUT_P = 372,                    /* OUT_P  */
  YYSYMBOL_OUTER_P = 373,                  /* OUTER_P  */
  YYSYMBOL_OVER = 374,                     /* OVER  */
  YYSYMBOL_OVERLAPS = 375,                 /* OVERLAPS  */
  YYSYMBOL_OVERLAY = 376,                  /* OVERLAY  */
  YYSYMBOL_OVERRIDING = 377,               /* OVERRIDING  */
  YYSYMBOL_OWNED = 378,                    /* OWNED  */
  YYSYMBOL_OWNER = 379,                    /* OWNER  */
  YYSYMBOL_PARALLEL = 380,                 /* PARALLEL  */
  YYSYMBOL_PARSER = 381,                   /* PARSER  */
  YYSYMBOL_PARTIAL = 382,                  /* PARTIAL  */
  YYSYMBOL_PARTITION = 383,                /* PARTITION  */
  YYSYMBOL_PARTITIONS = 384,               /* PARTITIONS  */
  YYSYMBOL_PASSING = 385,                  /* PASSING  */
  YYSYMBOL_PASSWORD = 386,                 /* PASSWORD  */
  YYSYMBOL_PAUSE = 387,                    /* PAUSE  */
  YYSYMBOL_PLACING = 388,                  /* PLACING  */
  YYSYMBOL_PLANS = 389,                    /* PLANS  */
  YYSYMBOL_POLICY = 390,                   /* POLICY  */
  YYSYMBOL_POSITION = 391,                 /* POSITION  */
  YYSYMBOL_PRECEDING = 392,                /* PRECEDING  */
  YYSYMBOL_PRECISION = 393,                /* PRECISION  */
  YYSYMBOL_PREFERRED = 394,                /* PREFERRED  */
  YYSYMBOL_PRESERVE = 395,                 /* PRESERVE  */
  YYSYMBOL_PREPARE = 396,                  /* PREPARE  */
  YYSYMBOL_PREPARED = 397,                 /* PREPARED  */
  YYSYMBOL_PRIMARY = 398,                  /* PRIMARY  */
  YYSYMBOL_PRIOR = 399,                    /* PRIOR  */
  YYSYMBOL_PRIVILEGES = 400,               /* PRIVILEGES  */
  YYSYMBOL_PROCEDURAL = 401,               /* PROCEDURAL  */
  YYSYMBOL_PROCEDURE = 402,                /* PROCEDURE  */
  YYSYMBOL_PROGRAM = 403,                  /* PROGRAM  */
  YYSYMBOL_PUBLICATION = 404,              /* PUBLICATION  */
  YYSYMBOL_PUSHDOWN = 405,                 /* PUSHDOWN  */
  YYSYMBOL_QUOTE = 406,                    /* QUOTE  */
  YYSYMBOL_RANDOMLY = 407,                 /* RANDOMLY  */
  YYSYMBOL_RANGE = 408,                    /* RANGE  */
  YYSYMBOL_READ = 409,                     /* READ  */
  YYSYMBOL_REAL = 410,                     /* REAL  */
  YYSYMBOL_REASSIGN = 411,                 /* REASSIGN  */
  YYSYMBOL_REBUILD = 412,                  /* REBUILD  */
  YYSYMBOL_RECHECK = 413,                  /* RECHECK  */
  YYSYMBOL_RECURSIVE = 414,                /* RECURSIVE  */
  YYSYMBOL_REF = 415,                      /* REF  */
  YYSYMBOL_REFERENCES = 416,               /* REFERENCES  */
  YYSYMBOL_REFERENCING = 417,              /* REFERENCING  */
  YYSYMBOL_REFRESH = 418,                  /* REFRESH  */
  YYSYMBOL_REINDEX = 419,                  /* REINDEX  */
  YYSYMBOL_RELATIVE_P = 420,               /* RELATIVE_P  */
  YYSYMBOL_RELEASE = 421,                  /* RELEASE  */
  YYSYMBOL_RENAME = 422,                   /* RENAME  */
  YYSYMBOL_REPEATABLE = 423,               /* REPEATABLE  */
  YYSYMBOL_REPLACE = 424,                  /* REPLACE  */
  YYSYMBOL_REPLICA = 425,                  /* REPLICA  */
  YYSYMBOL_RESET = 426,                    /* RESET  */
  YYSYMBOL_RESTART = 427,                  /* RESTART  */
  YYSYMBOL_RESTRICT = 428,                 /* RESTRICT  */
  YYSYMBOL_RETURNING = 429,                /* RETURNING  */
  YYSYMBOL_RETURNS = 430,                  /* RETURNS  */
  YYSYMBOL_REVOKE = 431,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 432,                    /* RIGHT  */
  YYSYMBOL_ROLE = 433,                     /* ROLE  */
  YYSYMBOL_ROLLBACK = 434,                 /* ROLLBACK  */
  YYSYMBOL_ROLLBACK_SUBTXN = 435,          /* ROLLBACK_SUBTXN  */
  YYSYMBOL_ROLLUP = 436,                   /* ROLLUP  */
  YYSYMBOL_ROW = 437,                      /* ROW  */
  YYSYMBOL_ROWS = 438,                     /* ROWS  */
  YYSYMBOL_RULE = 439,                     /* RULE  */
  YYSYMBOL_SAMPLE = 440,                   /* SAMPLE  */
  YYSYMBOL_SAVEPOINT = 441,                /* SAVEPOINT  */
  YYSYMBOL_SCHEMA = 442,                   /* SCHEMA  */
  YYSYMBOL_SCHEMAS = 443,                  /* SCHEMAS  */
  YYSYMBOL_SCROLL = 444,                   /* SCROLL  */
  YYSYMBOL_SEARCH = 445,                   /* SEARCH  */
  YYSYMBOL_SECOND_P = 446,                 /* SECOND_P  */
  YYSYMBOL_SECURITY = 447,                 /* SECURITY  */
  YYSYMBOL_SELECT = 448,                   /* SELECT  */
  YYSYMBOL_SEQUENCE = 449,                 /* SEQUENCE  */
  YYSYMBOL_SEQUENCES = 450,                /* SEQUENCES  */
  YYSYMBOL_SERIALIZABLE = 451,             /* SERIALIZABLE  */
  YYSYMBOL_SERVER = 452,                   /* SERVER  */
  YYSYMBOL_SESSION = 453,                  /* SESSION  */
  YYSYMBOL_SESSION_USER = 454,             /* SESSION_USER  */
  YYSYMBOL_SESSIONTIMEZONE = 455,          /* SESSIONTIMEZONE  */
  YYSYMBOL_SET = 456,                      /* SET  */
  YYSYMBOL_SETS = 457,                     /* SETS  */
  YYSYMBOL_SETOF = 458,                    /* SETOF  */
  YYSYMBOL_SHARDING = 459,                 /* SHARDING  */
  YYSYMBOL_SHARE = 460,                    /* SHARE  */
  YYSYMBOL_SHOW = 461,                     /* SHOW  */
  YYSYMBOL_SIMILAR = 462,                  /* SIMILAR  */
  YYSYMBOL_SIMPLE = 463,                   /* SIMPLE  */
  YYSYMBOL_SKIP = 464,                     /* SKIP  */
  YYSYMBOL_SLOT = 465,                     /* SLOT  */
  YYSYMBOL_SMALLINT = 466,                 /* SMALLINT  */
  YYSYMBOL_SNAPSHOT = 467,                 /* SNAPSHOT  */
  YYSYMBOL_SOME = 468,                     /* SOME  */
  YYSYMBOL_SQL_P = 469,                    /* SQL_P  */
  YYSYMBOL_STABLE = 470,                   /* STABLE  */
  YYSYMBOL_STANDALONE_P = 471,             /* STANDALONE_P  */
  YYSYMBOL_START = 472,                    /* START  */
  YYSYMBOL_STATEMENT = 473,                /* STATEMENT  */
  YYSYMBOL_STATISTICS = 474,               /* STATISTICS  */
  YYSYMBOL_STDIN = 475,                    /* STDIN  */
  YYSYMBOL_STDOUT = 476,                   /* STDOUT  */
  YYSYMBOL_STEP = 477,                     /* STEP  */
  YYSYMBOL_STORAGE = 478,                  /* STORAGE  */
  YYSYMBOL_STRICT_P = 479,                 /* STRICT_P  */
  YYSYMBOL_STRIP_P = 480,                  /* STRIP_P  */
  YYSYMBOL_SUBSCRIPTION = 481,             /* SUBSCRIPTION  */
  YYSYMBOL_SUBSTRING = 482,                /* SUBSTRING  */
  YYSYMBOL_SUCCESSFUL = 483,               /* SUCCESSFUL  */
  YYSYMBOL_SYMMETRIC = 484,                /* SYMMETRIC  */
  YYSYMBOL_SYNC = 485,                     /* SYNC  */
  YYSYMBOL_SYSDATE = 486,                  /* SYSDATE  */
  YYSYMBOL_SYSID = 487,                    /* SYSID  */
  YYSYMBOL_SYSTEM_P = 488,                 /* SYSTEM_P  */
  YYSYMBOL_SYSTIMESTAMP = 489,             /* SYSTIMESTAMP  */
  YYSYMBOL_TABLE = 490,                    /* TABLE  */
  YYSYMBOL_TABLES = 491,                   /* TABLES  */
  YYSYMBOL_TABLESAMPLE = 492,              /* TABLESAMPLE  */
  YYSYMBOL_TABLESPACE = 493,               /* TABLESPACE  */
  YYSYMBOL_TEMP = 494,                     /* TEMP  */
  YYSYMBOL_TEMPLATE = 495,                 /* TEMPLATE  */
  YYSYMBOL_TEMPORARY = 496,                /* TEMPORARY  */
  YYSYMBOL_TEXT_P = 497,                   /* TEXT_P  */
  YYSYMBOL_THEN = 498,                     /* THEN  */
  YYSYMBOL_TIME = 499,                     /* TIME  */
  YYSYMBOL_TIMESTAMP = 500,                /* TIMESTAMP  */
  YYSYMBOL_TO = 501,                       /* TO  */
  YYSYMBOL_TRAILING = 502,                 /* TRAILING  */
  YYSYMBOL_TRANSACTION = 503,              /* TRANSACTION  */
  YYSYMBOL_TRANSFORM = 504,                /* TRANSFORM  */
  YYSYMBOL_TREAT = 505,                    /* TREAT  */
  YYSYMBOL_TRIGGER = 506,                  /* TRIGGER  */
  YYSYMBOL_TRIM = 507,                     /* TRIM  */
  YYSYMBOL_TRUE_P = 508,                   /* TRUE_P  */
  YYSYMBOL_TRUNCATE = 509,                 /* TRUNCATE  */
  YYSYMBOL_TRUSTED = 510,                  /* TRUSTED  */
  YYSYMBOL_TYPE_P = 511,                   /* TYPE_P  */
  YYSYMBOL_TYPES_P = 512,                  /* TYPES_P  */
  YYSYMBOL_UNBOUNDED = 513,                /* UNBOUNDED  */
  YYSYMBOL_UNCOMMITTED = 514,              /* UNCOMMITTED  */
  YYSYMBOL_UNENCRYPTED = 515,              /* UNENCRYPTED  */
  YYSYMBOL_UNION = 516,                    /* UNION  */
  YYSYMBOL_UNIQUE = 517,                   /* UNIQUE  */
  YYSYMBOL_UNKNOWN = 518,                  /* UNKNOWN  */
  YYSYMBOL_UNLISTEN = 519,                 /* UNLISTEN  */
  YYSYMBOL_UNLOCK_P = 520,                 /* UNLOCK_P  */
  YYSYMBOL_UNLOGGED = 521,                 /* UNLOGGED  */
  YYSYMBOL_UNPAUSE = 522,                  /* UNPAUSE  */
  YYSYMBOL_UNTIL = 523,                    /* UNTIL  */
  YYSYMBOL_UPDATE = 524,                   /* UPDATE  */
  YYSYMBOL_USER = 525,                     /* USER  */
  YYSYMBOL_USING = 526,                    /* USING  */
  YYSYMBOL_VACUUM = 527,                   /* VACUUM  */
  YYSYMBOL_VALID = 528,                    /* VALID  */
  YYSYMBOL_VALIDATE = 529,                 /* VALIDATE  */
  YYSYMBOL_VALIDATOR = 530,                /* VALIDATOR  */
  YYSYMBOL_VALUE_P = 531,                  /* VALUE_P  */
  YYSYMBOL_VALUES = 532,                   /* VALUES  */
  YYSYMBOL_VARCHAR = 533,                  /* VARCHAR  */
  YYSYMBOL_VARIADIC = 534,                 /* VARIADIC  */
  YYSYMBOL_VARYING = 535,                  /* VARYING  */
  YYSYMBOL_VERBOSE = 536,                  /* VERBOSE  */
  YYSYMBOL_VERSION_P = 537,                /* VERSION_P  */
  YYSYMBOL_VIEW = 538,                     /* VIEW  */
  YYSYMBOL_VIEWS = 539,                    /* VIEWS  */
  YYSYMBOL_VOLATILE = 540,                 /* VOLATILE  */
  YYSYMBOL_WHEN = 541,                     /* WHEN  */
  YYSYMBOL_WHENEVER = 542,                 /* WHENEVER  */
  YYSYMBOL_WHERE = 543,                    /* WHERE  */
  YYSYMBOL_WHITESPACE_P = 544,             /* WHITESPACE_P  */
  YYSYMBOL_WINDOW = 545,                   /* WINDOW  */
  YYSYMBOL_WITH = 546,                     /* WITH  */
  YYSYMBOL_WITHIN = 547,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 548,                  /* WITHOUT  */
  YYSYMBOL_WORK = 549,                     /* WORK  */
  YYSYMBOL_WRAPPER = 550,                  /* WRAPPER  */
  YYSYMBOL_WRITE = 551,                    /* WRITE  */
  YYSYMBOL_XML_P = 552,                    /* XML_P  */
  YYSYMBOL_XMLATTRIBUTES = 553,            /* XMLATTRIBUTES  */
  YYSYMBOL_XMLCONCAT = 554,                /* XMLCONCAT  */
  YYSYMBOL_XMLELEMENT = 555,               /* XMLELEMENT  */
  YYSYMBOL_XMLEXISTS = 556,                /* XMLEXISTS  */
  YYSYMBOL_XMLFOREST = 557,                /* XMLFOREST  */
  YYSYMBOL_XMLNAMESPACES = 558,            /* XMLNAMESPACES  */
  YYSYMBOL_XMLPARSE = 559,                 /* XMLPARSE  */
  YYSYMBOL_XMLPI = 560,                    /* XMLPI  */
  YYSYMBOL_XMLROOT = 561,                  /* XMLROOT  */
  YYSYMBOL_XMLSERIALIZE = 562,             /* XMLSERIALIZE  */
  YYSYMBOL_XMLTABLE = 563,                 /* XMLTABLE  */
  YYSYMBOL_YEAR_P = 564,                   /* YEAR_P  */
  YYSYMBOL_YES_P = 565,                    /* YES_P  */
  YYSYMBOL_ZONE = 566,                     /* ZONE  */
  YYSYMBOL_NOT_LA = 567,                   /* NOT_LA  */
  YYSYMBOL_NULLS_LA = 568,                 /* NULLS_LA  */
  YYSYMBOL_WITH_LA = 569,                  /* WITH_LA  */
  YYSYMBOL_570_ = 570,                     /* '<'  */
  YYSYMBOL_571_ = 571,                     /* '>'  */
  YYSYMBOL_572_ = 572,                     /* '='  */
  YYSYMBOL_POSTFIXOP = 573,                /* POSTFIXOP  */
  YYSYMBOL_574_ = 574,                     /* '+'  */
  YYSYMBOL_575_ = 575,                     /* '-'  */
  YYSYMBOL_576_ = 576,                     /* '*'  */
  YYSYMBOL_577_ = 577,                     /* '/'  */
  YYSYMBOL_578_ = 578,                     /* '%'  */
  YYSYMBOL_579_ = 579,                     /* '^'  */
  YYSYMBOL_UMINUS = 580,                   /* UMINUS  */
  YYSYMBOL_581_ = 581,                     /* '['  */
  YYSYMBOL_582_ = 582,                     /* ']'  */
  YYSYMBOL_583_ = 583,                     /* '('  */
  YYSYMBOL_584_ = 584,                     /* ')'  */
  YYSYMBOL_585_ = 585,                     /* '.'  */
  YYSYMBOL_586_ = 586,                     /* ','  */
  YYSYMBOL_587_ = 587,                     /* ';'  */
  YYSYMBOL_588_ = 588,                     /* ':'  */
  YYSYMBOL_589_ = 589,                     /* '{'  */
  YYSYMBOL_590_ = 590,                     /* '}'  */
  YYSYMBOL_YYACCEPT = 591,                 /* $accept  */
  YYSYMBOL_prog = 592,                     /* prog  */
  YYSYMBOL_stmt = 593,                     /* stmt  */
  YYSYMBOL_CreateRoleStmt = 594,           /* CreateRoleStmt  */
  YYSYMBOL_opt_with = 595,                 /* opt_with  */
  YYSYMBOL_OptRoleList = 596,              /* OptRoleList  */
  YYSYMBOL_AlterOptRoleList = 597,         /* AlterOptRoleList  */
  YYSYMBOL_AlterOptRoleElem = 598,         /* AlterOptRoleElem  */
  YYSYMBOL_CreateOptRoleElem = 599,        /* CreateOptRoleElem  */
  YYSYMBOL_CreateUserStmt = 600,           /* CreateUserStmt  */
  YYSYMBOL_AlterRoleStmt = 601,            /* AlterRoleStmt  */
  YYSYMBOL_opt_in_database = 602,          /* opt_in_database  */
  YYSYMBOL_AlterRoleSetStmt = 603,         /* AlterRoleSetStmt  */
  YYSYMBOL_DropRoleStmt = 604,             /* DropRoleStmt  */
  YYSYMBOL_CreateGroupStmt = 605,          /* CreateGroupStmt  */
  YYSYMBOL_AlterGroupStmt = 606,           /* AlterGroupStmt  */
  YYSYMBOL_add_drop = 607,                 /* add_drop  */
  YYSYMBOL_CreateSchemaStmt = 608,         /* CreateSchemaStmt  */
  YYSYMBOL_OptSchemaName = 609,            /* OptSchemaName  */
  YYSYMBOL_OptSchemaEltList = 610,         /* OptSchemaEltList  */
  YYSYMBOL_schema_stmt = 611,              /* schema_stmt  */
  YYSYMBOL_VariableSetStmt = 612,          /* VariableSetStmt  */
  YYSYMBOL_set_rest = 613,                 /* set_rest  */
  YYSYMBOL_generic_set = 614,              /* generic_set  */
  YYSYMBOL_set_rest_more = 615,            /* set_rest_more  */
  YYSYMBOL_var_name = 616,                 /* var_name  */
  YYSYMBOL_var_list = 617,                 /* var_list  */
  YYSYMBOL_var_value = 618,                /* var_value  */
  YYSYMBOL_iso_level = 619,                /* iso_level  */
  YYSYMBOL_opt_boolean_or_string = 620,    /* opt_boolean_or_string  */
  YYSYMBOL_zone_value = 621,               /* zone_value  */
  YYSYMBOL_opt_encoding = 622,             /* opt_encoding  */
  YYSYMBOL_NonReservedWord_or_Sconst = 623, /* NonReservedWord_or_Sconst  */
  YYSYMBOL_VariableResetStmt = 624,        /* VariableResetStmt  */
  YYSYMBOL_reset_rest = 625,               /* reset_rest  */
  YYSYMBOL_generic_reset = 626,            /* generic_reset  */
  YYSYMBOL_SetResetClause = 627,           /* SetResetClause  */
  YYSYMBOL_FunctionSetResetClause = 628,   /* FunctionSetResetClause  */
  YYSYMBOL_VariableShowStmt = 629,         /* VariableShowStmt  */
  YYSYMBOL_ConstraintsSetStmt = 630,       /* ConstraintsSetStmt  */
  YYSYMBOL_constraints_set_list = 631,     /* constraints_set_list  */
  YYSYMBOL_constraints_set_mode = 632,     /* constraints_set_mode  */
  YYSYMBOL_CheckPointStmt = 633,           /* CheckPointStmt  */
  YYSYMBOL_DiscardStmt = 634,              /* DiscardStmt  */
  YYSYMBOL_AlterTableStmt = 635,           /* AlterTableStmt  */
  YYSYMBOL_alter_table_cmds = 636,         /* alter_table_cmds  */
  YYSYMBOL_alter_group_cmds = 637,         /* alter_group_cmds  */
  YYSYMBOL_partition_cmd = 638,            /* partition_cmd  */
  YYSYMBOL_alter_group_cmd = 639,          /* alter_group_cmd  */
  YYSYMBOL_index_partition_cmd = 640,      /* index_partition_cmd  */
  YYSYMBOL_alter_table_cmd = 641,          /* alter_table_cmd  */
  YYSYMBOL_alter_column_default = 642,     /* alter_column_default  */
  YYSYMBOL_opt_drop_behavior = 643,        /* opt_drop_behavior  */
  YYSYMBOL_opt_collate_clause = 644,       /* opt_collate_clause  */
  YYSYMBOL_alter_using = 645,              /* alter_using  */
  YYSYMBOL_replica_identity = 646,         /* replica_identity  */
  YYSYMBOL_Identified_cluster = 647,       /* Identified_cluster  */
  YYSYMBOL_reloptions = 648,               /* reloptions  */
  YYSYMBOL_opt_reloptions = 649,           /* opt_reloptions  */
  YYSYMBOL_reloption_list = 650,           /* reloption_list  */
  YYSYMBOL_reloption_elem = 651,           /* reloption_elem  */
  YYSYMBOL_alter_identity_column_option_list = 652, /* alter_identity_column_option_list  */
  YYSYMBOL_alter_identity_column_option = 653, /* alter_identity_column_option  */
  YYSYMBOL_PartitionBoundSpec = 654,       /* PartitionBoundSpec  */
  YYSYMBOL_hash_partbound_elem = 655,      /* hash_partbound_elem  */
  YYSYMBOL_hash_partbound = 656,           /* hash_partbound  */
  YYSYMBOL_partbound_datum = 657,          /* partbound_datum  */
  YYSYMBOL_partbound_datum_list = 658,     /* partbound_datum_list  */
  YYSYMBOL_range_datum_list = 659,         /* range_datum_list  */
  YYSYMBOL_PartitionRangeDatum = 660,      /* PartitionRangeDatum  */
  YYSYMBOL_AlterCompositeTypeStmt = 661,   /* AlterCompositeTypeStmt  */
  YYSYMBOL_alter_type_cmds = 662,          /* alter_type_cmds  */
  YYSYMBOL_alter_type_cmd = 663,           /* alter_type_cmd  */
  YYSYMBOL_ClosePortalStmt = 664,          /* ClosePortalStmt  */
  YYSYMBOL_CopyStmt = 665,                 /* CopyStmt  */
  YYSYMBOL_copy_from = 666,                /* copy_from  */
  YYSYMBOL_opt_program = 667,              /* opt_program  */
  YYSYMBOL_opt_shard_list = 668,           /* opt_shard_list  */
  YYSYMBOL_copy_file_name = 669,           /* copy_file_name  */
  YYSYMBOL_copy_options = 670,             /* copy_options  */
  YYSYMBOL_copy_opt_list = 671,            /* copy_opt_list  */
  YYSYMBOL_copy_opt_item = 672,            /* copy_opt_item  */
  YYSYMBOL_opt_binary = 673,               /* opt_binary  */
  YYSYMBOL_opt_oids = 674,                 /* opt_oids  */
  YYSYMBOL_copy_delimiter = 675,           /* copy_delimiter  */
  YYSYMBOL_opt_using = 676,                /* opt_using  */
  YYSYMBOL_copy_generic_opt_list = 677,    /* copy_generic_opt_list  */
  YYSYMBOL_copy_generic_opt_elem = 678,    /* copy_generic_opt_elem  */
  YYSYMBOL_copy_generic_opt_arg = 679,     /* copy_generic_opt_arg  */
  YYSYMBOL_copy_generic_opt_arg_list = 680, /* copy_generic_opt_arg_list  */
  YYSYMBOL_copy_generic_opt_arg_list_item = 681, /* copy_generic_opt_arg_list_item  */
  YYSYMBOL_CreateStmt = 682,               /* CreateStmt  */
  YYSYMBOL_OptTemp = 683,                  /* OptTemp  */
  YYSYMBOL_OptTableElementList = 684,      /* OptTableElementList  */
  YYSYMBOL_OptTypedTableElementList = 685, /* OptTypedTableElementList  */
  YYSYMBOL_TableElementList = 686,         /* TableElementList  */
  YYSYMBOL_TypedTableElementList = 687,    /* TypedTableElementList  */
  YYSYMBOL_TableElement = 688,             /* TableElement  */
  YYSYMBOL_TypedTableElement = 689,        /* TypedTableElement  */
  YYSYMBOL_columnDef = 690,                /* columnDef  */
  YYSYMBOL_columnOptions = 691,            /* columnOptions  */
  YYSYMBOL_ColQualList = 692,              /* ColQualList  */
  YYSYMBOL_ColConstraint = 693,            /* ColConstraint  */
  YYSYMBOL_ColConstraintElem = 694,        /* ColConstraintElem  */
  YYSYMBOL_generated_when = 695,           /* generated_when  */
  YYSYMBOL_ConstraintAttr = 696,           /* ConstraintAttr  */
  YYSYMBOL_TableLikeClause = 697,          /* TableLikeClause  */
  YYSYMBOL_TableLikeOptionList = 698,      /* TableLikeOptionList  */
  YYSYMBOL_TableLikeOption = 699,          /* TableLikeOption  */
  YYSYMBOL_TableConstraint = 700,          /* TableConstraint  */
  YYSYMBOL_ConstraintElem = 701,           /* ConstraintElem  */
  YYSYMBOL_opt_no_inherit = 702,           /* opt_no_inherit  */
  YYSYMBOL_opt_column_list = 703,          /* opt_column_list  */
  YYSYMBOL_columnList = 704,               /* columnList  */
  YYSYMBOL_columnElem = 705,               /* columnElem  */
  YYSYMBOL_key_match = 706,                /* key_match  */
  YYSYMBOL_ExclusionConstraintList = 707,  /* ExclusionConstraintList  */
  YYSYMBOL_ExclusionConstraintElem = 708,  /* ExclusionConstraintElem  */
  YYSYMBOL_ExclusionWhereClause = 709,     /* ExclusionWhereClause  */
  YYSYMBOL_key_actions = 710,              /* key_actions  */
  YYSYMBOL_key_update = 711,               /* key_update  */
  YYSYMBOL_key_delete = 712,               /* key_delete  */
  YYSYMBOL_key_action = 713,               /* key_action  */
  YYSYMBOL_OptInherit = 714,               /* OptInherit  */
  YYSYMBOL_OptPartitionSpec = 715,         /* OptPartitionSpec  */
  YYSYMBOL_PartitionSpec = 716,            /* PartitionSpec  */
  YYSYMBOL_interval_expr = 717,            /* interval_expr  */
  YYSYMBOL_part_strategy = 718,            /* part_strategy  */
  YYSYMBOL_part_params = 719,              /* part_params  */
  YYSYMBOL_part_elem = 720,                /* part_elem  */
  YYSYMBOL_OptWith = 721,                  /* OptWith  */
  YYSYMBOL_OnCommitOption = 722,           /* OnCommitOption  */
  YYSYMBOL_OptTableSpace = 723,            /* OptTableSpace  */
  YYSYMBOL_OptDistributeBy = 724,          /* OptDistributeBy  */
  YYSYMBOL_OptDistributeType = 725,        /* OptDistributeType  */
  YYSYMBOL_DistributeStyle = 726,          /* DistributeStyle  */
  YYSYMBOL_OptDistKey = 727,               /* OptDistKey  */
  YYSYMBOL_OptDistributeByInternal = 728,  /* OptDistributeByInternal  */
  YYSYMBOL_OptSubCluster = 729,            /* OptSubCluster  */
  YYSYMBOL_OptSubClusterInternal = 730,    /* OptSubClusterInternal  */
  YYSYMBOL_OptConsTableSpace = 731,        /* OptConsTableSpace  */
  YYSYMBOL_ExistingIndex = 732,            /* ExistingIndex  */
  YYSYMBOL_CreateStatsStmt = 733,          /* CreateStatsStmt  */
  YYSYMBOL_create_as_target = 734,         /* create_as_target  */
  YYSYMBOL_opt_with_data = 735,            /* opt_with_data  */
  YYSYMBOL_CreateMatViewStmt = 736,        /* CreateMatViewStmt  */
  YYSYMBOL_create_mv_target = 737,         /* create_mv_target  */
  YYSYMBOL_OptNoLog = 738,                 /* OptNoLog  */
  YYSYMBOL_RefreshMatViewStmt = 739,       /* RefreshMatViewStmt  */
  YYSYMBOL_CreateSeqStmt = 740,            /* CreateSeqStmt  */
  YYSYMBOL_AlterSeqStmt = 741,             /* AlterSeqStmt  */
  YYSYMBOL_OptSeqOptList = 742,            /* OptSeqOptList  */
  YYSYMBOL_OptParenthesizedSeqOptList = 743, /* OptParenthesizedSeqOptList  */
  YYSYMBOL_SeqOptList = 744,               /* SeqOptList  */
  YYSYMBOL_SeqOptElem = 745,               /* SeqOptElem  */
  YYSYMBOL_opt_by = 746,                   /* opt_by  */
  YYSYMBOL_NumericOnly = 747,              /* NumericOnly  */
  YYSYMBOL_NumericOnly_list = 748,         /* NumericOnly_list  */
  YYSYMBOL_CreatePLangStmt = 749,          /* CreatePLangStmt  */
  YYSYMBOL_opt_trusted = 750,              /* opt_trusted  */
  YYSYMBOL_handler_name = 751,             /* handler_name  */
  YYSYMBOL_opt_inline_handler = 752,       /* opt_inline_handler  */
  YYSYMBOL_validator_clause = 753,         /* validator_clause  */
  YYSYMBOL_opt_validator = 754,            /* opt_validator  */
  YYSYMBOL_DropPLangStmt = 755,            /* DropPLangStmt  */
  YYSYMBOL_opt_procedural = 756,           /* opt_procedural  */
  YYSYMBOL_CreateTableSpaceStmt = 757,     /* CreateTableSpaceStmt  */
  YYSYMBOL_OptTableSpaceOwner = 758,       /* OptTableSpaceOwner  */
  YYSYMBOL_DropTableSpaceStmt = 759,       /* DropTableSpaceStmt  */
  YYSYMBOL_CreateExtensionStmt = 760,      /* CreateExtensionStmt  */
  YYSYMBOL_create_extension_opt_list = 761, /* create_extension_opt_list  */
  YYSYMBOL_create_extension_opt_item = 762, /* create_extension_opt_item  */
  YYSYMBOL_AlterExtensionStmt = 763,       /* AlterExtensionStmt  */
  YYSYMBOL_alter_extension_opt_list = 764, /* alter_extension_opt_list  */
  YYSYMBOL_alter_extension_opt_item = 765, /* alter_extension_opt_item  */
  YYSYMBOL_AlterExtensionContentsStmt = 766, /* AlterExtensionContentsStmt  */
  YYSYMBOL_CreateFdwStmt = 767,            /* CreateFdwStmt  */
  YYSYMBOL_fdw_option = 768,               /* fdw_option  */
  YYSYMBOL_fdw_options = 769,              /* fdw_options  */
  YYSYMBOL_opt_fdw_options = 770,          /* opt_fdw_options  */
  YYSYMBOL_AlterFdwStmt = 771,             /* AlterFdwStmt  */
  YYSYMBOL_create_generic_options = 772,   /* create_generic_options  */
  YYSYMBOL_generic_option_list = 773,      /* generic_option_list  */
  YYSYMBOL_alter_generic_options = 774,    /* alter_generic_options  */
  YYSYMBOL_alter_generic_option_list = 775, /* alter_generic_option_list  */
  YYSYMBOL_alter_generic_option_elem = 776, /* alter_generic_option_elem  */
  YYSYMBOL_generic_option_elem = 777,      /* generic_option_elem  */
  YYSYMBOL_generic_option_name = 778,      /* generic_option_name  */
  YYSYMBOL_generic_option_arg = 779,       /* generic_option_arg  */
  YYSYMBOL_CreateForeignServerStmt = 780,  /* CreateForeignServerStmt  */
  YYSYMBOL_opt_type = 781,                 /* opt_type  */
  YYSYMBOL_foreign_server_version = 782,   /* foreign_server_version  */
  YYSYMBOL_opt_foreign_server_version = 783, /* opt_foreign_server_version  */
  YYSYMBOL_AlterForeignServerStmt = 784,   /* AlterForeignServerStmt  */
  YYSYMBOL_CreateForeignTableStmt = 785,   /* CreateForeignTableStmt  */
  YYSYMBOL_AlterForeignTableStmt = 786,    /* AlterForeignTableStmt  */
  YYSYMBOL_ImportForeignSchemaStmt = 787,  /* ImportForeignSchemaStmt  */
  YYSYMBOL_import_qualification_type = 788, /* import_qualification_type  */
  YYSYMBOL_import_qualification = 789,     /* import_qualification  */
  YYSYMBOL_CreateUserMappingStmt = 790,    /* CreateUserMappingStmt  */
  YYSYMBOL_auth_ident = 791,               /* auth_ident  */
  YYSYMBOL_DropUserMappingStmt = 792,      /* DropUserMappingStmt  */
  YYSYMBOL_AlterUserMappingStmt = 793,     /* AlterUserMappingStmt  */
  YYSYMBOL_CreatePolicyStmt = 794,         /* CreatePolicyStmt  */
  YYSYMBOL_AlterPolicyStmt = 795,          /* AlterPolicyStmt  */
  YYSYMBOL_RowSecurityOptionalExpr = 796,  /* RowSecurityOptionalExpr  */
  YYSYMBOL_RowSecurityOptionalWithCheck = 797, /* RowSecurityOptionalWithCheck  */
  YYSYMBOL_RowSecurityDefaultToRole = 798, /* RowSecurityDefaultToRole  */
  YYSYMBOL_RowSecurityOptionalToRole = 799, /* RowSecurityOptionalToRole  */
  YYSYMBOL_RowSecurityDefaultPermissive = 800, /* RowSecurityDefaultPermissive  */
  YYSYMBOL_RowSecurityDefaultForCmd = 801, /* RowSecurityDefaultForCmd  */
  YYSYMBOL_row_security_cmd = 802,         /* row_security_cmd  */
  YYSYMBOL_CreateAmStmt = 803,             /* CreateAmStmt  */
  YYSYMBOL_CreateTrigStmt = 804,           /* CreateTrigStmt  */
  YYSYMBOL_TriggerActionTime = 805,        /* TriggerActionTime  */
  YYSYMBOL_TriggerEvents = 806,            /* TriggerEvents  */
  YYSYMBOL_TriggerOneEvent = 807,          /* TriggerOneEvent  */
  YYSYMBOL_TriggerReferencing = 808,       /* TriggerReferencing  */
  YYSYMBOL_TriggerTransitions = 809,       /* TriggerTransitions  */
  YYSYMBOL_TriggerTransition = 810,        /* TriggerTransition  */
  YYSYMBOL_TransitionOldOrNew = 811,       /* TransitionOldOrNew  */
  YYSYMBOL_TransitionRowOrTable = 812,     /* TransitionRowOrTable  */
  YYSYMBOL_TransitionRelName = 813,        /* TransitionRelName  */
  YYSYMBOL_TriggerForSpec = 814,           /* TriggerForSpec  */
  YYSYMBOL_TriggerForOptEach = 815,        /* TriggerForOptEach  */
  YYSYMBOL_TriggerForType = 816,           /* TriggerForType  */
  YYSYMBOL_TriggerWhen = 817,              /* TriggerWhen  */
  YYSYMBOL_TriggerFuncArgs = 818,          /* TriggerFuncArgs  */
  YYSYMBOL_TriggerFuncArg = 819,           /* TriggerFuncArg  */
  YYSYMBOL_OptConstrFromTable = 820,       /* OptConstrFromTable  */
  YYSYMBOL_ConstraintAttributeSpec = 821,  /* ConstraintAttributeSpec  */
  YYSYMBOL_ConstraintAttributeElem = 822,  /* ConstraintAttributeElem  */
  YYSYMBOL_CreateEventTrigStmt = 823,      /* CreateEventTrigStmt  */
  YYSYMBOL_event_trigger_when_list = 824,  /* event_trigger_when_list  */
  YYSYMBOL_event_trigger_when_item = 825,  /* event_trigger_when_item  */
  YYSYMBOL_event_trigger_value_list = 826, /* event_trigger_value_list  */
  YYSYMBOL_AlterEventTrigStmt = 827,       /* AlterEventTrigStmt  */
  YYSYMBOL_enable_trigger = 828,           /* enable_trigger  */
  YYSYMBOL_CreateAssertStmt = 829,         /* CreateAssertStmt  */
  YYSYMBOL_DropAssertStmt = 830,           /* DropAssertStmt  */
  YYSYMBOL_DefineStmt = 831,               /* DefineStmt  */
  YYSYMBOL_definition = 832,               /* definition  */
  YYSYMBOL_def_list = 833,                 /* def_list  */
  YYSYMBOL_def_elem = 834,                 /* def_elem  */
  YYSYMBOL_def_arg = 835,                  /* def_arg  */
  YYSYMBOL_old_aggr_definition = 836,      /* old_aggr_definition  */
  YYSYMBOL_old_aggr_list = 837,            /* old_aggr_list  */
  YYSYMBOL_old_aggr_elem = 838,            /* old_aggr_elem  */
  YYSYMBOL_opt_enum_val_list = 839,        /* opt_enum_val_list  */
  YYSYMBOL_enum_val_list = 840,            /* enum_val_list  */
  YYSYMBOL_AlterEnumStmt = 841,            /* AlterEnumStmt  */
  YYSYMBOL_opt_if_not_exists = 842,        /* opt_if_not_exists  */
  YYSYMBOL_CreateOpClassStmt = 843,        /* CreateOpClassStmt  */
  YYSYMBOL_opclass_item_list = 844,        /* opclass_item_list  */
  YYSYMBOL_opclass_item = 845,             /* opclass_item  */
  YYSYMBOL_opt_default = 846,              /* opt_default  */
  YYSYMBOL_opt_opfamily = 847,             /* opt_opfamily  */
  YYSYMBOL_opclass_purpose = 848,          /* opclass_purpose  */
  YYSYMBOL_opt_recheck = 849,              /* opt_recheck  */
  YYSYMBOL_CreateOpFamilyStmt = 850,       /* CreateOpFamilyStmt  */
  YYSYMBOL_AlterOpFamilyStmt = 851,        /* AlterOpFamilyStmt  */
  YYSYMBOL_opclass_drop_list = 852,        /* opclass_drop_list  */
  YYSYMBOL_opclass_drop = 853,             /* opclass_drop  */
  YYSYMBOL_DropOpClassStmt = 854,          /* DropOpClassStmt  */
  YYSYMBOL_DropOpFamilyStmt = 855,         /* DropOpFamilyStmt  */
  YYSYMBOL_DropOwnedStmt = 856,            /* DropOwnedStmt  */
  YYSYMBOL_ReassignOwnedStmt = 857,        /* ReassignOwnedStmt  */
  YYSYMBOL_DropStmt = 858,                 /* DropStmt  */
  YYSYMBOL_drop_type_any_name = 859,       /* drop_type_any_name  */
  YYSYMBOL_drop_type_name = 860,           /* drop_type_name  */
  YYSYMBOL_drop_type_name_on_any_name = 861, /* drop_type_name_on_any_name  */
  YYSYMBOL_any_name_list = 862,            /* any_name_list  */
  YYSYMBOL_any_name = 863,                 /* any_name  */
  YYSYMBOL_attrs = 864,                    /* attrs  */
  YYSYMBOL_type_name_list = 865,           /* type_name_list  */
  YYSYMBOL_TruncateStmt = 866,             /* TruncateStmt  */
  YYSYMBOL_opt_restart_seqs = 867,         /* opt_restart_seqs  */
  YYSYMBOL_CommentStmt = 868,              /* CommentStmt  */
  YYSYMBOL_comment_type_any_name = 869,    /* comment_type_any_name  */
  YYSYMBOL_comment_type_name = 870,        /* comment_type_name  */
  YYSYMBOL_comment_text = 871,             /* comment_text  */
  YYSYMBOL_SecLabelStmt = 872,             /* SecLabelStmt  */
  YYSYMBOL_opt_provider = 873,             /* opt_provider  */
  YYSYMBOL_security_label_type_any_name = 874, /* security_label_type_any_name  */
  YYSYMBOL_security_label_type_name = 875, /* security_label_type_name  */
  YYSYMBOL_security_label = 876,           /* security_label  */
  YYSYMBOL_FetchStmt = 877,                /* FetchStmt  */
  YYSYMBOL_fetch_args = 878,               /* fetch_args  */
  YYSYMBOL_from_in = 879,                  /* from_in  */
  YYSYMBOL_opt_from_in = 880,              /* opt_from_in  */
  YYSYMBOL_GrantStmt = 881,                /* GrantStmt  */
  YYSYMBOL_RevokeStmt = 882,               /* RevokeStmt  */
  YYSYMBOL_privileges = 883,               /* privileges  */
  YYSYMBOL_privilege_list = 884,           /* privilege_list  */
  YYSYMBOL_privilege = 885,                /* privilege  */
  YYSYMBOL_privilege_target = 886,         /* privilege_target  */
  YYSYMBOL_grantee_list = 887,             /* grantee_list  */
  YYSYMBOL_grantee = 888,                  /* grantee  */
  YYSYMBOL_opt_grant_grant_option = 889,   /* opt_grant_grant_option  */
  YYSYMBOL_GrantRoleStmt = 890,            /* GrantRoleStmt  */
  YYSYMBOL_RevokeRoleStmt = 891,           /* RevokeRoleStmt  */
  YYSYMBOL_opt_grant_admin_option = 892,   /* opt_grant_admin_option  */
  YYSYMBOL_opt_granted_by = 893,           /* opt_granted_by  */
  YYSYMBOL_AlterDefaultPrivilegesStmt = 894, /* AlterDefaultPrivilegesStmt  */
  YYSYMBOL_DefACLOptionList = 895,         /* DefACLOptionList  */
  YYSYMBOL_DefACLOption = 896,             /* DefACLOption  */
  YYSYMBOL_DefACLAction = 897,             /* DefACLAction  */
  YYSYMBOL_defacl_privilege_target = 898,  /* defacl_privilege_target  */
  YYSYMBOL_IndexStmt = 899,                /* IndexStmt  */
  YYSYMBOL_opt_unique = 900,               /* opt_unique  */
  YYSYMBOL_opt_concurrently = 901,         /* opt_concurrently  */
  YYSYMBOL_opt_index_name = 902,           /* opt_index_name  */
  YYSYMBOL_access_method_clause = 903,     /* access_method_clause  */
  YYSYMBOL_index_params = 904,             /* index_params  */
  YYSYMBOL_index_elem = 905,               /* index_elem  */
  YYSYMBOL_opt_collate = 906,              /* opt_collate  */
  YYSYMBOL_opt_class = 907,                /* opt_class  */
  YYSYMBOL_opt_asc_desc = 908,             /* opt_asc_desc  */
  YYSYMBOL_opt_nulls_order = 909,          /* opt_nulls_order  */
  YYSYMBOL_CreateFunctionStmt = 910,       /* CreateFunctionStmt  */
  YYSYMBOL_opt_or_replace = 911,           /* opt_or_replace  */
  YYSYMBOL_func_args = 912,                /* func_args  */
  YYSYMBOL_func_args_list = 913,           /* func_args_list  */
  YYSYMBOL_function_with_argtypes_list = 914, /* function_with_argtypes_list  */
  YYSYMBOL_function_with_argtypes = 915,   /* function_with_argtypes  */
  YYSYMBOL_func_args_with_defaults = 916,  /* func_args_with_defaults  */
  YYSYMBOL_func_args_with_defaults_list = 917, /* func_args_with_defaults_list  */
  YYSYMBOL_func_arg = 918,                 /* func_arg  */
  YYSYMBOL_arg_class = 919,                /* arg_class  */
  YYSYMBOL_param_name = 920,               /* param_name  */
  YYSYMBOL_func_return = 921,              /* func_return  */
  YYSYMBOL_func_type = 922,                /* func_type  */
  YYSYMBOL_func_arg_with_default = 923,    /* func_arg_with_default  */
  YYSYMBOL_aggr_arg = 924,                 /* aggr_arg  */
  YYSYMBOL_aggr_args = 925,                /* aggr_args  */
  YYSYMBOL_aggr_args_list = 926,           /* aggr_args_list  */
  YYSYMBOL_aggregate_with_argtypes = 927,  /* aggregate_with_argtypes  */
  YYSYMBOL_aggregate_with_argtypes_list = 928, /* aggregate_with_argtypes_list  */
  YYSYMBOL_createfunc_opt_list = 929,      /* createfunc_opt_list  */
  YYSYMBOL_common_func_opt_item = 930,     /* common_func_opt_item  */
  YYSYMBOL_createfunc_opt_item = 931,      /* createfunc_opt_item  */
  YYSYMBOL_func_as = 932,                  /* func_as  */
  YYSYMBOL_transform_type_list = 933,      /* transform_type_list  */
  YYSYMBOL_opt_definition = 934,           /* opt_definition  */
  YYSYMBOL_table_func_column = 935,        /* table_func_column  */
  YYSYMBOL_table_func_column_list = 936,   /* table_func_column_list  */
  YYSYMBOL_AlterFunctionStmt = 937,        /* AlterFunctionStmt  */
  YYSYMBOL_alterfunc_opt_list = 938,       /* alterfunc_opt_list  */
  YYSYMBOL_opt_restrict = 939,             /* opt_restrict  */
  YYSYMBOL_RemoveFuncStmt = 940,           /* RemoveFuncStmt  */
  YYSYMBOL_RemoveAggrStmt = 941,           /* RemoveAggrStmt  */
  YYSYMBOL_RemoveOperStmt = 942,           /* RemoveOperStmt  */
  YYSYMBOL_oper_argtypes = 943,            /* oper_argtypes  */
  YYSYMBOL_any_operator = 944,             /* any_operator  */
  YYSYMBOL_operator_with_argtypes_list = 945, /* operator_with_argtypes_list  */
  YYSYMBOL_operator_with_argtypes = 946,   /* operator_with_argtypes  */
  YYSYMBOL_DoStmt = 947,                   /* DoStmt  */
  YYSYMBOL_dostmt_opt_list = 948,          /* dostmt_opt_list  */
  YYSYMBOL_dostmt_opt_item = 949,          /* dostmt_opt_item  */
  YYSYMBOL_CreateCastStmt = 950,           /* CreateCastStmt  */
  YYSYMBOL_cast_context = 951,             /* cast_context  */
  YYSYMBOL_DropCastStmt = 952,             /* DropCastStmt  */
  YYSYMBOL_opt_if_exists = 953,            /* opt_if_exists  */
  YYSYMBOL_CreateTransformStmt = 954,      /* CreateTransformStmt  */
  YYSYMBOL_transform_element_list = 955,   /* transform_element_list  */
  YYSYMBOL_DropTransformStmt = 956,        /* DropTransformStmt  */
  YYSYMBOL_ReindexStmt = 957,              /* ReindexStmt  */
  YYSYMBOL_reindex_target_type = 958,      /* reindex_target_type  */
  YYSYMBOL_reindex_target_multitable = 959, /* reindex_target_multitable  */
  YYSYMBOL_reindex_option_list = 960,      /* reindex_option_list  */
  YYSYMBOL_reindex_option_elem = 961,      /* reindex_option_elem  */
  YYSYMBOL_AlterTblSpcStmt = 962,          /* AlterTblSpcStmt  */
  YYSYMBOL_RenameStmt = 963,               /* RenameStmt  */
  YYSYMBOL_opt_column = 964,               /* opt_column  */
  YYSYMBOL_opt_set_data = 965,             /* opt_set_data  */
  YYSYMBOL_AlterObjectDependsStmt = 966,   /* AlterObjectDependsStmt  */
  YYSYMBOL_AlterObjectSchemaStmt = 967,    /* AlterObjectSchemaStmt  */
  YYSYMBOL_AlterOperatorStmt = 968,        /* AlterOperatorStmt  */
  YYSYMBOL_operator_def_list = 969,        /* operator_def_list  */
  YYSYMBOL_operator_def_elem = 970,        /* operator_def_elem  */
  YYSYMBOL_operator_def_arg = 971,         /* operator_def_arg  */
  YYSYMBOL_AlterOwnerStmt = 972,           /* AlterOwnerStmt  */
  YYSYMBOL_CreatePublicationStmt = 973,    /* CreatePublicationStmt  */
  YYSYMBOL_opt_publication_for_tables = 974, /* opt_publication_for_tables  */
  YYSYMBOL_publication_for_tables = 975,   /* publication_for_tables  */
  YYSYMBOL_opt_publication_for_shards = 976, /* opt_publication_for_shards  */
  YYSYMBOL_publication_for_shards = 977,   /* publication_for_shards  */
  YYSYMBOL_AlterPublicationStmt = 978,     /* AlterPublicationStmt  */
  YYSYMBOL_CreateSubscriptionStmt = 979,   /* CreateSubscriptionStmt  */
  YYSYMBOL_publication_name_list = 980,    /* publication_name_list  */
  YYSYMBOL_publication_name_item = 981,    /* publication_name_item  */
  YYSYMBOL_AlterSubscriptionStmt = 982,    /* AlterSubscriptionStmt  */
  YYSYMBOL_DropSubscriptionStmt = 983,     /* DropSubscriptionStmt  */
  YYSYMBOL_RuleStmt = 984,                 /* RuleStmt  */
  YYSYMBOL_RuleActionList = 985,           /* RuleActionList  */
  YYSYMBOL_RuleActionMulti = 986,          /* RuleActionMulti  */
  YYSYMBOL_RuleActionStmt = 987,           /* RuleActionStmt  */
  YYSYMBOL_RuleActionStmtOrEmpty = 988,    /* RuleActionStmtOrEmpty  */
  YYSYMBOL_event = 989,                    /* event  */
  YYSYMBOL_opt_instead = 990,              /* opt_instead  */
  YYSYMBOL_NotifyStmt = 991,               /* NotifyStmt  */
  YYSYMBOL_notify_payload = 992,           /* notify_payload  */
  YYSYMBOL_ListenStmt = 993,               /* ListenStmt  */
  YYSYMBOL_UnlistenStmt = 994,             /* UnlistenStmt  */
  YYSYMBOL_TransactionStmt = 995,          /* TransactionStmt  */
  YYSYMBOL_opt_transaction = 996,          /* opt_transaction  */
  YYSYMBOL_transaction_mode_item = 997,    /* transaction_mode_item  */
  YYSYMBOL_transaction_mode_list = 998,    /* transaction_mode_list  */
  YYSYMBOL_transaction_mode_list_or_empty = 999, /* transaction_mode_list_or_empty  */
  YYSYMBOL_ViewStmt = 1000,                /* ViewStmt  */
  YYSYMBOL_opt_check_option = 1001,        /* opt_check_option  */
  YYSYMBOL_LoadStmt = 1002,                /* LoadStmt  */
  YYSYMBOL_CreatedbStmt = 1003,            /* CreatedbStmt  */
  YYSYMBOL_createdb_opt_list = 1004,       /* createdb_opt_list  */
  YYSYMBOL_createdb_opt_items = 1005,      /* createdb_opt_items  */
  YYSYMBOL_createdb_opt_item = 1006,       /* createdb_opt_item  */
  YYSYMBOL_createdb_opt_name = 1007,       /* createdb_opt_name  */
  YYSYMBOL_opt_equal = 1008,               /* opt_equal  */
  YYSYMBOL_AlterDatabaseStmt = 1009,       /* AlterDatabaseStmt  */
  YYSYMBOL_AlterDatabaseSetStmt = 1010,    /* AlterDatabaseSetStmt  */
  YYSYMBOL_DropdbStmt = 1011,              /* DropdbStmt  */
  YYSYMBOL_AlterCollationStmt = 1012,      /* AlterCollationStmt  */
  YYSYMBOL_AlterSystemStmt = 1013,         /* AlterSystemStmt  */
  YYSYMBOL_CreateDomainStmt = 1014,        /* CreateDomainStmt  */
  YYSYMBOL_AlterDomainStmt = 1015,         /* AlterDomainStmt  */
  YYSYMBOL_opt_as = 1016,                  /* opt_as  */
  YYSYMBOL_AlterTSDictionaryStmt = 1017,   /* AlterTSDictionaryStmt  */
  YYSYMBOL_AlterTSConfigurationStmt = 1018, /* AlterTSConfigurationStmt  */
  YYSYMBOL_any_with = 1019,                /* any_with  */
  YYSYMBOL_CreateConversionStmt = 1020,    /* CreateConversionStmt  */
  YYSYMBOL_ClusterStmt = 1021,             /* ClusterStmt  */
  YYSYMBOL_cluster_index_specification = 1022, /* cluster_index_specification  */
  YYSYMBOL_VacuumStmt = 1023,              /* VacuumStmt  */
  YYSYMBOL_vacuum_option_list = 1024,      /* vacuum_option_list  */
  YYSYMBOL_vacuum_option_elem = 1025,      /* vacuum_option_elem  */
  YYSYMBOL_AnalyzeStmt = 1026,             /* AnalyzeStmt  */
  YYSYMBOL_analyze_keyword = 1027,         /* analyze_keyword  */
  YYSYMBOL_analyze_sync_option = 1028,     /* analyze_sync_option  */
  YYSYMBOL_opt_verbose = 1029,             /* opt_verbose  */
  YYSYMBOL_opt_full = 1030,                /* opt_full  */
  YYSYMBOL_opt_freeze = 1031,              /* opt_freeze  */
  YYSYMBOL_analyze_option_list = 1032,     /* analyze_option_list  */
  YYSYMBOL_analyze_option_elem = 1033,     /* analyze_option_elem  */
  YYSYMBOL_opt_name_list = 1034,           /* opt_name_list  */
  YYSYMBOL_AuditStmt = 1035,               /* AuditStmt  */
  YYSYMBOL_audit_or_noaudit = 1036,        /* audit_or_noaudit  */
  YYSYMBOL_opt_when_success_or_not = 1037, /* opt_when_success_or_not  */
  YYSYMBOL_success_or_not = 1038,          /* success_or_not  */
  YYSYMBOL_audit_stmt_list = 1039,         /* audit_stmt_list  */
  YYSYMBOL_audit_stmts = 1040,             /* audit_stmts  */
  YYSYMBOL_audit_stmt = 1041,              /* audit_stmt  */
  YYSYMBOL_audit_user_list = 1042,         /* audit_user_list  */
  YYSYMBOL_audit_obj_type = 1043,          /* audit_obj_type  */
  YYSYMBOL_audit_obj = 1044,               /* audit_obj  */
  YYSYMBOL_CleanAuditStmt = 1045,          /* CleanAuditStmt  */
  YYSYMBOL_SampleStmt = 1046,              /* SampleStmt  */
  YYSYMBOL_PauseStmt = 1047,               /* PauseStmt  */
  YYSYMBOL_BarrierStmt = 1048,             /* BarrierStmt  */
  YYSYMBOL_opt_barrier_id = 1049,          /* opt_barrier_id  */
  YYSYMBOL_CreateNodeStmt = 1050,          /* CreateNodeStmt  */
  YYSYMBOL_pgxcnode_name = 1051,           /* pgxcnode_name  */
  YYSYMBOL_pgxcgroup_name = 1052,          /* pgxcgroup_name  */
  YYSYMBOL_pgxcnodes = 1053,               /* pgxcnodes  */
  YYSYMBOL_pgxcnode_list = 1054,           /* pgxcnode_list  */
  YYSYMBOL_AlterNodeStmt = 1055,           /* AlterNodeStmt  */
  YYSYMBOL_DropNodeStmt = 1056,            /* DropNodeStmt  */
  YYSYMBOL_CreateNodeGroupStmt = 1057,     /* CreateNodeGroupStmt  */
  YYSYMBOL_AlterNodeGroupStmt = 1058,      /* AlterNodeGroupStmt  */
  YYSYMBOL_DropNodeGroupStmt = 1059,       /* DropNodeGroupStmt  */
  YYSYMBOL_MoveDataStmt = 1060,            /* MoveDataStmt  */
  YYSYMBOL_data_node = 1061,               /* data_node  */
  YYSYMBOL_shard_list = 1062,              /* shard_list  */
  YYSYMBOL_CreateShardStmt = 1063,         /* CreateShardStmt  */
  YYSYMBOL_DropShardStmt = 1064,           /* DropShardStmt  */
  YYSYMBOL_CleanShardingStmt = 1065,       /* CleanShardingStmt  */
  YYSYMBOL_CreateKeyValuesStmt = 1066,     /* CreateKeyValuesStmt  */
  YYSYMBOL_qual_table_list = 1067,         /* qual_table_list  */
  YYSYMBOL_CheckOverLapStmt = 1068,        /* CheckOverLapStmt  */
  YYSYMBOL_ExplainStmt = 1069,             /* ExplainStmt  */
  YYSYMBOL_ExplainableStmt = 1070,         /* ExplainableStmt  */
  YYSYMBOL_explain_option_list = 1071,     /* explain_option_list  */
  YYSYMBOL_explain_option_elem = 1072,     /* explain_option_elem  */
  YYSYMBOL_explain_option_name = 1073,     /* explain_option_name  */
  YYSYMBOL_explain_option_arg = 1074,      /* explain_option_arg  */
  YYSYMBOL_ExecDirectStmt = 1075,          /* ExecDirectStmt  */
  YYSYMBOL_DirectStmt = 1076,              /* DirectStmt  */
  YYSYMBOL_CleanConnStmt = 1077,           /* CleanConnStmt  */
  YYSYMBOL_CleanConnDbName = 1078,         /* CleanConnDbName  */
  YYSYMBOL_CleanConnUserName = 1079,       /* CleanConnUserName  */
  YYSYMBOL_opt_force = 1080,               /* opt_force  */
  YYSYMBOL_PrepareStmt = 1081,             /* PrepareStmt  */
  YYSYMBOL_prep_type_clause = 1082,        /* prep_type_clause  */
  YYSYMBOL_PreparableStmt = 1083,          /* PreparableStmt  */
  YYSYMBOL_ExecuteStmt = 1084,             /* ExecuteStmt  */
  YYSYMBOL_execute_param_clause = 1085,    /* execute_param_clause  */
  YYSYMBOL_InsertStmt = 1086,              /* InsertStmt  */
  YYSYMBOL_insert_target = 1087,           /* insert_target  */
  YYSYMBOL_insert_rest = 1088,             /* insert_rest  */
  YYSYMBOL_override_kind = 1089,           /* override_kind  */
  YYSYMBOL_insert_column_list = 1090,      /* insert_column_list  */
  YYSYMBOL_insert_column_item = 1091,      /* insert_column_item  */
  YYSYMBOL_opt_on_conflict = 1092,         /* opt_on_conflict  */
  YYSYMBOL_opt_conf_expr = 1093,           /* opt_conf_expr  */
  YYSYMBOL_returning_clause = 1094,        /* returning_clause  */
  YYSYMBOL_DeleteStmt = 1095,              /* DeleteStmt  */
  YYSYMBOL_using_clause = 1096,            /* using_clause  */
  YYSYMBOL_LockStmt = 1097,                /* LockStmt  */
  YYSYMBOL_opt_lock = 1098,                /* opt_lock  */
  YYSYMBOL_lock_type = 1099,               /* lock_type  */
  YYSYMBOL_opt_nowait = 1100,              /* opt_nowait  */
  YYSYMBOL_opt_nowait_or_skip = 1101,      /* opt_nowait_or_skip  */
  YYSYMBOL_LockNodeStmt = 1102,            /* LockNodeStmt  */
  YYSYMBOL_lock_param_list = 1103,         /* lock_param_list  */
  YYSYMBOL_lock_param = 1104,              /* lock_param  */
  YYSYMBOL_UpdateStmt = 1105,              /* UpdateStmt  */
  YYSYMBOL_set_clause_list = 1106,         /* set_clause_list  */
  YYSYMBOL_set_clause = 1107,              /* set_clause  */
  YYSYMBOL_set_target = 1108,              /* set_target  */
  YYSYMBOL_set_target_list = 1109,         /* set_target_list  */
  YYSYMBOL_DeclareCursorStmt = 1110,       /* DeclareCursorStmt  */
  YYSYMBOL_cursor_name = 1111,             /* cursor_name  */
  YYSYMBOL_cursor_options = 1112,          /* cursor_options  */
  YYSYMBOL_opt_hold = 1113,                /* opt_hold  */
  YYSYMBOL_SelectStmt = 1114,              /* SelectStmt  */
  YYSYMBOL_select_with_parens = 1115,      /* select_with_parens  */
  YYSYMBOL_select_no_parens = 1116,        /* select_no_parens  */
  YYSYMBOL_select_clause = 1117,           /* select_clause  */
  YYSYMBOL_simple_select = 1118,           /* simple_select  */
  YYSYMBOL_with_clause = 1119,             /* with_clause  */
  YYSYMBOL_cte_list = 1120,                /* cte_list  */
  YYSYMBOL_common_table_expr = 1121,       /* common_table_expr  */
  YYSYMBOL_opt_materialized = 1122,        /* opt_materialized  */
  YYSYMBOL_opt_with_clause = 1123,         /* opt_with_clause  */
  YYSYMBOL_into_clause = 1124,             /* into_clause  */
  YYSYMBOL_OptTempTableName = 1125,        /* OptTempTableName  */
  YYSYMBOL_opt_table = 1126,               /* opt_table  */
  YYSYMBOL_all_or_distinct = 1127,         /* all_or_distinct  */
  YYSYMBOL_distinct_clause = 1128,         /* distinct_clause  */
  YYSYMBOL_opt_all_clause = 1129,          /* opt_all_clause  */
  YYSYMBOL_opt_sort_clause = 1130,         /* opt_sort_clause  */
  YYSYMBOL_sort_clause = 1131,             /* sort_clause  */
  YYSYMBOL_sortby_list = 1132,             /* sortby_list  */
  YYSYMBOL_sortby = 1133,                  /* sortby  */
  YYSYMBOL_select_limit = 1134,            /* select_limit  */
  YYSYMBOL_opt_select_limit = 1135,        /* opt_select_limit  */
  YYSYMBOL_limit_clause = 1136,            /* limit_clause  */
  YYSYMBOL_offset_clause = 1137,           /* offset_clause  */
  YYSYMBOL_select_limit_value = 1138,      /* select_limit_value  */
  YYSYMBOL_select_offset_value = 1139,     /* select_offset_value  */
  YYSYMBOL_opt_select_fetch_first_value = 1140, /* opt_select_fetch_first_value  */
  YYSYMBOL_select_offset_value2 = 1141,    /* select_offset_value2  */
  YYSYMBOL_row_or_rows = 1142,             /* row_or_rows  */
  YYSYMBOL_first_or_next = 1143,           /* first_or_next  */
  YYSYMBOL_group_clause = 1144,            /* group_clause  */
  YYSYMBOL_group_by_list = 1145,           /* group_by_list  */
  YYSYMBOL_group_by_item = 1146,           /* group_by_item  */
  YYSYMBOL_empty_grouping_set = 1147,      /* empty_grouping_set  */
  YYSYMBOL_rollup_clause = 1148,           /* rollup_clause  */
  YYSYMBOL_cube_clause = 1149,             /* cube_clause  */
  YYSYMBOL_grouping_sets_clause = 1150,    /* grouping_sets_clause  */
  YYSYMBOL_having_clause = 1151,           /* having_clause  */
  YYSYMBOL_for_locking_clause = 1152,      /* for_locking_clause  */
  YYSYMBOL_opt_for_locking_clause = 1153,  /* opt_for_locking_clause  */
  YYSYMBOL_for_locking_items = 1154,       /* for_locking_items  */
  YYSYMBOL_for_locking_item = 1155,        /* for_locking_item  */
  YYSYMBOL_for_locking_strength = 1156,    /* for_locking_strength  */
  YYSYMBOL_locked_rels_list = 1157,        /* locked_rels_list  */
  YYSYMBOL_values_clause = 1158,           /* values_clause  */
  YYSYMBOL_from_clause = 1159,             /* from_clause  */
  YYSYMBOL_from_list = 1160,               /* from_list  */
  YYSYMBOL_table_ref = 1161,               /* table_ref  */
  YYSYMBOL_joined_table = 1162,            /* joined_table  */
  YYSYMBOL_alias_clause = 1163,            /* alias_clause  */
  YYSYMBOL_opt_alias_clause = 1164,        /* opt_alias_clause  */
  YYSYMBOL_func_alias_clause = 1165,       /* func_alias_clause  */
  YYSYMBOL_join_type = 1166,               /* join_type  */
  YYSYMBOL_join_outer = 1167,              /* join_outer  */
  YYSYMBOL_join_qual = 1168,               /* join_qual  */
  YYSYMBOL_relation_expr = 1169,           /* relation_expr  */
  YYSYMBOL_opt_partition_for = 1170,       /* opt_partition_for  */
  YYSYMBOL_partition_for = 1171,           /* partition_for  */
  YYSYMBOL_relation_expr_list = 1172,      /* relation_expr_list  */
  YYSYMBOL_relation_expr_opt_alias = 1173, /* relation_expr_opt_alias  */
  YYSYMBOL_tablesample_clause = 1174,      /* tablesample_clause  */
  YYSYMBOL_opt_repeatable_clause = 1175,   /* opt_repeatable_clause  */
  YYSYMBOL_func_table = 1176,              /* func_table  */
  YYSYMBOL_rowsfrom_item = 1177,           /* rowsfrom_item  */
  YYSYMBOL_rowsfrom_list = 1178,           /* rowsfrom_list  */
  YYSYMBOL_opt_col_def_list = 1179,        /* opt_col_def_list  */
  YYSYMBOL_opt_ordinality = 1180,          /* opt_ordinality  */
  YYSYMBOL_where_clause = 1181,            /* where_clause  */
  YYSYMBOL_where_or_current_clause = 1182, /* where_or_current_clause  */
  YYSYMBOL_OptTableFuncElementList = 1183, /* OptTableFuncElementList  */
  YYSYMBOL_TableFuncElementList = 1184,    /* TableFuncElementList  */
  YYSYMBOL_TableFuncElement = 1185,        /* TableFuncElement  */
  YYSYMBOL_xmltable = 1186,                /* xmltable  */
  YYSYMBOL_xmltable_column_list = 1187,    /* xmltable_column_list  */
  YYSYMBOL_xmltable_column_el = 1188,      /* xmltable_column_el  */
  YYSYMBOL_xmltable_column_option_list = 1189, /* xmltable_column_option_list  */
  YYSYMBOL_xmltable_column_option_el = 1190, /* xmltable_column_option_el  */
  YYSYMBOL_xml_namespace_list = 1191,      /* xml_namespace_list  */
  YYSYMBOL_xml_namespace_el = 1192,        /* xml_namespace_el  */
  YYSYMBOL_Typename = 1193,                /* Typename  */
  YYSYMBOL_opt_array_bounds = 1194,        /* opt_array_bounds  */
  YYSYMBOL_SimpleTypename = 1195,          /* SimpleTypename  */
  YYSYMBOL_ConstTypename = 1196,           /* ConstTypename  */
  YYSYMBOL_GenericType = 1197,             /* GenericType  */
  YYSYMBOL_opt_type_modifiers = 1198,      /* opt_type_modifiers  */
  YYSYMBOL_Numeric = 1199,                 /* Numeric  */
  YYSYMBOL_opt_float = 1200,               /* opt_float  */
  YYSYMBOL_Bit = 1201,                     /* Bit  */
  YYSYMBOL_ConstBit = 1202,                /* ConstBit  */
  YYSYMBOL_BitWithLength = 1203,           /* BitWithLength  */
  YYSYMBOL_BitWithoutLength = 1204,        /* BitWithoutLength  */
  YYSYMBOL_Character = 1205,               /* Character  */
  YYSYMBOL_ConstCharacter = 1206,          /* ConstCharacter  */
  YYSYMBOL_CharacterWithLength = 1207,     /* CharacterWithLength  */
  YYSYMBOL_CharacterWithoutLength = 1208,  /* CharacterWithoutLength  */
  YYSYMBOL_character = 1209,               /* character  */
  YYSYMBOL_opt_varying = 1210,             /* opt_varying  */
  YYSYMBOL_ConstDatetime = 1211,           /* ConstDatetime  */
  YYSYMBOL_ConstInterval = 1212,           /* ConstInterval  */
  YYSYMBOL_opt_timezone = 1213,            /* opt_timezone  */
  YYSYMBOL_opt_interval = 1214,            /* opt_interval  */
  YYSYMBOL_interval_second = 1215,         /* interval_second  */
  YYSYMBOL_a_expr = 1216,                  /* a_expr  */
  YYSYMBOL_b_expr = 1217,                  /* b_expr  */
  YYSYMBOL_c_expr = 1218,                  /* c_expr  */
  YYSYMBOL_func_application = 1219,        /* func_application  */
  YYSYMBOL_func_expr = 1220,               /* func_expr  */
  YYSYMBOL_func_expr_windowless = 1221,    /* func_expr_windowless  */
  YYSYMBOL_func_expr_common_subexpr = 1222, /* func_expr_common_subexpr  */
  YYSYMBOL_xml_root_version = 1223,        /* xml_root_version  */
  YYSYMBOL_opt_xml_root_standalone = 1224, /* opt_xml_root_standalone  */
  YYSYMBOL_xml_attributes = 1225,          /* xml_attributes  */
  YYSYMBOL_xml_attribute_list = 1226,      /* xml_attribute_list  */
  YYSYMBOL_xml_attribute_el = 1227,        /* xml_attribute_el  */
  YYSYMBOL_document_or_content = 1228,     /* document_or_content  */
  YYSYMBOL_xml_whitespace_option = 1229,   /* xml_whitespace_option  */
  YYSYMBOL_xmlexists_argument = 1230,      /* xmlexists_argument  */
  YYSYMBOL_within_group_clause = 1231,     /* within_group_clause  */
  YYSYMBOL_filter_clause = 1232,           /* filter_clause  */
  YYSYMBOL_window_clause = 1233,           /* window_clause  */
  YYSYMBOL_window_definition_list = 1234,  /* window_definition_list  */
  YYSYMBOL_window_definition = 1235,       /* window_definition  */
  YYSYMBOL_over_clause = 1236,             /* over_clause  */
  YYSYMBOL_window_specification = 1237,    /* window_specification  */
  YYSYMBOL_opt_existing_window_name = 1238, /* opt_existing_window_name  */
  YYSYMBOL_opt_partition_clause = 1239,    /* opt_partition_clause  */
  YYSYMBOL_opt_frame_clause = 1240,        /* opt_frame_clause  */
  YYSYMBOL_frame_extent = 1241,            /* frame_extent  */
  YYSYMBOL_frame_bound = 1242,             /* frame_bound  */
  YYSYMBOL_row = 1243,                     /* row  */
  YYSYMBOL_explicit_row = 1244,            /* explicit_row  */
  YYSYMBOL_implicit_row = 1245,            /* implicit_row  */
  YYSYMBOL_sub_type = 1246,                /* sub_type  */
  YYSYMBOL_all_Op = 1247,                  /* all_Op  */
  YYSYMBOL_MathOp = 1248,                  /* MathOp  */
  YYSYMBOL_qual_Op = 1249,                 /* qual_Op  */
  YYSYMBOL_qual_all_Op = 1250,             /* qual_all_Op  */
  YYSYMBOL_subquery_Op = 1251,             /* subquery_Op  */
  YYSYMBOL_expr_list = 1252,               /* expr_list  */
  YYSYMBOL_func_arg_list = 1253,           /* func_arg_list  */
  YYSYMBOL_func_arg_expr = 1254,           /* func_arg_expr  */
  YYSYMBOL_type_list = 1255,               /* type_list  */
  YYSYMBOL_array_expr = 1256,              /* array_expr  */
  YYSYMBOL_array_expr_list = 1257,         /* array_expr_list  */
  YYSYMBOL_extract_list = 1258,            /* extract_list  */
  YYSYMBOL_extract_arg = 1259,             /* extract_arg  */
  YYSYMBOL_overlay_list = 1260,            /* overlay_list  */
  YYSYMBOL_overlay_placing = 1261,         /* overlay_placing  */
  YYSYMBOL_position_list = 1262,           /* position_list  */
  YYSYMBOL_substr_list = 1263,             /* substr_list  */
  YYSYMBOL_substr_from = 1264,             /* substr_from  */
  YYSYMBOL_substr_for = 1265,              /* substr_for  */
  YYSYMBOL_trim_list = 1266,               /* trim_list  */
  YYSYMBOL_in_expr = 1267,                 /* in_expr  */
  YYSYMBOL_case_expr = 1268,               /* case_expr  */
  YYSYMBOL_when_clause_list = 1269,        /* when_clause_list  */
  YYSYMBOL_when_clause = 1270,             /* when_clause  */
  YYSYMBOL_case_default = 1271,            /* case_default  */
  YYSYMBOL_case_arg = 1272,                /* case_arg  */
  YYSYMBOL_columnref = 1273,               /* columnref  */
  YYSYMBOL_indirection_el = 1274,          /* indirection_el  */
  YYSYMBOL_opt_slice_bound = 1275,         /* opt_slice_bound  */
  YYSYMBOL_indirection = 1276,             /* indirection  */
  YYSYMBOL_opt_indirection = 1277,         /* opt_indirection  */
  YYSYMBOL_opt_asymmetric = 1278,          /* opt_asymmetric  */
  YYSYMBOL_opt_target_list = 1279,         /* opt_target_list  */
  YYSYMBOL_target_list = 1280,             /* target_list  */
  YYSYMBOL_target_el = 1281,               /* target_el  */
  YYSYMBOL_qualified_name_list = 1282,     /* qualified_name_list  */
  YYSYMBOL_qualified_name = 1283,          /* qualified_name  */
  YYSYMBOL_name_list = 1284,               /* name_list  */
  YYSYMBOL_name = 1285,                    /* name  */
  YYSYMBOL_database_name = 1286,           /* database_name  */
  YYSYMBOL_access_method = 1287,           /* access_method  */
  YYSYMBOL_attr_name = 1288,               /* attr_name  */
  YYSYMBOL_index_name = 1289,              /* index_name  */
  YYSYMBOL_file_name = 1290,               /* file_name  */
  YYSYMBOL_func_name = 1291,               /* func_name  */
  YYSYMBOL_AexprConst = 1292,              /* AexprConst  */
  YYSYMBOL_Iconst = 1293,                  /* Iconst  */
  YYSYMBOL_SignedIconst = 1294,            /* SignedIconst  */
  YYSYMBOL_RoleId = 1295,                  /* RoleId  */
  YYSYMBOL_RoleSpec = 1296,                /* RoleSpec  */
  YYSYMBOL_role_list = 1297,               /* role_list  */
  YYSYMBOL_NonReservedWord = 1298,         /* NonReservedWord  */
  YYSYMBOL_unreserved_keyword = 1299,      /* unreserved_keyword  */
  YYSYMBOL_col_name_keyword = 1300,        /* col_name_keyword  */
  YYSYMBOL_type_func_name_keyword = 1301,  /* type_func_name_keyword  */
  YYSYMBOL_reserved_keyword = 1302,        /* reserved_keyword  */
  YYSYMBOL_statements = 1303,              /* statements  */
  YYSYMBOL_statement = 1304,               /* statement  */
  YYSYMBOL_CreateAsStmt = 1305,            /* CreateAsStmt  */
  YYSYMBOL_1306_1 = 1306,                  /* $@1  */
  YYSYMBOL_at = 1307,                      /* at  */
  YYSYMBOL_ECPGConnect = 1308,             /* ECPGConnect  */
  YYSYMBOL_connection_target = 1309,       /* connection_target  */
  YYSYMBOL_opt_database_name = 1310,       /* opt_database_name  */
  YYSYMBOL_db_prefix = 1311,               /* db_prefix  */
  YYSYMBOL_server = 1312,                  /* server  */
  YYSYMBOL_opt_server = 1313,              /* opt_server  */
  YYSYMBOL_server_name = 1314,             /* server_name  */
  YYSYMBOL_opt_port = 1315,                /* opt_port  */
  YYSYMBOL_opt_connection_name = 1316,     /* opt_connection_name  */
  YYSYMBOL_opt_user = 1317,                /* opt_user  */
  YYSYMBOL_ora_user = 1318,                /* ora_user  */
  YYSYMBOL_user_name = 1319,               /* user_name  */
  YYSYMBOL_char_variable = 1320,           /* char_variable  */
  YYSYMBOL_opt_options = 1321,             /* opt_options  */
  YYSYMBOL_connect_options = 1322,         /* connect_options  */
  YYSYMBOL_opt_opt_value = 1323,           /* opt_opt_value  */
  YYSYMBOL_prepared_name = 1324,           /* prepared_name  */
  YYSYMBOL_ECPGCursorStmt = 1325,          /* ECPGCursorStmt  */
  YYSYMBOL_ECPGExecuteImmediateStmt = 1326, /* ECPGExecuteImmediateStmt  */
  YYSYMBOL_ECPGVarDeclaration = 1327,      /* ECPGVarDeclaration  */
  YYSYMBOL_single_vt_declaration = 1328,   /* single_vt_declaration  */
  YYSYMBOL_precision = 1329,               /* precision  */
  YYSYMBOL_opt_scale = 1330,               /* opt_scale  */
  YYSYMBOL_ecpg_interval = 1331,           /* ecpg_interval  */
  YYSYMBOL_ECPGDeclaration = 1332,         /* ECPGDeclaration  */
  YYSYMBOL_1333_2 = 1333,                  /* $@2  */
  YYSYMBOL_sql_startdeclare = 1334,        /* sql_startdeclare  */
  YYSYMBOL_sql_enddeclare = 1335,          /* sql_enddeclare  */
  YYSYMBOL_var_type_declarations = 1336,   /* var_type_declarations  */
  YYSYMBOL_vt_declarations = 1337,         /* vt_declarations  */
  YYSYMBOL_variable_declarations = 1338,   /* variable_declarations  */
  YYSYMBOL_type_declaration = 1339,        /* type_declaration  */
  YYSYMBOL_1340_3 = 1340,                  /* $@3  */
  YYSYMBOL_var_declaration = 1341,         /* var_declaration  */
  YYSYMBOL_1342_4 = 1342,                  /* $@4  */
  YYSYMBOL_1343_5 = 1343,                  /* $@5  */
  YYSYMBOL_opt_bit_field = 1344,           /* opt_bit_field  */
  YYSYMBOL_storage_declaration = 1345,     /* storage_declaration  */
  YYSYMBOL_storage_clause = 1346,          /* storage_clause  */
  YYSYMBOL_storage_modifier = 1347,        /* storage_modifier  */
  YYSYMBOL_var_type = 1348,                /* var_type  */
  YYSYMBOL_enum_type = 1349,               /* enum_type  */
  YYSYMBOL_enum_definition = 1350,         /* enum_definition  */
  YYSYMBOL_struct_union_type_with_symbol = 1351, /* struct_union_type_with_symbol  */
  YYSYMBOL_1352_6 = 1352,                  /* $@6  */
  YYSYMBOL_struct_union_type = 1353,       /* struct_union_type  */
  YYSYMBOL_1354_7 = 1354,                  /* $@7  */
  YYSYMBOL_s_struct_union_symbol = 1355,   /* s_struct_union_symbol  */
  YYSYMBOL_s_struct_union = 1356,          /* s_struct_union  */
  YYSYMBOL_simple_type = 1357,             /* simple_type  */
  YYSYMBOL_unsigned_type = 1358,           /* unsigned_type  */
  YYSYMBOL_signed_type = 1359,             /* signed_type  */
  YYSYMBOL_opt_signed = 1360,              /* opt_signed  */
  YYSYMBOL_variable_list = 1361,           /* variable_list  */
  YYSYMBOL_variable = 1362,                /* variable  */
  YYSYMBOL_opt_initializer = 1363,         /* opt_initializer  */
  YYSYMBOL_opt_pointer = 1364,             /* opt_pointer  */
  YYSYMBOL_ECPGDeclare = 1365,             /* ECPGDeclare  */
  YYSYMBOL_ECPGDisconnect = 1366,          /* ECPGDisconnect  */
  YYSYMBOL_dis_name = 1367,                /* dis_name  */
  YYSYMBOL_connection_object = 1368,       /* connection_object  */
  YYSYMBOL_execstring = 1369,              /* execstring  */
  YYSYMBOL_ECPGFree = 1370,                /* ECPGFree  */
  YYSYMBOL_ECPGOpen = 1371,                /* ECPGOpen  */
  YYSYMBOL_opt_ecpg_using = 1372,          /* opt_ecpg_using  */
  YYSYMBOL_ecpg_using = 1373,              /* ecpg_using  */
  YYSYMBOL_using_descriptor = 1374,        /* using_descriptor  */
  YYSYMBOL_into_descriptor = 1375,         /* into_descriptor  */
  YYSYMBOL_into_sqlda = 1376,              /* into_sqlda  */
  YYSYMBOL_using_list = 1377,              /* using_list  */
  YYSYMBOL_UsingValue = 1378,              /* UsingValue  */
  YYSYMBOL_UsingConst = 1379,              /* UsingConst  */
  YYSYMBOL_ECPGDescribe = 1380,            /* ECPGDescribe  */
  YYSYMBOL_opt_output = 1381,              /* opt_output  */
  YYSYMBOL_ECPGAllocateDescr = 1382,       /* ECPGAllocateDescr  */
  YYSYMBOL_ECPGDeallocateDescr = 1383,     /* ECPGDeallocateDescr  */
  YYSYMBOL_ECPGGetDescriptorHeader = 1384, /* ECPGGetDescriptorHeader  */
  YYSYMBOL_ECPGGetDescHeaderItems = 1385,  /* ECPGGetDescHeaderItems  */
  YYSYMBOL_ECPGGetDescHeaderItem = 1386,   /* ECPGGetDescHeaderItem  */
  YYSYMBOL_ECPGSetDescriptorHeader = 1387, /* ECPGSetDescriptorHeader  */
  YYSYMBOL_ECPGSetDescHeaderItems = 1388,  /* ECPGSetDescHeaderItems  */
  YYSYMBOL_ECPGSetDescHeaderItem = 1389,   /* ECPGSetDescHeaderItem  */
  YYSYMBOL_IntConstVar = 1390,             /* IntConstVar  */
  YYSYMBOL_desc_header_item = 1391,        /* desc_header_item  */
  YYSYMBOL_ECPGGetDescriptor = 1392,       /* ECPGGetDescriptor  */
  YYSYMBOL_ECPGGetDescItems = 1393,        /* ECPGGetDescItems  */
  YYSYMBOL_ECPGGetDescItem = 1394,         /* ECPGGetDescItem  */
  YYSYMBOL_ECPGSetDescriptor = 1395,       /* ECPGSetDescriptor  */
  YYSYMBOL_ECPGSetDescItems = 1396,        /* ECPGSetDescItems  */
  YYSYMBOL_ECPGSetDescItem = 1397,         /* ECPGSetDescItem  */
  YYSYMBOL_AllConstVar = 1398,             /* AllConstVar  */
  YYSYMBOL_descriptor_item = 1399,         /* descriptor_item  */
  YYSYMBOL_ECPGSetAutocommit = 1400,       /* ECPGSetAutocommit  */
  YYSYMBOL_on_off = 1401,                  /* on_off  */
  YYSYMBOL_ECPGSetConnection = 1402,       /* ECPGSetConnection  */
  YYSYMBOL_ECPGTypedef = 1403,             /* ECPGTypedef  */
  YYSYMBOL_1404_8 = 1404,                  /* $@8  */
  YYSYMBOL_opt_reference = 1405,           /* opt_reference  */
  YYSYMBOL_ECPGVar = 1406,                 /* ECPGVar  */
  YYSYMBOL_1407_9 = 1407,                  /* $@9  */
  YYSYMBOL_ECPGWhenever = 1408,            /* ECPGWhenever  */
  YYSYMBOL_action = 1409,                  /* action  */
  YYSYMBOL_ECPGKeywords = 1410,            /* ECPGKeywords  */
  YYSYMBOL_ECPGKeywords_vanames = 1411,    /* ECPGKeywords_vanames  */
  YYSYMBOL_ECPGKeywords_rest = 1412,       /* ECPGKeywords_rest  */
  YYSYMBOL_ECPGTypeName = 1413,            /* ECPGTypeName  */
  YYSYMBOL_symbol = 1414,                  /* symbol  */
  YYSYMBOL_ECPGColId = 1415,               /* ECPGColId  */
  YYSYMBOL_ColId = 1416,                   /* ColId  */
  YYSYMBOL_type_function_name = 1417,      /* type_function_name  */
  YYSYMBOL_ColLabel = 1418,                /* ColLabel  */
  YYSYMBOL_ECPGColLabel = 1419,            /* ECPGColLabel  */
  YYSYMBOL_ECPGColLabelCommon = 1420,      /* ECPGColLabelCommon  */
  YYSYMBOL_ECPGCKeywords = 1421,           /* ECPGCKeywords  */
  YYSYMBOL_all_unreserved_keyword = 1422,  /* all_unreserved_keyword  */
  YYSYMBOL_ECPGunreserved_interval = 1423, /* ECPGunreserved_interval  */
  YYSYMBOL_into_list = 1424,               /* into_list  */
  YYSYMBOL_ecpgstart = 1425,               /* ecpgstart  */
  YYSYMBOL_c_args = 1426,                  /* c_args  */
  YYSYMBOL_coutputvariable = 1427,         /* coutputvariable  */
  YYSYMBOL_civarind = 1428,                /* civarind  */
  YYSYMBOL_char_civar = 1429,              /* char_civar  */
  YYSYMBOL_civar = 1430,                   /* civar  */
  YYSYMBOL_indicator = 1431,               /* indicator  */
  YYSYMBOL_cvariable = 1432,               /* cvariable  */
  YYSYMBOL_ecpg_param = 1433,              /* ecpg_param  */
  YYSYMBOL_ecpg_bconst = 1434,             /* ecpg_bconst  */
  YYSYMBOL_ecpg_fconst = 1435,             /* ecpg_fconst  */
  YYSYMBOL_ecpg_sconst = 1436,             /* ecpg_sconst  */
  YYSYMBOL_ecpg_xconst = 1437,             /* ecpg_xconst  */
  YYSYMBOL_ecpg_ident = 1438,              /* ecpg_ident  */
  YYSYMBOL_quoted_ident_stringvar = 1439,  /* quoted_ident_stringvar  */
  YYSYMBOL_c_stuff_item = 1440,            /* c_stuff_item  */
  YYSYMBOL_c_stuff = 1441,                 /* c_stuff  */
  YYSYMBOL_c_list = 1442,                  /* c_list  */
  YYSYMBOL_c_term = 1443,                  /* c_term  */
  YYSYMBOL_c_thing = 1444,                 /* c_thing  */
  YYSYMBOL_c_anything = 1445,              /* c_anything  */
  YYSYMBOL_DeallocateStmt = 1446,          /* DeallocateStmt  */
  YYSYMBOL_Iresult = 1447,                 /* Iresult  */
  YYSYMBOL_execute_rest = 1448,            /* execute_rest  */
  YYSYMBOL_ecpg_into = 1449,               /* ecpg_into  */
  YYSYMBOL_opt_ecpg_into = 1450,           /* opt_ecpg_into  */
  YYSYMBOL_ecpg_fetch_into = 1451,         /* ecpg_fetch_into  */
  YYSYMBOL_opt_ecpg_fetch_into = 1452      /* opt_ecpg_fetch_into  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   153418

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  591
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  862
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3485
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6613

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   826


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   578,     2,     2,
     583,   584,   576,   574,   586,   575,   585,   577,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   588,   587,
     570,   572,   571,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   581,     2,   582,   579,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   589,     2,   590,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   573,   580
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1669,  1669,  1672,  1674,  1676,  1678,  1680,  1682,  1684,
    1686,  1688,  1690,  1692,  1694,  1696,  1698,  1700,  1702,  1704,
    1706,  1708,  1710,  1712,  1714,  1716,  1718,  1720,  1722,  1724,
    1726,  1728,  1730,  1732,  1734,  1736,  1738,  1740,  1742,  1744,
    1746,  1748,  1750,  1752,  1754,  1772,  1774,  1776,  1778,  1780,
    1782,  1784,  1786,  1788,  1790,  1792,  1794,  1796,  1798,  1800,
    1802,  1804,  1806,  1808,  1810,  1812,  1814,  1816,  1818,  1820,
    1822,  1824,  1826,  1828,  1830,  1832,  1834,  1836,  1838,  1840,
    1842,  1844,  1846,  1848,  1850,  1852,  1856,  1858,  1860,  1862,
    1864,  1866,  1868,  1870,  1872,  1874,  1876,  1878,  1880,  1882,
    1884,  1886,  1888,  1890,  1892,  1894,  1896,  1898,  1900,  1902,
    1904,  1906,  1908,  1910,  1912,  1914,  1916,  1918,  1920,  1922,
    1924,  1926,  1928,  1930,  1932,  1939,  1941,  1943,  1945,  1947,
    1949,  1951,  1953,  1955,  1957,  1959,  1961,  1963,  1969,  1971,
    1973,  1975,  1977,  1979,  1981,  1983,  1985,  1991,  2001,  2005,
    2011,  2015,  2025,  2035,  2036,  2050,  2057,  2063,  2074,  2080,
    2089,  2096,  2102,  2111,  2118,  2126,  2131,  2139,  2143,  2148,
    2154,  2159,  2165,  2170,  2176,  2180,  2184,  2188,  2193,  2197,
    2201,  2205,  2209,  2217,  2221,  2225,  2229,  2233,  2237,  2245,
    2253,  2257,  2266,  2268,  2276,  2280,  2284,  2288,  2296,  2300,
    2304,  2308,  2312,  2316,  2324,  2332,  2340,  2344,  2352,  2356,
    2360,  2365,  2374,  2379,  2385,  2390,  2396,  2400,  2404,  2408,
    2412,  2416,  2424,  2428,  2432,  2440,  2444,  2448,  2456,  2460,
    2464,  2468,  2469,  2473,  2477,  2481,  2486,  2490,  2494,  2498,
    2502,  2506,  2510,  2518,  2522,  2530,  2534,  2542,  2546,  2560,
    2564,  2568,  2572,  2580,  2584,  2588,  2592,  2600,  2604,  2608,
    2612,  2616,  2620,  2624,  2632,  2636,  2641,  2647,  2651,  2659,
    2667,  2671,  2675,  2679,  2687,  2691,  2699,  2703,  2711,  2715,
    2723,  2727,  2731,  2735,  2739,  2748,  2756,  2760,  2768,  2772,
    2780,  2788,  2792,  2796,  2800,  2804,  2812,  2816,  2820,  2824,
    2828,  2832,  2836,  2840,  2844,  2848,  2852,  2856,  2860,  2864,
    2868,  2872,  2876,  2880,  2884,  2892,  2896,  2904,  2908,  2916,
    2920,  2928,  2936,  2944,  2948,  2952,  2956,  2960,  2964,  2968,
    2972,  2976,  2980,  2984,  2988,  2992,  2996,  3000,  3004,  3008,
    3012,  3016,  3020,  3024,  3028,  3032,  3036,  3040,  3044,  3048,
    3052,  3056,  3060,  3064,  3068,  3072,  3076,  3080,  3084,  3088,
    3092,  3096,  3100,  3104,  3108,  3112,  3116,  3120,  3124,  3128,
    3132,  3136,  3140,  3144,  3148,  3152,  3156,  3160,  3164,  3168,
    3172,  3176,  3180,  3184,  3188,  3192,  3196,  3204,  3208,  3216,
    3220,  3225,  3231,  3236,  3242,  3247,  3253,  3257,  3261,  3265,
    3273,  3278,  3284,  3292,  3297,  3303,  3307,  3315,  3319,  3323,
    3327,  3335,  3339,  3347,  3351,  3355,  3359,  3367,  3371,  3375,
    3379,  3387,  3395,  3399,  3407,  3411,  3415,  3419,  3423,  3431,
    3435,  3443,  3447,  3455,  3459,  3463,  3471,  3479,  3483,  3491,
    3495,  3499,  3503,  3511,  3516,  3524,  3532,  3540,  3544,  3552,
    3557,  3563,  3568,  3574,  3578,  3582,  3590,  3594,  3602,  3607,
    3613,  3617,  3621,  3625,  3629,  3633,  3637,  3641,  3645,  3649,
    3653,  3657,  3661,  3665,  3669,  3677,  3682,  3688,  3693,  3699,
    3704,  3710,  3715,  3721,  3725,  3733,  3741,  3745,  3749,  3753,
    3758,  3764,  3768,  3776,  3784,  3788,  3792,  3796,  3800,  3804,
    3812,  3816,  3820,  3824,  3828,  3832,  3836,  3841,  3847,  3852,
    3858,  3863,  3869,  3873,  3881,  3885,  3893,  3897,  3901,  3909,
    3913,  3921,  3929,  3933,  3941,  3946,  3952,  3956,  3960,  3964,
    3972,  3976,  3980,  3984,  3988,  3992,  3996,  4000,  4008,  4012,
    4020,  4024,  4028,  4032,  4040,  4048,  4052,  4057,  4063,  4067,
    4071,  4075,  4079,  4083,  4087,  4095,  4099,  4107,  4111,  4115,
    4119,  4123,  4127,  4131,  4139,  4144,  4150,  4155,  4161,  4165,
    4173,  4181,  4185,  4190,  4195,  4201,  4205,  4213,  4217,  4225,
    4230,  4236,  4240,  4244,  4248,  4253,  4259,  4267,  4275,  4279,
    4283,  4287,  4291,  4299,  4304,  4310,  4315,  4321,  4329,  4334,
    4340,  4344,  4352,  4356,  4364,  4368,  4372,  4380,  4384,  4388,
    4393,  4399,  4403,  4407,  4412,  4418,  4423,  4429,  4434,  4440,
    4448,  4452,  4456,  4464,  4469,  4475,  4479,  4483,  4487,  4491,
    4499,  4504,  4510,  4514,  4518,  4526,  4530,  4535,  4541,  4549,
    4553,  4561,  4569,  4573,  4578,  4584,  4588,  4596,  4604,  4609,
    4615,  4623,  4627,  4635,  4639,  4647,  4652,  4658,  4663,  4669,
    4673,  4681,  4685,  4689,  4693,  4697,  4701,  4705,  4709,  4713,
    4717,  4721,  4725,  4729,  4733,  4741,  4746,  4752,  4756,  4760,
    4764,  4772,  4776,  4784,  4788,  4796,  4801,  4807,  4811,  4819,
    4824,  4830,  4834,  4842,  4847,  4853,  4857,  4865,  4870,  4876,
    4884,  4889,  4895,  4899,  4907,  4911,  4915,  4919,  4923,  4927,
    4935,  4940,  4946,  4950,  4954,  4958,  4966,  4974,  4979,  4985,
    4993,  4997,  5001,  5005,  5009,  5013,  5017,  5021,  5025,  5029,
    5033,  5037,  5041,  5045,  5049,  5053,  5057,  5061,  5065,  5069,
    5073,  5077,  5081,  5085,  5089,  5093,  5101,  5109,  5113,  5117,
    5121,  5129,  5133,  5141,  5146,  5152,  5156,  5164,  5169,  5175,
    5179,  5187,  5195,  5199,  5207,  5211,  5215,  5219,  5227,  5235,
    5243,  5251,  5255,  5263,  5268,  5274,  5278,  5286,  5291,  5297,
    5301,  5305,  5313,  5317,  5321,  5325,  5333,  5337,  5345,  5353,
    5357,  5365,  5370,  5376,  5380,  5388,  5392,  5400,  5404,  5412,
    5420,  5428,  5436,  5441,  5447,  5452,  5458,  5463,  5469,  5474,
    5480,  5485,  5491,  5496,  5502,  5506,  5510,  5514,  5518,  5526,
    5534,  5538,  5546,  5550,  5554,  5562,  5566,  5574,  5578,  5582,
    5586,  5590,  5598,  5603,  5609,  5613,  5621,  5629,  5633,  5641,
    5645,  5653,  5661,  5666,  5672,  5677,  5683,  5687,  5695,  5700,
    5706,  5710,  5715,  5721,  5725,  5729,  5733,  5741,  5746,  5753,
    5755,  5763,  5767,  5771,  5775,  5779,  5783,  5791,  5795,  5803,
    5807,  5815,  5823,  5827,  5835,  5843,  5847,  5851,  5855,  5863,
    5872,  5881,  5885,  5889,  5893,  5897,  5901,  5905,  5909,  5913,
    5917,  5921,  5925,  5929,  5933,  5937,  5941,  5949,  5957,  5961,
    5969,  5973,  5981,  5985,  5989,  5993,  5997,  6001,  6009,  6017,
    6021,  6029,  6037,  6042,  6048,  6052,  6060,  6064,  6068,  6072,
    6080,  6085,  6091,  6099,  6103,  6111,  6115,  6119,  6123,  6127,
    6135,  6140,  6146,  6151,  6157,  6161,  6166,  6172,  6178,  6184,
    6192,  6196,  6204,  6208,  6216,  6220,  6228,  6232,  6240,  6244,
    6252,  6260,  6268,  6272,  6276,  6280,  6284,  6288,  6292,  6296,
    6300,  6304,  6308,  6312,  6320,  6324,  6328,  6332,  6336,  6340,
    6344,  6348,  6352,  6356,  6360,  6364,  6368,  6376,  6380,  6384,
    6388,  6392,  6396,  6400,  6408,  6412,  6416,  6424,  6428,  6436,
    6440,  6448,  6452,  6460,  6464,  6465,  6473,  6477,  6482,  6488,
    6492,  6496,  6500,  6504,  6508,  6512,  6516,  6520,  6524,  6528,
    6532,  6536,  6540,  6544,  6548,  6552,  6560,  6564,  6568,  6572,
    6576,  6580,  6584,  6588,  6592,  6596,  6600,  6604,  6608,  6612,
    6620,  6624,  6628,  6632,  6636,  6640,  6644,  6648,  6652,  6656,
    6660,  6664,  6668,  6676,  6680,  6688,  6692,  6696,  6700,  6704,
    6708,  6712,  6720,  6725,  6731,  6735,  6739,  6743,  6747,  6751,
    6759,  6763,  6767,  6771,  6775,  6779,  6783,  6787,  6791,  6799,
    6803,  6811,  6815,  6819,  6823,  6829,  6835,  6841,  6847,  6853,
    6859,  6865,  6875,  6886,  6897,  6908,  6919,  6930,  6941,  6957,
    6973,  6989,  7000,  7016,  7027,  7043,  7058,  7062,  7070,  7075,
    7081,  7089,  7093,  7101,  7105,  7109,  7113,  7117,  7125,  7129,
    7137,  7141,  7145,  7149,  7157,  7161,  7165,  7169,  7173,  7177,
    7181,  7185,  7189,  7193,  7197,  7201,  7205,  7209,  7213,  7217,
    7225,  7229,  7237,  7241,  7249,  7254,  7260,  7268,  7272,  7280,
    7285,  7291,  7296,  7302,  7310,  7315,  7321,  7325,  7329,  7337,
    7341,  7345,  7353,  7357,  7361,  7365,  7369,  7377,  7381,  7389,
    7394,  7400,  7405,  7411,  7416,  7422,  7427,  7433,  7437,  7445,
    7449,  7453,  7461,  7466,  7472,  7477,  7483,  7487,  7492,  7498,
    7502,  7507,  7513,  7517,  7521,  7529,  7534,  7540,  7544,  7552,
    7556,  7564,  7568,  7576,  7580,  7584,  7588,  7596,  7600,  7608,
    7612,  7620,  7624,  7628,  7632,  7636,  7644,  7648,  7652,  7656,
    7660,  7668,  7676,  7684,  7688,  7692,  7700,  7704,  7708,  7716,
    7725,  7729,  7733,  7737,  7745,  7749,  7757,  7765,  7769,  7777,
    7781,  7789,  7793,  7797,  7801,  7805,  7809,  7813,  7817,  7821,
    7825,  7829,  7833,  7837,  7841,  7845,  7849,  7853,  7857,  7865,
    7869,  7873,  7877,  7881,  7889,  7893,  7901,  7905,  7913,  7918,
    7924,  7932,  7936,  7944,  7952,  7956,  7964,  7969,  7975,  7979,
    7987,  7991,  7999,  8003,  8011,  8015,  8019,  8023,  8031,  8035,
    8043,  8047,  8055,  8063,  8071,  8075,  8083,  8087,  8095,  8099,
    8103,  8111,  8115,  8120,  8126,  8134,  8139,  8145,  8153,  8157,
    8161,  8165,  8173,  8181,  8185,  8189,  8193,  8201,  8205,  8213,
    8217,  8221,  8229,  8233,  8241,  8249,  8253,  8261,  8265,  8269,
    8273,  8277,  8281,  8285,  8289,  8293,  8297,  8301,  8305,  8309,
    8313,  8317,  8321,  8325,  8329,  8333,  8337,  8341,  8345,  8349,
    8353,  8357,  8361,  8365,  8369,  8373,  8377,  8381,  8385,  8389,
    8393,  8397,  8401,  8405,  8409,  8413,  8417,  8421,  8425,  8429,
    8433,  8437,  8441,  8445,  8449,  8453,  8457,  8461,  8465,  8473,
    8478,  8484,  8489,  8495,  8499,  8503,  8507,  8515,  8519,  8523,
    8527,  8531,  8535,  8539,  8543,  8547,  8551,  8555,  8559,  8563,
    8567,  8571,  8575,  8579,  8583,  8587,  8591,  8595,  8599,  8603,
    8607,  8611,  8619,  8627,  8631,  8639,  8643,  8651,  8655,  8659,
    8663,  8667,  8675,  8679,  8683,  8687,  8691,  8695,  8699,  8703,
    8707,  8711,  8715,  8719,  8723,  8727,  8731,  8735,  8739,  8743,
    8747,  8751,  8755,  8759,  8767,  8775,  8780,  8786,  8790,  8798,
    8803,  8809,  8817,  8821,  8825,  8829,  8837,  8841,  8849,  8853,
    8861,  8869,  8873,  8877,  8881,  8885,  8889,  8893,  8897,  8901,
    8905,  8909,  8913,  8921,  8925,  8929,  8933,  8941,  8949,  8953,
    8957,  8965,  8969,  8977,  8981,  8985,  8989,  8993,  9001,  9006,
    9012,  9016,  9020,  9024,  9032,  9036,  9041,  9047,  9055,  9060,
    9066,  9074,  9078,  9086,  9090,  9094,  9098,  9102,  9106,  9110,
    9114,  9118,  9122,  9126,  9130,  9134,  9138,  9142,  9146,  9150,
    9154,  9158,  9166,  9170,  9175,  9181,  9185,  9189,  9193,  9197,
    9205,  9209,  9213,  9221,  9226,  9232,  9236,  9240,  9245,  9254,
    9258,  9262,  9267,  9273,  9281,  9289,  9294,  9300,  9304,  9312,
    9316,  9320,  9328,  9332,  9336,  9340,  9344,  9348,  9352,  9360,
    9365,  9371,  9375,  9379,  9387,  9395,  9399,  9403,  9407,  9415,
    9423,  9427,  9435,  9443,  9447,  9451,  9455,  9459,  9463,  9467,
    9475,  9480,  9486,  9494,  9498,  9502,  9506,  9510,  9514,  9522,
    9526,  9534,  9542,  9546,  9550,  9558,  9563,  9569,  9573,  9577,
    9581,  9585,  9589,  9597,  9601,  9609,  9613,  9617,  9621,  9625,
    9633,  9637,  9641,  9645,  9653,  9657,  9665,  9669,  9673,  9678,
    9684,  9689,  9695,  9700,  9706,  9711,  9717,  9721,  9729,  9733,
    9741,  9746,  9752,  9756,  9760,  9764,  9772,  9776,  9784,  9789,
    9795,  9800,  9806,  9810,  9818,  9822,  9830,  9834,  9838,  9842,
    9846,  9850,  9854,  9858,  9862,  9866,  9870,  9874,  9878,  9882,
    9886,  9890,  9894,  9898,  9902,  9906,  9910,  9914,  9918,  9922,
    9926,  9930,  9934,  9938,  9942,  9946,  9950,  9954,  9958,  9962,
    9966,  9970,  9974,  9978,  9982,  9986,  9990,  9994,  9998, 10002,
   10006, 10010, 10014, 10018, 10022, 10026, 10030, 10034, 10038, 10042,
   10046, 10050, 10054, 10058, 10062, 10066, 10070, 10074, 10078, 10082,
   10086, 10090, 10094, 10098, 10102, 10106, 10110, 10114, 10118, 10122,
   10126, 10130, 10134, 10138, 10142, 10146, 10150, 10154, 10158, 10162,
   10166, 10170, 10174, 10178, 10182, 10186, 10190, 10194, 10198, 10202,
   10206, 10214, 10218, 10226, 10230, 10234, 10238, 10242, 10246, 10254,
   10258, 10262, 10266, 10270, 10278, 10282, 10286, 10290, 10294, 10298,
   10302, 10306, 10314, 10322, 10326, 10334, 10342, 10347, 10353, 10357,
   10365, 10373, 10381, 10389, 10393, 10401, 10405, 10409, 10413, 10421,
   10425, 10433, 10437, 10445, 10453, 10461, 10465, 10469, 10473, 10481,
   10485, 10493, 10497, 10505, 10509, 10513, 10517, 10525, 10533, 10537,
   10545, 10550, 10559, 10563, 10571, 10575, 10583, 10587, 10591, 10595,
   10603, 10607, 10611, 10615, 10619, 10623, 10627, 10631, 10635, 10643,
   10647, 10655, 10663, 10667, 10675, 10679, 10684, 10690, 10698, 10706,
   10710, 10714, 10722, 10726, 10731, 10737, 10741, 10746, 10752, 10757,
   10763, 10769, 10779, 10784, 10790, 10794, 10798, 10802, 10810, 10812,
   10820, 10825, 10831, 10839, 10843, 10851, 10855, 10859, 10863, 10867,
   10875, 10879, 10887, 10891, 10899, 10907, 10911, 10916, 10922, 10926,
   10931, 10937, 10942, 10948, 10956, 10961, 10967, 10975, 10980, 10986,
   10990, 10994, 10998, 11002, 11006, 11010, 11014, 11022, 11027, 11033,
   11037, 11042, 11048, 11052, 11060, 11064, 11072, 11076, 11084, 11092,
   11096, 11104, 11108, 11116, 11124, 11128, 11136, 11189, 11193, 11206,
   11208, 11212, 11216, 11220, 11229, 11235, 11239, 11247, 11251, 11259,
   11263, 11271, 11275, 11279, 11283, 11287, 11291, 11295, 11299, 11307,
   11311, 11319, 11323, 11327, 11331, 11335, 11339, 11343, 11351, 11355,
   11359, 11367, 11371, 11379, 11387, 11391, 11396, 11402, 11407, 11413,
   11418, 11420, 11426, 11430, 11434, 11438, 11442, 11446, 11450, 11454,
   11458, 11466, 11471, 11477, 11481, 11486, 11492, 11496, 11504, 11509,
   11515, 11520, 11526, 11534, 11538, 11546, 11550, 11558, 11562, 11566,
   11570, 11578, 11583, 11589, 11593, 11598, 11606, 11610, 11618, 11622,
   11630, 11638, 11642, 11647, 11653, 11661, 11665, 11673, 11677, 11685,
   11690, 11696, 11700, 11708, 11712, 11716, 11720, 11724, 11732, 11740,
   11748, 11756, 11764, 11769, 11775, 11779, 11787, 11792, 11798, 11802,
   11810, 11818, 11822, 11826, 11830, 11838, 11843, 11849, 11853, 11861,
   11866, 11872, 11876, 11884, 11888, 11892, 11896, 11900, 11904, 11908,
   11915, 11922, 11926, 11934, 11938, 11942, 11946, 11950, 11954, 11962,
   11966, 11970, 11974, 11982, 11987, 11993, 11997, 12001, 12005, 12010,
   12016, 12020, 12024, 12028, 12036, 12041, 12047, 12051, 12059, 12063,
   12067, 12071, 12079, 12084, 12090, 12094, 12102, 12106, 12114, 12118,
   12122, 12130, 12138, 12143, 12149, 12153, 12161, 12169, 12173, 12181,
   12186, 12192, 12197, 12203, 12208, 12214, 12218, 12224, 12230, 12235,
   12241, 12245, 12253, 12261, 12265, 12273, 12277, 12285, 12289, 12293,
   12301, 12305, 12313, 12317, 12321, 12325, 12333, 12337, 12345, 12349,
   12357, 12359, 12361, 12365, 12369, 12373, 12381, 12391, 12402, 12411,
   12415, 12419, 12423, 12427, 12431, 12435, 12443, 12447, 12451, 12455,
   12463, 12467, 12475, 12480, 12486, 12490, 12494, 12498, 12502, 12506,
   12510, 12514, 12518, 12522, 12526, 12530, 12534, 12538, 12546, 12551,
   12557, 12561, 12569, 12573, 12581, 12589, 12597, 12601, 12609, 12613,
   12621, 12629, 12637, 12641, 12645, 12649, 12653, 12657, 12665, 12670,
   12676, 12680, 12684, 12688, 12696, 12704, 12708, 12713, 12719, 12723,
   12727, 12731, 12735, 12739, 12743, 12747, 12751, 12755, 12759, 12763,
   12767, 12772, 12778, 12782, 12790, 12794, 12798, 12802, 12806, 12810,
   12814, 12818, 12822, 12826, 12830, 12834, 12838, 12842, 12846, 12850,
   12854, 12858, 12862, 12866, 12870, 12874, 12878, 12882, 12886, 12890,
   12894, 12898, 12902, 12906, 12910, 12914, 12918, 12922, 12926, 12930,
   12934, 12938, 12942, 12946, 12950, 12954, 12958, 12962, 12966, 12970,
   12974, 12978, 12982, 12986, 12990, 12994, 12998, 13002, 13006, 13010,
   13014, 13018, 13022, 13026, 13030, 13035, 13039, 13043, 13051, 13055,
   13059, 13063, 13067, 13071, 13075, 13079, 13083, 13087, 13091, 13095,
   13099, 13103, 13107, 13111, 13115, 13119, 13123, 13127, 13131, 13135,
   13139, 13143, 13147, 13155, 13159, 13163, 13167, 13171, 13175, 13179,
   13183, 13187, 13191, 13195, 13199, 13203, 13207, 13215, 13219, 13223,
   13227, 13231, 13235, 13239, 13247, 13251, 13259, 13263, 13271, 13275,
   13279, 13283, 13287, 13291, 13295, 13299, 13303, 13307, 13311, 13315,
   13319, 13323, 13327, 13331, 13335, 13339, 13343, 13347, 13351, 13355,
   13359, 13363, 13367, 13371, 13375, 13379, 13383, 13387, 13391, 13395,
   13399, 13403, 13407, 13411, 13415, 13419, 13423, 13427, 13431, 13435,
   13439, 13443, 13447, 13451, 13459, 13463, 13471, 13475, 13479, 13484,
   13490, 13498, 13502, 13510, 13514, 13522, 13526, 13534, 13538, 13543,
   13549, 13553, 13557, 13561, 13569, 13574, 13580, 13585, 13591, 13596,
   13602, 13606, 13614, 13622, 13626, 13631, 13637, 13645, 13649, 13656,
   13661, 13667, 13672, 13677, 13683, 13687, 13695, 13699, 13703, 13707,
   13711, 13719, 13723, 13727, 13735, 13739, 13747, 13755, 13759, 13763,
   13771, 13775, 13783, 13787, 13791, 13795, 13799, 13803, 13807, 13811,
   13815, 13819, 13823, 13827, 13835, 13839, 13847, 13851, 13859, 13863,
   13867, 13871, 13875, 13879, 13887, 13891, 13899, 13903, 13911, 13915,
   13919, 13927, 13931, 13939, 13943, 13947, 13955, 13959, 13967, 13972,
   13978, 13982, 13986, 13990, 13994, 13998, 14002, 14006, 14014, 14018,
   14026, 14034, 14039, 14045, 14049, 14053, 14057, 14061, 14066, 14072,
   14080, 14088, 14092, 14096, 14104, 14108, 14116, 14124, 14128, 14136,
   14144, 14149, 14155, 14160, 14166, 14170, 14178, 14182, 14186, 14190,
   14198, 14203, 14209, 14213, 14222, 14224, 14232, 14237, 14243, 14248,
   14254, 14258, 14266, 14270, 14274, 14278, 14286, 14290, 14298, 14302,
   14310, 14314, 14322, 14330, 14338, 14346, 14354, 14362, 14370, 14374,
   14382, 14386, 14390, 14394, 14398, 14402, 14406, 14410, 14414, 14418,
   14422, 14426, 14430, 14434, 14435, 14440, 14446, 14450, 14451, 14455,
   14463, 14471, 14475, 14479, 14487, 14491, 14499, 14503, 14507, 14511,
   14519, 14523, 14527, 14531, 14535, 14539, 14543, 14547, 14551, 14555,
   14559, 14563, 14567, 14571, 14575, 14579, 14583, 14587, 14591, 14595,
   14599, 14603, 14607, 14611, 14615, 14619, 14623, 14627, 14631, 14635,
   14639, 14643, 14647, 14651, 14655, 14659, 14663, 14667, 14671, 14675,
   14679, 14683, 14687, 14691, 14695, 14699, 14703, 14707, 14711, 14715,
   14719, 14723, 14727, 14731, 14735, 14739, 14743, 14747, 14751, 14755,
   14759, 14763, 14767, 14771, 14775, 14779, 14783, 14787, 14791, 14795,
   14799, 14803, 14807, 14811, 14815, 14819, 14823, 14827, 14831, 14835,
   14839, 14843, 14847, 14851, 14855, 14859, 14863, 14867, 14871, 14875,
   14879, 14883, 14887, 14891, 14895, 14899, 14903, 14907, 14911, 14915,
   14919, 14923, 14927, 14931, 14935, 14939, 14943, 14947, 14951, 14955,
   14959, 14963, 14967, 14971, 14975, 14979, 14983, 14987, 14991, 14995,
   14999, 15003, 15007, 15011, 15015, 15019, 15023, 15027, 15031, 15035,
   15039, 15043, 15047, 15051, 15055, 15059, 15063, 15067, 15071, 15075,
   15079, 15083, 15087, 15091, 15095, 15099, 15103, 15107, 15111, 15115,
   15119, 15123, 15127, 15131, 15135, 15139, 15143, 15147, 15151, 15155,
   15159, 15163, 15167, 15171, 15175, 15179, 15183, 15187, 15191, 15195,
   15199, 15203, 15207, 15211, 15215, 15219, 15223, 15227, 15231, 15235,
   15239, 15243, 15247, 15251, 15255, 15259, 15263, 15267, 15271, 15275,
   15279, 15283, 15287, 15291, 15295, 15299, 15303, 15307, 15311, 15315,
   15319, 15323, 15327, 15331, 15335, 15339, 15343, 15347, 15351, 15355,
   15359, 15363, 15367, 15371, 15375, 15379, 15383, 15387, 15391, 15395,
   15399, 15403, 15407, 15411, 15415, 15419, 15423, 15427, 15431, 15435,
   15439, 15443, 15447, 15451, 15455, 15459, 15463, 15467, 15471, 15475,
   15479, 15483, 15487, 15491, 15495, 15499, 15503, 15507, 15511, 15515,
   15519, 15523, 15527, 15531, 15535, 15539, 15543, 15547, 15551, 15555,
   15559, 15563, 15567, 15571, 15575, 15579, 15583, 15587, 15591, 15595,
   15599, 15603, 15607, 15611, 15615, 15619, 15623, 15627, 15631, 15635,
   15639, 15643, 15647, 15651, 15655, 15659, 15663, 15667, 15671, 15675,
   15679, 15683, 15687, 15691, 15695, 15699, 15703, 15707, 15711, 15715,
   15719, 15723, 15731, 15735, 15739, 15743, 15747, 15751, 15755, 15759,
   15763, 15767, 15771, 15775, 15779, 15783, 15787, 15791, 15795, 15799,
   15803, 15807, 15811, 15815, 15819, 15823, 15827, 15831, 15835, 15839,
   15843, 15847, 15851, 15855, 15859, 15863, 15867, 15871, 15875, 15879,
   15883, 15887, 15891, 15895, 15899, 15903, 15907, 15911, 15915, 15919,
   15923, 15927, 15935, 15939, 15943, 15947, 15951, 15955, 15959, 15963,
   15967, 15971, 15975, 15979, 15983, 15987, 15991, 15995, 15999, 16003,
   16007, 16011, 16015, 16019, 16023, 16031, 16035, 16039, 16043, 16047,
   16051, 16055, 16059, 16063, 16067, 16071, 16075, 16079, 16083, 16087,
   16091, 16095, 16099, 16103, 16107, 16111, 16115, 16119, 16123, 16127,
   16131, 16135, 16139, 16143, 16147, 16151, 16155, 16159, 16163, 16167,
   16171, 16175, 16179, 16183, 16187, 16191, 16195, 16199, 16203, 16207,
   16211, 16215, 16219, 16223, 16227, 16231, 16235, 16239, 16243, 16247,
   16251, 16255, 16259, 16263, 16267, 16271, 16275, 16279, 16283, 16287,
   16291, 16295, 16299, 16303, 16307, 16311, 16315, 16319, 16323, 16327,
   16331, 16335, 16339, 16343, 16347, 16351, 16355, 16359, 16363, 16373,
   16374, 16377, 16378, 16379, 16385, 16386, 16387, 16388, 16389, 16402,
   16402, 16411, 16426, 16428, 16431, 16433, 16437, 16449, 16465, 16469,
   16480, 16481, 16484, 16496, 16505, 16506, 16509, 16510, 16511, 16514,
   16515, 16518, 16519, 16522, 16523, 16526, 16528, 16530, 16532, 16536,
   16543, 16550, 16566, 16600, 16610, 16613, 16617, 16630, 16631, 16633,
   16635, 16639, 16653, 16660, 16721, 16730, 16732, 16733, 16736, 16738,
   16739, 16742, 16743, 16744, 16745, 16746, 16753, 16752, 16762, 16764,
   16766, 16767, 16770, 16771, 16772, 16773, 16776, 16777, 16781, 16780,
   16797, 16795, 16811, 16810, 16824, 16830, 16831, 16834, 16836, 16837,
   16840, 16841, 16842, 16843, 16846, 16847, 16850, 16858, 16875, 16883,
   16906, 17012, 17046, 17048, 17050, 17054, 17058, 17057, 17108, 17110,
   17109, 17124, 17130, 17137, 17142, 17148, 17149, 17152, 17153, 17154,
   17155, 17156, 17157, 17158, 17166, 17174, 17177, 17178, 17179, 17180,
   17181, 17182, 17190, 17198, 17199, 17200, 17203, 17204, 17207, 17209,
   17218, 17306, 17307, 17314, 17315, 17316, 17322, 17331, 17334, 17335,
   17336, 17337, 17340, 17341, 17342, 17345, 17347, 17355, 17356, 17362,
   17370, 17371, 17374, 17375, 17378, 17383, 17390, 17395, 17402, 17409,
   17409, 17411, 17418, 17419, 17422, 17423, 17424, 17425, 17426, 17427,
   17428, 17429, 17430, 17436, 17443, 17455, 17461, 17468, 17476, 17477,
   17489, 17500, 17511, 17515, 17516, 17519, 17524, 17528, 17529, 17532,
   17538, 17546, 17552, 17559, 17563, 17564, 17567, 17570, 17574, 17575,
   17578, 17584, 17593, 17598, 17608, 17618, 17630, 17631, 17632, 17633,
   17634, 17635, 17636, 17637, 17638, 17639, 17640, 17641, 17642, 17643,
   17644, 17651, 17652, 17655, 17656, 17663, 17664, 17665, 17672, 17671,
   17688, 17689, 17696, 17695, 17765, 17771, 17777, 17785, 17791, 17797,
   17803, 17809, 17815, 17821, 17827, 17833, 17844, 17845, 17848, 17849,
   17850, 17851, 17852, 17853, 17854, 17855, 17856, 17857, 17858, 17859,
   17860, 17861, 17862, 17863, 17864, 17865, 17866, 17867, 17868, 17869,
   17870, 17873, 17874, 17875, 17876, 17877, 17878, 17882, 17883, 17884,
   17885, 17886, 17887, 17888, 17891, 17894, 17895, 17896, 17897, 17898,
   17899, 17900, 17901, 17914, 17915, 17916, 17917, 17918, 17919, 17920,
   17925, 17926, 17927, 17928, 17929, 17930, 17936, 17937, 17938, 17939,
   17940, 17941, 17942, 17943, 17944, 17945, 17946, 17949, 17950, 17951,
   17952, 17953, 17956, 17957, 17958, 17959, 17962, 17963, 17964, 17965,
   17966, 17967, 17968, 17985, 17986, 17987, 17990, 17991, 17992, 17993,
   17994, 17995, 17999, 17999, 18002, 18008, 18009, 18012, 18014, 18019,
   18029, 18040, 18047, 18048, 18049, 18052, 18085, 18087, 18089, 18092,
   18102, 18112, 18122, 18123, 18126, 18128, 18129, 18130, 18133, 18135,
   18143, 18144, 18145, 18149, 18150, 18154, 18155, 18158, 18159, 18162,
   18163, 18164, 18165, 18166, 18169, 18170, 18171, 18172, 18173, 18174,
   18175, 18176, 18177, 18178, 18179, 18180, 18181, 18182, 18183, 18184,
   18185, 18186, 18187, 18188, 18189, 18190, 18191, 18192, 18193, 18194,
   18195, 18196, 18197, 18198, 18199, 18200, 18201, 18202, 18203, 18204,
   18205, 18206, 18207, 18208, 18209, 18210, 18211, 18212, 18213, 18214,
   18215, 18216, 18217, 18218, 18219, 18220, 18221, 18222, 18223, 18224,
   18227, 18228, 18229, 18230, 18233, 18234, 18235, 18236, 18237, 18238,
   18239, 18240, 18241, 18242, 18249, 18250, 18251, 18252, 18255, 18256,
   18259, 18260, 18263, 18264, 18275, 18276
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "SQL_ALLOCATE",
  "SQL_AUTOCOMMIT", "SQL_BOOL", "SQL_BREAK", "SQL_CALL", "SQL_CARDINALITY",
  "SQL_CONNECT", "SQL_COUNT", "SQL_DATETIME_INTERVAL_CODE",
  "SQL_DATETIME_INTERVAL_PRECISION", "SQL_DESCRIBE", "SQL_DESCRIPTOR",
  "SQL_DISCONNECT", "SQL_FOUND", "SQL_FREE", "SQL_GET", "SQL_GO",
  "SQL_GOTO", "SQL_IDENTIFIED", "SQL_INDICATOR", "SQL_KEY_MEMBER",
  "SQL_LENGTH", "SQL_LONG", "SQL_NULLABLE", "SQL_OCTET_LENGTH", "SQL_OPEN",
  "SQL_OUTPUT", "SQL_REFERENCE", "SQL_RETURNED_LENGTH",
  "SQL_RETURNED_OCTET_LENGTH", "SQL_SCALE", "SQL_SECTION", "SQL_SHORT",
  "SQL_SIGNED", "SQL_SQLERROR", "SQL_SQLPRINT", "SQL_SQLWARNING",
  "SQL_START", "SQL_STOP", "SQL_STRUCT", "SQL_UNSIGNED", "SQL_VAR",
  "SQL_WHENEVER", "S_ADD", "S_AND", "S_ANYTHING", "S_AUTO", "S_CONST",
  "S_DEC", "S_DIV", "S_DOTPOINT", "S_EQUAL", "S_EXTERN", "S_INC",
  "S_LSHIFT", "S_MEMPOINT", "S_MEMBER", "S_MOD", "S_MUL", "S_NEQUAL",
  "S_OR", "S_REGISTER", "S_RSHIFT", "S_STATIC", "S_SUB", "S_VOLATILE",
  "S_TYPEDEF", "CSTRING", "CVARIABLE", "CPP_LINE", "IP", "DOLCONST",
  "ECONST", "NCONST", "UCONST", "UIDENT", "IDENT", "FCONST", "SCONST",
  "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT",
  "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS", "GREATER_EQUALS",
  "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P",
  "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS",
  "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTACH", "ATTRIBUTE", "AUDIT",
  "AUTHORIZATION", "BACKWARD", "BARRIER", "BEFORE", "BEGIN_P",
  "BEGIN_SUBTXN", "BETWEEN", "BIGINT", "BINARY", "BINARY_FLOAT",
  "BINARY_DOUBLE", "BIT", "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED",
  "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P",
  "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLEAN",
  "CLOSE", "CLUSTER", "COALESCE", "COLLATE", "COLLATION", "COLUMN",
  "COLUMNS", "COMMENT", "COMMENTS", "COMMIT", "COMMIT_SUBTXN", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COORDINATOR",
  "COPY", "COST", "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P",
  "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA",
  "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE",
  "DATA_P", "DATABASE", "DAY_P", "DBTIMEZONE", "DEALLOCATE", "DEC",
  "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED",
  "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DESC",
  "DETACH", "DICTIONARY", "DIRECT", "DISABLE_P", "DISCARD", "DISTINCT",
  "DISTKEY", "DISTRIBUTE", "DISTRIBUTED", "DISTSTYLE", "DO", "DOCUMENT_P",
  "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING",
  "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCHANGE",
  "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN",
  "EXTENSION", "EXTENT", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY",
  "FETCH", "FILTER", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE",
  "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "GROUPING", "GTM", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IMPORT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX", "INDEXES",
  "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P", "INOUT",
  "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER",
  "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION",
  "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P",
  "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT",
  "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP", "LOCATION",
  "LOCK_P", "LOCKED", "LOGGED", "MAPPING", "MATCH", "MATERIALIZED",
  "MAXVALUE", "METHOD", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE",
  "NAME_P", "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NO",
  "NOAUDIT", "NODE", "NONE", "NOT", "NOTHING", "NOTIFY", "NOTNULL",
  "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMBER", "NUMERIC", "OBJECT_P",
  "OF", "OFF", "OFFSET", "OID_P", "OIDS", "OLD", "ON", "ONLY",
  "OPENTENBASE_P", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "ORDINALITY", "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY",
  "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARSER", "PARTIAL",
  "PARTITION", "PARTITIONS", "PASSING", "PASSWORD", "PAUSE", "PLACING",
  "PLANS", "POLICY", "POSITION", "PRECEDING", "PRECISION", "PREFERRED",
  "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES",
  "PROCEDURAL", "PROCEDURE", "PROGRAM", "PUBLICATION", "PUSHDOWN", "QUOTE",
  "RANDOMLY", "RANGE", "READ", "REAL", "REASSIGN", "REBUILD", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFERENCING", "REFRESH", "REINDEX",
  "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA",
  "RESET", "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE",
  "RIGHT", "ROLE", "ROLLBACK", "ROLLBACK_SUBTXN", "ROLLUP", "ROW", "ROWS",
  "RULE", "SAMPLE", "SAVEPOINT", "SCHEMA", "SCHEMAS", "SCROLL", "SEARCH",
  "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES",
  "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SESSIONTIMEZONE",
  "SET", "SETS", "SETOF", "SHARDING", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SKIP", "SLOT", "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE",
  "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT",
  "STEP", "STORAGE", "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING",
  "SUCCESSFUL", "SYMMETRIC", "SYNC", "SYSDATE", "SYSID", "SYSTEM_P",
  "SYSTIMESTAMP", "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP",
  "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO",
  "TRAILING", "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM",
  "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED",
  "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN",
  "UNLOCK_P", "UNLOGGED", "UNPAUSE", "UNTIL", "UPDATE", "USER", "USING",
  "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHENEVER", "WHERE", "WHITESPACE_P",
  "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS",
  "XMLFOREST", "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT",
  "XMLSERIALIZE", "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "NOT_LA",
  "NULLS_LA", "WITH_LA", "'<'", "'>'", "'='", "POSTFIXOP", "'+'", "'-'",
  "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'",
  "','", "';'", "':'", "'{'", "'}'", "$accept", "prog", "stmt",
  "CreateRoleStmt", "opt_with", "OptRoleList", "AlterOptRoleList",
  "AlterOptRoleElem", "CreateOptRoleElem", "CreateUserStmt",
  "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_group_cmds",
  "partition_cmd", "alter_group_cmd", "index_partition_cmd",
  "alter_table_cmd", "alter_column_default", "opt_drop_behavior",
  "opt_collate_clause", "alter_using", "replica_identity",
  "Identified_cluster", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "partbound_datum",
  "partbound_datum_list", "range_datum_list", "PartitionRangeDatum",
  "AlterCompositeTypeStmt", "alter_type_cmds", "alter_type_cmd",
  "ClosePortalStmt", "CopyStmt", "copy_from", "opt_program",
  "opt_shard_list", "copy_file_name", "copy_options", "copy_opt_list",
  "copy_opt_item", "opt_binary", "opt_oids", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem", "opt_no_inherit",
  "opt_column_list", "columnList", "columnElem", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem",
  "ExclusionWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "interval_expr", "part_strategy", "part_params", "part_elem", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptDistributeBy",
  "OptDistributeType", "DistributeStyle", "OptDistKey",
  "OptDistributeByInternal", "OptSubCluster", "OptSubClusterInternal",
  "OptConsTableSpace", "ExistingIndex", "CreateStatsStmt",
  "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "AlterForeignTableStmt",
  "ImportForeignSchemaStmt", "import_qualification_type",
  "import_qualification", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreatePolicyStmt",
  "AlterPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultPermissive",
  "RowSecurityDefaultForCmd", "row_security_cmd", "CreateAmStmt",
  "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerReferencing", "TriggerTransitions",
  "TriggerTransition", "TransitionOldOrNew", "TransitionRowOrTable",
  "TransitionRelName", "TriggerForSpec", "TriggerForOptEach",
  "TriggerForType", "TriggerWhen", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertStmt", "DropAssertStmt", "DefineStmt", "definition",
  "def_list", "def_elem", "def_arg", "old_aggr_definition",
  "old_aggr_list", "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "AlterEnumStmt", "opt_if_not_exists", "CreateOpClassStmt",
  "opclass_item_list", "opclass_item", "opt_default", "opt_opfamily",
  "opclass_purpose", "opt_recheck", "CreateOpFamilyStmt",
  "AlterOpFamilyStmt", "opclass_drop_list", "opclass_drop",
  "DropOpClassStmt", "DropOpFamilyStmt", "DropOwnedStmt",
  "ReassignOwnedStmt", "DropStmt", "drop_type_any_name", "drop_type_name",
  "drop_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_type_any_name", "comment_type_name", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type_any_name",
  "security_label_type_name", "security_label", "FetchStmt", "fetch_args",
  "from_in", "opt_from_in", "GrantStmt", "RevokeStmt", "privileges",
  "privilege_list", "privilege", "privilege_target", "grantee_list",
  "grantee", "opt_grant_grant_option", "GrantRoleStmt", "RevokeRoleStmt",
  "opt_grant_admin_option", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique", "opt_concurrently",
  "opt_index_name", "access_method_clause", "index_params", "index_elem",
  "opt_collate", "opt_class", "opt_asc_desc", "opt_nulls_order",
  "CreateFunctionStmt", "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "operator_with_argtypes_list",
  "operator_with_argtypes", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "CreateTransformStmt", "transform_element_list", "DropTransformStmt",
  "ReindexStmt", "reindex_target_type", "reindex_target_multitable",
  "reindex_option_list", "reindex_option_elem", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterOwnerStmt",
  "CreatePublicationStmt", "opt_publication_for_tables",
  "publication_for_tables", "opt_publication_for_shards",
  "publication_for_shards", "AlterPublicationStmt",
  "CreateSubscriptionStmt", "publication_name_list",
  "publication_name_item", "AlterSubscriptionStmt", "DropSubscriptionStmt",
  "RuleStmt", "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "opt_transaction", "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "AlterCollationStmt", "AlterSystemStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "any_with", "CreateConversionStmt",
  "ClusterStmt", "cluster_index_specification", "VacuumStmt",
  "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "analyze_sync_option", "opt_verbose", "opt_full",
  "opt_freeze", "analyze_option_list", "analyze_option_elem",
  "opt_name_list", "AuditStmt", "audit_or_noaudit",
  "opt_when_success_or_not", "success_or_not", "audit_stmt_list",
  "audit_stmts", "audit_stmt", "audit_user_list", "audit_obj_type",
  "audit_obj", "CleanAuditStmt", "SampleStmt", "PauseStmt", "BarrierStmt",
  "opt_barrier_id", "CreateNodeStmt", "pgxcnode_name", "pgxcgroup_name",
  "pgxcnodes", "pgxcnode_list", "AlterNodeStmt", "DropNodeStmt",
  "CreateNodeGroupStmt", "AlterNodeGroupStmt", "DropNodeGroupStmt",
  "MoveDataStmt", "data_node", "shard_list", "CreateShardStmt",
  "DropShardStmt", "CleanShardingStmt", "CreateKeyValuesStmt",
  "qual_table_list", "CheckOverLapStmt", "ExplainStmt", "ExplainableStmt",
  "explain_option_list", "explain_option_elem", "explain_option_name",
  "explain_option_arg", "ExecDirectStmt", "DirectStmt", "CleanConnStmt",
  "CleanConnDbName", "CleanConnUserName", "opt_force", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "LockNodeStmt", "lock_param_list", "lock_param",
  "UpdateStmt", "set_clause_list", "set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_materialized", "opt_with_clause",
  "into_clause", "OptTempTableName", "opt_table", "all_or_distinct",
  "distinct_clause", "opt_all_clause", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "opt_select_fetch_first_value",
  "select_offset_value2", "row_or_rows", "first_or_next", "group_clause",
  "group_by_list", "group_by_item", "empty_grouping_set", "rollup_clause",
  "cube_clause", "grouping_sets_clause", "having_clause",
  "for_locking_clause", "opt_for_locking_clause", "for_locking_items",
  "for_locking_item", "for_locking_strength", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "opt_alias_clause", "func_alias_clause", "join_type",
  "join_outer", "join_qual", "relation_expr", "opt_partition_for",
  "partition_for", "relation_expr_list", "relation_expr_opt_alias",
  "tablesample_clause", "opt_repeatable_clause", "func_table",
  "rowsfrom_item", "rowsfrom_list", "opt_col_def_list", "opt_ordinality",
  "where_clause", "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "xmltable",
  "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "explicit_row", "implicit_row", "sub_type",
  "all_Op", "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "NonReservedWord", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", "statements", "statement",
  "CreateAsStmt", "$@1", "at", "ECPGConnect", "connection_target",
  "opt_database_name", "db_prefix", "server", "opt_server", "server_name",
  "opt_port", "opt_connection_name", "opt_user", "ora_user", "user_name",
  "char_variable", "opt_options", "connect_options", "opt_opt_value",
  "prepared_name", "ECPGCursorStmt", "ECPGExecuteImmediateStmt",
  "ECPGVarDeclaration", "single_vt_declaration", "precision", "opt_scale",
  "ecpg_interval", "ECPGDeclaration", "$@2", "sql_startdeclare",
  "sql_enddeclare", "var_type_declarations", "vt_declarations",
  "variable_declarations", "type_declaration", "$@3", "var_declaration",
  "$@4", "$@5", "opt_bit_field", "storage_declaration", "storage_clause",
  "storage_modifier", "var_type", "enum_type", "enum_definition",
  "struct_union_type_with_symbol", "$@6", "struct_union_type", "$@7",
  "s_struct_union_symbol", "s_struct_union", "simple_type",
  "unsigned_type", "signed_type", "opt_signed", "variable_list",
  "variable", "opt_initializer", "opt_pointer", "ECPGDeclare",
  "ECPGDisconnect", "dis_name", "connection_object", "execstring",
  "ECPGFree", "ECPGOpen", "opt_ecpg_using", "ecpg_using",
  "using_descriptor", "into_descriptor", "into_sqlda", "using_list",
  "UsingValue", "UsingConst", "ECPGDescribe", "opt_output",
  "ECPGAllocateDescr", "ECPGDeallocateDescr", "ECPGGetDescriptorHeader",
  "ECPGGetDescHeaderItems", "ECPGGetDescHeaderItem",
  "ECPGSetDescriptorHeader", "ECPGSetDescHeaderItems",
  "ECPGSetDescHeaderItem", "IntConstVar", "desc_header_item",
  "ECPGGetDescriptor", "ECPGGetDescItems", "ECPGGetDescItem",
  "ECPGSetDescriptor", "ECPGSetDescItems", "ECPGSetDescItem",
  "AllConstVar", "descriptor_item", "ECPGSetAutocommit", "on_off",
  "ECPGSetConnection", "ECPGTypedef", "$@8", "opt_reference", "ECPGVar",
  "$@9", "ECPGWhenever", "action", "ECPGKeywords", "ECPGKeywords_vanames",
  "ECPGKeywords_rest", "ECPGTypeName", "symbol", "ECPGColId", "ColId",
  "type_function_name", "ColLabel", "ECPGColLabel", "ECPGColLabelCommon",
  "ECPGCKeywords", "all_unreserved_keyword", "ECPGunreserved_interval",
  "into_list", "ecpgstart", "c_args", "coutputvariable", "civarind",
  "char_civar", "civar", "indicator", "cvariable", "ecpg_param",
  "ecpg_bconst", "ecpg_fconst", "ecpg_sconst", "ecpg_xconst", "ecpg_ident",
  "quoted_ident_stringvar", "c_stuff_item", "c_stuff", "c_list", "c_term",
  "c_thing", "c_anything", "DeallocateStmt", "Iresult", "execute_rest",
  "ecpg_into", "opt_ecpg_into", "ecpg_fetch_into", "opt_ecpg_fetch_into", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-5890)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3325)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const int yypact[] =
{
   -5890,  1005, 10254, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, 39903, -5890,
   -5890, -5890, -5890, -5890,138790,  1489, -5890, -5890, -5890,143957,
   -5890, -5890, -5890,   614, 92227, -5890, 95593,  1498, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890,101764, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, 77063,  1399, -5890,   975,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890,   977,  8598, -5890,
   -5890, 96154, -5890, -5890,   358, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890,   779, -5890,  1264, 96715,  1209, -5890,
   -5890,  1402,  1371, -5890, -5890,   177, 20801, -5890, -5890, 88300,
   93349, -5890, -5890,102325,   965,  1902, 17646,   977, 39339, 97276,
   -5890,  2849, -5890, 73662, -5890, -5890, -5890, 92788, -5890, -5890,
   -5890,  1806, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890,110179,  2920,  1522, 73092, -5890, -5890, -5890, -5890,
     334, -5890,110179, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890,  1931, -5890, -5890, 97837, -5890,  1722,  1978,   152,110740,
  111301, 89983, -5890,  1531, -5890, -5890,110179,110179,  1869,  1354,
   75939, -5890,111862, -5890, -5890,  1864, -5890,102886, -5890, -5890,
   -5890, -5890, -5890,  1522, -5890, 77063, 71968,  2320,   329,  1793,
   -5890, -5890,112423, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890,110179,  2054,  1964, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,   926,
   -5890, 16969, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
     732, -5890,  1180,  1049,  1775,   374,  1985, -5890, -5890, -5890,
   11952, -5890, -5890, -5890, -5890, -5890, -5890, -5890,140464,  1028,
   -5890, -5890, -5890,  2016, -5890,  2026, -5890, -5890, -5890,  1868,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890,   981, -5890, -5890,
   -5890, -5890,  2608,139348,101764, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, 87739, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,   260, -5890,
   -5890, -5890, -5890, -5890,101764,101764, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890,101764,  2186, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890,   418,  2478, -5890, -5890, 77063,  2843,  2843,
    2761,140464, -5890, -5890, -5890, 79311,  1177,110179,110179,110179,
    2383,110179,  2309,110179,   241, 79311,149394,  2452,103447,  2471,
    2310,104008,  2402, 66825,112984, -5890,110179,146924,110179,110179,
  113545,110179,110179,110179,110179,   173, 98398,110179,  2416,110179,
  110179,147418,114106,  2593, -5890,  2867,  1714,110179,  2787,  2424,
    2810,  2720,  2883,  2888,  2902, -5890, -5890, -5890,110179, 11307,
    2920, -5890, -5890,  2054,110179,  2707, 79311,110179,  2920,  2483,
  114667,  2480,110179,  2683,110179,  2533,115228,   340,  2226,149394,
    2710,  2529,  2395,104569,  2569, 67399,  2647,110179,110179,149394,
  115789,116350,  2815,116911,110179,110179, -5890, -5890,  2638,110179,
  110179, -5890,  2760,149888,  1907,  2783,  2944,  2846,  1409, -5890,
   -5890,  3040,  2549, -5890, -5890,  3075,101764, -5890, 98959, -5890,
   -5890, -5890,  2706, -5890, -5890, -5890, -5890, -5890, -5890,145936,
    1902, -5890, -5890,  2813, 79873,110179,  2894, -5890, -5890,117472,
   83807,  2666, -5890,   412, 80435,150382,  2832,  3029,  2641,105130,
    2718, 67973,  3062, -5890, -5890,150876, -5890, -5890, -5890, -5890,
    2934, -5890,118033, -5890,118594,  2800,  2894, -5890, 84369,151370,
   -5890,  2923,119155,119716,120277, -5890, 16466, -5890,  2652,  3022,
    2890,  2668,  2680,  2215,101764,101764,   951,141452, -5890, -5890,
    1209, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,   215,
    2228, 74232,   974, 74802, -5890, -5890,   985,  1090,  1285,   215,
    3185,  3185,   159,101764, -5890, -5890,  2228, -5890,   135,   652,
    2693,  2693,  2693,  2893,  1382, -5890,  2693,  2838, -5890, -5890,
   -5890, -5890,102886, 74232,  3025, 74802,110179, -5890,  2749,  2753,
    2714, -5890,  3070,  2920,   185,  3170,  2771, -5890, -5890, -5890,
   -5890, -5890,  2779,110179,110179,110179, -5890, -5890, -5890,  3196,
    2766,  3026, -5890,  2752, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890,  2977,  2985,  2995,   253,  2920,  2852,  2781,
    2285, -5890,  3134, -5890,  3009, 46241, 46241,  1630,101764,  2920,
   75372,105691,135424,   316,145936,  2920,120838,  2822,  1009,  3031,
   -5890, -5890, -5890,   894, -5890,  3273,  2839,  3108,   394,  1714,
   63416, -5890,   967,102886, 29599, -5890, -5890, -5890, -5890, -5890,
     626,  3146, 50294,110179,  2824, -5890,  2837,  2824,  2840,  2847,
    1775, -5890,   304,121399,  3039, -5890,  6565, -5890,  2940,  3794,
   -5890,  2947,  2936,  6049,  2948, -5890, -5890,   850, -5890, -5890,
    2953,  2996,  2951, -5890, -5890, -5890, -5890, -5890,  1986, -5890,
    3063,  1511, -5890, -5890, -5890,  3027, -5890,  3030, -5890, -5890,
     238,  2875, -5890,  1690,  1690,  3351,  1690,  1823,  1971, -5890,
    2122, -5890,  3272,  3211,102886,  2954,   977,  2957, -5890, -5890,
   -5890,  2962, -5890,  2956,  2965, -5890,   966,  3266, -5890, -5890,
   -5890, -5890,  3068,  3069,  3083,  3094,  2980,  3095,   289, -5890,
   -5890, -5890, -5890,  3338, -5890, -5890, -5890, -5890, -5890, -5890,
    3502,  3475,144454,144454,   764,   881,   227,   254, -5890, -5890,
   -5890,  3321, -5890, -5890,  3318,110179,  3127,110179, -5890, -5890,
   -5890,121960, -5890, -5890,  2843,  2962,  2140,  3038, -5890,   290,
   -5890,  2285, -5890,   326,   337,   361,  3296,110179,  2166,  3056,
    2141,  1832, -5890,   824,110179,   225,  3087,106252,  5661,  3064,
    3079,  2285,  3224,  1316,110179,  3373,  3418, 16214,   289,106813,
  110179,  3400, -5890,110179, -5890, -5890, -5890, -5890,110179,110179,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,  3104,
     210, -5890, -5890,  3076,  3461,  3335,   909,  3423,  3286,  1834,
    3348,  2125,  3479, 19069,  1529,  3300,  2151,  1466,122521,135985,
    3452,  3497, 17508,  1914,   910,  3379,   827,  3423,  3501,  3342,
    1834,  3531, 10042,110179,  3199, -5890,  3480,  3576,   865, -5890,
     226, -5890,  1627, -5890, -5890,  1315,  3431,110179, -5890, -5890,
    3661,  3280,  3436,   852,  3482, 79311,  3231, -5890, -5890,110179,
   -5890, -5890, 84931,  3309, -5890,   466, 79311, -5890,  3460,  3279,
   68547,110179, -5890, -5890,110179, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890,  3375,  3575,110179, 84931, -5890,  3520,110179,
  110179,  3577,  3243, -5890, -5890, -5890, -5890,  2693,110179,  3245,
    3683, -5890, -5890, 84931,  3485,   195,110179,  1394,  3569,  3725,
  110179,  3500,  3584,  1394,  3298,123082, -5890, -5890,  1394,110179,
    3769, -5890, -5890,110179,  2391,110179,110179,110179,  3269,  1861,
    3490,  3607,  1394,  3511,  3741,  3743,  3518,  3358,   255,  3524,
    2837,  3706,  3493,  1058,  1387,   172,  2469,  1394,  3340,123643,
  124204,110179,  3344,110179,  3711, 79311,110179,  3636, -5890,  3489,
  107374, -5890,  3304,  3040, -5890, -5890, -5890, -5890, -5890,  1761,
   -5890, -5890, -5890, -5890, -5890,  3657, -5890,   205,   291,  3658,
    3313,  3662,124765, -5890, -5890, -5890, -5890,  3362, -5890,  3362,
    3362,  3320,  3320,  3507,  3322,  3665, -5890, -5890, -5890,  2770,
    3362,  3320,  3320, -5890, 86055, -5890,  2185,  2234, -5890,   218,
   -5890,  3797, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
    3323, -5890,  1004, -5890,  2376, -5890, -5890, -5890, -5890,  3359,
   -5890,  3672,   224, -5890,  3675, -5890,  3328,110179,125326, -5890,
  110179,  3400,125887,126448,127009,  3680,   249, -5890,149394,  3681,
    3328,  3656,  3684,   291,  3685, -5890,  1079,  3673,  3691,   218,
    3699,  2509,  3328,146430,  3700,   258, -5890,  3705,   273,  3707,
    3581, 18364, 16466, -5890, 19776,  2304, -5890, -5890, -5890,127570,
    3363, -5890, -5890, -5890, 50294,   896,  3455, -5890, -5890, -5890,
    2414, -5890,142953, -5890,   951,  2228, -5890,101764,  2228,101764,
     159,  2228,101764,  2228,101764,   159,  2228,101764,101764,101764,
    2228, -5890, -5890,   285,   301, -5890, -5890, -5890, -5890, -5890,
  101764,  3364,110179,110179, -5890, -5890, -5890, 93910,149394, 94471,
   -5890,110179, -5890,   142,101764, -5890,110179,101764, -5890,  3760,
   -5890,  3366,  3367,  2920, -5890,128131, -5890,  2668, 84931,  3841,
  149394,  3711, -5890,  2444, -5890, -5890, -5890, -5890, -5890, -5890,
    3640,110179,  3709,  3720, 93910,149394,  3722,128692,  3185, 50294,
   70844, -5890,  2285,145936,  3611,  3390, -5890, -5890, -5890, -5890,
    2406,  3028,  3112,  3174,   236,  3254, 50294,  3393,   236,   236,
    3402,  3740, -5890, -5890, -5890,   384,  3409,  3412, -5890, -5890,
     395,   395, -5890,  3413,  3415, -5890,   407,  3416,  3417,  3293,
     417,  3421,  3424,  3425,  2770,   236, 50294, -5890,  3426,   395,
     395,  3427,  3428,  3429,  3383,  3432, -5890, -5890,  3407,  3434,
   -5890, -5890,   213,   597,  3435,  3438, -5890,  3413, -5890,   425,
    3442,  3443,  3447,  3450,  3451,  3453,  3454,  3457, 50294, 50294,
   50294, -5890, 44504,  2285,  2920, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890,   449,  5251, -5890,  3459, -5890, -5890,  3615,
   -5890, -5890, 50294, -5890, -5890,   298, -5890,   458, -5890, -5890,
    2285, -5890, -5890,  1072, -5890, -5890, -5890, -5890,  3738,  3462,
    2379,  2379,   269, -5890, 96154, 96154, -5890, -5890,  1275,  3472,
   -5890,  2507, -5890, -5890, -5890, -5890, -5890, -5890,145442,  3927,
   -5890,  1303,  2920,   226,  1750,  3867,141949,142451,  3750,  3750,
    3746, -5890, -5890,110179,  3677,  3807, -5890, -5890, -5890,   207,
    3763, -5890, -5890, -5890,  2448, -5890, -5890, -5890, -5890,  1209,
   15472,  2467,  2824,110179,110179,  3952, -5890, -5890, -5890, -5890,
    2472, -5890,   320, -5890,  2837, -5890, -5890, -5890, -5890, -5890,
    3527, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890,  3532,  3805, -5890,
   -5890, -5890,  3808, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890,  3534,  3810, -5890, -5890, -5890,
    3799, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890,110179, 99520,  3733, -5890, 17175, -5890, -5890,  1775,
    1775, 50294,  1775,  1221,  1573, 46820, 50294,  3831,  3723,  1918,
    1825,  3835, -5890,  3729,  1823,  1971,102886,110179,129253,  3631,
   50294, -5890,  2962,  3512,  2365, -5890, 87178,139906,139906,  3798,
   -5890, -5890,  1678,  1199,  3643,  3761,  3185,  1625,  2762,  2762,
   -5890, -5890,  3516, -5890,  3898, 96154,  3572,144454, -5890, -5890,
  110179, -5890, -5890,107935, -5890, -5890, -5890,  2206,  3522, -5890,
    3526,110179, -5890,  4092,  2762,  2762, -5890, -5890,  3523, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890,140464,  3528,110179,
   -5890,  3529,  3533, -5890, 29599,  3609,  3613,  3678, 71406, -5890,
    2285,110179,  3400,  3614,  3586,  3624,  3686, 77063,  3547,  3632,
    3633,  3693,  3821, -5890, -5890,  3638,  3639,136546, -5890, -5890,
    1530, -5890, -5890, -5890,  1530, -5890,  3570, -5890,  1510,  1181,
    1298,  3647,   280,  1195,  3978, -5890,  1587, -5890, -5890,  3713,
   -5890,  5221,110179,  3915, 12704,  3800,   289,  3802,  3710, -5890,
   -5890,  1659,  3659,110179, -5890,  3667,  3815,   289,   828,137107,
   -5890, -5890, -5890, -5890, -5890, -5890,  3160, 43372, -5890,  2343,
    3668,  3645,  2391,  3679,110179, 88861,   451,  3788,  3812,  3832,
    3816,  1534,  4046,   306,  1984,  2455,   748,  3900,  3747,110179,
    2155,  3826,110179,  3603,  3687,  3948,  3688,  3923,  3612,  2066,
    1593,  4032,  3616, -5890, -5890, -5890, -5890, -5890,  3820,  3922,
    3965,  5318,  3752,110179,  2391,   914,  3689,  3690, 82121, -5890,
    3702,  1086, 69121,110179,110179,  3721,  3724,  3712,  3716,    65,
    4021,  2039,  3717, -5890, -5890, -5890,  2039,110179,  3727,  3730,
  110179, 86055,   289, -5890,  4078,   289,   289,  2091,  4088,  3731,
     645,  3888,  2657,  1394,  3616,  3317, -5890,  3734,  3736,  2100,
   -5890,  3857,  3744,  3749,  3753,  3784,  2920, -5890, -5890,  3755,
    3840,  3756,    81, -5890, -5890,  1483,  3737,102886,  3856,  3865,
     323,  3261,  3616, -5890,  3759,  3765,  3612,  3612,110179,110179,
  110179,110179,110179,   220,  4143,  4144,  3766,   214,  3822,  3694,
   -5890,  2039,147912,  3768, -5890,  2039,110179,  3771,  3498,  3616,
    2134, -5890,  2338, -5890, -5890, -5890,  1714, -5890,110179,110179,
    4020,  3363,  3363, 99520,  4022,110179,110179, -5890,110179, -5890,
    3982, 84931,  3914,  3984, -5890,  3735, -5890,  3987,   289, -5890,
  110179,110179,  3989,  3926,  3928,  1082, 84931,  3929,  3991, -5890,
    3994,  3996,  4150,  3801,  3751,  3787, 71406, -5890,  3269,  3726,
    4188,  4068,110179, 77063, -5890,  4208,  1530,110179, -5890, 84931,
    3947,  4075,   265, -5890,110179,  3966,   592, -5890,  2391, -5890,
     138,  3772,   954,  3953, -5890,  4152,  4119,  3803, -5890, -5890,
    1329,110179,   287,  4192, -5890, -5890,  4091,149394,  1697,  4099,
    2920,  3791,  4073,  4059,  4102,  3977,  2920,149394,  4027,110179,
  110179,110179,110179, -5890, -5890,  3985,   366,   146, -5890,147912,
    3995, -5890,110179,  3997,  3317,  4009,  4245,   922,  2693,129814,
    4108, -5890,130375,  3777,  4252, 84931,  4060, -5890, -5890,  3779,
    3185, -5890,  3304, -5890,  2514, -5890,  3925, -5890, 79311, -5890,
   -5890, 79311, -5890, -5890, -5890, 84931,110179,  4141, -5890, -5890,
    3795, -5890, -5890, 50294, -5890, -5890, -5890,  3185, -5890, 84931,
    3362,  3362, -5890, -5890, -5890,  4271,  3885,  3887,  3185, -5890,
    3185, -5890, 84931, -5890,  3806,  3809,  3185,  3890, -5890,  3893,
    3185, -5890,  2482, -5890, -5890, 79311, 79311, -5890,149394,149394,
   -5890,  4153,   258, -5890,  2391,  4161,   291,  4165,  3876,  4167,
    3878, 69121, 69121, -5890,   282,149394,110179,110179, -5890,110179,
   -5890, -5890, -5890, -5890, 84931, 84931, -5890,149394,147912,  4172,
    4174,   291,110179,110179, -5890,110179, -5890,110179,110179, -5890,
   19032,  2314, -5890, 16466, -5890,  4065,  1394,110179,  2920,  2508,
    3750, -5890,  2186,110179,  1904,   951,151864, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890,101764, -5890,101764,   159, -5890,
   -5890,101764, -5890,101764,   159, -5890,101764, -5890, -5890, -5890,
  101764,110179,  4398,  3830, -5890,  1072, -5890,110179,  2527, -5890,
   -5890,  2539,  1015,110179,110179,   658, 79311,110179,  4062,110179,
  110179,110179,110179,110179,  3918,  3472,  1937, -5890,  1875,   737,
  102886,  4072, -5890,  4235, -5890,  4171,  2811,  2811, -5890,  4080,
    1394, -5890, -5890,  2544,  2054,  1651,110179,  1215,  2779, -5890,
   -5890, 94471, 92788,  4173,   327,  4282,110179, -5890,  3845, 13198,
    3843, -5890, -5890, -5890, -5890, -5890,  6867, 50294, 45662, -5890,
   -5890, 15472,  3892, 50294, 50294,  3852,  3185,  3185, -5890,  3078,
   50294, 50294, 50294,  3185,  3185,  2715, 50294, 69121, 50294, 53768,
   41632, 50294, 50294, 45083, -5890, 50294,  4103, 54926, 50294,  1750,
    4104, 50294,  1750,  2715,  4350,  4350,  1793,  1915,  6361,  3854,
    2285, -5890,  3185,  1068,   346, 84931, 50294, 50294, 50294, 50294,
   77063,  3942,   263,110179, 50294,  3859,  1916, -5890, 50294, -5890,
    3872, 50294,  3955,  1310, 50294, 50294, 50294, 50294, 50294, 50294,
   50294, 50294, 50294, -5890, 56621,   402, -5890,  4185,  4212,  1144,
     523, 95032, 46241,  4205, -5890, 40472, -5890,   277,101764, -5890,
   -5890,  2285,  4205, -5890, -5890, -5890, -5890, -5890,  2206,  3877,
   -5890,  3889, -5890, -5890, -5890, -5890, -5890,110179,  3927, -5890,
   -5890,  3959, -5890, -5890, -5890, -5890,   471, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890,  3882, -5890, -5890, -5890, -5890,
    3882, -5890, -5890,  3750,  3886, -5890,   137,  4198,  4203,   291,
  140464,121399,   626,100081, -5890, 50294, -5890,  2547,  2403,121399,
     304, -5890,110179,110179,  3992, -5890, -5890, -5890, -5890, -5890,
   -5890,  4215,  1846, -5890, -5890,  1920,  3943,  2113, -5890,  2117,
    2132,108496,  3938,  3897, -5890,  4000, -5890,  4190, -5890,  3901,
   -5890, 13229,  4190, -5890, -5890,   233,  4026,  4193,  4124, -5890,
   -5890, -5890,  3905, 15472, -5890,  2506, 15472,  2573, -5890, -5890,
   -5890, -5890, -5890, -5890,  1795, -5890,110179,  1428,  3831,  1825,
    3967,  1296,  4388,110179, -5890, 63981,  2561,  2456, -5890,  2962,
   -5890, -5890, 37573, -5890, 38187, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890,  3919, -5890, -5890, -5890, -5890, -5890,
     289,  3920,  4468, -5890,144454, -5890, -5890, -5890,  4398, -5890,
    3075, -5890,  3075,  4496, -5890,101764, -5890, -5890, -5890, -5890,
     545, -5890, 16466, -5890, 16466, -5890,149394,110179,110179,  4135,
   -5890,  4374, -5890, 86055, -5890,  3930, -5890, 85493, 80997, -5890,
   -5890,   604, -5890,  1415,  2391,  2391,149394, -5890,110179,110179,
   -5890, 77063,149394,110179,110179, -5890,149394,110179,110179, -5890,
   -5890, -5890, -5890, -5890,143455,  1258, 92788,  4071, 90544, -5890,
   -5890,  3933,110179,  3993,  4214,  4217,   585, -5890, -5890,130936,
   -5890,  4175,149394,110179,110179, 50294,  4178,110179,110179, -5890,
     416,  4017,  4023, -5890,110179,  4029,  4194, 79311,  3939,110179,
  110179, 84931,  4025,   632, 79311,  3999, 69695,110179,110179,110179,
  110179,  4087,  4284, 84931,110179,  4229,  1351,102886,   322,  3521,
    3616,  4184, -5890,  4300,  1640, -5890, -5890,149394, -5890,110179,
    4176, -5890, -5890, -5890, 91105,  4420,  4074, -5890, -5890,137668,
   -5890, -5890, -5890,  2579, -5890,149394,149394, -5890,110179, 17579,
  131497,  1338,  4197,  3363,  3185, -5890, -5890, 84931, -5890,110179,
  110179,110179,110179,  3363,  4307,  4233,110179,100642,  2706,  3964,
   -5890, -5890, -5890,  4336, -5890,132058,132619,  1700,  1711,  4236,
  110179,101203,110179,  4238, -5890,  4115,110179, -5890, -5890, 77625,
  149394, -5890,110179,   897, 77063, -5890, -5890,  4429,110179, -5890,
    4195,  1185, -5890,110179,  3363,110179, 14668,  4054,  4064,110179,
    4200,   335,  3530,  3616,  4063,  3974, -5890, -5890, -5890,  2920,
   -5890, -5890,  4162,   992,110179,110179,  3981,  2583,149394,110179,
   77063, -5890,  4207,  1517,102886,102886,149394,110179,102886, -5890,
  110179,135424, -5890,149394,  1206, -5890,  4146,149394,110179, 19534,
   -5890, -5890, -5890,   289, -5890, -5890, -5890, -5890, -5890,110179,
  110179,   289,110179,110179,   289,  1411, -5890,149394,110179, -5890,
   -5890, -5890,110179,149394,110179,110179, -5890,149394,  4028,110179,
   77063, -5890,110179, 17531,110179,110179,110179,110179,110179,110179,
  149394,110179, -5890, -5890,  1046,  1662,  1324,  2032,   978,110179,
    4299,110179,133180,149394,110179,110179,  2920,110179,  1998, -5890,
   -5890,  4120, -5890,149394,  1206, -5890, 19049,110179,110179,  4076,
    4081,   248,  4166, -5890, -5890, -5890,  3990, -5890, -5890,  4330,
    4330,  4330,108496, -5890,110179,  3998, -5890, -5890, -5890,  2225,
    4472,133741,  2225, -5890,  2225,  4286,  4061,  4067,  2225,110179,
  110179, -5890, -5890, -5890, -5890,  4281,110179,  2225,  2225,  2225,
    4224,  4186,  4230,  4133,  4313,  2596, -5890,  4024, -5890, 50294,
   84931,110179, -5890,  2606, -5890,  4030,   366, -5890,  4051, -5890,
   77063,110179,  4335,  4321,   350,   958,  4364,  4244, 89422,  3469,
   -5890,  4113,  4523,  3363, -5890, -5890, -5890,  2920, -5890,  4356,
  110179,  4069,110179,  4495,  4117,102886,  4151,  4028, -5890,  3469,
  110179, -5890,  1826, 92788, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890,110179, -5890, -5890,  4361,110179,  3185,110179, 50294,  4209,
   -5890,  2920,  3269,  3269,  3269,  3269, -5890, -5890, -5890, -5890,
    4257,  1926, -5890,  4033,  3269,110179,  4163,  4384,  3469,  4038,
    4386, -5890,  3317,  4387,  4390,110179,  4267, 89422,  2391,  4082,
    4280,  4516,  2693,  2920,  4283,  4268, -5890, 43938,  7215,  4269,
    4325,145936,107374, -5890,  4070,  4369,  4370,  4399, -5890,   205,
   -5890,  4538, -5890,110179, 50294,  2618,  4077,   218, -5890, -5890,
    4079,  3809,  4084,  4085,  4089,  4090, -5890,  3185, 61156,  4093,
    1514,  4319,  4094, -5890,   224, -5890,  3328, -5890,110179, -5890,
   -5890,110179, -5890,110179,110179,110179,110179,   249, -5890, -5890,
    3328, -5890,   291, -5890,  4348,   218,  3328,  4202,  4407,145936,
   -5890,   258, -5890,   273,  4294,   291, -5890, -5890, -5890,  4422,
   -5890, -5890,  2637, -5890, -5890, -5890, -5890, -5890, -5890,  2693,
    2514, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890,101764,  3075, -5890,  2645, -5890,110179, -5890,  4381,
    4391,  4397,  3990,  4095,  4114,110179,  4098,  3990,   289,  3990,
    3472,  3472,  3990,  4095,148406,  4567,  4415, -5890,  4179,  4106,
    4431,   223, -5890,   229,   114,  4355, -5890, -5890, -5890,  4436,
  134302,  2648, -5890, -5890, -5890,  2651,  4456, -5890, -5890, 84931,
   -5890,149394,  4147,110179,110179, -5890,   261,  4331,  4109,148406,
    4562,   291,  4333, -5890, -5890, -5890, 50294, 79311, -5890, -5890,
   84931,  4196,  4210, 79311,  4343,  4168, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, 84931, -5890,  4396,110179,110179,  2658,
   -5890,  2354, -5890,  2380, 50294,   431, -5890, 14028,  2673, 50294,
    4121,  4123, -5890, -5890, -5890, -5890, -5890, -5890,  4125,  4450,
   -5890, -5890,  2695,  2717,  2721,  4127,  4129,  5575,  4130, 14283,
    4134,  4137, 53768, 53768, 44504,  2258, -5890, 53768,  4138,  4346,
    2728, 13637,  4139,  4140, 14368, 47399, 50294, 47399, 47399, 15329,
    4139,  4142,  2738, 77063,  4342, 15415,  2754, -5890, 50294, 77063,
    6119, 50294, -5890, 50294,  4145, -5890, -5890,  3048,  3048,  3048,
    2715, -5890,  4164, -5890, 53768, 53768, -5890,  2541, 44504, -5890,
   -5890,  4474, -5890, -5890,  1764, -5890,  4148, -5890, -5890,  2639,
   69121,  7454, 50294,   268, 50294,  3859, 50294,  4231,  3048,  3048,
    3048,   718,   718,   232,   232,   232,  2288,   523, -5890, -5890,
   -5890,  4155,  4156,  4158,  4360,  4159, 50294, -5890,  2597,  2655,
  110179,  7905,  9196, 10737, -5890, -5890, -5890, 57765,  4201, 50294,
   50294, 50294,  4169, -5890,  3006, 15472,   687, -5890,  3017, -5890,
   -5890, -5890,  4201,  2664,  4496,  2206, -5890,  1714,  3185,  1068,
  142953, -5890,  3677, -5890, 50294, -5890, -5890, -5890, -5890, -5890,
    2837, -5890, -5890, -5890,  2065, 15472, -5890, -5890,  4408,  4180,
   -5890,  2837, -5890, -5890,  4170,   320, -5890, -5890,110179, -5890,
   -5890,  3938, -5890,110179, -5890, 50294, -5890, -5890,  1664,  4177,
   50294,  2506, -5890, -5890,  4226, -5890, 50294, -5890, -5890, -5890,
    3472, -5890,  4428, -5890, -5890, -5890, 57765,  4216,  4220,  1667,
   62851,  4394, -5890,110179, -5890,110179,   264, -5890,  4189, -5890,
   -5890, -5890, -5890,  2290, -5890, -5890, -5890, -5890, -5890, -5890,
    4183, -5890,  4187, -5890,  4199, -5890, -5890, -5890, -5890,   245,
    4191,  4204,  4211,    31, -5890, -5890, -5890, -5890, 80997,  2376,
   -5890, 85493, -5890, 85493, -5890,  2376,  4624, -5890, 80997,  2337,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890,149394,149394,  4401,110179,  4409,
    4414, 50294,  1109,110179,  4206,  4218,  1639,  4498,110179, -5890,
    4544,   291, -5890, -5890,  4285, -5890, 15472, -5890, -5890, -5890,
   -5890, -5890,149394,110179, -5890,145936, -5890,110179, -5890, 84931,
   -5890, -5890, -5890,110179,  4232,110179, -5890,110179,110179,110179,
   -5890, -5890, -5890, -5890, -5890,  1265, 84931, -5890, -5890,110179,
  110179,   452,  4287,  4292,110179, -5890,  1098,  3857, 19806,110179,
  110179,110179,  4492,110179, -5890, -5890, -5890, -5890,  4432, -5890,
   -5890, 80997, -5890,  3328,  1439,  4293,  3616,  4439, -5890,  4551,
   -5890, -5890,  4430, -5890,  1602, -5890, -5890, -5890,110179,  4352,
   -5890, -5890, -5890, -5890,  4219, -5890,110179,  4221, -5890,  4561,
     291,  4564,   291,110179,110179,110179,110179,  4359, -5890, -5890,
   -5890, -5890,  4261,  4362,  4490, -5890, 77063, 77063, 77063,  2757,
   -5890, -5890,  2920, -5890, -5890, -5890, -5890, -5890, -5890,  4529,
   -5890,  2765, -5890,  1888,  4228, -5890, -5890, -5890, -5890,110179,
   -5890, -5890, -5890,149394,110179, 19977,  4575,110179,110179,110179,
    4618,  3752, -5890,  4028, 77063, -5890,  2204, -5890,   964, 84931,
   -5890, 82683, -5890, -5890,  2773, -5890,  4243,110179,  4315,149394,
    4291,  4234,  4234, -5890, -5890,  4234, -5890, -5890,  4503,  4433,
   -5890,  2565,  4437,149394,  4301, -5890, -5890,  4326, -5890, -5890,
    4328,  3571,  3616,  3317, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,  3269, -5890,
   -5890,  2058, -5890, -5890,  1731,   348,  3610,  3616, -5890,  2063,
   -5890,  4329, -5890,  4332, -5890, -5890, -5890,  4497,  4501,  4506,
    4334,  4337,  4392,  4338,  4341,  4395, -5890,  4344,  4402,  4347,
    4410,  4473,  4349,   291, 84931,  4507,  2920,  4393,  4607,   291,
   -5890,  4353, -5890,  4354, -5890,  4740, -5890,110179, -5890,  4363,
    3813,  3616, -5890, -5890,149394,110179, -5890, -5890, -5890,134863,
    4365,  4365,  4365, -5890,  4366, -5890, -5890, -5890, 84931,110179,
    4563, -5890, -5890,  2225,110179,110179, -5890,  4566,  4569,110179,
    4570, -5890, -5890, -5890, -5890, -5890,  1249, -5890,  4277,   198,
    4595, -5890,  2706, 65676,  6795,  4279,   212, -5890, 77063, 65676,
    2282,  3363,  1878,   186,  1394,110179,  3185, -5890,145936,110179,
  145936, -5890,   958,  4430,110179,110179,110179,  4290,  4296, -5890,
   -5890, -5890, -5890,149394,  1140,149394,  3185, -5890, -5890,110179,
   -5890, -5890,  4467,  4367, -5890,110179,  2693,  2706,  4628, -5890,
    4234,  4297, -5890,  4759,  3743,  1697,  4459,  1910,  3358,  4696,
   -5890, -5890,  2837,   305, 77063,  4082, -5890, -5890, -5890, -5890,
  110179,110179,   366,  2920, -5890,  4302,  4303, -5890,110179,  4636,
  110179,110179,110179,110179,  2054,  4304,110179,  4310, 84931,  4525,
    3612,  4780,  4659,  2054,  4082,  4406,  4661,102886, -5890,  2777,
     174, -5890,  2920,145936, 81559,  4649, -5890,  7088, -5890, -5890,
     492,110179,  4633, -5890,110179, -5890, -5890, 62286, -5890, 84931,
   -5890,  2789, -5890, -5890, -5890,  3185, -5890, -5890,  1815,  1815,
    4318, -5890, 61721, -5890,  4320, -5890,  2372, -5890, -5890, -5890,
     258,   291,  4382,   291,  4383,   291, -5890, -5890,110179, -5890,
  110179,147912,   291, -5890, -5890,110179, -5890,110179,   350, -5890,
  110179,  4664, -5890, -5890, -5890, -5890,  4480,  4482,  4483,110179,
    3990, -5890,  4324,149394,  2067, -5890, -5890,  4549, -5890, -5890,
  102886,  4476, -5890, -5890, -5890, -5890,  4692,  4695, -5890,134302,
    4351, -5890,  4434, -5890,  2811, -5890,110179,   350, -5890, -5890,
    1464, -5890, -5890, -5890,149394, 93910,   286,149394, -5890, -5890,
   15472,  4358,  4631,  4632, -5890, -5890,  4637,   289, -5890,  4638,
   -5890,  4643,  4644, -5890, -5890, -5890,  4368, 15726, 50294, -5890,
    4706, 84931, -5890,  6887, -5890, -5890, -5890, 50294, -5890, -5890,
   -5890, -5890, -5890, 50294, -5890, 50294,  4690, -5890, 42212,  4859,
    4859,  4371, 84931, 53768, 53768, 53768, 53768,  1969,  3427, 53768,
   53768, 53768, 53768, 53768, 53768, 53768, 53768, 53768, 54347,   318,
   -5890,  4572, 50294, 50294,  4699,  4690, -5890, 84931,  4376,  4139,
    4377,  4378, 50294, -5890, -5890,  2792, 55491,  4385, 77063, -5890,
   50294, 13694,  2796,  4413, 15828,  2285,  7146,  2920, 50294,  2393,
    3226, 50294,  2803, 50294,  4697, -5890, -5890, -5890,  4372, -5890,
   -5890, 84931, 50294,  4400,  3149, 53768, 53768,  3403, -5890,  4389,
   50294, 44504, -5890,  4582,  4411, 64546, -5890, 42792,  4417,  1522,
    1522,  1522,  1522, -5890,110179,110179,110179, 58330,  4704,  4403,
   57200,109057,  4418,  1604, -5890,109057,109618,109057, -5890,  4405,
   -5890,  4416,  2285, 50294,  4708,   799,   799,  4582, -5890, 50294,
   50294, 47978,  4412, -5890,  4708, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
    4419, -5890,  4421, -5890, -5890,   226,  4425, -5890, -5890, -5890,
    7534,   245,  3992,  4427, -5890, -5890,  2054,  3992, -5890, -5890,
    4435, -5890,  4438, -5890,  4177,  2072, -5890,  7882,  4589, -5890,
   -5890, -5890,  4418, 48557,  4546, -5890, -5890, -5890,  4446,  2820,
   -5890, -5890,  4815,  4546, -5890, -5890,  2829, 63981,  4216, 50294,
    2285,  3185,  4441, -5890,  3075,  2664, -5890, -5890, -5890, -5890,
   -5890,  2833,  2407, -5890, -5890, 80997, -5890,  4470,  3328,  3328,
    1951,  3990,  4733,  1951,  8195, -5890, -5890, 58895,110179,110179,
   -5890,110179,  2850,  2068,110179, -5890,110179, -5890, -5890, -5890,
   -5890,  4872, -5890,110179, -5890, -5890,  4466,  4475,110179,110179,
  110179,110179,  4680, -5890, -5890,  3056, -5890, -5890,149394,110179,
   -5890, -5890, -5890,   342,  3837,  3616, -5890,  4493, -5890, -5890,
   -5890,  4725, -5890,  4882,  4526,110179,  4782,110179,  4443, -5890,
    2068,  4769,  1295,  3612,  2252,  4810, -5890,  1074, -5890, -5890,
    4517, -5890, -5890,110179,  2864,110179,110179, -5890,110179, -5890,
   -5890, -5890, -5890, -5890, -5890,110179, -5890,  4585, -5890, -5890,
   -5890, -5890, 77625, -5890, -5890,110179, -5890, 77063, 65676, 77063,
   78749, -5890, -5890,  1776,   364,  3979,  3616,110179, -5890,  4528,
   -5890, -5890, -5890, -5890,  2058,  4532,  4534,  4598,  1107,  1480,
    4540,  4541,  4602,  4469,  4477,  4478, -5890, 77063, 66251,  4629,
  110179,  3328,  4481,  4511,   215,  2920, -5890, -5890,  2920,  3328,
    2920,110179,110179,110179, -5890, 77063, -5890,  4925,  4574,110179,
  110179,110179,110179, -5890,  4531, -5890,110179,110179,  4811,  1160,
    2518,149394,110179,110179,149394,110179,110179,110179,110179,110179,
  110179,  4827,110179, -5890,  4916,  4834,  2686,  4883,  4568,110179,
   -5890,110179,  2920,  3857,110179,110179, -5890, -5890,110179, -5890,
  148900, -5890, -5890, -5890,110179,  4494,  4781,  2225, -5890,  4784,
    4785,  2225,  2225,  4787,  2225, -5890, -5890,  1394, -5890,  3185,
   -5890, -5890,  4186,110179, -5890,  4024, -5890,  4438,  2762,  2762,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890,  2946,110179, -5890,
   -5890, -5890,110179, -5890,  4504,110179,110179, 53768, -5890,  1633,
    1827,   331, -5890,  4786,110179,  4028, -5890, -5890, -5890,  4698,
  110179, -5890, -5890, -5890, -5890, -5890, -5890, -5890,  1075,  4304,
   -5890,  4818, 89422,  3328,149394,149394,  3328, -5890,    95, -5890,
   77063, 84931,  4520,  4082, -5890,   294,  4603,  3185,149394,  1697,
    2020,124204,  3791,  4555,  4743, 57765,  2058, -5890,  4521,  4691,
   -5890,  4530,  4524, -5890, -5890,110179,  4430,147912,  2913,  3317,
    1010,  2680,  4147, 91666,  4732,  4304,  4818,  4957,  4625, -5890,
    2054,110179,  4147,  4625,  2920,110179,  3993, -5890, 80997, 50294,
   50294, -5890,  4533, -5890,  4539, 10584, -5890,  4610,  4537, -5890,
   -5890, -5890, -5890, -5890, -5890,  4627,  4543,110179,  5046, -5890,
   -5890,  4550, -5890,  4553, -5890, -5890, -5890,  2357,140464, 61721,
   61721, 61721, 61721, 61721, -5890, -5890, -5890,110179, -5890,110179,
   -5890,   291, -5890,  4684, -5890,   291,  1394, -5890,  2054,110179,
  110179,110179,  3990,   289, -5890,  4877,148406, -5890, -5890,  2916,
  110179, -5890, -5890,  4639,  3185,134302, -5890,  1394, -5890,  4951,
     327,  4888, -5890, -5890, -5890,  2698,  2698,  2698,  4845,  2698,
    2698,  2698, -5890, 50294, 15472, -5890,  4565, -5890, 15472,  8572,
   15472,  4699, -5890,  2917, 50294, -5890,  2498,  2498,  2498,  3796,
    4891, -5890,  1732,  4571,  2498,  2498,  2498,   511,   511,   209,
     209,   209,  4859,   318, 15472, 15472, -5890, -5890,  4573, -5890,
   -5890, -5890,  4139, -5890, 50873,  4735,  5013, -5890, -5890, -5890,
    4604,  4609,  4576, -5890, 50294, 51452,  4577, 86055,  4776, -5890,
    2184, 50294, 50294,  4066, -5890,  9500, 50294, 84931,  2921,  4066,
     408, 50294,  3263,  3354, 50294, 50294,  4854,  8827,  4580, 50294,
  138229, -5890, -5890, -5890,  2925, 50294,110179,110179,110179,110179,
   -5890, -5890, -5890,109057,109618,109057,  4587, 56056, 60590,  1604,
    4590,110179, -5890, -5890,  4588, 57765,  4853,  4800, -5890, 57765,
    4800,  1891,  4800,  4856,  4683, 65111, -5890, -5890,  4596, -5890,
    4807, -5890, 40472,  2343, 15472,  5048,  4913, 50294,  4599,  4600,
    4601, 15472, 15472, 50294, -5890,  2920,  4913,  2664,   506,  2920,
   -5890, -5890, -5890,  3185,  4605, -5890,110179, 69121, -5890, -5890,
   -5890, -5890, -5890,  4829, 15472, 46241, -5890,  2054,  2183,110179,
    2285,   654, -5890,  4615,110179, -5890,  4546, 15472, -5890, 16466,
   -5890, -5890, -5890, -5890,  4679,  2928, -5890, -5890, -5890, -5890,
   -5890, -5890,  4693, 92788,  4937, -5890, 50294,  2932, -5890,  4646,
    5040,   163,  2937,  2966,  2068, -5890,  4028, -5890,  1894,  4912,
     338, -5890,   291, -5890, 84931, -5890,110179,110179, -5890, -5890,
   -5890, -5890,110179,  3547, -5890, -5890,110179,110179,110179,110179,
   -5890,149394,110179, -5890,110179, -5890, 77063,  1878,  1633,  4924,
    4847, -5890,   289, -5890,  1633,  4848,   215,110179, -5890, -5890,
    2758, -5890, 84931,  2971, -5890,  2974,   291,   291, -5890, -5890,
   -5890, -5890, -5890, -5890,  4630,   487,  4616,  5069,  4711,110179,
  110179,110179, -5890,110179, -5890,149394,110179,110179,  3185,  3185,
   84931,  4619, -5890,  3185,  3185,  4620, -5890,149394,110179,110179,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890,  4707, -5890, 50294,  5063, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890,149394,110179,  4709, -5890,  4710, -5890,
    1014, -5890, -5890,110179,110179,110179,110179,  4976, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,110179, -5890,
  110179, -5890, -5890,  2920,  2920, 84931,   291,   291, -5890, -5890,
   -5890, -5890, -5890,149394, -5890, -5890,  4915,  2225, -5890,  2225,
    2225, -5890, -5890,  2225, -5890,  4634,  2989, -5890,  1249, -5890,
    2068,   853,  4959, -5890,  4962, 50294, -5890,  1536,  3796, -5890,
    5022,  5110, -5890, -5890, -5890, -5890,  4028,  2693,  4700, 79311,
    1459, -5890,  4944,   350,  4866, 89422,  2063,  2037,  4641,  4773,
   -5890,  3328,  3328,  4965,110179,  2058,  4703,110179,  5119, -5890,
   -5890, -5890, -5890, -5890, -5890,149394,  4291,  2990, -5890,  1088,
    4981,110179, 50294,  4418, -5890,   262,  4984, -5890,  2920, -5890,
   -5890,  4783,  4082, -5890,110179,  4879, 89422,  4147, -5890,  2994,
   -5890, -5890, -5890,  4688,  5104,  2391, -5890,  2063,  4732,  1334,
  110179,  2805,  4694,  5130, -5890, -5890,  4988,  4880,  4662, -5890,
   15472, 15472,  2920, 86617,  7088, 84931,  4995,110179,   571,  4964,
  110179, -5890,   291, -5890, -5890,  4668,  2470,  2470, -5890, -5890,
   -5890,   291,   291, -5890,110179, -5890, -5890,  3990,  3990,  3990,
   -5890,  4881, -5890, -5890,  4956,134302,  4670,   211, -5890, -5890,
     291,148406, -5890, -5890, -5890, -5890, -5890,  2698, -5890, -5890,
   -5890, 15472, -5890, -5890, -5890, -5890,  9187, 53768,  5002, -5890,
    4675, 84931, -5890,  4677,  2997,  3015, 54926,  4846, -5890, -5890,
   -5890,  9234,  4734, 15472,  4793,  4682,  4685,  4066,  4066,  9500,
    3018, -5890,  4066, 50294, 50294,  4066,  4066, 50294, -5890, -5890,
    9362,  4884, -5890, -5890,  9555, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, 78187,  4689,  4342,109057,  4702,110179,  1604, 57765,
   -5890, -5890,  2106, -5890, 57765,  4966, -5890, 57765, 79311, -5890,
  110179,  4712,110179, -5890,   687, 52031, 50294,  4728, -5890, -5890,
   -5890,  4582, -5890,  4728, -5890,  2762, -5890, -5890, -5890, -5890,
   -5890,  4713, -5890,  4701,  4714,101764,   363, -5890,  1667, -5890,
   -5890,  5109, 58895,  5060, 50294, -5890, -5890, -5890, -5890, -5890,
  148406,  4914,148406,  2068, 10069,  4028, 58895, 70269,110179,110179,
  110179,  4862,  4028,  4700, -5890, -5890, -5890, -5890, -5890, -5890,
    4715, -5890, -5890, -5890, -5890,  4778, -5890, -5890,  1021,  4072,
   -5890,  3019, -5890,  5169,  5045, -5890, -5890, -5890, -5890, -5890,
   -5890,  4916, -5890, -5890, -5890, -5890, 65676, 50294, -5890,149394,
  110179, -5890,  4791, -5890, -5890, -5890, -5890, -5890, 60025, 69121,
   -5890,  1107,  4718,  4720,  1480, -5890, -5890, -5890,110179, 10840,
    4726,  1026,  4072,110179,110179,  4727,  4737,  4741,  1924,  1682,
    2241,  3990,  5034, -5890, -5890, -5890, -5890,  4916, -5890, -5890,
   -5890,  2225, -5890, -5890, -5890, -5890, 77063, -5890,  2244, -5890,
    3185,   444, 79311,  5176,  5176,110179, -5890, 12131,  4943, -5890,
   -5890,  5025,  4700,  4982,  5047, -5890,  4744,110179,  4930,  4750,
  110179,  4731,  4874,  1175,  1175,110179,110179,110179, -5890, -5890,
  110179,  3024,  2054,  3328,  4511, -5890,  1697, 89422,  5146,  4430,
     349, -5890, -5890,   262, -5890,  1925,  5115,  4796, -5890,110179,
    5228,  4304,110179,  4756, -5890, -5890, 91666,  4973,  1878,152852,
    4525,  4732,  2391,  4907, -5890,  4908, -5890,  4849, -5890,  1297,
   -5890,  2054,110179,102886, 58895, -5890, 85493, -5890,  3049, -5890,
   -5890, -5890,  4836,  4201,  4885,  4886,  4764,110179,   891, -5890,
    4779, -5890, -5890, -5890, -5890, -5890,   350, -5890,110179,  4812,
   -5890,  3185,  4770,   350, -5890,   286, -5890, -5890,  3875, 53768,
   84931,  3052, 50294, -5890, 50294, -5890,  5222, -5890, -5890, -5890,
     125, -5890, -5890, -5890,  4066,  4066,  4066, -5890,  5223,  4582,
   -5890, -5890,  3066,  5249, 53189,  5207, -5890,110179,  3071, -5890,
   50294,  4789, -5890, -5890, 57765,  2106,  4790,  3074,110179,  3080,
   84931,  4792,  4795,    92,  4798, 41052,  4788, -5890, -5890, -5890,
   -5890, -5890, 15472, 15472,110179, -5890,  4799, -5890, -5890, -5890,
   -5890,110179, -5890, -5890, -5890,  4835,110179,  3081, -5890,  1143,
   15472,  2067,  1951,   286,  5040,  4700, -5890,  4801, -5890, -5890,
   -5890,   864,   864,110179,  4700, -5890, -5890,110179,  4876, -5890,
   -5890, 77063,  5099, -5890,  4860, -5890,   799,  1277,  4072,110179,
   84931, -5890,   157,  5133, -5890, 84931, 84931, -5890, -5890, -5890,
   50294,  4892, -5890, -5890, -5890,  1227,  1442,152358, -5890, -5890,
  110179,110179,110179,110179,110179,   291, -5890,  3084, -5890,140958,
   -5890, -5890,  3725,  2920,  3725,  2061, -5890, -5890,  3725, -5890,
    3725, -5890, -5890, -5890, -5890,  1394,  5184,  5176,   942, -5890,
   -5890, -5890,  2179,  5037,  4805, -5890,  1346,  5026,  4897,  4808,
   -5890, 79311,  3769,  4304,  4818,110179, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890,  3085,  4430,110179,  5152,  4082,
    4694, -5890,  4850, -5890, 57765, -5890, -5890, -5890,  3725, -5890,
     168,  4814,  5163,  4430,  2054,  4732,  4304,  4818, -5890, -5890,
    4816, -5890, -5890,  4625,  2391,  4525, -5890, -5890, -5890, -5890,
    5255,  5035,  5257,  4147, -5890,  3993,  3088, -5890, 10584, 86617,
   84931,  5189,  4861,  4863, -5890, -5890,  4878,110179, -5890, -5890,
    2775,  5326,  4430,  4828, -5890,  3185, -5890,  3875,  3091, -5890,
    3098,  3099,  4999,  4887, -5890, 50294,  2198,  4405, 78187,  4832,
   -5890, 53768,  3102, -5890,  3775,110179,  3106, -5890, 15472,110179,
   -5890, -5890, 50294, -5890,  3107, -5890, -5890, 50294,  4837, 50294,
   -5890, 52031,  4831, -5890,  5308, -5890, -5890,  2054, -5890,  4201,
   58895, -5890,  4967, -5890,  5171, -5890,110179,  4894, 69121,  4177,
    4177,  2693, -5890,  2068, -5890,110179, -5890,  4805, 50294, -5890,
    4842,  4934, -5890, -5890,  3120,  1928,  5021,  5021,  3123,  3128,
   12269,110179, -5890, -5890, -5890, -5890, -5890, -5890,  3135, -5890,
   -5890, -5890, -5890,  3145, -5890,  3150,  3185,  4095,  2241,  4095,
   -5890,  3990, -5890, -5890, 77063, -5890,144948, -5890, -5890, -5890,
    2920, -5890,  2920,  5087,110179, 72530,  2920,  2920,  4634,  2920,
   -5890, -5890, -5890,  5224,  5159, -5890,  3317, -5890, -5890, -5890,
   -5890,   410, -5890,  5080,  5081,110179, -5890,  4864,  3151,  2063,
    4994,  4430, -5890, -5890, -5890,110179,  5337,  5338, -5890,110179,
    4418,110179, -5890, -5890, -5890, 50294,  5049, -5890,  4694,  2391,
    2063,  4732,  1878, 59460,  2805,  4525,  4625,  5085, -5890,  5086,
   -5890,  4871,  4082,  7088, -5890, -5890,   406,  5199,  5202, -5890,
   -5890, -5890, -5890, -5890,110179, -5890,  3185,  3154, -5890, -5890,
   -5890, -5890, -5890,  4139, 49136, 49136,  4875, -5890, -5890,110179,
    3796,  4889, 53189, 77063,  3155, -5890, 83245, -5890,  3159,  3162,
   -5890,  3165, 52031,  3171, -5890,110179,  4890, -5890, -5890, -5890,
   63981,148406,   864,  4893, -5890,  4895, -5890, -5890,  4982,  2068,
    4072, -5890, 15472,  2920,110179, 79311,  5328, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890,  4072,  4963,  1227, -5890,  1442, -5890,
  152358, -5890,110179, -5890, -5890,  3175, -5890, -5890, -5890,110179,
    4521, -5890,  4521, -5890, -5890, -5890, -5890,  5023, -5890,  1066,
    1348,  1348,  5262, -5890,  4941, -5890, -5890,  4896, -5890,  5014,
  110179, -5890, -5890,  1107,  2054,  4430, -5890, -5890, 12367, 79311,
   -5890,  4525,  4732,  2391, 50294,  3176, -5890,  5040,   163,  4849,
    4625,  2805, -5890, -5890, 58895,  4625, -5890, -5890, -5890,  2678,
   79311, 79311, -5890,  3179, -5890, 52610,  5030,   302, 13776, -5890,
   -5890, -5890, -5890,  3184, 54926, -5890, -5890, -5890,110179,  5097,
    1853, -5890,  5051, -5890,  3187, -5890, -5890, -5890,  1991,   286,
    4177, 50294,  2068, -5890,  5026, -5890,  4072, -5890,110179, -5890,
    4898, -5890, -5890, -5890, -5890, -5890,144948,  4521,  4796, -5890,
   -5890,  5373, -5890,  1274, -5890, -5890, -5890,110179,  4430,  4619,
    4694, -5890, -5890,  4899,  4625,  2391,  4525, 12675,  5347, 59460,
  110179,110179, -5890, -5890,  4849,  3193,  4201, -5890,  3470, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890,  4900,  4901, -5890,  5370,
   -5890, -5890, -5890, -5890, -5890, -5890,  4342, -5890, -5890, 53768,
    5132, -5890,  1853, -5890, 53768,  4902, -5890, -5890, -5890, -5890,
   -5890, 12726, -5890, -5890, -5890,  1227, -5890,  5253, -5890, -5890,
   -5890,  4430, -5890, -5890, 76501,  2805,  4525,  4625,  5040,  4906,
   -5890, -5890, -5890, -5890, -5890,  4082, -5890,  2096, -5890, -5890,
    2392,  2847,  4983,  5236, 49715,  5335,  3796, -5890, -5890,  3796,
   50294, -5890,  2068,  3194,  5090, -5890,  3197, -5890, -5890, -5890,
   -5890, -5890,  4849,  4625,  2805,110179, 78749,  4625, -5890,  3470,
    5027,  5032, -5890,110179, 13061, -5890, 79311, -5890, 76501, -5890,
   -5890,  4849, -5890,  4910,  4201, -5890,  4953,  4958,  3201, -5890,
    4922, -5890, -5890,  5029, -5890,  5256,  5259, -5890, 76501,  4926,
   79311, 79311,  3206, 78749, -5890, -5890, -5890,  4923,  5129,  4933,
    3185,  4936, -5890
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
    3009,     0,     2,     1,  3438,  3442,  3446,  3447,  3364,  3448,
    3449,  3414,  3415,  3416,  3417,  3418,  3419,  3420,  3421,  3422,
    3423,  3424,  3425,  3427,  3426,  3428,  3429,  3430,  3431,  3432,
    3433,  3434,  3435,  3437,  3436,  3386,  3016,  3383,  3380,  3381,
    3382,  3387,  3385,  3378,  3379,  2535,  3451,  3439,  3452,  3440,
    3441,  3443,  3444,  3413,  3445,  3453,  3454,  3455,  3450,  3458,
    3409,  3410,  3408,  3411,  3412,  3456,  3457,  3400,  3401,  3402,
    3403,  3459,  3017,  3018,  3405,  3010,  3014,  3076,  3147,  3406,
    3407,  3404,  3015,  3399,  3147,     0,  3268,  3269,  3270,     0,
    3271,  3272,  3273,  3199,  3161,  3274,     0,     0,  3275,  3276,
    3277,  3278,  3279,  3280,  3281,  3282,     0,  3283,  3284,  3285,
    3286,  3146,  3287,  3288,  3289,  3290,  3123,  3129,  3252,     0,
    3103,  3104,  3100,  3102,  3101,  3105,  3088,  1514,   698,  1605,
    1604,     0,  1626,  2902,  1514,  1495,  2852,  2853,  2903,  2855,
    2854,  2856,  2857,  2858,     0,   290,     0,     0,  1611,  2859,
    2904,     0,  1514,  1497,  2905,   476,  1186,  2906,  2907,  3031,
       0,  2860,  2861,     0,     0,     0,   698,  1514,     0,     0,
    2862,  1938,  2863,     0,  2864,  2908,  2909,     0,  2865,  2866,
    2910,     0,  2911,  2867,  2868,  2869,  2912,  2913,  2914,  2870,
    2915,  2916,     0,     0,  1952,     0,  2871,  2917,  2872,  1627,
       0,  2873,     0,  2918,  2874,  2875,  2876,  2877,  2919,  2920,
    2878,     0,  2879,  2880,     0,  2881,     0,     0,     0,     0,
       0,     0,  2921,  1514,  1500,  2882,     0,     0,     0,  1959,
       0,  2883,     0,  2922,  2884,     0,  2885,     0,  2923,  2886,
    2887,  2888,  2889,  1952,  3248,  3124,     0,     0,  1613,     0,
    2890,  2924,     0,  2891,  2892,  2893,  2894,  2895,  2896,  2897,
    2898,  2899,  2900,  2901,     0,     0,     0,    81,    82,    31,
      30,   104,    60,    16,    71,   143,   142,   144,    47,    40,
      89,    26,    28,    44,    48,    74,    76,    62,   117,    72,
      24,    70,    98,    77,   102,    55,    10,    11,    56,    12,
      57,    13,    58,    14,   113,    83,   105,    35,    69,    23,
      49,    79,    80,     3,    51,    91,    87,     9,    65,    66,
      68,    95,    96,    97,   125,   100,   138,    46,   135,   110,
     111,   131,   112,   132,     7,   114,    59,    15,   128,   127,
     129,    90,    52,    92,    78,   103,   126,    27,   130,    19,
      20,    22,    21,    67,    29,    75,    32,   101,   133,   122,
     116,   139,   137,   145,   118,    84,     5,     6,   106,     4,
      25,    54,     8,    34,    33,    53,    45,   141,    36,  1611,
      37,     0,    41,   134,   123,    38,    64,    17,    94,    63,
      18,    93,   121,    73,    99,    43,    61,    39,   109,   108,
      42,   124,   107,   115,    88,   119,   120,   140,    86,   136,
    1920,  1907,  1961,  1919,  1937,     0,  1923,  3343,  3344,    50,
    1938,   147,   148,   153,  3013,  3065,  3066,  3067,  3147,  3098,
    3099,  3092,  3108,  3118,  3107,  3111,  3119,  3106,  3125,     0,
     150,   152,   154,   157,   151,   146,   149,   156,   161,   155,
     160,   158,   159,   162,   163,   164,  3345,  2191,  3342,    85,
    3083,  3082,     0,  3147,     0,  3375,  2550,  2551,  2552,  2553,
    2554,  2555,  2556,  2557,  2558,  2559,  2560,  2561,  2562,  2563,
    2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,  2573,
    2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2584,  2585,  2586,  2587,  2589,  2588,  2590,  2591,  2592,  2593,
    2594,  2595,  2596,  2597,  2598,  2599,  2600,  2542,  2601,  2602,
    2603,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,
    2613,  2614,  2615,  2616,  2617,  2618,  2619,  2620,  2621,  2622,
    2623,  2624,  2625,  2626,  2627,  2628,  2629,  2630,  2631,  2632,
    2633,  2634,  2635,  2636,  2637,  2638,  2639,  2640,  2641,  2642,
    2643,  2644,  2645,  2646,  2647,  2648,  2649,  2650,  2651,  2652,
    2653,  2654,  2655,  2656,  2657,  2658,  2659,  2660,  2661,  2662,
    2663,  2664,  2665,  2666,  2667,  2668,  2669,  2670,  2671,  2672,
    2673,  2674,  2675,  2676,  2677,  2678,  2679,  2680,  2681,  2682,
    2683,  2684,  2685,  2686,  2687,  2688,  2689,  2690,  2691,  2692,
    2693,  2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,  2702,
    2703,  2704,  2705,  2706,  2707,  2708,  2709,  2710,  2711,  2712,
    2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,  2721,  2722,
    2723,  2724,  2725,  2726,  2727,  2728,  2729,  2730,  2731,  2732,
    2733,  2736,  2734,  2735,  2737,  2738,  2739,  2740,  2741,  2742,
    2743,  2744,  2745,  2746,  2747,  2748,  2749,  2750,  2751,  2752,
    2753,  2754,  2755,  2756,  2757,  2758,  2759,  2760,  2761,  2762,
    2763,  2764,  2765,  2766,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,  2777,  2778,  2779,  2780,  2781,  2782,
    2783,  2784,  2543,  2785,  2786,  2787,  2788,  2789,  2790,  2791,
    2792,  2793,  2794,  2795,  2796,  2797,  2798,  2799,  2800,  2801,
    2802,  2803,  2804,  2805,  2806,  2807,  2808,  2809,  2810,  2811,
    2812,  2813,  2814,  2815,  3031,  2816,  2817,  2818,  2819,  2820,
    2821,  2822,  2823,  2824,  2825,  2826,  2827,  2828,  2829,  2830,
    2831,  2832,  2833,  2834,  2835,  2836,  2837,  2838,  2839,  2840,
    2841,  2842,  2843,  2844,  2845,  2846,  2847,  2848,  2849,  2850,
    2851,  3049,  2540,  2541,  2547,  2548,  2549,  3024,  3045,  3051,
    3371,  3050,  2546,  3198,     0,     0,  3291,  3292,  3293,  3294,
    3295,  3296,  3346,  3347,  3348,  3349,  3350,  3352,  3351,  3160,
    3318,  3355,  3159,  3356,  3163,  3357,  3358,  3359,  3360,  3319,
    3361,  3162,  3353,  3315,  3164,  3157,  3158,  3316,  3266,  3267,
    2513,  3317,  3314,  3354,  3052,  3313,  3168,  3167,  1897,  3370,
    2512,  1898,     0,  3170,  3297,  3298,  3299,  3300,  3302,  3301,
    3303,  2925,  2926,  2927,  2928,  2929,  2930,  2931,  2932,  2933,
    2934,  2935,  2936,  2937,  3328,  2938,  2939,  2940,  3341,  2941,
    2942,  3329,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,
    2951,  2952,  2953,  2954,  2955,  2956,  2957,  2958,  2959,  2960,
    2961,  2962,  2963,  2964,  2965,  2966,  2967,  3330,  3331,  2968,
    2969,  2970,  2971,  2972,  2973,  2974,  2975,  2976,  2977,  2978,
    2979,  2980,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,
    2990,  2989,  2991,  2992,  2993,  2994,  2995,  2996,  2997,  3332,
    2998,  2999,  3333,  3000,  3001,  3002,  3334,  3003,  3004,  3005,
    3006,  3007,  3008,  3338,  3339,  3340,  3327,  3121,  3304,  3326,
    3337,  3335,  3336,  3131,  3127,  3135,  3130,     0,     0,     0,
       0,  3147,  1513,  1512,  1493,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   697,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3021,     0,  1524,     0,     0,     0,
       0,  1788,     0,     0,     0,   444,   443,  1610,  1583,   698,
       0,  1498,   475,  1938,     0,     0,     0,     0,  1757,     0,
       0,     0,     0,   930,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     213,     0,     0,     0,     0,     0,   501,   500,     0,     0,
       0,  1159,   506,     0,     0,     0,     0,     0,   686,  3030,
    3025,  3035,     0,  3028,  3029,  3313,     0,  3462,  2734,  3061,
    3062,  3460,  2798,  1899,   291,   294,   295,   292,   293,     0,
    1283,  1284,  1286,     0,     0,     0,  1296,   970,   971,     0,
       0,     0,   979,     0,     0,     0,     0,   968,     0,     0,
       0,     0,     0,   984,   981,     0,   985,   982,   965,   983,
       0,   972,     0,   964,     0,     0,  1296,   986,     0,     0,
     966,     0,     0,     0,     0,  1499,     0,  3113,  3114,     0,
    2616,  2660,  1841,   507,     0,     0,  1938,     0,  1806,  1807,
    1611,  1796,  1808,  1801,  1803,  1802,  1804,  1800,  1805,  2551,
    1099,  2566,  1099,  2648,  1096,  1097,  1099,  1099,  1099,  2756,
       0,     0,  1071,     0,  1082,  2536,  1099,  2537,  3371,  1104,
     567,   567,   567,     0,  1103,  1108,   567,     0,  1490,  1533,
    2517,  1951,     0,  2566,  2640,  2648,     0,  1072,     0,     0,
    1489,  1753,     0,  2816,  1833,     0,     0,  1311,  1307,  1309,
    1310,  1308,     0,     0,     0,  2774,  1504,   275,  3311,  2784,
    2886,  2816,  3312,   274,   269,   270,  3306,  3307,  3309,   243,
    3310,  3308,  3305,  2555,     0,     0,  1103,     0,  1501,     0,
    2508,  1502,  1053,  1958,  1956,     0,  2499,     0,     0,  2576,
       0,  2592,  2685,   266,  2767,  2775,  2784,  2886,  2816,  2849,
     222,   232,   227,     0,   284,  2784,  2886,  2816,     0,  1524,
       0,  1924,  2063,     0,     0,  3122,  1492,  1491,  1754,  1612,
       0,  1615,     0,  2751,  1928,  1931,  1621,  1929,  1920,     0,
       0,  3012,     0,  1609,     0,  1633,  1721,  1722,  1723,     0,
    1637,  1724,     0,     0,     0,  1641,  1645,  1725,  1649,  1654,
    1726,  1727,     0,  1662,  1666,  1728,  1668,  1673,  1729,  1677,
       0,     0,  1680,  1684,  1688,     0,  1694,  1730,  1698,  1702,
    1629,  1632,  1634,  1955,  1955,     0,  1955,     0,  1912,  1920,
    1915,  1919,     0,     0,     0,     0,  1514,     0,  3090,  3118,
    3097,  3153,  3094,     0,     0,  3143,  3139,  3136,  3144,  3145,
    3138,  3126,  2180,  2181,  2182,  2179,  2192,  2178,     0,  3071,
    2183,  3110,  3077,     0,  3085,  3084,  3388,  3389,  3200,  3023,
    3042,     0,     0,     0,     0,     0,     0,     0,  3169,  3171,
    3173,  3133,  3132,  3128,     0,     0,     0,     0,  3258,  3259,
    3257,     0,  3254,  3256,     0,  3153,     0,     0,  3322,  3316,
    3325,     0,  2518,  3317,  3314,  3313,     0,     0,     0,   989,
       0,  1536,  1145,     0,     0,     0,     0,     0,     0,     0,
    1194,  1195,     0,  2540,     0,     0,  2659,     0,     0,     0,
       0,   401,  1760,     0,  2410,  2421,  2422,  2423,  2580,  2643,
    2418,  2419,  2420,  2412,  2413,  2414,  2415,  2416,  2417,     0,
       0,  1278,  2411,     0,  2659,     0,     0,   192,     0,   169,
       0,     0,  2659,     0,     0,     0,     0,     0,     0,     0,
       0,  2659,     0,     0,     0,     0,     0,   192,  2690,     0,
     169,  2659,     0,     0,     0,  1518,     0,     0,     0,  1520,
    1523,  1494,  1795,  2510,  1744,     0,  1748,     0,  1745,  1751,
    1746,  1586,     0,  2508,     0,     0,     0,  1023,  1016,     0,
    1024,  1031,     0,     0,  1033,     0,     0,  1017,     0,     0,
       0,     0,  1036,  1037,     0,  1038,  1018,  1039,  1040,  1019,
    1041,  1020,  1042,     0,     0,     0,     0,  1021,     0,     0,
       0,  1508,     0,  1835,  1837,  1836,  1834,   567,     0,     0,
       0,  1755,  1756,     0,  2659,     0,     0,   169,     0,  1571,
       0,  2659,  2787,   169,     0,     0,   505,   504,   169,     0,
       0,   503,   502,     0,   610,     0,  2580,  2643,     0,  1185,
       0,  1436,   169,  2659,     0,   215,  2659,   774,     0,  2659,
    1621,     0,   701,     0,     0,   885,  2690,   169,     0,     0,
       0,     0,     0,     0,  1162,     0,     0,     0,   685,   698,
       0,  3034,  3040,     0,  3032,  3201,  3463,  3461,  3156,     0,
    1287,   267,   268,  1285,   977,  2659,  1227,   391,   391,     0,
       0,  2659,  2734,  1555,  2137,  2139,  2142,  2169,  2147,  2169,
    2169,  2133,  2133,  2625,  2149,  2659,  2134,  2135,  2174,     0,
    2169,  2133,  2133,  2138,     0,  2136,  2177,  2177,  2164,   391,
     993,  2118,  2119,  2120,  2121,  2150,  2151,  2122,  2156,  2157,
    2161,  2123,  2191,  3323,  2133,  3324,  3321,  3320,   978,     0,
     969,  2659,   391,  1191,  2659,  2544,   202,     0,     0,   967,
       0,   401,     0,  2580,  2643,  2659,   391,  1280,     0,  2659,
     198,     0,  2659,   391,  2659,   702,     0,     0,  2659,   391,
    2659,  2690,   200,     0,  2659,   391,   987,  2659,   391,  2659,
       0,     0,     0,  3393,  3397,     0,  3395,  3390,  3112,     0,
       0,  3166,  3165,  3064,     0,  3474,     0,  1899,  1798,  1813,
       0,  1809,  1816,  1812,  1938,  1099,  1098,     0,  1099,     0,
    3484,  1099,     0,  1099,     0,  3484,  1099,     0,     0,     0,
    1099,  2538,  2539,     0,     0,  3483,  3479,  3482,  1073,  1083,
       0,  1105,     0,     0,  1112,  1111,  1110,     0,     0,     0,
    1113,     0,  2066,  1868,     0,  1080,     0,     0,  1078,     0,
    1761,     0,     0,     0,  1487,     0,  1507,     0,     0,     0,
       0,  1162,  1314,     0,  1312,  1303,  1304,  1503,   273,   271,
       0,     0,     0,     0,     0,     0,  1509,     0,     0,  2491,
       0,  2492,  2509,     0,     0,     0,  3377,  2524,  2424,  3376,
       0,  2853,  2855,  2854,  2856,  2857,  2483,     0,  3318,  2858,
    2859,  2904,  2326,  2309,  2320,  2327,  2310,  2312,  2321,  2324,
    2860,  2861,  2257,  2862,  2863,  2531,  2864,  2865,  2866,  2868,
    2869,  2870,  2314,  2316,  2871,  2872,     0,  2532,  2874,  2875,
    2876,  2715,  2878,  2879,  2881,  2882,  2322,  2323,  2884,  2885,
    2318,  2319,  2886,  2887,  2888,  2889,  2530,     0,  2325,  2890,
    2892,  2893,  2894,  2895,  2897,  2898,  2899,  2900,     0,     0,
       0,  2505,     0,  2289,     0,  2126,  2127,  2152,  2153,  2128,
    2158,  2159,  2129,     0,  2504,  2194,  2375,  2288,  2305,     0,
    2294,  2295,     0,  2287,  2283,  1941,  2500,     0,  2284,  2520,
    2484,  2534,  2533,  3371,  2494,  2523,  2521,  2522,  1941,  2498,
       0,     0,     0,   235,     0,     0,  3247,   286,     0,   287,
    2506,  2784,   223,   265,   237,   264,   238,   236,     0,  2578,
     224,     0,     0,   225,     0,     0,     0,     0,     0,     0,
       0,   280,  1496,     0,  2063,     0,  2059,  2058,  2062,   998,
       0,  1597,  1598,  1596,     0,  1593,  1595,  1599,  1614,  1611,
    2434,     0,  1930,     0,     0,     0,  1910,  1909,  1619,  1618,
       0,  1616,  2807,  1600,  1621,  1667,  1638,  1642,  1646,  1655,
       0,  1663,  1669,  1674,  1706,  1636,  1707,  1685,  1689,  1695,
    1699,  1703,  1708,  1639,  1643,  1647,  1656,     0,  1664,  1670,
    1675,  1678,     0,  1681,  1686,  1690,  1696,  1700,  1704,  1709,
    1692,  1640,  1644,  1648,  1657,     0,  1665,  1671,  1676,  1679,
       0,  1682,  1687,  1691,  1697,  1701,  1705,  1693,  1710,  1711,
    1712,  1713,  1714,  1715,  1658,  1716,  1717,  1672,  1718,  1719,
    1683,  1720,     0,     0,  1631,  1622,     0,  1953,  1954,     0,
       0,     0,     0,     0,     0,     0,     0,  2007,  1969,  1970,
    1972,  2004,  2008,  2016,     0,  1916,     0,     0,  2068,     0,
       0,  3011,  3153,  3154,     0,  3148,     0,  3147,  3147,  3141,
    3140,  3137,     0,     0,     0,     0,     0,     0,     0,     0,
    3068,   680,  3070,   677,     0,     0,  3044,     0,  3048,  3046,
       0,  3193,  3196,     0,  3194,  3195,  3197,     0,  3202,  3203,
       0,     0,  3384,     0,     0,     0,  3184,  3172,  3179,  3181,
    3183,  3182,  3191,  3187,  3190,  3192,  3134,  3147,  3265,     0,
    3260,  3263,     0,  3255,     0,     0,     0,     0,     0,  1226,
    2519,     0,   401,     0,     0,     0,     0,     0,   990,     0,
       0,     0,     0,  1544,  1545,  1546,     0,     0,  1547,  1548,
    1536,   277,  1554,  1552,  1535,  1537,  1550,  1542,     0,     0,
       0,     0,     0,     0,     0,  1563,     0,   206,   207,     0,
     718,   698,     0,  2659,     0,     0,     0,     0,     0,  1234,
    1241,     0,     0,     0,  1243,     0,     0,     0,     0,     0,
    1235,  1233,  1236,   279,  1247,  1264,  1267,     0,  1193,  1196,
       0,     0,   610,     0,     0,     0,  1370,     0,     0,     0,
       0,     0,     0,     0,     0,  1370,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   302,   304,   315,   382,   383,   381,     0,     0,
    2659,     0,     0,     0,   610,     0,     0,     0,     0,  1282,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   167,   168,   173,     0,     0,     0,     0,
       0,     0,     0,   663,   676,     0,     0,     0,     0,     0,
     673,     0,     0,   169,   307,   653,   659,     0,     0,     0,
     781,   780,     0,     0,     0,     0,     0,  1461,  1459,     0,
       0,     0,     0,  1561,  1560,     0,     0,     0,     0,     0,
    1370,     0,   296,   298,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   436,
     437,     0,     0,     0,   173,     0,     0,     0,     0,   309,
       0,  3078,     0,  1519,  1516,  1517,     0,  1522,     0,     0,
    1829,     0,     0,     0,     0,     0,     0,  1582,     0,  1030,
       0,     0,     0,     0,  1032,     0,  1025,     0,     0,  1022,
    2580,  2643,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,     0,   478,     0,     0,   882,     0,     0,
       0,     0,     0,     0,   893,     0,  1536,     0,  1570,     0,
       0,     0,     0,   711,     0,  2659,     0,   171,   610,   872,
       0,     0,     0,     0,  1758,     0,   931,     0,   883,   506,
       0,     0,     0,  1440,  1435,   171,     0,     0,   209,     0,
       0,   778,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   823,   822,     0,     0,     0,   884,     0,
       0,   171,     0,  2659,   656,  2659,     0,   567,   567,     0,
       0,  1161,  1164,     0,     0,     0,     0,  3038,  3033,  3036,
       0,  3026,  3040,  1902,  1904,  1903,     0,  1901,     0,   389,
     390,     0,  1270,   880,  1295,     0,     0,  2659,  1557,  2168,
    2155,  2163,  2162,     0,  2144,  2143,  2141,     0,  2140,     0,
    2169,  2169,  2167,  2146,  2145,  2118,     0,     0,     0,  2173,
       0,  2171,     0,   960,  2114,  2110,     0,  2180,  2179,  2178,
       0,  2124,  2133,  2130,   980,     0,     0,  1268,     0,     0,
    1770,  2659,   391,  1774,   610,  2659,   391,  2659,     0,  2659,
       0,     0,     0,  1272,   391,     0,     0,     0,  1463,     0,
     976,   974,   973,   975,     0,     0,   958,     0,     0,     0,
    2659,   391,     0,     0,   953,     0,   955,     0,     0,  3391,
       0,     0,  3394,     0,  3115,  2659,   169,     0,     0,     0,
    3480,  1838,  3477,     0,     0,  1938,     0,   254,   255,   253,
    1814,   256,  1815,  1811,  1797,     0,  1091,     0,  3484,  3485,
    1076,     0,  1086,     0,  3484,  1074,     0,  1087,  1084,  1085,
       0,     0,     0,  3478,  3362,  3368,  1090,     0,     0,   568,
     570,     0,     0,  2604,  2624,     0,  2649,  2678,  2679,  2775,
    2780,     0,  2811,  2821,     0,  1114,  1140,  1109,   792,     0,
       0,  1878,  1081,     0,  1079,     0,     0,     0,  1488,  2659,
     169,  1831,  2441,     0,  1938,     0,     0,     0,     0,   272,
     244,     0,     0,     0,  1142,     0,  2774,  1506,     0,  2490,
       0,  2487,  2486,  2515,  2493,  1052,   698,     0,     0,  2292,
    2293,  2482,     0,     0,     0,     0,     0,     0,  2291,  2449,
       0,     0,     0,     0,     0,  2217,     0,     0,     0,  2462,
       0,  2468,     0,     0,  2254,     0,     0,     0,     0,     0,
       0,     0,     0,  2218,  2198,  2199,  3319,  2289,  2434,     0,
    2290,  2527,     0,  2191,  2424,     0,  2421,  2422,  2423,     0,
       0,     0,  2497,     0,  2432,     0,     0,  2232,  2430,  2234,
       0,     0,     0,     0,  2418,  2419,  2420,  2412,  2413,  2414,
    2415,  2416,  2417,  2428,  2214,     0,  2503,     0,  2377,     0,
    2213,     0,     0,  2020,  1940,     0,  2525,  2485,     0,  3369,
    3372,  2285,  2020,  3244,  3243,  3242,  3241,  3212,     0,  3206,
    3207,     0,  3245,  3246,   288,   289,   285,     0,     0,   240,
     239,     0,   262,   263,   234,   261,     0,   257,   258,   242,
    2366,  2365,   241,   233,   230,   228,   245,   247,   248,   231,
     229,   283,   281,     0,     0,  2060,     0,     0,     0,   391,
    3147,  1609,     0,  1609,  2017,     0,  1932,     0,  1936,  1609,
       0,  1606,     0,     0,  1609,  1659,  1660,  1650,  1651,  1661,
    1652,     0,  1629,  1731,  1743,  1737,  2692,  1733,  1734,  1738,
    1735,     0,  1629,  1739,  1630,     0,  1635,  1927,  1926,  1962,
    1963,  1178,  1925,  1987,  1988,  1983,     0,     0,     0,  2013,
    2011,  1979,  1973,  1978,  1976,     0,  1980,  2194,  2006,  1914,
    1967,  1968,  1971,  1913,     0,  2009,     0,  1881,  2007,  1972,
    1865,     0,  1843,     0,  2069,     0,     0,     0,  3155,  3153,
    3093,  2118,  3147,  3086,  3147,  3142,  3074,  2185,  2186,  2187,
    2188,  2189,  2190,  3075,     0,  3072,  2184,  3073,   678,   679,
       0,     0,     0,  3041,     0,  3022,  3047,  3178,  2794,  3210,
       0,  3211,     0,     0,  3175,     0,  3185,  3188,  3186,  3189,
       0,  2118,  3365,  3261,  3365,  2118,     0,     0,     0,  1206,
    1208,     0,  1207,     0,  1210,     0,  1219,     0,     0,  1205,
    1224,     0,  1213,  1211,   610,   610,     0,  1559,     0,     0,
     991,     0,     0,     0,     0,  1543,     0,     0,  2811,   276,
    1546,  1551,  1538,  1549,     0,     0,     0,     0,     0,  1144,
    1143,     0,     0,  1166,     0,     0,     0,  1566,   556,     0,
     388,     0,     0,     0,     0,     0,     0,     0,     0,   878,
     875,     0,     0,   874,     0,   716,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   754,     0,  1370,     0,
     786,     0,  1245,     0,     0,  1242,  1244,     0,  1248,     0,
       0,  1246,  1239,  1240,  2775,  2784,  2816,   278,  1266,     0,
    1265,  1263,  1188,     0,  1189,     0,     0,  1767,     0,     0,
       0,  2635,  2659,  2703,  2726,   323,   342,     0,  1369,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     628,   620,   621,   624,   622,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   368,     0,     0,   371,   370,     0,
       0,   386,     0,     0,     0,   375,   354,     0,     0,   355,
       0,     0,   374,     0,     0,     0,     0,     0,     0,     0,
       0,  1370,     0,   311,     0,  1773,   317,   400,  1766,     0,
    1462,  1460,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1279,     0,   809,     0,     0,     0,     0,     0,  1442,
       0,     0,   195,     0,   190,   194,     0,     0,     0,     0,
     661,   662,   675,     0,   666,   667,   664,   668,   669,     0,
       0,     0,     0,     0,     0,     0,   660,     0,     0,   776,
     775,   779,     0,     0,     0,     0,  1453,     0,  1259,     0,
       0,  1451,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1316,  1315,     0,     0,     0,     0,     0,     0,
     921,     0,     0,     0,     0,     0,     0,     0,     0,   197,
     796,     0,   795,     0,   191,   196,     0,     0,     0,     0,
       0,     0,     0,   252,  1515,  1521,  1794,  2511,  1828,  1824,
    1824,  1824,     0,  1750,     0,  1747,  1585,  2516,  1584,     0,
       0,     0,     0,  1034,     0,     0,     0,     0,     0,     0,
       0,  1026,  1027,  1028,  1029,     0,     0,     0,     0,     0,
       0,   450,     0,   452,     0,     0,   909,  3320,   881,     0,
       0,     0,   895,     0,   898,   901,     0,  1534,     0,   525,
       0,     0,     0,     0,   704,   754,     0,     0,   509,   204,
    1759,     0,     0,     0,   608,   607,   609,     0,   930,     0,
       0,     0,     0,   811,     0,     0,     0,  1259,  1439,   166,
     213,   215,   507,     0,   214,   216,   218,   219,   220,   217,
     221,     0,   773,   777,     0,     0,     0,     0,     0,     0,
     700,     0,     0,     0,     0,     0,   824,   828,   827,   831,
     829,     0,   825,     0,     0,  2089,     0,     0,   189,     0,
       0,   651,   655,     0,  3019,     0,     0,   509,   610,   404,
    2659,     0,   567,     0,  2659,     0,  1163,     0,     0,     0,
       0,     0,     0,  3039,     0,     0,     0,     0,  1900,   391,
    1228,     0,  1556,     0,     0,     0,     0,   391,  2166,  2165,
    2115,  2111,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,  2131,   391,  1192,   203,  2545,     0,   962,
    1769,     0,  1464,     0,     0,     0,     0,   391,  1281,   950,
     199,  1787,   391,   703,     0,   391,   201,     0,     0,     0,
     695,   391,   988,   391,     0,   391,  3392,  3398,  3396,     0,
     711,  1764,     0,  1817,  1818,  1840,  3481,  3475,  3476,   567,
    1904,  1799,  1810,  1088,  1095,  1077,  1094,  1093,  1075,  1092,
    1089,  3177,     0,     0,  3367,     0,  1106,     0,   566,     0,
       0,     0,  1120,  1121,     0,     0,  1119,  1122,     0,  1124,
    1116,  1115,  1125,  1126,     0,     0,  1142,   790,     0,     0,
       0,     0,  1875,     0,  1873,     0,  2067,  1877,  1866,     0,
       0,     0,  1884,  1886,  1887,     0,     0,   711,  1832,     0,
    1830,     0,   644,     0,     0,  1313,     0,     0,  1103,     0,
       0,   391,     0,  1505,  1752,  2488,  2491,     0,  1054,  1060,
       0,     0,     0,     0,     0,     0,  1063,  1064,  1065,  1056,
    1066,  1067,  1057,  1068,     0,  1058,     0,     0,     0,     0,
    2445,     0,  2446,     0,     0,  2481,  2477,     0,     0,     0,
       0,     0,  2453,  2454,  2455,  2452,  2456,  2451,     0,     0,
    2457,  2450,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2882,     0,     0,     0,     0,  2258,     0,     0,  2405,
       0,  2434,  2467,     0,     0,     0,     0,     0,     0,  2434,
    2473,     0,     0,     0,     0,  2364,     0,  2361,     0,     0,
       0,     0,  2494,     0,     0,  2528,  2195,  2209,  2210,  2211,
    2215,  2502,     0,  2496,     0,     0,  2196,  2223,     0,  2474,
    2250,     0,  2255,  2238,     0,  2231,     0,  2236,  2240,  2219,
       0,  2216,     0,  2497,  2433,     0,  2431,     0,  2206,  2207,
    2208,  2200,  2201,  2202,  2203,  2204,  2205,  2212,  2409,  2407,
    2408,     0,     0,     0,  2385,     0,     0,  2235,  2652,  2685,
       0,  1952,  1952,  1952,  1939,  1950,  2501,     0,  2084,     0,
       0,     0,     0,  2297,     0,  2438,  1961,  2436,  2518,  3374,
    3373,  2495,  2084,     0,     0,     0,  2507,     0,     0,  2191,
       0,   282,  2063,  2065,     0,   996,   997,   995,  2118,  1590,
    1621,  1594,  1589,  1587,  1609,  2435,  1620,  1934,     0,     0,
    1602,  1621,  1617,  1608,  1607,     0,  1601,  1653,     0,  1623,
    1736,  1629,  1625,     0,  1628,     0,  1176,  1177,     0,  1181,
       0,     0,  1981,  2014,     0,  2005,     0,  1985,  1986,  1977,
    2015,  1879,     0,  2010,  1918,  1917,     0,  2087,     0,     0,
       0,  1857,  1845,     0,  2070,     0,  2020,  1889,     0,  2494,
    2018,  3091,  3149,  3096,  3117,  3087,  3120,  2193,  3069,  3109,
       0,  3043,  3213,  3214,     0,  3204,  3205,  3174,  3180,  3251,
       0,  3366,     0,     0,  1412,  1317,  1377,  1209,     0,  2133,
    1220,     0,  1204,     0,  1203,  2133,     0,  1221,     0,  2133,
    1768,  1765,  1413,  1318,  1378,   992,  1414,  1319,  1379,  1415,
    1320,  1553,  1541,  1540,  1539,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   859,
    2659,   391,  1564,  1416,     0,  1321,   387,  1565,  1380,  1569,
     877,   876,     0,     0,  1381,     0,   717,     0,   721,     0,
     723,   724,   725,     0,     0,     0,   726,     0,  2580,  2643,
     728,   731,   738,   743,   733,     0,     0,   745,   739,     0,
       0,     0,     0,     0,     0,   751,   753,     0,     0,     0,
       0,     0,     0,     0,  1237,  1238,  1417,  1324,     0,  1382,
    1187,     0,  1325,   205,     0,     0,   303,  2659,   325,     0,
     384,   343,   758,   859,  1372,   322,   352,   385,     0,     0,
     367,   362,   363,   361,   626,   619,     0,     0,   629,  2659,
     391,  2659,   391,     0,     0,     0,     0,     0,   364,   359,
     360,   356,     0,     0,     0,   369,  2554,  2626,  2785,     0,
     762,   764,     0,   769,   372,  1344,   398,   397,   396,     0,
     376,     0,   405,   408,     0,   373,   350,   353,   351,   633,
     632,   347,   316,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1454,  1259,     0,  1452,     0,  2514,     0,     0,
    1274,     0,  1420,  1383,     0,  1403,     0,     0,     0,     0,
     803,  1443,  1445,  1432,  1331,  1444,   193,  1359,     0,     0,
     178,     0,     0,     0,     0,   172,   182,     0,  1423,  1332,
       0,     0,   308,   654,   665,   670,  1338,   674,   671,  1393,
     672,  1430,  1333,  1334,  1426,  1362,  1388,  1433,     0,  1455,
    1335,  1259,  1448,  1450,     0,  1370,     0,   297,   299,     0,
     320,     0,  1336,     0,  1386,  1425,  1361,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1572,     0,     0,     0,
       0,     0,     0,   391,     0,     0,     0,  1372,  2659,   391,
    1424,     0,  1367,     0,  1401,     0,   438,     0,  1360,     0,
       0,   310,  1340,  1395,     0,     0,   250,   249,   251,     0,
    1827,  1827,  1827,  1749,     0,  1044,  1003,  1043,     0,  2624,
       0,  1002,  1004,     0,     0,     0,  1005,     0,     0,     0,
       0,  1001,   999,  1000,  1510,   449,     0,   477,     0,     0,
       0,   908,     0,     0,     0,     0,     0,   897,     0,     0,
       0,     0,  1562,     0,   169,     0,     0,   715,     0,     0,
       0,   710,   753,   758,     0,     0,     0,     0,   508,   512,
     516,   517,   518,     0,     0,     0,     0,   183,   170,     0,
     873,  1771,     0,     0,   939,     0,   567,     0,   813,  1438,
    1437,     0,  1434,     0,   215,   208,     0,     0,   774,     0,
    1785,  1783,  1621,     0,     0,   404,   892,   890,   889,   891,
       0,     0,     0,   913,   888,     0,  2088,  2090,     0,     0,
       0,     0,     0,     0,     0,   511,     0,     0,   570,   614,
       0,     0,     0,     0,   404,     0,     0,     0,  1198,     0,
    1216,  1199,     0,     0,     0,     0,  1252,  1259,  1253,  1229,
       0,     0,   683,  3037,  3031,  1905,  1906,     0,  1271,     0,
    1558,     0,  2132,  2148,   961,     0,  2176,  2175,  2177,  2177,
       0,  2116,     0,  3464,  3472,  3471,     0,  2160,  2125,  1269,
     391,   391,     0,   391,     0,   391,  1273,  1465,     0,   959,
       0,     0,   391,   952,   954,     0,   956,     0,   708,  1762,
       0,     0,  3176,  3363,  1107,   569,     0,     0,     0,     0,
    1118,   681,  1123,     0,  1135,  1130,  1132,     0,  1136,   789,
       0,     0,  1876,  1869,  1871,  1870,     0,     0,  1867,     0,
    2711,  1779,     0,  1882,     0,  1883,     0,   706,  2442,   951,
       0,   650,  1305,  1306,     0,     0,   391,     0,  1137,  1511,
    2490,     0,     0,     0,  1061,  1055,     0,     0,  1059,     0,
    1062,     0,     0,  1957,  2443,  2444,     0,     0,     0,  2478,
       0,     0,  2339,     0,  2311,  2313,  2329,     0,  2340,  2296,
    2341,  2315,  2317,     0,  2425,     0,     0,  2330,     0,  2260,
    2261,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2276,  2275,
    2331,  2404,     0,     0,  2465,  2466,  2332,     0,     0,  2472,
       0,     0,     0,  2337,  2342,     0,     0,     0,     0,  2348,
       0,  2369,     0,     0,     0,  2286,  2435,     0,     0,     0,
       0,     0,     0,     0,     0,  2256,  2239,  2233,     0,  2237,
    2241,     0,     0,     0,  2227,     0,     0,  2225,  2251,  2221,
       0,     0,  2252,     0,     0,     0,  2304,     0,     0,  1952,
    1952,  1952,  1952,  1949,     0,     0,     0,     0,  2771,  2901,
       0,  2044,  2019,  2021,  2031,  2044,  2049,  2044,  2306,  2082,
    2307,     0,  2508,     0,  1990,  1961,  1961,  1961,  2303,     0,
       0,     0,     0,  1960,  1990,  3226,  3228,  3229,  3230,  3231,
    3232,  3234,  3235,  3237,  3238,  3239,  3227,  3233,  3236,  3240,
    3217,  3218,     0,  3208,  3209,   226,     0,   259,   246,  2061,
       0,  3251,  1609,     0,  1588,  1935,  1938,  1609,  1732,  1624,
    1740,  1964,     0,  2426,  1181,     0,  1966,     0,     0,  2012,
    1974,  1880,  1864,     0,  1862,  1849,  1851,  1850,     0,     0,
    1852,  2494,     0,  1862,  1844,  1894,     0,     0,  2087,     0,
    1893,     0,  3151,  3079,     0,     0,  3250,  3253,  3264,  3262,
    3089,     0,  2133,  1201,  1202,     0,  1225,     0,  1147,  1148,
       0,  1146,     0,     0,     0,   555,  1165,     0,     0,     0,
     859,     0,     0,   559,     0,  1567,     0,  1431,  1358,   719,
     720,     0,   732,     0,   741,   740,     0,     0,     0,     0,
       0,     0,     0,   727,   747,   687,   748,   750,     0,     0,
     749,   752,   755,  1370,     0,   787,  1346,     0,  1399,  1231,
    1373,     0,  1190,     0,     0,     0,     0,     0,     0,   525,
     346,     0,     0,     0,   169,     0,   327,   335,   411,   341,
       0,  1376,   378,     0,     0,     0,     0,   349,     0,   339,
     365,   357,   366,   358,   377,     0,   379,     0,   766,   767,
     765,   761,     0,   768,   770,     0,   402,     0,     0,     0,
       0,   634,  1419,     0,  1370,     0,   312,     0,  1342,     0,
    1397,   321,   318,  1456,  1259,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,     0,     0,     0,
       0,   808,     0,   805,     0,     0,   175,   174,     0,   181,
       0,     0,     0,     0,  1258,     0,  1457,     0,     0,     0,
       0,     0,     0,   420,     0,   319,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   439,   393,     0,   916,     0,     0,     0,
     441,     0,     0,     0,     0,     0,  1418,  1326,  2604,  1823,
       0,  1821,  1819,  1820,     0,     0,     0,     0,  1014,     0,
       0,     0,     0,     0,     0,   454,   455,   169,   453,     0,
     447,   448,   450,     0,   910,     0,   907,  2715,  2412,  2413,
     905,   911,   902,   904,   903,   906,   859,     0,     0,   894,
     899,   900,     0,  1772,     0,     0,     0,     0,   540,     0,
       0,     0,   531,     0,     0,  1259,   524,   527,   528,     0,
       0,   711,  1786,  1784,   714,   712,   713,   746,     0,   511,
     547,   594,     0,   185,     0,     0,   186,   184,     0,  1792,
       0,     0,     0,   404,   810,     0,   807,     0,     0,   211,
     507,     0,   778,     0,     0,     0,  1259,   699,   830,   833,
     826,     0,   912,   914,   886,     0,   758,     0,     0,   656,
       0,  1841,   644,     0,   596,   511,   594,     0,   616,   403,
       0,     0,   644,   616,     0,     0,  1166,  1197,     0,     0,
       0,  1249,  1254,  1250,     0,     0,  1212,     0,  1251,  1230,
    1184,  1482,  1483,  1480,  1481,     0,     0,     0,  3054,  1896,
    3063,     0,  2154,     0,  2172,  2170,  2112,     0,  3147,     0,
       0,     0,     0,     0,  2117,   963,  1466,     0,   946,     0,
     948,   391,   797,     0,   696,   391,   169,  1763,     0,     0,
       0,     0,  1117,     0,  1133,     0,     0,  1100,  1139,     0,
       0,  1874,  1872,     0,     0,     0,  1885,   169,   642,     0,
    1142,     0,  1101,  1141,  2489,     0,     0,     0,     0,     0,
       0,     0,  2447,     0,  2480,  2476,     0,  2308,  2448,     0,
    2460,  2459,  2405,     0,     0,  2259,  2271,  2272,  2273,  2461,
       0,  2281,     0,     0,  2268,  2269,  2270,  2262,  2263,  2264,
    2265,  2266,  2267,  2274,  2470,  2469,  2463,  2464,     0,  2334,
    2335,  2336,  2471,  2343,     0,  2571,  2370,  2347,  2363,  2362,
       0,     0,     0,  2350,     0,     0,  2359,     0,  2406,  2529,
    2197,     0,     0,  2224,  2475,  2242,     0,     0,     0,  2220,
    2425,     0,     0,     0,     0,     0,  2229,     0,     0,     0,
    2388,  2383,  2384,  2402,     0,     0,     0,     0,     0,     0,
    1943,  1942,  1948,  2044,  2049,  2044,     0,     0,  1920,     0,
    2031,     0,  2043,  2029,  2042,     0,     0,  2055,  2053,     0,
    2055,     0,  2055,     0,  2023,     0,  2045,  2025,  2042,  2027,
       0,  2074,     0,  2509,  2083,     0,  2003,     0,     0,     0,
       0,  2439,  2440,     0,  2437,  2298,  2003,     0,     0,     0,
    2064,  3249,  1591,     0,     0,  1603,     0,     0,  1965,  1179,
    1180,  1982,  1975,     0,  2085,     0,  1863,     0,     0,     0,
    1854,  1860,  1842,     0,     0,  1890,  1862,  1891,  3095,     0,
    3150,  3215,  3216,  1222,     0,     0,  1214,  1153,  1156,  1154,
    1152,  1155,     0,     0,     0,   859,     0,     0,   575,     0,
    1173,  1173,     0,     0,   561,   638,  1259,   862,     0,     0,
       0,   860,   391,  1322,     0,   742,     0,     0,   737,   735,
     734,   736,     0,   688,  1429,  1323,     0,     0,     0,     0,
    1232,     0,     0,  1345,     0,   324,     0,   521,     0,   336,
       0,   332,     0,  1371,     0,     0,     0,     0,   331,   415,
       0,   412,     0,     0,   627,     0,   391,   391,   344,   380,
     763,   399,   406,   407,   410,     0,     0,     0,     0,     0,
       0,     0,  1375,     0,  1458,     0,     0,     0,     0,     0,
       0,   940,   923,     0,     0,   941,   942,     0,     0,     0,
    1276,  1277,  1275,  1404,  1405,  1410,  1407,  1406,  1409,  1408,
    1411,     0,  1329,     0,     0,   801,   179,   176,   177,   180,
    1356,  1339,  1394,  1449,     0,     0,     0,  1337,     0,  1387,
       0,  1352,  1348,     0,     0,     0,     0,     0,  1428,  1366,
    1392,  1427,  1364,  1390,  1363,  1389,  1365,  1391,     0,  1357,
       0,  2092,   920,     0,     0,     0,   391,   391,   919,   799,
    1341,  1396,  1822,     0,  1826,  1789,     0,     0,  1006,     0,
       0,  1008,  1009,     0,  1011,   459,     0,  1781,     0,   819,
     879,     0,     0,   896,   858,     0,   529,     0,   535,   538,
       0,     0,   542,   543,   541,   530,  1259,   567,   637,     0,
       0,   869,     0,   705,     0,   509,     0,   544,     0,     0,
     513,   188,   187,     0,     0,  1259,     0,     0,     0,   814,
     818,   816,   815,   817,   812,     0,   803,     0,   215,     0,
       0,     0,     0,   639,  1446,     0,   843,   887,     0,  2091,
     793,     0,   404,   652,     0,     0,   509,   644,  3020,     0,
     514,   519,   520,   525,     0,   610,   595,     0,   596,     0,
       0,   618,  1532,     0,   645,   647,     0,     0,     0,  1200,
    1217,  1218,     0,     0,  1259,     0,     0,     0,     0,   690,
       0,  3027,   391,  2113,  3465,     0,  3466,  3467,  3468,  3469,
    3470,   391,   391,  1302,     0,   957,   711,  1129,  1128,  1127,
     682,     0,  1131,   791,     0,     0,     0,  1775,   711,   643,
     391,     0,  1070,  1049,  1069,  1048,  1050,     0,  1047,  1045,
    1046,  2479,  2328,  2338,  2458,  2404,  2435,     0,     0,  2282,
       0,     0,  2333,  2891,     0,     0,     0,     0,  2367,  2368,
    2349,     0,  2702,  2354,     0,     0,     0,  2248,  2246,  2243,
       0,  2244,  2228,     0,     0,  2226,  2222,     0,  2253,  2374,
       0,  2390,  2387,  2401,  2435,  1947,  1946,  1945,  1944,  2030,
    2026,  2028,     0,  2896,     0,  2033,  2040,     0,  2022,     0,
    2054,  2050,     0,  2051,     0,     0,  2052,     0,     0,  2024,
       0,  2040,     0,  2081,  1961,     0,     0,  2379,  2301,  2302,
    2299,  1961,  2526,  2379,  3219,     0,  3222,  3220,  3221,  3225,
     260,     0,  1933,  1741,     0,     0,  3480,  1846,     0,  1847,
    1853,     0,     0,     0,     0,  1895,  1888,  3152,  1215,  1223,
       0,     0,     0,   557,     0,  1259,     0,     0,     0,  1175,
    1175,     0,  1259,   637,   864,   863,   866,   861,   865,  1568,
       0,   729,   730,   744,  1347,     0,  1400,  1354,     0,  1878,
     326,     0,   759,     0,     0,   328,   414,   416,   329,   330,
     333,   393,   625,   623,   348,   338,     0,     0,   345,     0,
       0,  1343,     0,  1398,  1350,  1421,  1327,  1384,     0,     0,
     929,     0,     0,     0,     0,  1422,  1328,  1385,     0,     0,
       0,     0,  1878,     0,     0,     0,     0,     0,     0,     0,
       0,  1577,     0,  1374,   392,   918,   917,   393,   440,  1368,
    1825,     0,  1007,  1012,  1013,  1010,     0,   446,   456,   451,
       0,   480,     0,  1293,  1293,     0,   859,     0,     0,   526,
     539,     0,   637,   574,     0,   532,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1793,  1447,
       0,     0,     0,   806,   805,  1441,   210,   509,     0,   758,
       0,   837,   838,   832,   834,     0,   845,   849,   915,     0,
       0,   511,     0,     0,  1839,   510,     0,     0,   522,     0,
     614,   596,   610,     0,   611,     0,   615,   631,   617,     0,
    1525,     0,     0,     0,     0,  1255,     0,  1261,     0,  1211,
    1182,  1256,     0,  2084,     0,     0,     0,     0,   694,  3053,
    3057,  1294,  3473,   947,   949,   798,   709,  1134,     0,     0,
    1780,     0,     0,   707,  1138,   391,  1051,  2406,  2277,     0,
       0,     0,     0,  2344,     0,  2345,  2372,  2371,  2351,  2355,
       0,  2352,  2353,  2245,  2249,  2247,  2230,  2376,     0,  1961,
    2403,  2077,     0,  2080,     0,     0,  2032,     0,     0,  2034,
       0,     0,  2036,  2038,     0,     0,     0,     0,     0,     0,
    2512,     0,  2600,  2866,  2770,     0,  1989,  1991,  1994,  1996,
    1995,  1997,  1993,  2002,     0,  1922,     0,  1921,  3224,  3223,
    1592,     0,  2427,  2086,  1861,     0,     0,     0,  1167,     0,
    1892,  1135,     0,   391,  1173,   637,   576,  2715,   577,  1172,
    1174,  1178,  1178,     0,   637,   859,   722,     0,     0,   305,
     757,     0,     0,   337,   395,   409,  1961,     0,  1878,     0,
       0,   927,   936,   936,   924,     0,     0,   943,  1330,   802,
       0,     0,   300,  1353,  1349,     0,     0,     0,  1579,  1580,
       0,     0,     0,     0,     0,   391,  1015,     0,   483,   490,
     460,   465,  1571,     0,  1571,     0,   462,   467,  1571,   461,
    1571,   466,   458,  1782,   481,   169,     0,  1293,     0,  1290,
    1289,   857,     0,   565,   658,   533,     0,   585,   636,     0,
     870,     0,     0,   511,   594,     0,   554,   553,   549,   548,
     550,   551,   552,   546,   545,     0,   758,  1790,   933,   404,
    1532,   800,     0,   771,     0,   835,   840,   839,  1571,   844,
       0,     0,     0,   758,     0,   596,   511,   594,   515,   525,
       0,   601,   600,   616,   610,   614,   612,   613,   641,   630,
       0,     0,     0,   644,  1581,  1166,     0,  1260,     0,     0,
       0,     0,     0,     0,  1297,   689,     0,     0,   693,   684,
       0,  3055,   758,     0,  1777,     0,  1102,  2278,     0,  2279,
       0,     0,     0,  2357,  2356,     0,  2393,  2082,     0,     0,
    2076,     0,     0,  2106,     0,     0,     0,  2041,  2057,     0,
    2037,  2035,     0,  2046,     0,  2048,  2298,     0,     0,     0,
    1998,     0,  2378,  2380,     0,  2300,  1742,     0,  1859,  2084,
       0,  1856,     0,  1149,     0,  1150,  1175,   580,     0,  1181,
    1181,   567,   859,   558,  1355,     0,   760,   658,     0,   340,
       0,     0,   313,  1351,     0,     0,   938,   938,     0,     0,
       0,     0,   427,   434,   433,   428,   426,   435,     0,   431,
     425,   424,   429,     0,   422,     0,     0,  1573,     0,  1574,
    1575,  1578,   442,   457,     0,   488,     0,   486,   485,   487,
       0,   474,     0,     0,     0,     0,     0,     0,   459,     0,
    1288,  1292,  1291,     0,     0,   534,     0,   536,   571,   572,
     573,     0,   537,   581,   582,     0,   867,     0,     0,     0,
       0,   758,   593,   782,  1791,     0,     0,     0,  1526,     0,
     640,     0,   846,   847,   842,     0,     0,   794,  1532,   610,
       0,   596,   523,     0,   618,   614,   616,     0,  1529,     0,
     646,     0,   404,  1259,  1262,  1257,  1486,     0,     0,   692,
     691,  3058,  3060,  3059,     0,   788,     0,     0,  2280,  2360,
    2346,  2373,  2358,  2389,     0,     0,     0,  2075,  2078,     0,
    2109,     0,     0,     0,     0,  2095,     0,  2039,     0,     0,
    2047,     0,     0,     0,  1992,     0,     0,  1848,  1858,  1168,
       0,     0,  1178,     0,   859,     0,  1170,  1169,   574,   560,
    1878,   334,   394,     0,     0,     0,     0,   934,   937,   925,
     926,   945,   944,   804,  1878,     0,     0,   418,     0,   417,
       0,   421,     0,   484,   493,     0,   491,   463,   469,     0,
     473,   471,   470,   464,   468,   445,   479,     0,   564,     0,
       0,     0,     0,   583,     0,   584,   635,     0,   871,     0,
       0,   784,   932,     0,     0,   758,   836,   841,     0,     0,
    1527,   614,   596,   610,     0,     0,   602,  1173,  1173,   631,
     616,   618,  1530,  1531,     0,   616,  1183,  1485,  1484,  1938,
       0,     0,  3056,     0,  1776,  2852,     0,  2823,     0,  2391,
    2394,  2392,  2386,     0,     0,  2107,  2108,  2093,     0,     0,
    2097,  2056,  2073,  2000,     0,  1999,  2381,  2382,  2084,   391,
    1181,     0,   562,   578,   585,   306,  1878,   928,     0,   301,
       0,   432,   430,   423,  1576,   489,     0,   472,   849,   657,
     590,     0,   589,     0,   587,   586,   868,     0,   758,   922,
    1532,   772,   848,     0,   616,   610,   614,     0,   599,     0,
    1175,  1175,   496,   498,   631,     0,  2084,  1468,  1938,  1467,
    1469,  1477,  1474,  1476,  1475,  1473,  1300,  1301,  1778,     0,
    2398,  2397,  2396,  2400,  2399,  2079,     0,  2096,  2099,     0,
       0,  2105,  2098,  2100,     0,     0,  2071,  2001,  1855,  1151,
    1171,     0,   859,   314,   935,     0,   492,     0,   588,   592,
     591,   758,   783,  1528,   852,   618,   614,   616,  1173,     0,
     597,   603,   605,   604,   494,   404,  1157,     0,  1478,  1472,
    1920,  1907,     0,     0,     0,     0,  2103,  2104,  2101,  2102,
       0,   579,   563,     0,     0,   785,     0,   850,   853,   856,
     854,   855,   631,   616,   618,  1175,     0,   616,  1470,  1938,
       0,     0,  2395,     0,     0,   419,     0,   820,     0,   497,
     499,   631,   606,     0,  2084,  1471,     0,     0,     0,  2072,
       0,   851,   495,     0,  1158,     0,     0,  2094,   852,     0,
       0,     0,     0,     0,  1298,  1299,   821,     0,     0,     0,
       0,     0,   598
};

/* YYPGOTO[NTERM-NUM].  */
static const int yypgoto[] =
{
   -5890, -5890,  5098, -5890, -1440,   170,  3143,  -920, -5890, -5890,
   -5890,  1363, -5890, -5890, -5890, -5890,  4100, -5890,  2160, -3247,
   -5890, -5890,   -10,  4056, -1983,   -17,  3568,  1777, -5890, -1731,
   -5890, -5890, -1010,    27, -5890,  4086,   328, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -1255, -5890,  2293,  1501, -5890,
    2373,  1569, -1412, -3304, -5890, -5890, -1409, -2150, -4149, -5890,
     808, -5890,   845, -5176,  -787, -5890, -5629, -5890,  -959,  -781,
   -5890, -5890,  2291, -5890, -5890, -5890,   706, -5890,   162,  -647,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890,  -632, -5890, -5890,
    -883,   339,   -94, -3240, -4694, -5890, -5890,   664,  -237, -2182,
   -5890, -4527, -5890,   164, -2517, -5890, -5890, -5890,  -201, -2143,
    1684, -5890, -1139, -1738,  2047,  -741, -5890,   -78, -5890,  -855,
    -642,  -640,  -777, -4737, -5240, -5890, -5890, -5890, -5890,  -884,
   -2206, -5543, -4801, -4684, -5890, -5890, -5890, -5258, -4170, -5532,
   -4092,  1692, -5890, -5890, -4724,   480,   635, -5890,   491,   498,
   -5890,   650,  -567, -1456, -2276, -5890, -1317, -5890, -5890, -5890,
   -3843, -5890, -5890, -5890, -5890,   -62, -5890, -5890, -5890, -5890,
   -3387, -5890, -5890, -5890, -5890, -5890, -5890, -3512,  2246,  2247,
   -5890, -4031, -5890, -1407, -5890,   861, -3874,  1588, -5890, -5890,
    1349,  4132,   672, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -2369, -5890, -5890, -5890, -5890,   153,  -186, -5890, -5890, -5890,
   -5890, -5890, -5890,   501, -5890,  2267,  1342, -5890, -5890,  -188,
   -5890, -5890, -5890, -5890, -5890, -5890,  -842,  -991,  -969, -5890,
   -3823, -5890, -5890, -5890,  -159,  -412, -5890, -5890, -5890, -5890,
   -5890, -1468, -5890,  1413, -4036, -5890, -5890,  1420, -5890, -5890,
   -5890, -5890, -5890,  -760,   -97,  3163, -5890,  -348,  -551, -5890,
   -5890, -5890,   -96, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
   -5890, -1649, 19014, -1350,  -929, -5890, -5890, -5890, -5890, -5890,
   -3140, -5890, -5890, -5890, -5890, -4499, -5890,  5426,    58,  -543,
     512, -5890,  -215,   -92,  3846, -1725, -3518,   608,  -305, -5890,
   -5890, -5890, -3408, -5890, -5890, -5890, -5890, -4448,   530, -5890,
    3827, -5890, -4757, -5552, -4491, -5030, -5425, -5511, -4439, -5890,
   -5890, -5890, -5890,  -848,  -960, -5890, -5890, -2170,  2629, -2737,
   -5890, -2918,   671,  1762,  4083, -3601,  -874,  3113, -4761, -1152,
   -4172, -5890, -5890, -3246,  -446, -5890, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -1023,  3053,  -955, -5890, -5890,  4558, -5890,
   -5310, -5890,  4519, -5890, -5890, -5890, -5890,  2942,  2945, -5890,
    2950, -5890, -5890, -2152,  1506, -5890, -5890, -5890, -5890,   878,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -3792,
     866, -5890, -5890, -5890, -5890, -5890,  -753,  -919, -5890, -5890,
     567, -5890, -5890, -5890, -5890,  2351, -1432, -1155,  4423,   573,
   -5691, -5890, -5890, -1521, -5890,  3458, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -3174, -5890, -5890, -5409, -5890,
   -5890, -5890, -5890, -5890,  2791,  2786,  -100, -2688,  -226, -5890,
   -5890, -5890,  2784, -1518, -5890, -5890, -2652, -5890, -5890, -5890,
    3579,  3270,  3268, -2154, -5890, -5890, -5890, -5890, -5890, -5890,
    -911, -1382, -2155,  2799, -5890, -5890, -5890, -5890, -5890, -5890,
   -4177, -4743, -5890, -5890, -5890, -5890, -5890, -5890, -5890,  -970,
   -5890,  3043, -5890, -5890, -5890, -5890, -5890,  -107,  -953, -5890,
   -5890, -5890, -2582,   581,   733,   -77, -5890, -5890,    41, -5890,
     481, -5890, -5890, -4350,   -75, -5890, -5890, -5890, -5890, -5365,
   -5890, -5890,  2998,  1300,   -74,  -629,  1070, -3660, -5890,   601,
     -71,  3951,  2180,   -36,   -32,  -248,  -267,  -222,   -76,   -43,
    3696, -5890, -5890,  3754, -5890,  -198,  2484, -5890, -5890, -1320,
    -389, -5890,  1898, -1069,  2767,  3617,  3619, -5890,  1892, -5890,
   -5890,  1899, -5890,  1145,  -600,  -428, -5890, -5890, -5890, -5890,
     528, -1065,  2780, -5890,  3618, -5890, -5890, -5890, -2599, -3709,
   -4343,  1182, -4325, -4266,   576,   554, -1620,  -181,  -221, -1848,
   -5890, -1209,  3620, -5890, -5890,  1190,  -388, -5890, -5890,  -386,
   -3682,  1101, -5890, -5332, -3108,  1196,  -851,  -694, -5890,  -775,
   -5890,  -563,  5939, -2349, -1604, -5890, -5890, -1577, 12853, -5890,
   -5890, -5890, 20720, 21749, -5890, -5890, 24106, 31135, -5890, -1385,
   31846,  9160, -1574, -1563, -1929, 30049, -2620,  -978, -3597, -5890,
   -4489, -3296, -5890, -5890, -5890,  -131,  1253,  -561, -5890, -5368,
   -5890, -5890,   112, -5890,  -569, -5890,  -565, -5890, -5890, -5890,
    -548, -5889,  2943, -5890, -5890, -5890,  -947, -5890, 32783, -3576,
   -5890, -1127, -3603, -3571, -4304, -2577, -5890, -5890, -5890, -5890,
   -5890, -5890, -5890, -1871, -4200,  -649,  2034, -5890, -5890,  2130,
   -5890, -5890, -5890, -1771,  2161, -1177, -3448,  2049, -5890, -1192,
    2952, -1217,  6809,  -864, 26304,  -137, -3099, -1934, -2312, -5890,
    5266, -4610,    -2,  -165,  -939,  6116, -1028, -1050, 16206,  8778,
    7516, -4032, -5890, -5890,   639, -5890, -5890, -5890,  5019,  1451,
   -5890,  4149, -5890,  2324,  3246, -5890, -5890,  2793, -1096,     0,
   -5890,  -514, -5890,  -117, -5890, -5890, -5890,   278, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890, -5890, -5890,  3655, -5890, -5890,
   -1859, -5890, -5890, -5890, -5890, -5890,  5339,  -408, -5890,  4642,
    -407, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890, -5890,
    3664,  2825, -5890,  4380, -5890, -5890, -5890,   -15,  3970, -5890,
   -5890, -5890, -1490,  -687,  4404,  4424,  2797, -5890, -5890, -5890,
   -5890, -5890, -5890, -5890, -5890,  2801, -5890, -5890,  2015, -2720,
    2798, -5890, -5890,  1148, -5890, -5890,   599, -5890,  1153, -5890,
    3839, -5890, -5890, -5890,  1200, -5890, -5890, -5890,  -627, 22708,
     -69,   392,   761,  1701, -5890, 12415, 30327,  -102,  3676,   -65,
   18087, 28726,   -20, -5890,  5321,  2802,  2261, -1233, -5890,   489,
    3132, 20152, -5890, -1228,    53,  5054, -5890,  2307,  -759, -1483,
    4096,  -870, -2531, -5890,  5788, -5890, -4027, -5890, -1230,   155,
    4640, -1523
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,   266,   267,  2305,  3349,  3204,  4227,  4228,   268,
     269,  2301,   270,   271,   272,   273,  2211,   274,  1584,  2468,
    3374,   275,  3019,  1251,  1252,  1253,  2845,  2846,  3284,  2847,
    2834,  1954,  2631,  2233,  1214,  1215,  2192,  2234,   277,   278,
    1948,  2826,   279,   280,   281,  2272,  3175,  2353,  3176,  2273,
    2274,  2205,  2522,  5371,  6159,  4020,  2284,  3162,  4281,  4021,
    4022,  4707,  4708,  4795,  6184,  6185,  6177,  6183,  6178,  6179,
     282,  2369,  2370,   283,   284,  4852,  4186,  4189,  4847,  5747,
    5748,  6002,  1014,  3323,  6005,  6006,  5987,  5988,  6198,  6345,
    6346,  3375,  2460,  4277,  4944,  4218,  5469,  4219,  5470,  4220,
    5471,  4202,  4886,  4887,  5411,  4888,  4221,  5427,  6033,  4222,
    3038,  6215,  3418,  2661,  2659,  6017,  5227,  5228,  6314,  6222,
    6223,  6224,  6454,  5429,  5475,  5476,  6530,  6060,  6385,  6386,
    2454,  4948,  5481,  5817,  3984,  3133,  3988,  2275,  6068,  2276,
    5765,  3899,   286,  2496,  4391,  1138,  3421,  1055,  1139,  3376,
     290,  3411,  6217,  3412,  2326,  3213,  6180,  4362,   291,  1609,
    4674,  5838,  6088,  6089,   292,   993,   293,  2478,   294,   295,
    3344,  4211,   296,  3055,  3916,   297,   298,  3945,  3946,  3947,
     299,  4699,  5681,  2277,  4009,  4010,  4011,  4012,  4733,   300,
    2471,  3383,  3384,   301,   302,   303,   304,  3549,  3550,   305,
    3271,   306,   307,   308,   309,  4773,  5335,  5446,  4060,  4238,
    4916,  5444,   310,  3377,  2486,  3401,  3402,  5456,  5793,  5794,
    5795,  6048,  6376,  5797,  6050,  6244,  6052,  6556,  6557,  5756,
    4653,  5241,   312,  5420,  5421,  2450,   313,  3053,   314,   315,
     316,  2434,  3333,  3334,  4861,  2427,  3325,  3326,  4931,  4932,
     317,  4136,   318,  5311,  5312,  1056,  6236,  6166,  6329,   319,
     320,  5315,  5316,   321,   322,   323,   324,   325,  1122,  1123,
    1124,  1715,  1716,  3869,  1659,   326,  2859,   327,  1539,  1540,
    4166,   328,  1824,  3607,  3608,  5533,   329,  1162,  1746,  1747,
    3378,   331,  1173,  3578,  1175,  2674,  4364,  4365,  5017,   332,
     333,  3546,  3581,   334,  2198,  3029,  3030,  5222,  3379,  1057,
    2502,  3425,  3894,  5927,  5928,  5659,  5941,  3799,  4596,   336,
    1058,  2238,  3103,  1682,  1683,  3428,  4289,  2996,  2997,  2998,
    4965,  2999,  4291,  3000,  2169,  3001,  1626,  1627,  4297,  4298,
    4299,  4961,  4968,  4099,  5827,  5828,   337,  2236,  3101,   338,
     339,   340,  2289,  1449,  1696,  1697,   341,  1080,  1081,   342,
    6009,   343,  1630,   344,  5836,   345,   346,  1203,  1204,  1803,
    1804,   347,   348,  3120,  4710,   349,   350,   351,  4054,  4055,
    5327,   352,   353,  2463,  2464,  3367,  3368,   354,   355,  4101,
    4102,   356,   357,   358,  6479,  6537,  6538,  6539,  4975,  6399,
    6481,  1794,   360,   361,   362,   996,  1489,  1490,  1491,  3380,
    5820,   364,   365,  2193,  2194,  2195,  2196,  3024,   366,   367,
     368,   369,   370,   371,   372,  2439,   373,   374,  5980,   375,
     376,  2397,   377,  1984,  1985,   378,   379,  2003,  1008,  1271,
    1989,  2000,  2001,  1995,   380,   381,  2075,  2895,  1320,  1321,
    1322,  2882,  2891,  2892,   382,   383,   384,   385,  1551,   386,
    4381,  1789,  2618,  3502,   387,   388,   389,   390,   391,   392,
    4382,  5396,   393,   394,   395,   396,  4908,   397,   398,  1141,
    1740,  1741,  1742,  2633,   399,  3503,   400,  4160,  4831,  3289,
     401,  1799,  1542,  1142,  1735,  1143,  2931,  3821,  4608,  4609,
    4610,  4613,  5643,  5196,  1144,  3817,   405,  2681,  3555,  3558,
    3813,   406,  3561,  3562,  1145,  3826,  3827,  3828,  4616,  1146,
    1164,  1619,  3437,  1147,  1903,   411,   412,   413,  1280,  1274,
    1275,  3779,   415,  2803,  3734,  1182,  2079,  1235,  1236,  1327,
    4553,  2899,  2900,  2922,  2923,  2088,  2089,  2912,  2914,  3801,
    2915,  3809,  2905,  5166,  5906,  5907,  5908,  5909,  5910,  5911,
    5617,  2918,  2919,  2091,  2092,  2093,  2927,   416,  3738,  4532,
    4533,  4534,  5142,  5143,  5157,  5153,  5601,  5892,  4535,  1977,
    1978,  1783,  2099,  5609,  6506,  4536,  5881,  5882,  6110,  5161,
    4544,  4604,  4265,  4266,  4267,  4537,  6294,  6295,  6502,  6503,
    6112,  6113,  3002,  2555,  1661,  1904,  1662,  2563,  1905,  2538,
    1664,  1906,  1907,  1908,  1667,  1909,  1910,  1911,  1670,  2530,
    1912,  1913,  2549,  1359,  1360,  1990,  6114,  1915,  1916,  1917,
    4539,  1918,  5096,  5565,  5554,  3666,  3667,  2842,  5092,  4477,
    2798,  3724,  5915,  6132,  6133,  4516,  5121,  5581,  5879,  6286,
    6409,  6410,  1919,  1920,  1921,  3721,  2793,  1452,  1922,  4863,
    2795,  3660,  3746,  3747,  2693,  2720,  3613,  3628,  3629,  3640,
    4436,  3648,  3653,  4464,  4465,  3661,  3690,  1923,  3615,  3616,
    4420,  2722,  1924,  1821,  2710,  2170,  2811,  3685,  1938,  1925,
    1926,  2675,  1262,  5888,   828,   811,  4046,  2712,  1502,  1179,
    1927,  1928,  1929,  2121,   771,  1685,  1686,   773,   812,   813,
    1398,   934,     2,    75,  1148,  4274,   420,   421,  1060,  1061,
    1062,  1611,  1612,  2508,  2511,  2126,  2965,   777,   778,   829,
    5501,  5839,  6091,  1132,   422,   423,   424,   425,  2122,  2961,
    1361,    76,    84,    77,  1362,   462,   463,  2942,   426,   951,
     427,  2102,  1341,  4622,   428,   429,   430,   431,   432,  1127,
     433,  1343,   434,  1344,   435,   436,   437,   438,  1351,   439,
    2104,  2105,  5210,  2106,   440,   441,   815,   816,  1733,   442,
     443,  1378,  1379,  1765,  1766,  2132,  2147,  2148,  2149,   444,
     785,   445,   446,   447,  2138,  2139,   448,  2819,  2820,  2970,
    2821,   449,  3842,  3843,   450,  4570,  4571,  5627,  4572,   451,
    2815,   452,   453,  1264,  4627,   454,   947,   455,  1392,   817,
     818,   819,  1400,   937,  1219,   830,  1402,  4013,   939,   940,
     821,   822,   823,  2653,    78,  3850,  2654,  1931,   831,  1932,
    2809,  1933,  1934,  1935,  1936,  1937,  2155,   825,  1368,  1723,
    1724,  3851,  1726,    82,  1727,   459,  4326,  2621,  1767,  3507,
    2639,  2640
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      74,   403,   414,   404,   407,  1418,  1225,  2325,  1166,   456,
    2094,  2630,  1578,   457,   938,   456,  1261,  1279,  1450,   457,
    1338,  1339,  1059,  1328,  1949,   827,  1451,  1422,  1971,  1621,
    1166,  1774,  1775,  1776,  2658,   833,  3107,  1780,  1458,  2572,
    2374,  2120,   409,  1071,  1939,  1263,   410,   456,  2282,  3226,
    2545,  2714,  1479,  1822,  1979,    79,  3037,  2330,  2387,  2178,
    1431,  4396,  1054,  3115,  2534,  2535,   938,  3104,  3744,  1620,
    4554,  1140,  2475,  1376,  2543,  2544,  1006,  1700,  3178,  3862,
    3864,  1396,  3498,  2551,  3296,  1174,  4048,  1743,  1451,  2703,
    1568,  1712,  1073,  1963,   814,   414,   942,  1194,  3753,   456,
    1582,  4680,  3116,  3136,  1121,   276,  4927,  4602,  4217,  2561,
    2458,  2278,  3570,  4348,  1597,  2394,   994,  2436,  3155,  3645,
    3406,  4242,  1574,  2443,  4245,  4969,  2855,  2488,  2447,  1226,
    5296,   814,  4728,  1492,  4730,  4953,  4545,  4546,  4368,   410,
    4538,  3612,  2465,   938,  2150,  1991,  1380,  1330,   942,  2152,
    4700,  4133,  5485,  1283,  1451,  5188,  5229,  2491,  5230,  1063,
    1070,  4864,  4171,  4871,  4172,  4615,  1738,  4864,  4176,  1070,
    4547,  1165,  5267,  3769,  5447,  3773,   456,  4181,  4182,  4183,
    4387,  3780,  4897,  2949,  2951,  2952,  3786,  5139,  1691,  1709,
    3426,  2451,  1331,  1165,  1621,  5224,  3451,  5108,  3248,  5488,
    1221,  5660,  5023,  1213,  5494,  5426,  3252,  3253,  2324,  5478,
    1221,  5156,  1221,  3752,  1070,  1258,  2523,  2352,  5468,  4538,
    1250,  1277,  4594,  5818,  4485,   942,  5885,  2379,  5484,  3487,
    3789,  1163,  2645,  1278,  1956,  5942,  3290,  3291,  5812,  3293,
    3792,  2612,  3350,  3010,  2239,  2620,  3097,  2553,  2943,  2943,
    5772,  5477,  4754,  1163,  2531,  2532,  1725,  4631,  2087,  1718,
    3861,  4234,  2090,  5202,  5076,  2542,  2235,  6063,  2141,  5154,
    2567,  5159,  6076,  2534,  2535,  4626,  2128,  2129,  5897,  2817,
    5899,  1371,  2574,  2487,  2583,  6069,   465, -2177, -2177, -2177,
   -2177,  2588,  2543,  2544, -2177,  4987,  4442,  2596,   465,  2651,
      45,  5811,  3355,  2604,   465,  1012,  2606,  1615,  2573,  2551,
   -2169, -2169, -2169, -2169,  5949,  2141,  5658, -2169,    45,  2765,
    5982,  5983,  1393,  2207,  2562,   465,  1822,  5851,    37,    38,
      39,    40,  3264,  3763,    43,    44,  1826,  2142,  3259,    45,
      45,  1197,  2519,   403,   414,   404,   407,  6182,  2771,  6238,
      45, -2519, -2519, -2519, -2519,  2519,   465,  5972, -2519,   456,
     465,  2519,   461,   457, -3323, -3323, -3323, -3323,  3470,    43,
    4959, -3323,  2072,  3403,    45,  4333,  2857,  4335,  3683, -3323,
   -3323,  4620,  1329,  3683,   409,  2773,  2519,  3351,   410,  3364,
      37,    38,    39,    40,   456,  2519,  5439,    44,   457,  2714,
   -3324, -3324, -3324, -3324,  2683,  4442,  6165, -3324,  2424,  4156,
    2519, -3321, -3321, -3321, -3321, -3324, -3324,   285, -3321,  2519,
    2679,  4889,  2871,  2519,  1485,  2632, -3321, -3321,  2519,  1416,
    6149,  6150, -3052,  1198,  4681, -3320, -3320, -3320, -3320,  1797,
    3129,  4540, -3320,  1381,  6010,  2208,  3043,   276, -2410,  2432,
   -3320, -3320,  4850,  2531,  2532, -2410,  1763,  4372, -2907, -2907,
   -2907, -2907,  4926,  4374,  1367, -2907,  4868,  6103,  2714, -2133,
   -2133, -2133, -2133, -2907, -2907,  1998, -2133,  3118,  3118,  1942,
    2542, -2149, -2149, -2149, -2149,  3240,  2874,  4207, -2149,  3246,
    3118, -2174, -2174, -2174, -2174,  5440,  2172,  3118, -2174, -2164,
   -2164, -2164, -2164,  3118,  3718,  2622, -2164,  1815,   935,  6397,
   -2429,  3719,  1953,  2242,  4789,  4394,  6489, -2429,  3737,  3118,
    4540,  3910,  6256,    37,    38,    39,    40,  1486,  1564,  5414,
      44,  2387,    37,    38,    39,    40,  5667,  5535,  5536,    44,
    5538,  5539,  5540,  1395,  1339,    37,    38,    39,    40,  6128,
    6491,  4376,    44,   995,  3404,  3198,  2407,  6380,   287,  4925,
     935,    37,    38,    39,    40,  2412,  6124,  3397,    44,   288,
   -2699,  6064,  1487,  1451,  2872,  1332,   289,   465,   779,   311,
      37,    38,    39,    40,  1269,  5441,    43,    44,  3580,  2290,
     330,    45,  3833,  6162,  1199,  2801,  5433,  1059,  4442,  1468,
    1679,  2073,  5791,  6044,  4208,  6242,  3118,  2619,   335,  1752,
    2765,  6360,  3458,  1757,  1758,  1759,   465,  3119,  4630,    37,
      38,    39,    40,  1770,  5792,    43,    44,  1826,  2142,  1469,
      45,  2400,  3849,  2520,  2858,  1488,  3853,   935,  4377,  2771,
    1200,  6243,  1201,   783,  2835,   359,  2520,  -482,  2433,  2848,
    2848,   363,  2520,  4418,  2405,  6572,  1188,  3398,  2448,   402,
    1763, -3052,  1167,  1621,  2433,  1333,  2291,  1374,  1375,  3021,
    2584, -2177, -2177, -2177, -2177,  2731,  2773,  2520, -2177,   408,
    5434,  2209,  5415,  4373,  1167,  1764,  2520,  2131,  2134,  4375,
    6104,  1763,  1621,  4971,  6492,  2804,    35,  6210,  6398,  4851,
    4681,  2520,  5293,  2601,    41,    42,  4864,  3210,  2804,  6442,
    2520,  1382,  6390,  3130,  2520,  3265,  -169,   419,  4676,  2520,
    3764,  6312, -3052,  2143,  3352,  -169,  2760,  4890,  2680,  3405,
    -169,  1417,   129,   130,  1063,  1202,  5329,  3791,  2851,  2852,
    2288,  1365,  5442,  5804,  1819,  3266,  4960,  3684,  1820,  2210,
    2676,  3260,  4505,  2807,  2652,  2433,  2472,  5852,  2137,   285,
    1013,  2546,  4157,  3005,  5438,  1472,  3342,  2163,  1798,  6523,
    2143,  2529,  2695,  1621,  2634,  2759,  2570,  3365,  2433,  6342,
    2074,  3044,  2547,  4972,  1070,  1070,  1372,  2704,  4457,  1160,
    1161,  2521,  4209,  2680,  4646,  2433,  2548,  4753,  3870,  3871,
    2818,  6430,  5598,  5570,  2552,  2765,  5602,  1160,  1161,  5156,
    2566,  2792,  2386,  2715, -2410,  6249,  3800, -2699,  5443, -2169,
    3924,  2873,  1411,  3949,  3247,  5834,  3458,  5234,  2144,  2145,
    1565,  3199,  1367,  3551,  2771,  2582,  4037,  1373,  6464,  1779,
    1999,  3911,  6475,  5256,  2603,  1384,  3534,  1779,  5527,  4790,
    4617,  5544,  2611,  3137,  1189,  4786,  5646,  6069,  1819,  2389,
   -2519,   952,  1820,  2118,  2119,  5299,  5668,  5589,  2569,  5591,
    3720,  2773,  5016, -3323,  3241,  3399, -2429,   936,   456,  1981,
    3221,  1982,   456,  3224,  2802,  1557,   457,  4210, -2699,  1279,
    3400,  2865,  4452,  4453,  4454,  4455,  4456,  4457,  1334,  3082,
     287, -2699,  1680,   784,  6146,  5460, -1908,   953,  1621, -3324,
    3091,   288,  1270,  2569,  1744,  3337,  1621,  1621,   289,  3525,
   -3321,   311,  2199,  6527,  3231,  2363,  3950,   942,  3968,   936,
    4538,  2364,   330,  4538,  6361,  2865,  1543,   414,  1544,  1545,
    4973,  2095,  6069,  4633, -3320,  4634,  5808,  1538,  2830,  2802,
     335,  1617,  1633,  3491,  3285,  6435,  2406,  6413,  3970,  3080,
    3328,  1782,  5506,  5507,  5508,  5509,  5510, -2907,  3977,  6439,
    6004,  3552,  3614,  2936,  3866,  3347,  3796,  1546,  2533,  1811,
    5174,   410,  4677,  6563,  1745,  3463,  1751,   359,  1756,  2714,
    2537,  2109, -1908,   363,  1760,  3211,  5818,  4919,  3214,  3215,
   -2174,   402,  3744,  3744,  3744,     3,   936,  2295, -2164,  4030,
    5399,  6383,   948,  1330,   949,  3533,  4974,  5641,  1751,  4038,
    1756,   408,  4439,  4440,  3543,  2928,  3173,  4459,  3092,  2929,
    6069,  2966,  2762,  4838,  5215,  4574,  2714,  1739,  5856,  1736,
    3751,  2805,  1782,  5400,  2200,  6532,  6533,  2365,  1380,  6069,
    4538,  4970,  1771,  6369,  3758,  3338,  6211,  1325,  1331,   419,
     414,  2130,  4758,  1737,  4489,  4490,  1367,  1074,  1070,  3797,
    5697,  6513,  5835,  2358,  6382,  4839,  4840,  3875,   121,  3179,
    1750,  5625,  1755,  3835,  3100,  3835,  4584,  4454,  4455,  4456,
    4457,  3305,  1769,  4016,  2808, -1908,   125,  2787,  2788,  2789,
    2790,  2791,  2792,  5883,   410,  1278,  2058,  6055,  2917,  5752,
    3535,  3897,  1785,  2098,  1788,  3515,  3097,  2359,  5435,  2144,
    2145,  3518,  3925,  3180,    74,  1133,  3093,  2612,  6545,  2296,
    2867,  1732,  3508,  5818,  5499,  1070,  3226,  3181,  4163,  4589,
    6582,  5753,  6465,   465,  4117,  2546,  1134,  1165,  1965,  1165,
    4118,  1165,  4017,  5230,   997,  3448,  3449,  1165,  1761,  1762,
    3469, -1908,  1983,  5200,  3472,  5229,  2547,  5230,  3898,  1325,
    1986,  1352,  3479,  3138,  3553,  3348,  3500,  2311,  2133,    79,
    2550,  1165,  4131,  1165,  4759,  3139,  1135,  3140,  3867,  3490,
    3868,  2303,  5328,  1763,  2557,   456,  2214,  3554,  4231,  1980,
    3675,  2312,  2635,  2201,  3481,  2637,  2366,  1485,  2641,  1749,
    2643,  1754,  4279,  2646,  2304, -2516,  5453,  2650,  6212,  -169,
    -169,  2479,  1221, -1911,  3940,  1946,  1221,  4618,  1154,  2384,
    1992,  4540,  1952,  6086,  4540,  1772,  1960,  5642,  1367,  1154,
     814,  1784,  2590,  1787,  4018,  3311,  2202,  5861,  1329,  2367,
    3567,  1353,  1155,  2313,  3141,  3031,  5889,  4290,  2557,  2110,
    3004,  5893,  6254,  1155,  5895,  2480,  4119,  5818,  5725,  3191,
    5886, -2645,  3529,  4551,  1353,  4862,    35,  6026, -1908,  3415,
    2203,  4862, -2680,  2368,    41,    42,  2591,  6230,  2297,  3312,
    1764,  2360,  5726,  3883,  2789,  2790,  2791,  2792,   465,  2059,
    3941,    37,    38,    39,    40,  3416,  5818,    43,    44, -1911,
    1486,  1354,    45,  5800,  1355,  3354, -1908,  6263,  6261, -1908,
    6251,   950,  4969,    37,    38,    39,    40,  3031,  4538,  6229,
      44,  2298,  3182,  6027,  1354,  5230,  4027,  2558,  1353,   935,
    2060,  3033,  6028,  4760,  1154,  1451,  2314,  3032,  5849,  6260,
    1975,  4540,  6277,  2204,  1075,  1487,  1165,  6470,  6471,  3419,
    3034,  2061,  6250,  5308,  3940,  2299,   998,  5464,  1155,   217,
    3183,  4068,  6029,    35,   465,  2146,  4966,    37,    38,    39,
      40,    41,    42,    43,    44,  5167,  4761, -2701,    45,  2545,
    3506,  3045,  5682,  5465,  2315,  1966,  4044,  2316,  1354,   229,
    4132,  2558,  5653,  4904,  1197,  2361,  3445,  1764,  3225,  5354,
    1323,  2123, -1911,  3033,  2207,  1076,  2385,  2390,  1488,  4581,
    4762,  6087,  1377,  4019,   943,  4120,  1165,  1356,  4668,   999,
    2153,  4069,  3034,  1819,   944,  6070,  3703,  1820,  2191,  2481,
    3941,   237,  1406,  6071,  2318,  3415,  6030,  3767,  1221,  1221,
    1356,  1213,  2345,  3540,  3541,  6391,  1233,  6031,  5424,  1077,
    2592,  1078,  1007,  3313,  3039,  3530,  1967,  2903,  4121,  6172,
    6519,  3416,  4669,  5309,  2824,  1324,  1962,  5948, -1911,  1811,
     952,  2123,  5971,   249,  6144,  6450,  2391,  2483,  3944,  4070,
    6141,  3040,  3818,  2320,  3040,  2528,  1198,   252,  6565,  2832,
   -2645,  4704,  4122,   464,  5423,  3417,  3531,  3035,  5304,  1282,
    2484, -2680,   832,   465,  1356,  2321,    37,    38,    39,    40,
     264,  1407,    43,    44,  3286, -2133,   953,    45,  3189,  2950,
    5280,  2949,  6252,  6403,   265,  5813,  2208,  3154,  2323,  1154,
    3466,  3046,   945,  1976,  5645,  1357,  4028,  2506,  4538,  2825,
    1325,  6120,  4538,  2482,  5814,  6173,  6098,  3480,  6174,  5614,
    5727, -2645,  2904,  1155,  1358,  1234,  5269,  5767,  2559,  3486,
    6389,  5945, -2680,  4905,  2593,  2433,  1743,  3314,  6175,  3035,
    2760,  3725, -2737,  3704,  5355,  5310,  2473,  2560,  3705,  6473,
    3609,  3611,  4071,  5466,  6476, -1911,  5174,  3618,  3216,  1648,
      35,  6218,  5621,  3632,  3633,  3634,  3465,  2569,    41,    42,
    3447, -2133,  2569,  3650,  3652,  6072, -2701,  3940,  3662,  5883,
    1000,  2833,  5530,  3761,  3706,  6520,  3036,  3478,  3944,  4540,
    2068,  2336,  2559, -1911,  1451,  1451, -1911,  3047,  1167,  5418,
    1167,  5270,  1167,  3838,  3041,  1356,  4670,  3440,  1167,  6309,
    6449,  5230,  5028,  6032,  1279,  3511,  6164,  1199,  5425,  2392,
    5955,  6168,  6169,  6525,  4864,  1605,  3485,  6142,   414,  3190,
    6015,  5787,  1167,  3819,  1167,  2337,  2636, -2701,  2638,  2485,
    5454,  2642,  4874,  2644,  6172,  -756,  2647,  2648,  2649,  2338,
    6451,  3885,   946,  3941,  5768,  2182,  1326,  5388,  3036,  2656,
    4701,  5391,  5392,  1200,  5394,  1201,  3501,  6474,   936,  3810,
    6316,  6317,   410,  2682,  3638,  4045,  2684,  3464,  2713,    74,
      74,  4072,    74,  1001,  4845,  4846,  6564,  3726,  6219,  5815,
    3942,  4073,  4877,  6161,  4074,  6176,  5313,  1002,  5409,  3217,
    1165,  3493,  3218,  3361,   229,  1007,  4127,  2150,  1434,  2981,
    1339,   456,  2152,  4083,  2183,  1435,  1436,  1437,  6043,  3025,
    4671,  3646,  6580,  2863,  6387,  1009,  6584,  5410,  1010,  3664,
    3026,  2069,  3707,  3943,    79,    79,  6452,    79,  3811,  5146,
    4128,  4029,  1003,  3886,  2947, -2133,   237,  4126,  3027,  1004,
    1451,  4692,  2077,  6175,  4879,  2123,  3049,  1732,  2719,  3532,
     942,  2118,  2119,  3537,  6453,  3539,  5029,  3226,  3542,  6220,
    3050, -2737,  2897,  2898,  3744,  2902,  2708,  4693,  3536,  4330,
    4862,  2728,  4702,  5056,  5057,  5058,  5059,  5459,   249,  5064,
    5065,  5066,  5067,  5068,  5069,  5070,  5071,  5072,  5073,  5042,
    3954,  6562,   252,  6147,  2948,  2339,  5314,  1167,  1606,  4540,
    5326,  2184,  6152,  4540,  3966,  2744,  3163,  1331,  1331,  5147,
    1331,   779,   779,  2569,  3893,   264,  2151,  3362,  2946,  1128,
    2757,  3372, -2737,  1345,   952,  2098,  2906,  2118,  2119,  3820,
    6581,  3944,  5758,  1778,  2340,  5112,  5113,  4882,  2341,  2513,
    6237,  5148,  3812,  1346,  5182,  4694,  4084,  2263,  5511,  5185,
    5512,  2078,    35,  1347,  4087,  5230,  5149,  4090,  2327,  3020,
      41,    42,  1485,  1607,  4579,  2907,  5150,  1167,  2840,  1608,
     953, -1166,  2342,    35,  4256,  4257,  4258,  4259,  1227,  2822,
    2823,    41,    42,  6012,  4883,  1380,  4264,  3164,  3955,  4058,
    2303,  3028,  5151,  5548,   814,   814,  1265,  2514,  2947,  5549,
    6176,  2328,  4884,  4791,  4082,  2955,  6583,  3373,  2956,  1165,
    1356,  3783,  3501,  2304,  1165,  1165,  3051,  2841,  1779,  3085,
    2263,  3125,  5003,  3126,  1621,  4494,    37,    38,    39,    40,
    6387,  4495,  2908,    44,  1966,  4061,  4062, -2133,  4107,  4065,
    5663,  6510,  1021,  6607,  6085,  4538, -2133,  2182,  2533, -2133,
    2177, -2133,  4538,  4250,  5184,  6233,  4496,  4538,  2948,  3052,
    4538,  1348,  1181,  5855,  2123,  1486,  2118,  2119,  4059,  2123,
    2123,  4151,  6247,  2188,  4874,  2189,  5412,  4308,  4703,  4704,
    4592,  4875,  2513,  2909,   952,  4314,  5152,   456,   456,   456,
    3127,  4123,   457,   457,  4876,  4538,  4873,  1329,  1329,  6499,
    1329,  2515,  4329,  4885,    35,  1967,  2183,  1177,  4705,  4538,
    1487,  6275,    41,    42,  3086,  4336,  2329,  2083,  1811,  2083,
    4337,  2957,  2084,  4339,  4877,  2713,  4878,  6156,  3963,  4343,
     953,  4344,  1191,  4346,  4124,  1028,  3131,  1349,   456,  5550,
    3510,  4969,   457,  5664,  5956,   456,  4145,  2910,  2906,  2985,
    1195,  5413,  2364,  2516,  3926,  3547,  5981, -1160,   456,  4787,
    2963,  3930,  2300,  6395,  2954,  4497,  1761,  1762,  4125,  1451,
    1028,  4498,  6153,  1488,  1356,   814,  3243,  3691,  2388,  5846,
    4949,  1940,  5931,  3692,  5933,  2969,  4879,  2907,  2085,  3993,
    2085,  5853,  2976,  2978,  1032, -1920,  5147,  5671,  5672,  3075,
    3995,  6081,  3571,  2184,  5297,  4606,  4240,   942,  3693, -1920,
    4652,  1350,  2083,  4880, -1920,  3897,  3962,  1221,  5665,  4398,
    5762,  2958,  2959,  1232,    37,    38,    39,    40,  5148,  1032,
    5060,    44,  2086,  3918,  2086,  5771,  5061,  4788,  3668,  5779,
    3548,  3671,  4607,  5604,  2515,  4246,  4577,  2977,  2979,  6500,
    6371,  5786,  1941,  5150,  6501,  2517,  3994,  1079,  5217,  1221,
   -1920,  2185,   935,  2389,  1165, -1960,  3847,  3996,  2365,  6472,
   -1960,  4361,  4649,   229,  4881,  1165,  5803,  4538,  5978,  4882,
   -1920,  1167,  5298,  2085,  1440,  1441,  1442,  2569,  1443,  1444,
    1445,  1446,  1447,  1448,  6270,  2433,  2516,  5742,  5830,  5743,
    5744,  5979,  4582,  5745,  2186,  2909, -2540,  5408,   220,  4793,
    -192,  4253,  3694,  4587,  4067,   237,  5237,  3695,  2389,  2123,
    5773,  2765,  4499,  3696, -1920,  -507,  4883,   465,  3216,  1028,
    2123,  5146,  4500,  4284,  4075, -1920, -1960,  3132,  2187,  4261,
    -192,    45,  3463,  2354,  4884,  4262,  4540,  4538,  6326,    37,
      38,    39,    40,  4540,  6534,  1196,    44,   249,  4540,    81,
    1165,  4540,  4794,  1165,  1165,  5062,  5774,  4311,  5189,  2910,
    1046,  1598,  1047,  5152,  1598,  2188,  5063,  2189,  2191,  6319,
   -1960,  3335,  1049,  2191,  4148,  6240,  2355,  2773,  1032,  5235,
    2356,  3145,  1828,  1051,  6461,  4442,  4540,  2459,  2517,  4443,
    4444,  4445,  1323,  5238,  4075,  1046,  1599,  1047,   265,  1599,
    4540,  5147,  6046,  2546,   456,  2123, -1961,  1259,  2123,  2123,
    2357, -1961,  5990,  6327,  3146,  2765,  1272,  5237,  2190,  5190,
    2303,  1621,  2459,  4164,  2547,   458,  6567,  5954,  2074,  3442,
    3156,   458,  6579,  5148,  5218,  4885,   782,  1600,  2191,  -507,
    4921,  5219,  2191,  2304,  2771,  3145,  1165,  6203,  5149,  5935,
    5239,  6592,  6204,   942,  5240,  6047,  5944,  1324,  5150,  3217,
    5991,  4302,  3218,   458,  3697,  3744,  4552,  6522,  6213,  5279,
    3744, -1920,  3788,  5985,  3698,  2065,  3744, -1961,  3146,  1621,
    3343,  2773,  5220,  2848,  5151,  1601,  5992,  4538,  1601,  3157,
    1167,  3229,  3768,  1339,  4129,  1167,  1167,  6308,  5626,  3556,
    4738,  2123, -2649,  5221,  5238,   220,  1065,  6205,  5993,  5890,
    5978,  1268,  5994,  4739,  1028,   458,  2066,  1828,   954,  4342,
    4442, -1961,  1154,  3545,  4443,  4444,  4445,  3577,  4130,  4655,
    6555,  6432,  1325,  5979,  5995,  3201,  1819,  5996,   935,  1996,
    1820,  5101,   229,  1011,  2308, -2649,  1155, -2649,  3433,  4632,
    2389,  4538,  5997,  3279,  1046,  5265,  1047,  4441,  1125,  2165,
    2179,  5239,  4928,  2569,  4583,  5240,  1739,  1222,  4540,  4469,
    2333,  5257,  4938,  1032,  4543,  3446,  4446,  1222,  5152,  1222,
    4682,  2459,  -649,  4538,   237,  2173,  3454,  2309,  3455,   414,
    3785,  1281,   458,  5271,  3459,  5278,  3280,  4447,  3462,  3158,
    5638,  4492,  2166,  2180,  3513,  5051,  3514,  4709,  5461,   935,
    3516,  1335,  3517,  2334,  1228,  3519,  4165,  4617,  4717,  3520,
    4719,   936,  1828,  4755,  2174,  4442,   249,  3159,  2175, -3325,
   -3325, -3325,  5300,   410,  5077,  5998,  2167,  2181,  4540,  4518,
     252,  5986,  4575,  1342,  4098,  5999,  6284,  2335,    74,  3576,
    3118,    74,  3160,  5015,  3161, -3116,   779,  1543,   414,  1544,
    1545,  3135,  2176,   264,  4448,  2764,  4756,  1958,  2765,  3202,
    4784,   229,  5891,  4406,  3205,  3369,  6285,   265,  1326,    37,
      38,    39,    40,  5487,  4785,  4872,    44,  4741,     8,  3154,
    6000,  4262,  2828,  5016,  3606, -2780,  4538,  2771,  1546, -2821,
    4757,  3408,   410,    79,  3646,  3646,    79, -3325,  3681,  3646,
    5031,  4360,  4555,   237, -2840,  4556,  4557,  4503,  5647,  -413,
    6568,  6038,  6001,  6569,  3563,  3563,  4558,  4559,  4560,  6552,
    4561,  4562,  4447,  4685,  2773,  4563,  4564,  4565, -2780,  3269,
   -2780,   456, -2821,  3275, -2821,  1167,  3646,  3646,  -413,  1046,
    1621,  1047,  1377,  4402,  3751,   249,  1167, -2840,  2489, -2840,
    1566,  4813,  1567,  2764,  3620,  3621,  2765,  4820,  4869,   252,
    3777,  3635,  3636,  2546,  4924,   458,  1052,  2813,  1731,   465,
    3802,  2490,  2814,  3689,  4984,  4985,  6508,  3281,  4540,  3778,
     942,  5683,   264,  1451,  2547,  2771,  5826,  5687,  2598,  4448,
    3674,  3282,  1986,  4352,  4891, -3325,   265,  5356,  2548,  4491,
     458,  1383,    37,    38,    39,    40,    35,  1394,  4862,    44,
    4746,  2599,  2546,  1412,    41,    42,  5373,  5978,  4290,  3283,
    5357,   456,  2773,  6429,  6536,   457,  1424,  4538,  2303,  2764,
    5472,  1167,  2765,  2547,  1167,  1167,  2766,  2767,  2768,  5374,
    5979,  3887,  4540,  3890, -3325,  1414,  2969,  2550,  6200, -3325,
    6202,  2304,  2306,  4892,  6206,   935,  6207,  1428,  4449,  4450,
    4451,  2771,  4452,  4453,  4454,  4455,  4456,  4457,  -413,  -413,
    2371,  2772,    43,  2375,  4540,    35,   465,    45,  1429,  3751,
    1385,  4593,  4566,    41,    42, -3325,  3948,  4638,  4639,  3884,
      45,  1474,  1386,  1387,  4448,  1621,  1819,  4502,  2773,  2311,
    1820,  3458,  4538,   456,  6241,   456,  4860,   457,  4621,   457,
    3880,  1388,  4860,  1433,  1389,    37,    38,    39,    40,  1571,
    2613,  1572,    44,  2312,  2614,  3822,    45,  1167,  1483,   410,
    2613,  1484,  6594,  1165,  3497,  4659,  1494,  2780,  6077,  2713,
    5232,  5233, -3325,  2540,  2541,  4637,  4776, -3325,  4995,  4996,
    2533,  4998,  3011,  5000,  1819,  1495, -2519,  5858,  1820,  1496,
    5004,  4989,  4990,  4991,  4992,  4993,  4414,  2452,   936,  2453,
    2865,  5504,   456,  3807,  3808,  2313,  4989,  4990,  4991,  4992,
    4993,  2939,  2940, -3325,  4994,   129,   130,  4540,  1165,  2533,
    3744,  2177,  4415,  4449,  4450,  4451,  4416,  4452,  4453,  4454,
    4455,  4456,  4457,  1782,  1782,  1367,  1996,  1782,  2146, -1908,
      74,  3156,    74,  1497,  5032,  5214,  1556,  2718,  2774,   265,
    2533,   942,  3011,  2775,    37,    38,    39,    40,  2625,  4567,
    2626,    44,  1498, -3325,  5279,  2780,  4468,  1499,  4470,  4471,
   -1984, -1984,  1390,  2123,  2776,  2777,  5274,  6396,  2252,  2253,
    2254,  1500,  1165,  1133,  4641,  6477,   202,  1558,  2697,  2778,
    2698,  4771,  2861,  2153,  2862,    79,  1548,    79,  2314,  1560,
    3157,  1065,  2939,  3831,  1134,  4779,  4991,  4992,  4993,  5532,
    1575,  2864,  4023,  2865,  1569,  3463,  2869,  4568,  2870,  1391,
    3435,  1570,  3436,  4066,  2779,  2533,  1553,  3011, -3325, -3325,
   -3325,  1579,  4452,  4453,  4454,  4455,  4456,  4457,  1588,  1221,
     456,  2780,  5680,  1593,  1135,   456,  2315,  -648,  4056,  2316,
    5038,  4519,  3505,  4520,  2865,  4549,  4550,  4913,  4540,  3223,
    3225, -3325, -2137, -2137, -2137, -2137, -1211, -1211, -3325, -2137,
    1602,  3526,  3971,  3527,  1603,  2787,  2788,  2789,  2790,  2791,
    2792,   456,  4714,  3528,  1610,  3527,   229,  1604,  3568,   942,
    3569,  3776,  2764,  2389,   942,  2765,  2318,  1613,  4103, -3325,
   -3325, -3325,  1624,  2387,  1782,  3830,   465,  2865,    35,  4521,
    3158,  4522,    37,    38,    39,    40,    41,    42,  1621,    44,
    1621,  5019,   935,  3960,  2771,  3961,  1629,  4050,   237,  4051,
     942,   456,  1678,  4540,  2772,  4569,  1687,  2782,  3159,  1689,
    4191,  1221,  4192,  4161,  4162,  2320, -2139, -2139, -2139, -2139,
    4197,  1688,  4198, -2139,   936,  4903,  1698,  4906,  4894,  1692,
    4896,  2773,  4312,  3160,  2865,  3161, -3325,  2321,  4832,  4833,
     249,  1165,  1701,  2787,  2788,  2789,  2790,  2791,  2792,  1165,
     942,  4349,  1165,  4350,   252,  5168,  5169,  5170,  1713,  4354,
    2323,  3527,  4383,  2764,  4384,  4385,  2765,  4384,  4203,  6097,
    3154,  1126,  4413,  1621,  2865,  1706,  4593,   264, -2142, -2142,
   -2142, -2142,  4593,  1730,   458, -2142,  1777,  4422,   458,  2865,
    1729,  6478,  1405,  1734,  5272,  2771,  2123,   217,  3622,  5810,
      45,   456,  1405,   782,  2123, -3325,  1773,  2123,  4247,  4428,
    1781,  2865,  2783,  4963,   782,  2784,  2785,  2786,  1786,  2787,
    2788,  2789,  2790,  2791,  2792,  1791,  2215,   229,   782,  1792,
    1793,  4429,  2773,  2865,  1800,  4430,  4310,  2865,  1795,  1801,
    1828,  5053,  4461,  4442,  2865,  1802,  1808,  4443,  4444,  4445,
     942,  2774,  4474,  1405,  2865,  5253,  2775,  1810, -2147, -2147,
   -2147, -2147,  1809,  2216,  5102, -2147,   782,  1811,  4479,   237,
    4480,  4731,  5826,  4732,  1812,  5082,   782,  1828,  3623,  4736,
    4442,  4737,  1813,  1817,  4443,  4444,  4445,  4766,  1814,  4767,
     782,  4957,  2778,  4958,  1818,  5163,  5030, -2135, -2135, -2135,
   -2135,  5573,  1825,  4982, -2135,  2865,  5083,  5111,  5084,  1618,
    5093,   249,  5094,  1823,  4251,  1136,   782,  5104,  1961,  2865,
    5124,  1405,  2714,  1968,  1167,   252,  1279,  1677,  1964,  1988,
    2218,  1405,   782,   935,  5198,  1969,  5199,  5395,  3624,  1970,
    1993,  3625,   782,  5203,  2780,  5204,  5379,  5213,   264,  3868,
    1994,  4860, -3325,  2005,  1996,  1677,   782, -3325,  2311,  3751,
    2022,  1997,  1137,    81,  5236,  2219,  3527,  2039,  1828,  5007,
    1279,  4442,  2040,  2062,   782,  4443,  4444,  4445,  5284,  1167,
    2389,  5325,  2312,   779,  2057,  4320,  4323, -2138, -2138, -2138,
   -2138,  2076,  5574, -3325, -2138,  3646,  3646,  3646,  3646,  2151,
    2220,  3646,  3646,  3646,  3646,  3646,  3646,  3646,  3646,  3646,
    3646, -2136, -2136, -2136, -2136,  2081,  2063,  2764, -2136,  2064,
    2765,  6290,  5401,  5566,  5402,  5012,  2067,  5462,  5086,  3527,
    5523,  5545,  2680,  2865,  2313,  5571,  2221,  3569,  2097,  5583,
    2782,  2865,  5649,  1167,  3868,  2780,  5655,  2070,  5656,  2771,
    2071,  5661,  1367,  3527,  3626,  4447,  2096,  3646,  3646, -3325,
    5603,   936,  5606,  4524,  4525,  4526,  1165,  2100,  2103,    35,
    2223,   935,  1405,  1405,  2101,  2107,   935,    41,    42,  1222,
    5662,   782,  3527,  1222,  2108,  5692,  2773,  2389,  5693,  2111,
    2389,  4475,  4447,  2116,  2124,  2224,  5516,  4482,  4223,  2112,
    2113,   458,  1279,  5749,  5785,  5750,  5750,  1987,  5805,  1405,
    5806,  5863,   935,  5864,  2114,  3156,   220,  5528,  3098,  5513,
    2226,  2123,  4448,  5515,   456,  2115,  2117,  2314,  2227,  5865,
     456,  2865,  5873,  5950,  3569,  5951,  6065,  2228,  6039,  2127,
    3527, -3325,  2757,  2125,  2156,  2783,  3099,  2157, -3325, -3325,
   -3325,  2168,  2787,  2788,  2789,  2790,  2791,  2792,  2159,  4448,
    2230,  5114,   935,  6078,  4068,  6079,  6099,  2212,  3569,  2231,
    2171,  2177,  3627,   942,  3157,  2315,  2240,  2237,  2316,   942,
    6107,  2243,  6108,  4447,  2244,  6117,  2757,  2389,  6123,  3225,
    4935,  2292, -3322,  5472,  6125,  6139,  4935,  6140,  6193,  6232,
    6194,  2827,  6262,  3689,  6140,  6278, -3325,  3569,  2283,   782,
     782, -3325,  6279,  6280,  4480,  2865,  6291,  2288,  6292,  4512,
    6297,  6300,  2389,  4935,  4069,  2318,  5520,  2293,  2294,  5781,
    2232,  2300,  1167,  3249,  6325,  4531,  3569,  6331,  2302,  3569,
    1167,  2307,  6332,  1167,  3569,  2310, -3325, -3325,  2197,  6335,
    4448,  6336,  2332,  2787,  2788,  2789,  2790,  2791,  2792,  6337,
    2346,  6338,   935,  2347,  6339,  6368,  6340,  3352,  6404,  6417,
    5750,  6418,  2362,  6421,  2320,  2389,  6422,  4224,  2865,  6423,
    2372,  2865,  4070,  2969,  3158,  6425,  4576,  2865,  1165,  6445,
    6468,  6446,  6469,  6488,  2373,  5750,  2321,  2376,  6495,  2780,
    4935,  6507,   936,  6131,  2383,  1222,  1222,  6535,  6575,  6140,
    6336,  6577,  3159,  6578,  4531,  6597,  2381,  6418,  1278,  2323,
    6606,  4593,  6578,  2382,  2393,  2395,  4449,  4450,  4451,  2398,
    4452,  4453,  4454,  4455,  4456,  4457,  2396,  3160,  2080,  3161,
    2082,  2399,  1405,  2123,  2401,  2404,  2408,  2409,   202,  1677,
    2415,  4593,  3156,  1405,  2416,  2419,  2422,  2423,  2426,  2429,
    5669,  2431,  2437,  4449,  4450,  4451,  2438,  4452,  4453,  4454,
    4455,  4456,  4457,  1677,  3154,  3156,  2441,  2442,  2444,  5283,
    2449,  5285,  2433,  2461,  3156,  4071,  2462,  2466,  6255,  1828,
    1677,  2467,  4442,  -212,  2469, -3325,  4443,  4444,  4445,  2470,
    2474,  2476,  2477,  2501,  5694,  5695,  5431,  5432,  2492,  6546,
    1828,  3157,  2499,  4442,  6549,  2505,  6293,  4443,  4444,  4445,
     975,  5384,  2510,  2518,  2524,  3156,  2525,  2529,  2526,  3646,
    2536,  2539,  4225,  2533,  3157,  2537,  2556,  2554,  2565,  2564,
     936,  2568,  1405,  3157,  2569,   936,  2581,  2585,   229,  2586,
    2587,  2589,  2594,  5385,  4449,  4450,  4451,  2595,  4452,  4453,
    4454,  4455,  4456,  4457,  3156,  2597,  2602,   456,   456,   456,
    3278,  2605,  4103,  2607,  2608,  2623,  2617,  2657,  2685,  2686,
    2687,   936,  2694,  2699,  3157,  5686,  4226,  5555,  2701,  1828,
     237,  1677,  4442,  3951,  5738,  5739,  4443,  4444,  4445,  2702,
   -3325,  2705,  4039,  2717,  2716,   456,  2723,  2787,  2788,  2789,
    2790,  2791,  2792,  2023,  4072,  2724,   942,   942,   942,  2725,
    2799,  3158,  2726,  3157,  4073,  2727,   265,  4074,  2729,  2730,
    2731,   936,   249,  5636,  2732,   782,  2797,  2733,  2734,  2736,
    2737,  2738,  2739,  4783,  3158,  2740,   252,  2741,  2742,  3159,
     782,  2743,  4829,  3158,   942,  2745,  2746,  1167,    81,    81,
    2747,    81,  2024,  2748,  2749,  2801,  2750,  2751,  2831,   264,
    2752,  1405,  3159,  6381,  3160,  2843,  3161,  1763,  2802,   782,
    2025,  3159,  4792,   265, -1479,   935,  2856, -1479,  2827,  2853,
    1975,   935,  2860,  2868,  3158,  2875,  4956,  3160,  2877,  3161,
    2876,  2878,  2879,  2880,  4447,  2026,  3160,  2881,  3161,  2894,
    2084,  3154,  2086,  3226,  2924,   782,  2926,  2935,  2938,  1356,
    5841,  2945,  3159,  2962,  2953,  4447,  3335,  2964,  2973,  5843,
    5844,   936,  2960,  3158,  3154,  1677,  2975,   782,  2972,  2980,
    2986,  2982, -3268,  3154,  2987,  3006,  2984,  3160,  5854,  3161,
    2988,  2027,   782,  3007,  5118,  3008,  1405,   458,  3009,   456,
     782,  3159,  3011,  3012,  3013,  3014,  3015,  3156,  2028,  3016,
    3017,  4448,  3023,  1405,  3048,  5517,  5518,  5519,  3042,  1782,
    2764,  3077,  4103,  2765,  3154,  3054,  3160,  3084,  3161,  5594,
    3087,  3156,  4448,  3081,  5634,  3083,  3090,  1059,  3089,  3105,
    3106,  3121,  3108,  1405, -3325,  3122,  3123,  6466,   942,  3124,
    3128,  3142,  2771,  3147,  3143,   456,  3149,  3151,  3150,  3152,
    4980,  1165, -3325,  3154,  3153,  3154,  3157,  1165,  3165,  3167,
    3168,  3169,  3166,  3188,  4893,  1405,  1405,  1405,  3174,  1405,
    3200,  3194,  3212,  3196,  3195,  3184,  3185,  3197,  3203,  2773,
    3157,  2796,  3219,  3222,  4907,  2263,  3235,  2029,  3207,  1405,
    3242,  3208,  3220,  5678,   942,  3227,  2030,  3228,  4942,  3244,
    1451,  4448,   410,  2031,  3238,  3232,  2123,  4952,  3245,  1167,
    3233,   410,  2123,  2032,  3234,  4825,  3237,  3239,  6197,  6526,
    3250,  3261,  3262,  1279,  3267,   782,  3251,  3263,  2838,  3273,
    3288,  4979,  3277,   782,   782,   410,  3294,  3301,  5763,  5258,
    3268,  3299,  1279,  3302,  2033,  3303,  3304,  2034,  3308,  3309,
    3317,  3310,  3316,  3318,  5901,  3319,  3320,  3322,  3324,  3330,
    2035,  5916,  3321,  3156,  3331,  2036,  3158,  1070,  3336,  3329,
    3340,  3341,  3346,  4983,  3356,  3358,  5721,  3357,  3353,  2037,
    4323,  5126,  5127,  5128,  5129,  5790,  3366,  3370,  2329,  3360,
    3158,  6187,  2038,  6189,  3159,  3381,  3385,  3386,  3387, -3325,
    3388,  3407,  3396,  3410, -3325,  4449,  4450,  4451,  3391,  4452,
    4453,  4454,  4455,  4456,  4457,  3413,  3414,  3423,  3159,  3160,
    3427,  3161,  3157,  3429,  3432,  3431,  4449,  4450,  4451,  3438,
    4452,  4453,  4454,  4455,  4456,  4457,  5088,  3443,  3444,  4860,
   -3325,  3450,  3563,  3160,  3452,  3161,  3453,  3457,  1405,  3468,
    3458,  3460,  1405,  1405,  3461,  6037,  3154,  3471,   935,   935,
     935,  3473,  3474,  3475,  3476,  1165,  3506,  1405,  3488,   456,
    3489,  3499,  3522,   458,   458,   458,  3523,  5783,  3538,  3544,
    3154,  5301,  3557,  3559,   936,  3560,  3566,  3579,  3582,  3584,
     936,  3586,  2780,  3614,   782,  3619,   935,  2765,  3663,  3669,
    3673,  3682,  3688,  6096,  5740,  4449,  4450,  4451,  3722,  4452,
    4453,  4454,  4455,  4456,  4457,  3700,  3702,  3723,   942,  3737,
    2123,  3755,  3757,  3754,   458,  6344,  6350,  6352,  3760,  3765,
    3762,   458,  3158,  2764,  3766,  1677,  2765,  3785,  3787,  2757,
    2074,  3790,  3793,  3794,   458,  1324,  3803,  3795,  3805,  5728,
    5729,  3806,  5731,  3816,  1222,  5133,  3804,  2197,  5138,  3823,
    3159,  2197,  3840,  3837,  3839,  2771,  2817,  3857,  3858,  1543,
     414,  1544,  1545,  3888,  3860, -3325,  3891,  3895,  3912,  3893,
    3896,  6145,  3919,  3917,  3913,  3160,  3902,  3161, -3325,  3907,
    3915,  3923,  3935,  3936,  3939,  3952,  1222,  3927,  3953,  3958,
    1958,  1962,  2773,  3969,  1677,  3978,  3979,  3986,  3987,  3997,
    1546,  4003,  4004,  4024,   410,  4033,  4026,  4034,  6035,  6106,
    4041,  3134,  3154,  4036,  4040,  6208,  4043,  4049,  4077,  3646,
    4057,  4135,  4147,  6192,  4098,  4158,  2389,  4154,  5866,  4159,
    5505,  1339,  4155,  4168,  3788,  4173,  4179,  4174,  4184,  4185,
     935,  4187,  4188,  4175,  4190,  1677,  4193,  4201,  4205,  4206,
    4214,  4215,  4199,  4229,  4230,  4233,  4237,  4235,  4239,  5336,
    4241,  6447,  4249,  4254,  4260,  4268,  4263,  5115,  1677,  5208,
    4269,  4270,  4271,  4272,  4276,  4273,  4282,  4283,  4280,  4286,
    4301,  4287,  4300, -3325,  5938,  4023,  6160,  5294,  4305,  4306,
    2787,  2788,  2789,  2790,  2791,  2792,   935,  4304,  4307,  4309,
    4316,  4317,  2956,  4338,  4340,  6234,  4341,  4345,  4347,  4356,
    4315,  4313, -3325,   456,  4359,  4056,  4367, -3325,   456,  4357,
     456,  5957,  6199,  4318,  4319,  4358,  3580,  4327,  4328,   782,
    4369,  2603,  1167,  4103,  2566,  4371,  5962,  4378,  1167,  4370,
    4379,  5382,  4386,  4390,  4395,  1779,  4397,  4399,   456,  4407,
    4405,  4410,  4404, -3325,  4427,  4424,  4408,  4425,  1677,  4426,
    1451,  4431,   942,  4432,  4434,  6344,   456,   942,  4437,   942,
    4438, -2402,  4460,  1677,  4466,  2865,  4473,  4476,  4493,  4487,
    4488,  4501,  4510,  3327,  4515,  4585,  1165,  6101,  4511,  4513,
     458,  4514,  4517,  2197,  4543,  4595,  1677,   942,  5961,  4593,
    4599,  4601,  4605,  4548,  5963,  2780,  4350,  4612,  4635,  4603,
    6359,  4619,  1451,  4586,  4640,   942,  1165,   936,   936,   936,
    4623,  4625,  1165,  4624,   782,  4628,  4642,  4643,  2759,  4651,
    4654,  4689,  4663,  4691,   782,  4696,  4656,  4697,  4678,  4647,
    2613,  2123,  6007,  4679,  4695,  4629,   782,  4716,  4698,  4712,
    4718,  4648,  4713,  4727,  4715,   936,  4724,  4725,  4103,  4726,
    4735,  4740,  1677,  4747,  4751,  4768,  4770,  4772,  4774,  4775,
    2680,  2123,  4798,  4778,  4780,  1405,  4799,  4781,  1405,  4782,
    4796,  4800,  1677,  4797,  4803,  4801,  4811,  4806,  4802,  4804,
    1405,   456,  4805,  4819,  4808,  4807,  1677,  5397,  4809,  4817,
    4812, -3325,  4810,  4815,  4821,  4822,  1761,  1762,  3259,  1677,
    4849,  4853,  4837,  4867,  4824,  4841,  4830,  4834,  4842,  4844,
     935,  4910,  1405,  1405,  4901,   782,   782,  4915,  4911,  4918,
    4917,  3646,  4902,  4920,  4923,  4937,  4934,  4943,  4947,  4935,
     942,  4950,   782,  4531,  4946,  4951,  1167,  4955,  4967,  4977,
    4986,  1677,  1677,  4988,   782,   782,  3646,  4954,  4997,  4999,
    5013,  2958,  2959,  5008,  5482,  5397,  5018,    81,   410,   456,
      81,  2311,  5009,   457,  5010,  5011,  5021,  6186,  5020,  5022,
    5035,  5036,  5045,   782,  5024,  5025,  5037,  5039,  2764,  1621,
    5034,  2765,  5040,  5041,  4463,  2312,  4442, -2401,  4462,  2718,
    5095,  5106,  1325,  5192,  5119,  5107, -3325,  5054,  5136,   936,
    5079,  5080,  5081,  2787,  2788,  2789,  2790,  2791,  2792,  5087,
    2771,  5165,  4979,  1405,  5160,  5195,   410,  5197,  6283,  5201,
   -3325,  5216,  5223,  5244,  5110,  5252,  5137,  4323,  4323,  4323,
    4323,  4323,  5246,  5178,  5259,  6299,  5175,  2313,  5273,  5162,
    6301,  5247,  6303,  5125,  5145,  5177,  3045,  2773,  5651,  5179,
    5183,  1165,  6318,  5209,  5260,   936,  5261,  6509,  5264,  5262,
    5186,  5187,  5526,  6116,  1405,  1405,  5266,  5268,  5282,  5303,
    1405,  1405,  5289,  5305,  6116,  5306,  3631,  1405,  1405,  1405,
    5307,  5317,  5318,  1405,  5319,  1405,  1405,  1405,  1405,  1405,
    1405,  5331,  1405,  5320,  1405,  1405,    80,  5334,  1405,  5344,
    5353,  5321,  5322,  5350,  5333,  5368,  2123,  5345,  5274,  5370,
    5372,  5273,  1677,  1405,  1405,  1405,  1405,   458,  5386,  5375,
    5387,  1405,  5577,  5389,  5390,  1405,  5393,  5405,  1405,  5416,
    2314,  1405,  1405,  1405,  1405,  1405,  1405,  1405,  1405,  1405,
    5419,  1405,  5428,  5437,  5445,  5451,  5452,  3527,  5455,  1405,
    5458,  5689,  1405,  4531,  5457,  5474,  5479,  4531,  5480,  5492,
    6191,  5495,  5493,  5496,   935,  6315,  5498, -3325,  5497,   935,
    5500,   935, -3325,  3646,  5502,  5503,  5514,  5521,  2315,  5529,
    5525,  2316,  5531,   781,  5537,  5547,  1621,  5557,  5558,  5542,
    5556, -2403,  3225,  5559,  5551,  5599,  5275,  5552,  5607,   935,
    5560,  5637,  5639,  5564,  5579,   410,   410,   458, -3325,  1987,
    5592,  5597,  1405,  5600,  5595,  5608,  2969,   935,  5613,  5612,
    5616,  5631,  5615,  5618,  5619,  5620,  5635,  5644,  2318,  5632,
    5648,  5652,  5657,  5658,  5650,  5666,  5684,   456,  5685,  5688,
    5698,  1451,  5696,  5699,  5700,  5711,  5714,    74,  5718,  5720,
    5723,  5724,  5732,  1064,  5741,  5754,  5755,  5746,  5760,  1082,
    2780,  5761,  5769,  5770,  5775,  5776,  5764,  1167,  5777,  5780,
    5782,  5628,  5788,  5796,  5807,  5799,  5802,  2320,  5809,   936,
    5819,  5821,  5822,  5823,  5832,  5824,   942,  1180,  5847,   458,
    5837,   458,  5842,  5848,  5850,  6298,  5859,  1167,  5860,  2321,
    5862,  5867,    79,  1167,  5870,  5869,  5871,  5878,  5894,  5872,
    1165,   782,  5884,  5914,  1165,  5926,  5929,  5932,  5943,  5947,
    5952,  5953,  2323,  5984,  5276,  5887,  5921,  6008,  5277,    81,
    6186,    81,  5959,   782,  5415,  5898,  6014,  5920,  5922,  5946,
    1677,  5965,   935,  5966,  1677,  1677,  5708,  5709,  6016,  5970,
    5975,  5712,  5713,   782,  3646,  6024, -3325,  3056,   458,   782,
    5976,    35,  3057,   782,  5977,  2123,  6025,  6019,  6018,    41,
      42,   782,  6021,  6022,  6042,  2764,  6049,  6051,  2765,  6054,
    6057,  6059,  2766,  2767,  2768,  6066,  6067,  6080,  6084,   782,
    2270,  6090,  1405,  6095,  6082,  6083,  6102,  6105,  6093,  2769,
    6109,  3058,  2770,  6115,  1405,  6437,  6137,  2771,  1677,  6155,
    6157,  1405,  6119,  6122,  6131,  3059,  6126,  2772,  6127,  6214,
    1677,  6129,  6165,  6135,  6148,  6171,  6158,  6209,  6216,  6221,
    6225,  3060,  6226,  3154,   782,  6235,  1621,  6245,  6246,  6253,
    6239,  6257,  6258,  6259,  2773,  6266,  1222,  6267,  6269,  6268,
    6274,  6276,   782,   782,  6281,  6289,  2245,  6305,  6282,  6306,
    6302, -3325,  2246,  6310,  1677,  6311,  6323,  6324,  2787,  2788,
    2789,  2790,  2791,  2792,  6328,  3985,  6496,  6313,  6349,  3061,
    6486,  6487,  6358,  6362,  6364,  6357,  6370,  6367,  6373,  6374,
    3062,  6379,  6392,  6393,  6394,  6400,   458,   782,  6401,  6412,
    6448,   458,  6438,  6360,  6440,  6361,  6457,  6490,  6498,  2248,
    6518,  6529,  3063,  5120,  6505,  6414,  6431,  3064,  6544,  6433,
    6456,  6515,  6524,  6547,  6570,  6550,  6542,  6543,  6554,  6566,
    6571,  6573,  6576,   936,  6593,   782,  6586,   458,   936,  6595,
     936,  6587,  1167,   782,  6596,  6598,  6599,  6608,  1222,  6603,
     782,  4076,  6600,  6609,   782,  6601,  6610,  3274,  1337,  2249,
    6612,  3646,  3170,  2241,  2774,  2344,  3646,  2251,   936,  2775,
    4243,  2252,  2253,  2254,   782,  2850,  4108,  4578,  2255,  4032,
     782,  2256,  4752,  4706,   782,  5292,   936,   458,  3065,  2257,
    2776,  2777,  5281,  6443,  2343,  6441,  6553,   782,  5398,  4146,
    5751,  6355,  6343,  6516,  5923,  2778,  5430,  4531,  2258,  6058,
     782,  5759,  4531,  6034,  4355,  4531,  4645,  6434,  5936,  6512,
     782,  4076,  6365,  6363,  6455,  6531,  5483,  3066,  4650,  5463,
    6321,  4212,  4213,  5290,  5450,  4729,  2331,  4922,  6041,  5784,
    2779,  2259,  6075,  4200,  4930,  6045,  6517,  6602,  6020,  6591,
    6228,  4870,  4854,  6459,  5964,  6167,  6330,  2780,  5967,  3359,
    2781,  1187,   975,  5918,  5522,  2677,  6143,  3863,  2696,  5489,
    4636,  3439,  2428,  6264,  3477,  1707,  1405,  1677,  1623,  3573,
    6604,  6605,  3574,  4818,  5989,  5323,  6480,   458,  3575,  3772,
    6585,  5343,  3022,  3771,  3782,  2896,  4076,  1279,   935,  2764,
    2260,  3292,  2765,  3067,  2261,  3295,  2766,  2767,  2768,  3512,
    3068,   936,  3784,  3069,  5467,  2262,  4076,   456,  5919,  5925,
    5640,  6428,  1972,  2769,  5026,  3565,  2263,  5205,  2624,  2866,
    4351,  2771,  2812,  4591,  1165,  1405,  3815,  2264,  4600,  5176,
    4598,  2772,  6424,  6304,  5623,  5605,  2921,  2920,  3814,  2925,
    5590,  3070,  5140,  2782,  6121,  4076,  2930,  5134,  3071,  5206,
    6288,  6287,  6588,  5135,  6497,  3072,   942,  6548,  2773,  6415,
    2265,  6100,  3073,  5089,  1677,  5917,  6426,  6411,   782,  4508,
    3171,  6427,  3727,  2267,  2268,  4419,  6040,  4401,  6003,  2123,
     410,  1405,  4506,  1370,  3736,  4978,  4303,  3841,  3434,  3074,
    6402,  1167,  2512,  2944,  3832,  1167,  2937,  2691,  1340,  4573,
    1728,  3846,  5211,  3845,  3172,  2164,  5624,  3848,  5212,  2135,
    2816,  5181,  2941,  1363,  4353,  6073,  3852,  3524,  1064,   410,
      83,  5924,     0,     0,     0,     0,   782,  2215,     0,  2136,
       0,     0,  1768,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2610,  2783,  2270,
       0,  2784,  2785,  2786,     0,  2787,  2788,  2789,  2790,  2791,
    2792,     0,     0,     0,  2216,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2271,  2774,  6094,
       0,   782,     0,  2775,     0,     0,     0,     0,     0,     0,
       0,     0,  4531,     0,     0,  2217,     0,     0,     0,     0,
       0,     0,     0,  2757,  2776,  2777,  1677,     0,   782,     0,
       0,     0,   456,     0,     0,     0,   782,     0,     0,  2778,
       0,     0,     0,  1405,  1405,     0,     0,  1677,     0,     0,
    1405,  2218,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1677,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1405,     0,     0,  2779,     0,  1405,     0,     0,     0,
       0,   942,     0,     0,     0,     0,  2219,     0,     0,     0,
       0,  2780,     0,     0,  2781,     0,     0,     0,     0,  1405,
    1405,  1405,     0,     0,  1405,     0,     0,     0,     0,     0,
       0,     0,  1405,  1405,  1405,  1405,     0,     0,     0,     0,
     458,  2220,     0,  1165,  1165,  1405,   458,     0,  1405,     0,
    1405,     0,     0,     0,     0,     0,     0,  1165,     0,     0,
       0,  1405,  1405,     0,     0,  1405,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2221,     0,  1405,
       0,  1405,  4531,  1405,     0,     0,     0,     0,  6248,     0,
       0,     0,   410,     0,     0,     0,     0,   936,  2123,  2123,
       0,     0,     0,  1405,     0,     0,     0,  2782,     0,     0,
    2222,  2223,  2123,     0,  1405,     0,  1405,  1405,  1405,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1541,     0,  2224,   782,     0,     0,
       0,  1405,  1552,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2225,     0,     0,     0,   220,  6271,     0,
       0,  2226,  5989,  5397,     0,     0,     0,     0,     0,  2227,
       0,  6307,  1405,     0,     0,   410,     0,  1405,  2228,     0,
       0,     0,     0,  1405,     0,     0,     0,  2229,     0,     0,
       0,     0,     0,  1405,     0,   456,     0,     0,     0,     0,
       0,  2230,     0,  1622,  1082,     0,     0,     0,   935,     0,
    2231,     0,  2783,     0,     0,  2784,  2785,  2786,     0,  2787,
    2788,  2789,  2790,  2791,  2792,     0,     0,     0,     0,     0,
       0,  4433,     0,     0,     0,  1677,     0,     0,  1677,     0,
    1677,     0,     0,     0,   942,  1677,     0,     0,     0,     0,
      80,     0,     0,     0,  6341,  1167,     0,     0,     0,     0,
       0,  6416,   782,   782,     0,     0,     0,     0,  1405,     0,
       0,  2232,     0,  2764,     0,   772,  2765,     0,     0,     0,
    2766,  2767,  2768,     0,     0,     0,     0,     0,     0,   782,
       0,  1397,   782,     0,   456,     0,  1677,  2769,     0,     0,
    6541,  1419,     0,     0,     0,  2771,     0,     0,  2041,     0,
       0,     0,     0,  1677,     0,  2772,     0,  1796,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1677,     0,
       0,     0,  2773,   942,  5397,     0,     0,     0,     0,     0,
       0,  1816,  1549,     0,     0,     0,     0,  2042,     0,     0,
       0,     0,     0,  1943,     0,     0,     0,  1955,  1622,  1957,
       0,     0,     0,     0,     0,  2043,     0,     0,     0,     0,
       0,     0,     0,   458,   458,   458,     0,     0,     0,     0,
       0,     0,  6482,   414,  6483,  6484,     0,     0,     0,     0,
    2044,     0,     0,     0,  1165,     0,  1165,     0,  6460,     0,
     782,     0,   410,   935,     0,     0,     0,     0,     0,     0,
    1397,   458,     0,     0,     0,     0,  1677,     0,  1677,     0,
    1419,     0,     0,  6485,     0,     0,   782,   410,     0,     0,
       0,     0,     0,     0,     0,     0,  2045,     0,     0,     0,
     782,     0,     0,     0,     0,     0,     0,     0,     0,  2123,
       0,  2123,  2774,  2046,     0,     0,     0,  2775,     0,     0,
       0,  6482,   414,  6483,  6484,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2776,  2777,
       0,     0,  6559,     0,     0,     0,   781,   781,     0,     0,
       0,  2154,     0,  2778,     0,     0,     0,     0,     0,     0,
       0,  1677,  6485,     0,     0,  2764,  6540,     0,  2765,     0,
       0,     0,  2766,  2767,  2768,   456,     0,     0,     0,     0,
       0,   782,     0,     0,  1167,  1167,     0,     0,  2779,  2769,
       0,     0,     0,     0,     0,  1677,  6559,  2771,  1167,     0,
       0,     0,  2047,     0,     0,  2780,     0,  2772,  2781,     0,
       0,  2048,  6482,   414,  6483,  6484,  6559,     0,  2049,  4855,
    1677,     0,     0,     0,   942,   458,  1677,   936,  2050,   456,
       0,     0,     0,  1165,  2773,   782,     0,   782,     0,     0,
       0,     0,  6558,     0,     0,     0,     0,     0,     0,   456,
     782,     0,   782,  6485,     0,     0,     0,   410,     0,  2051,
       0,     0,  2052,     0,  4914,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2053,     0,     0,   942,     0,
    2054,   458,     0,     0,     0,     0,     0,     0,  2123,     0,
       0,     0,     0,     0,  2055,     0,  6558,  6560,   942,  6272,
       0,  2782,     0,     0,     0,  1677,   935,  2056,     0,     0,
       0,     0,     0,     0,     0,     0,  6558,     0,     0,     0,
     782,  1677,     0,     0,     0,     0,     0,     0,  6611,     0,
       0,     0,     0,     0,     0,     0,  1677,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6560,     0,     0,  2774,     0,     0,     0,     0,  2775,
       0,     0,     0,     0,     0,     0,     0,     0,   782,     0,
       0,  6560,     0,     0,     0,     0,     0,     0,     0,     0,
    2776,  2777,     0,     0,     0,     0,     0,     0,     0,     0,
     782,     0,     0,     0,     0,  2778,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   935,  2783,     0,     0,  2784,
    2785,  2786,     0,  2787,  2788,  2789,  2790,  2791,  2792,     0,
       0,   782,     0,     0,   782,  4483,     0,     0,     0,     0,
    2779,     0,   936,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1405,     0,  2780,  1677,     0,
    2781,     0,     0,     0,  1405,     0,     0,     0,     0,     0,
    1405,     0,  1405,     0,     0,  1405,     0,     0,     0,  1677,
    1405,  1405,  1405,  1405,  2006,     0,  1405,  1405,  1405,  1405,
    1405,  1405,  1405,  1405,  1405,  1405,     0,  1622,     0,  1405,
    1405,  1397,     0,     0,  1677,    80,    80,     0,    80,  1405,
       0,     0,  1419,  1405,     0,   458,     0,  1405,     0,     0,
       0,     0,     0,     0,     0,  1405,  1622,     0,  1405,     0,
    1405,     0,     0,  2007,     0,     0,     0,     0,  1677,  1405,
       0,     0,  1405,  1405,     0,     0,     0,  1405,  1405,     0,
       0,  2008,     0,  2782,  1405,  1167,     0,  1167,     0,     0,
       0,     0,     0,     0,  1405,     0,     0,  1405,     0,     0,
       0,     0,     0,     0,     0,     0,  2009,  2688,     0,     0,
    1405,     0,     0,     0,     0,     0,  1405,  1405,  1405,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2503,     0,     0,     0,     0,     0,  1622,     0,  2764,
       0,     0,  2765,     0,     0,     0,  2766,  2767,  2768,     0,
       0,     0,  2010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2769,     0,     0,     0,     0,     0,  2011,
    1405,  2771,     0,     0,     0,     0,   935,     0,     0,     0,
       0,  2772,     0,     0,     0,     0,  1405,     0,  2783,     0,
       0,  2784,  2785,  2786,     0,  2787,  2788,  2789,  2790,  2791,
    2792,     0,  1677,     0,     0,  3672,     0,     0,  2773,     0,
       0,     0,     0,     0,  1405,   936,     0,     0,  2761,     0,
       0,     0,     0,     0,     0,     0,     0,  2763,  3587,     0,
     935,  2764,     0,     0,  2765,     0,     0,     0,  2766,  2767,
    2768,  2806,     0,     0,     0,   782,     0,     0,     0,     0,
     935,     0,     0,     0,     0,  2769,     0,     0,  2012,     0,
       0,     0,     0,  2771,  1167,     0,     0,  2013,     0,     0,
       0,     0,  1622,  2772,  2014,  2837,  2839,     0,     0,     0,
    1622,  1622,  3588,     0,     0,     0,     0,     0,     0,  1660,
       0,     0,     0,     0,     0,  1229,     0,     0,     0,   458,
    2773,     0,     0,     0,   458,  1677,   458,  1405,     0,     0,
       0,     0,     0,  2015,   936,  2016,  3589,  1660,  2017,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2774,     0,
       0,  2018,     0,  2775,   458,  1677,  2019,     0,     0,     0,
       0,     0,  1423,     0,     0,  3590,     0,     0,     0,     0,
    2020,     0,   458,  1459,  2776,  2777,  3591,     0,     0,     0,
       0,     0,     0,  2021,     0,     0,     0,  1480,   782,  2778,
       0,   782,     0,     0,     0,     0,     0,     0,  3592,     0,
       0,     0,     0,  3593,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   782,     0,     0,
       0,     0,     0,     0,  2779,   772,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   772,     0,     0,     0,     0,
    2774,  2780,     0,     0,  2781,  2775,     0,     0,     0,   772,
       0,     0,     0,  3594,     0,     0,     0,     0,     0,     0,
       0,   781,     0,     0,  1405,     0,  2776,  2777,     0,     0,
       0,     0,     0,     0,  3595,     0,     0,     0,     0,  4292,
       0,  2778,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   782,   782,     0,     0,     0,     0,   458,  1677,     0,
       0,     0,     0,     0,  2215,   782,     0,     0,     0,     0,
    2764,     0,  1405,  2765,     0,     0,  2779,  2766,  2767,  2768,
       0,     0,     0,     0,   782,     0,     0,     0,     0,     0,
       0,     0,     0,  2780,  2769,     0,  2781,  2782,     0,     0,
       0,  2216,  2771,     0,     0,  1677,  1405,  1405,   975,     0,
       0,  3596,  2772,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   936,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   458,     0,     0,     0,  2773,
    3597,     0,     0,     0,     0,     0,     0,     0,     0,  3598,
       0,     0,     0,     0,     0,     0,  3599,     0,     0,     0,
       0,     0,     0,   782,     0,     0,  4292,     0,  2218,     0,
       0,     0,  3600,     0,     0,     0,     0,     0,     0,   936,
       0,     0,     0,     0,     0,     0,     0,     0,  3601,  2782,
    1405,  2215,     0,     0,     0,     0,     0,  3602,     0,   936,
    3603,  1405,  2783,  2219,     0,  2784,  2785,  2786,     0,  2787,
    2788,  2789,  2790,  2791,  2792,     0,     0,     0,  3604,  4866,
       0,     0,     0,  3230,     0,     0,     0,     0,  2216,     0,
    3236,  1405,     0,  4293,     0,     0,     0,     0,  2220,     0,
       0,  1405,  1405,     0,  1677,  3605,     0,     0,  1405,  1405,
       0,     0,     0,  1405,  1677,     0,     0,     0,  1405,  2774,
       0,  1405,  1405,     0,  2775,     0,  1405,     0,     0,     0,
       0,     0,  1405,     0,  2221,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1405,  2776,  2777,     0,     0,     0,
       0,  2403,  1405,     0,  2783,  2218,  1405,  2784,  2785,  2786,
    2778,  2787,  2788,  2789,  2790,  2791,  2792,     0,  2223,  1405,
       0,  5047,     0,     0,  1405,  2418,     0,     0,     0,     0,
    1405,     0,     0,     0,     0,     0,     0,     0,   772,   772,
    2219,     0,  2430,  2224,     0,  2779,     0,     0,     0,     0,
       0,     0,  1405,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2780,     0,   220,  2781,    81,     0,  2226,     0,
    4293,     0,     0,     0,  3382,  2220,  2227,     0,     0,     0,
    3389,     0,     0,  1405,     0,  2228,     0,     0,  2764,     0,
       0,  2765,     0,     0,  3099,  2766,  2767,  2768,     0,     0,
       0,  1677,     0,     0,     0,     0,     0,     0,  2230,     0,
       0,  2221,  2769,     0,     0,     0,     0,  2231,   782,     0,
    2771,     0,     0,   458,     0,     0,     0,     0,     0,     0,
    2772,     0,     0,     0,     0,     0,     0,     0,     0,  1677,
       0,     0,  4295,     0,   418,  2223,     0,     0,     0,     0,
     418,     0,     0,     0,     0,   776,     0,  2773,  2782,     0,
       0,     0,   782,     0,     0,     0,     0,  1677,  2764,     0,
    2224,  2765,     0,     0,   782,  2766,  2767,  2768,  2232,     0,
       0,     0,   418,  4296,  4098,     0,     0,     0,     0,     0,
    1405,   220,  2769,     0,     0,  4294,     0,     0,     0,     0,
    2771,   782,     0,  2227,     0,     0,     0,     0,     0,     0,
    2772,     0,  2228,     0,    80,     0,     0,    80,     0,     0,
       0,  3099,  3504,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1677,     0,   418,  2230,     0,  2773,     0,     0,
     782,     0,     0,     0,  2231,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1405,  2783,     0,     0,  2784,  2785,  2786,  4295,
    2787,  2788,  2789,  2790,  2791,  2792,  1405,  2774,     0,     0,
    5098,     0,  2775,     0,     0,     0,     0,  2692,     0,     0,
    3564,  3564,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   782,  2776,  2777,  2232,     0,     0,     0,  1405,
    4296,   418,     0,     0,     0,     0,     0,     0,  2778,     0,
       0,     0,     0,     0,     0,     0,     0,  1427,     0,     0,
       0,     0,     0,  3630,  1397,     0,     0,  1397,     0,  1463,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1677,  1482,  1677,  2779,     0,     0,     0,  2774,     0,     0,
       0,     0,  2775,     0,     0,     0,     0,  1501,     0,     0,
    2780,     0,     0,  1547,     0,     0,     0,     0,     0,     0,
       0,  1419,  1419,  2776,  2777,     0,     0,     0,   782,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2778,     0,
       0,     0,     0,     0,  1405,     0,     0,     0,  1677,     0,
       0,     0,     0,  1405,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1405,  1405,     0,  2779,  1405,     0,     0,     0,     0,     0,
    3759,     0,     0,     0,     0,     0,     0,     0,     0,  1405,
    2780,     0,     0,  2781,     0,     0,  1405,     0,     0,     0,
       0,  1405,     0,     0,  1405,  1405,  2782,     0,     0,     0,
       0,     0,  1405,  1405,     0,     0,     0,     0,     0,     0,
       0,     0,  1419,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   418,     0,     0,     0,     0,  1405,
       0,  1405,     0,     0,     0,     0,     0,   782,     0,   782,
       0,     0,     0,  1405,     0,     0,  2764,     0,     0,  2765,
       0,     0,     0,  2766,  2767,  2768,     0,     0,     0,   418,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2769,     0,     0,     0,     0,     0,  2782,     0,  2771,     0,
       0,     0,     0,  1677,  1405,     0,   782,     0,  2772,     0,
       0,     0,  1805,     0,     0,  1405,     0,     0,   781,     0,
       0,  2783,     0,     0,  2784,  2785,  2786,     0,  2787,  2788,
    2789,  2790,  2791,  2792,  2154,  2773,    80,     0,    80,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1950,     0,     0,   458,     0,     0,     0,     0,     0,  1405,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1974,
       0,     0,     0,     0,     0,     0,     0,     0,  1622, -2812,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2004,     0,     0,     0,     0,     0,     0,     0,
       0,  2783,     0,     0,  2784,  2785,  2786,     0,  2787,  2788,
    2789,  2790,  2791,  2792,     0,     0,  6062,     0,  5180,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1405,     0,  1677,     0, -2812,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1957, -2812,
       0,     0,     0,     0, -2812,  2774,     0,     0,     0, -2812,
    2775,     0,     0,     0,     0, -2812,  1405,  1677, -2812,  1405,
       0,  1405, -2812,     0,     0,     0,     0,     0,     0,     0,
       0,  2776,  2777,     0,     0,     0,     0,     0,     0,     0,
       0,  1405,     0,     0,     0,     0,  2778,  1405,     0,     0,
   -2812,  1405,     0,     0,     0,     0,     0,  1677,     0,     0,
       0,     0,  1405,     0,     0,     0,     0,     0,     0,     0,
   -2812,     0,     0,     0,     0,     0,     0,  3187,     0,     0,
       0,  2779,     0,  4042,     0,     0,     0,     0,  2281,     0,
       0,     0,     0,   772,     0,     0,     0,     0,  2780,     0,
       0,  2781,     0,     0,     0,     0,     0,     0,   458,     0,
       0,     0,     0,     0, -2812,     0,     0,  1677, -2812,     0,
       0,     0,  1677,  1677,     0, -2812,     0,  1405,     0,  2764,
       0,     0,  2765,     0,   782,     0,  2766,  2767,  2768,     0,
       0,     0,     0,     0,     0,     0,   782,     0,     0,     0,
       0,     0,     0,  2769,     0,     0,     0,     0,     0,     0,
       0,  2771,     0,     0,     0,     0,     0,     0,     0,     0,
    4143,  2772,     0,  1397,     0,     0,     0,     0,  1405,     0,
    1419,     0,     0,     0, -2812,     0,     0,     0,     0,     0,
    3300,     0,     0,     0,  2782,     0,     0,     0,  2773,     0,
       0,  1405,     0,  4167,     0,  3315,  4167,     0,  4167,     0,
       0,     0,  4167,     0,     0,     0,     0,     0,     0,     0,
       0,  4167,  4167,  4167,  2446,     0,     0,     0,  3339,     0,
       0,     0,     0,     0,     0,     0,  1677,  1677,     0,     0,
       0,     0,     0,     0,     0,  1181,     0,  6273,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2494,  2497,
    2498,  4232,  1405,     0,     0,  1405,     0,     0,  1405,     0,
       0, -2812,     0,     0,     0,     0,     0,     0,     0,  1405,
       0,     0,     0,     0,  1405,     0,  1405,     0,  1405,     0,
       0,     0,     0,     0,  3430,  4255,     0,  1405, -2812,  2783,
   -2812, -2812,  2784,  2785,  2786,     0,  2787,  2788,  2789,  2790,
    2791,  2792,     0,   418,  3441,  1405,  5191,   418,  2774,     0,
       0,     0,     0,  2775,     0,     0,     0,  4285,  1660,     0,
       0,  1420,   776,     0,     0,  1622, -2812,     0,  3272, -2812,
   -2812,  3456, -2812,   776,  2776,  2777,     0,     0,     0,     0,
       0,   458,     0,   782,     0,     0,     0,   776,     0,  2778,
       0,     0,  4325,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3484,  1660,     0,     0,     0,     0,     0,
       0,     0,     0,  1622,  2779,   776,     0,     0,     0,     0,
       0,     0,  1405,     0,     0,   776,     0,     0,     0,     0,
    1405,  2780,     0,     0,  2781,     0,     0,     0,     0,   776,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3371,     0,     0,  1950,     0,     0,     0,
       0,  1405,  1405,  3390,     0,   776,     0,     0,     0,  1405,
     458,     0,     0,  1677,     0,  3272,     0,     0,     0,  1405,
    1420,   776,     0,     0,     0,     0,     0,     0,   782,     0,
       0,   776,     0,  1950,     0,     0,     0,     0,     0,     0,
       0,     0,  1405,     0,     0,   776,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   782,     0,     0,
       0,     0,     0,   776,     0,     0,  2764,  2782,     0,  2765,
       0,     0,     0,  2766,  2767,  2768,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2769,     0,     0,     0,     0,  3467,  1405,     0,  2771,     0,
       0,  1405,     0,     0,     0,     0,     0,     0,  2772,   955,
       0,  1405,     0,     0,  3676,     0,     0,  1405,  1405,     0,
       0,     0,  1405,     0,  3272,     0,     0,     0,     0,     0,
       0,  1405,     0,     0,     0,  2773,     0,  6504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1405,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   956,
       0,     0,   957,   782,     0,     0,     0,     0,     0,     0,
     776,     0,  2783,     0,     0,  2784,  2785,  2786,   958,  2787,
    2788,  2789,  2790,  2791,  2792,     0,  1405,     0,     0,  5225,
     418,     0,  2854,     0,     0,     0,     0,   959,     0,     0,
       0,     0,     0,     0,   960,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1405,     0,     0,  6504,
       0,  1405,     0,     0,  1622,     0,   961,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   962,     0,     0,
       0,   458,     0,     0,     0,     0,   963,     0,     0,     0,
       0,     0,     0,     0,     0,  2774,     0,     0,     0,   964,
    2775,  1405,     0,  1397,   965,     0,   417,  1405,     0,  1419,
       0,   966,   417,   967,     0,     0,     0,   775,     0,     0,
       0,  2776,  2777,  1405,     0,     0,     0,     0,     0,   968,
       0,     0,     0,  1405,     0,   458,  2778,     0,   776,   776,
       0,     0,     0,     0,   417,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   969,   458,  2932,  1405,  1405,     0,
    1405,  2764,     0,     0,  2765,     0,     0,     0,  2766,  2767,
    2768,  2779,     0,     0,     0,   970,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2769,     0,     0,  2780,     0,
       0,  2781,   971,  2771,     0,     0,   417,     0,     0,     0,
       0,     0,     0,  2772,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   972,   973,     0,     0,     0,     0,  1622,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2773,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1217,   975,
    3922,     0,   976,  4541,     0,     0,     0,     0,  1217,     0,
    1217,     0,  3937,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   417,     0,     0,     0,     0,     0,     0,
       0,   977,  1420,     0,  2782,     0,     0,   978,     0,     0,
     979,     0,     0,     0,     0,     0,     0,   980,     0,     0,
     981,     0,     0,  3109,     0,     0,  3972,     0,     0,     0,
       0,     0,     0,   982,     0,     0,  4734,     0,  3144,     0,
       0,     0,   983,     0,     0,     0,     0,     0,     0,   984,
     772,     0,  4541,     0,     0,     0,   985,     0,   986,     0,
       0,   987,     0,     0,     0,   988,     0,     0,     0,     0,
    2774,     0,  3854,  3193,   989,  2775,     0,     0,     0,   990,
       0,     0,     0,     0,     0,     0,  3206,     0,     0,  3209,
       0,     0,  3872,   991,     0,  4777,  2776,  2777,  3876,     0,
       0,     0,  3879,     0,     0,     0,   992,     0,     0,  2783,
       0,  2778,  2784,  2785,  2786,     0,  2787,  2788,  2789,  2790,
    2791,  2792,     0,     0,     0,     0,  5543,     0,  3903,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3258,     0,     0,     0,     0,  2779,     0,     0,     0,
       0,     0,     0,     0,     0,  3276,     0,     0,     0,     0,
    4816,     0,     0,  2780,     0,     0,  2781,     0,     0,     0,
       0,     0,     0,  3956,     0,     0,   417,  3298,     0,     0,
       0,     0,     0,     0,   776,     0,     0,     0,     0,     0,
       0,   772,     0,     0,     0,     0,     0,  4167,     0,   776,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4848,   417,     0,     0,     0,     0,     0,  4865,     0,     0,
       0,     0,     0,  4865,     0,     0,     0,     0,   776,     0,
       0,     0,  1622,     0,  1622,     0,  4014,     0,     0,  4195,
    3363,  2764,     0,     0,  2765,     0,     0,     0,  2766,  2767,
    2768,     0,     0,     0,     0,     0,     0,     0,     0,  2782,
       0,     0,     0,     0,   776,  2769,     0,     0,     0,     0,
       0,  3409,     0,  2771,  4052,     0,     0,     0,  3422,     0,
       0,     0,  4063,  2772,     0,     0,   776,  4933,  2764,   772,
       0,  2765,     0,  4078,     0,  2766,  2767,  2768,     0,     0,
       0,   776,     0,     0,     0,     0,   418,     0,     0,   776,
    2773,     0,  2769,  4091,     0,     0,  4962,  1622,     0,  4094,
    2771,     0,     0,  4097,     0,     0,     0,     0,     0,     0,
    2772,     0,     0,     0,     0,     0,  4115,     0,     0,     0,
   -2814,     0,     0,     0,     0,     0,  4325,     0,     0,  4140,
       0,     0,     0,     0,     0,     0,     0,  2773,     0,   772,
       0,     0,     0,     0,  2783,     0,     0,  2784,  2785,  2786,
       0,  2787,  2788,  2789,  2790,  2791,  2792,     0,     0,     0,
       0,  5578,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -2814,     0,     0,     0,
       0,     0,  3509,     0,     0,     0,     0,     0,  3564,     0,
   -2814,     0,     0,     0,     0, -2814,  2764,     0,     0,  2765,
   -2814,     0,     0,  2766,  2767,  2768, -2814,     0,     0, -2814,
    2774,     0,     0, -2814,     0,  2775,     0,     0,     0,     0,
    2769,     0,     0,     0,   776,     0,     0,     0,  2771,  1950,
    1950,     0,   776,   776,     0,     0,  2776,  2777,  2772,     0,
       0, -2814,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2778,     0,     0,     0,  3572,     0,  2774,  4388,     0,
       0, -2814,  2775,     0,     0,  2773,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4403,
       0,     0,     0,  2776,  2777,     0,  2779,     0,     0,     0,
       0,  5099,     0,  4409,     0,     0,     0,     0,  2778,     0,
       0,     0,     0,  2780,     0, -2814,  2781,     0,     0, -2814,
       0,     0,     0,     0,     0,     0, -2814,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2779,  2764,     0,     0,  2765,     0,     0,
       0,  2766,  2767,  2768,     0,     0,     0,     0,     0,     0,
    2780,     0,     0,  2781,     0,     0,     0,     0,     0,     0,
    3735,     0,     0,     0,     0,     0,  2771,     0,     0,     0,
       0,     0,   418,   418,   418, -2814,  2772,     0,     0,     0,
       0,     0,     0,     0,     0,  2774,  3756,     0,     0,  2764,
    2775,     0,  2765,   776,     0,     0,  2766,  2767,  2768,  2782,
       0,     0,     0,  2773,     0,     0,     0,     0,     0,     0,
    4366,  2776,  2777,  2769,     0,     0,     0,     0,     0,     0,
    3770,  2771,  3774,   418,     0,     0,  2778,     0,  3781,     0,
     418,  2772,     0,     0,     0,     0,  1181,  4389,     0,     0,
       0,     0,     0,   418,     0,  4366,  2782,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2773,     0,
       0,  2779, -2814,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   417,     0,     0,  2780,   417,
       0,  2781,     0,     0,     0,  1950,     0,     0,     0, -2814,
       0, -2814, -2814,     0,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2783,   775,     0,  2784,  2785,  2786,
       0,  2787,  2788,  2789,  2790,  2791,  2792,     0,     0,   775,
       0,  5857,     0,  2774,     0,     0,     0, -2814,  2775,     0,
   -2814, -2814,     0, -2814,     0,     0,     0,     0,     0,     0,
       0,     0,  4865,  4541,     0,     0,  4541,     0,     0, -3325,
   -3325,  2783,     0,     0,  2784,  2785,  2786,   775,  2787,  2788,
    2789,  2790,  2791,  2792,  2778,     0,     0,   775,  5868,     0,
       0,     0,  5330,     0,  2782,     0,     0,     0,  2774,  5337,
       0,   775,  5338,  2775,  5339,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -3325,
       0,     0,     0,     0,  2776,  2777,     0,   775,  4661,     0,
       0,     0,     0,     0,     0,     0,  2780,     0,     0,  2778,
       0,     0,     0,   775,     0,  4672,  5378,     0,     0,     0,
       0,     0,     0,   775,     0,     0,     0,     0,   776,     0,
       0,  4167,     0,     0,     0,  4167,  4167,   775,  4167,     0,
       0,     0,     0,     0,  2779,     0,     0,     0,     0,     0,
       0,     0,     0,  4541,     0,   775,     0,     0,     0,     0,
       0,  2780,     0,     0,  2781,     0,     0,     0,     0,  2783,
    3975,     0,  2784,  2785,  2786,     0,  2787,  2788,  2789,  2790,
    2791,  2792,     0,     0,     0,     0,  5877,     0,     0,   418,
       0,  4002,     0,     0,     0,  4005,     0,     0,     0,     0,
       0,     0,  2782,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4035,     0,
       0,     0,     0,   776,     0,     0,     0,     0,  4763,     0,
    4765,     0,     0,   776,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   776,  5295,     0,  5486,     0,
       0,     0,     0,     0,     0,     0,     0,  2782,     0,     0,
    1217,     0,   775,     0,  1217,     0,     0,     0,  4657,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,  4325,  4325,  4325,  4325,  4325,     0,     0,
       0,     0,     0,  4109,  4110,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2783,     0,     0,
    2784,  2785,  2786,  4814,  2787,  2788,  2789,  2790,  2791,  2792,
       0,  1420,  1420,     0,   776,   776,     0,     0,     0,  5534,
    5534,  5534,     0,  5534,  5534,  5534,     0,     0,     0,     0,
       0,   776,     0,     0,     0,     0,     0,  4835,     0,     0,
       0,     0,     0,   776,   776,     0,     0,     0,     0,     0,
       0,     0,  2783,     0,     0,  2784,  2785,  2786,     0,  2787,
    2788,  2789,  2790,  2791,  2792,     0,     0,     0,     0,  5880,
    2245,     0,   776,     0,     0,     0,  2246,     0,     0,  4742,
     775,   775,     0,  2764,     0,     0,  2765,     0,     0,     0,
    2766,  2767,  2768,     0,     0,     0,     0,     0,     0,     0,
       0,  4236,     0,     0,     0,     0,     0,  2769,     0,     0,
       0,     0,  1420,     0,     0,  2771,     0,     0,     0,     0,
       0,  4541,     0,  2248,     0,  2772,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3972,     0,     0,
       0,     0,  2773,     0,     0,     0,     0,     0,     0,  5622,
       0,     0,  5629,  5630,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2249,     0,     0,  1217,  1217,  4981,     0,
    1672,  2251,     0,     0,     0,  2252,  2253,  2254,     0,     4,
       0,     0,  2255,    80,     0,  2256,     0,     0,     0,     0,
    4826,     0,     0,  2257,     0,     0,     0,     0,  1672,     5,
       0,     0,     0,     0,     0,     0,   418,     0,     0,     6,
       7,     0,  2258,     0,     8,     0,     9,    10,     0,     0,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,  2259,    36,     0,    37,    38,
      39,    40,    41,    42,    43,    44,     0,     0,     0,    45,
       0,     0,  2774,     0,     0,     0,     0,  2775,     0,  2806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5046,     0,     0,     0,     0,     0,     0,     0,  2776,  2777,
       0,     0,     0,     0,     0,     0,   418,     0,     0,     0,
       0,  5055,  4392,  2778,  2260,     0,     0,     0,  2261,     0,
       0,     0,     0,     0,     0,     0,     0,    46,     0,  2262,
       0,     0,     0,     0,     0,     0,  5078,     0,     0,     0,
    2263,  4541,     0,     0,     0,  4541,     0,     0,  2779,     0,
       0,  2264,     0,     0,     0,     0,     0,  5735,  5736,     0,
       0,     0,     0,     0,     0,  2780,     0,     0,  2781,     0,
    2692,  4167,     0,  4167,  4167,     0,     0,  4167,     0,     0,
       0,     0,  4848,     0,  2265,     0,     0,  3272,   418,     0,
     418,     0,     0,     0,  2377,     0,     0,  2267,  2268,     0,
       0,     0,     0,     0,     0,     0,   775,     0,     0,  5014,
     776,    47,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   775,     0,     0,     0,     0,     0,     0,  2378,     0,
       0,    48,   776,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5798,  5033,     0,     0,     0,     0,     0,     0,
     775,     0,   776,     0,    49,     0,     0,   418,   776,     0,
       0,  2782,   776,     0,     0,     0,     0,     0,     0,  4523,
     776,     0,     0,  2270,     0,     0,  5825,    50,     0,     0,
       0,     0,     0,     0,     0,     0,   775,     0,   776,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2271,     0,     0,     0,     0,     0,     0,   775,     0,
    1420,     0,     0,     0,    51,     0,     0,    52,     0,     0,
       0,  5534,     0,   775,     0,     0,     0,     0,   417,     0,
       0,   775,     0,   776,     0,    53,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   776,   776,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2783,     0,     0,  2784,
    2785,  2786,     0,  2787,  2788,  2789,  2790,  2791,  2792,     0,
       0,     0,     0,  5934,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   418,   776,     0,     0,     0,
     418,     0,  1672,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5766,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4292,  1672,     0,     0,     0,
      54,     0,     0,     0,   776,     0,   418,     0,     0,     0,
       0,     0,   776,  1672,     0,     0,     0,     0,     0,   776,
    2215,     0,     0,   776,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   775,     0,     0,     0,
       0,     0,     0,   776,   775,   775,     0,     0,     0,   776,
    4865,     0,     0,   776,     0,    55,   418,  2216,     0,     0,
       0,     0,     0,     0,     0,     0,   776,     0,     0,     0,
      56,     0,     0,     0,     0,     0,     0,     0,     0,   776,
       0,     0,     0,     0,     0,     0,     0,    57,     0,   776,
       0,     0,     0,     0,  5254,  4167,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1672,     0,     0,     0,    58,     0,
       0,     0,     0,     0,  2218,     0,    59,     0,    60,    61,
      62,    63,    64,     0,     0,    65,    66,    67,    68,     0,
      69,    70,    71,    72,    73,     0,     0,     0,     0,     0,
    5436,     0,     0,     0,     0,     0,   418,     0,  4541,  2219,
       0,     0,     0,     0,     0,  4541,  4769,     0,     0,     0,
    4541,     0,     0,  4541,  5896,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   417,   417,     0,     0,  4293,
       0,     0,     0,     0,  2220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   775,     0,     0,  4541,     0,
       0, -2829,     0,     0,     0,     0,     0,  5358,     0,     0,
    5361,     0,  4541,     0,  2764,     0,     0,  2765,     0,     0,
    2221,  2766,  2767,  2768,     0,   417,     0,     0,     0,     0,
       0,     0,   417,     0,     0,     0,   772,   776,  2769,     0,
       0,     0,     0,     0,     0,   417,  2771,     0,  1672,     0,
       0,     0,     0,     0,  2223,  1217,  2772, -2829,     0,     0,
       0,     0,     0,     0,  1419,     0,     0,     0,     0,     0,
       0, -2829,     0,     0,     0,     0, -2829,     0,     0,  2224,
       0, -2829,     0,  2773,     0,     0,     0, -2829,     0,     0,
   -2829,     0,     0,     0, -2829,   776,     0,  1217,     0,     0,
     220,     0,     0,     0,  2226,     0,     0,     0,  1419,     0,
       0,     0,  2227,  4898,  4899,  4900,     0,     0,     0,  6181,
    6181,  2228, -2829,     0,  5448,     0,     0,     0,     0,     0,
    3099,     0,     0,  1622,  4912,     0,  2692,  6201,     0,     0,
       0,     0, -2829,  3272,  2230,     0,     0,     0,     0,     0,
     776,     0,     0,  2231,     0,     0,     0,     0,     0,     0,
    4929,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4939,  4940,     0,     0,     0,  4945,     0,   776,  4295,     0,
    4541,     0,     0,     0,     0,   776, -2829,     0,     0,     0,
   -2829,     0,     0,     0,     0,     0,     0, -2829,     0,  1420,
       0,     0,     0,  2774,     0,     0,     0,     0,  2775,     0,
       0,  2836,     0,     0,  2232,     0,     0,     0,     0,  4296,
       0,     0,  4366,     0,     0,     0,     0,     0,     0,  2776,
    2777,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     775,     0,     0,     0,  2778,     0,     0,     0,     0,     0,
    4541,     0,     0,     0,     0,     0, -2829,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   418,
       0,     0,     0,  5670,     0,   418,     0,     0,     0,  2779,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1950,     0,  2780,     0,     0,  2781,
       0,   417,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5691,     0,     0,     0,     0,     0,  1181,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   775,     0,     0,     0,  5710,
    1622,     0,     0, -2829,  6347,   775,  6348,     0,     0,     0,
    6353,  6354,     0,  6356,     0,     0,     0,   775,     0,     0,
       0,     0,     0,     0,     0,     0,   776,     0,     0,     0,
   -2829,     0, -2829, -2829,     0,     0,     0,  6227,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2782,     0,     0,     0,     0,     0,     0,     0,
    4541,     0,     0,     0,  5737,     0,     0,     0, -2829,     0,
       0, -2829, -2829,     0, -2829,     0,     0,     0,  1672,     0,
       0,     0,     0,  5130,  5131,  5132,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   775,   775,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   775,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4541,   775,   775,  5622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6181,     0,  6181,     0,     0,     0,     0,  1672,     0,     0,
       0,   776,   776,  1504,   775,     0,  4541,  2783,  1505,     0,
    2784,  2785,  2786,     0,  2787,  2788,  2789,  2790,  2791,  2792,
       0,  5705,     0,     0,  5969,     0,     0,     0,   776,     0,
       0,   776,     0,  5715,  5831,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1506,  1672,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1507,  1508,     0,     0,     0,     0,     0,     0,     0,
       0,  1672,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2692,     0,     0,     0,     0,     0,  1511,     0,     0,   772,
    1622,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4541,
       0,     0,   418,   418,   418,  1512,     0,     0,     0,     0,
       0,     0,     0,     0,  5288,     0,  1513,     0,     0,     0,
       0,     0,     0,     0,     0,  1514,     0,     0,   417,   776,
       0,     0,     0,     0,     0,     0,     0,     0,  1515,     0,
     418,  1672,     0,  1516,     0,     0,     0,     0,     0,  6181,
       0,     0,     0,     0,     0,   776,  1672,     0,  6561,     0,
       0,     0,     0,     0,     0,     0,  1672,     0,  1517,   776,
       0,  1419,     0,     0,     0,     0,     0,     0,     0,  1672,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1518,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6561,     0,  1519,     0,     0,     0,   417,     0,
       0,     0,     0,     0,     0,  6463,     0,  4366,     0,     0,
       0,     0,  6561,     0,     0,     0,     0,     0,     0,     0,
    4541,     0,     0,     0,     0,  1672,  1419,  1419,     0,     0,
     776,     0,     0,  1520,     0,     0,     0,     0,     0,     0,
       0,  5404,     0,     0,     0,  1672,     0,     0,     0,     0,
       0,     0,     0,  5417,     0,     0,     0,  1521,     0,  1672,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,  1522,  1672,     0,   418,     0,     0,     0,     0,     0,
     417,     0,   417,     0,   776,     0,   776,     0,     0,     0,
    5449,     0,     0,     0,     0,  4541,     0,     0,     0,   776,
    1523,   776,   775,     0,     0,     0,  1524,     0,     0,  1525,
       0,     0,     0,     0,  1672,  1672,  1526,     0,     0,  1527,
    3422,     0,     0,     0,   775,     0,  4366,     0,  4366,     0,
     418,     0,  1528,     0,     0,     0,     0,     0,     0,     0,
       0,  1529,     0,     0,   775,     0,     0,     0,  1530,   417,
     775,     0,     0,     0,   775,     0,     0,  1531,     0,  2692,
    1532,     0,   775,     0,  1533,     0,     0,     0,     0,   776,
       0,  1534,     0,  1535,     0,     0,     0,     0,  1536,     0,
     775,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5295,     0,     0,     0,     0,     0,     0,  4814,
       0,     0,  6590,     0,     0,  1537,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   776,     0,     0,
       0,     0,     0,     0,     0,   775,  1419,  1419,     0,  5295,
       0,     0,     0,     0,     0,     0,     0,  1217,     0,   776,
       0,     0,     0,   775,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2692,
       0,     0,     0,     0,  2692,  2692,     0,     0,     0,     0,
     776,     0,     0,   776,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,     0,   417,   775,     0,
       0,     0,   417,     0,     0,  5585,  5586,  5587,  5588,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    85,     0,     0,     0,     0,
       0,    89,     0,     0,     0,    93,   775,    94,   417,    96,
      97,     0,     0,     0,   775,     0,     0,     0,     0,  1217,
     106,   775,     0,     0,     0,   775,     0,     0,     0,     0,
       0,     0,     0,     0,   418,     0,   118,   119,     0,     0,
       0,     0,     0,     0,     0,   775,     0,     0,     0,     0,
       0,   775,     0,     0,     0,   775,     0,     0,   417,  6265,
       0,     0,     0,     0,     0,     0,     0,     0,   775,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   775,     0,     0,     0,     0,   127,     0,     0,     0,
       0,   775,     0,     0,     0,     0,   128,     0,   129,   130,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   132,     0,     0,     0,     0,  1336,   135,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   144,   145,
       0,   146,   147,   148,     0,     0,     0,     0,     0,   151,
       0,   152,   153,     0,     0,     0,     0,     0,   417,     0,
       0,     0,     0,     0,   155,     0,   156,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   159,     0,     0,   160,     0,     0,   163,     0,     0,
       0,     0,     0,  1672,     0,     0,     0,  1672,  1672,     0,
       0,     0,   164,     0,     0,     0,     0,     0,   165,     0,
       0,     0,   166,     0,     0,     0,     0,     0,   167,     0,
       0,     0,     0,     0,     0,     0,     0,   169,     0,   171,
       0,     0,     0,     0,   776,     0,   173,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   775,
       0,     0,   177,     0,     0,  2764,     0,     0,  2765,     0,
       0,  1672,  2766,  2767,  2768,     0,     0,     0,     0,   181,
       0,     0,     0,  1672,     0,  6420,     0,     0,     0,  2769,
       0,     0,     0,     0,     0,     0,     0,  2771,   418,     0,
       0,     0,     0,   418,     0,   418,     0,  2772,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   775,   192,   193,
       0,     0,     0,     0,   194,     0,     0,  1672,     0,     0,
       0,     0,     0,   418,  2773,     0,   195,     0,     0,     0,
       0,     0,     0,     0,     0,   199,   200,     0,     0,     0,
     202,   418,     0,     0,     0,     0,  5833,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   776,     0,     0,
     776,     0,   775,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
       0,     0,     0,     0,     0,     0,   776,     0,   214,   775,
       0,     0,     0,  2764,     0,     0,  2765,   775,     0,     0,
    2766,  2767,  2768,   216,     0,     0,     0,     0,     0,     0,
     217,   218,     0,   219,     0,     0,     0,  2769,   220,     0,
       0,     0,     0,   221,     0,  2771,   223,   224,     0,     0,
       0,     0,   226,   227,     0,  2772,     0,     0,     0,   228,
     229,     0,     0,     0,  2774,     0,     0,     0,   230,  2775,
       0,     0,     0,   232,     0,     0,     0,     0,     0,     0,
     776,   776,  2773,     0,   235,     0,   418,  4366,     0,     0,
    2776,  2777,     0,     0,   776,     0,     0,     0,     0,     0,
       0,   417,   237,     0,     0,  2778,     0,   417,     0,     0,
       0,  2764,     0,   776,  2765,     0,     0,     0,  2766,  2767,
    2768,   243,     0,   244,     0,     0,     0,     0,     0,     0,
       0,   246,     0,     0,   247,  2769,     0,     0,     0,   248,
    2779,     0,     0,  2771,   249,     0,     0,     0,     0,     0,
    1672,     0,     0,  2772,     0,     0,     0,  2780,   252,     0,
    2781,     0,     0,     0,   418,     0,     0,     0,     0,   820,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2773,   264,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   776,     0,     0,   265,     0,     0,   775,  -165,
       0,     0,  2774,     0,     0,     0,   820,  2775,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6011,     0,     0,     0,  2776,  2777,
       0,     0,     0,     0,   820,     0,     0,     0,     0,  6023,
       0,     0,     0,  2778,  1950,     0,     0,  1672,     0,     0,
       0,     0,  1176,  2782,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1178,     0,     0,
       0,  6056,     0,     0,     0,     0,     0,  1190,  2779,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1206,  2780,  1176,     0,  2781,     0,
    2774,  1230,  1231,     0,     0,  2775,     0,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,  1267,     0,   775,   775,     0,  2776,  2777,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2778,     0,     0,     0,     0,     0,     0,     0,     0,
     775,     0,     0,   775,     0,     0,     0,     0,  2783,     0,
       0,  2784,  2785,  2786,     0,  2787,  2788,  2789,  2790,  2791,
    2792,     0,     0,     0,     0,  6013,  2779,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1672,
       0,  2782,     0,  2780,     0,     0,  2781,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,  6151,     0,     0,     0,     0,     0,     0,  2764,
       0,     0,  2765,     0,  1672,     0,  2766,  2767,  2768,     0,
       0,     0,     0,     0,     0,     0,     0,   776,     0,     0,
       0,     0,   418,  2769,   417,   417,   417,     0,     0,     0,
       0,  2771,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2772,  2245,     0,     0,     0,     0,     0,  2246,     0,
    2764,   775,     0,  2765,     0,     0,     0,  2766,  2767,  2768,
       0,   776,   417,     0,     0,     0,     0,     0,  2773,  2782,
       0,     0,     0,   776,  2769,     0,  2783,   775,     0,  2784,
    2785,  2786,  2771,  2787,  2788,  2789,  2790,  2791,  2792,     0,
       0,   775,  2772,  6333,     0,  2248,     0,     0,     0,     0,
     776,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2773,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   776,
       0,     0,     0,     0,     0,  2249,     0,     0,     0,     0,
       0,     0,     0,  2251,     0,     0,     0,  2252,  2253,  2254,
       0,     0,     0,     0,  2255,     0,     0,  2256,     0,     0,
       0,     0,   775,     0,  2783,  2257,     0,  2784,  2785,  2786,
       0,  2787,  2788,  2789,  2790,  2791,  2792,     0,  2774,     0,
       0,  6462,     0,  2775,  2258,     0,     0,     0,     0,     0,
       0,   776,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2776,  2777,   417,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   775,  2259,   775,  2778,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2774,
       0,   775,     0,   775,  2775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,  1672,     0,  1672,  2779,  2776,  2777,     0,  1672,     0,
       0,     0,   417,     0,     0,     0,     0,     0,     0,     0,
    2778,  2780,     0,     0,  2781,     0,  2260,   776,     0,     0,
    2261,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2262,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   775,  2263,     0,     0,  2779,     0,     0,     0,  1672,
       0,     0,     0,  2264,     0,     0,     0,     0,     0,     0,
       0,     0,  2780,     0,     0,  2781,  1672,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2265,     0,     0,   775,
       0,  1672,     0,     0,     0,     0,  3078,     0,     0,  2267,
    2268,     0,     0,     0,     0,     0,     0,  2782,     0,     0,
       0,   775,     0,     0,     0,  2764,     0,     0,  2765,   820,
       0,     0,  2766,  2767,  2768,     0,     0,     0,     0,     0,
    3079,     0,     0,     0,     0,     0,   776,     0,   776,  2769,
       0,     0,   775,     0,     0,   775,     0,  2771,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2772,  2782,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2270,     0,     0,     0,  1672,
       0,  1672,     0,     0,  2773,   776,     0,     0,     0,     0,
       0,     0,     0,     0,  1420,     0,     0,     0,     0,     0,
       0,     0,     0,  2271,     0,     0,     0,     0,     0,     0,
       0,     0,  2783,     0,     0,  2784,  2785,  2786,     0,  2787,
    2788,  2789,  2790,  2791,  2792,     0,   417,     0,     0,  6528,
       0,     0,   418,     0,     0,     0,     0,     0,  1420,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2764,     0,     0,  2765,     0,     0,     0,  2766,
    2767,  2768,     0,  2783,  1672,     0,  2784,  2785,  2786,     0,
    2787,  2788,  2789,  2790,  2791,  2792,  2769,     0,     0,     0,
    6551,     0,     0,  2764,  2771,     0,  2765,     0,     0,     0,
    2766,  2767,  2768,     0,  2772,     0,     0,     0,  1672,     0,
       0,     0,     0,     0,  2774,     0,     0,  2769,     0,  2775,
       0,  3796,     0,     0,     0,  2771,     0,     0,     0,     0,
       0,  2773,     0,  1672,     0,  2772,     0,     0,     0,  1672,
    2776,  2777,     0,     0,     0,     0,     0,     0,     0,     0,
    1401,     0,  1409,  1409,   820,  2778,  1409,     0,     0,     0,
    1421,     0,  2773,  1230,     0,     0,  1432,     0,  1453,     0,
       0,     0,     0,     0,     0,  1230,     0,     0,  1409,     0,
       0,  1230,     0,     0,     0,  1409,     0,  1230,     0,     0,
    2779,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1503,     0,     0,     0,  2780,     0,  1230,
    2781,  1401,     0,     0,  3797,  1409,     0,   820,  1672,  1409,
       0,     0,     0,     0,     0,     0,     0,     0,  1432,     0,
    1453,     0,     0,     0,  1672,  1585,   775,     0,  1409,     0,
       0,     0,     0,     0,     0,  1409,     0,   418,     0,  1672,
       0,  2774,     0,     0,     0,     0,  2775,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   776,     0,     0,     0,  2776,  2777,  1401,
       0,     0,  2774,     0,   820,   776,     0,  2775,     0,  1421,
     417,     0,  2778,     0,  1432,   417,  1453,   417,     0,     0,
       0,     0,     0,  2782,     0,     0,     0,     0,  2776,  2777,
       0,     0,     0,     0,     0,     0,     0,  1409,     0,     0,
       0,     0,     0,  2778,     0,   417,     0,  2779,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   417,  2780,     0,     0,  2781,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2779,   775,
       0,  1672,   775,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2780,     0,  1230,  2781,     0,
       0,  1790,  1672,     0,     0,     0,     0,     0,   775,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1230,     0,
    1807,     0,     0,     0,     0,     0,     0,  1672,  2783,     0,
       0,  2784,  2785,  2786,     0,  2787,  2788,  2789,  2790,  2791,
    2792,     0,     0,     0,     0,  6589,     0,     0,     0,     0,
    1930,  1930,     0,     0,     0,   820,  1230,     0,     0,     0,
    2782,  1672,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1230,     0,     0,  1230,     0,
       0,     0,   775,   775,     0,     0,     0,  1930,   417,     0,
       0,  2782,     0,     0,     0,     0,   775,     0,  1230,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     418,     0,   776,     0,     0,   775,     0,     0,     0,     0,
       0,  2764,     0,     0,  2765,     0,     0,     0,  2766,  2767,
    2768,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2769,     0,     0,     0,  1230,
       0,     0,     0,  2771,     0,  3798,     0,     0,     0,     0,
       0,     0,     0,  2772,     0,  2783,   417,     0,  2784,  2785,
    2786,     0,  2787,  2788,  2789,  2790,  2791,  2792,  2764,     0,
    3585,  2765,     0,     0,     0,  2766,  2767,  2768,     0,     0,
    2773,     0,     0,     0,   775,  1672,  2783,     0,     0,  2784,
    2785,  2786,  2769,  2787,  2788,  2789,  2790,  2791,  2792,   418,
    2771,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2772,     0,  1432,     0,     0,     0,     0,   776,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,     0,     0,  1432,
       0,  1420,     0,     0,  1230,  1790,     0,  2773,     0,     0,
       0,     0,     0,  1409,  1409,     0,   776,     0,     0,     0,
    2764,     0,     0,  2765,     0,     0,     0,  2766,  2767,  2768,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2769,     0,  4462,     0,     0,     0,
       0,  4463,  2771,     0,     0,     0,     0,     0,  1672,     0,
       0,     0,  2772,     0,     0,     0,     0,     0,     0,     0,
    2774,     0,  1790,     0,     0,  2775,  1420,  1420,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,     0,  1672,  2773,
       0,  1421,     0,     0,     0,  1453,  2776,  2777,     0,     0,
       0,     0,     0,  1663,     0,     0,     0,     0,     0,     0,
       0,  2778,     0,     0,  1409,     0,     0,     0,     0,     0,
       0,     0,   776,     0,     0,     0,     0,  2774,     0,     0,
       0,  1663,  2775,     0,     0,     0,     0,     0,     0,     0,
    1230,     0,     0,     0,  1432,     0,  2779,     0,  1790,     0,
       0,  1409,  1409,  2776,  2777,     0,     0,     0,     0,     0,
       0,     0,     0,  2780,     0,     0,  2781,     0,  2778,     0,
       0,     0,     0,     0,  1230,  1230,  1230,     0,  1409,     0,
    1401,     0,     0,     0,  6493,  2509,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   775,
     418,     0,     0,  2779,   417,     0,     0,   820,     0,  2774,
       0,     0,     0,     0,  2775,     0,     0,     0,     0,     0,
    2780,     0,     0,  2781,     0,     0,     0,     0,     0,     0,
       0,  1672,     0,     0,     0,  2776,  2777,     0,     0,     0,
       0,     0,     0,   775,     0,     0,     0,     0,     0,  5090,
    2778,     0,     0,     0,   418,   775,     0,     0,     0,  2782,
       0,     0,  1432,  1409,     0,  1790,     0,     0,  1409,  1409,
       0,     0,  2764,     0,   418,  2765,  1420,  1420,  1672,  2766,
    2767,  2768,   775,     0,     0,  2779,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2769,     0,     0,  4421,
       0,     0,  2780,     0,  2771,  2781,     0,     0,     0,  1930,
       0,     0,     0,     0,  2772,     0,  2782,     0,     0,     0,
       0,   775,     0,     0,     0,     0,     0,     0,  6494,     0,
       0,     0,     0,     0,  5091,     0,     0,     0,     0,     0,
       0,  2773,     0,     0,     0,     0,     0,  2660,  2660,     0,
       0,     0,  1230,     0,  1176,     0,     0,     0,     0,     0,
       0,  1790,     0,     0,  2783,     0,     0,  2784,  2785,  2786,
       0,  2787,  2788,  2789,  2790,  2791,  2792,     0,     0,     0,
       0,     0,     0,   775,     0,     0,  2700,     0,     0,  1230,
       0,     0,  2707,     0,  1930,     0,     0,     0,  2782,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1930,     0,     0,     0,     0,     0,  1672,     0,     0,
       0,  2783,     0,     0,  2784,  2785,  2786,  1672,  2787,  2788,
    2789,  2790,  2791,  2792,     0,     0,     0,     0,     0,     0,
       0,  1930,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2774,     0,     0,     0,     0,  2775,     0,     0,   775,
       0,     0,     0,  1930,  1930,  1930,     0,  1930,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2776,  2777,     0,
       0,     0,     0,     0,     0,     0,     0,  1930,     0,     0,
       0,     0,  2778,  2783,     0,     0,  2784,  2785,  2786,     0,
    2787,  2788,  2789,  2790,  2791,  2792,     0,     0,     0,   820,
     820,     0,     0,     0,     0,  1663,     0,  2764,     0,     0,
    2765,     0,     0,     0,  2766,  2767,  2768,  2779,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1230,  1663,
       0,  2769,     0,     0,  2780,     0,     0,  2781,     0,  2771,
       0,     0,     0,     0,  1672,     0,  1663,     0,     0,  2772,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   775,     0,
     775,     0,     0,     0,     0,     0,  2773,     0,     0,     0,
       0,     0,  1672,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2764,     0,     0,  2765,     0,     0,     0,  2766,
    2767,  2768,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,     0,     0,     0,     0,  2769,   775,     0,  4467,
       0,     0,     0,     0,  2771,     0,     0,  2883,  2893,     0,
    2782,     0,     0,     0,  2772,     0,  1930,     0,     0,     0,
    1930,  1930,     0,     0,     0,     0,     0,  1663,     0,     0,
       0,  1230,  1230,  2934,     0,  1930,     0,     0,     0,     0,
       0,  2773,     0,     0,   417,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,     0,     0,     0,     0,
     820,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2774,     0,     0,     0,
       0,  2775,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2776,  2777,     0,     0,  1432,     0,     0,     0,
       0,     0,     0,     0,     0,  2783,     0,  2778,  2784,  2785,
    2786,     0,  2787,  2788,  2789,  2790,  2791,  2792,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2779,     0,     0,     0,     0,     0,  3088,     0,
       0,  2774,     0,     0,     0,     0,  2775,     0,     0,  2780,
       0,  1663,  2781,     0,     0,  1672,     0,     0,     0,  1230,
    3117,     0,     0,     0,     0,     0,     0,  2776,  2777,     0,
       0,  4435,     0,     0,  1230,     0,     0,  1409,     0,     0,
       0,     0,  2778,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3177,     0,
       0,     0,     0,     0,     0,     0,     0,  1453,     0,  1230,
       0,  1672,     0,     0,     0,     0,     0,  2779,     0,     0,
       0,     0,  1230,     0,     0,  1230,     0,     0,     0,   417,
       0,     0,     0,     0,  2780,     0,     0,  2781,     0,     0,
       0,     0,     0,     0,     0,  2782,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   775,     0,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,  2245,   775,     0,     0,
       0,     0,  2246,  1409,  1409,  1409,  1409,  1230,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2893,     0,
    2883,  3297,     0,  1230,     0,     0,     0,     0,     0,  2248,
       0,     0,     0,     0,     0,  1409,  1409,     0,     0,     0,
    2782,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1409,     0,     0,
    2783,     0,  1790,  2784,  2785,  2786,  1672,  2787,  2788,  2789,
    2790,  2791,  2792,     0,     0,     0,     0,     0,     0,  2249,
       0,     0,     0,     0,     0,     0,  1230,  2251,     0,     0,
       0,  2252,  2253,  2254,     0,     0,     0,     0,  2255,     0,
       0,  2256,     0,     0,  1409,  1409,  1409,  1409,     0,  2257,
       0,     0,     0,     0,     0,     0,     0,  1230,     0,     0,
       0,     0,     0,     0,  1230,     0,     0,  3297,  2258,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1401,     0,  2783,  1401,     0,  2784,  2785,
    2786,   820,  2787,  2788,  2789,  2790,  2791,  2792,  1930,     0,
       0,  2259,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,     0,   775,     0,     0,     0,     0,     0,
    1421,  1421,     0,     0,     0,     0,  1672,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1453,  1453,     0,     0,
       0,  1790,     0,     0,     0,     0,     0,     0,     0,     0,
    2260,     0,     0,     0,  2261,     0,     0,  1409,  1409,     0,
    1672,  1663,     0,  1409,     0,  2262,     0,     0,     0,     0,
       0,     0,  1432,     0,     0,     0,  2263,     0,  1230,     0,
       0,     0,     0,     0,     0,     0,     0,  2264,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   417,  2660,     0,     0,     0,     0,     0,     0,  1409,
    2265,  1421,     0,     0,     0,  1230,  1230,     0,  1409,   775,
    1663,     0,     0,  2267,  2268,  1230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1230,     0,     0,     0,     0,  1176,  1176,   775,     0,
    1672,  3583,     0,     0,  2269,  1672,  1672,     0,     0,     0,
       0,     0,  1930,  1930,     0,     0,     0,     0,  1930,  1930,
       0,  1663,     0,     0,     0,  1930,  1930,  1930,     0,     0,
       0,  1930,  1453,  1930,  1930,  1930,  1930,  1930,  1930,     0,
    1930,     0,  1930,  1930,  1663,     0,  1930,     0,     0,  2270,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1930,  1930,  1930,  1930,     0,     0,     0,  1409,  1930,
       0,     0,     0,  1930,     0,     0,  1930,  2271,     0,  1930,
    1930,  1930,  1930,  1930,  1930,  1930,  1930,  1930,     0,  1930,
       0,     0,     0,     0,     0,     0,  1230,  1930,     0,     0,
    1930,     0,     0,     0,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1663,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1663,
       0,     0,     0,     0,     0,     0,  1230,     0,  1230,  1663,
    1930,     0,     0,     0,  1230,     0,     0,  1432,  1432,     0,
       0,     0,  1663,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,     0,     0,     0,  2893,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1230,     0,     0,     0,     0,     0,     0,  3824,     0,
    3829,     0,     0,     0,     0,     0,   417,     0,  1663,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   417,     0,  1663,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1663,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1663,     0,     0,     0,     0,
       0,     0,     0,  2764,     0,     0,  2765,     0,     0,     0,
    2766,  2767,  2768,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   820,     0,     0,     0,     0,  2769,     0,     0,
       0,  1176,     0,  1176,     0,  2771,     0,  1663,  1663,     0,
       0,     0,     0,     0,     0,  2772,  1672,     0,     0,     0,
    1930,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1401,     0,  1409,  1409,     0,     0,     0,  1421,
       0,  1453,  2773,  1409,     0,  1409,     0,     0,     0,  1409,
       0,     0,  1230,     0,     0,     0,     0,     0,     0,  2764,
       0,     0,  2765,     0,     0,     0,  2766,  2767,  2768,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2769,     0,  3117,  4478,     0,     0,     0,
       0,  2771,     0,     0,     0,  3974,  1230,     0,     0,     0,
       0,  2772,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3992,     0,     0,     0,     0,  2764,  1230,     0,  2765,
       0,  1230,     0,  2766,  2767,  2768,     0,     0,  2773,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1790,     0,
    2769,     0,     0,  4472,  1230,     0,     0,     0,  2771,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2772,  4047,
    4047,     0,  2774,     0,     0,     0,     0,  2775,     0,  1230,
    1230,     0,     0,  1230,     0,   820,     0,     0,  1663,     0,
       0,     0,     0,     0,     0,  2773,     0,     0,  2776,  2777,
       0,     0,     0,     0,  1409,     0,     0,  1409,     0,     0,
       0,     0,     0,  2778,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1230,
    1230,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4134,     0,  4137,  4139,  2779,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2774,     0,
       0,     0,     0,  2775,     0,  2780,     0,     0,  2781,     0,
       0,     0,     0,     0,     0,     0,     0,  2893,     0,  1432,
       0,     0,     0,     0,  2776,  2777,  1409,     0,     0,     0,
       0,     0,     0,     0,  1409,  1409,     0,     0,     0,  2778,
       0,  1409,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1930,  2774,  1409,     0,     0,     0,
    2775,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3117,  2779,     0,     0,     0,     0,     0,
       0,  2776,  2777,     0,     0,  4047,     0,  1230,     0,     0,
    1230,  2780,     0,     0,  2781,  4244,  2778,     0,  1176,     0,
       0,  2782,     0,     0,     0,     0,     0,     0,     0,     0,
    1790,     0,  1409,  1930,     0,     0,     0,     0,     0,     0,
    2764,     0,     0,  2765,     0,     0,     0,  2766,  2767,  2768,
    4134,  2779,     0,     0,     0,     0,     0,     0,     0,     0,
    1409,     0,  4278,     0,  2769,     0,     0,     0,  2780,     0,
       0,  2781,  2771,     0,     0,     0,  1663,  2509,     0,     0,
    1663,  1663,  2772,     0,     0,     0,     0,     0,   820,  1930,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4324,     0,     0,     0,  2782,     0,  2773,
       0,     0,     0,  1409,     0,     0,     0,     0,  1409,  4047,
    1409,  4047,     0,     0,     0,     0,  2783,     0,     0,  2784,
    2785,  2786,     0,  2787,  2788,  2789,  2790,  2791,  2792,     0,
       0,     0,  2764,     0,  1663,  2765,     0,     0,     0,  2766,
    2767,  2768,     0,     0,     0,     0,  1663,     0,     0,     0,
       0,     0,     0,     0,  2782,     0,  2769,     0,     0,  5097,
       0,     0,  2660,     0,  2771,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2772,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1663,     0,     0,     0,     0,  1432,     0,     0,     0,     0,
       0,  2773,  2783,     0,     0,  2784,  2785,  2786,  1230,  2787,
    2788,  2789,  2790,  2791,  2792,     0,     0,     0,     0,  2774,
       0,  1930,  1401,     0,  2775,     0,     0,     0,  1421,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1409,     0,     0,  2776,  2777,     0,     0,  1930,
       0,     0,     0,     0,  1930,     0,     0,     0,     0,  2783,
    2778,     0,  2784,  2785,  2786,     0,  2787,  2788,  2789,  2790,
    2791,  2792,     0,     0,     0,     0,     0,  1930,  1930,  1930,
       0,     0,  1930,     0,     0,     0,     0,     0,     0,     0,
    1930,  1930,  1930,  1930,     0,  2779,     0,     0,     0,     0,
       0,     0,     0,  1930,     0,     0,  1930,     0,  1930,     0,
       0,     0,  2780,     0,     0,  2781,     0,     0,     0,  1930,
    1930,  2774,     0,  1930,     0,     0,  2775,     0,     0,     0,
       0,     0,     0,     0,     0,  1453,     0,  1930,     0,  1930,
       0,  1930,     0,     0,     0,     0,     0,  2776,  2777,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1930,  2778,     0,     0,  1230,     0,     0,     0,     0,
       0,     0,  4542,     0,  1930,  1930,  1930,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2779,     0,  1930,
       0,     0,     0,  1663,     0,     0,     0,     0,  2782,     0,
       0,     0,     0,     0,  2780,     0,     0,  2781,     0,     0,
       0,     0,     0,  4588,     0,     0,     0,     0,  4590,     0,
    1930,     0,     0,     0,     0,  1930,     0,     0,     0,     0,
       0,  1930,     0,     0,  5043,     0,     0,     0,     0,     0,
       0,  4542,     0,     0,     0,  4611,     0,     0,  4614,     0,
    3829,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1663,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2782,     0,     0,  2783,     0,   774,  2784,  2785,  2786,     0,
    2787,  2788,  2789,  2790,  2791,  2792,  1930,     0,  4047,     0,
       0,     0,  2245,  2660,     0,     0,     0,     0,  2246,     0,
       0,     0,   933,     0,     0,     0,     0,     0,     0,     0,
       0,  2247,     0,     0,     0,     0,     0,     0,     0,     0,
    1409,     0,  1409,  1409,  1409,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2248,     0,     0,     0,     0,
       0,     0,     0,     0,   933,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2783,     0,     0,  2784,  2785,
    2786,     0,  2787,  2788,  2789,  2790,  2791,  2792,     0,     0,
       0,     0,     0,     0,     0,  2249,     0,     0,  2250,     0,
       0,     0,  1663,  2251,     0,     0,  1216,  2252,  2253,  2254,
       0,     0,     0,     0,  2255,     0,  1216,  2256,  1216,     0,
       0,     0,     0,  1663,  1790,  2257,     0,     0,     0,     0,
       0,   933,     0,     0,     0,     0,     0,  1663,     0,     0,
       0,     0,     0,     0,  2258,     0,     0,     0,     0,     0,
       0,     4,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     0,     0,     0,     0,     0,  2259,     0,     0,
       0,     6,     7,     0,     0,     0,     0,     0,     9,    10,
       0,     0,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,     0,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,     0,     0,
       0,    45,     0,     0,     0,     0,  2260,     0,     0,     0,
    2261,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2262,     0,     0,   820,     0,     0,     0,     0,     0,
       0,     0,  2263,     0,  1409,     0,     0,     0,     0,  4047,
    4047,     0,     0,  2264,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1790,     0,     0,     0,     0,     0,  2265,     0,     0,  1230,
    1230,  1230,     0,     0,     0,     0,  2266,     0,     0,  2267,
    2268,     0,     0,     0,  4909,     0,     0,     0,     0,     0,
    1230,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2269,     0,     0,     0,     0,  2660,  1230,     0,     0,     0,
       0,     0,     0,     0,     0,  2660,  1230,  1230,     0,     0,
       0,  1230,     0,    47,     0,     0,     0,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,  1663,     0,    48,  1663,  2270,  1663,     0,     0,   820,
       0,  1663,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,  4324,     0,     0,
       0,     0,     0,  2271,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
    1409,     0,     0,     0,     0,  1432,     0,     0,     0,     0,
       0,     0,  1663,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1230,     0,     0,     0,  1663,
       0,     0,     0,     0,  1432,     0,    51,     0,     0,    52,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1230,     0,     0,     0,  1663,     0,     0,    53,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1930,     0,     0,     0,     0,     0,     0,
       0,     0,  1930,     0,     0,     0,     0,     0,  1930,     0,
    1930,     0,     0,  1930,     0,     0,     0,     0,  1930,  1930,
    1930,  1930,     0,     0,  1930,  1930,  1930,  1930,  1930,  1930,
    1930,  1930,  1930,  1930,     0,     0,     0,  1930,  1930,     0,
       0,     0,     0,     0,     0,     0,     0,  1930,     0,     0,
       0,  1930,     0,     0,     0,  1930,     0,     0,     0,     0,
       0,     0,  1663,  1930,  1663,     0,  1930,     0,  1930,     0,
       0,     0,    54,     0,     0,     0,     0,  1930,     0,     0,
    1930,  1930,     0,     0,     0,  1930,  1930,     0,     0,     0,
    5122,     0,  1930,     0,     0,     0,     0,     0,     0,  1230,
    1230,  1230,  1401,     0,     0,  4542,  5144,     0,     0,     0,
    5144,  5158,  5144,     0,     0,     0,     0,     0,  1930,     0,
       0,     0,     0,     0,  1930,  1930,  1930,    55,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,     0,     0,     0,     0,  1663,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    57,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1930,     0,
       0,  1663,     0,     0,     0,     0,     0,     0,     0,     0,
      58,     0,  3829,     0,  1930,     0,     0,     0,    59,     0,
      60,    61,    62,    63,    64,     0,  1663,    65,    66,  1721,
       0,     0,  1663,     0,    71,  1722,     0,     0,     0,     0,
       0,     0,  5231,  2660,  2660,     0,  3297,  1284,     0,     0,
       0,  1285,     0,  1286,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1409,  1409,  1409,  1409,     0,  1287,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1288,     0,     0,     0,
       0,  1663,     0,  5287,     0,     0,     0,     0,     0,     0,
    1230,     0,     0,  1289,     0,     0,     0,  1663,     0,     0,
       0,     0,     0,   933,     0,  1401,     0,     0,  1290,     0,
       0,     0,  1663,     0,     0,     0,     0,     0,     0,     0,
    1291,     0,   774,     0,     0,     0,     0,     0,  1292,     0,
       0,     0,     0,   774,     0,     0,     0,     0,     0,  1293,
       0,     0,  1294,     0,     0,     0,     0,   774,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1295,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1296,     0,     0,     0,  1297,
       0,     0,  1298,     0,  5376,   774,     0,     0,     0,     0,
       0,     0,     0,   820,     0,   774,     0,     0,     0,  1432,
    1299,     0,     0,     0,     0,     0,     0,     0,     0,   774,
    1300,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1284,  1663,     0,     0,     0,     0,  1286,
       0,     0,     0,  1409,     0,   774,     0,  1230,     0,     0,
    1409,  1301,  1930,     0,  1287,  1663,  1302,     0,     0,  1230,
       0,   774,     0,     0,     0,  5422,     0,     0,     0,     0,
       0,   774,     0,  1303,     0,     0,     0,  3117,     0,     0,
    1663,     0,     0,     0,     0,   774,     0,     0,     0,     0,
       0,     0,  1288,     0,     0,     0,  1230,     0,     0,     0,
    4542,     0,     0,   774,     0,     0,     0,     0,     0,  1289,
    4134,     0,  1304,     0,  1663,     0,     0,     0,  5473,     0,
       0,     0,     0,     0,  1290,     0,  1230,     0,     0,     0,
    3297,     0,     0,     0,  1930,  1930,  1291,     0,     0,     0,
       0,     0,     0,     0,  1292,     0,     0,     0,     0,     0,
       0,  1305,     0,     0,     0,  1293,     0,     0,  1294,     0,
       0,     0,  1306,     0,  4324,  4324,  4324,  4324,  4324,     0,
       0,  1307,  4047,  1295,  4047,     0,     0,  1308,  1309,     0,
       0,     0,     0,     0,     0,  1310,     0,     0,     0,     0,
       0,  1296,     0,     0,     0,  1297,     0,     0,  1298,     0,
    1432,     0,     0,     0,     0,     0,     0,     0,  1216,     0,
     774,     0,  1216,     0,     0,     0,  1299,  1311,  1930,  1312,
       0,     0,  1313,     0,     0,     0,  1300,     0,     0,  1930,
       0,     0,     0,     0,     0,  1314,     0,     0,  1315,     0,
    1316,     0,     0,     0,     0,     0,     0,     0,  1663,     0,
       0,     0,     0,  1317,  1318,     0,     0,  1301,     0,  1930,
       0,     0,  1302,     0,     0,     0,     0,  1319,     0,  1930,
    1930,     0,     0,     0,     0,     0,  1930,  1930,     0,  1303,
       0,  1930,     0,     0,     0,     0,  1930,     0,     0,  1930,
    1930,     0,     0,     0,  1930,  5582,     0,     0,     0,     0,
    1930,  1230,  1230,  1230,  1230,     0,     0,     0,  5144,  5158,
    5144,     0,  1930,  5144,     0,     0,  5596,     0,  1304,     0,
    4542,     0,     0,     0,  4542,     0,     0,     0,     0,     0,
    5611,     0,     0,     0,     0,     0,     0,  1930,   774,   774,
       0,     0,  1930,     0,     0,     0,     0,     0,  1930,     0,
       0,  1663,     0,     0,     0,     0,     0,  1305,     0,     0,
       0,  5633,  1453,     0,     0,     0,  2245,     0,  1306,     0,
    1930,     0,  2246,     0,  4611,     0,     0,  1307,     0,  3829,
       0,  1663,     0,  1308,  1309,  2348,     0,     0,     0,  2245,
       0,  1310,     0,     0,     0,  2246,     0,     0,  1176,     0,
       0,  1930,     0,     0,     0,     0,     0,     0,  2348,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2248,
       0,  4047,  4047,  1311,     0,  1312,     0,     0,  1313,     0,
       0,     0,     0,     0,  1216,  1216,     0,  2245,     0,  3117,
       0,  1314,  2248,  2246,  1315,     0,  1316,     0,     0,     0,
       0,     0,  5690,     0,     0,     0,     0,     0,     0,  1317,
    1318,     0,     0,     0,     0,     0,     0,     0,     0,  2249,
       0,     0,     0,  1319,  2349,     0,     0,  2251,     0,     0,
       0,  2252,  2253,  2254,     0,     0,     0,     0,  2255,     0,
    2248,  2256,  2249,     0,     0,     0,     0,  2349,     0,  2257,
    2251,     0,  1083,     0,  2252,  2253,  2254,  1084,  1930,     0,
       0,  2255,     0,     0,  2256,     0,     0,     0,  2258,  1085,
       0,     0,  2257,     0,  1663,     0,     0,     0,     0,     0,
    1409,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2249,  2258,     0,     0,     0,  1409,  1086,     0,  2251,     0,
       0,  2259,  2252,  2253,  2254,     0,     0,     0,     0,  2255,
    1087,     0,  2256,     0,     0,     0,     0,     0,     0,     0,
    2257,  1663,     0,     0,  2259,     0,  1088,     0,     0,     0,
    1930,     0,     0,     0,     0,     0,     0,     0,     0,  2258,
       0,     0,     0,     0,  1401,  1089,     0,     0,     0,     0,
    3117,     0,     0,     0,     0,     0,     0,     0,     0,  5778,
    2260,     0,  2660,     0,  2261,     0,     0,     0,     0,     0,
       0,     0,  2259,     0,  1090,  2262,     0,  1930,     0,     0,
       0,     0,     0,  2260,     0,  1091,  2263,  2261,     0,  1409,
       0,  3117,     0,     0,  1092,     0,     0,  2264,  2262,     0,
       0,     0,     0,     0,     0,     0,     0,  1093,     0,  2263,
       0,     0,  1094,     0,   774,     0,     0,     0,     0,  1095,
    2264,  1096,  1230,     0,     0,  5840,     0,     0,     0,   774,
    2265,  2260,     0,     0,     0,  2261,     0,  1097,     0,     0,
    2350,     0,     0,  2267,  2268,     0,  2262,     0,     0,     0,
    1432,     0,     0,  2265,     0,     0,     0,  2263,   774,     0,
    1663,     0,     0,  4105,     0,     0,  2267,  2268,  2264,     0,
    1663,     0,  1930,     0,  2351,     0,     0,     0,     0,     0,
       0,  1930,     0,  1098,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   774,     0,     0,  4106,  1930,  1930,
    1099,  2265,  1930,     0,     0,     0,     0,     0,     0,     0,
       0,  3965,     0,     0,  2267,  2268,   774,  1401,     0,  2270,
    5144,  1100,  1101,     0,  4542,     0,     0,     0,     0,  4542,
       0,   774,  4542,  1401,  1102,  4134,   933,  5900,     0,   774,
    1930,  1930,  2270,     0,     0,  2269,  1103,  2271,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   975,     0,     0,
    1104,     0,     0,     0,     0,     0,     0,  5231,     0,  1930,
    2271,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5231,  1453,  1409,  1409,  1409,     0,     0,     0,  1105,
    2270,     0,     0,     0,     0,  1106,     0,     0,  1107,     0,
       0,     0,     0,     0,     0,  1108,     0,  1663,  1109,     0,
       0,     0,     0,     0,     0,  1110,     0,     0,  2271,     0,
       0,     0,  1930,     0,     0,     0,     0,     0,     0,     0,
    1111,     0,     0,  1421,  1453,     0,     0,  1112,     0,     0,
       0,     0,     0,     0,     0,  1663,  1113,     0,     0,  1114,
       0,     0,     0,  1115,     0,     0,     0,     0,     0,     0,
    1116,     0,  1117,     0,     0,     0,     0,  1118,     0,     0,
       0,     0,     0,  1663,   774,     0,     0,  1421,     0,     0,
    1230,  1119,   774,   774,     0,     0,     0,     0,     0,     0,
       0,     0,  5422,     0,  1120,  1230,     0,     0,     0,     0,
    1230,     0,  1790,     0,     0,  4047,     0,     0,     0,     0,
       0,     0,  3117,   941,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1230,     0,     0,
       0,  5473,     0,     0,     0,     0,     0,     0,  1663,     0,
       0,     0,     0,     0,     0,     0,     0,  1409,  1230,  5231,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   941,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1930,     0,     0,  1930,     0,  1930,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1930,
       0,     0,     0,     0,     0,  1930,     0,  1220,     0,  4542,
       0,     0,   933,  5900,     0,     0,     0,  1220,     0,  1220,
    1930,     0,     0,     0,     0,     0,     0,     0,     0,  6134,
       0,     0,   941,   774,     0,     0,  6136,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1663,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1230,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     4,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   933,     0,  1930,     0,     0,     0,     5,
       0,     0,     0,  1216,     0,  1409,  1409,  1409,  1409,     6,
       7,     0,     0,     0,  1663,     0,     9,    10,     0,     0,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,  1216,  1401,     0,    37,    38,
      39,    40,    41,    42,    43,    44,     0,     0,     0,    45,
       0,     0,  1790,     0,     0,     0,     0,     0,     0,  4542,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    46,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1930,     0,     0,  1401,     0,     0,  1930,     0,     0,     0,
    6296,     0,     0,     0,     0,     0,     0,  1930,     0,     0,
       0,     0,  1930,     0,  1930,     0,  1930,     0,     0,  1663,
       0,     0,     0,     0,     0,  5231,     0,     0,     0,     0,
       0,  1409,     0,  1453,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1930,     0,     0,     0,     0,   774,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    47,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,     0,     0,     0,     0,     0,     0,     0,  2660,
    2660,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,     0,     0,     0,     0,   933,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1409,     0,     0,     0,     0,     0,  6377,    50,     0,     0,
    1930,     0,     0,     0,     0,     0,     0,     0,  6388,     0,
       0,     0,     0,   774,     0,     0,     0,     0,     0,  1663,
       0,     0,     0,   774,     0,     0,     0,     0,     0,  5840,
       0,     0,     0,     0,    51,   774,     0,    52,     0,  1930,
    1930,     0,     0,     0,  4134,     0,     0,  1930,     0,     0,
       0,     0,     0,  1663,     0,    53,     0,  1930,     0,     0,
    6134,     0,     0,     0,     0,  3829,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1421,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1663,     0,     0,     0,  1409,     0,     0,
       0,     0,     0,     0,  2660,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   774,   774,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   774,     0,     0,  1401,     0,     0,     0,     0,  1930,
       0,     0,     0,   774,   774,     0,     0,     0,     0,  5231,
      54,     0,     0,  1663,     0,  1421,  1421,     0,  1663,  1663,
    1930,     0,     0,     0,     0,     0,     0,     0,     0,  1930,
       0,     0,   774,  6296,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1930,     0,     0,     0,
       0,     0,     0,  1409,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    55,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      56,     0,     0,     0,  6388,  1409,  1409,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    57,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1930,     0,     0,     0,     0,  1930,
       0,     0,     0,     0,     0,     0,     0,     0,    58,     0,
       0,     0,     0,  1663,     0,     0,    59,     0,    60,    61,
      62,    63,    64,     0,     0,    65,    66,  1721,  2609,     0,
       0,     0,    71,     0,     0,     0,     0,     0,     0,  1930,
       0,     0,     0,     0,     0,  1930,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   933,     0,     0,     0,
    1409,  1401,     0,     0,     0,     0,     0,     0,  6296,     0,
       0,  1401,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1421,  1421,     0,  1401,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   941,     0,     0,     4,     0,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,     0,     5,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     6,     7,     0,
       0,     0,     0,     0,     9,    10,     0,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,  1403,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,     0,     0,     0,    45,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2245,     0,  1663,
       0,     0,     0,  2246,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2245,     0,     0,
     774,  1403,     0,  2246,     0,    46,     0,  1675,     0,     0,
    2311,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   774,     0,     0,     0,     0,     0,     0,     0,
    2248,     0,     0,     0,  2312,  1675,     0,     0,     0,     0,
       0,     0,   774,     0,     0,     0,     0,   933,   774,     0,
    2248,     0,   774,     0,     0,     0,     0,     0,     0,     0,
     774,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   774,     0,
    2249,     0,     0,     0,     0,     0,  2313,     0,  2251,    47,
       0,     0,  2252,  2253,  2254,     0,     0,     0,     0,  2255,
    2249,     0,  2256,     0,     0,     0,     0,     0,  2251,    48,
    2257,     0,  2252,  2253,  2254,     0,     0,     0,     0,  2255,
       0,     0,  2256,   774,     0,     0,     0,     0,     0,  2258,
    2257,     0,    49,     0,     0,  1216,     0,     0,     0,     0,
       0,   774,   774,     0,     0,     0,     0,     0,     0,  2258,
       0,     0,  1403,  1403,     0,    50,     0,     0,     0,  1220,
       0,     0,  2259,  1220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2314,
       0,     0,  2259,     0,     0,   933,   774,     0,     0,  1403,
     933,     0,    51,     0,     0,    52,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,     0,     0,     0,     0,
       0,  2260,     0,     0,   774,  2261,   933,  2315,     0,     0,
    2316,     0,   774,     0,     0,     0,  2262,  1216,     0,   774,
       0,  2317,     0,   774,     0,  2261,     0,  2263,     0,     0,
       0,     0,     0,     0,     0,     0,  2262,     0,  2264,     0,
       0,     0,     0,   774,     0,     0,     0,  2263,     0,   774,
       0,     0,     0,   774,     0,     0,   933,  2318,  2264,     0,
       0,     0,     0,     0,     0,     0,   774,     0,     0,     0,
       0,  2265,     0,     0,     0,     0,     0,     0,     0,   774,
       0,  4149,     0,     0,  2267,  2268,     0,     0,    54,   774,
       0,  2265,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2319,     0,     0,  2267,  2268,  2320,     0,     0,     0,
       0,     0,     0,     0,     0,  4150,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2321,     0,
       0,     0,     0,     0,     0,  2322,     0,     0,     0,     0,
       0,     0,     0,    55,     0,     0,     0,     0,     0,     0,
       0,  2323,     0,     0,     0,     0,   933,     0,    56,     0,
    2270,     0,     0,     0,     0,  1220,  1220,     0,     0,     0,
       0,     0,     0,     0,     0,    57,     0,     0,     0,     0,
    2270,     0,     0,     0,     0,     0,     0,     0,  2271,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,    58,     0,  2271,  1675,
       0,     0,     0,  1403,    59,     0,    60,    61,    62,    63,
      64,     0,     0,    65,    66,  1721,  3496,     0,     0,     0,
      71,     0,     0,  1675,     0,     0,     0,     0,     0,     0,
       0,     0,  2245,     0,     0,     0,     0,   774,  2246,     0,
    1675,     0,     0,     0,     0,  2311,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2312,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2248,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,   774,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2249,     0,     0,     0,     0,
       0,  1675,     0,  2251,     0,     0,     0,  2252,  2253,  2254,
     774,     0,     0,     0,  2255,     0,     0,  2256,     0,     0,
       0,     0,     0,     0,     0,  2257,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   774,     0,     0,
       0,     4,     0,     0,  2258,   774,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     6,     7,     0,  2314,     0,     0,  2259,     9,    10,
       0,  1403,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,     0,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,     0,     0,
       0,    45,  2315,     0,     0,  2316,     0,     0,     0,   933,
       0,     0,     0,     0,     0,   933,  2317,     0,     0,     0,
    2261,     0,     0,     0,     0,  1675,     0,     0,     0,     0,
       0,  2262,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2263,     0,  2245,     0,  1403,   941,     0,     0,
    2246,     0,  2318,  2264,     0,     0,     0,     0,     0,    46,
       0,     0,     0,  1403,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2265,     0,     0,     0,
       0,     0,     0,  1403,     0,     0,  4080,  2248,     0,  2267,
    2268,  2320,     0,     0,     0,     0,   774,     0,     0,     0,
       0,  1408,  1410,     0,     0,  1413,     0,     0,     0,     0,
       0,     0,     0,  2321,     0,  1403,  1403,  1403,     0,  1403,
    4081,     0,     0,     0,     0,     0,     0,  1466,     0,     0,
       0,     0,     0,    47,  1476,     0,  2323,  2249,     0,  1403,
       0,     0,     0,     0,     0,  2251,     0,     0,     0,  2252,
    2253,  2254,     0,    48,     0,     0,  2255,     0,     0,  2256,
       0,     0,     0,     0,  1555,  2270,     0,  2257,  1559,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2258,  1590,     0,     0,
       0,     0,     0,  2271,  1595,     0,     0,     0,     0,    50,
       0,     0,     0,     0,     0,  2245,     0,     0,     0,     0,
       0,  2246,     0,     0,     0,     0,     0,     0,     0,  2259,
       0,   774,   774,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    51,     0,     0,    52,
       0,     0,     0,     0,     0,     0,     0,     0,   774,     0,
       0,   774,     0,     0,     0,     0,     0,    53,  2248,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2260,     0,
       0,     0,  2261,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2262,     0,     0,     0,     0,  1403,     0,
       0,     0,  1403,  1403,  2263,     0,     0,     0,  2249,     0,
       0,     0,     0,     0,     0,  2264,  2251,  1403,     0,     0,
    2252,  2253,  2254,     0,     0,     0,     0,  2255,     0,     0,
    2256,     0,     0,     0,     0,     0,     0,     0,  2257,     0,
       0,     0,   933,   933,   933,     0,     0,     0,  2265,     0,
       0,     0,    54,     0,     0,     0,     0,  2258,  4683,     0,
       0,  2267,  2268,     0,     0,     0,     0,     0,     0,   774,
       0,   780,     0,     0,     0,     0,   824,     0,   824,     0,
     933,     0,     0,     0,     0,  1675,     0,     0,   824,     0,
    2259,     0,  4684,     0,   941,   774,     0,     0,     0,     0,
       0,     0,     0,     0,  1220,     0,     0,    55,     0,   774,
       0,     0,     0,   824,     0,     0,     0,     0,     0,     0,
       0,     0,    56,     0,     0,     0,     0,     0,     0,   824,
       0,     0,     0,     0,     0,     0,     0,  2270,     0,    57,
       0,   824,   824,     0,     0,   824,  1220,     0,     0,  2260,
       0,   824,     0,  2261,  1675,  1168,     0,     0,     0,     0,
       0,     0,     0,     0,  2262,  2271,     0,     0,     0,     0,
      58,     0,     0,     0,     0,  2263,     0,  1168,    59,     0,
      60,    61,    62,    63,    64,     0,  2264,    65,    66,  1721,
     774,     0,     0,     0,    71,     0,   824,     0,     0,     0,
       0,     0,     0,     0,     0,  1675,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2265,
       0,     0,     0,     0,     0,     0,     0,     0,  1675,  4744,
       0,     0,  2267,  2268,   933,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   774,     0,   774,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   774,
       0,   774,     0,  4745,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2286,  2287,     0,     0,     0,     0,     0,     0,
     933,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2270,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1675,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   774,
       0,     0,     0,  1675,     0,     0,  2271,     0,     0,     0,
       0,     0,     0,  1675,     0,     0,     0,     0,     0,     0,
     941,     0,     0,     0,     0,     0,  1675,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   774,     0,     0,
       0,     0,     0,  2420,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   774,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2456,  2457,  1675,     0,     0,     0,     0,     0,     0,     0,
     774,     0,     0,   774,     0,  1403,     0,     0,  1403,     0,
       0,     0,  1675,     0,     0,     0,   824,  2500,     0,     0,
    1403,     0,     0,     0,     0,     0,  1675,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1675,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,  1403,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1675,  1675,     0,   933,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2578,  2580,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1403,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1403,  1403,     0,     0,     0,     0,
    1403,  1403,     0,     0,     0,     0,     0,  1403,  1403,  1403,
       0,     0,     0,  1403,     0,  1403,  1403,  1403,  1403,  1403,
    1403,     0,  1403,     0,  1403,  1403,     0,     0,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1675,  1403,  1403,  1403,  1403,   941,     0,     0,
       0,  1403,     0,     0,     0,  1403,     0,     0,  1403,     0,
       0,  1403,  1403,  1403,  1403,  1403,  1403,  1403,  1403,  1403,
       0,  1403,     0,     0,   774,     0,   824,     0,     0,  1403,
       0,     0,  1403,     0,     0,     0,     0,  1015,     0,     0,
       0,     0,  1016,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1017,     0,     0,     0,     0,     0,
       0,     0,     0,  1018,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   824,   824,   933,     0,
       0,  1019,     0,   933,     0,   933,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,  1020,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1021,     0,     0,
       0,  -931,     0,   933,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   824,     0,     0,     0,     0,     0,
    1022,   933,     0,     0,     0,     0,     0,  1023,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   774,     0,     0,
     774,     0,     0,     0,     0,     0,     0,     0,     0,  1024,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,   774,     0,     0,  1026,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1027,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,     0,  1029,     0,  1030,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1675,     0, -1160,     0,  1675,  1675,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   941,     0,
       0,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
     774,   774,     0,     0,     0,     0,   933,     0,     0,  1032,
       0,     0,     0,     0,   774,     0,     0,     0,  -649,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   774,  1403,  1033,     0,     0,  1675,     0,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
    1675,     0,     0,     0,     0,     0,  1034,  1035,     0,     0,
    1036,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1220,     0,     0,     0,
       0,  1037,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1675,  1038,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -507,     0,  1614,   824,     0,
     824,     0,   774,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1039,     0,   941,     0,     0,     0,
       0,   941,     0,  1040,     0,     0,     0,     0,     0,     0,
    -507,     0,     0,  1041,     0,     0,     0,     0,     0,     0,
    1042,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,  3148,   941,     0,     0,
       0,     0,  1044,   824,     0,     0,   824,   824,  1220,     0,
       0,  -507,     0,     0,  1045,  1046,     0,  1047,  1048,     0,
       0,   780,     0,  1168,     0,  1168,     0,  1049,     0,     0,
       0,   780,  1050,     0,     0,   824,     0,     0,  1051,     0,
       0,     0,  1052,     0,     0,     0,  1053,   941,     0,     0,
       0,     0,     0,     0,     0,  1168,     0,  1168,     0,  -507,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3254,  3255,  3256,  3257,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     824,     0,   824,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1403,  1675,     0,     0,
       0,     0,     0,     0,  3306,  3307,     0,   941,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3332,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   774,     0,     0,
       0,     0,   933,     0,     0,  1403,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3392,  3393,  3394,  3395,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     780,   774,     0,     0,  1675,     0,     0,     0,     0,     0,
       0,     0,     0,   774,   780,   780,     0,     0,  2140,     0,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     774,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     780,     0,     0,     0,     0,     0,     0,     0,     0,   774,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3492,     0,     0,
       0,     0,  3495,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   774,     0,     0,     0,     0,  1675,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1403,  1403,     0,     0,  1675,     0,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1675,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,  1403,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1403,
    1403,  1403,     0,     0,  1403,     0,     0,   774,     0,     0,
       0,     0,  1403,  1403,  1403,  1403,     0,     0,     0,     0,
     941,     0,     0,     0,     0,  1403,   941,     0,  1403,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,  1403,     0,     0,  1403,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3686,     0,  1403,
       0,  1403,     0,  1403,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1665,     0,     0,  1403,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1403,     0,  1403,  1403,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1665,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,   774,     0,   774,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,     0,  1403,     0,     0,
       0,     0,     0,  1403,   780,     0,     0,     0,     0,   824,
       0,   824,     0,  1403,   824,   774,   824,     0,     0,   824,
     824,   824,     0,     0,     0,  2655,     0,     0,     0,     0,
       0,     0,   824,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   824,     0,     0,   824,
       0,     0,     0,     0,     0,  1675,     0,     0,  1675,   824,
    1675,     0,   933,     0,     0,  1675,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1675,     0,     0,     0,
       0,     0,     0,     0,     0,  6061,     0,     0,     0,     0,
       0,     0,     0,  1675,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1675,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3920,  3921,     0,     0,     0,     0,     0,
       0,     0,  3932,     0,  3934,  2810,     0,     0,  3938,     0,
       0,     0,     0,   941,   941,   941,   824,   824,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   780,     0,     0,     0,     0,   780,   780,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   941,     0,     0,     0,     0,  1675,     0,  1675,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   933,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   774,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   774,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1675,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1665,  4085,     0,     0,  4088,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1675,  1665,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1665,     0,     0,     0,   824,     0,   780,
    1675,     0,     0,     0,     0,   941,  1675,     0,     0,  2971,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4170,     0,     0,     0,     0,
       0,     0,     0,  4177,  4178,     0,     0,     0,     0,     0,
    4180,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   941,     0,     0,     0,  4196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1675,     0,     0,   780,     0,
       0,     0,     0,     0,  1665,     0,     0,     0,     0,   780,
       0,  1675,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1675,     0,     0,     0,
     933,  4252,   774,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4275,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   780,     0,     0,   780,   780,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4332,     0,  4334,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   933,
       0,     0,     0,     0,     0,  1403,     0,     0,  1675,     0,
       0,     0,     0,     0,  1403,     0,     0,   774,  1665,     0,
    1403,     0,  1403,     0,     0,  1403,     0,     0,     0,  1675,
    1403,  1403,  1403,  1403,     0,     0,  1403,  1403,  1403,  1403,
    1403,  1403,  1403,  1403,  1403,  1403,   774,     0,     0,  1403,
    1403,     0,     0,     0,  1675,     0,     0,     0,     0,  1403,
     780,     0,     0,  1403,     0,   941,     0,  1403,     0,     0,
       0,     0,     0,     0,     0,  1403,     0,     0,  1403,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,  1675,  1403,
       0,     0,  1403,  1403,     0,     0,     0,  1403,  1403,     0,
       0,     0,     0,     0,  1403,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1403,     0,     0,  1403,     0,     0,
       0,  4411,     0,     0,     0,     0,     0,     0,     0,     0,
    1403,     0,     0,     0,     0,     0,  1403,  1403,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   774,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1403,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1675,     0,     0,     0,     0,     0,     0,     0,
     933,     0,     0,     0,  1403,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   933,     0,     0,   824,     0,   824,
       0,     0,     0,   824,     0,   824,     0,     0,   824,     0,
       0,     0,   824,     0,   933,     0,     0,  2810,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   941,
       0,     0,     0,     0,   941,  1675,   941,  1403,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1666,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   941,  1675,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1666,     0,     0,
       0,     0,   941,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1665,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1218,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1218,  4664,
    1218,  4665,  4666,  4667,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2655,     0,     0,     0,  1665,     0,     0,
    3750,     0,     0,     0,  1403,     0,     0,     0,     0,     0,
    2971,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   941,  1675,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1665,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1665,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1675,  1403,  1403,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   780,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   780,     0,     0,     0,   780,     0,     0,     0,
       0,  1665,  3844,     0,  2140,     0,     0,   824,     0,     0,
    1403,     0,     0,     0,     0,     0,  1665,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,  1665,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1665,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,   780,     0,     0,     0,
       0,  1403,  1403,  4836,  1675,     0,     0,     0,  1403,  1403,
       0,     0,     0,  1403,  1675,     0,     0,     0,  1403,     0,
       0,  1403,  1403,     0,     0,     0,  1403,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1403,  1665,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,  1403,     0,     0,     0,
       0,     0,     0,     0,     0,  1665,     0,     0,     0,  1403,
       0,     0,     0,     0,  1403,     0,     0,     0,     0,  1665,
    1403,  1666,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1665,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,  1666,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1666,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1403,  1665,  1665,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1675,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   941,     0,     0,     0,     0,     0,  5005,
       0,     0,     0,     0,     0,   780,     0,     0,     0,  1675,
       0,     0,     0,   780,     0,     0,   780,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1675,     0,     0,
       0,     0,     0,  1666,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1675,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1665,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1403,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1403,
       0,     0,     0,     0,     0,     0,     0,  1666,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1675,     0,  1675,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1403,     0,     0,     0,  1675,     0,
       0,     0,     0,  1403,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1403,  1403,     0,  1399,  1403,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,   824,  2655,     0,     0,     0,  1403,
       0,     0,  5248,  5249,  5250,  5251,  1403,     0,     0,     0,
     780,  1403,     0,     0,  1403,  1403,     0,     0,     0,     0,
       0,     0,  1403,  1403,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1665,     0,     0,     0,  1665,  1665,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,  1403,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1403,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1665,     0,  1675,  1403,     0,     0,     0,     0,     0,
       0,     0,  1399,  1665,     0,  1403,     0,     0,  1673,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1673,     0,     0,     0,
       0,     0,     0,   941,     0,     0,     0,  1665,     0,  1403,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5403,     0,     0,     0,     0,     0,     0,  5406,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2971,     0,     0,
       0,  1403,   780,  1675,     0,     0,     0,  1666,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,  1399,     0,  1403,  1675,     0,  1403,
    1218,  1403,     0,     0,  1218,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,     0,  1403,     0,     0,
    1399,  1403,     0,     0,     0,     0,  1666,  1675,     0,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1666,   941,     0,
       0,     0,     0,     0,     0,     0,     0,  1675,     0,     0,
    1665,     0,  1675,  1675,     0,     0,     0,  1403,     0,     0,
    1666,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1665,     0,     0,
    1666,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1666,  1675,  1675,     0,     0,
       0,     0,     0,     0,     0,  1666,  1218,  1218,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1666,     0,
       0,     0,  1403,     0,     0,  1403,     0,     0,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1403,
       0,     0,     0,  1399,  1403,     0,  1403,     0,  1403,     0,
    1673,     0,     0,     0,  1399,     0,     0,  1403,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1673,  1403,     0,     0,     0,     0,
       0,     0,     0,     0,  1666,     0,     0,     0,     0,     0,
       0,  1673,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1666,     0,     0,     0,     0,     0,
       0,   941,     0,     0,     0,     0,     0,     0,  1666,  1665,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1666,     0,     0,     0,     0,     0,     0,     0,     0,
    1665,     0,     0,  1399,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1665,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
    1403,     0,     0,  1666,  1666,   780,     0,     0,     0,     0,
       0,   780,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1673,     0,     0,     0,     0,     0,     0,  5730,
       0,  1403,  1403,     0,     0,     0,     0,     0,     0,  1403,
     941,     0,     0,  1675,  5734,     0,     0,     0,     0,  1403,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   824,
       0,     0,     0,     0,     0,     0,  1403,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,     0,     0,  5801,     0,
       0,  1403,     0,     0,     0,     0,     0,  1403,  1403,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,  1673,     0,     0,     0,
       0,     0,     0,     0,  1666,     0,     0,     0,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,  1399,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1403,     0,     0,   780,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,  1665,     0,
       0,  1665,     0,  1665,     0,     0,  1403,     0,  1665,     0,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1399,  1399,  1399,     0,
    1399,   941,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1399,  1403,     0,     0,     0,     0,     0,  1403,     0,  1665,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1403,     0,     0,  1665,     0,     0,     0,
       0,     0,     0,  1403,     0,   941,     0,     0,     0,     0,
       0,     0,  5939,  5940,  5940,     0,     0,     0,     0,     0,
       0,  1665,     0,     0,     0,   941,     0,  1403,  1403,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1666,     0,     0,     0,  1666,  1666,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1665,
       0,  1665,     0,     0,     0,     0,  3844,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1399,
       0,     0,     0,  1399,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1399,     0,
    1666,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1666,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6074,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1665,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1666,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1673,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1665,     0,
     780,     0,     0,     0,     0,  1218,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1665,     0,     0,     0,     0,     0,  1665,
     780,     0,     0,     0,     0,     0,   780,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1218,     0,     0,
       0,     0,     0,     0,     0,  1673,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6188,  1673,  6190,  1665,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1665,     0,     0,     0,     0,  1673,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1665,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1666,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1673,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1673,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1673,     0,     0,     0,     0,     0,
       0,  1665,     0,     0,     0,     0,     0,  1673,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5940,     0,  1665,     0,     0,   780,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1666,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1665,     0,     0,
       0,     0,     0,     0,     0,     0,  1668,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1673,     0,     0,     0,     0,     0,     0,
       0,  1665,     0,     0,  1668,     0,  1399,     0,     0,  1399,
       0,     0,     0,  1673,     0,     0,     0,     0,     0,     0,
       0,  1399,     0,     0,     0,     0,     0,  1673,     0,  6372,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1673,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1673,  1673,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1666,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2971,     0,     0,     0,     0,     0,     0,     0,     0,  1666,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1666,     0,  1665,  6444,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   780,  1399,  1399,     0,   780,     0,
       0,  1399,  1399,     0,     0,     0,     0,     0,  1399,  1399,
    1399,     0,     0,     0,  1399,     0,  1399,  1399,  1399,  1399,
    1399,  1399,  6514,  1399,     0,  1399,  1399,     0,  1665,  1399,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1673,  1399,  1399,  1399,  1399,     0,     0,
       0,     0,  1399,     0,  5940,  5940,  1399,     0,  1665,  1399,
       0,     0,  1399,  1399,  1399,  1399,  1399,  1399,  1399,  1399,
    1399,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
    1399,     0,     0,  1399,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,     0,     0,     0,     0,     0,  5940,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1666,     0,     0,
    1666,     0,  1666,     0,     0,     0,     0,  1666,  1668,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1665,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1668,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1668,
       0,     0,     0,     0,     0,     0,     0,     0,  1666,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1665,     0,
       0,     0,     0,     0,     0,  1666,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1673,     0,     0,     0,  1673,  1673,     0,     0,     0,
    1666,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,     0,     0,     0,     0,     0,     0,
    1668,     0,     0,     0,     0,  1399,     0,     0,     0,  1673,
       0,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,  1673,     0,     0,     0,     0,     0,   824,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1666,     0,
    1666,     0,     0,     0,     0,     0,     0,  1218,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1665,     0,     0,
       0,     0,     0,     0,     0,  1673,     0,  1665,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   780,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1666,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1668,     0,     0,     0,     0,  1218,
       0,     0,     0,     0,     0,     0,     0,  1666,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1666,     0,     0,     0,     0,     0,  1666,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1665,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1665,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1666,     0,     0,
    1665,     0,     0,     0,     0,     0,     0,  1399,  1673,     0,
       0,     0,     0,  1666,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1666,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1665,  1399,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   780,   780,     0,
       0,     0,     0,     0,     0,  1673,     0,     0,     0,     0,
       0,   780,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1666,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1666,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1665,  1666,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   780,     0,     0,     0,     0,     0,     0,     0,
    1666,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1665,     0,     0,  1668,     0,     0,  1673,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,  1399,     0,     0,  1673,     0,
       0,  1399,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1673,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,  1399,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1668,     0,     0,     0,     0,     0,     0,
    1399,  1399,  1399,     0,     0,  1399,     0,     0,     0,     0,
       0,     0,     0,  1399,  1399,  1399,  1399,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1399,     0,     0,  1399,
       0,  1399,     0,     0,  1666,     0,     0,     0,     0,     0,
       0,     0,  1399,  1399,  1668,     0,  1399,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1399,     0,  1399,     0,  1399,     0,  1665,  1668,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1399,     0,  1399,  1399,  1399,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1069,     0,     0,     0,     0,     0,
       0,     0,  1399,  1069,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1666,   780,     0,
     780,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,     0,     0,     0,  1668,  1399,     0,
       0,     0,     0,     0,  1399,     0,     0,  1666,  1069,     0,
       0,     0,  1668,     0,  1399,     0,     0,     0,     0,     0,
       0,     0,  1668,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1668,  1665,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1276,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1673,     0,  1276,  1673,
       0,  1673,     0,     0,     0,     0,  1673,     0,     0,     0,
    1665,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1399,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1668,     0,     0,     0,     0,     0,     0,     0,     0,
    1665,     0,     0,     0,     0,     0,     0,  1673,     0,     0,
       0,  1668,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1673,  1668,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1668,     0,
    1666,     0,     0,     0,     0,     0,     0,   780,     0,  1673,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1665,     0,     0,     0,     0,  1665,  1665,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1668,  1668,     0,     0,     0,     0,     0,  1666,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1673,     0,  1673,
       0,     0,     0,     0,     0,     0,     0,     0,  1366,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1665,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1673,     0,     0,     0,  1666,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1666,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1668,     0,     0,     0,     0,  1673,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1673,     0,     0,     0,     0,     0,  1673,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1673,     0,     0,     0,
       0,     0,     0,  1666,     0,     0,     0,     0,     0,     0,
       0,     0,  1673,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1665,  1673,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1666,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1666,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1069,  1069,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1668,
       0,     0,     0,  1668,  1668,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1666,     0,  1399,     0,     0,  1673,
       0,     0,     0,     0,     0,  1399,  1366,     0,     0,     0,
       0,  1399,     0,  1399,     0,     0,  1399,     0,     0,     0,
    1673,  1399,  1399,  1399,  1399,     0,     0,  1399,  1399,  1399,
    1399,  1399,  1399,  1399,  1399,  1399,  1399,  1668,     0,     0,
    1399,  1399,     0,     0,     0,  1673,     0,     0,     0,  1668,
    1399,     0,     0,     0,  1399,     0,     0,     0,  1399,     0,
       0,     0,     0,     0,     0,     0,  1399,     0,     0,  1399,
       0,  1399,     0,     0,     0,     0,     0,     0,     0,  1673,
    1399,     0,     0,  1399,  1399,     0,     0,     0,  1399,  1399,
       0,     0,     0,  1668,     0,  1399,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1399,     0,     0,  1399,     0,
       0,     0,     0,     0,  1666,     0,     0,     0,     0,     0,
       0,  1399,     0,     0,     0,     0,     0,  1399,  1399,  1399,
       0,     0,     0,     0,     0,     0,     0,  1415,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1455,     0,
    1456,     0,  1460,  1461,     0,  1464,  1465,     0,  1467,     0,
       0,  1473,     0,  1475,     0,     0,     0,     0,     0,     0,
    1666,  1493,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1399,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1550,     0,     0,     0,     0,     0,  1399,     0,     0,
    1563,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1580,  1581,  1673,     0,  1587,     0,     0,  1591,  1592,
       0,     0,     0,  1594,     0,  1399,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1366,     0,  1069,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1628,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1703,     0,  1705,     0,
       0,     0,     0,     0,     0,     0,     0,  1493,  1720,     0,
       0,     0,     0,     0,     0,     0,  1668,     0,     0,  1069,
       0,     0,     0,     0,     0,  1666,  1673,     0,  1399,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1673,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1668,     0,     0,     0,     0,     0,     0,
       0,     0,  1366,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1666,     0,  1276,     0,     0,
       0,     0,     0,     0,     0,  1399,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1666,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1673,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1666,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1673,  1399,  1399,     0,
       0,     0,     0,     0,     0,  1668,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2158,
       0,  2160,     0,     0,     0,  2162,  1668,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1666,
    1668,     0,     0,     0,  1666,  1666,     0,     0,  2206,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2285,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1399,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2380,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,  1399,     0,  1673,     0,     0,     0,  1399,
    1399,     0,     0,  2402,  1399,  1673,     0,     0,     0,  1399,
       0,     0,  1399,  1399,     0,  2413,     0,  1399,  2414,  1666,
       0,     0,     0,  1399,     0,     0,     0,     0,     0,  2417,
       0,     0,     0,     0,  2421,  1399,     0,     0,     0,     0,
       0,     0,  2425,  1399,     0,     0,     0,  1399,     0,     0,
    2435,     0,     0,     0,  2440,     0,     0,     0,     0,     0,
    1399,     0,     0,     0,     0,  1399,     0,     0,     0,  2455,
       0,  1399,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,     0,     0,     0,     0,     0,     0,
    2504,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1673,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1668,     0,     0,  1668,     0,  1668,
       0,     0,     0,     0,  1668,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1673,     0,     0,     0,     0,     0,  2576,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1673,     0,
       0,     0,     0,     0,     0,  1668,     0,     0,     0,     0,
       0,     0,     0,  2616,     0,     0,     0,     0,     0,     0,
       0,  1399,  1668,     0,     0,  1666,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1668,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1673,     0,  2678,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2690,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1399,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1668,     0,  1668,     0,     0,
    1399,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1673,     0,  1673,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1668,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1399,     0,     0,     0,  1673,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1668,     0,     0,     0,     0,     0,
       0,  1399,  1399,     0,     0,  1399,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1276,  1493,  1668,
    1399,     0,     0,     0,     0,  1668,     0,  1399,     0,     0,
       0,     0,  1399,     0,     0,  1399,  1399,     0,     0,     0,
       0,     0,     0,  1399,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1399,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1668,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1668,     0,     0,     0,  1673,  1399,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1668,  1399,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2967,     0,     0,  2967,     0,     0,
       0,     0,     0,     0,     0,  2974,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1399,     0,     0,  2983,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3076,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1668,     0,     0,
       0,     0,  1399,     0,  1673,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1668,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1399,  1673,     0,
    1399,     0,  1399,  1668,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,  3192,  1399,     0,
       0,     0,  1399,     0,     0,     0,     0,  1668,  1673,     0,
       0,     0,     0,  1399,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1673,     0,
       0,     0,     0,  1673,  1673,     0,     0,     0,  1399,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1493,  3287,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1399,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1668,     0,     0,     0,     0,     0,     0,  3345,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1673,  1673,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,     0,     0,  1399,     0,     0,  1399,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1399,     0,     0,     0,     0,  1399,     0,  1399,     0,  1399,
       0,     0,     0,     0,  1668,     0,     0,     0,  1399,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1399,     0,     0,     0,
       0,     0,     0,     0,  1668,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3482,     0,  3483,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1493,
       0,  3494,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,     0,  3521,     0,     0,     0,     0,
       0,  1399,     0,     0,     0,     0,     0,  1493,     0,     0,
       0,  1493,     0,  1493,     0,     0,  1493,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,  1399,     0,     0,     0,     0,     0,     0,
    1399,     0,     0,     0,  1673,     0,     0,     0,     0,     0,
    1399,     0,     0,     0,     0,     0,     0,  1668,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1668,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1399,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,  1399,  1399,
       0,     0,  3749,  1399,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1399,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1399,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1668,     0,     0,     0,  1399,     0,     0,
       0,     0,  1399,  1668,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1399,     0,     0,     0,     0,     0,  1399,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,  1366,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,     0,
       0,  3855,  3856,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1399,  1399,
       0,  1399,  3873,  3874,     0,     0,     0,  3877,  3878,     0,
       0,     0,  3881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3892,     0,     0,     0,
       0,     0,     0,  3901,     0,     0,     0,  3904,  3905,     0,
    1668,  3908,  3909,     0,     0,     0,     0,     0,  3914,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3931,     0,  3933,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1668,     0,
       0,     0,     0,  3957,     0,     0,     0,     0,  3959,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3964,     0,     0,     0,  1668,     0,     0,     0,
       0,     0,     0,  3973,     0,     0,  3976,     0,     0,     0,
    3980,  3983,     0,     0,     0,     0,     0,     0,     0,  3990,
       0,     0,     0,     0,  3998,  4001,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4015,     0,     0,     0,
       0,     0,  4025,     0,     0,     0,     0,     0,     0,  4031,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1668,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4053,     0,     0,     0,     0,     0,     0,
       0,  4064,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4079,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4086,     0,     0,  4089,     0,     0,
       0,     0,  4092,     0,     0,     0,  4093,     0,  4095,  4096,
       0,     0,     0,  4100,     0,     0,  4104,     0,     0,     0,
    4111,  4112,  4113,  4114,     0,  4116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4141,  4142,
       0,  4144,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4152,  4153,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1668,     0,     0,     0,    86,    87,    88,     0,    90,
      91,    92,     0,     0,     0,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,     0,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,     0,     0,  4204,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1668,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,  1404,     0,     0,     0,  4248,     0,     0,     0,     0,
       0,  1404,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   133,
       0,     0,     0,     0,     0,   136,   137,   138,   139,   140,
     141,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1404,   143,     0,     0,     0,     0,     0,     0,
       0,   149,     0,   150,     0,     0,     0,     0,     0,     0,
       0,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   157,  4331,     0,     0,     0,     0,
       0,   158,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   161,   162,     0,     0,     0,     0,     0,     0,
       0,     0,  1668,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,     0,     0,     0,     0,  1676,     0,     0,     0,
    1404,     0,     0,     0,     0,     0,  1366,     0,     0,     0,
       0,     0,     0,     0,     0,   170,     0,     0,     0,  1493,
     172,     0,     0,     0,  1676,     0,   174,     0,     0,     0,
       0,     0,   175,     0,   176,     0,     0,     0,     0,     0,
       0,   178,     0,   179,     0,     0,     0,     0,     0,     0,
       0,     0,   180,     0,     0,     0,     0,     0,  4393,     0,
       0,     0,     0,     0,     0,     0,   182,   183,     0,     0,
       0,     0,     0,   184,     0,   185,     0,     0,   186,   187,
       0,   188,     0,     0,     0,     0,     0,     0,     0,     0,
     189,   190,  4412,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1668,     0,     0,     0,   196,   197,   198,     0,
       0,     0,     0,     0,   201,     0,     0,     0,   203,     0,
       0,   204,     0,   205,   206,     0,     0,     0,     0,     0,
       0,  1404,  1404,     0,     0,     0,  1668,     0,     0,     0,
       0,   207,   208,     0,   209,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     212,     0,   213,     0,     0,     0,     0,     0,  1404,     0,
       0,     0,     0,     0,     0,     0,  1668,     0,     0,   215,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   222,     0,     0,     0,     0,   225,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   231,     0,     0,
       0,   233,     0,     0,     0,   234,  1668,     0,     0,     0,
       0,  1668,  1668,     0,     0,     0,     0,     0,     0,     0,
       0,   236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   238,     0,     0,     0,     0,     0,     0,   239,   240,
       0,     0,     0,     0,   241,     0,   242,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   250,     0,     0,   251,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1668,     0,     0,     0,
       0,     0,  1493,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4658,     0,     0,
       0,  4660,     0,     0,     0,     0,     0,  4662,     0,     0,
       0,  1404,     0,     0,     0,     0,     0,     0,  1676,     0,
       0,     0,  1404,  4673,  4675,     0,     0,     0,  4675,     0,
       0,     0,     0,  4686,  4687,  4688,     0,  4690,     0,     0,
       0,     0,  1676,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1676,
       0,     0,  4711,     0,     0,     0,     0,     0,     0,     0,
    1493,     0,     0,     0,     0,     0,     0,  4720,  4721,  4722,
    4723,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1404,     0,     0,     0,     0,     0,     0,  4743,     0,
       0,  4748,  4749,  4750,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1676,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1668,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4823,     0,     0,     0,     0,     0,     0,     0,  4827,
    1404,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4843,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4895,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1676,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4936,     0,     0,     0,     0,  4941,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4976,     0,     0,     0,     0,
       0,  1069,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1404,  1404,  1404,     0,  1404,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5001,     0,  5002,     0,     0,     0,  1404,     0,
       0,  5006,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1493,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5027,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1404,     0,     0,
       0,  1404,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1676,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5242,     0,
    5243,     0,     0,  1676,     0,     0,     0,  5245,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5255,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5263,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1676,     0,     0,  1493,     0,  1493,
    5286,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1676,     0,  5291,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5302,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5332,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5340,  5341,  5342,     0,     0,
       0,     0,     0,  5346,  5347,  5348,  5349,     0,     0,     0,
    5351,  5352,     0,     0,     0,     0,  5359,  5360,     0,  5362,
    5363,  5364,  5365,  5366,  5367,     0,  5369,     0,     0,     0,
       0,     0,     0,     0,     0,  5377,     0,  1676,  5380,  5381,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1676,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1676,     0,     0,     0,     0,  4675,     0,     0,
       0,     0,     0,     0,     0,  1676,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5407,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1676,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1404,     0,     0,  1404,     0,     0,
       0,  1676,     0,     0,     0,     0,     0,     0,     0,  1404,
       0,     0,     0,     0,     0,  1676,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1676,     0,
       0,  4675,     0,     0,  1914,  1914,     0,     0,     0,     0,
       0,  1404,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1493,  1493,  1493,     0,     0,     0,     0,
    1676,  1676,     0,     0,  5524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1674,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1404,  1404,  1674,     0,     0,     0,  1404,
    1404,     0,     0,     0,     0,     0,  1404,  1404,  1404,     0,
       0,     0,  1404,     0,  1404,  1404,  1404,  1404,  1404,  1404,
       0,  1404,     0,  1404,  1404,     0,     0,  1404,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1676,  1404,  1404,  1404,  1404,     0,     0,     0,     0,
    1404,     0,     0,     0,  1404,     0,     0,  1404,     0,     0,
    1404,  1404,  1404,  1404,  1404,  1404,  1404,  1404,  1404,     0,
    1404,     0,     0,     0,     0,     0,     0,     0,  1404,     0,
       0,  1404,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5673,     0,     0,     0,
    5674,  5675,  5676,  5677,     0,     0,  5679,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1404,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5701,  5702,  5703,     0,  5704,     0,     0,
    5706,  5707,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5716,  5717,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5722,
       0,     0,     0,     0,     0,     0,     0,  1493,  1493,     0,
    1493,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5733,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1676,
       0,     0,     0,  1676,  1676,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5789,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1404,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1404,  5816,     0,     0,  1676,     0,     0,
    1404,     0,     0,     0,     0,     0,     0,     0,     0,  1676,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5845,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1674,
       0,     0,     0,  1676,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1674,     0,     0,     0,     0,  2709,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1674,     0,     0,     0,     0,  2721,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1493,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2735,  1493,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2753,  2754,  2755,
       0,  2758,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2800,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1674,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5958,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5968,     0,     0,     0,     0,  5973,  5974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1404,  1676,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6036,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6053,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1404,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1674,     0,     0,     0,     0,
    2901,     0,     0,     0,  2913,  2916,     0,     0,     0,     0,
       0,  4675,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6092,  1676,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1493,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1493,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1669,     0,     0,     0,     0,
    6138,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6154,     0,  1669,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6163,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1493,     0,
       0,     0,     0,     0,     0,  1676,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1404,  1404,     0,     0,  1676,     0,     0,  1404,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6231,
    1676,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,     0,     0,     0,  1404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1404,  1404,
    1404,     0,     0,  1404,     0,     0,     0,     0,     0,     0,
       0,  1404,  1404,  1404,  1404,     0,     0,     0,     0,     0,
       0,  4675,     0,     0,  1404,     0,     0,  1404,     0,  1404,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,  1404,     0,     0,  1404,     0,     0,     0,     0,     0,
       0,     0,     0,  1493,     0,     0,     0,     0,  1404,     0,
    1404,     0,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1404,     0,     0,     0,     0,     0,     0,  6320,
       0,     0,     0,  1404,     0,  1404,  1404,  1404,     0,     0,
       0,     0,     0,     0,     0,  6334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,     0,     0,     0,  3003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1404,     0,     0,     0,     0,  1404,     0,     0,  6366,
       0,     0,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1404,  6375,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1676,     0,     0,  1676,     0,  1676,
       0,     0,     0,     0,  1676,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1674,     0,  1404,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6436,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1674,     0,
       0,     0,     0,     0,     0,  1676,     0,  1669,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1676,     0,     0,     0,     0,     0,     0,     0,
       0,  1669,     0,     0,  6458,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1676,  1669,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1674,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1674,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3003,     0,     0,     0,     0,     0,     0,
       0,  6521,     0,     0,     0,     0,  1674,     0,     0,     0,
       0,     0,  3617,     0,     0,  1676,     0,  1676,     0,     0,
       0,     0,     0,     0,     0,  3637,     0,  3639,     0,  1669,
    3651,  3654,  3659,     0,     0,     0,     0,  3665,     0,     0,
    3670,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3677,  3678,  3679,  3680,     0,
       0,     0,     0,  3687,     0,     0,     0,  3699,     0,     0,
    3701,     0,  1674,  3708,  3709,  3710,  3711,  3712,  3713,  3714,
    3715,  3716,     0,  3717,     0,     0,     0,     0,     0,     0,
       0,  1914,  1674,     0,  3745,     0,     0,     0,     0,     0,
    1676,     0,     0,     0,     0,     0,  1674,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1674,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1676,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3775,     0,     0,     0,     0,  1676,
       0,  1674,  1674,     0,     0,  1676,     0,     0,     0,     0,
       0,     0,     0,  1669,     0,     0,  1671,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1676,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1676,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1676,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1674,     0,  3906,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3748,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1404,     0,     0,  1676,     0,     0,
       0,     0,     0,  1404,     0,     0,     0,     0,     0,  1404,
       0,  1404,     0,     0,  1404,     0,     0,     0,  1676,  1404,
    1404,  1404,  1404,     0,     0,  1404,  1404,  1404,  1404,  1404,
    1404,  1404,  1404,  1404,  1404,     0,     0,     0,  1404,  1404,
       0,     0,     0,  1676,     0,     0,     0,     0,  1404,     0,
       0,     0,  1404,     0,     0,     0,  1404,     0,     0,     0,
       0,     0,     0,     0,  1404,     0,     0,  1404,     0,  1404,
       0,     0,     0,     0,     0,     0,     0,  1676,  1404,     0,
       0,  1404,  1404,     0,     0,     0,  1404,  1404,     0,     0,
       0,     0,     0,  1404,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1404,     0,     0,  1404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1404,
       0,     0,     0,     0,     0,  1404,  1404,  1404,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1669,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3859,     0,     0,     0,  3003,  3865,     0,     0,     0,  1404,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1671,     0,
       0,  1676,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1669,  1404,     0,     0,     0,     0,  4194,     0,
       0,     0,  1671,     0,     0,     0,     0,     0,  1674,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1671,
    1674,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1669,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1674,     0,  1669,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1676,     0,  1404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1676,     0,     0,     0,     0,     0,
    1671,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1669,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1669,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1669,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1669,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1404,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4400,     0,  1676,     0,     0,
    1669,     0,     0,     0,  1671,     0,     0,     0,     0,     0,
       0,  1404,     0,     0,     0,     0,     0,  1674,     0,     0,
    1669,     0,     0,  4417,     0,     0,     0,     0,  4423,     0,
       0,     0,     0,     0,  1669,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1676,  1404,  1404,  1669,     0,     0,
       0,     0,     0,  2758,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3659,     0,  3659,  3659,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4481,     0,     0,
    4484,     0,  4486,     0,     0,     0,     0,     0,     0,  1669,
    1669,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4504,     0,  4507,  3003,  4509,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1404,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,     0,     0,     0,     0,     0,     0,  3745,  3745,
    3745,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,     0,  4580,     0,     0,     0,     0,     0,     0,
    1404,  1404,     0,  1676,     0,     0,     0,  1404,  1404,     0,
       0,     0,  1404,  1676,     0,     0,     0,  1404,     0,     0,
    1404,  1404,     0,     0,  2901,  1404,     0,     0,     0,  4597,
       0,  1404,     0,     0,     0,  2916,     0,     0,     0,     0,
       0,     0,     0,  1404,     0,     0,     0,     0,     0,     0,
       0,  1404,     0,     0,     0,  1404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1404,     0,
       0,     0,     0,  1404,     0,     0,  1674,     0,     0,  1404,
    1669,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1674,     0,     0,
       0,  1404,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1674,     0,     0,     0,     0,     0,     0,     0,     0,
    4644,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1676,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1676,     0,
       0,     0,     0,     0,  1671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1676,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1404,
       0,     0,     0,     0,     0,     0,  3748,  3748,  3748,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1671,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1676,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1669,     0,
       0,  1404,  1669,  1669,  1671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1671,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1404,     0,
       0,     0,     0,     0,     0,  3003,     0,     0,  3865,     0,
    3865,     0,     0,     0,     0,  3003,  1669,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1669,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1676,
       0,  1676,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1674,  1671,     0,     0,
       0,     0,  1669,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,  1674,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,  1404,     0,     0,     0,  1676,     0,     0,
       0,     0,  1404,     0,     0,  1671,     0,     0,  3003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1404,
    1404,     0,     0,  1404,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1404,     0,
       0,     0,     0,     0,     0,  1404,     0,     0,     0,     0,
    1404,     0,     0,  1404,  1404,     0,     0,     0,     0,     0,
       0,  1404,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,  1671,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1404,     0,
    1404,  1671,     0,     0,     0,     0,  1674,     0,  1674,     0,
       0,     0,  1404,     0,     0,  1671,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1671,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1676,  1404,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1404,     0,     0,     0,     0,     0,
    1671,  1671,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1674,     0,     0,     0,  1669,     0,  5044,     0,     0,
       0,     0,     0,     0,     0,     0,  5048,     0,  1404,     0,
       0,     0,  5049,     0,  5050,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1674,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5074,  5075,     0,     0,     0,     0,     0,     0,     0,
    3865,     0,     0,     0,     0,     0,  3865,     0,     0,  3665,
       0,     0,     0,     0,     0,     0,     0,  5100,     0,     0,
    5103,     0,  5105,     0,     0,     0,     0,     0,     0,     0,
    1404,  5109,  1676,     0,     0,     0,     0,     0,     0,  5116,
    5117,     0,  1669,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1404,  1676,     0,  1404,     0,
    1404,     0,  5164,     0,     0,     0,     0,     0,  5171,  5172,
    3745,     0,     0,     0,     0,  1674,     0,     0,     0,     0,
    1404,  1671,     0,     0,     0,     0,  1404,     0,     0,     0,
    1404,  3865,     0,     0,     0,     0,  1676,     0,     0,     0,
       0,  1404,     0,     0,     0,     0,  1674,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5194,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1676,     0,     0,     0,
       0,  1676,  1676,     0,     0,     0,  1404,  2794,     0,     0,
       0,     0,     0,     0,  1669,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1669,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1669,
       0,     0,     0,     0,     0,     0,     0,  1404,  1674,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1674,
    1404,     0,     0,  2794,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1674,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1676,  1676,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1674,     0,
       0,  1404,     0,     0,  1404,     0,     0,  1404,     0,  1671,
       0,     0,     0,  1671,  1671,     0,     0,     0,  1404,     0,
       0,     0,     0,  1404,     0,  1404,     0,  1404,     0,     0,
       0,     0,     0,     0,     0,     0,  1404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3748,     0,
       0,     0,     0,     0,  1404,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1671,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1671,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3003,  1671,     0,     0,     0,     0,     0,     0,
       0,  1404,     0,     0,     0,     0,     0,     0,     0,  1404,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1669,     0,     0,  1669,     0,  1669,     0,
       0,     0,     0,  1669,     0,     0,     0,     0,  5490,  5491,
    1404,  1404,     0,     0,     0,     0,     0,     0,  1404,     0,
       0,     0,  1676,     0,     0,     0,     0,     0,  1404,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1404,     0,     0,  1669,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3865,     0,     0,     0,     0,
       0,  1669,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5541,     0,     0,  3865,  1669,     0,     0,     0,
       0,     0,     0,  5546,     0,  1404,     0,     0,     0,     0,
    1404,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,     0,     0,     0,     0,  1404,  1404,     0,     0,
       0,  1404,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,     0,  5561,  5563,     0,     0,     0,     0,     0,
    5567,  5568,     0,     0,     0,  5569,     0,  1404,     0,     0,
    5572,     0,     0,  5575,  5576,     0,     0,     0,  5580,     0,
       0,     0,     0,     0,  5584,     0,  1671,     0,     0,     0,
       0,     0,     0,     0,  1669,     0,  1669,     0,     0,     0,
       0,     0,     0,     0,     0,  1404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3745,     0,     0,     0,     0,  3745,     0,     0,     0,
       0,     0,  3745,     0,     0,  1404,     0,     0,     0,     0,
    1404,     0,     0,     0,     0,     0,     0,     0,  1674,     0,
       0,     0,     0,     0,  1914,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1669,
    1404,     0,     0,  1671,     0,  5654,  1404,     0,     0,     0,
       0,     0,     0,     0,     0,  3003,     0,     0,     0,     0,
       0,     0,  1404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1404,  1669,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1404,  1404,  1669,  1404,
       0,     0,     0,     0,  1669,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5719,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1669,     0,  1671,     0,     0,     0,     0,
       0,     0,     0,     0,  1674,     0,     0,     0,     0,  1669,
       0,     0,     0,     0,  1674,     0,  1671,     0,     0,     0,
       0,     0,     0,     0,  1669,     0,     0,     0,     0,     0,
    1671,     0,     0,     0,  5757,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3748,
       0,     0,  2794,     0,  3748,     0,     0,     0,     0,     0,
    3748,     0,     0,     0,  2794,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2794,     0,
       0,     0,  3647,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2794,  2794,  2794,     0,
       0,  2794,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1669,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1674,     0,     0,     0,     0,     0,  1669,     0,     0,
       0,     0,     0,  2794,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1669,     0,     0,     0,     0,     0,     0,  1674,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5874,  5875,     0,     0,  5876,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1669,  1674,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5912,  5913,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2794,     0,     0,     0,     0,     0,
       0,     0,     0,  5930,     0,     0,  2794,     0,     0,  2794,
       0,     0,  1674,     0,  1671,     0,     0,  1671,     0,  1671,
       0,     0,     0,     0,  1671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3745,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1671,     0,     0,     0,     0,
    1669,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1671,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5829,     0,  1674,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1669,     0,     0,     0,     0,  1674,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1671,     0,  1671,     0,     0,
       0,     0,     0,  1669,     0,     0,     0,     0,     0,     0,
       0,  3665,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2758,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1671,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1671,     0,     0,     0,     0,  6170,
       0,     0,     0,  3865,  3748,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1671,
       0,     0,     0,     0,     0,  1671,  1669,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1669,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1671,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3865,     0,  1671,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5912,     0,     0,     0,     0,     0,     0,  1674,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6322,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1674,     0,     0,
       0,     0,  1669,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1669,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1671,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1674,  1671,     0,
       0,     0,  1674,  1674,  6378,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1671,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6408,  6408,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1671,     0,     0,
       0,  5912,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1669,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2794,     0,     0,     0,     0,     0,  5829,  1674,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1669,     0,     0,
    2794,     0,  2794,     0,     0,  3647,  3647,     0,  4458,     0,
    3647,     0,     0,  6467,  2794,     0,     0,  2794,     0,     0,
       0,     0,  2794,     0,     0,  1669,     0,     0,  2794,     0,
       0,     0,     0,  2794,  6408,     0,     0,     0,     0,     0,
    2794,  2794,  2794,  2794,     0,     0,     0,  3647,  3647,     0,
    2794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6511,  1671,  2794,     0,  2794,     0,     0,     0,     0,     0,
       0,  2794,  2794,  2794,  2794,  2794,  2794,  2794,  2794,  2794,
    2794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1669,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2794,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2794,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1671,     0,     0,     0,     0,     0,
       0,     0,     0,  6408,     0,     0,     0,     0,     0,  6574,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1671,     0,     0,     0,     0,     0,
       0,     0,     0,  1674,     0,     0,     0,     0,     0,     0,
    1669,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1669,     0,     0,  2794,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1671,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1669,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1671,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1671,     0,     0,     0,     0,     0,     0,
       0,  1669,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2794,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1669,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1669,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1671,     0,     0,     0,     0,  1669,     0,     0,     0,     0,
    1669,  1669,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1671,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1671,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2794,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2794,     0,     0,     0,     0,     0,  2794,     0,     0,     0,
       0,     0,     0,     0,     0,  1669,     0,     0,     0,     0,
       0,  1671,  4458,  4458,     0,     0,  3647,  3647,  3647,  3647,
       0,     0,  3647,  3647,  3647,  3647,  3647,  3647,  3647,  3647,
    3647,  3647,  4458,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2794,     0,     0,  2794,     0,  2794,
       0,     0,  4458,  4458,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2794,  3647,  3647,
    2794,     0,  2794,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1671,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2794,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1671,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2794,     0,     0,
       0,  1669,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    86,
      87,    88,     0,    90,    91,    92,     0,     0,     0,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,     0,     0,     0,   107,   108,   109,   110,     0,   111,
     112,   113,   114,     0,   115,   116,   117,     0,     0,     0,
       0,     0,   120,   121,     0,     0,     0,     0,   122,     0,
       0,     0,     0,     0,     0,     0,     0,   123,     0,   124,
       0,   125,     0,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
    3647,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   133,     0,     0,     0,     0,     0,   136,
     137,   138,   139,   140,   141,   142,  1671,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,     0,     0,
       0,     0,     0,     0,     0,   149,     0,   150,     0,     0,
       0,     0,     0,     0,     0,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1671,     0,   157,     0,
       0,     0,     0,     0,     0,   158,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   161,   162,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     168,     0,     0,     0,     0,     0,  1671,     0,     0,   170,
       0,  1671,  1671,     0,   172,     0,     0,     0,     0,     0,
     174,     0,     0,     0,     0,     0,   175,  2794,   176,     0,
       0,  2794,  2794,  2794,     0,   178,     0,   179,     0,  4458,
    4458,  4458,  4458,     0,     0,     0,   180,  4458,  4458,  4458,
    4458,  4458,  4458,  4458,  4458,  4458,  4458,  2794,  2794,     0,
     182,   183,     0,     0,     0,     0,     0,   184,     0,   185,
       0,     0,   186,   187,     0,   188,     0,     0,     0,     0,
       0,     0,     0,  2794,   189,   190,  2794,   191,  2794,     0,
       0,     0,  2794,     0,     0,  4458,  4458,     0,     0,  2794,
    2794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     196,   197,   198,     0,     0,     0,     0,     0,   201,     0,
       0,     0,   203,     0,     0,   204,  1671,   205,   206,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   207,   208,  2794,   209,   210,
       0,     0,     0,     0,  2794,  2794,     0,     0,     0,     0,
       0,     0,     0,     0,   212,     0,   213,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2794,     0,     0,
       0,     0,     0,   215,     0,     0,     0,     0,     0,     0,
    2794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   222,     0,     0,     0,     0,
     225,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   231,     0,     0,     0,   233,     0,     0,     0,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   238,     0,     0,     0,     0,
       0,     0,   239,   240,     0,     0,     0,     0,   241,     0,
     242,     0,     0,     0,     0,     0,     0,     0,     0,   245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   250,     0,     0,   251,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,     0,     0,
       0,     0,  1671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3834,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4458,     0,    86,    87,    88,     0,    90,    91,    92,
       0,     0,     0,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,     0,     0,     0,   107,   108,
     109,   110,     0,   111,   112,   113,   114,     0,   115,   116,
     117,     0,     0,     0,     0,     0,   120,   121,     0,     0,
       0,     0,   122,     0,     0,     0,     0,     0,     0,     0,
       0,   123,     0,   124,     0,   125,     0,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,  2794,  2794,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   133,     0,     0,
       0,     0,     0,   136,   137,   138,   139,   140,   141,   142,
       0,     0,     0,     0,  2794,     0,     0,     0,     0,  2794,
    3647,   143,     0,     0,     0,     0,     0,     0,     0,   149,
       0,   150,     0,     0,  2794,     0,  2794,     0,     0,   154,
    2794,  2794,  2794,     0,     0,  2794,     0,     0,  2794,  2794,
       0,     0,   157,  2794,     0,     0,     0,  2794,     0,   158,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     161,   162,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   168,     0,     0,     0,     0,     0,
       0,     0,     0,   170,     0,     0,     0,     0,   172,     0,
       0,     0,     0,     0,   174,     0,     0,  2794,     0,     0,
     175,     0,   176,     0,     0,     0,     0,     0,     0,   178,
       0,   179,     0,     0,     0,     0,     0,     0,     0,     0,
     180,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   182,   183,     0,     0,     0,     0,
       0,   184,     0,   185,     0,     0,   186,   187,     0,   188,
       0,     0,     0,     0,     0,     0,     0,     0,   189,   190,
       0,   191,  2794,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   196,   197,   198,     0,     0,     0,
       0,     0,   201,     0,     0,     0,   203,     0,     0,   204,
    2794,   205,   206,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   207,
     208,     0,   209,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   212,     0,
     213,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   215,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   222,
       0,     0,     0,     0,   225,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4458,  3647,     0,     0,   231,     0,     0,     0,   233,
       0,     0,     0,   234,     0,     0,     0,  2794,  2794,  2794,
       0,     0,     0,     0,     0,     0,     0,  3647,     0,   236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   238,
       0,     0,     0,     0,     0,     0,   239,   240,     0,     0,
       0,     0,   241,     0,   242,  2794,  2794,     0,     0,     0,
       0,     0,     0,   245,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2794,     0,     0,     0,     0,     0,     0,
     250,     0,     0,   251,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3836,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4458,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3647,     0,     0,  4458,     0,     0,
       0,  2794,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2794,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4458,     0,  3647,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2794,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2794,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2794,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3647,     0,     0,     0,     0,  3647,     0,     0,
       0,     0,     0,     0,  2794,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4458,
       0,     0,  4458,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   834,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,  2794,    98,    99,
     100,   101,   102,   103,   835,   104,   105,   789,   836,     0,
     107,   108,   109,   110,   837,   838,   112,   113,   114,     0,
     115,   839,   840,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,   841,   474,   475,   476,   842,   843,   844,   845,   846,
     847,   848,   477,   478,   849,   479,   480,   481,   850,   133,
     482,   483,   484,   485,   486,   136,   137,   138,   139,   140,
     141,   142,   851,   487,   488,   489,   490,   491,   852,   853,
     492,   493,   854,   143,   494,   855,   495,   496,   497,   498,
     499,   149,   856,   150,   857,   500,   501,   502,   503,   504,
     505,   154,   506,   507,   858,   859,   508,   509,   510,   511,
     512,   513,   514,   860,   157,   515,   516,   861,   862,   863,
     864,   158,   865,   866,   867,   518,   519,   520,   521,   803,
     868,   522,   161,   162,   523,   869,   524,   870,   525,   526,
     527,   528,   529,   530,   871,   531,   532,   533,   534,   535,
     872,   536,   537,   538,   539,   873,   540,   541,   542,   543,
     544,   874,   545,   546,   547,   875,   548,   549,   550,   876,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,   877,   560,   878,   561,   562,   174,   563,   879,   564,
     880,   565,   175,   881,   176,   566,   567,   568,   569,   882,
     570,   178,   883,   179,   571,   572,   884,   573,   574,   805,
     575,   576,   180,   577,   578,   579,   580,   885,   581,   582,
     583,   584,   585,   586,   886,   587,   182,   183,   887,   588,
     589,   590,   888,   184,   889,   185,   890,   591,   186,   187,
     592,   188,   593,   594,   595,   596,   597,   891,   892,   598,
     189,   190,   599,   191,   893,   600,   601,   602,   894,   895,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,   197,   198,   617,
     618,   619,   896,   620,   201,   897,   621,   622,   203,   623,
     898,   204,   624,   205,   206,   625,   626,   627,   899,   628,
     629,   630,   900,   901,   631,   632,   633,   634,   902,   903,
     635,   207,   208,   636,   209,   210,   637,   638,   639,   640,
     641,   642,   904,   643,   644,   645,   646,   905,   647,   648,
     212,   649,   213,   650,   651,   652,   653,   906,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,   907,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   908,   682,
     683,   222,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,   909,   697,   698,
     699,   700,   701,   910,   911,   703,   704,   231,   705,   706,
     707,   233,   708,   709,   710,   234,   711,   912,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,   913,   914,   725,   915,   726,   727,   916,   917,
     728,   238,   729,   730,   731,   732,   733,   918,   239,   240,
     919,   920,   735,   736,   241,   737,   242,   921,   738,   739,
     740,   741,   742,   743,   744,   922,   923,   745,   746,   747,
     748,   749,   750,   751,   924,   925,   752,   753,   754,   755,
     756,   926,   250,   927,   757,   251,   758,   759,   760,   761,
     928,   929,   930,   762,   931,   932,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    85,     0,     0,    86,
      87,    88,    89,    90,    91,    92,    93,     0,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,  1126,   104,
     105,   106,     0,     0,   107,   108,   109,   110,     0,   111,
     112,   113,   114,     0,   115,   116,   117,   118,   119,     0,
       0,     0,   120,   121,     0,     0,     0,     0,   122,     0,
       0,     0,     0,     0,     0,     0,     0,   123,     0,   124,
       0,   125,   126,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   127,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   128,     0,   129,
     130,     0,     0,     0,     0,     0,     0,     0,     0,   131,
       0,     0,   132,   133,     0,     0,     0,   134,   135,   136,
     137,   138,   139,   140,   141,   142,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,     0,   144,
     145,     0,   146,   147,   148,   149,     0,   150,     0,     0,
     151,     0,   152,   153,     0,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   155,     0,   156,   157,     0,
       0,     0,     0,     0,     0,   158,     0,     0,     0,     0,
       0,     0,   159,     0,     0,   160,   161,   162,   163,     0,
       0,     0,     0,     0, -1938,     0,     0,     0,     0,     0,
       0,     0,     0,   164,     0,     0,     0,     0,     0,   165,
       0,     0,     0,   166,     0,     0,     0,     0,     0,   167,
     168,     0,     0,     0,     0,     0,     0,     0,   169,   170,
     171,     0,     0,     0,   172,     0,     0,   173,     0,     0,
     174,     0,     0,     0,     0,     0,   175,     0,   176,     0,
       0,     0,     0,   177,     0,   178,     0,   179,     0,     0,
       0,     0,     0,     0,     0,     0,   180,     0,     0,     0,
     181,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     182,   183,     0,     0, -1938,     0,     0,   184,     0,   185,
       0,     0,   186,   187,     0,   188,     0,     0,     0,     0,
       0,     0,     0,     0,   189,   190,     0,   191,     0,   192,
     193,     0,     0,     0,     0,   194,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   195,     0,     0,
     196,   197,   198,     0,     0,     0,   199,   200,   201,     0,
       0,   202,   203,     0,     0,   204,     0,   205,   206,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   207,   208,     0,   209,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,     0,     0,     0,   212,     0,   213,     0,     0,   214,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   215,   216,     0,     0,     0,     0,     0,
       0,   217,   218,     0,   219,     0,     0,     0,     0,   220,
       0,     0,     0,     0,   221,   222,     0,   223,   224,     0,
     225,     0,     0,   226,   227,     0,     0,     0,     0,     0,
     228,   229,     0,     0,     0,     0,     0,     0,     0,   230,
       0,   231,     0,     0,   232,   233,     0,     0,     0,   234,
       0,     0,     0,     0,     0,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,     0,     0,     0,     0,
       0,     0,     0,   237,     0,   238,     0,     0,     0,     0,
       0,     0,   239,   240,     0,     0,     0,     0,   241,     0,
     242,     0,   243,     0,   244,     0,     0,     0,     0,   245,
       0,     0,   246,     0,     0,   247,     0, -1938,     0,     0,
     248,     0,     0,     0,     0,   249,   250,     0,     0,   251,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   252,
       0,     0,     0,     0,     0,     0,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,     0,     0,
       0,     0,   264,     0,     0,     0,     0,   834,    86,    87,
      88,   786,    90,    91,    92,   787,   265,   788,    95,     0,
    -165,    98,    99,   100,   101,   102,   103,   835,   104,   105,
     789,   836,     0,   107,   108,   109,   110,   837,   838,   112,
     113,   114,     0,   115,   839,   840,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,  3739,   474,   475,   476,     0,     0,
       0,     0,  1830,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,  1831,
     138,  1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,
     491,  1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,
     496,   497,   498,   499,  1840,     0,  1841,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,
     520,   521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,  3740,   536,   537,   538,   539,     0,   540,
     541,  1643,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1853,   556,
     557,   558,   559,  1854,  1855,   560,     0,   561,   562,  1856,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,  1857,     0,  1858,   571,   572,     0,
     573,   574,   805,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,  1646,  1859,     0,  1860,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,  1861,   190,   599,   191,     0,   600,   601,
     602,  1862,  1863,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,  1864,
     197,  1865,   617,   618,   619,     0,   620,   201,  1866,   621,
     622,   203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,  1871,   633,
     634,     0,     0,   635,   207,   208,   636,   209,  1872,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,  1873,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,  1874,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,  1875,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,  1876,  1877,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,  1878,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,  1879,     0,     0,   725,  1880,   726,
     727,  1881,     0,   728,   238,   729,   730,   731,   732,   733,
       0,  1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,
    1886,   738,   739,   740,   741,   742,   743,   744,     0,  1887,
     745,   746,   747,   748,   749,   750,   751,  1888,     0,   752,
     753,   754,   755,   756,   809,  1889,  3741,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,
     258,  1894,  1895,  1896,  1897,   263,   810,   769,   770,  1898,
       0,     0,     0,     0,     0,     0,  1899,  1900,  3742,     0,
       0,     0,     0,     0,     0,  1902,  3743,   834,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   835,   104,   105,
     789,   836,     0,   107,   108,   109,   110,   837,   838,   112,
     113,   114,     0,   115,   839,   840,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,  1830,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,  1831,
     138,  1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,
     491,  1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,
     496,   497,   498,   499,  1840,     0,  1841,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,
     520,   521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,  1643,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1853,   556,
     557,   558,   559,  1854,  1855,   560,     0,   561,   562,  1856,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,  1857,     0,  1858,   571,   572,     0,
     573,   574,   805,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,  1646,  1859,     0,  1860,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,  1861,   190,   599,   191,     0,   600,   601,
     602,  1862,  1863,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,  1864,
     197,  1865,   617,   618,   619,     0,   620,   201,  1866,   621,
     622,   203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,  1871,   633,
     634,     0,     0,   635,   207,   208,   636,   209,  1872,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,  1873,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,  1874,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,  1875,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
     229,   697,   698,   699,   700,   701,  1876,  1877,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,  1878,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,  1879,     0,     0,   725,  1880,   726,
     727,  1881,   237,   728,   238,   729,   730,   731,   732,   733,
       0,  1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,
    1886,   738,   739,   740,   741,   742,   743,   744,     0,  1887,
     745,   746,   747,   748,   749,   750,   751,  1888,     0,   752,
     753,   754,   755,   756,  2756,  1889,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,   252,   763,
     764,   765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,
     258,  1894,  1895,  1896,  1897,   263,   810,   769,   770,  1898,
       0,   264,     0,     0,     0,     0,  1899,  1900,     0,     0,
       0,     0,     0,     0,     0,  1902,  6130,   834,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   835,   104,   105,
     789,   836,     0,   107,   108,   109,   110,   837,   838,   112,
     113,   114,     0,   115,   839,   840,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,  1830,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,  1831,
     138,  1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,
     491,  1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,
     496,   497,   498,   499,  1840,     0,  1841,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,
     520,   521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,  1643,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1853,   556,
     557,   558,   559,  1854,  1855,   560,     0,   561,   562,  1856,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,  1857,     0,  1858,   571,   572,     0,
     573,   574,   805,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,  1646,  1859,     0,  1860,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,  1861,   190,   599,   191,     0,   600,   601,
     602,  1862,  1863,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,  1864,
     197,  1865,   617,   618,   619,     0,   620,   201,  1866,   621,
     622,   203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,  1871,   633,
     634,     0,     0,   635,   207,   208,   636,   209,  1872,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,  1873,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,  1874,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,  1875,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,  1876,  1877,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,  1878,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,  1879,     0,     0,   725,  1880,   726,
     727,  1881,     0,   728,   238,   729,   730,   731,   732,   733,
       0,  1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,
    1886,   738,   739,   740,   741,   742,   743,   744,     0,  1887,
     745,   746,   747,   748,   749,   750,   751,  1888,     0,   752,
     753,   754,   755,   756,   809,  1889,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,
     258,  1894,  1895,  1896,  1897,   263,   810,   769,   770,  1898,
       0,     0,     0,     0,     0,     0,  1899,  1900,     0,     0,
       0,     0,     0,     0,     0,  1902,  3649,   834,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   835,   104,   105,
     789,   836,     0,   107,   108,   109,   110,   837,   838,   112,
     113,   114,     0,   115,   839,   840,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,  1830,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,  1831,
     138,  1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,
     491,  1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,
     496,   497,   498,   499,  1840,     0,  1841,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,
     520,   521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,  1643,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1853,   556,
     557,   558,   559,  1854,  1855,   560,     0,   561,   562,  1856,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,  1857,     0,  1858,   571,   572,     0,
     573,   574,   805,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,  1646,  1859,     0,  1860,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,  1861,   190,   599,   191,     0,   600,   601,
     602,  1862,  1863,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,  1864,
     197,  1865,   617,   618,   619,     0,   620,   201,  1866,   621,
     622,   203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,  1871,   633,
     634,     0,     0,   635,   207,   208,   636,   209,  1872,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,  1873,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,  1874,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,  1875,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,  1876,  1877,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,  1878,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,  1879,     0,     0,   725,  1880,   726,
     727,  1881,     0,   728,   238,   729,   730,   731,   732,   733,
       0,  1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,
    1886,   738,   739,   740,   741,   742,   743,   744,     0,  1887,
     745,   746,   747,   748,   749,   750,   751,  1888,     0,   752,
     753,   754,   755,   756,   809,  1889,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,
     258,  1894,  1895,  1896,  1897,   263,   810,   769,   770,  1898,
       0,     0,     0,     0,     0,     0,  1899,  1900,     0,     0,
       0,     0,     0,     0,     0,  1902,  5052,   834,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   835,   104,   105,
     789,   836,     0,   107,   108,   109,   110,   837,   838,   112,
     113,   114,     0,   115,   839,   840,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,  1830,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,  1831,
     138,  1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,
     491,  1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,
     496,   497,   498,   499,  1840,     0,  1841,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,
     520,   521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,  1643,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1853,   556,
     557,   558,   559,  1854,  1855,   560,     0,   561,   562,  1856,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,  1857,     0,  1858,   571,   572,     0,
     573,   574,   805,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,  1646,  1859,     0,  1860,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,  1861,   190,   599,   191,     0,   600,   601,
     602,  1862,  1863,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,  1864,
     197,  1865,   617,   618,   619,     0,   620,   201,  1866,   621,
     622,   203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,  1871,   633,
     634,     0,     0,   635,   207,   208,   636,   209,  1872,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,  1873,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,  1874,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,  1875,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,  1876,  1877,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,  1878,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,  1879,     0,     0,   725,  1880,   726,
     727,  1881,     0,   728,   238,   729,   730,   731,   732,   733,
       0,  1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,
    1886,   738,   739,   740,   741,   742,   743,   744,     0,  1887,
     745,   746,   747,   748,   749,   750,   751,  1888,     0,   752,
     753,   754,   755,   756,   809,  1889,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,
     258,  1894,  1895,  1896,  1897,   263,   810,   769,   770,  1898,
       0,     0,     0,     0,     0,     0,  1899,  1900,     0,     0,
       0,     0,     0,     0,     0,  1902,  5123,   834,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   835,   104,   105,
     789,   836,     0,   107,   108,   109,   110,   837,   838,   112,
     113,   114,     0,   115,   839,   840,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,     0,  1634,
     138,  1635,  1636,  1637,  1638,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,  1639,  1640,   494,     0,   495,
     496,   497,   498,   499,     0,     0,   150,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,     0,     0,     0,   158,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,  1641,  1642,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,  1643,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,     0,     0,   560,     0,   561,   562,  1644,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,     0,     0,     0,   571,   572,     0,
     573,   574,   805,   575,   576,   180,   577,   578,   579,   580,
    2989,   581,   582,   583,   584,   585,   586,     0,   587,   182,
    2990,     0,   588,   589,   590,  1646,  1647,     0,  1648,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,     0,   190,   599,   191,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,  1649,
     197,  1650,   617,   618,   619,     0,   620,     0,     0,   621,
     622,   203,   623,     0,     0,   624,  1651,  1652,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,  2992,   208,   636,   209,     0,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,     0,   649,     0,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,  1653,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,     0,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
    2993,   705,   706,   707,   233,   708,   709,   710,  1655,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,     0,     0,     0,   725,     0,   726,
     727,     0,     0,   728,   238,   729,   730,   731,   732,   733,
       0,  1656,  1657,     0,     0,   735,   736,     0,   737,     0,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,     0,  1658,  2994,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   810,   769,   770,     0,
       0,     0,     0,   834,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,  3102,    98,    99,   100,
     101,   102,   103,   835,   104,   105,   789,   836,     0,   107,
     108,   109,   110,   837,   838,   112,   113,   114,     0,   115,
     839,   840,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,   133,   482,
     483,   484,   485,   486,     0,  1634,   138,  1635,  1636,  1637,
    1638,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,  1639,  1640,   494,     0,   495,   496,   497,   498,   499,
       0,     0,   150,     0,   500,   501,   502,   503,   504,   505,
     154,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,   157,   515,   516,     0,     0,     0,     0,
     158,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,  1641,  1642,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,  1643,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,     0,
       0,   560,     0,   561,   562,  1644,   563,     0,   564,     0,
     565,   175,     0,   176,   566,   567,   568,   569,     0,   570,
       0,     0,     0,   571,   572,     0,   573,   574,   805,   575,
     576,   180,   577,   578,   579,   580,  2989,   581,   582,   583,
     584,   585,   586,     0,   587,   182,  2990,     0,   588,   589,
     590,  1646,  1647,     0,  1648,     0,   591,   186,   187,   592,
     188,   593,   594,   595,   596,   597,     0,     0,   598,     0,
     190,   599,   191,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,  1649,   197,  1650,   617,   618,
     619,     0,   620,     0,     0,   621,   622,   203,   623,     0,
       0,   624,  1651,  1652,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
    2992,   208,   636,   209,     0,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,     0,
     649,     0,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,  1653,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
     222,   684,   685,   686,   687,     0,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,  2993,   705,   706,   707,
     233,   708,   709,   710,  1655,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
       0,     0,     0,   725,     0,   726,   727,     0,     0,   728,
     238,   729,   730,   731,   732,   733,     0,  1656,  1657,     0,
       0,   735,   736,     0,   737,     0,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
       0,  1658,  2994,   757,   251,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   810,   769,   770,     0,     0,     0,     0,   834,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,  4288,    98,    99,   100,   101,   102,   103,   835,
     104,   105,   789,   836,     0,   107,   108,   109,   110,   837,
     838,   112,   113,   114,     0,   115,   839,   840,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,   465,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1826,  1827,  1828,    45,
    1829,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,  1830,     0,     0,   477,   478,     0,
     479,   480,   481,     0,   133,   482,   483,   484,   485,   486,
     136,  1831,   138,  1832,  1833,  1834,  1835,     0,   487,   488,
     489,   490,   491,  1836,  1837,   492,   493,  1838,  1839,   494,
       0,   495,   496,   497,   498,   499,  1840,     0,  1841,     0,
     500,   501,   502,   503,   504,   505,   154,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,     0,   157,
     515,   516,     0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,
     518,   519,   520,   521,   803,  1849,   522,  1850,  1851,   523,
    1852,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,  1643,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1853,   556,   557,   558,   559,  1854,  1855,   560,     0,   561,
     562,  1856,   563,     0,   564,     0,   565,   175,     0,   176,
     566,   567,   568,   569,     0,   570,  1857,     0,  1858,   571,
     572,     0,   573,   574,   805,   575,   576,   180,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,   182,   183,     0,   588,   589,   590,  1646,  1859,     0,
    1860,     0,   591,   186,   187,   592,   188,   593,   594,   595,
     596,   597,     0,     0,   598,  1861,   190,   599,   191,     0,
     600,   601,   602,  1862,  1863,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,  1864,   197,  1865,   617,   618,   619,     0,   620,   201,
    1866,   621,   622,   203,   623,  1867,  1868,   624,  1869,  1870,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
    1871,   633,   634,     0,     0,   635,   207,   208,   636,   209,
    1872,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,  1873,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,  1874,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,   222,   684,   685,   686,
     687,  1875,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,   229,   697,   698,   699,   700,   701,  1876,  1877,
     703,   704,   231,   705,   706,   707,   233,   708,   709,   710,
    1878,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,  1879,     0,     0,   725,
    1880,   726,   727,  1881,   237,   728,   238,   729,   730,   731,
     732,   733,     0,  1882,  1883,     0,     0,   735,   736,  1884,
     737,  1885,  1886,   738,   739,   740,   741,   742,   743,   744,
       0,  1887,   745,   746,   747,   748,   749,   750,   751,  1888,
       0,   752,   753,   754,   755,   756,  2756,  1889,     0,   757,
     251,   758,   759,   760,   761,     0,     0,     0,   762,     0,
     252,   763,   764,   765,   766,   767,   768,   253,  1890,  1891,
    1892,  1893,   258,  1894,  1895,  1896,  1897,   263,   810,   769,
     770,  1898,     0,   264,     0,     0,     0,     0,  1899,  1900,
       0,     0,     0,     0,     0,     0,     0,  1902,   834,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   835,   104,
     105,   789,   836,     0,   107,   108,   109,   110,   837,   838,
     112,   113,   114,     0,   115,   839,   840,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,   465,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,  1826,  1827,  1828,    45,  1829,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,  1830,     0,     0,   477,   478,     0,   479,
     480,   481,     0,   133,   482,   483,   484,   485,   486,   136,
    1831,   138,  1832,  1833,  1834,  1835,  3655,   487,   488,   489,
     490,   491,  1836,  1837,   492,   493,  1838,  1839,   494,     0,
     495,   496,   497,   498,   499,  1840,     0,  1841,     0,   500,
     501,   502,   503,   504,   505,   154,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,   157,   515,
     516,     0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,
     519,   520,   521,   803,  1849,   522,  1850,  1851,   523,  1852,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,  1643,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1853,
     556,   557,   558,   559,  1854,  1855,   560,     0,   561,   562,
    1856,   563,     0,   564,     0,   565,   175,  3656,   176,   566,
     567,   568,   569,     0,   570,  1857,     0,  1858,   571,   572,
       0,   573,   574,   805,   575,   576,   180,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
     182,   183,     0,   588,   589,   590,  1646,  1859,     0,  1860,
       0,   591,   186,   187,   592,   188,   593,   594,   595,   596,
     597,     0,  3657,   598,  1861,   190,   599,   191,     0,   600,
     601,   602,  1862,  1863,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
    1864,   197,  1865,   617,   618,   619,     0,   620,   201,  1866,
     621,   622,   203,   623,  1867,  1868,   624,  1869,  1870,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,  1871,
     633,   634,     0,     0,   635,   207,   208,   636,   209,  1872,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,  1873,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,  1874,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,   222,   684,   685,   686,   687,
    1875,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,  1876,  1877,   703,
     704,   231,   705,   706,   707,   233,   708,   709,   710,  1878,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,  1879,     0,     0,   725,  1880,
     726,   727,  1881,     0,   728,   238,   729,   730,   731,   732,
     733,     0,  1882,  1883,     0,  3658,   735,   736,  1884,   737,
    1885,  1886,   738,   739,   740,   741,   742,   743,   744,     0,
    1887,   745,   746,   747,   748,   749,   750,   751,  1888,     0,
     752,   753,   754,   755,   756,   809,  1889,     0,   757,   251,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,  1890,  1891,  1892,
    1893,   258,  1894,  1895,  1896,  1897,   263,   810,   769,   770,
    1898,     0,     0,     0,     0,     0,     0,  1899,  1900,     0,
       0,     0,     0,     0,     0,     0,  1902,   834,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   835,   104,   105,
     789,   836,     0,   107,   108,   109,   110,   837,   838,   112,
     113,   114,     0,   115,   839,   840,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,  1830,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,  1831,
     138,  1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,
     491,  1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,
     496,   497,   498,   499,  1840,     0,  1841,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,
     520,   521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,  1643,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1853,   556,
     557,   558,   559,  1854,  1855,   560,     0,   561,   562,  1856,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,  1857,     0,  1858,   571,   572,     0,
     573,   574,   805,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,  1646,  1859,     0,  1860,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,  1861,   190,   599,   191,     0,   600,   601,
     602,  1862,  1863,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,  1864,
     197,  1865,   617,   618,   619,     0,   620,   201,  1866,   621,
     622,   203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,  1871,   633,
     634,     0,     0,   635,   207,   208,   636,   209,  1872,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,  1873,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,  1874,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,  1875,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,  1876,  1877,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,  1878,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,  1879,     0,     0,   725,  1880,   726,
     727,  1881,     0,   728,   238,   729,   730,   731,   732,   733,
       0,  1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,
    1886,   738,   739,   740,   741,   742,   743,   744,     0,  1887,
     745,   746,   747,   748,   749,   750,   751,  1888,     0,   752,
     753,   754,   755,   756,   809,  1889,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,
     258,  1894,  1895,  1896,  1897,   263,   810,   769,   770,  1898,
       0,     0,     0,     0,     0,     0,  1899,  1900,     0,     0,
       0,     0,     0,  2718,  3610,  1902,   834,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   835,   104,   105,   789,
     836,     0,   107,   108,   109,   110,   837,   838,   112,   113,
     114,     0,   115,   839,   840,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,   465,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,  1830,     0,     0,   477,   478,     0,   479,   480,   481,
       0,   133,   482,   483,   484,   485,   486,   136,  1831,   138,
    1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,   491,
    1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,   496,
     497,   498,   499,  1840,     0,  1841,     0,   500,   501,   502,
     503,   504,   505,   154,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,   157,   515,   516,     0,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,   520,
     521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
    1643,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1853,   556,   557,
     558,   559,  1854,  1855,   560,     0,   561,   562,  1856,   563,
       0,   564,     0,   565,   175,     0,   176,   566,   567,   568,
     569,     0,   570,  1857,     0,  1858,   571,   572,     0,   573,
     574,   805,   575,   576,   180,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,   182,   183,
       0,   588,   589,   590,  1646,  1859,     0,  1860,     0,   591,
     186,   187,   592,   188,   593,   594,   595,   596,   597,     0,
       0,   598,  1861,   190,   599,   191,     0,   600,   601,   602,
    1862,  1863,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,  1864,   197,
    1865,   617,   618,   619,     0,   620,   201,  1866,   621,   622,
     203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,  1871,   633,   634,
       0,     0,   635,   207,   208,   636,   209,  1872,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,  1873,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,  1874,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,   222,   684,   685,   686,   687,  1875,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,  1876,  1877,   703,   704,   231,
     705,   706,   707,   233,   708,   709,   710,  1878,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,  1879,     0,     0,   725,  1880,   726,   727,
    1881,     0,   728,   238,   729,   730,   731,   732,   733,     0,
    1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,  1886,
     738,   739,   740,   741,   742,   743,   744,     0,  1887,   745,
     746,   747,   748,   749,   750,   751,  1888,     0,   752,   753,
     754,   755,   756,   809,  1889,     0,   757,   251,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,   258,
    1894,  1895,  1896,  1897,   263,   810,   769,   770,  1898,     0,
       0,     0,     0,     0,     0,  1899,  1900,  1901,     0,     0,
       0,     0,     0,     0,  1902,   834,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   835,   104,   105,   789,   836,
       0,   107,   108,   109,   110,   837,   838,   112,   113,   114,
       0,   115,   839,   840,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,   465,     0,     0,    37,    38,    39,    40,    41,    42,
      43,    44,  1826,  1827,  1828,    45,  1829,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,  2911,   474,   475,   476,     0,     0,     0,     0,
    1830,     0,     0,   477,   478,     0,   479,   480,   481,     0,
     133,   482,   483,   484,   485,   486,   136,  1831,   138,  1832,
    1833,  1834,  1835,     0,   487,   488,   489,   490,   491,  1836,
    1837,   492,   493,  1838,  1839,   494,     0,   495,   496,   497,
     498,   499,  1840,     0,  1841,     0,   500,   501,   502,   503,
     504,   505,   154,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,   157,   515,   516,     0,  1842,
    1843,  1844,  1845,  1846,  1847,  1848,   518,   519,   520,   521,
     803,  1849,   522,  1850,  1851,   523,  1852,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,  1643,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1853,   556,   557,   558,
     559,  1854,  1855,   560,     0,   561,   562,  1856,   563,     0,
     564,     0,   565,   175,     0,   176,   566,   567,   568,   569,
       0,   570,  1857,     0,  1858,   571,   572,     0,   573,   574,
     805,   575,   576,   180,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,   182,   183,     0,
     588,   589,   590,  1646,  1859,     0,  1860,     0,   591,   186,
     187,   592,   188,   593,   594,   595,   596,   597,     0,     0,
     598,  1861,   190,   599,   191,     0,   600,   601,   602,  1862,
    1863,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,  1864,   197,  1865,
     617,   618,   619,     0,   620,   201,  1866,   621,   622,   203,
     623,  1867,  1868,   624,  1869,  1870,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,  1871,   633,   634,     0,
       0,   635,   207,   208,   636,   209,  1872,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,  1873,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
    1874,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,   222,   684,   685,   686,   687,  1875,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,  1876,  1877,   703,   704,   231,   705,
     706,   707,   233,   708,   709,   710,  1878,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,  1879,     0,     0,   725,  1880,   726,   727,  1881,
       0,   728,   238,   729,   730,   731,   732,   733,     0,  1882,
    1883,     0,     0,   735,   736,  1884,   737,  1885,  1886,   738,
     739,   740,   741,   742,   743,   744,     0,  1887,   745,   746,
     747,   748,   749,   750,   751,  1888,     0,   752,   753,   754,
     755,   756,   809,  1889,     0,   757,   251,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,  1890,  1891,  1892,  1893,   258,  1894,
    1895,  1896,  1897,   263,   810,   769,   770,  1898,     0,     0,
       0,     0,     0,     0,  1899,  1900,     0,     0,     0,     0,
       0,     0,     0,  1902,   834,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   835,   104,   105,   789,   836,     0,
     107,   108,   109,   110,   837,   838,   112,   113,   114,     0,
     115,   839,   840,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
     465,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1826,  1827,  1828,    45,  1829,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,  1830,
       0,     0,   477,   478,     0,   479,   480,   481,     0,   133,
     482,   483,   484,   485,   486,   136,  1831,   138,  1832,  1833,
    1834,  1835,     0,   487,   488,   489,   490,   491,  1836,  1837,
     492,   493,  1838,  1839,   494,     0,   495,   496,   497,   498,
     499,  1840,     0,  1841,     0,   500,   501,   502,   503,   504,
     505,   154,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,   157,   515,   516,     0,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,   518,   519,   520,   521,   803,
    1849,   522,  1850,  1851,   523,  1852,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,  1643,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,  1853,   556,   557,   558,   559,
    1854,  1855,   560,     0,   561,   562,  1856,   563,     0,   564,
       0,   565,   175,  3656,   176,   566,   567,   568,   569,     0,
     570,  1857,     0,  1858,   571,   572,     0,   573,   574,   805,
     575,   576,   180,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,   182,   183,     0,   588,
     589,   590,  1646,  1859,     0,  1860,     0,   591,   186,   187,
     592,   188,   593,   594,   595,   596,   597,     0,     0,   598,
    1861,   190,   599,   191,     0,   600,   601,   602,  1862,  1863,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,  1864,   197,  1865,   617,
     618,   619,     0,   620,   201,  1866,   621,   622,   203,   623,
    1867,  1868,   624,  1869,  1870,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,  1871,   633,   634,     0,     0,
     635,   207,   208,   636,   209,  1872,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
    1873,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,  1874,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,   222,   684,   685,   686,   687,  1875,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,  1876,  1877,   703,   704,   231,   705,   706,
     707,   233,   708,   709,   710,  1878,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,  1879,     0,     0,   725,  1880,   726,   727,  1881,     0,
     728,   238,   729,   730,   731,   732,   733,     0,  1882,  1883,
       0,     0,   735,   736,  1884,   737,  1885,  1886,   738,   739,
     740,   741,   742,   743,   744,     0,  1887,   745,   746,   747,
     748,   749,   750,   751,  1888,     0,   752,   753,   754,   755,
     756,   809,  1889,     0,   757,   251,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,  1890,  1891,  1892,  1893,   258,  1894,  1895,
    1896,  1897,   263,   810,   769,   770,  1898,     0,     0,     0,
       0,     0,     0,  1899,  1900,     0,     0,     0,     0,     0,
       0,     0,  1902,   834,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   835,   104,   105,   789,   836,     0,   107,
     108,   109,   110,   837,   838,   112,   113,   114,     0,   115,
     839,   840,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,   465,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
    1826,  1827,  1828,    45,  1829,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,  1830,     0,
       0,   477,   478,     0,   479,   480,   481,     0,   133,   482,
     483,   484,   485,   486,   136,  1831,   138,  1832,  1833,  1834,
    1835,     0,   487,   488,   489,   490,   491,  1836,  1837,   492,
     493,  1838,  1839,   494,     0,   495,   496,   497,   498,   499,
    1840,     0,  1841,     0,   500,   501,   502,   503,   504,   505,
     154,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,   157,   515,   516,     0,  1842,  1843,  1844,
    1845,  1846,  1847,  1848,   518,   519,   520,   521,   803,  1849,
     522,  1850,  1851,   523,  1852,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,  1643,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1853,   556,   557,   558,   559,  1854,
    1855,   560,     0,   561,   562,  1856,   563,     0,   564,     0,
     565,   175,     0,   176,   566,   567,   568,   569,     0,   570,
    1857,     0,  1858,   571,   572,     0,   573,   574,   805,   575,
     576,   180,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,   182,   183,     0,   588,   589,
     590,  1646,  1859,     0,  1860,     0,   591,   186,   187,   592,
     188,   593,   594,   595,   596,   597,     0,     0,   598,  1861,
     190,   599,   191,     0,   600,   601,   602,  1862,  1863,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,  1864,   197,  1865,   617,   618,
     619,     0,   620,   201,  1866,   621,   622,   203,   623,  1867,
    1868,   624,  1869,  1870,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,  1871,   633,   634,     0,     0,   635,
     207,   208,   636,   209,  1872,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,  1873,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,  1874,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
     222,   684,   685,   686,   687,  1875,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,  1876,  1877,   703,   704,   231,   705,   706,   707,
     233,   708,   709,   710,  1878,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
    1879,     0,     0,   725,  1880,   726,   727,  1881,     0,   728,
     238,   729,   730,   731,   732,   733,     0,  1882,  1883,     0,
       0,   735,   736,  1884,   737,  1885,  1886,   738,   739,   740,
     741,   742,   743,   744,     0,  1887,   745,   746,   747,   748,
     749,   750,   751,  1888,     0,   752,   753,   754,   755,   756,
     809,  1889,  5173,   757,   251,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,  1890,  1891,  1892,  1893,   258,  1894,  1895,  1896,
    1897,   263,   810,   769,   770,  1898,     0,     0,     0,     0,
       0,     0,  1899,  1900,     0,     0,     0,     0,     0,     0,
       0,  1902,   834,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   835,   104,   105,   789,   836,     0,   107,   108,
     109,   110,   837,   838,   112,   113,   114,     0,   115,   839,
     840,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,   465,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1826,
    1827,  1828,    45,  1829,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,  1830,     0,     0,
     477,   478,     0,   479,   480,   481,     0,   133,   482,   483,
     484,   485,   486,   136,  1831,   138,  1832,  1833,  1834,  1835,
       0,   487,   488,   489,   490,   491,  1836,  1837,   492,   493,
    1838,  1839,   494,     0,   495,   496,   497,   498,   499,  1840,
       0,  1841,     0,   500,   501,   502,   503,   504,   505,   154,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,   157,   515,   516,  5193,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,   518,   519,   520,   521,   803,  1849,   522,
    1850,  1851,   523,  1852,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,  1643,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1853,   556,   557,   558,   559,  1854,  1855,
     560,     0,   561,   562,  1856,   563,     0,   564,     0,   565,
     175,     0,   176,   566,   567,   568,   569,     0,   570,  1857,
       0,  1858,   571,   572,     0,   573,   574,   805,   575,   576,
     180,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,   182,   183,     0,   588,   589,   590,
    1646,  1859,     0,  1860,     0,   591,   186,   187,   592,   188,
     593,   594,   595,   596,   597,     0,     0,   598,  1861,   190,
     599,   191,     0,   600,   601,   602,  1862,  1863,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,  1864,   197,  1865,   617,   618,   619,
       0,   620,   201,  1866,   621,   622,   203,   623,  1867,  1868,
     624,  1869,  1870,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,  1871,   633,   634,     0,     0,   635,   207,
     208,   636,   209,  1872,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,  1873,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,  1874,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,   222,
     684,   685,   686,   687,  1875,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,  1876,  1877,   703,   704,   231,   705,   706,   707,   233,
     708,   709,   710,  1878,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,  1879,
       0,     0,   725,  1880,   726,   727,  1881,     0,   728,   238,
     729,   730,   731,   732,   733,     0,  1882,  1883,     0,     0,
     735,   736,  1884,   737,  1885,  1886,   738,   739,   740,   741,
     742,   743,   744,     0,  1887,   745,   746,   747,   748,   749,
     750,   751,  1888,     0,   752,   753,   754,   755,   756,   809,
    1889,     0,   757,   251,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,  1890,  1891,  1892,  1893,   258,  1894,  1895,  1896,  1897,
     263,   810,   769,   770,  1898,     0,     0,     0,     0,     0,
       0,  1899,  1900,     0,     0,     0,     0,     0,     0,     0,
    1902,   834,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   835,   104,   105,   789,   836,     0,   107,   108,   109,
     110,   837,   838,   112,   113,   114,     0,   115,   839,   840,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,   465,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,  1826,  1827,
    1828,    45,  1829,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,  1830,     0,     0,   477,
     478,     0,   479,   480,   481,     0,   133,   482,   483,   484,
     485,   486,  6405,  1831,   138,  1832,  1833,  1834,  1835,     0,
     487,   488,   489,   490,   491,  1836,  1837,   492,   493,  1838,
    1839,   494,     0,   495,   496,   497,   498,   499,  1840,     0,
    1841,     0,   500,   501,   502,   503,   504,   505,   154,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,   157,   515,   516,  6406,  1842,  1843,  1844,  1845,  1846,
    1847,  1848,   518,   519,   520,   521,   803,  1849,   522,  1850,
    1851,   523,  1852,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,  1643,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1853,   556,   557,   558,   559,  1854,  1855,   560,
       0,   561,   562,  1856,   563,     0,   564,     0,   565,   175,
       0,   176,   566,   567,   568,   569,     0,   570,  1857,     0,
    1858,   571,   572,     0,   573,   574,   805,   575,   576,   180,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,   182,   183,     0,   588,   589,   590,  1646,
    1859,     0,  1860,     0,   591,   186,   187,   592,   188,   593,
     594,   595,   596,   597,     0,     0,   598,  1861,   190,   599,
     191,     0,   600,   601,   602,  1862,  1863,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,  1864,   197,  1865,   617,   618,   619,     0,
     620,   201,  1866,   621,   622,   203,   623,  1867,  1868,   624,
    1869,  1870,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,  1871,   633,   634,     0,     0,   635,   207,   208,
     636,   209,  1872,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,  1873,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,  1874,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,   222,   684,
     685,   686,   687,  1875,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
    1876,  1877,   703,   704,   231,   705,   706,   707,   233,   708,
     709,   710,  1878,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,  1879,     0,
       0,   725,  1880,   726,   727,  1881,     0,   728,   238,   729,
     730,   731,   732,   733,     0,  1882,  1883,     0,     0,   735,
     736,  1884,   737,  1885,  1886,   738,   739,   740,   741,  6407,
     743,   744,     0,  1887,   745,   746,   747,   748,   749,   750,
     751,  1888,     0,   752,   753,   754,   755,   756,   809,  1889,
       0,   757,   251,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
    1890,  1891,  1892,  1893,   258,  1894,  1895,  1896,  1897,   263,
     810,   769,   770,  1898,     0,     0,     0,     0,     0,     0,
    1899,  1900,     0,     0,     0,     0,     0,     0,     0,  1902,
     834,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     835,   104,   105,   789,   836,     0,   107,   108,   109,   110,
     837,   838,   112,   113,   114,     0,   115,   839,   840,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,   465,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1826,  1827,  1828,
      45,  1829,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,  1830,     0,     0,   477,   478,
       0,   479,   480,   481,     0,   133,   482,   483,   484,   485,
     486,   136,  1831,   138,  1832,  1833,  1834,  1835,     0,   487,
     488,   489,   490,   491,  1836,  1837,   492,   493,  1838,  1839,
     494,     0,   495,   496,   497,   498,   499,  1840,     0,  1841,
       0,   500,   501,   502,   503,   504,   505,   154,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
     157,   515,   516,  6406,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,   518,   519,   520,   521,   803,  1849,   522,  1850,  1851,
     523,  1852,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,  1643,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,  1853,   556,   557,   558,   559,  1854,  1855,   560,     0,
     561,   562,  1856,   563,     0,   564,     0,   565,   175,     0,
     176,   566,   567,   568,   569,     0,   570,  1857,     0,  1858,
     571,   572,     0,   573,   574,   805,   575,   576,   180,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,   182,   183,     0,   588,   589,   590,  1646,  1859,
       0,  1860,     0,   591,   186,   187,   592,   188,   593,   594,
     595,   596,   597,     0,     0,   598,  1861,   190,   599,   191,
       0,   600,   601,   602,  1862,  1863,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,  1864,   197,  1865,   617,   618,   619,     0,   620,
     201,  1866,   621,   622,   203,   623,  1867,  1868,   624,  1869,
    1870,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,  1871,   633,   634,     0,     0,   635,   207,   208,   636,
     209,  1872,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,  1873,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,  1874,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,   222,   684,   685,
     686,   687,  1875,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,  1876,
    1877,   703,   704,   231,   705,   706,   707,   233,   708,   709,
     710,  1878,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,  1879,     0,     0,
     725,  1880,   726,   727,  1881,     0,   728,   238,   729,   730,
     731,   732,   733,     0,  1882,  1883,     0,     0,   735,   736,
    1884,   737,  1885,  1886,   738,   739,   740,   741,  6407,   743,
     744,     0,  1887,   745,   746,   747,   748,   749,   750,   751,
    1888,     0,   752,   753,   754,   755,   756,   809,  1889,     0,
     757,   251,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,  1890,
    1891,  1892,  1893,   258,  1894,  1895,  1896,  1897,   263,   810,
     769,   770,  1898,     0,     0,     0,     0,     0,     0,  1899,
    1900,     0,     0,     0,     0,     0,     0,     0,  1902,   834,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   835,
     104,   105,   789,   836,     0,   107,   108,   109,   110,   837,
     838,   112,   113,   114,     0,   115,   839,   840,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,   465,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1826,  1827,  1828,    45,
    1829,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,  1830,     0,     0,   477,   478,     0,
     479,   480,   481,     0,   133,   482,   483,   484,   485,   486,
     136,  1831,   138,  1832,  1833,  1834,  1835,     0,   487,   488,
     489,   490,   491,  1836,  1837,   492,   493,  1838,  1839,   494,
       0,   495,   496,   497,   498,   499,  1840,     0,  1841,     0,
     500,   501,   502,   503,   504,   505,   154,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,     0,   157,
     515,   516,     0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,
     518,   519,   520,   521,   803,  1849,   522,  1850,  1851,   523,
    1852,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,  1643,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1853,   556,   557,   558,   559,  1854,  1855,   560,     0,   561,
     562,  1856,   563,     0,   564,     0,   565,   175,     0,   176,
     566,   567,   568,   569,     0,   570,  1857,     0,  1858,   571,
     572,     0,   573,   574,   805,   575,   576,   180,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,   182,   183,     0,   588,   589,   590,  1646,  1859,     0,
    1860,     0,   591,   186,   187,   592,   188,   593,   594,   595,
     596,   597,     0,     0,   598,  1861,   190,   599,   191,     0,
     600,   601,   602,  1862,  1863,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,  1864,   197,  1865,   617,   618,   619,     0,   620,   201,
    1866,   621,   622,   203,   623,  1867,  1868,   624,  1869,  1870,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
    1871,   633,   634,     0,     0,   635,   207,   208,   636,   209,
    1872,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,  1873,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,  1874,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,   222,   684,   685,   686,
     687,  1875,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,     0,   697,   698,   699,   700,   701,  1876,  1877,
     703,   704,   231,   705,   706,   707,   233,   708,   709,   710,
    1878,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,  1879,     0,     0,   725,
    1880,   726,   727,  1881,     0,   728,   238,   729,   730,   731,
     732,   733,     0,  1882,  1883,     0,     0,   735,   736,  1884,
     737,  1885,  1886,   738,   739,   740,   741,   742,   743,   744,
       0,  1887,   745,   746,   747,   748,   749,   750,   751,  1888,
       0,   752,   753,   754,   755,   756,   809,  1889,     0,   757,
     251,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,  1890,  1891,
    1892,  1893,   258,  1894,  1895,  1896,  1897,   263,   810,   769,
     770,  1898,     0,     0,     0,     0,     0,     0,  1899,  1900,
       0,     0,     0,     0,     0,     0,     0,  1902,   834,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   835,   104,
     105,   789,   836,     0,   107,   108,   109,   110,   837,   838,
     112,   113,   114,     0,   115,   839,   840,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,   465,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,  1826,  1827,  1828,    45,  1829,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,  1830,     0,     0,   477,   478,     0,   479,
     480,   481,     0,   133,   482,   483,   484,   485,   486,   136,
    1831,   138,  1832,  1833,  1834,  1835,     0,   487,   488,   489,
     490,   491,  1836,  1837,   492,   493,  1838,  1839,   494,     0,
     495,   496,   497,   498,   499,  1840,     0,  1841,     0,   500,
     501,   502,   503,   504,   505,   154,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,   157,   515,
     516,     0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,
     519,   520,   521,   803,  1849,   522,  1850,  1851,   523,  1852,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,  1643,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1853,
     556,   557,   558,   559,  1854,  1855,   560,     0,   561,   562,
    1856,   563,     0,   564,     0,   565,   175,     0,   176,   566,
     567,   568,   569,     0,   570,  1857,     0,  1858,   571,   572,
       0,   573,   574,   805,   575,   576,   180,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
     182,   183,     0,   588,   589,   590,  1646,  1859,     0,  1860,
       0,   591,   186,   187,   592,   188,   593,   594,   595,   596,
     597,     0,     0,   598,  1861,   190,   599,   191,     0,   600,
     601,   602,  1862,  1863,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
    1864,   197,  1865,   617,   618,   619,     0,   620,   201,  1866,
     621,   622,   203,   623,  1867,  1868,   624,  1869,  1870,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,  1871,
     633,   634,     0,     0,   635,   207,   208,   636,   209,  1872,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,  1873,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,  1874,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,   222,   684,   685,   686,   687,
    1875,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,  1876,  1877,   703,
     704,   231,   705,   706,   707,   233,   708,   709,   710,  1878,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,  1879,     0,     0,   725,  1880,
     726,   727,  1881,     0,   728,   238,   729,   730,   731,   732,
     733,     0,  1882,  1883,     0,     0,   735,   736,  1884,   737,
    1885,  1886,   738,   739,   740,   741,   742,   743,   744,     0,
    1887,   745,   746,   747,   748,   749,   750,   751,  1888,     0,
     752,   753,   754,   755,   756,   809,  1889,     0,   757,   251,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,  5553,  1890,  1891,  1892,
    1893,   258,  1894,  1895,  1896,  1897,   263,   810,   769,   770,
    1898,     0,     0,     0,     0,     0,     0,  1899,  1900,     0,
       0,     0,     0,     0,     0,     0,  1902,   834,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   835,   104,   105,
     789,   836,     0,   107,   108,   109,   110,   837,   838,   112,
     113,   114,     0,   115,   839,   840,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,  1830,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,  1831,
     138,  1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,
     491,  1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,
     496,   497,   498,   499,  1840,     0,  1841,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,  1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,
     520,   521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,  1643,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1853,   556,
     557,   558,   559,  1854,  1855,   560,     0,   561,   562,  1856,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,  1857,     0,  1858,   571,   572,     0,
     573,   574,   805,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,  1646,  1859,     0,  1860,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,  1861,   190,   599,   191,     0,   600,   601,
     602,  1862,  1863,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,  1864,
     197,  1865,   617,   618,  5562,     0,   620,   201,  1866,   621,
     622,   203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,  1871,   633,
     634,     0,     0,   635,   207,   208,   636,   209,  1872,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,  1873,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,  1874,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,  1875,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,  1876,  1877,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,  1878,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,  1879,     0,     0,   725,  1880,   726,
     727,  1881,     0,   728,   238,   729,   730,   731,   732,   733,
       0,  1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,
    1886,   738,   739,   740,   741,   742,   743,   744,     0,  1887,
     745,   746,   747,   748,   749,   750,   751,  1888,     0,   752,
     753,   754,   755,   756,   809,  1889,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,
     258,  1894,  1895,  1896,  1897,   263,   810,   769,   770,  1898,
       0,     0,     0,     0,     0,     0,  1899,  1900,     0,     0,
       0,     0,     0,     0,     0,  1902,   834,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   835,   104,   105,   789,
     836,     0,   107,   108,   109,   110,   837,   838,   112,   113,
     114,     0,   115,   839,   840,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,   465,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,  1830,     0,     0,   477,   478,     0,   479,   480,   481,
       0,   133,   482,   483,   484,   485,   486,   136,  1831,   138,
    1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,   491,
    1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,   496,
     497,   498,   499,  1840,     0,  1841,     0,   500,   501,   502,
     503,   504,   505,   154,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,   157,   515,  5902,     0,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,   520,
     521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
    1643,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1853,   556,   557,
     558,   559,  1854,  1855,   560,     0,   561,   562,  1856,   563,
       0,   564,     0,   565,   175,     0,   176,   566,   567,   568,
     569,     0,   570,  1857,     0,  5903,   571,   572,     0,   573,
     574,   805,   575,   576,   180,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,   182,   183,
       0,   588,   589,   590,  1646,  1859,     0,  1860,     0,   591,
     186,   187,   592,   188,   593,   594,   595,   596,   597,     0,
       0,   598,  1861,   190,   599,   191,     0,   600,   601,   602,
    1862,  1863,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,  1864,   197,
    1865,   617,   618,   619,     0,   620,   201,  1866,   621,   622,
     203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,  1871,   633,   634,
       0,     0,   635,   207,   208,   636,   209,  1872,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,  1873,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,  1874,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,   222,   684,   685,   686,  5904,  1875,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,  1876,  1877,   703,   704,   231,
     705,   706,   707,   233,   708,   709,   710,  1878,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,  1879,     0,     0,   725,  1880,   726,   727,
    1881,     0,   728,   238,   729,   730,   731,   732,   733,     0,
    1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,  1886,
     738,   739,   740,   741,   742,   743,   744,     0,  1887,   745,
     746,   747,   748,   749,   750,   751,  1888,     0,   752,   753,
     754,   755,   756,   809,  1889,     0,   757,   251,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,   258,
    1894,  1895,  1896,  1897,   263,   810,   769,   770,  1898,     0,
       0,     0,     0,     0,     0,  1899,  1900,     0,     0,     0,
       0,     0,     0,     0,  5905,   834,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   835,   104,   105,   789,   836,
       0,   107,   108,   109,   110,   837,   838,   112,   113,   114,
       0,   115,   839,   840,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,   465,     0,     0,    37,    38,    39,    40,    41,    42,
      43,    44,  1826,  1827,  1828,    45,  1829,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
    1830,     0,     0,   477,   478,     0,   479,   480,   481,     0,
     133,   482,   483,   484,   485,   486, -3325,  1831,   138,  1832,
    1833,  1834,  1835,     0,   487,   488,   489,   490,   491,  1836,
    1837,   492,   493,  1838,  1839,   494,     0,   495,   496,   497,
     498,   499,  1840,     0,  1841,     0,   500,   501,   502,   503,
     504,   505,   154,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,   157,   515,   516,  6406,  1842,
    1843,  1844,  1845,  1846,  1847,  1848,   518,   519,   520,   521,
     803,  1849,   522,  1850,  1851,   523,  1852,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,  1643,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1853,   556,   557,   558,
     559,  1854,  1855,   560,     0,   561,   562,  1856,   563,     0,
     564,     0,   565,   175,     0,   176,   566,   567,   568,   569,
       0,   570,  1857,     0,  1858,   571,   572,     0,   573,   574,
     805,   575,   576, -3325,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,   182,   183,     0,
     588,   589,   590,  1646,  1859,     0,  1860,     0,   591,     0,
       0,   592,   188,   593,   594,   595,   596,   597,     0,     0,
     598,  1861,   190,   599, -3325,     0,   600,   601,   602,  1862,
    1863,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,  1864,   197,  1865,
     617,   618,   619,     0,   620,   201,  1866,   621,   622,     0,
     623,  1867,  1868,   624,  1869,  1870,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,  1871,   633,   634,     0,
       0,   635,   207,   208,   636,   209,  1872,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,  1873,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
    1874,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,   222,   684,   685,   686,   687,  1875,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,  1876,  1877,   703,   704,   231,   705,
     706,   707, -3325,   708,   709,   710,  1878,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,  1879,     0,     0,   725,  1880,   726,   727,  1881,
       0,   728,   238,   729,   730,   731,   732,   733,     0,  1882,
    1883,     0,     0,   735,   736,  1884,   737,  1885,  1886,   738,
     739,   740,   741,  6407,   743,   744,     0,  1887,   745,   746,
     747,   748,   749,   750,   751,  1888,     0,   752,   753,   754,
     755,   756,   809,  1889,     0,   757,   251,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,  1890,  1891,  1892,  1893,   258,  1894,
    1895,  1896,  1897,   263,   810,   769,   770, -3325,     0,     0,
       0,     0,     0,     0,  1899,  1900,     0,     0,     0,     0,
       0,     0,     0,  1902,   834,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   835,   104,   105,   789,   836,     0,
     107,   108,   109,   110,   837,   838,   112,   113,   114,     0,
     115,   839,   840,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
     465,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1826,  1827,  1828,    45,  1829,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,  1830,
       0,     0,   477,   478,     0,   479,   480,   481,     0,   133,
     482,   483,   484,   485,   486,   136,  1831,   138,  1832,  1833,
    1834,  1835,     0,   487,   488,   489,   490,   491,  1836,  1837,
     492,   493,  1838,  1839,   494,     0,   495,   496,   497,   498,
     499,  1840,     0,  1841,     0,   500,   501,   502,   503,   504,
     505,   154,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,   157,   515,   516,     0,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,   518,   519,   520,   521,   803,
    1849,   522,  1850,  1851,   523,  6111,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,  1643,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,  1853,   556,   557,   558,   559,
    1854,  1855,   560,     0,   561,   562,  1856,   563,     0,   564,
       0,   565,   175,     0,   176,   566,   567,   568,   569,     0,
     570,  1857,     0,  1858,   571,   572,     0,   573,   574,   805,
     575,   576,   180,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,   182,   183,     0,   588,
     589,   590,  1646,  1859,     0,  1860,     0,   591,   186,   187,
     592,   188,   593,   594,   595,   596,   597,     0,     0,   598,
    1861,   190,   599,   191,     0,   600,   601,   602,  1862,  1863,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,  1864,   197,  1865,   617,
     618,   619,     0,   620,   201,     0,   621,   622,   203,   623,
    1867,  1868,   624,  1869,  1870,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,  1871,   633,   634,     0,     0,
     635,   207,   208,   636,   209,  1872,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
    1873,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,  1874,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,   222,   684,   685,   686,   687,  3641,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,  1876,  1877,   703,   704,   231,   705,   706,
     707,   233,   708,   709,   710,  1878,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,  1879,     0,     0,   725,  1880,   726,   727,  1881,     0,
     728,   238,   729,   730,   731,   732,   733,     0,  1882,  1883,
       0,     0,   735,   736,  1884,   737,  1885,  1886,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,  1888,     0,   752,   753,   754,   755,
     756,   809,  1889,     0,   757,   251,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,  1890,  1891,  1892,  1893,   258,  1894,  1895,
    1896,  1897,   263,   810,   769,   770,     0,     0,     0,     0,
       0,     0,     0,  3642,  3643,     0,     0,     0,     0,     0,
       0,     0,  3644,   834,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   835,   104,   105,   789,   836,     0,   107,
     108,   109,   110,   837,   838,   112,   113,   114,     0,   115,
     839,   840,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,   465,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
    1826,  1827,  1828,    45,  1829,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,  1830,     0,
       0,   477,   478,     0,   479,   480,   481,     0,   133,   482,
     483,   484,   485,   486,   136,  1831,   138,  1832,  1833,  1834,
    1835,     0,   487,   488,   489,   490,   491,  1836,  1837,   492,
     493,  1838,  1839,   494,     0,   495,   496,   497,   498,   499,
    1840,     0,  1841,     0,   500,   501,   502,   503,   504,   505,
     154,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,   157,   515,   516,     0,  1842,  1843,  1844,
    1845,  1846,  1847,  1848,   518,   519,   520,   521,   803,  1849,
     522,  1850,  1851,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,  1643,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1853,   556,   557,   558,   559,  1854,
    1855,   560,     0,   561,   562,  1856,   563,     0,   564,     0,
     565,   175,     0,   176,   566,   567,   568,   569,     0,   570,
    1857,     0,  1858,   571,   572,     0,   573,   574,   805,   575,
     576,   180,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,   182,   183,     0,   588,   589,
     590,  1646,  1859,     0,  1860,     0,   591,   186,   187,   592,
     188,   593,   594,   595,   596,   597,     0,     0,   598,  1861,
     190,   599,   191,     0,   600,   601,   602,  1862,  1863,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,  1864,   197,  1865,   617,   618,
     619,     0,   620,   201,     0,   621,   622,   203,   623,  1867,
    1868,   624,  1869,  1870,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,  1871,   633,   634,     0,     0,   635,
     207,   208,   636,   209,  1872,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,  1873,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,  1874,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
     222,   684,   685,   686,   687,  3641,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,  1876,  1877,   703,   704,   231,   705,   706,   707,
     233,   708,   709,   710,  1878,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
    1879,     0,     0,   725,  1880,   726,   727,  1881,     0,   728,
     238,   729,   730,   731,   732,   733,     0,  1882,  1883,     0,
       0,   735,   736,  1884,   737,  1885,  1886,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,  1888,     0,   752,   753,   754,   755,   756,
     809,  1889,     0,   757,   251,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,  1890,  1891,  1892,  1893,   258,  1894,  1895,  1896,
    1897,   263,   810,   769,   770,     0,     0,     0,     0,     0,
       0,     0,  3642,  3643,     0,     0,     0,     0,     0,     0,
       0,  3644,   834,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   835,   104,   105,   789,   836,     0,   107,   108,
     109,   110,   837,   838,   112,   113,   114,     0,   115,   839,
     840,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,   465,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1826,
    1827,  1828,    45,  1829,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,  1830,     0,     0,
     477,   478,     0,   479,   480,   481,     0,   133,   482,   483,
     484,   485,   486,   136,  1831,   138,  1832,  1833,  1834,  1835,
       0,   487,   488,   489,   490,   491,  1836,  1837,   492,   493,
    1838,  1839,   494,     0,   495,   496,   497,   498,   499,  1840,
       0,  1841,     0,   500,   501,   502,   503,   504,   505,   154,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,   157,   515,   516,     0,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,   518,   519,   520,   521,   803,  1849,   522,
    1850,  1851,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,  1643,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1853,   556,   557,   558,   559,  1854,  1855,
     560,     0,   561,   562,  1856,   563,     0,   564,     0,   565,
     175,     0,   176,   566,   567,   568,   569,     0,   570,  1857,
       0,  1858,   571,   572,     0,   573,   574,   805,   575,   576,
     180,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,   182,   183,     0,   588,   589,   590,
    1646,  1859,     0,  1860,     0,   591,     0,   187,   592,   188,
     593,   594,   595,   596,   597,     0,     0,   598,  1861,   190,
     599,   191,     0,   600,   601,   602,  1862,  1863,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,  1864,   197,  1865,   617,   618,   619,
       0,   620,   201,     0,   621,   622,   203,   623,  1867,  1868,
     624,  1869,  1870,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,  1871,   633,   634,     0,     0,   635,   207,
     208,   636,   209,  1872,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,  1873,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,  1874,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,   222,
     684,   685,   686,   687,  3641,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,  1876,  1877,   703,   704,   231,   705,   706,   707,   233,
     708,   709,   710,  1878,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,  1879,
       0,     0,   725,  1880,   726,   727,  1881,     0,   728,   238,
     729,   730,   731,   732,   733,     0,  1882,  1883,     0,     0,
     735,   736,  1884,   737,  1885,  1886,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,  1888,     0,   752,   753,   754,   755,   756,   809,
    1889,     0,   757,   251,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,  1890,  1891,  1892,  1893,   258,  1894,  1895,  1896,  1897,
     263,   810,   769,   770,     0,     0,     0,     0,     0,     0,
       0,  3642,  3643,     0,     0,     0,     0,     0,     0,     0,
    3644,   834,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   835,   104,   105,   789,   836,     0,   107,   108,   109,
     110,   837,   838,   112,   113,   114,     0,   115,   839,   840,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,   465,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,  1826,  1827,
       0,    45,  1829,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,  1830,     0,     0,   477,
     478,     0,   479,   480,   481,     0,   133,   482,   483,   484,
     485,   486,   136,  1831,   138,  1832,  1833,  1834,  1835,     0,
     487,   488,   489,   490,   491,  1836,  1837,   492,   493,  1838,
    1839,   494,     0,   495,   496,   497,   498,   499,  1840,     0,
    1841,     0,   500,   501,   502,   503,   504,   505,   154,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,   157,   515,   516,     0,  1842,  1843,  1844,  1845,  1846,
    1847,  1848,   518,   519,   520,   521,   803,  1849,   522,  1850,
    1851,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,  1643,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1853,   556,   557,   558,   559,  1854,  1855,   560,
       0,   561,   562,  1856,   563,     0,   564,     0,   565,   175,
       0,   176,   566,   567,   568,   569,     0,   570,  1857,     0,
    1858,   571,   572,     0,   573,   574,   805,   575,   576,   180,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,   182,   183,     0,   588,   589,   590,  1646,
    1859,     0,  1860,     0,   591,   186,   187,   592,   188,   593,
     594,   595,   596,   597,     0,     0,   598,  1861,   190,   599,
     191,     0,   600,   601,   602,  1862,  1863,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,  1864,   197,  1865,   617,   618,   619,     0,
     620,   201,     0,   621,   622,   203,   623,  1867,  1868,   624,
    1869,  1870,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,   208,
     636,   209,  1872,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,  1873,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,  1874,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,   222,   684,
     685,   686,   687,  3641,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
    1876,  1877,   703,   704,   231,   705,   706,   707,   233,   708,
     709,   710,  1878,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,  1879,     0,
       0,   725,  1880,   726,   727,  1881,     0,   728,   238,   729,
     730,   731,   732,   733,     0,  1882,  1883,     0,     0,   735,
     736,  1884,   737,  1885,  1886,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,  1888,     0,   752,   753,   754,   755,   756,   809,  1889,
       0,   757,   251,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
    1890,  1891,  1892,  1893,   258,  1894,  1895,  1896,  1897,   263,
     810,   769,   770,     0,     0,     0,   834,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,  3644,
      98,    99,   100,   101,   102,   103,   835,   104,   105,   789,
     836,     0,   107,   108,   109,   110,   837,   838,   112,   113,
     114,     0,   115,   839,   840,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,   465,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1826,  1827,     0,    45,  1829,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,  1830,     0,     0,   477,   478,     0,   479,   480,   481,
       0,   133,   482,   483,   484,   485,   486,   136,  1831,   138,
    1832,  1833,  1834,  1835,     0,  5085,   488,   489,   490,   491,
    1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,   496,
     497,   498,   499,  1840,     0,  1841,     0,   500,   501,   502,
     503,   504,   505,   154,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,   157,   515,   516,     0,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,   520,
     521,   803,  1849,   522,  1850,  1851,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
    1643,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1853,   556,   557,
     558,   559,  1854,  1855,   560,     0,   561,   562,  1856,   563,
       0,   564,     0,   565,   175,     0,   176,   566,   567,   568,
     569,     0,   570,  1857,     0,  1858,   571,   572,     0,   573,
     574,   805,   575,   576,   180,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,   182,   183,
       0,   588,   589,   590,  1646,  1859,     0,  1860,     0,   591,
     186,   187,   592,   188,   593,   594,   595,   596,   597,     0,
       0,   598,  1861,   190,   599,   191,     0,   600,   601,   602,
    1862,  1863,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,  1864,   197,
    1865,   617,   618,   619,     0,   620,   201,     0,   621,   622,
     203,   623,  1867,  1868,   624,  1869,  1870,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,   208,   636,   209,  1872,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,  1873,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,  1874,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,   222,   684,   685,   686,   687,  3641,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,  1876,  1877,   703,   704,   231,
     705,   706,   707,   233,   708,   709,   710,  1878,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,  1879,     0,     0,   725,  1880,   726,   727,
    1881,     0,   728,   238,   729,   730,   731,   732,   733,     0,
    1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,  1886,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,  1888,     0,   752,   753,
     754,   755,   756,   809,  1889,     0,   757,   251,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,   258,
    1894,  1895,  1896,  1897,   263,   810,   769,   770,     0,     0,
       0,   834,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,  3644,    98,    99,   100,   101,   102,
     103,   835,   104,   105,   789,   836,     0,   107,   108,   109,
     110,   837,   838,   112,   113,   114,     0,   115,   839,   840,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,   465,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,  1826,  1827,
       0,    45,  1829,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,  1830,     0,     0,   477,
     478,     0,   479,   480,   481,     0,   133,   482,   483,   484,
     485,   486,   136,  1831,   138,  1832,  1833,  1834,  1835,     0,
     487,   488,   489,   490,   491,  1836,  1837,   492,   493,  1838,
    1839,   494,     0,   495,   496,   497,   498,   499,  1840,     0,
    1841,     0,   500,   501,   502,   503,   504,   505,   154,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,   157,   515,   516,     0,  1842,  1843,  1844,  1845,  1846,
    1847,  1848,   518,   519,   520,   521,   803,  1849,   522,  1850,
    1851,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,  1643,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1853,   556,   557,   558,   559,  1854,  1855,   560,
       0,   561,   562,  1856,   563,     0,   564,     0,   565,   175,
       0,   176,   566,   567,   568,   569,     0,   570,  1857,     0,
    1858,   571,   572,     0,   573,   574,   805,   575,   576,   180,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,   182,   183,     0,   588,   589,   590,  1646,
    1859,     0,  1860,     0,   591,   186,   187,   592,   188,   593,
     594,   595,   596,   597,     0,     0,   598,  1861,   190,   599,
     191,     0,   600,   601,   602,  1862,  1863,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,  1864,   197,  1865,   617,   618,   619,     0,
     620,   201,     0,   621,   622,   203,   623,  1867,  1868,   624,
    1869,  1870,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,   208,
     636,   209,  1872,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,  1873,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,  1874,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,   222,   684,
     685,   686,   687,  3641,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
    1876,  1877,   703,   704,   231,   705,   706,   707,   233,   708,
     709,   710,  1878,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,  1879,     0,
       0,   725,  1880,   726,   727,  1881,     0,   728,   238,   729,
     730,   731,   732,   733,     0,  1882,  1883,     0,     0,   735,
     736,  1884,   737,  1885,  1886,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,  1888,     0,   752,   753,   754,   755,   756,   809,  1889,
       0,   757,   251,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
    1890,  1891,  1892,  1893,  5593,  1894,  1895,  1896,  1897,   263,
     810,   769,   770,     0,     0,     0,   834,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,  3644,
      98,    99,   100,   101,   102,   103,   835,   104,   105,   789,
     836,     0,   107,   108,   109,   110,   837,   838,   112,   113,
     114,     0,   115,   839,   840,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,   465,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1826,  1827,  1828,    45,  1829,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,  1830,     0,     0,   477,   478,     0,   479,   480,   481,
       0,   133,   482,   483,   484,   485,   486,     0,  1831,   138,
    1832,  1833,  1834,  1835,     0,   487,   488,   489,   490,   491,
    1836,  1837,   492,   493,  1838,  1839,   494,     0,   495,   496,
     497,   498,   499,  1840,     0,  1841,     0,   500,   501,   502,
     503,   504,   505,   154,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,   157,   515,   516,     0,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,   518,   519,   520,
     521,   803,  1849,   522,  1850,  1851,   523,  1852,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
    1643,   543,   544,     0,   545,   546,   547,     0,   548,     0,
     550,     0,   551,   552,   553,   554,   555,  1853,   556,   557,
     558,   559,  1854,  1855,   560,     0,   561,   562,  1856,   563,
       0,   564,     0,   565,   175,     0,   176,   566,   567,   568,
     569,     0,   570,  1857,     0,  1858,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,   182,   183,
       0,   588,   589,   590,  1646,  1859,     0,  1860,     0,   591,
       0,     0,   592,   188,   593,   594,   595,   596,   597,     0,
       0,   598,  1861,   190,   599,     0,     0,   600,   601,   602,
    1862,  1863,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,  1864,   197,
    1865,   617,   618,   619,     0,   620,   201,  1866,   621,   622,
       0,   623,  1867,  1868,   624,  1869,  1870,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,  1871,   633,   634,
       0,     0,   635,   207,   208,   636,   209,  1872,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,  1873,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,  1874,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,   222,   684,   685,   686,   687,  1875,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,  1876,  1877,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,  1878,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,  1879,     0,     0,   725,  1880,   726,   727,
    1881,     0,   728,   238,   729,   730,   731,   732,   733,     0,
    1882,  1883,     0,     0,   735,   736,  1884,   737,  1885,  1886,
     738,   739,   740,   741,   742,   743,   744,     0,  1887,   745,
     746,   747,   748,   749,   750,   751,  1888,     0,   752,   753,
     754,   755,   756,   809,  1889,     0,   757,   251,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,  1890,  1891,  1892,  1893,   258,
    1894,  1895,  1896,  1897,   263,   810,   769,   770,     0,     0,
       0,     0,     0,     0,     0,  1899,  1900,     0,     0,     0,
       0,     0,     0,     0,  1902,   834,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   835,   104,   105,   789,   836,
       0,   107,   108,   109,   110,   837,   838,   112,   113,   114,
       0,   115,   839,   840,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
     133,   482,   483,   484,   485,   486,   136,   137,   138,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
    1837,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,  1840,     0,  1841,     0,   500,   501,   502,   503,
     504,   505,   154,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,   157,   515,   516,     0,  1842,
    1843,  1844,  1845,  1846,  1847,  1848,   518,   519,   520,   521,
     803,  1849,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,  1854,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,   175,     0,   176,   566,   567,   568,   569,
       0,   570,  1857,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,   180,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,   182,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,   186,
     187,   592,   188,   593,   594,   595,   596,   597,  4527,     0,
     598,  1861,   190,   599,   191,     0,   600,   601,   602,  1862,
    1863,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,   197,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,   203,
     623,     0,  1868,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,  1260,   631,   632,   633,   634,     0,
       0,   635,   207,   208,   636,   209,  1872,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,  1873,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,   222,   684,   685,   686,   687,   225,  4528,   689,
     690,   691,   692,   693,   694,   695,   808,   696,   229,   697,
     698,   699,   700,   701,  1876,  1877,   703,   704,   231,   705,
     706,   707,   233,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,  1879,     0,     0,   725,  1880,   726,   727,  1881,
     237,   728,   238,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,  1884,   737,  1885,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,  1888,     0,   752,   753,   754,
     755,   756,  2756,   250,     0,   757,   251,   758,   759,   760,
     761,     0,     0,     0,   762,     0,   252,   763,   764,   765,
     766,   767,   768,   253,  1890,  1891,  1892,  1893,   258,  1894,
    1895,  1896,  1897,  4529,   810,   769,   770,     0,     0,   264,
     834,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,  4530,    98,    99,   100,   101,   102,   103,
     835,   104,   105,   789,   836,     0,   107,   108,   109,   110,
     837,   838,   112,   113,   114,     0,   115,   839,   840,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,   133,   482,   483,   484,   485,
     486,   136,   137,   138,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,  1837,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,  1840,     0,  1841,
       0,   500,   501,   502,   503,   504,   505,   154,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
     157,   515,   516,     0,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,   518,   519,   520,   521,   803,  1849,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,  1854,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,   175,     0,
     176,   566,   567,   568,   569,     0,   570,  1857,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,   180,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,   182,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,   186,   187,   592,   188,   593,   594,
     595,   596,   597,  4527,     0,   598,  1861,   190,   599,   191,
       0,   600,   601,   602,  1862,  1863,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,   197,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,   203,   623,     0,  1868,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,  1260,
     631,   632,   633,   634,     0,     0,   635,   207,   208,   636,
     209,  1872,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,  1873,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,   222,   684,   685,
     686,   687,   225,  4528,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,  1876,
    1877,   703,   704,   231,   705,   706,   707,   233,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,  1879,     0,     0,
     725,  1880,   726,   727,  1881,     0,   728,   238,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
    1884,   737,  1885,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
    1888,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,   251,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,  1890,
    1891,  1892,  1893,   258,  1894,  1895,  1896,  1897,  4529,   810,
     769,   770,     0,     0,     0,   834,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,  4530,    98,
      99,   100,   101,   102,   103,   835,   104,   105,   789,   836,
       0,   107,   108,   109,   110,   837,   838,   112,   113,   114,
       0,   115,   839,   840,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
     133,   482,   483,   484,   485,   486,   136,   137,   138,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
    1837,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,  1840,     0,  1841,     0,   500,   501,   502,   503,
     504,   505,   154,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,   157,   515,   516,     0,  1842,
    1843,  1844,  1845,  1846,  1847,  1848,   518,   519,   520,   521,
     803,  1849,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,  1854,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,   175,     0,   176,   566,   567,   568,   569,
       0,   570,  1857,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,   180,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,   182,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,   186,
     187,   592,   188,   593,   594,   595,   596,   597,     0,     0,
     598,  1861,   190,   599,   191,     0,   600,   601,   602,  1862,
    1863,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,   197,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,   203,
     623,     0,  1868,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,   208,   636,   209,  1872,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,  1873,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,   222,   684,   685,   686,   687,   225,  4528,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,  1876,  1877,   703,   704,   231,   705,
     706,   707,   233,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,  1879,     0,     0,   725,  1880,   726,   727,  1881,
       0,   728,   238,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,  1884,   737,  1885,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,  1888,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,   251,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,  1890,  1891,  1892,  1893,   258,  1894,
    1895,  1896,  1897,  4529,   810,   769,   770,     0,     0,     0,
     834,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,   265,    98,    99,   100,   101,   102,   103,
     835,   104,   105,   789,   836,     0,   107,   108,   109,   110,
     837,   838,   112,   113,   114,     0,   115,   839,   840,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,   133,   482,   483,   484,   485,
     486,   136,   137,   138,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,  1837,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,  1840,     0,  1841,
       0,   500,   501,   502,   503,   504,   505,   154,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
     157,   515,   516,     0,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,   518,   519,   520,   521,   803,  1849,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,  1854,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,   175,     0,
     176,   566,   567,   568,   569,     0,   570,  1857,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,   180,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,   182,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,   186,   187,   592,   188,   593,   594,
     595,   596,   597,     0,     0,   598,  1861,   190,   599,   191,
       0,   600,   601,   602,  1862,  1863,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,   197,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,   203,   623,     0,  1868,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,   208,   636,
     209,  1872,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,  1873,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,   222,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,  1876,
    1877,   703,   704,   231,   705,   706,   707,   233,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,  1879,     0,     0,
     725,  1880,   726,   727,  1881,     0,   728,   238,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
    1884,   737,  1885,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
    1888,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,   251,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,  1890,
    1891,  1892,  1893,   258,  1894,  1895,  1896,  1897,   263,   810,
     769,   770,     0,     0,     0,   834,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,  5226,    98,
      99,   100,   101,   102,   103,   835,   104,   105,   789,   836,
       0,   107,   108,   109,   110,   837,   838,   112,   113,   114,
       0,   115,   839,   840,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
     133,   482,   483,   484,   485,   486,   136,   137,   138,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
    1837,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,  1840,     0,  1841,     0,   500,   501,   502,   503,
     504,   505,   154,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,   157,   515,   516,     0,  1842,
    1843,  1844,  1845,  1846,  1847,  1848,   518,   519,   520,   521,
     803,  1849,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,  1854,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,   175,     0,   176,   566,   567,   568,   569,
       0,   570,  1857,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,   180,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,   182,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,   186,
     187,   592,   188,   593,   594,   595,   596,   597,     0,     0,
     598,  1861,   190,   599,   191,     0,   600,   601,   602,  1862,
    1863,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,   197,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,   203,
     623,     0,  1868,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,   208,   636,   209,  1872,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,  1873,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,   222,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,  1876,  1877,   703,   704,   231,   705,
     706,   707,   233,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,  1879,     0,     0,   725,  1880,   726,   727,  1881,
       0,   728,   238,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,  1884,   737,  1885,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,  1888,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,   251,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,  1890,  1891,  1892,  1893,   258,  1894,
    1895,  1896,  1897,   263,   810,   769,   770,     0,     0,     0,
     834,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,  6384,    98,    99,   100,   101,   102,   103,
     835,   104,   105,   789,   836,     0,   107,   108,   109,   110,
     837,   838,   112,   113,   114,     0,   115,   839,   840,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,   133,   482,   483,   484,   485,
     486,   136,   137,   138,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,   150,
       0,   500,   501,   502,   503,   504,   505,   154,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
     157,   515,   516,     0,     0,     0,     0,   158,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,   175,     0,
     176,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,   180,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,   182,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,   186,   187,   592,   188,   593,   594,
     595,   596,   597,     0,     0,   598,   189,   190,   599,   191,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,   197,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,   203,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,   208,   636,
     209,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,   222,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,   233,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,   238,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,   251,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,     0,     0,     0,     0,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,  5960,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,  5141,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0, -2044,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0, -2044,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587, -2044,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592, -2044,   593,   594,   595,   596,   597,     0,     0,
     598,   189, -2044,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196, -2044,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683, -2044,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,     0,     0,     0,
       0,     0,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,  1996,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
      37,    38,    39,    40,    41,    42,     0,    44,     0,     0,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,   576,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,     0,     0,     0,     0,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,  4321,  4322,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,    37,    38,    39,    40,    41,
      42,     0,    44,     0,     0,     0,    45,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,     0,     0,
       0,     0,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,  4322,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,   465,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,   576,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,   229,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,   237,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,  2756,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,   252,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,     0,     0,   264,     0,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,   265,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,   229,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,   237,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,  2756,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,   252,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,     0,     0,
     264,     0,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,   265,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,   576,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,     0,     0,     0,     0,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,  1973,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,     0,     0,
       0,     0,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,  3825,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,   576,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,     0,     0,     0,     0,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,  5120,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,     0,     0,
       0,   834,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,  5610,    98,    99,   100,   101,   102,
     103,   835,   104,   105,   789,   836,     0,   107,   108,   109,
     110,   837,   838,   112,   113,   114,     0,   115,   839,   840,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,   465,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,     0,     0,
    1434,    45,     0,     0,     0,     0,     0,  1435,  1436,  1437,
     466,   467,   468,   469,   470,   471,   472,   473,   841,   474,
     475,   476,   842,   843,   844,   845,   846,   847,   848,   477,
     478,   849,   479,   480,   481,   850,   133,   482,   483,   484,
     485,   486,     0,  1634,   138,  1635,  1636,  1637,  1638,   851,
     487,   488,   489,   490,   491,   852,   853,   492,   493,  1639,
    1640,   494,   855,   495,   496,   497,   498,   499,     0,   856,
     150,   857,   500,   501,   502,   503,   504,   505,   154,   506,
     507,   801,   859,   508,   509,   510,   511,   512,   513,   514,
     860,   157,   515,   516,     0,   862,   863,   864,   158,   865,
     866,   867,   518,   519,   520,   521,   803,   868,   522,  1641,
    1642,   523,   869,   524,   870,   525,   526,   527,   528,   529,
     530,   871,   531,   532,   533,   534,   535,   872,   536,   537,
     538,   539,   873,   540,   541,  1643,   543,   544,   874,   545,
     546,   547,   875,   548,   549,   550,   876,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,     0,   877,   560,
     878,   561,   562,  1644,   563,   879,   564,   880,   565,   175,
     881,   176,   566,   567,   568,   569,   882,   570,     0,   883,
       0,   571,   572,   884,   573,   574,   805,   575,   576,   180,
     577,   578,   579,   580,   885,   581,   582,   583,   584,   585,
     586,   886,   587,   182,     0,     0,   588,   589,   590,  1646,
    1647,   889,  1648,   890,   591,   186,   187,   592,   188,   593,
     594,   595,   596,   597,   891,   892,   598,     0,   190,   599,
     191,   893,   600,   601,   602,   894,   895,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,  1649,   197,  1650,   617,   618,   619,   896,
     620,  4856,   897,   621,   622,   203,   623,   898,     0,   624,
    1651,  1652,   625,   626,   627,   899,   628,   629,   630,   900,
     901,   631,  4857,   633,   634,   902,   903,   635,     0,   208,
     636,   209,     0,   637,   638,   639,   640,   641,   642,   904,
     643,   644,   645,   646,   905,   647,   648,     0,   649,     0,
     650,   651,   652,   653,   906,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,  1653,   665,   666,   667,
     668,   669,   907,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   908,   682,   683,   222,   684,
     685,   686,   687,     0,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,   909,   697,   698,   699,   700,   701,
     910,   911,   703,   704,  2993,   705,   706,   707,   233,   708,
     709,   710,  1655,   711,   912,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,     0,   913,
     914,   725,   915,   726,   727,   916,   917,   728,   238,   729,
     730,   731,   732,   733,   918,  1656,  1657,     0,   920,   735,
     736,     0,   737,     0,   921,   738,   739,   740,   741,   742,
     743,   744,     0,   923,   745,   746,   747,   748,   749,   750,
     751,   924,   925,   752,   753,   754,   755,   756,     0,  1658,
     927,   757,   251,   758,   759,   760,   761,   928,   929,   930,
     762,   931,   932,   763,   764,   765,   766,   767,   768,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     810,   769,   770,     0,     0,     0,  1440,  1441,  1442,     0,
    4858,  4859,  1445,  1446,  1447,  1448,   834,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   835,   104,   105,   789,
     836,     0,   107,   108,   109,   110,   837,   838,   112,   113,
     114,     0,   115,   839,   840,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,   465,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,     0,     0,  1434,    45,     0,     0,     0,
       0,     0,  1435,  1436,  1437,   466,   467,   468,   469,   470,
     471,   472,   473,   841,   474,   475,   476,   842,   843,   844,
     845,   846,   847,   848,   477,   478,   849,   479,   480,   481,
     850,   133,   482,   483,   484,   485,   486,     0,  1634,   138,
    1635,  1636,  1637,  1638,   851,   487,   488,   489,   490,   491,
     852,   853,   492,   493,  1639,  1640,   494,   855,   495,   496,
     497,   498,   499,     0,   856,   150,   857,   500,   501,   502,
     503,   504,   505,   154,   506,   507,   801,   859,   508,   509,
     510,   511,   512,   513,   514,   860,   157,   515,   516,     0,
     862,   863,   864,   158,   865,   866,   867,   518,   519,   520,
     521,   803,   868,   522,  1641,  1642,   523,   869,   524,   870,
     525,   526,   527,   528,   529,   530,   871,   531,   532,   533,
     534,   535,   872,   536,   537,   538,   539,   873,   540,   541,
    1643,   543,   544,   874,   545,   546,   547,   875,   548,   549,
     550,   876,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,     0,   877,   560,   878,   561,   562,  1644,   563,
     879,   564,   880,   565,   175,   881,   176,   566,   567,   568,
     569,   882,   570,     0,   883,     0,   571,   572,   884,   573,
     574,   805,   575,   576,   180,   577,   578,   579,   580,   885,
     581,   582,   583,   584,   585,   586,   886,   587,   182,     0,
       0,   588,   589,   590,  1646,  1647,   889,  1648,   890,   591,
     186,   187,   592,   188,   593,   594,   595,   596,   597,   891,
     892,   598,     0,   190,   599,   191,   893,   600,   601,   602,
     894,   895,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,  1649,   197,
    1650,   617,   618,   619,   896,   620,  5324,   897,   621,   622,
     203,   623,   898,     0,   624,  1651,  1652,   625,   626,   627,
     899,   628,   629,   630,   900,   901,   631,  4857,   633,   634,
     902,   903,   635,     0,   208,   636,   209,     0,   637,   638,
     639,   640,   641,   642,   904,   643,   644,   645,   646,   905,
     647,   648,     0,   649,     0,   650,   651,   652,   653,   906,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,  1653,   665,   666,   667,   668,   669,   907,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     908,   682,   683,   222,   684,   685,   686,   687,     0,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,   909,
     697,   698,   699,   700,   701,   910,   911,   703,   704,  2993,
     705,   706,   707,   233,   708,   709,   710,  1655,   711,   912,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,     0,   913,   914,   725,   915,   726,   727,
     916,   917,   728,   238,   729,   730,   731,   732,   733,   918,
    1656,  1657,     0,   920,   735,   736,     0,   737,     0,   921,
     738,   739,   740,   741,   742,   743,   744,     0,   923,   745,
     746,   747,   748,   749,   750,   751,   924,   925,   752,   753,
     754,   755,   756,     0,  1658,   927,   757,   251,   758,   759,
     760,   761,   928,   929,   930,   762,   931,   932,   763,   764,
     765,   766,   767,   768,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   810,   769,   770,     0,     0,
       0,  1440,  1441,  1442,     0,  4858,  4859,  1445,  1446,  1447,
    1448,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,  1434,
       0,     0,     0,     0,     0,     0,  1435,  1436,  1437,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,  1438,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,  1439,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,     0,     0,     0,  1440,  1441,  1442,     0,  1443,
    1444,  1445,  1446,  1447,  1448,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,  1434,     0,     0,     0,     0,     0,     0,
    1435,  1436,  1437,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,  1576,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,  1577,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,     0,     0,     0,  1440,
    1441,  1442,     0,  1443,  1444,  1445,  1446,  1447,  1448,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,  1434,     0,     0,
       0,     0,     0,     0,  1435,  1436,  1437,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,  1693,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,  1694,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,  1695,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
       0,     0,     0,  1440,  1441,  1442,     0,  1443,  1444,  1445,
    1446,  1447,  1448,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1434,     0,     0,     0,     0,     0,     0,  1435,  1436,
    1437,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
     800,   143,   494,     0,   495,  2410,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,     0,   515,   516,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
    2411,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,   576,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
     735,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,     0,     0,     0,  1440,  1441,  1442,
       0,  1443,  1444,  1445,  1446,  1447,  1448,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,  1434,     0,     0,     0,     0,
       0,     0,  1435,  1436,  1437,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,     0,     0,
       0,  1440,  1441,  1442,     0,  1443,  1444,  1445,  1446,  1447,
    1448,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,  1434,
       0,     0,     0,     0,     0,     0,  1435,  1436,  1437,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,  3928,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,  3929,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,     0,     0,     0,  1440,  1441,  1442,     0,  1443,
    1444,  1445,  1446,  1447,  1448,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,  1434,     0,     0,     0,     0,     0,     0,
    1435,  1436,  1437,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,  5937,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,     0,     0,     0,  1440,
    1441,  1442,     0,  1443,  1444,  1445,  1446,  1447,  1448,   834,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   835,
     104,   105,   789,   836,     0,   107,   108,   109,   110,   837,
     838,   112,   113,   114,     0,   115,   839,   840,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,   841,   474,   475,   476,
     842,   843,   844,   845,   846,   847,   848,   477,   478,   849,
     479,   480,   481,   850,   133,   482,   483,   484,   485,   486,
     136,   137,   138,   139,   140,   141,   142,   851,   487,   488,
     489,   490,   491,   852,   853,   492,   493,   854,   143,   494,
     855,   495,   496,   497,   498,   499,   149,   856,   150,   857,
     500,   501,   502,   503,   504,   505,   154,   506,   507,   858,
     859,   508,   509,   510,   511,   512,   513,   514,   860,   157,
     515,   516,   861,   862,   863,   864,   158,   865,   866,   867,
     518,   519,   520,   521,   803,   868,   522,   161,   162,   523,
     869,   524,   870,   525,   526,   527,   528,   529,   530,   871,
     531,   532,   533,   534,   535,   872,   536,   537,   538,   539,
     873,   540,   541,   542,   543,   544,   874,   545,   546,   547,
     875,   548,   549,   550,   876,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,   877,   560,   878,   561,
     562,   174,   563,   879,   564,   880,   565,   175,   881,   176,
     566,   567,   568,   569,   882,   570,   178,   883,   179,   571,
     572,   884,   573,   574,   805,   575,   576,   180,   577,   578,
     579,   580,   885,   581,   582,   583,   584,   585,   586,   886,
     587,   182,   183,   887,   588,   589,   590,   888,   184,   889,
     185,   890,   591,   186,   187,   592,   188,   593,   594,   595,
     596,   597,   891,   892,   598,   189,   190,   599,   191,   893,
     600,   601,   602,   894,   895,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,   196,   197,   198,   617,   618,   619,   896,   620,   201,
     897,   621,   622,   203,   623,   898,   204,   624,   205,   206,
     625,   626,   627,   899,   628,   629,   630,   900,   901,   631,
     632,   633,   634,   902,   903,   635,   207,   208,   636,   209,
     210,   637,   638,   639,   640,   641,   642,   904,   643,   644,
     645,   646,   905,   647,   648,   212,   649,   213,   650,   651,
     652,   653,   906,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
     907,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   908,   682,   683,   222,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,   909,   697,   698,   699,   700,   701,   910,   911,
     703,   704,   231,   705,   706,   707,   233,   708,   709,   710,
     234,   711,   912,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,   913,   914,   725,
     915,   726,   727,   916,   917,   728,   238,   729,   730,   731,
     732,   733,   918,   239,   240,   919,   920,   735,   736,   241,
     737,   242,   921,   738,   739,   740,   741,   742,   743,   744,
     922,   923,   745,   746,   747,   748,   749,   750,   751,   924,
     925,   752,   753,   754,   755,   756,   926,   250,   927,   757,
     251,   758,   759,   760,   761,   928,   929,   930,   762,   931,
     932,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,   834,    86,    87,    88,   786,    90,    91,    92,   787,
    2711,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   835,   104,   105,   789,   836,     0,   107,   108,   109,
     110,   837,   838,   112,   113,   114,     0,   115,   839,   840,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,   133,   482,   483,   484,
     485,   486,     0,  1634,   138,  1635,  1636,  1637,  1638,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,  1639,
    1640,   494,     0,   495,   496,   497,   498,   499,     0,     0,
     150,     0,   500,   501,   502,   503,   504,   505,   154,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,   157,   515,   516,     0,     0,     0,     0,   158,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,  1641,
    1642,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,  1643,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,     0,     0,   560,
       0,   561,   562,  1644,   563,     0,   564,     0,   565,   175,
       0,   176,   566,   567,   568,   569,     0,   570,     0,     0,
       0,   571,   572,     0,   573,   574,   805,   575,   576,   180,
     577,   578,   579,   580,  2989,   581,   582,   583,   584,   585,
     586,     0,   587,   182,  2990,     0,   588,   589,   590,  1646,
    1647,     0,  1648,     0,   591,   186,   187,   592,   188,   593,
     594,   595,   596,   597,     0,     0,   598,     0,   190,   599,
     191,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,  1649,   197,  1650,   617,   618,   619,     0,
     620,     0,     0,   621,   622,   203,   623,     0,     0,   624,
    1651,  1652,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,  2991,   635,  2992,   208,
     636,   209,     0,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,     0,   649,     0,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,  1653,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,   222,   684,
     685,   686,   687,     0,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,  2993,   705,   706,   707,   233,   708,
     709,   710,  1655,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,     0,     0,
       0,   725,     0,   726,   727,     0,     0,   728,   238,   729,
     730,   731,   732,   733,     0,  1656,  1657,     0,     0,   735,
     736,     0,   737,     0,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,     0,  1658,
    2994,   757,   251,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     810,   769,   770,     0,    86,    87,    88,   786,    90,    91,
      92,   787,  2995,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,   800,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,   805,   575,
     576,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
     809,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,     0,    86,    87,    88,   786,
      90,    91,    92,   787,  1266,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0,     0,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,   595,   596,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,     0,    86,    87,
      88,   786,    90,    91,    92,   787,  6351,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,    45,     0,     0,
       0,     0,     0,     0,     0,     0,   466,  1149,   468,   469,
     470,   471,   472,   473,  1150,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,  1183,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
    1184,   558,   559,   172,     0,   560,     0,   561,  1152,   174,
     563,     0,   564,     0,  1185,     0,  1154,     0,   566,   567,
     568,   569,     0,   570,   178,  1186,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
    1155,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,  1156,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,  1157,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,  1158,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,  1159,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,     0,
       0,     0,     0,     0,     0,     0,  1160,  1161,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,    45,     0,     0,
       0,     0,     0,     0,     0,     0,   466,  1149,   468,   469,
     470,   471,   472,   473,  1150,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,  1151,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,  1152,   174,
     563,     0,   564,     0,  1153,     0,  1154,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
    1155,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,  1156,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,  1157,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,  1158,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,  1159,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,     0,
       0,     0,     0,     0,     0,     0,  1160,  1161,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,    45,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,  1748,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,  1154,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
    1155,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,     0,
       0,     0,     0,     0,     0,     0,  1160,  1161,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,    45,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,  1753,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,  1154,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
    1155,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,     0,
       0,     0,     0,     0,     0,     0,  1160,  1161,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,   804,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,  1944,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,     0,
       0,     0,     0,  1237,  1945,    86,    87,    88,   786,    90,
      91,    92,   787,  1238,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
    1239,   493,  1208,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,  1240,     0,  1241,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,  1242,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,  1243,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,  1244,   685,   686,   687,   225,   688,   689,   690,
     691,  1245,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,  1246,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,  1247,   240,
       0,     0,  1248,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,  1212,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,  1249,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,   834,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   835,   104,   105,   789,
     836,     0,   107,   108,   109,   110,   837,   838,   112,   113,
     114,     0,   115,   839,   840,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,     0,     0,     0,    45,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,   841,   474,   475,   476,   842,   843,   844,
     845,   846,   847,   848,   477,   478,   849,   479,   480,   481,
     850,   133,   482,   483,   484,   485,   486,   136,   137,   138,
     139,   140,   141,   142,   851,   487,   488,   489,   490,   491,
     852,   853,   492,   493,   854,   143,   494,   855,   495,   496,
     497,   498,   499,   149,   856,   150,   857,   500,   501,   502,
     503,   504,   505,   154,   506,   507,   858,   859,   508,   509,
     510,   511,   512,   513,   514,   860,   157,   515,   516,   861,
     862,   863,   864,   158,   865,   866,   867,   518,   519,   520,
     521,   803,   868,   522,   161,   162,   523,   869,   524,   870,
     525,   526,   527,   528,   529,   530,   871,   531,   532,   533,
     534,   535,   872,   536,   537,   538,   539,   873,   540,   541,
     542,   543,   544,   874,   545,   546,   547,   875,   548,   549,
     550,   876,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,   877,   560,   878,   561,   562,   174,   563,
     879,   564,   880,   565,   175,   881,   176,   566,   567,   568,
     569,   882,   570,   178,   883,   179,   571,   572,   884,   573,
     574,   805,   575,   576,   180,   577,   578,   579,   580,   885,
     581,   582,   583,   584,   585,   586,   886,   587,   182,   183,
     887,   588,   589,   590,   888,   184,   889,   185,   890,   591,
     186,   187,   592,   188,   593,   594,   595,   596,   597,   891,
     892,   598,   189,   190,   599,   191,   893,   600,   601,   602,
     894,   895,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,   197,
     198,   617,   618,   619,   896,   620,   201,   897,   621,   622,
     203,   623,   898,   204,   624,   205,   206,   625,   626,   627,
     899,   628,   629,   630,   900,   901,   631,   632,   633,   634,
     902,   903,   635,   207,   208,   636,   209,   210,   637,   638,
     639,   640,   641,   642,   904,   643,   644,   645,   646,   905,
     647,   648,   212,   649,   213,   650,   651,   652,   653,   906,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,   907,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     908,   682,   683,   222,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,   909,
     697,   698,   699,   700,   701,   910,   911,   703,   704,   231,
     705,   706,   707,   233,   708,   709,   710,   234,   711,   912,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,   913,   914,   725,   915,   726,   727,
     916,   917,   728,   238,   729,   730,   731,   732,   733,   918,
     239,   240,   919,   920,   735,   736,   241,   737,   242,   921,
     738,   739,   740,   741,   742,   743,   744,   922,   923,   745,
     746,   747,   748,   749,   750,   751,   924,   925,   752,   753,
     754,   755,   756,   926,   250,   927,   757,   251,   758,   759,
     760,   761,   928,   929,   930,   762,   931,   932,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,   834,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   835,   104,
     105,   789,   836,     0,   107,   108,   109,   110,   837,   838,
     112,   113,   114,     0,   115,   839,   840,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,   841,   474,   475,   476,   842,
     843,   844,   845,   846,   847,   848,   477,   478,   849,   479,
     480,   481,   850,   133,   482,   483,   484,   485,   486,   136,
     137,   138,   139,   140,   141,   142,   851,   487,   488,   489,
     490,   491,   852,   853,   492,   493,   854,   143,   494,   855,
     495,   496,   497,   498,   499,   149,   856,   150,   857,   500,
     501,   502,   503,   504,   505,   154,   506,   507,   858,   859,
     508,   509,   510,   511,   512,   513,   514,   860,   157,   515,
     516,   861,   862,   863,   864,   158,   865,   866,   867,   518,
     519,   520,   521,   803,   868,   522,   161,   162,   523,   869,
     524,   870,   525,   526,   527,   528,   529,   530,   871,   531,
     532,   533,   534,   535,   872,   536,   537,   538,   539,   873,
     540,   541,   542,   543,   544,   874,   545,   546,   547,   875,
     548,   549,   550,   876,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,   877,   560,   878,   561,   562,
     174,   563,   879,   564,   880,   565,   175,   881,   176,   566,
     567,   568,   569,   882,   570,   178,   883,   179,   571,   572,
     884,   573,   574,   805,   575,   576,   180,   577,   578,   579,
     580,   885,   581,   582,   583,   584,   585,   586,   886,   587,
     182,   183,   887,   588,   589,   590,   888,   184,   889,   185,
     890,   591,   186,   187,   592,   188,   593,   594,   595,   596,
     597,   891,   892,   598,   189,   190,   599,   191,   893,   600,
     601,   602,   894,   895,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,   197,   198,   617,   618,   619,   896,   620,   201,   897,
     621,   622,   203,   623,   898,   204,   624,   205,   206,   625,
     626,   627,   899,   628,   629,   630,   900,   901,   631,   632,
     633,   634,   902,   903,   635,   207,   208,   636,   209,   210,
     637,   638,   639,   640,   641,   642,   904,   643,   644,   645,
     646,   905,   647,   648,   212,   649,   213,   650,   651,   652,
     653,   906,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,   907,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   908,   682,   683,   222,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,   909,   697,   698,   699,   700,   701,   910,   911,   703,
     704,   231,   705,   706,   707,   233,   708,   709,   710,   234,
     711,   912,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,   913,   914,   725,   915,
     726,   727,   916,   917,   728,   238,   729,   730,   731,   732,
     733,   918,   239,   240,   919,   920,   735,   736,   241,   737,
     242,   921,   738,   739,   740,   741,   742,   743,   744,   922,
     923,   745,   746,   747,   748,   749,   750,   751,   924,   925,
     752,   753,   754,   755,   756,   926,   250,   927,   757,   251,
     758,   759,   760,   761,   928,   929,   930,   762,   931,   932,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
     834,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     835,   104,   105,   789,   836,     0,   107,   108,   109,   110,
     837,   838,   112,   113,   114,     0,   115,   839,   840,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,  4006,   471,   472,   473,   841,   474,   475,
     476,   842,   843,   844,   845,   846,   847,   848,   477,   478,
     849,   479,   480,   481,   850,   133,   482,   483,   484,   485,
     486,   136,   137,   138,   139,   140,   141,   142,   851,   487,
     488,   489,   490,   491,   852,   853,   492,   493,   854,   143,
     494,   855,   495,   496,   497,   498,   499,   149,   856,   150,
     857,   500,   501,   502,   503,   504,   505,   154,   506,   507,
     858,   859,   508,   509,   510,   511,   512,   513,   514,   860,
     157,   515,   516,   861,   862,   863,   864,   158,   865,   866,
     867,   518,   519,   520,   521,   803,   868,   522,   161,   162,
     523,   869,   524,   870,   525,   526,   527,   528,   529,   530,
     871,   531,   532,   533,   534,   535,   872,   536,   537,   538,
     539,   873,   540,   541,   542,  4007,   544,   874,   545,   546,
     547,   875,   548,   549,   550,   876,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,   877,   560,   878,
     561,   562,   174,   563,   879,   564,   880,   565,   175,   881,
     176,   566,   567,   568,   569,   882,   570,   178,   883,   179,
     571,   572,   884,   573,   574,   805,   575,   576,   180,   577,
     578,   579,   580,   885,   581,   582,   583,   584,   585,   586,
     886,   587,   182,   183,   887,   588,   589,   590,   888,   184,
     889,   185,   890,   591,   186,   187,   592,   188,   593,   594,
     595,   596,   597,   891,   892,   598,   189,   190,   599,   191,
     893,   600,   601,   602,   894,   895,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,   197,   198,   617,   618,   619,   896,   620,
     201,   897,   621,   622,   203,   623,   898,   204,   624,   205,
     206,   625,   626,   627,   899,   628,   629,   630,   900,   901,
     631,   632,   633,   634,   902,   903,   635,   207,   208,   636,
     209,   210,   637,   638,   639,   640,   641,   642,   904,   643,
     644,   645,   646,   905,   647,   648,   212,   649,   213,   650,
     651,   652,   653,   906,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,   907,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   908,   682,   683,   222,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,   909,   697,   698,   699,   700,   701,   910,
     911,  4008,   704,   231,   705,   706,   707,   233,   708,   709,
     710,   234,   711,   912,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,   913,   914,
     725,   915,   726,   727,   916,   917,   728,   238,   729,   730,
     731,   732,   733,   918,   239,   240,   919,   920,   735,   736,
     241,   737,   242,   921,   738,   739,   740,   741,   742,   743,
     744,   922,   923,   745,   746,   747,   748,   749,   750,   751,
     924,   925,   752,   753,   754,   755,   756,   926,   250,   927,
     757,   251,   758,   759,   760,   761,   928,   929,   930,   762,
     931,   932,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,   834,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   835,   104,   105,   789,   836,     0,   107,   108,
     109,   110,   837,   838,   112,   113,   114,     0,   115,   839,
     840,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,   133,   482,   483,
     484,   485,   486,   136,   137,   138,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,  1837,   492,   493,
     800,   143,   494,     0,   495,   496,   497,   498,   499,  1840,
       0,  1841,     0,   500,   501,   502,   503,   504,   505,   154,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,   157,   515,   516,     0,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,   518,   519,   520,   521,   803,  1849,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,  1854,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
     175,     0,   176,   566,   567,   568,   569,     0,   570,  1857,
       0,   179,   571,   572,     0,   573,   574,   805,   575,   576,
     180,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,   182,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,   186,   187,   592,   188,
     593,   594,   595,   596,   597,     0,     0,   598,  1861,   190,
     599,   191,     0,   600,   601,   602,  1862,  1863,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,   197,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,   203,   623,     0,  1868,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
     208,   636,   209,  1872,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,  1873,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,   222,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,  1876,  1877,   703,   704,   231,   705,   706,   707,   233,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,  1879,
       0,     0,   725,  1880,   726,   727,  1881,     0,   728,   238,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
     735,   736,  1884,   737,  1885,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,  1888,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,   251,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,  1890,  1891,  1892,  1893,   258,  1894,  1895,  1896,  1897,
     263,   810,   769,   770,   834,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   835,   104,   105,   789,   836,     0,
     107,   108,   109,   110,   837,   838,   112,   113,   114,     0,
     115,   839,   840,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
     465,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1826,  1827,     0,    45,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,   133,
     482,   483,   484,   485,   486,   136,  1831,   138,  1832,  1833,
    1834,  1835,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,  1838,  1839,   494,     0,   495,   496,   497,   498,
     499,   149,     0,   150,     0,   500,   501,   502,   503,   504,
     505,   154,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,   157,   515,   516,     0,     0,     0,
       0,   158,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,  1850,  1851,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,  1643,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,  1855,   560,     0,   561,   562,  1856,   563,     0,   564,
       0,   565,   175,     0,   176,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,   180,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,   182,   183,     0,   588,
     589,   590,  1646,  1859,     0,  1860,     0,   591,   186,   187,
     592,   188,   593,   594,   595,   596,   597,     0,     0,   598,
     189,   190,   599,   191,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,  1864,   197,  1865,   617,
     618,   619,     0,   620,   201,     0,   621,   622,   203,   623,
    1867,   204,   624,  1869,  1870,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,   208,   636,   209,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,  1874,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,   222,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,   233,   708,   709,   710,  1878,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,   238,   729,   730,   731,   732,   733,     0,  1882,  1883,
       0,     0,   735,   736,   241,   737,   242,  1886,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,  1889,     0,   757,   251,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,   834,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   835,   104,   105,   789,
     836,     0,   107,   108,   109,   110,   837,   838,   112,   113,
     114,     0,   115,   839,   840,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,   133,   482,   483,   484,   485,   486,   136,   137,   138,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,   150,     0,   500,   501,   502,
     503,   504,   505,   154,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,   157,   515,   516,     0,
       0,     0,     0,   158,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,   175,     0,   176,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,   180,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,   182,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
     186,   187,   592,   188,   593,   594,   595,   596,   597,     0,
       0,   598,   189,   190,   599,   191,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,   197,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
     203,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,   208,   636,   209,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,   222,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,   233,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,   238,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,   251,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,   834,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   835,   104,
     105,   789,   836,     0,   107,   108,   109,   110,   837,   838,
     112,   113,   114,     0,   115,   839,   840,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,   133,   482,   483,   484,   485,   486,   136,
     137,   138,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,   150,     0,   500,
     501,   502,   503,   504,   505,   154,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,   157,   515,
     516,     0,     0,     0,     0,   158,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,   175,     0,   176,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,  1625,   180,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
     182,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,   186,   187,   592,   188,   593,   594,   595,   596,
     597,     0,     0,   598,   189,   190,   599,   191,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,   197,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,   203,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,   208,   636,   209,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,   222,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,   233,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,   238,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,   251,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
     834,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     835,   104,   105,   789,   836,     0,   107,   108,   109,   110,
     837,   838,   112,   113,   114,     0,   115,   839,   840,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,   133,   482,   483,   484,   485,
     486,   136,   137,   138,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,   150,
       0,   500,   501,   502,   503,   504,   505,   154,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
     157,   515,   516,     0,     0,     0,     0,   158,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,   175,     0,
     176,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,  1681,   180,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,   182,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,   186,   187,   592,   188,   593,   594,
     595,   596,   597,     0,     0,   598,   189,   190,   599,   191,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,   197,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,   203,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,   208,   636,
     209,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,   222,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,   233,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,   238,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,   251,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,   834,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   835,   104,   105,   789,   836,     0,   107,   108,
     109,   110,   837,   838,   112,   113,   114,     0,   115,   839,
     840,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,   133,   482,   483,
     484,   485,   486,     0,  1634,   138,  1635,  1636,  1637,  1638,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
    1639,  1640,   494,     0,   495,   496,   497,   498,   499,     0,
       0,   150,     0,   500,   501,   502,   503,   504,   505,   154,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,   157,   515,   516,     0,     0,     0,     0,   158,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
    1641,  1642,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,  1643,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,     0,     0,
     560,     0,   561,   562,  1644,   563,     0,   564,     0,   565,
     175,     0,   176,   566,   567,   568,   569,     0,   570,     0,
       0,     0,   571,   572,     0,   573,   574,   805,   575,   576,
     180,   577,   578,   579,   580,  2989,   581,   582,   583,   584,
     585,   586,     0,   587,   182,  2990,     0,   588,   589,   590,
    1646,  1647,     0,  1648,     0,   591,   186,   187,   592,   188,
     593,   594,   595,   596,   597,     0,     0,   598,     0,   190,
     599,   191,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,  1649,   197,  1650,   617,   618,   619,
       0,   620,     0,     0,   621,   622,   203,   623,     0,     0,
     624,  1651,  1652,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,  2992,
     208,   636,   209,     0,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,     0,   649,
       0,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,  1653,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,   222,
     684,   685,   686,   687,     0,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,  2993,   705,   706,   707,   233,
     708,   709,   710,  1655,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,     0,
       0,     0,   725,     0,   726,   727,     0,     0,   728,   238,
     729,   730,   731,   732,   733,     0,  1656,  1657,     0,     0,
     735,   736,     0,   737,     0,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,     0,
    1658,  2994,   757,   251,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,   769,   770,   834,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   835,   104,   105,   789,   836,     0,
     107,   108,   109,   110,   837,   838,   112,   113,   114,     0,
     115,   839,   840,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,   133,
     482,   483,   484,   485,   486,     0,  1634,   138,  1635,  1636,
    1637,  1638,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,  1639,  1640,   494,     0,   495,   496,   497,   498,
     499,     0,     0,   150,     0,   500,   501,   502,   503,   504,
     505,   154,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,   157,   515,   516,     0,     0,     0,
       0,   158,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,  1641,  1642,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,  1643,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
       0,     0,   560,     0,   561,   562,  1644,   563,     0,   564,
       0,   565,   175,     0,   176,   566,   567,   568,   569,     0,
     570,     0,     0,     0,   571,   572,     0,   573,   574,   805,
     575,   576,   180,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,   182,     0,     0,   588,
     589,   590,  1646,  1647,     0,  1648,     0,   591,   186,   187,
     592,   188,   593,   594,   595,   596,   597,     0,     0,   598,
       0,   190,   599,   191,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,  1649,   197,  1650,   617,
     618,   619,     0,   620,     0,     0,   621,   622,   203,   623,
    3090,     0,   624,  1651,  1652,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,     0,   208,   636,   209,     0,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
       0,   649,     0,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,  1653,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,   222,   684,   685,   686,   687,     0,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,  2993,   705,   706,
     707,   233,   708,   709,   710,  1655,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,     0,     0,     0,   725,     0,   726,   727,     0,  4964,
     728,   238,   729,   730,   731,   732,   733,     0,  1656,  1657,
       0,     0,   735,   736,     0,   737,     0,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,     0,  1658,     0,   757,   251,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   810,   769,   770,   834,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   835,   104,   105,   789,
     836,     0,   107,   108,   109,   110,   837,   838,   112,   113,
     114,     0,   115,   839,   840,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,   133,   482,   483,   484,   485,   486,     0,  1634,   138,
    1635,  1636,  1637,  1638,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,  1639,  1640,   494,     0,   495,   496,
     497,   498,   499,     0,     0,   150,     0,   500,   501,   502,
     503,   504,   505,   154,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,   157,   515,   516,     0,
       0,     0,     0,   158,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,  1641,  1642,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
    1643,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,     0,     0,   560,     0,   561,   562,  1644,   563,
       0,   564,     0,   565,   175,     0,   176,   566,   567,   568,
     569,     0,   570,     0,     0,     0,   571,   572,     0,   573,
     574,   805,   575,   576,   180,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,   182,     0,
       0,   588,   589,   590,  1646,  1647,     0,  1648,     0,   591,
     186,   187,   592,   188,   593,   594,   595,   596,   597,     0,
       0,   598,     0,   190,   599,   191,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,  1649,   197,
    1650,   617,   618,   619,     0,   620,  3186,     0,   621,   622,
     203,   623,     0,     0,   624,  1651,  1652,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,     0,   208,   636,   209,     0,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,     0,   649,     0,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,  1653,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,   222,   684,   685,   686,   687,     0,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,  1654,
     705,   706,   707,   233,   708,   709,   710,  1655,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,     0,     0,     0,   725,     0,   726,   727,
       0,     0,   728,   238,   729,   730,   731,   732,   733,     0,
    1656,  1657,     0,     0,   735,   736,     0,   737,     0,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,     0,  1658,     0,   757,   251,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   810,   769,   770,   834,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   835,   104,
     105,   789,   836,     0,   107,   108,   109,   110,   837,   838,
     112,   113,   114,     0,   115,   839,   840,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,   133,   482,   483,   484,   485,   486,     0,
    1634,   138,  1635,  1636,  1637,  1638,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,  1639,  1640,   494,     0,
     495,   496,   497,   498,   499,     0,     0,   150,     0,   500,
     501,   502,   503,   504,   505,   154,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,   157,   515,
     516,     0,     0,     0,     0,   158,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,  1641,  1642,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,  1643,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,     0,     0,   560,     0,   561,   562,
    1644,   563,     0,   564,     0,   565,   175,     0,   176,   566,
     567,   568,   569,     0,   570,     0,     0,     0,   571,   572,
       0,   573,   574,   805,   575,   576,   180,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
     182,     0,     0,   588,   589,   590,  1646,  1647,     0,  1648,
       0,   591,   186,   187,   592,   188,   593,   594,   595,   596,
     597,     0,     0,   598,     0,   190,   599,   191,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
    1649,   197,  1650,   617,   618,   619,     0,   620,  4764,     0,
     621,   622,   203,   623,     0,     0,   624,  1651,  1652,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,     0,   208,   636,   209,     0,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,     0,   649,     0,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,  1653,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,   222,   684,   685,   686,   687,
       0,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,  1654,   705,   706,   707,   233,   708,   709,   710,  1655,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,     0,     0,     0,   725,     0,
     726,   727,     0,     0,   728,   238,   729,   730,   731,   732,
     733,     0,  1656,  1657,     0,     0,   735,   736,     0,   737,
       0,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,     0,  1658,     0,   757,   251,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   810,   769,   770,
     834,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     835,   104,   105,   789,   836,     0,   107,   108,   109,   110,
     837,   838,   112,   113,   114,     0,   115,   839,   840,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,   133,   482,   483,   484,   485,
     486,     0,  1634,   138,  1635,  1636,  1637,  1638,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,  1639,  1640,
     494,     0,   495,   496,   497,   498,   499,     0,     0,   150,
       0,   500,   501,   502,   503,   504,   505,   154,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
     157,   515,   516,     0,     0,     0,     0,   158,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,  1641,  1642,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,  1643,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,     0,     0,   560,     0,
     561,   562,  1644,   563,  6419,   564,     0,   565,   175,     0,
     176,   566,   567,   568,   569,     0,   570,     0,     0,     0,
     571,   572,     0,   573,   574,   805,   575,   576,   180,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,   182,     0,     0,   588,   589,   590,  1646,  1647,
       0,  1648,     0,   591,   186,   187,   592,   188,   593,   594,
     595,   596,   597,     0,     0,   598,     0,   190,   599,   191,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,  1649,   197,  1650,   617,   618,   619,     0,   620,
       0,     0,   621,   622,   203,   623,     0,     0,   624,  1651,
    1652,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,     0,   208,   636,
     209,     0,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,     0,   649,     0,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,  1653,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,   222,   684,   685,
     686,   687,     0,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,  1654,   705,   706,   707,   233,   708,   709,
     710,  1655,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,     0,     0,     0,
     725,     0,   726,   727,     0,     0,   728,   238,   729,   730,
     731,   732,   733,     0,  1656,  1657,     0,     0,   735,   736,
       0,   737,     0,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,     0,  1658,     0,
     757,   251,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   810,
     769,   770,   834,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   835,   104,   105,   789,   836,     0,   107,   108,
     109,   110,   837,   838,   112,   113,   114,     0,   115,   839,
     840,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,   133,   482,   483,
     484,   485,   486,     0,  1634,   138,  1635,  1636,  1637,  1638,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
    1639,  1640,   494,     0,   495,   496,   497,   498,   499,     0,
       0,   150,     0,   500,   501,   502,   503,   504,   505,   154,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,   157,   515,   516,     0,     0,     0,     0,   158,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
    1641,  1642,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,  1643,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,     0,     0,
     560,     0,   561,   562,  1644,   563,     0,   564,     0,   565,
     175,     0,   176,   566,   567,   568,   569,     0,   570,     0,
       0,     0,   571,   572,     0,   573,   574,   805,   575,  1645,
     180,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,   182,     0,     0,   588,   589,   590,
    1646,  1647,     0,  1648,     0,   591,   186,   187,   592,   188,
     593,   594,   595,   596,   597,     0,     0,   598,     0,   190,
     599,   191,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,  1649,   197,  1650,   617,   618,   619,
       0,   620,     0,     0,   621,   622,   203,   623,     0,     0,
     624,  1651,  1652,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,     0,
     208,   636,   209,     0,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,     0,   649,
       0,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,  1653,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,   222,
     684,   685,   686,   687,     0,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,  1654,   705,   706,   707,   233,
     708,   709,   710,  1655,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,     0,
       0,     0,   725,     0,   726,   727,     0,     0,   728,   238,
     729,   730,   731,   732,   733,     0,  1656,  1657,     0,     0,
     735,   736,     0,   737,     0,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,     0,
    1658,     0,   757,   251,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,   769,   770,   834,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   835,   104,   105,   789,   836,     0,
     107,   108,   109,   110,   837,   838,   112,   113,   114,     0,
     115,   839,   840,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,   133,
     482,   483,   484,   485,   486,     0,  1634,   138,  1635,  1636,
    1637,  1638,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,  1639,  1640,   494,     0,   495,   496,   497,   498,
     499,     0,     0,   150,     0,   500,   501,   502,   503,   504,
     505,   154,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,   157,   515,   516,     0,     0,     0,
       0,   158,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,  1641,  1642,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,  1643,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
       0,     0,   560,     0,   561,   562,  1644,   563,     0,   564,
       0,   565,   175,     0,   176,   566,   567,   568,   569,     0,
     570,     0,     0,     0,   571,   572,     0,   573,   574,   805,
     575,  1708,   180,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,   182,     0,     0,   588,
     589,   590,  1646,  1647,     0,  1648,     0,   591,   186,   187,
     592,   188,   593,   594,   595,   596,   597,     0,     0,   598,
       0,   190,   599,   191,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,  1649,   197,  1650,   617,
     618,   619,     0,   620,     0,     0,   621,   622,   203,   623,
       0,     0,   624,  1651,  1652,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,     0,   208,   636,   209,     0,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
       0,   649,     0,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,  1653,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,   222,   684,   685,   686,   687,     0,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,  1654,   705,   706,
     707,   233,   708,   709,   710,  1655,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,     0,     0,     0,   725,     0,   726,   727,     0,     0,
     728,   238,   729,   730,   731,   732,   733,     0,  1656,  1657,
       0,     0,   735,   736,     0,   737,     0,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,     0,  1658,     0,   757,   251,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   810,   769,   770,   834,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   835,   104,   105,   789,
     836,     0,   107,   108,   109,   110,   837,   838,   112,   113,
     114,     0,   115,   839,   840,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,   133,   482,   483,   484,   485,   486,     0,  1634,   138,
    1635,  1636,  1637,  1638,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,  1639,  1640,   494,     0,   495,   496,
     497,   498,   499,     0,     0,   150,     0,   500,   501,   502,
     503,   504,   505,   154,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,   157,   515,   516,     0,
       0,     0,     0,   158,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,  1641,  1642,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
    1643,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,     0,     0,   560,     0,   561,   562,  1644,   563,
       0,   564,     0,   565,   175,     0,   176,   566,   567,   568,
     569,     0,   570,     0,     0,     0,   571,   572,     0,   573,
     574,   805,   575,   576,   180,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,   182,     0,
       0,   588,   589,   590,  1646,  1647,     0,  1648,     0,   591,
     186,   187,   592,   188,   593,   594,   595,   596,   597,     0,
       0,   598,     0,   190,   599,   191,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,  1649,   197,
    1650,   617,   618,   619,     0,   620,     0,     0,   621,   622,
     203,   623,     0,     0,   624,  1651,  1652,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,     0,   208,   636,   209,     0,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,     0,   649,     0,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,  1653,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,   222,   684,   685,   686,   687,     0,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,  1654,
     705,   706,   707,   233,   708,   709,   710,  1655,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,     0,     0,     0,   725,     0,   726,   727,
       0,     0,   728,   238,   729,   730,   731,   732,   733,     0,
    1656,  1657,     0,     0,   735,   736,     0,   737,     0,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,     0,  1658,     0,   757,   251,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   810,   769,   770,   834,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   835,   104,
     105,   789,   836,     0,   107,   108,   109,   110,   837,   838,
     112,   113,   114,     0,   115,   839,   840,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,   133,   482,   483,   484,   485,   486,     0,
    1634,   138,  1635,  1636,  1637,  1638,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,  1639,  1640,   494,     0,
     495,   496,   497,   498,   499,     0,     0,   150,     0,   500,
     501,   502,   503,   504,   505,   154,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,   157,   515,
     516,     0,     0,     0,     0,   158,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,  1641,  1642,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,  1643,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,     0,     0,   560,     0,   561,   562,
    1644,   563,     0,   564,     0,   565,   175,     0,   176,   566,
     567,   568,   569,     0,   570,     0,     0,     0,   571,   572,
       0,   573,   574,   805,   575,   576,   180,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
     182,     0,     0,   588,   589,   590,  1646,  1647,     0,  1648,
       0,   591,   186,   187,   592,   188,   593,   594,   595,   596,
     597,     0,     0,   598,     0,   190,   599,   191,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
    1649,   197,  1650,   617,   618,   619,     0,   620,     0,     0,
     621,   622,   203,   623,     0,     0,   624,  1651,  1652,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,     0,   208,   636,   209,     0,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,     0,   649,     0,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,  1653,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,   222,   684,   685,   686,   687,
       0,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,  2993,   705,   706,   707,   233,   708,   709,   710,  1655,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,     0,     0,     0,   725,     0,
     726,   727,     0,     0,   728,   238,   729,   730,   731,   732,
     733,     0,  1656,  1657,     0,     0,   735,   736,     0,   737,
       0,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,     0,  1658,     0,   757,   251,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   810,   769,   770,
     834,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     835,   104,   105,   789,   836,     0,   107,   108,   109,   110,
     837,   838,   112,   113,   114,     0,   115,   839,   840,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,   133,   482,   483,   484,   485,
     486,     0,  1634,   138,  1635,  1636,  1637,  1638,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,  1639,  1640,
     494,     0,   495,   496,   497,   498,   499,     0,     0,   150,
       0,   500,   501,   502,   503,   504,   505,   154,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
     157,   515,   516,     0,     0,     0,     0,   158,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,  1641,  1642,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,  1643,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,     0,     0,   560,     0,
     561,   562,  1644,   563,     0,   564,     0,   565,   175,     0,
     176,   566,   567,   568,   569,     0,   570,     0,     0,     0,
     571,   572,     0,   573,   574,   805,   575,   576,   180,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,   182,     0,     0,   588,   589,   590,  1646,  1647,
       0,  1648,     0,   591,   186,   187,   592,   188,   593,   594,
     595,   596,   597,     0,     0,   598,     0,   190,   599,   191,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,  1649,   197,  1650,   617,   618,   619,     0,   620,
       0,     0,   621,   622,   203,   623,     0,     0,   624,  1651,
    1652,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,     0,   208,   636,
     209,     0,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,     0,   649,     0,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,  1653,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,   222,   684,   685,
     686,   687,     0,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,     0,   705,   706,   707,   233,   708,   709,
     710,  1655,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,     0,     0,     0,
     725,     0,   726,   727,     0,     0,   728,   238,   729,   730,
     731,   732,   733,     0,  1656,  1657,     0,     0,   735,   736,
       0,   737,     0,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,     0,  1658,     0,
     757,   251,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   810,
     769,   770,   834,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   835,   104,   105,   789,   836,     0,   107,   108,
     109,   110,   837,   838,   112,   113,   114,     0,   115,   839,
     840,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,   133,   482,   483,
     484,   485,   486,     0,     0,   138,     0,     0,     0,     0,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
       0,     0,   494,     0,   495,   496,   497,   498,   499,     0,
       0,   150,     0,   500,   501,   502,   503,   504,   505,   154,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,   157,   515,   516,     0,     0,     0,     0,   158,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
       0,     0,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,     0,     0,
     560,     0,   561,   562,     0,   563,     0,   564,     0,   565,
     175,     0,   176,   566,   567,   568,   569,     0,   570,     0,
       0,     0,   571,   572,     0,   573,   574,   805,   575,   576,
     180,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,   182,     0,     0,   588,   589,   590,
       0,     0,     0,     0,     0,   591,   186,   187,   592,   188,
     593,   594,   595,   596,   597,     0,     0,   598,     0,   190,
     599,   191,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,     0,   197,     0,   617,   618,   619,
       0,   620,     0,     0,   621,   622,   203,   623,     0,     0,
     624,     0,     0,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,     0,
     208,   636,   209,     0,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,     0,   649,
       0,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,     0,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,   222,
     684,   685,   686,   687,     0,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,     0,   705,   706,   707,   233,
     708,   709,   710,     0,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,     0,
       0,     0,   725,     0,   726,   727,     0,     0,   728,   238,
     729,   730,   731,   732,   733,     0,     0,     0,     0,     0,
     735,   736,     0,   737,     0,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,     0,
       0,     0,   757,   251,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
     841,   474,   475,   476,   842,   843,   844,   845,   846,   847,
     848,   477,   478,   849,   479,   480,   481,   850,   133,   482,
     483,   484,   485,   486,   136,   137,   138,   139,   140,   141,
     142,   851,   487,   488,   489,   490,   491,   852,   853,   492,
     493,     0,   143,   494,   855,   495,   496,   497,   498,   499,
     149,   856,   150,   857,   500,   501,   502,   503,   504,   505,
     154,   506,   507,   858,   859,   508,   509,   510,   511,   512,
     513,   514,   860,   157,   515,   516,     0,   862,   863,   864,
     158,   865,   866,   867,   518,   519,   520,   521,     0,   868,
     522,   161,   162,   523,   869,   524,   870,   525,   526,   527,
     528,   529,   530,   871,   531,   532,   533,   534,   535,   872,
     536,   537,   538,   539,   873,   540,   541,   542,   543,   544,
     874,   545,   546,   547,   875,   548,   549,   550,   876,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
     877,   560,   878,   561,   562,   174,   563,   879,   564,   880,
     565,   175,   881,   176,   566,   567,   568,   569,   882,   570,
     178,   883,   179,   571,   572,   884,   573,   574,     0,   575,
     576,   180,   577,   578,   579,   580,   885,   581,   582,   583,
     584,   585,   586,   886,   587,   182,   183,     0,   588,   589,
     590,     0,   184,   889,   185,   890,   591,   186,   187,   592,
     188,   593,   594,   595,   596,   597,   891,   892,   598,   189,
     190,   599,   191,   893,   600,   601,   602,   894,   895,   603,
     604,   605,   606,   607,   608,   609,   610,   611,     0,   612,
     613,     0,   614,   615,   616,   196,   197,   198,   617,   618,
     619,   896,   620,   201,   897,   621,   622,   203,   623,   898,
     204,   624,   205,   206,   625,   626,   627,   899,   628,   629,
     630,   900,   901,   631,   632,   633,   634,   902,   903,   635,
     207,   208,   636,   209,   210,   637,   638,   639,   640,   641,
     642,   904,   643,   644,   645,   646,   905,   647,   648,   212,
     649,   213,   650,   651,   652,   653,   906,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,   907,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   908,   682,   683,
     222,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,     0,   696,   909,   697,   698,   699,
     700,   701,   910,   911,   703,   704,   231,   705,   706,   707,
     233,   708,   709,   710,   234,   711,   912,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,   913,   914,   725,   915,   726,   727,   916,   917,   728,
     238,   729,   730,   731,   732,   733,   918,   239,   240,     0,
     920,   735,   736,   241,   737,   242,   921,   738,   739,   740,
     741,   742,   743,   744,     0,   923,   745,   746,   747,   748,
     749,   750,   751,   924,   925,   752,   753,   754,   755,   756,
       0,   250,   927,   757,   251,   758,   759,   760,   761,   928,
     929,   930,   762,   931,   932,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
     465,     0,     0,    37,    38,    39,    40,    41,    42,     0,
      44,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,  1369,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,   465,     0,     0,    37,    38,    39,    40,    41,    42,
       0,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0,     0,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,   595,   596,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,  3031,   495,   496,
     497,   498,   499,   149,     0,     0,  3110,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,  3032,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,  3111,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,  3034,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,  3112,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,  3113,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,  3114,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,  3035,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,  3036,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,  3031,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,  3032,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,  3111,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,  3034,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,  4216,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
    3035,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,  3036,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,  1223,   472,   473,  1169,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,  1170,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,  1224,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,   576,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,  1171,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,  1172,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   789,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,  1169,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
     136,   137,     0,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,   800,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,     0,     0,
     500,   501,   502,   503,   504,   505,     0,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,  1170,     0,
     515,   516,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   803,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,     0,     0,     0,
     566,   567,   568,   569,  3889,   570,   178,     0,   179,   571,
     572,     0,   573,   574,   805,   575,   576,     0,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,     0,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,     0,     0,   592,     0,   593,   594,   595,
     596,   597,     0,     0,   598,   189,     0,   599,     0,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,   196,     0,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,     0,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,     0,   636,     0,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
    1171,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,     0,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,  1172,   697,   698,   699,   700,   701,     0,     0,
     703,   704,   231,   705,   706,   707,     0,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,     0,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,   809,   250,     0,   757,
       0,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,    37,
      38,    39,    40,    41,    42,     0,    44,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,  3031,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,  3032,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,  3111,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,  3034,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,   576,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,  3035,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,  3036,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,   465,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,   799,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
     800,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,     0,   515,   516,   802,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,   804,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,   576,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
     735,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
    1169,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,   800,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,  1170,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,   805,   575,
     576,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,  1171,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,  1172,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
     809,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,  1066,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
     465,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,  1067,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,  1068,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,  2662,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,  2663,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,  2664,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,  2665,   565,     0,     0,     0,  2666,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,  2667,  2668,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,   691,  2669,   693,   694,   695,   808,   696,     0,  2670,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
    2671,   728,     0,  2672,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,  2673,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,  1170,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,  1171,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,  1172,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,    86,    87,
      88,   786,    90,    91,    92,   787,  2651,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,   465,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,  3728,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
    3729,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,  2968,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,  3730,   728,     0,   729,  3731,   731,  3732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,  3733,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,   465,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,   826,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,   576,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   789,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,   465,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
     136,   137,     0,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,   800,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,     0,     0,
     500,   501,   502,   503,   504,   505,     0,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,     0,     0,
     515,   516,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   803,     0,   522,   161,   162,   523,
     804,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,     0,     0,     0,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,   805,   575,   576,     0,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,     0,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,     0,     0,   592,     0,   593,   594,   595,
     596,   597,     0,     0,   598,   189,     0,   599,     0,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,   196,     0,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,     0,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,     0,   636,     0,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,     0,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,     0,   697,   698,   699,   700,   701,     0,     0,
     703,   704,   231,   705,   706,   707,     0,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,     0,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,   809,   250,     0,   757,
       0,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,   465,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,  1005,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,   465,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
    1129,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,  1130,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,   576,     0,
    1131,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,   465,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
     800,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,  1192,     0,   515,   516,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,   576,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
    1193,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
    1470,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,   800,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,   805,   575,
    1471,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,  1260,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
     809,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
     465,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,  1616,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,  2884,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0,     0,  2885,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,   595,   596,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,  2886,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,  2887,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
    2888,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,  2889,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,  2890,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,   129,   130,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,  2002,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,  3981,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,  3982,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,  3999,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,   576,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,  4000,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   789,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,   465,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
     136,   137,     0,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,   800,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,     0,     0,
     500,   501,   502,   503,   504,   505,     0,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,     0,     0,
     515,   516,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   803,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,     0,     0,     0,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,   805,   575,   576,     0,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,     0,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,     0,     0,   592,     0,   593,   594,   595,
     596,   597,     0,     0,   598,   189,     0,   599,     0,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,   196,     0,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,     0,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,     0,   636,     0,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,     0,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,     0,   697,   698,   699,   700,   701,     0,     0,
     703,   704,   231,   705,   706,   707,     0,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,     0,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,   809,   250,     0,   757,
       0,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,   465,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,  1072,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,   576,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
    1260,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,  1425,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
     800,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,     0,   515,   516,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,  1426,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
     735,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,   800,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,  1430,   179,   571,   572,     0,   573,   574,   805,   575,
     576,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
     809,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,  1573,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0,     0,   566,   567,   568,   569,
       0,   570,   178,  1690,   179,   571,   572,     0,   573,   574,
     805,   575,   576,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,   595,   596,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,  1947,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,  2213,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,  1260,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,  2279,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,  2280,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   789,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,     0,     0,  2507,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
     136,   137,     0,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,   800,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,     0,     0,
     500,   501,   502,   503,   504,   505,     0,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,     0,     0,
     515,   516,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   803,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,     0,     0,     0,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,   805,   575,   576,     0,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,     0,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,     0,     0,   592,     0,   593,   594,   595,
     596,   597,     0,     0,   598,   189,     0,   599,     0,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,   196,     0,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,     0,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,     0,   636,     0,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,     0,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,     0,   697,   698,   699,   700,   701,     0,     0,
     703,   704,   231,   705,   706,   707,     0,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,     0,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,   809,   250,     0,   757,
       0,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,    86,    87,    88,   786,    90,    91,    92,   787,  2651,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,  2968,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,  2884,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,   576,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,  5141,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
     800,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,     0,   515,   516,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,   576,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
     735,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,  5155,
       0,   477,   478,     0,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,   800,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,   805,   575,
     576,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
     809,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0,     0,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,   595,   596,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,  1205,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,  1207,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,  1208,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,     0,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,  1209,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
    1210,   240,     0,     0,  1211,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,  1212,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,  1254,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,  1208,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,     0,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,  1255,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,  1256,   240,     0,     0,  1257,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,  1212,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,   576,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,  1273,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   789,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
     136,   137,     0,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,   800,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,     0,     0,
     500,   501,   502,   503,   504,   505,     0,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,     0,     0,
     515,   516,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   803,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,     0,     0,     0,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,   805,   575,  1454,     0,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,     0,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,     0,     0,   592,     0,   593,   594,   595,
     596,   597,     0,     0,   598,   189,     0,   599,     0,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,   196,     0,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,     0,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,     0,   636,     0,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,     0,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,     0,   697,   698,   699,   700,   701,     0,     0,
     703,   704,   231,   705,   706,   707,     0,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,     0,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,   809,   250,     0,   757,
       0,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,  1462,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,  1481,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
     800,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,     0,   515,   516,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,  1554,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
     735,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,   800,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,   805,   575,
    1561,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,  1562,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
     809,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,  1583,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0,     0,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,  1586,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,   595,   596,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,  1589,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,  1631,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,  1632,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,  1702,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   789,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
     136,   137,     0,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,   800,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,     0,     0,
     500,   501,   502,   503,   504,   505,     0,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,     0,     0,
     515,   516,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   803,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,     0,     0,     0,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,   805,   575,  1704,     0,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,     0,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,     0,     0,   592,     0,   593,   594,   595,
     596,   597,     0,     0,   598,   189,     0,   599,     0,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,   196,     0,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,     0,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,     0,   636,     0,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,     0,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,     0,   697,   698,   699,   700,   701,     0,     0,
     703,   704,   231,   705,   706,   707,     0,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,     0,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,   809,   250,     0,   757,
       0,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,  1714,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,  1717,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
     800,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,     0,   515,   516,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,  1719,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
     735,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,  1958,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,  1239,
     493,  1208,   143,  1959,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,     0,     0,   508,   509,   510,   511,   512,
     513,   514,     0,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,   805,   575,
     576,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,  1243,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,  1244,   685,   686,   687,   225,   688,   689,   690,   691,
    1245,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,  1951,     0,     0,   703,   704,   231,   705,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,  1247,   240,     0,
       0,  1248,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
    1212,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
    1249,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,  2002,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,  2161,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0,     0,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,   576,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,   595,   596,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,  1207,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,  1208,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,     0,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,  1212,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,  2445,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,  2493,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   789,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
     136,   137,     0,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,   800,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,     0,     0,
     500,   501,   502,   503,   504,   505,     0,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,     0,     0,
     515,   516,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   803,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,     0,     0,     0,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,   805,   575,  2495,     0,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,     0,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,     0,     0,   592,     0,   593,   594,   595,
     596,   597,     0,     0,   598,   189,     0,   599,     0,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,   196,     0,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,     0,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,     0,   636,     0,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,     0,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,     0,   697,   698,   699,   700,   701,     0,     0,
     703,   704,   231,   705,   706,   707,     0,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,     0,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,   809,   250,     0,   757,
       0,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,  2527,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,  2571,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
     800,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,     0,   515,   516,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,  2575,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
     735,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,   800,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,   805,   575,
    2577,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
     809,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,  2579,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0,     0,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,  2615,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,   595,   596,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,  2689,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,  2706,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,  2933,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,   521,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,   576,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,     0,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   789,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
     136,   137,     0,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,   800,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,     0,     0,
     500,   501,   502,   503,   504,   505,     0,   506,   507,   801,
       0,   508,   509,   510,   511,   512,   513,   514,     0,     0,
     515,   516,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   803,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,     0,     0,     0,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,   805,   575,  3420,     0,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,     0,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,     0,     0,   592,     0,   593,   594,   595,
     596,   597,     0,     0,   598,   189,     0,   599,     0,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
     616,   196,     0,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,     0,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,     0,   636,     0,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,     0,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
     808,   696,     0,   697,   698,   699,   700,   701,     0,     0,
     703,   704,   231,   705,   706,   707,     0,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,     0,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,   809,   250,     0,   757,
       0,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,   800,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
     801,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,  3424,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,   809,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,   800,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,   801,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,  3900,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,   616,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,   809,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
     800,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,   801,     0,   508,   509,   510,   511,   512,   513,
     514,     0,     0,   515,   516,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,  3967,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,   616,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
     701,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,   239,   240,     0,     0,
     735,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,   809,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,   800,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,   801,     0,   508,   509,   510,   511,   512,
     513,   514,     0,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,   805,   575,
    3989,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,   616,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
     809,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,  3991,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    86,    87,    88,   786,
      90,    91,    92,   787,     0,   788,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   789,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   790,   791,     0,     0,     0,   792,
     793,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   795,     0,   796,     0,   797,   798,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,   136,   137,     0,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,   800,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,     0,     0,   500,   501,   502,   503,
     504,   505,     0,   506,   507,   801,     0,   508,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     803,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,     0,     0,     0,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
     805,   575,  4138,     0,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,     0,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,     0,
       0,   592,     0,   593,   594,   595,   596,   597,     0,     0,
     598,   189,     0,   599,     0,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     806,   612,   613,   807,   614,   615,   616,   196,     0,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,     0,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,     0,   636,     0,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,     0,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,   808,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,     0,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,     0,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,   809,   250,     0,   757,     0,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   810,   769,   770,    86,    87,    88,
     786,    90,    91,    92,   787,     0,   788,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   789,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   790,   791,     0,     0,     0,
     792,   793,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,   796,     0,   797,
     798,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,   136,   137,     0,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,   800,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   506,   507,   801,     0,   508,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   803,     0,   522,   161,   162,   523,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,  4169,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,     0,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,     0,     0,     0,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,   805,   575,   576,     0,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,     0,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
       0,     0,   592,     0,   593,   594,   595,   596,   597,     0,
       0,   598,   189,     0,   599,     0,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   806,   612,   613,   807,   614,   615,   616,   196,     0,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
       0,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,     0,     0,   631,   632,   633,   634,
       0,     0,   635,   207,     0,   636,     0,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,     0,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,   808,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,     0,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,     0,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,   809,   250,     0,   757,     0,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   810,   769,   770,    86,    87,
      88,   786,    90,    91,    92,   787,     0,   788,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     789,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   790,   791,     0,     0,
       0,   792,   793,     0,     0,     0,     0,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   795,     0,   796,     0,
     797,   798,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,   136,   137,
       0,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,   800,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,   801,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   803,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,   805,   575,   576,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,   189,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   806,   612,   613,   807,   614,   615,   616,   196,
       0,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,     0,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,  4380,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,     0,   636,     0,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,   808,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,     0,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   809,   250,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   810,   769,   770,    86,
      87,    88,   786,    90,    91,    92,   787,     0,   788,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   789,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   790,   791,     0,
       0,     0,   792,   793,     0,     0,     0,     0,   794,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,   796,
       0,   797,   798,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,   136,
     137,     0,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,   800,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   506,   507,   801,     0,
     508,   509,   510,   511,   512,   513,   514,     0,     0,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   518,
     519,   520,  4828,   803,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,     0,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,     0,     0,     0,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,   805,   575,   576,     0,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
       0,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,     0,     0,   592,     0,   593,   594,   595,   596,
     597,     0,     0,   598,   189,     0,   599,     0,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   806,   612,   613,   807,   614,   615,   616,
     196,     0,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,     0,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,     0,     0,   631,   632,
     633,   634,     0,     0,   635,   207,     0,   636,     0,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,     0,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,   808,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,     0,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,     0,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,   809,   250,     0,   757,     0,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   810,   769,   770,
      86,    87,    88,   786,    90,    91,    92,   787,     0,   788,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   789,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   790,   791,
       0,     0,     0,   792,   793,     0,     0,     0,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   795,     0,
     796,     0,   797,   798,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
     136,   137,     0,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,  1239,   493,  1208,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,     0,     0,
     500,   501,   502,   503,   504,   505,     0,   506,   507,     0,
       0,   508,   509,   510,   511,   512,   513,   514,     0,     0,
     515,   516,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   803,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,     0,     0,     0,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,   805,   575,   576,     0,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,     0,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,     0,     0,   592,     0,   593,   594,   595,
     596,   597,     0,     0,   598,   189,     0,   599,     0,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   806,   612,   613,   807,   614,   615,
    1243,   196,     0,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,     0,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,     0,   636,     0,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,     0,  1244,   685,   686,
     687,   225,   688,   689,   690,   691,  1245,   693,   694,   695,
     808,   696,     0,   697,   698,   699,   700,  1951,     0,     0,
     703,   704,   231,   705,   706,   707,     0,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,     0,   729,   730,   731,
     732,   733,     0,  1247,   240,     0,     0,  1248,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,  1212,   250,     0,   757,
       0,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,  1249,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   810,   769,
     770,    86,    87,    88,   786,    90,    91,    92,   787,     0,
     788,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   789,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   790,
     791,     0,     0,     0,   792,   793,     0,     0,     0,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,   796,     0,   797,   798,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,   136,   137,     0,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,  1208,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   506,   507,
       0,     0,   508,   509,   510,   511,   512,   513,   514,     0,
       0,   515,   516,     0,     0,     0,     0,     0,     0,     0,
       0,   518,   519,   520,   521,   803,     0,   522,   161,   162,
     523,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,     0,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,     0,     0,
       0,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,   805,   575,   576,     0,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,     0,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,     0,     0,   592,     0,   593,   594,
     595,   596,   597,     0,     0,   598,   189,     0,   599,     0,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   806,   612,   613,   807,   614,
     615,   616,   196,     0,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,     0,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,     0,     0,
     631,   632,   633,   634,     0,     0,   635,   207,     0,   636,
       0,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,     0,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,   808,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,     0,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,     0,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,  1212,   250,     0,
     757,     0,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   810,
     769,   770,    86,    87,    88,   786,    90,    91,    92,   787,
       0,   788,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   789,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     790,   791,     0,     0,     0,   792,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,   796,     0,   797,   798,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,   136,   137,     0,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,  1239,   493,  1208,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
       0,     0,   500,   501,   502,   503,   504,   505,     0,   506,
     507,     0,     0,   508,   509,   510,   511,   512,   513,   514,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   803,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,     0,
       0,     0,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,   805,   575,   576,     0,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,     0,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,     0,     0,   592,     0,   593,
     594,   595,   596,   597,     0,     0,   598,   189,     0,   599,
       0,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   806,   612,   613,   807,
     614,   615,  1243,   196,     0,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,     0,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,     0,
     636,     0,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,     0,  1244,
     685,   686,   687,   225,   688,   689,   690,   691,  1245,   693,
     694,   695,   808,   696,     0,   697,   698,   699,   700,  1951,
       0,     0,   703,   704,   231,   705,   706,   707,     0,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,     0,  3018,
     730,   731,   732,   733,     0,  1247,   240,     0,     0,  1248,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,  1212,   250,
       0,   757,     0,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,  1249,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     810,   769,   770,    86,    87,    88,   786,    90,    91,    92,
     787,     0,   788,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   789,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   790,   791,     0,     0,     0,   792,   793,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   795,     0,   796,     0,   797,   798,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,   136,   137,     0,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,  1239,   493,
    1208,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,     0,     0,   500,   501,   502,   503,   504,   505,     0,
     506,   507,     0,     0,   508,   509,   510,   511,   512,   513,
     514,     0,     0,   515,   516,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   803,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
       0,     0,     0,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,   805,   575,   576,
       0,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,     0,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,     0,     0,   592,     0,
     593,   594,   595,   596,   597,     0,     0,   598,   189,     0,
     599,     0,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   806,   612,   613,
     807,   614,   615,  1243,   196,     0,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,     0,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
       0,   636,     0,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,     0,
    1244,   685,   686,   687,   225,   688,   689,   690,   691,  3094,
     693,   694,   695,   808,   696,     0,   697,   698,   699,   700,
    3095,     0,     0,   703,   704,   231,   705,   706,   707,     0,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,     0,
     729,   730,   731,   732,   733,     0,  1247,   240,     0,     0,
    3096,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,  1212,
     250,     0,   757,     0,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,  1249,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   810,   769,   770,    86,    87,    88,   786,    90,    91,
      92,   787,     0,   788,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   789,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   790,   791,     0,     0,     0,   792,   793,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,   796,     0,   797,   798,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,   136,   137,     0,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,  1239,
     493,  1208,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,     0,     0,   500,   501,   502,   503,   504,   505,
       0,   506,   507,     0,     0,   508,   509,   510,   511,   512,
     513,   514,     0,     0,   515,   516,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   803,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,     0,     0,     0,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,   805,   575,
     576,     0,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,     0,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,     0,     0,   592,
       0,   593,   594,   595,   596,   597,     0,     0,   598,   189,
       0,   599,     0,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   806,   612,
     613,   807,   614,   615,  1243,   196,     0,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,     0,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,     0,   636,     0,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
       0,  1244,   685,   686,   687,   225,   688,   689,   690,   691,
    1245,   693,   694,   695,   808,   696,     0,   697,   698,   699,
     700,  3095,     0,     0,   703,   704,   231,   705,   706,   707,
       0,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
       0,   729,   730,   731,   732,   733,     0,  1247,   240,     0,
       0,  3096,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
    1212,   250,     0,   757,     0,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
    1249,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   810,   769,   770,    86,    87,    88,   786,    90,
      91,    92,   787,     0,   788,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   789,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   790,   791,     0,     0,     0,   792,   793,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,   795,     0,   796,     0,   797,   798,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,   136,   137,     0,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,   800,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,     0,     0,   500,   501,   502,   503,   504,
     505,     0,   506,   507,   801,     0,   508,   509,   510,   511,
     512,   513,   514,     0,     0,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   518,   519,   520,   521,   803,
       0,   522,   161,   162,   523,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,     0,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,     0,     0,     0,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,   805,
     575,   576,     0,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,     0,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,     0,     0,
     592,     0,   593,   594,   595,   596,   597,     0,     0,   598,
     189,     0,   599,     0,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   806,
     612,   613,   807,   614,   615,   616,   196,     0,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,     0,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,     0,     0,   631,   632,   633,   634,     0,     0,
     635,   207,     0,   636,     0,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,     0,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,     0,   684,   685,   686,   687,   225,     0,   689,   690,
     691,   692,   693,   694,   695,   808,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,     0,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,     0,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,   809,   250,     0,   757,     0,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   810,   769,   770,    86,    87,    88,     0,
      90,    91,    92,     0,     0,     0,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,     0,     0,
       0,   107,   108,   109,   110,     0,   111,   112,   113,   114,
   -3080,   115,   116,   117,     0,     0,     0,     0,     0,   120,
     121,     0,     0,     0,     0,   122,     0,     0,     0,     0,
       0,     0,     0,     0,   123,     0,   124,     0,   125,   126,
      35,     0,   460,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     133,     0,     0,     0,     0,     0,   136,   137,   138,   139,
     140,   141,   142,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,     0,     0,     0,     0,     0,
       0,     0,   149,     0,   150,     0,     0,     0,     0,     0,
       0,     0,   154,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   157,     0,     0,     0,     0,
       0,     0,   158,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,   162,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   168,     0,     0,
       0,     0,     0,     0,     0,     0,   170,     0,     0,     0,
       0,   172,     0,     0,     0,     0,     0,   174,     0,     0,
       0,     0,     0,   175,     0,   176,     0,     0,     0,     0,
       0,     0,   178,     0,   179,     0,     0,     0,     0,     0,
       0,     0,     0,   180,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   182,   183,     0,
       0,     0,     0,     0,   184,     0,   185,     0,     0,   186,
     187,     0,   188,     0,     0,     0,     0,     0,     0,     0,
       0,   189,   190,     0,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   196,   197,   198,
       0,     0,     0,     0,     0,   201,     0,     0,     0,   203,
       0,     0,   204,     0,   205,   206,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   207,   208,     0,   209,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   212,     0,   213,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     215,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,     0,     0,     0,     0,   225,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   231,     0,
       0,     0,   233,     0,     0,     0,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   238,     0,     0,     0,     0,     0,     0,   239,
     240,     0,     0,     0,     0,   241,     0,   242,     0,     0,
       0,     0,     0,     0,     0,     0,   245,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   250,     0,     0,   251,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,    86,    87,    88,     0,    90,    91,
      92,     0,     0,     0,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,     0,     0,     0,   107,
     108,   109,   110,     0,   111,   112,   113,   114, -3081,   115,
     116,   117,     0,     0,     0,     0,     0,   120,   121,     0,
       0,     0,     0,   122,     0,     0,     0,     0,     0,     0,
       0,     0,   123,     0,   124,     0,   125,   126,    35,     0,
    1364,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   133,     0,
       0,     0,     0,     0,   136,   137,   138,   139,   140,   141,
     142,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,     0,     0,     0,     0,     0,     0,     0,
     149,     0,   150,     0,     0,     0,     0,     0,     0,     0,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   157,     0,     0,     0,     0,     0,     0,
     158,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,   162,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   168,     0,     0,     0,     0,
       0,     0,     0,     0,   170,     0,     0,     0,     0,   172,
       0,     0,     0,     0,     0,   174,     0,     0,     0,     0,
       0,   175,     0,   176,     0,     0,     0,     0,     0,     0,
     178,     0,   179,     0,     0,     0,     0,     0,     0,     0,
       0,   180,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   182,   183,     0,     0,     0,
       0,     0,   184,     0,   185,     0,     0,   186,   187,     0,
     188,     0,     0,     0,     0,     0,     0,     0,     0,   189,
     190,     0,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   196,   197,   198,     0,     0,
       0,     0,     0,   201,     0,     0,     0,   203,     0,     0,
     204,     0,   205,   206,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     207,   208,     0,   209,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   212,
       0,   213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   215,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,     0,     0,     0,     0,   225,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   231,     0,     0,     0,
     233,     0,     0,     0,   234,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     238,     0,     0,     0,     0,     0,     0,   239,   240,     0,
       0,     0,     0,   241,     0,   242,     0,     0,     0,     0,
       0,     0,     0,     0,   245,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   250,     0,     0,   251,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    86,    87,    88,     0,    90,    91,    92,     0,
       0,     0,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,     0,     0,     0,   107,   108,   109,
     110,     0,   111,   112,   113,   114,     0,   115,   116,   117,
       0,     0,     0,     0,     0,   120,   121,     0,     0,     0,
       0,   122,     0,     0,     0,     0,     0,     0,     0,     0,
     123,     0,   124,     0,   125,     0,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   133,     0,     0,     0,
       0,     0,   136,   137,   138,   139,   140,   141,   142,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,     0,     0,     0,     0,     0,     0,     0,   149,     0,
     150,     0,     0,     0,     0,     0,     0,     0,   154,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   157,     0,     0,     0,     0,     0,     0,   158,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
     162,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   168,     0,     0,     0,     0,     0,     0,
       0,     0,   170,     0,     0,     0,     0,   172,     0,     0,
       0,     0,     0,   174,     0,     0,     0,     0,     0,   175,
       0,   176,     0,     0,     0,     0,     0,     0,   178,     0,
     179,     0,     0,     0,     0,     0,     0,     0,     0,   180,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   182,   183,     0,     0,     0,     0,     0,
     184,     0,   185,     0,     0,   186,   187,     0,   188,     0,
       0,     0,     0,     0,     0,     0,     0,   189,   190,     0,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   196,   197,   198,     0,     0,     0,     0,
       0,   201,     0,     0,     0,   203,     0,     0,   204,     0,
     205,   206,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   207,   208,
       0,   209,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   212,     0,   213,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   215,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,     0,
       0,     0,     0,   225,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   231,     0,     0,     0,   233,     0,
       0,     0,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   238,     0,
       0,     0,     0,     0,     0,   239,   240,     0,     0,     0,
       0,   241,     0,   242,     0,     0,     0,     0,     0,     0,
       0,     0,   245,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   250,
       0,     0,   251,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
      86,    87,    88,     0,    90,    91,    92,     0,     0,     0,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,     0,     0,     0,   107,   108,   109,   110,     0,
     111,   112,   113,   114,     0,   115,   116,   117,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   133,     0,     0,     0,     0,     0,
     136,   137,   138,   139,   140,   141,   142,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,     0,
       0,     0,     0,     0,     0,     0,   149,     0,   150,     0,
       0,     0,     0,     0,     0,     0,   154,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   157,
       0,     0,     0,     0,     0,     0,   158,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,   162,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   168,     0,     0,     0,     0,     0,     0,     0,     0,
     170,     0,     0,     0,     0,   172,     0,     0,     0,     0,
       0,   174,     0,     0,     0,     0,     0,   175,     0,   176,
       0,     0,     0,     0,     0,     0,   178,     0,   179,     0,
       0,     0,     0,     0,     0,     0,     0,   180,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   182,   183,     0,     0,     0,     0,     0,   184,     0,
     185,     0,     0,   186,   187,     0,   188,     0,     0,     0,
       0,     0,     0,     0,     0,   189,   190,     0,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   196,   197,   198,     0,     0,     0,     0,     0,   201,
       0,     0,     0,   203,     0,     0,   204,     0,   205,   206,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   207,   208,     0,   209,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   212,     0,   213,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   215,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,     0,     0,     0,
       0,   225,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   231,     0,     0,     0,   233,     0,     0,     0,
     234,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   238,     0,     0,     0,
       0,     0,     0,   239,   240,     0,     0,     0,     0,   241,
       0,   242,     0,     0,     0,     0,     0,     0,     0,     0,
     245,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   250,     0,     0,
     251,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    35,   465,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
       0,     0,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,   133,   482,
     483,   484,   485,   486,   136,   137,   138,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,     0,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,   150,     0,   500,   501,   502,   503,   504,   505,
     154,   506,   507,     0,     0,   508,   509,   510,   511,   512,
     513,   514,     0,   157,   515,   516,     0,     0,     0,     0,
     158,     0,     0,     0,   518,   519,   520,   521,     0,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
    2627,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,   175,     0,   176,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,     0,   575,
     576,   180,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,   182,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,   186,   187,   592,
     188,   593,   594,   595,   596,   597,     0,     0,   598,   189,
     190,   599,   191,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,     0,   612,
     613,     0,   614,   615,   616,   196,   197,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,   203,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,  2628,     0,   631,   632,   633,   634,     0,     0,   635,
     207,   208,   636,   209,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
     222,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,     0,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
     233,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
     238,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,  2629,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
       0,   250,     0,   757,   251,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    35,   769,   770,     0,     0,     0,     0,     0,
      41,    42,  2118,  2119,  6195,     0,     0,     0,     0,     0,
       0,  6196,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,   129,   130,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,   137,
     138,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,     0,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,   150,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,     0,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,     0,     0,     0,   158,     0,     0,     0,   518,   519,
     520,   521,     0,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,     0,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,   189,   190,   599,   191,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,     0,   612,   613,     0,   614,   615,   616,   196,
     197,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,   203,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,   208,   636,   209,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,     0,   696,
     229,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,   237,   728,   238,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,   249,   250,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,   252,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   769,   770,    35,
     465,   264,     0,    37,    38,    39,    40,    41,    42,    43,
      44,     0,     0,     0,    45,   265,     0,     0,     0,     0,
       0,     0,     0,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,   477,   478,     0,   479,   480,   481,     0,   133,
     482,   483,   484,   485,   486,   136,   137,   138,   139,   140,
     141,   142,     0,   487,   488,   489,   490,   491,     0,     0,
     492,   493,     0,   143,   494,     0,   495,   496,   497,   498,
     499,   149,     0,   150,     0,   500,   501,   502,   503,   504,
     505,   154,   506,   507,     0,     0,   508,   509,   510,   511,
     512,   513,   514,     0,   157,   515,   516,     0,     0,     0,
       0,   158,     0,     0,     0,   518,   519,   520,   521,     0,
       0,   522,   161,   162,   523,  2844,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   545,   546,   547,     0,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   170,   556,   557,   558,   559,
     172,  2627,   560,     0,   561,   562,   174,   563,     0,   564,
       0,   565,   175,     0,   176,   566,   567,   568,   569,     0,
     570,   178,     0,   179,   571,   572,     0,   573,   574,     0,
     575,   576,   180,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,     0,   587,   182,   183,     0,   588,
     589,   590,     0,   184,     0,   185,     0,   591,   186,   187,
     592,   188,   593,   594,   595,   596,   597,     0,     0,   598,
     189,   190,   599,   191,     0,   600,   601,   602,     0,     0,
     603,   604,   605,   606,   607,   608,   609,   610,   611,     0,
     612,   613,     0,   614,   615,   616,   196,   197,   198,   617,
     618,   619,     0,   620,   201,     0,   621,   622,   203,   623,
       0,   204,   624,   205,   206,   625,   626,   627,     0,   628,
     629,   630,  2628,     0,   631,   632,   633,   634,     0,     0,
     635,   207,   208,   636,   209,   210,   637,   638,   639,   640,
     641,   642,     0,   643,   644,   645,   646,     0,   647,   648,
     212,   649,   213,   650,   651,   652,   653,     0,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   215,
     665,   666,   667,   668,   669,     0,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,   682,
     683,   222,   684,   685,   686,   687,   225,   688,   689,   690,
     691,   692,   693,   694,   695,     0,   696,     0,   697,   698,
     699,   700,   701,     0,     0,   703,   704,   231,   705,   706,
     707,   233,   708,   709,   710,   234,   711,     0,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   236,     0,     0,   725,     0,   726,   727,     0,     0,
     728,   238,   729,   730,   731,   732,   733,     0,   239,   240,
       0,     0,   735,   736,   241,   737,   242,  2629,   738,   739,
     740,   741,   742,   743,   744,     0,     0,   745,   746,   747,
     748,   749,   750,   751,     0,     0,   752,   753,   754,   755,
     756,     0,   250,     0,   757,   251,   758,   759,   760,   761,
       0,     0,     0,   762,     0,     0,   763,   764,   765,   766,
     767,   768,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   769,   770,     0,     0,     0,     0,
       0,    35,   465,  2118,  2119,    37,    38,    39,    40,    41,
      42,    43,    44,     0,     0,     0,    45,     0,     0,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,   477,   478,     0,   479,   480,   481,
       0,   133,   482,   483,   484,   485,   486,   136,   137,   138,
     139,   140,   141,   142,     0,   487,   488,   489,   490,   491,
       0,     0,   492,   493,     0,   143,   494,     0,   495,   496,
     497,   498,   499,   149,     0,   150,     0,   500,   501,   502,
     503,   504,   505,   154,   506,   507,     0,     0,   508,   509,
     510,   511,   512,   513,   514,     0,   157,   515,   516,     0,
       0,     0,     0,   158,     0,     0,     0,   518,   519,   520,
     521,     0,     0,   522,   161,   162,   523,  2849,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   545,   546,   547,     0,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   170,   556,   557,
     558,   559,   172,  2627,   560,     0,   561,   562,   174,   563,
       0,   564,     0,   565,   175,     0,   176,   566,   567,   568,
     569,     0,   570,   178,     0,   179,   571,   572,     0,   573,
     574,     0,   575,   576,   180,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,     0,   587,   182,   183,
       0,   588,   589,   590,     0,   184,     0,   185,     0,   591,
     186,   187,   592,   188,   593,   594,   595,   596,   597,     0,
       0,   598,   189,   190,   599,   191,     0,   600,   601,   602,
       0,     0,   603,   604,   605,   606,   607,   608,   609,   610,
     611,     0,   612,   613,     0,   614,   615,   616,   196,   197,
     198,   617,   618,   619,     0,   620,   201,     0,   621,   622,
     203,   623,     0,   204,   624,   205,   206,   625,   626,   627,
       0,   628,   629,   630,  2628,     0,   631,   632,   633,   634,
       0,     0,   635,   207,   208,   636,   209,   210,   637,   638,
     639,   640,   641,   642,     0,   643,   644,   645,   646,     0,
     647,   648,   212,   649,   213,   650,   651,   652,   653,     0,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   215,   665,   666,   667,   668,   669,     0,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
       0,   682,   683,   222,   684,   685,   686,   687,   225,   688,
     689,   690,   691,   692,   693,   694,   695,     0,   696,     0,
     697,   698,   699,   700,   701,     0,     0,   703,   704,   231,
     705,   706,   707,   233,   708,   709,   710,   234,   711,     0,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   236,     0,     0,   725,     0,   726,   727,
       0,     0,   728,   238,   729,   730,   731,   732,   733,     0,
     239,   240,     0,     0,   735,   736,   241,   737,   242,  2629,
     738,   739,   740,   741,   742,   743,   744,     0,     0,   745,
     746,   747,   748,   749,   750,   751,     0,     0,   752,   753,
     754,   755,   756,     0,   250,     0,   757,   251,   758,   759,
     760,   761,     0,     0,     0,   762,     0,     0,   763,   764,
     765,   766,   767,   768,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   769,   770,     0,     0,
       0,     0,     0,    35,   465,  2118,  2119,    37,    38,    39,
      40,    41,    42,    43,    44,     0,     0,     0,    45,     0,
       0,     0,     0,     0,     0,     0,     0,   466,   467,   468,
     469,   470,   471,   472,   473,     0,   474,   475,   476,     0,
       0,     0,     0,     0,     0,     0,   477,   478,     0,   479,
     480,   481,     0,   133,   482,   483,   484,   485,   486,   136,
     137,   138,   139,   140,   141,   142,     0,   487,   488,   489,
     490,   491,     0,     0,   492,   493,     0,   143,   494,     0,
     495,   496,   497,   498,   499,   149,     0,   150,     0,   500,
     501,   502,   503,   504,   505,   154,   506,   507,     0,     0,
     508,   509,   510,   511,   512,   513,   514,     0,   157,   515,
     516,     0,     0,     0,     0,   158,     0,     0,     0,   518,
     519,   520,   521,     0,     0,   522,   161,   162,   523,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   545,   546,   547,     0,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   170,
     556,   557,   558,   559,   172,  2627,   560,     0,   561,   562,
     174,   563,     0,   564,     0,   565,   175,     0,   176,   566,
     567,   568,   569,     0,   570,   178,     0,   179,   571,   572,
       0,   573,   574,     0,   575,   576,   180,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,     0,   587,
     182,   183,     0,   588,   589,   590,     0,   184,     0,   185,
       0,   591,   186,   187,   592,   188,   593,   594,   595,   596,
     597,     0,     0,   598,   189,   190,   599,   191,     0,   600,
     601,   602,     0,     0,   603,   604,   605,   606,   607,   608,
     609,   610,   611,     0,   612,   613,     0,   614,   615,   616,
     196,   197,   198,   617,   618,   619,     0,   620,   201,     0,
     621,   622,   203,   623,     0,   204,   624,   205,   206,   625,
     626,   627,     0,   628,   629,   630,  2628,     0,   631,   632,
     633,   634,     0,     0,   635,   207,   208,   636,   209,   210,
     637,   638,   639,   640,   641,   642,     0,   643,   644,   645,
     646,     0,   647,   648,   212,   649,   213,   650,   651,   652,
     653,     0,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   215,   665,   666,   667,   668,   669,     0,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,     0,   682,   683,   222,   684,   685,   686,   687,
     225,   688,   689,   690,   691,   692,   693,   694,   695,     0,
     696,     0,   697,   698,   699,   700,   701,     0,     0,   703,
     704,   231,   705,   706,   707,   233,   708,   709,   710,   234,
     711,     0,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   236,     0,     0,   725,     0,
     726,   727,     0,     0,   728,   238,   729,   730,   731,   732,
     733,     0,   239,   240,     0,     0,   735,   736,   241,   737,
     242,  2629,   738,   739,   740,   741,   742,   743,   744,     0,
       0,   745,   746,   747,   748,   749,   750,   751,     0,     0,
     752,   753,   754,   755,   756,     0,   250,     0,   757,   251,
     758,   759,   760,   761,     0,     0,     0,   762,     0,     0,
     763,   764,   765,   766,   767,   768,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   769,   770,
       0,     0,     0,     0,     0,    35,   465,  2118,  2119,    37,
      38,    39,    40,    41,    42,     0,    44,     0,     0,     0,
      45,     0,     0,     0,     0,     0,     0,     0,     0,   466,
     467,   468,   469,   470,   471,   472,   473,     0,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,   477,   478,
       0,   479,   480,   481,     0,   133,   482,   483,   484,   485,
     486,   136,   137,   138,   139,   140,   141,   142,     0,   487,
     488,   489,   490,   491,     0,     0,   492,   493,     0,   143,
     494,     0,   495,   496,   497,   498,   499,   149,     0,   150,
       0,   500,   501,   502,   503,   504,   505,   154,   506,   507,
       0,     0,   508,   509,   510,   511,   512,   513,   514,     0,
     157,   515,   516,     0,     0,     0,     0,   158,     0,     0,
       0,   518,   519,   520,   521,     0,     0,   522,   161,   162,
     523,  3882,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   545,   546,
     547,     0,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   170,   556,   557,   558,   559,   172,  2627,   560,     0,
     561,   562,   174,   563,     0,   564,     0,   565,   175,     0,
     176,   566,   567,   568,   569,     0,   570,   178,     0,   179,
     571,   572,     0,   573,   574,     0,   575,   576,   180,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
       0,   587,   182,   183,     0,   588,   589,   590,     0,   184,
       0,   185,     0,   591,   186,   187,   592,   188,   593,   594,
     595,   596,   597,     0,     0,   598,   189,   190,   599,   191,
       0,   600,   601,   602,     0,     0,   603,   604,   605,   606,
     607,   608,   609,   610,   611,     0,   612,   613,     0,   614,
     615,   616,   196,   197,   198,   617,   618,   619,     0,   620,
     201,     0,   621,   622,   203,   623,     0,   204,   624,   205,
     206,   625,   626,   627,     0,   628,   629,   630,  2628,     0,
     631,   632,   633,   634,     0,     0,   635,   207,   208,   636,
     209,   210,   637,   638,   639,   640,   641,   642,     0,   643,
     644,   645,   646,     0,   647,   648,   212,   649,   213,   650,
     651,   652,   653,     0,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   215,   665,   666,   667,   668,
     669,     0,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,     0,   682,   683,   222,   684,   685,
     686,   687,   225,   688,   689,   690,   691,   692,   693,   694,
     695,     0,   696,     0,   697,   698,   699,   700,   701,     0,
       0,   703,   704,   231,   705,   706,   707,   233,   708,   709,
     710,   234,   711,     0,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   236,     0,     0,
     725,     0,   726,   727,     0,     0,   728,   238,   729,   730,
     731,   732,   733,     0,   239,   240,     0,     0,   735,   736,
     241,   737,   242,  2629,   738,   739,   740,   741,   742,   743,
     744,     0,     0,   745,   746,   747,   748,   749,   750,   751,
       0,     0,   752,   753,   754,   755,   756,     0,   250,     0,
     757,   251,   758,   759,   760,   761,     0,     0,     0,   762,
       0,     0,   763,   764,   765,   766,   767,   768,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     769,   770,     0,     0,     0,     0,     0,    35,   465,  1160,
    1161,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,     0,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
     477,   478,     0,   479,   480,   481,     0,   133,   482,   483,
     484,   485,   486,   136,   137,   138,   139,   140,   141,   142,
       0,   487,   488,   489,   490,   491,     0,     0,   492,   493,
       0,   143,   494,     0,   495,   496,   497,   498,   499,   149,
       0,   150,     0,   500,   501,   502,   503,   504,   505,   154,
     506,   507,     0,     0,   508,   509,   510,   511,   512,   513,
     514,     0,   157,   515,   516,     0,     0,     0,     0,   158,
       0,     0,   517,   518,   519,   520,   521,     0,     0,   522,
     161,   162,   523,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     545,   546,   547,     0,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   170,   556,   557,   558,   559,   172,     0,
     560,     0,   561,   562,   174,   563,     0,   564,     0,   565,
     175,     0,   176,   566,   567,   568,   569,     0,   570,   178,
       0,   179,   571,   572,     0,   573,   574,     0,   575,   576,
     180,   577,   578,   579,   580,     0,   581,   582,   583,   584,
     585,   586,     0,   587,   182,   183,     0,   588,   589,   590,
       0,   184,     0,   185,     0,   591,   186,   187,   592,   188,
     593,   594,   595,   596,   597,     0,     0,   598,   189,   190,
     599,   191,     0,   600,   601,   602,     0,     0,   603,   604,
     605,   606,   607,   608,   609,   610,   611,     0,   612,   613,
       0,   614,   615,   616,   196,   197,   198,   617,   618,   619,
       0,   620,   201,     0,   621,   622,   203,   623,     0,   204,
     624,   205,   206,   625,   626,   627,     0,   628,   629,   630,
       0,     0,   631,   632,   633,   634,     0,     0,   635,   207,
     208,   636,   209,   210,   637,   638,   639,   640,   641,   642,
       0,   643,   644,   645,   646,     0,   647,   648,   212,   649,
     213,   650,   651,   652,   653,     0,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   215,   665,   666,
     667,   668,   669,     0,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,     0,   682,   683,   222,
     684,   685,   686,   687,   225,   688,   689,   690,   691,   692,
     693,   694,   695,     0,   696,     0,   697,   698,   699,   700,
     701,   702,     0,   703,   704,   231,   705,   706,   707,   233,
     708,   709,   710,   234,   711,     0,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   236,
       0,     0,   725,     0,   726,   727,     0,     0,   728,   238,
     729,   730,   731,   732,   733,     0,   239,   240,   734,     0,
     735,   736,   241,   737,   242,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,   745,   746,   747,   748,   749,
     750,   751,     0,     0,   752,   753,   754,   755,   756,     0,
     250,     0,   757,   251,   758,   759,   760,   761,     0,     0,
       0,   762,     0,     0,   763,   764,   765,   766,   767,   768,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   769,   770,    35,   465,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,   133,   482,   483,   484,   485,   486,
     136,   137,   138,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,     0,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,   150,     0,
     500,   501,   502,   503,   504,   505,   154,   506,   507,     0,
       0,   508,   509,   510,   511,   512,   513,   514,     0,   157,
     515,   516,     0,     0,     0,     0,   158,     0,     0,   517,
     518,   519,   520,   521,     0,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,   175,     0,   176,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,     0,   575,   576,   180,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,   182,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,   186,   187,   592,   188,   593,   594,   595,
     596,   597,     0,     0,   598,   189,   190,   599,   191,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,     0,   612,   613,     0,   614,   615,
     616,   196,   197,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,   203,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,   208,   636,   209,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,   222,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
       0,   696,     0,   697,   698,   699,   700,   701,   702,     0,
     703,   704,   231,   705,   706,   707,   233,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,   238,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,     0,   250,     0,   757,
     251,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    35,   769,
     770,     0,    37,    38,    39,    40,    41,    42,     0,    44,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,   133,   482,
     483,   484,   485,   486,   136,   137,   138,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,     0,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,   150,     0,   500,   501,   502,   503,   504,   505,
     154,   506,   507,     0,     0,   508,   509,   510,   511,   512,
     513,   514,     0,   157,   515,   516,     0,     0,     0,     0,
     158,     0,     0,     0,   518,   519,   520,   521,     0,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
    2627,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,   175,     0,   176,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,     0,   575,
     576,   180,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,   182,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,   186,   187,   592,
     188,   593,   594,   595,   596,   597,     0,     0,   598,   189,
     190,   599,   191,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,     0,   612,
     613,     0,   614,   615,   616,   196,   197,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,   203,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,  2628,     0,   631,   632,   633,   634,     0,     0,   635,
     207,   208,   636,   209,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
     222,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,     0,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
     233,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
     238,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,  2629,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
       0,   250,     0,   757,   251,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    35,   769,   770,     0,    37,    38,    39,    40,
      41,    42,     0,    44,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,   137,
     138,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,     0,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,   150,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,     0,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,     0,     0,     0,   158,     0,     0,     0,   518,   519,
     520,   521,     0,     0,   522,   161,   162,   523,  2829,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,     0,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,   189,   190,   599,   191,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,     0,   612,   613,     0,   614,   615,   616,   196,
     197,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,   203,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,   208,   636,   209,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,     0,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,   238,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,     0,   250,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,    35,   769,   770,     0,
      37,    38,    39,    40,    41,    42,     0,    44,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,   133,   482,   483,   484,
     485,   486,   136,   137,   138,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,     0,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
     150,     0,   500,   501,   502,   503,   504,   505,   154,   506,
     507,     0,     0,   508,   509,   510,   511,   512,   513,   514,
       0,   157,   515,   516,     0,     0,     0,     0,   158,     0,
       0,     0,   518,   519,   520,   521,     0,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,   175,
       0,   176,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,     0,   575,   576,   180,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,   182,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,   186,   187,   592,   188,   593,
     594,   595,   596,   597,     0,     0,   598,   189,   190,   599,
     191,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,     0,   612,   613,     0,
     614,   615,   616,   196,   197,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,   203,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,   208,
     636,   209,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,   222,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,     0,   696,     0,   697,   698,   699,   700,   701,
       0,     0,   703,   704,   231,   705,   706,   707,   233,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,   238,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,     0,   250,
       0,   757,   251,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
      35,   769,   770,     0,    37,    38,    39,    40,    41,    42,
       0,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
     133,   482,   483,   484,   485,   486,   136,   137,   138,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,     0,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,   150,     0,   500,   501,   502,   503,
     504,   505,   154,   506,   507,     0,     0,   508,   509,   510,
     511,   512,   513,   514,     0,   157,   515,   516,     0,     0,
       0,     0,   158,     0,     0,     0,   518,   519,   520,   521,
       0,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,   175,     0,   176,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
       0,   575,  2600,   180,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,   182,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,   186,
     187,   592,   188,   593,   594,   595,   596,   597,     0,     0,
     598,   189,   190,   599,   191,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
       0,   612,   613,     0,   614,   615,   616,   196,   197,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,   203,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,   208,   636,   209,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,   222,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,     0,   696,     0,   697,
     698,   699,   700,   701,     0,     0,   703,   704,   231,   705,
     706,   707,   233,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,   238,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,     0,   250,     0,   757,   251,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,    35,   769,   770,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,  1457,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,   133,   482,   483,   484,   485,   486,
     136,   137,   138,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,     0,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,   150,     0,
     500,   501,   502,   503,   504,   505,   154,   506,   507,     0,
       0,   508,   509,   510,   511,   512,   513,   514,     0,   157,
     515,   516,     0,     0,     0,     0,   158,     0,     0,   517,
     518,   519,   520,   521,     0,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,   175,     0,   176,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,     0,   575,   576,   180,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,   182,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,   186,   187,   592,   188,   593,   594,   595,
     596,   597,     0,     0,   598,   189,   190,   599,   191,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,     0,   612,   613,     0,   614,   615,
     616,   196,   197,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,   203,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,   208,   636,   209,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,   222,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
       0,   696,     0,   697,   698,   699,   700,   701,   702,     0,
     703,   704,   231,   705,   706,   707,   233,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,   238,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,     0,   250,     0,   757,
     251,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    35,   769,
     770,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
    1477,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,   133,   482,
     483,   484,   485,   486,   136,   137,   138,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,     0,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,   150,     0,   500,   501,   502,   503,   504,   505,
     154,   506,   507,     0,     0,   508,   509,   510,   511,   512,
     513,   514,     0,   157,   515,   516,     0,     0,     0,     0,
     158,     0,     0,   517,   518,   519,   520,   521,     0,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,   175,     0,   176,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,     0,   575,
     576,   180,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,   182,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,   186,   187,   592,
     188,   593,   594,   595,   596,   597,     0,     0,   598,   189,
     190,   599,   191,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,  1478,   608,   609,   610,   611,     0,   612,
     613,     0,   614,   615,   616,   196,   197,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,   203,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,   208,   636,   209,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
     222,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,     0,   696,     0,   697,   698,   699,
     700,   701,   702,     0,   703,   704,   231,   705,   706,   707,
     233,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
     238,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
       0,   250,     0,   757,   251,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    35,   769,   770,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,   137,
     138,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,     0,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,   150,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,     0,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,     0,     0,     0,   158,     0,     0,   517,   518,   519,
     520,   521,     0,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,     0,   575,   576,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,   189,   190,   599,   191,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,     0,   612,   613,     0,   614,   615,   616,   196,
     197,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,   203,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,   208,   636,   209,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,     0,   696,
       0,   697,   698,   699,   700,   701,   702,     0,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,   238,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,  3270,     0,   752,
     753,   754,   755,   756,     0,   250,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,    35,   769,   770,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,   133,   482,   483,   484,
     485,   486,   136,   137,   138,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,     0,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
     150,     0,   500,   501,   502,   503,   504,   505,   154,   506,
     507,     0,     0,   508,   509,   510,   511,   512,   513,   514,
       0,   157,   515,   516,     0,     0,     0,     0,   158,     0,
       0,   517,   518,   519,   520,   521,     0,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,   175,
       0,   176,   566,   567,   568,   569,     0,   570,   178,  4363,
     179,   571,   572,     0,   573,   574,     0,   575,   576,   180,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,   182,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,   186,   187,   592,   188,   593,
     594,   595,   596,   597,     0,     0,   598,   189,   190,   599,
     191,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,     0,   612,   613,     0,
     614,   615,   616,   196,   197,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,   203,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,   208,
     636,   209,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,   222,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,     0,   696,     0,   697,   698,   699,   700,   701,
     702,     0,   703,   704,   231,   705,   706,   707,   233,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,   238,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,     0,   250,
       0,   757,   251,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
      35,   769,   770,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
     133,   482,   483,   484,   485,   486,   136,   137,   138,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,     0,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,   150,     0,   500,   501,   502,   503,
     504,   505,   154,   506,   507,     0,     0,   508,   509,   510,
     511,   512,   513,   514,     0,   157,   515,   516,     0,     0,
       0,     0,   158,     0,     0,   517,   518,   519,   520,   521,
       0,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,   175,     0,   176,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
       0,   575,   576,   180,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,   182,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,   186,
     187,   592,   188,   593,   594,   595,   596,   597,     0,     0,
     598,   189,   190,   599,   191,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,   607,   608,   609,   610,   611,
       0,   612,   613,     0,   614,   615,   616,   196,   197,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,   203,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,   208,   636,   209,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,   222,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,     0,   696,     0,   697,
     698,   699,   700,   701,   702,     0,   703,   704,   231,   705,
     706,   707,   233,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,   238,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,  5383,     0,   752,   753,   754,
     755,   756,     0,   250,     0,   757,   251,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,    35,   769,   770,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,   133,   482,   483,   484,   485,   486,
     136,   137,   138,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,     0,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,   150,     0,
     500,   501,   502,   503,   504,   505,   154,   506,   507,     0,
       0,   508,   509,   510,   511,   512,   513,   514,     0,   157,
     515,   516,     0,     0,     0,     0,   158,     0,     0,   517,
     518,   519,   520,   521,     0,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,   175,     0,   176,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,     0,   575,   576,   180,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,   182,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,   186,   187,   592,   188,   593,   594,   595,
     596,   597,     0,     0,   598,   189,   190,   599,   191,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,     0,   612,   613,     0,   614,   615,
     616,   196,   197,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,   203,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,   208,   636,   209,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,   222,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
       0,   696,     0,   697,   698,   699,   700,   701,   702,     0,
     703,   704,   231,   705,   706,   707,   233,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,   238,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,     0,   250,     0,   757,
     251,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    35,   769,
     770,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,   133,   482,
     483,   484,   485,   486,   136,   137,   138,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,     0,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,   150,     0,   500,   501,   502,   503,   504,   505,
     154,   506,   507,     0,     0,   508,   509,   510,   511,   512,
     513,   514,     0,   157,   515,   516,     0,     0,     0,     0,
     158,     0,     0,   517,   518,   519,   520,   521,     0,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,   175,     0,   176,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,     0,   575,
     576,   180,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,   182,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,   186,   187,   592,
     188,   593,   594,   595,   596,   597,     0,     0,   598,   189,
     190,   599,   191,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,  1596,   608,   609,   610,   611,     0,   612,
     613,     0,   614,   615,   616,   196,   197,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,   203,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,   208,   636,   209,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
     222,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,     0,   696,     0,   697,   698,   699,
     700,   701,   702,     0,   703,   704,   231,   705,   706,   707,
     233,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
     238,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
       0,   250,     0,   757,   251,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    35,   769,   770,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,   133,   482,   483,   484,   485,   486,   136,   137,
     138,   139,   140,   141,   142,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,     0,   143,   494,     0,   495,
     496,   497,   498,   499,   149,     0,   150,     0,   500,   501,
     502,   503,   504,   505,   154,   506,   507,     0,     0,   508,
     509,   510,   511,   512,   513,   514,     0,   157,   515,   516,
       0,     0,     0,     0,   158,     0,     0,   517,   518,   519,
     520,   521,     0,     0,   522,   161,   162,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   170,   556,
     557,   558,   559,   172,     0,   560,     0,   561,   562,   174,
     563,     0,   564,     0,   565,   175,     0,   176,   566,   567,
     568,   569,     0,   570,   178,     0,   179,   571,   572,     0,
     573,   574,     0,   575,  1684,   180,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,   182,
     183,     0,   588,   589,   590,     0,   184,     0,   185,     0,
     591,   186,   187,   592,   188,   593,   594,   595,   596,   597,
       0,     0,   598,   189,   190,   599,   191,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,     0,   612,   613,     0,   614,   615,   616,   196,
     197,   198,   617,   618,   619,     0,   620,   201,     0,   621,
     622,   203,   623,     0,   204,   624,   205,   206,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,   207,   208,   636,   209,   210,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,   212,   649,   213,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   215,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,   222,   684,   685,   686,   687,   225,
     688,   689,   690,   691,   692,   693,   694,   695,     0,   696,
       0,   697,   698,   699,   700,   701,   702,     0,   703,   704,
     231,   705,   706,   707,   233,   708,   709,   710,   234,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   236,     0,     0,   725,     0,   726,
     727,     0,     0,   728,   238,   729,   730,   731,   732,   733,
       0,   239,   240,     0,     0,   735,   736,   241,   737,   242,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,     0,   250,     0,   757,   251,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,    35,   769,   770,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     466,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,     0,   133,   482,   483,   484,
     485,   486,   136,   137,   138,   139,   140,   141,   142,     0,
     487,   488,   489,   490,   491,     0,     0,   492,   493,     0,
     143,   494,     0,   495,   496,   497,   498,   499,   149,     0,
     150,     0,   500,   501,   502,   503,   504,   505,   154,   506,
     507,     0,     0,   508,   509,   510,   511,   512,   513,   514,
       0,   157,   515,   516,     0,     0,     0,     0,   158,     0,
       0,   517,   518,   519,   520,   521,     0,     0,   522,   161,
     162,   523,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   545,
     546,   547,     0,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   170,   556,   557,   558,   559,   172,     0,   560,
       0,   561,   562,   174,   563,     0,   564,     0,   565,   175,
       0,   176,   566,   567,   568,   569,     0,   570,   178,     0,
     179,   571,   572,     0,   573,   574,     0,   575,  1699,   180,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,     0,   587,   182,   183,     0,   588,   589,   590,     0,
     184,     0,   185,     0,   591,   186,   187,   592,   188,   593,
     594,   595,   596,   597,     0,     0,   598,   189,   190,   599,
     191,     0,   600,   601,   602,     0,     0,   603,   604,   605,
     606,   607,   608,   609,   610,   611,     0,   612,   613,     0,
     614,   615,   616,   196,   197,   198,   617,   618,   619,     0,
     620,   201,     0,   621,   622,   203,   623,     0,   204,   624,
     205,   206,   625,   626,   627,     0,   628,   629,   630,     0,
       0,   631,   632,   633,   634,     0,     0,   635,   207,   208,
     636,   209,   210,   637,   638,   639,   640,   641,   642,     0,
     643,   644,   645,   646,     0,   647,   648,   212,   649,   213,
     650,   651,   652,   653,     0,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   215,   665,   666,   667,
     668,   669,     0,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,     0,   682,   683,   222,   684,
     685,   686,   687,   225,   688,   689,   690,   691,   692,   693,
     694,   695,     0,   696,     0,   697,   698,   699,   700,   701,
     702,     0,   703,   704,   231,   705,   706,   707,   233,   708,
     709,   710,   234,   711,     0,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   236,     0,
       0,   725,     0,   726,   727,     0,     0,   728,   238,   729,
     730,   731,   732,   733,     0,   239,   240,     0,     0,   735,
     736,   241,   737,   242,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,   745,   746,   747,   748,   749,   750,
     751,     0,     0,   752,   753,   754,   755,   756,     0,   250,
       0,   757,   251,   758,   759,   760,   761,     0,     0,     0,
     762,     0,     0,   763,   764,   765,   766,   767,   768,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
      35,   769,   770,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   475,   476,     0,     0,     0,     0,
       0,     0,     0,   477,   478,     0,   479,   480,   481,     0,
     133,   482,   483,   484,   485,   486,   136,   137,   138,   139,
     140,   141,   142,     0,   487,   488,   489,   490,   491,     0,
       0,   492,   493,     0,   143,   494,     0,   495,   496,   497,
     498,   499,   149,     0,   150,     0,   500,   501,   502,   503,
     504,   505,   154,   506,   507,     0,     0,   508,   509,   510,
     511,   512,   513,   514,     0,   157,   515,   516,     0,     0,
       0,     0,   158,     0,     0,   517,   518,   519,   520,   521,
       0,     0,   522,   161,   162,   523,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   545,   546,   547,     0,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   170,   556,   557,   558,
     559,   172,     0,   560,     0,   561,   562,   174,   563,     0,
     564,     0,   565,   175,     0,   176,   566,   567,   568,   569,
       0,   570,   178,     0,   179,   571,   572,     0,   573,   574,
       0,   575,  1710,   180,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,     0,   587,   182,   183,     0,
     588,   589,   590,     0,   184,     0,   185,     0,   591,   186,
     187,   592,   188,   593,   594,   595,   596,   597,     0,     0,
     598,   189,   190,   599,   191,     0,   600,   601,   602,     0,
       0,   603,   604,   605,   606,  1711,   608,   609,   610,   611,
       0,   612,   613,     0,   614,   615,   616,   196,   197,   198,
     617,   618,   619,     0,   620,   201,     0,   621,   622,   203,
     623,     0,   204,   624,   205,   206,   625,   626,   627,     0,
     628,   629,   630,     0,     0,   631,   632,   633,   634,     0,
       0,   635,   207,   208,   636,   209,   210,   637,   638,   639,
     640,   641,   642,     0,   643,   644,   645,   646,     0,   647,
     648,   212,   649,   213,   650,   651,   652,   653,     0,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     215,   665,   666,   667,   668,   669,     0,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,     0,
     682,   683,   222,   684,   685,   686,   687,   225,   688,   689,
     690,   691,   692,   693,   694,   695,     0,   696,     0,   697,
     698,   699,   700,   701,   702,     0,   703,   704,   231,   705,
     706,   707,   233,   708,   709,   710,   234,   711,     0,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   236,     0,     0,   725,     0,   726,   727,     0,
       0,   728,   238,   729,   730,   731,   732,   733,     0,   239,
     240,     0,     0,   735,   736,   241,   737,   242,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,   745,   746,
     747,   748,   749,   750,   751,     0,     0,   752,   753,   754,
     755,   756,     0,   250,     0,   757,   251,   758,   759,   760,
     761,     0,     0,     0,   762,     0,     0,   763,   764,   765,
     766,   767,   768,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,    35,   769,   770,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   475,   476,
     129,   130,     0,     0,     0,     0,     0,   477,   478,     0,
     479,   480,   481,     0,   133,   482,   483,   484,   485,   486,
     136,   137,   138,   139,   140,   141,   142,     0,   487,   488,
     489,   490,   491,     0,     0,   492,   493,     0,   143,   494,
       0,   495,   496,   497,   498,   499,   149,     0,   150,     0,
     500,   501,   502,   503,   504,   505,   154,   506,   507,     0,
       0,   508,   509,   510,   511,   512,   513,   514,     0,   157,
     515,   516,     0,     0,     0,     0,   158,     0,     0,     0,
     518,   519,   520,   521,     0,     0,   522,   161,   162,   523,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   545,   546,   547,
       0,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     170,   556,   557,   558,   559,   172,     0,   560,     0,   561,
     562,   174,   563,     0,   564,     0,   565,   175,     0,   176,
     566,   567,   568,   569,     0,   570,   178,     0,   179,   571,
     572,     0,   573,   574,     0,   575,   576,   180,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,     0,
     587,   182,   183,     0,   588,   589,   590,     0,   184,     0,
     185,     0,   591,   186,   187,   592,   188,   593,   594,   595,
     596,   597,     0,     0,   598,   189,   190,   599,   191,     0,
     600,   601,   602,     0,     0,   603,   604,   605,   606,   607,
     608,   609,   610,   611,     0,   612,   613,     0,   614,   615,
     616,   196,   197,   198,   617,   618,   619,     0,   620,   201,
       0,   621,   622,   203,   623,     0,   204,   624,   205,   206,
     625,   626,   627,     0,   628,   629,   630,     0,     0,   631,
     632,   633,   634,     0,     0,   635,   207,   208,   636,   209,
     210,   637,   638,   639,   640,   641,   642,     0,   643,   644,
     645,   646,     0,   647,   648,   212,   649,   213,   650,   651,
     652,   653,     0,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   215,   665,   666,   667,   668,   669,
       0,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,     0,   682,   683,   222,   684,   685,   686,
     687,   225,   688,   689,   690,   691,   692,   693,   694,   695,
       0,   696,     0,   697,   698,   699,   700,   701,     0,     0,
     703,   704,   231,   705,   706,   707,   233,   708,   709,   710,
     234,   711,     0,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   236,     0,     0,   725,
       0,   726,   727,     0,     0,   728,   238,   729,   730,   731,
     732,   733,     0,   239,   240,     0,     0,   735,   736,   241,
     737,   242,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,   745,   746,   747,   748,   749,   750,   751,     0,
       0,   752,   753,   754,   755,   756,     0,   250,     0,   757,
     251,   758,   759,   760,   761,     0,     0,     0,   762,     0,
       0,   763,   764,   765,   766,   767,   768,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    35,   769,
     770,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   475,   476,     0,     0,     0,     0,     0,     0,
       0,   477,   478,     0,   479,   480,   481,     0,   133,   482,
     483,   484,   485,   486,   136,   137,   138,   139,   140,   141,
     142,     0,   487,   488,   489,   490,   491,     0,     0,   492,
     493,     0,   143,   494,     0,   495,   496,   497,   498,   499,
     149,     0,   150,     0,   500,   501,   502,   503,   504,   505,
     154,   506,   507,     0,     0,   508,   509,   510,   511,   512,
     513,   514,     0,   157,   515,   516,     0,     0,     0,     0,
     158,     0,     0,     0,   518,   519,   520,   521,     0,     0,
     522,   161,   162,   523,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   545,   546,   547,     0,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   170,   556,   557,   558,   559,   172,
       0,   560,     0,   561,   562,   174,   563,     0,   564,     0,
     565,   175,     0,   176,   566,   567,   568,   569,     0,   570,
     178,     0,   179,   571,   572,     0,   573,   574,     0,   575,
     576,   180,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,     0,   587,   182,   183,     0,   588,   589,
     590,     0,   184,     0,   185,     0,   591,   186,   187,   592,
     188,   593,   594,   595,   596,   597,     0,     0,   598,   189,
     190,   599,   191,     0,   600,   601,   602,     0,     0,   603,
     604,   605,   606,   607,   608,   609,   610,   611,     0,   612,
     613,     0,   614,   615,   616,   196,   197,   198,   617,   618,
     619,     0,   620,   201,     0,   621,   622,   203,   623,     0,
     204,   624,   205,   206,   625,   626,   627,     0,   628,   629,
     630,     0,     0,   631,   632,   633,   634,     0,     0,   635,
     207,   208,   636,   209,   210,   637,   638,   639,   640,   641,
     642,     0,   643,   644,   645,   646,     0,   647,   648,   212,
     649,   213,   650,   651,   652,   653,     0,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   215,   665,
     666,   667,   668,   669,     0,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,     0,   682,   683,
     222,   684,   685,   686,   687,   225,   688,   689,   690,   691,
     692,   693,   694,   695,     0,   696,     0,   697,   698,   699,
     700,   701,     0,     0,   703,   704,   231,   705,   706,   707,
     233,   708,   709,   710,   234,   711,     0,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     236,     0,     0,   725,     0,   726,   727,     0,     0,   728,
     238,   729,   730,   731,   732,   733,     0,   239,   240,     0,
       0,   735,   736,   241,   737,   242,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,   745,   746,   747,   748,
     749,   750,   751,     0,     0,   752,   753,   754,   755,   756,
       0,   250,     0,   757,   251,   758,   759,   760,   761,     0,
       0,     0,   762,     0,     0,   763,   764,   765,   766,   767,
     768,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    35,   769,   770,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,   477,   478,     0,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,     0,     0,
       0,     0,     0,     0,     0,     0,   487,   488,   489,   490,
     491,     0,     0,   492,   493,     0,     0,   494,     0,   495,
     496,   497,   498,   499,     0,     0,     0,     0,   500,   501,
     502,   503,   504,   505,     0,   506,   507,     0,     0,   508,
     509,   510,   511,   512,   513,   514,     0,     0,   515,   516,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,     0,     0,   522,     0,     0,   523,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   545,   546,   547,     0,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,     0,     0,   560,     0,   561,   562,     0,
     563,     0,   564,     0,   565,     0,     0,     0,   566,   567,
     568,   569,     0,   570,     0,     0,     0,   571,   572,     0,
     573,   574,     0,   575,   576,     0,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,     0,   587,     0,
       0,     0,   588,   589,   590,     0,     0,     0,     0,     0,
     591,     0,     0,   592,     0,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,     0,     0,   600,   601,
     602,     0,     0,   603,   604,   605,   606,   607,   608,   609,
     610,   611,     0,   612,   613,     0,   614,   615,   616,     0,
       0,     0,   617,   618,   619,     0,   620,     0,     0,   621,
     622,     0,   623,     0,     0,   624,     0,     0,   625,   626,
     627,     0,   628,   629,   630,     0,     0,   631,   632,   633,
     634,     0,     0,   635,     0,     0,   636,     0,     0,   637,
     638,   639,   640,   641,   642,     0,   643,   644,   645,   646,
       0,   647,   648,     0,   649,     0,   650,   651,   652,   653,
       0,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,     0,   665,   666,   667,   668,   669,     0,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,     0,   682,   683,     0,   684,   685,   686,   687,     0,
     688,   689,   690,   691,   692,   693,   694,   695,     0,   696,
       0,   697,   698,   699,   700,   701,     0,     0,   703,   704,
       0,   705,   706,   707,     0,   708,   709,   710,     0,   711,
       0,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,     0,     0,     0,   725,     0,   726,
     727,     0,     0,   728,     0,   729,   730,   731,   732,   733,
       0,     0,     0,     0,     0,   735,   736,     0,   737,     0,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
     745,   746,   747,   748,   749,   750,   751,     0,     0,   752,
     753,   754,   755,   756,     0,     0,     0,   757,     0,   758,
     759,   760,   761,     0,     0,     0,   762,     0,     0,   763,
     764,   765,   766,   767,   768,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   769,   770
};

static const yytype_int16 yycheck[] =
{
       2,    78,    78,    78,    78,   965,   221,  1463,   173,    78,
    1330,  1742,  1035,    78,   116,    84,   237,   265,   973,    84,
     428,   428,   159,   412,  1241,    96,   973,   966,  1258,  1079,
     195,  1170,  1171,  1172,  1772,   106,  2242,  1176,   977,  1688,
    1480,  1358,    78,   160,  1236,   243,    78,   116,  1430,  2325,
    1654,  1822,   991,  1230,  1263,     2,  2199,  1464,  1490,  1409,
     971,  3579,   156,  2245,  1641,  1642,   168,  2237,  2805,  1079,
    3752,   171,  1590,   832,  1651,  1652,   147,  1105,  2284,  2997,
    2998,   955,  2613,  1657,  2396,   177,  3185,  1137,  1035,  1814,
    1029,  1119,   163,  1248,    94,   171,   116,   214,  2818,   168,
    1039,  3944,  2245,  2255,   166,    78,  4255,  3816,  3348,  1672,
    1578,  1428,  2694,  3500,  1053,  1497,   131,  1557,  2268,  2739,
    2489,  3367,  1033,  1563,  3371,  4297,  1974,  1595,  1568,   221,
    4740,   131,  4006,   997,  4008,  4284,  3739,  3740,  3546,   171,
    3737,  2718,  1582,   245,  1377,  1272,   833,   414,   168,  1377,
    3973,  3259,  4953,   379,  1101,  4594,  4647,  1597,  4647,   159,
     160,  4193,  3302,  4199,  3304,  3825,  1136,  4199,  3308,   169,
    3741,   173,  4699,  2861,  4917,  2863,   245,  3317,  3318,  3319,
    3567,  2869,  4213,  2112,  2113,  2114,  2874,  4530,  1099,  1118,
    2502,  1573,   414,   195,  1244,  4643,  2545,  4501,  2350,  4956,
     220,  5231,  4379,   220,  4965,  4899,  2356,  2357,  1463,  4946,
     230,  4536,   232,  2812,   214,   232,  1628,  1472,  4942,  3816,
     230,   264,  3798,  5481,  3672,   245,  5594,  1482,  4952,  2598,
    2882,   173,  1755,   265,  1244,  5660,  2391,  2392,  5478,  2393,
    2892,  1724,  2448,  2177,  1421,  1735,  2229,  1659,  2107,  2108,
    5426,  4945,  4044,   195,  1639,  1640,  1126,  3858,  1327,  1123,
    2997,  3360,  1327,  4613,  4464,  1650,  1418,  5810,    14,  4535,
    1682,  4537,  5824,  1850,  1851,    30,  1372,  1373,  5610,    10,
    5612,    21,  1691,   111,  1696,  5817,    71,    74,    75,    76,
      77,  1703,  1869,  1870,    81,  4322,    87,  1709,    71,    14,
      85,  5477,  2452,  1715,    71,   128,  1718,  1066,  1690,  1883,
      74,    75,    76,    77,  5679,    14,   153,    81,    85,    87,
    5729,  5730,   949,    98,  1674,    71,  1503,   116,    74,    75,
      76,    77,   118,   196,    80,    81,    82,    83,   118,    85,
      85,   189,   137,   420,   420,   420,   420,  5976,   116,  6040,
      85,    74,    75,    76,    77,   137,    71,  5722,    81,   428,
      71,   137,    84,   428,    74,    75,    76,    77,  2574,    80,
     196,    81,   134,   227,    85,  3474,   169,  3476,   115,    89,
      90,  3829,   414,   115,   420,   153,   137,   249,   420,   102,
      74,    75,    76,    77,   463,   137,   102,    81,   463,  2170,
      74,    75,    76,    77,  1786,    87,   249,    81,  1547,   161,
     137,    74,    75,    76,    77,    89,    90,    78,    81,   137,
     278,   235,   102,   137,   198,  1742,    89,    90,   137,   188,
    5941,  5942,   297,   281,  3946,    74,    75,    76,    77,   254,
     134,  3737,    81,    25,  5754,   220,   166,   420,   102,   254,
      89,    90,   254,  1838,  1839,   109,   297,   234,    74,    75,
      76,    77,  4254,   234,   464,    81,   254,   342,  2239,    74,
      75,    76,    77,    89,    90,   171,    81,   155,   155,  1238,
    1865,    74,    75,    76,    77,   404,  2004,   137,    81,   166,
     155,    74,    75,    76,    77,   201,  1407,   155,    81,    74,
      75,    76,    77,   155,   102,  1735,    81,   254,   116,   103,
     102,   109,   196,  1424,   166,   254,  6405,   109,   254,   155,
    3816,   105,  6065,    74,    75,    76,    77,   301,   188,   198,
      81,  1963,    74,    75,    76,    77,   198,  5036,  5037,    81,
    5039,  5040,  5041,   951,   951,    74,    75,    76,    77,   457,
     248,   437,    81,   195,   408,   490,  1516,  6248,    78,   254,
     168,    74,    75,    76,    77,  1520,  5898,   201,    81,    78,
     254,  5811,   346,  1520,   254,   201,    78,    71,    89,    78,
      74,    75,    76,    77,   255,   291,    80,    81,   261,   379,
      78,    85,  2941,  5958,   442,   297,   501,   734,    87,   426,
     188,   363,   340,   254,   254,   437,   155,  1734,    78,  1152,
      87,   201,   581,  1156,  1157,  1158,    71,   166,   587,    74,
      75,    76,    77,  1166,   362,    80,    81,    82,    83,   456,
      85,  1505,  2981,   428,   427,   409,  2985,   245,   524,   116,
     488,   473,   490,    29,  1961,    78,   428,   203,   583,  1966,
    1967,    78,   428,   222,   188,  6544,   322,   291,  1569,    78,
     297,   526,   173,  1713,   583,   291,   456,   784,   785,  2190,
    1698,    74,    75,    76,    77,   583,   153,   428,    81,    78,
     585,   456,   351,   460,   195,   526,   428,  1374,  1375,   460,
     565,   297,  1742,   201,   392,  1925,    70,  6007,   292,   501,
    4212,   428,  4738,  1713,    78,    79,  4738,  2311,  1938,  6338,
     428,   293,  6255,   407,   428,   501,    71,    78,   266,   428,
     583,  6146,   587,   469,   586,    80,  1903,   541,   586,   583,
      85,   490,   106,   107,   734,   583,  4768,  2891,  1968,  1969,
     583,   463,   448,  5467,   581,   531,   572,   484,   585,   524,
    1778,   531,   484,  1930,   469,   583,   501,   546,   531,   420,
     583,   548,   514,  2172,  4913,   986,   501,  1394,   583,  6460,
     469,   535,  1800,  1823,  1744,  1902,  1687,   490,   583,  6188,
     542,   501,   569,   291,   784,   785,   526,  1815,   579,   574,
     575,   586,   442,   586,  3893,   583,   583,  4043,  3004,  3005,
     531,  6312,  5145,  5107,   586,    87,  5149,   574,   575,  5134,
     586,   579,   586,  1823,   468,  6055,   583,   501,   524,   583,
     188,   501,   959,   501,   501,   254,   581,  4650,   574,   575,
     490,  2299,   832,    96,   116,   586,   501,   577,  6381,   586,
     536,   425,  6394,   501,   586,   947,   188,   586,  5025,   501,
     586,  5051,  1722,   105,   520,  4101,  5206,  6389,   581,   586,
     583,   503,   585,   574,   575,   501,   528,  5133,   586,  5135,
     468,   153,   586,   583,  2342,   509,   468,   116,   947,   253,
    2320,   255,   951,  2323,   586,  1022,   951,   537,   572,  1137,
     524,   586,   574,   575,   576,   577,   578,   579,   524,  2216,
     420,   585,   490,   289,  5934,  4936,   174,   549,  1958,   583,
    2227,   420,   583,   586,  1140,  2436,  1966,  1967,   420,  2657,
     583,   420,    98,  6466,  2331,    98,  3078,   947,  3110,   168,
    4527,   104,   420,  4530,   524,   586,  1013,  1013,  1013,  1013,
     448,  1330,  6474,  3861,   583,  3863,  5473,  1009,  1958,   586,
     420,  1068,  1089,  2602,  2386,  6320,   490,  6289,  3113,  2214,
    2428,  1182,  4989,  4990,  4991,  4992,  4993,   583,  3123,  6334,
     526,   234,   541,  2100,   370,   383,   112,  1013,   583,   585,
    4551,  1013,   530,  6526,  1149,  2562,  1151,   420,  1153,  2760,
     583,    25,   260,   420,  1159,  2312,  6254,  4244,  2315,  2316,
     583,   420,  3739,  3740,  3741,     0,   245,    98,   583,  3164,
    4853,  6251,    37,  1280,    39,  2664,   524,   363,  1183,  3171,
    1185,   420,  3642,  3643,  2673,  2094,  2281,  3647,   200,  2094,
    6562,  2127,   583,  4173,  4635,  3755,  2807,  1137,  5537,  1133,
    2811,   583,  1263,  4866,   220,  6470,  6471,   220,  1735,  6581,
    4647,  4297,   400,  6229,   583,  2437,   114,   370,  1280,   420,
    1136,   297,    98,  1134,  3684,  3685,  1066,   102,  1068,   205,
     583,  6436,   501,   163,  6250,  4174,  4175,  3011,    50,   165,
    1151,   575,  1153,  2942,  2236,  2944,  3774,   576,   577,   578,
     579,  2408,  1163,   196,    22,   363,    68,   574,   575,   576,
     577,   578,   579,  5592,  1136,  1137,   256,  5801,  2086,   256,
     452,   526,  1183,  1334,  1185,  2638,  3099,   207,  4910,   574,
     575,  2644,   490,   209,  1126,   174,   298,  2610,  6496,   220,
    1994,  1131,  2622,  6391,  4977,  1135,  3412,   223,  3292,  3791,
    6565,   288,  6382,    71,    98,   548,   195,  1149,   254,  1151,
     104,  1153,   255,  5642,   375,  2540,  2541,  1159,  1160,  1161,
    2572,   429,   536,  4611,  2576,  5656,   569,  5656,   583,   370,
    1270,   190,  2584,   425,   437,   583,  2616,   111,   297,  1126,
     583,  1183,   204,  1185,   220,   437,   235,   439,   584,  2601,
     586,   546,  4768,   297,   190,  1264,  1417,   460,  3353,  1264,
    2763,   135,  1745,   379,  2586,  1748,   379,   198,  1751,  1151,
    1753,  1153,  3418,  1756,   569,   363,  4925,  1760,   276,   574,
     575,   163,  1242,   174,   266,  1240,  1246,  3826,   254,   364,
    1273,  4527,  1242,   342,  4530,   583,  1246,   583,  1238,   254,
    1240,  1183,   163,  1185,   347,   163,   422,  5551,  1280,   422,
    2690,   270,   278,   187,   506,   146,  5599,  3427,   190,   293,
    2171,  5604,  6063,   278,  5607,   207,   220,  6525,   254,  2292,
    5595,   297,   257,   586,   270,  4193,    70,   102,   546,   357,
     456,  4199,   297,   456,    78,    79,   207,  6024,   379,   207,
     526,   381,   278,  3024,   576,   577,   578,   579,    71,   449,
     342,    74,    75,    76,    77,   383,  6564,    80,    81,   260,
     301,   330,    85,  5462,   333,   361,   584,  6078,  6075,   587,
    6057,   346,  5494,    74,    75,    76,    77,   146,  4925,  6023,
      81,   422,   418,   158,   330,  5824,   151,   333,   270,   947,
     490,   232,   167,   379,   254,  2292,   280,   166,  5525,  6073,
     383,  4647,  6095,   529,   389,   346,  1358,  6387,  6388,  2498,
     251,   511,  6056,   256,   266,   456,   102,   357,   278,   418,
     456,   165,   197,    70,    71,  1377,  4294,    74,    75,    76,
      77,    78,    79,    80,    81,   586,   422,   297,    85,  2993,
    2620,   196,  5266,   383,   328,   501,   404,   331,   330,   448,
     422,   333,  5225,   263,   189,   495,  2533,   526,   342,   249,
     230,  1358,   363,   232,    98,   450,   551,   102,   409,  3768,
     456,   530,   526,   526,    25,   379,  1428,   446,   163,   165,
    1377,   225,   251,   581,    35,   138,   126,   585,  1411,   381,
     342,   490,   265,   146,   378,   357,   271,  2859,  1468,  1469,
     446,  1468,  1469,  2670,  2671,  6256,   102,   282,   383,   494,
     381,   496,   536,   381,   166,   450,   572,   246,   422,   242,
     196,   383,   207,   366,   199,   295,   467,   456,   429,   585,
     503,  1428,   456,   532,  5932,   137,   171,   100,   530,   283,
     347,   196,   196,   427,   196,  1632,   281,   546,  6528,   196,
     526,   427,   456,    14,  4891,   583,   491,   398,  4754,   583,
     123,   526,    14,    71,   446,   449,    74,    75,    76,    77,
     569,   344,    80,    81,  2388,   110,   549,    85,   442,   330,
     456,  3460,  6059,  6276,   583,   201,   220,   583,   472,   254,
    2568,   346,   143,   576,  5204,   564,   361,  1609,  5145,   274,
     370,  5894,  5149,   495,   220,   328,  5860,  2585,   331,  5162,
     546,   587,   341,   278,   583,   211,   271,   108,   564,  2597,
    6254,  5663,   587,   433,   495,   583,  2626,   495,   351,   398,
    2757,   437,   297,   273,   424,   478,  1588,   583,   278,  6390,
    2717,  2718,   386,   583,  6395,   546,  5167,  2724,   187,   296,
      70,   255,  5173,  2730,  2731,  2732,  2566,   586,    78,    79,
    2539,   196,   586,  2740,  2741,   318,   526,   266,  2745,  6108,
     356,   318,  5030,  2853,   314,   351,   517,  2582,   530,  4925,
     119,   165,   564,   584,  2581,  2582,   587,   442,  1149,  4885,
    1151,   346,  1153,  2960,   346,   446,   381,  2521,  1159,  6140,
     584,  6140,   188,   478,  1902,  2625,  5960,   442,   583,   344,
    5696,  5965,  5966,  6464,  5696,   256,  2595,   524,  1744,   583,
    5762,   583,  1183,   377,  1185,   209,  1747,   587,  1749,   292,
    4926,  1752,   146,  1754,   242,   587,  1757,  1758,  1759,   223,
     342,   433,   293,   342,   235,   165,   516,  4837,   517,  1770,
      98,  4841,  4842,   488,  4844,   490,  2617,  6391,   947,  2926,
    6149,  6150,  1744,  1784,  2737,  3183,  1787,  2565,  1820,  1721,
    1722,   515,  1724,   459,   475,   476,  6527,   583,   382,   395,
     379,   525,   196,   456,   528,   508,   256,   473,   105,   328,
    1742,  2605,   331,   414,   448,   536,   422,  2980,    84,  2157,
    2157,  1820,  2980,  3209,   224,    91,    92,    93,  5789,   249,
     495,  2739,  6563,  1989,  6253,   363,  6567,   134,   397,  2747,
     260,   260,   462,   422,  1721,  1722,   428,  1724,   350,   175,
     456,  3163,   518,   525,   270,   370,   490,  3255,   278,   525,
    2737,  3961,   102,   351,   258,  1742,   209,  1797,  1830,  2663,
    1820,   574,   575,  2667,   456,  2669,   342,  4083,  2672,   463,
     223,   526,  2079,  2080,  4551,  2082,  1818,   378,  2666,  3468,
    4738,  1853,   220,  4443,  4444,  4445,  4446,  4935,   532,  4449,
    4450,  4451,  4452,  4453,  4454,  4455,  4456,  4457,  4458,  4416,
     200,  6525,   546,  5935,   330,   379,   366,  1358,   439,  5145,
    4768,   321,  5944,  5149,  3109,  1887,   263,  2079,  2080,   255,
    2082,  1372,  1373,   586,   526,   569,  1377,   538,   190,   168,
    1902,   174,   587,     5,   503,  2096,   303,   574,   575,   583,
    6564,   530,   346,   501,   418,  4505,  4506,   351,   422,   128,
    6039,   287,   464,    25,  4582,   456,  3213,   368,  4997,  4587,
    4999,   211,    70,    35,  3221,  6394,   302,  3224,   379,   379,
      78,    79,   198,   504,  3762,   342,   312,  1428,   168,   510,
     549,   583,   456,    70,  3392,  3393,  3394,  3395,   397,  1944,
    1945,    78,    79,  5756,   398,  2622,  3404,   344,   298,   422,
     546,   431,   338,   211,  1944,  1945,   245,   186,   270,   217,
     508,   422,   416,  4105,  3209,   330,  6566,   260,   333,  1961,
     446,  2872,  2873,   569,  1966,  1967,   379,   217,   586,   310,
     368,   437,  4341,   439,  3024,   211,    74,    75,    76,    77,
    6469,   217,   409,    81,   501,  3194,  3195,   572,  3243,  3198,
    5236,  6430,   166,  6603,  5837,  5592,   581,   165,   583,   584,
     585,   586,  5599,  3385,  4586,  6036,   242,  5604,   330,   422,
    5607,   143,   490,  5531,  1961,   301,   574,   575,   501,  1966,
    1967,  3276,  6053,   493,   146,   495,   199,  3439,   426,   427,
     366,   153,   128,   460,   503,  3447,   432,  2106,  2107,  2108,
     506,   379,  2107,  2108,   166,  5642,  4201,  2079,  2080,   196,
    2082,   290,  3464,   517,    70,   572,   224,   251,   456,  5656,
     346,  6092,    78,    79,   405,  3477,   537,   244,   585,   244,
    3482,   446,   249,  3485,   196,  2177,   198,  5951,  3106,  3491,
     549,  3493,   151,  3495,   422,   259,   102,   219,  2157,   357,
     186,  6263,  2157,   199,  5697,  2164,    98,   524,   303,  2164,
     378,   274,   104,   342,  3064,   230,   424,   281,  2177,   378,
    2125,  3066,   278,  6262,  2116,   351,  2118,  2119,   456,  3066,
     259,   357,  5945,   409,   446,  2125,  2347,   211,   501,  5516,
    4280,   501,  5650,   217,  5652,  2137,   258,   342,   315,   439,
     315,  5528,  2144,  2145,   318,   230,   255,  5246,  5247,  2211,
     439,  5833,   501,   321,   378,   488,  3365,  2177,   242,   244,
    3898,   293,   244,   285,   249,   526,  3105,  2187,   274,  3581,
    5416,  2118,  2119,   304,    74,    75,    76,    77,   287,   318,
     211,    81,   359,  3057,   359,  5425,   217,   456,  2749,  5435,
     315,  2752,   525,   302,   290,   369,  3759,  2144,  2145,   346,
    6231,  5448,   572,   312,   351,   444,   506,   305,   257,  2229,
     295,   379,  1820,   586,  2216,   244,  2975,   506,   220,  6389,
     249,  3538,   583,   448,   346,  2227,  5466,  5824,   546,   351,
     315,  1742,   456,   315,   570,   571,   572,   586,   574,   575,
     576,   577,   578,   579,  6087,   583,   342,  5387,  5494,  5389,
    5390,   569,  3770,  5393,   422,   460,   422,  4877,   426,   196,
     426,  3388,   346,  3781,  3203,   490,   198,   351,   586,  2216,
     233,    87,   508,   357,   359,   414,   398,    71,   187,   259,
    2227,   175,   518,  3422,  3204,   370,   315,   303,   456,   363,
     456,    85,  3869,   379,   416,   369,  5592,  5894,   370,    74,
      75,    76,    77,  5599,  6474,   327,    81,   532,  5604,     2,
    2312,  5607,   249,  2315,  2316,   346,   279,  3444,   246,   524,
     494,   414,   496,   432,   414,   493,   357,   495,  2301,  6152,
     359,  2433,   506,  2306,  3273,  6044,   422,   153,   318,  4651,
     426,   250,    84,   517,  6375,    87,  5642,   521,   444,    91,
      92,    93,   230,   285,  3274,   494,   449,   496,   583,   449,
    5656,   255,   437,   548,  2433,  2312,   244,   503,  2315,  2316,
     456,   249,   128,   445,   283,    87,   583,   198,   546,   307,
     546,  3431,   521,  3294,   569,    78,  6535,  5691,   542,  2526,
     324,    84,  6562,   287,   443,   517,    89,   490,  2371,   538,
     490,   450,  2375,   569,   116,   250,  2408,   346,   302,  5655,
     342,  6581,   351,  2433,   346,   490,  5662,   295,   312,   328,
     176,  3431,   331,   116,   508,  5162,  3746,  6458,   249,  4705,
    5167,   516,   586,  5737,   518,   449,  5173,   315,   283,  3489,
    2442,   153,   491,  3760,   338,   538,   202,  6044,   538,   383,
    1961,   351,  2860,  2860,   422,  1966,  1967,  6139,  5178,  2680,
     572,  2408,   542,   512,   285,   426,   159,   406,   224,   363,
     546,   151,   228,   585,   259,   168,   490,    84,   127,  3489,
      87,   359,   254,   546,    91,    92,    93,  2702,   456,  3901,
    6521,  6314,   370,   569,   250,   456,   581,   253,  2106,   584,
     585,   108,   448,   152,   379,   585,   278,   587,  2510,  3859,
     586,  6108,   268,   379,   494,  4697,   496,  3644,   167,   379,
     379,   342,  4260,   586,   459,   346,  2626,   220,  5824,  3656,
     379,  4683,  4270,   318,   543,  2537,   278,   230,   432,   232,
    3947,   521,   327,  6140,   490,   379,  2548,   422,  2550,  2625,
     485,   587,   245,  4703,  2556,  4705,   422,   299,  2560,   493,
     377,  3688,   422,   422,  2635,  4436,  2637,  3974,  4937,  2177,
    2641,   586,  2643,   422,   223,  2646,   351,   586,  3990,  2650,
    3992,  1820,    84,   379,   418,    87,   532,   521,   422,    91,
      92,    93,  4744,  2625,  4465,   351,   456,   456,  5894,  3726,
     546,  5741,  3757,   587,   546,   361,   408,   456,  2610,  2701,
     155,  2613,   546,   546,   548,   589,  2127,  2694,  2694,  2694,
    2694,   166,   456,   569,   366,    84,   422,   120,    87,  2301,
    4098,   448,   526,  3593,  2306,  2465,   438,   583,   516,    74,
      75,    76,    77,  4955,   586,   363,    81,  4029,    40,   583,
     406,   369,   145,   586,  2716,   542,  6253,   116,  2694,   542,
     456,  2491,  2694,  2610,  3642,  3643,  2613,   126,  2770,  3647,
    4395,  3535,     8,   490,   542,    11,    12,  3700,  5209,   427,
     584,  5780,   438,   587,  2686,  2687,    22,    23,    24,  6512,
      26,    27,   299,  3948,   153,    31,    32,    33,   585,  2371,
     587,  2770,   585,  2375,   587,  2216,  3684,  3685,   456,   494,
    3760,   496,   526,  3587,  4485,   532,  2227,   585,   249,   587,
     494,  4133,   496,    84,  2726,  2727,    87,  4139,  4196,   546,
     327,  2733,  2734,   548,  4252,   428,   521,   358,    70,    71,
    2905,   272,   363,  2775,  4318,  4319,  6428,   409,  6044,   346,
    2770,  5268,   569,  3700,   569,   116,  5493,  5274,   249,   366,
    2762,   423,  2862,  3522,  4204,   126,   583,   249,   583,   228,
     463,   293,    74,    75,    76,    77,    70,    16,  5696,    81,
    4035,   272,   548,   400,    78,    79,   100,   546,  4958,   451,
     272,  2860,   153,  6311,  6476,  2860,   344,  6394,   546,    84,
    4943,  2312,    87,   569,  2315,  2316,    91,    92,    93,   123,
     569,  3026,  6108,  3028,   273,   506,  2818,   583,  5992,   278,
    5994,   569,  1459,  4205,  5998,  2433,  6000,   356,   570,   571,
     572,   116,   574,   575,   576,   577,   578,   579,   586,   587,
    1477,   126,    80,  1480,  6140,    70,    71,    85,   538,  4620,
       7,  3798,   188,    78,    79,   314,  3077,  3885,  3886,  3024,
      85,   445,    19,    20,   366,  3915,   581,   228,   153,   111,
     585,   581,  6469,  2942,  6048,  2944,  4193,  2942,   588,  2944,
    3017,    38,  4199,   481,    41,    74,    75,    76,    77,   494,
     586,   496,    81,   135,   590,  2931,    85,  2408,   305,  2931,
     586,    34,  6584,  2905,   590,  3915,   119,   366,  5826,  3011,
    4648,  4649,   273,   143,   144,   578,   351,   278,  4330,  4331,
     583,  4333,   585,  4335,   581,   501,   583,  5547,   585,   119,
    4342,   574,   575,   576,   577,   578,   582,   546,  2177,   548,
     586,   584,  3011,   437,   438,   187,   574,   575,   576,   577,
     578,   586,   587,   314,   582,   106,   107,  6253,  2960,   583,
    5697,   585,   582,   570,   571,   572,   586,   574,   575,   576,
     577,   578,   579,  3194,  3195,  2975,   584,  3198,  2980,   587,
    2982,   324,  2984,   263,  4396,   578,   506,   581,   273,   583,
     583,  3011,   585,   278,    74,    75,    76,    77,   584,   335,
     586,    81,   119,   462,  5280,   366,  3655,   119,  3657,  3658,
     437,   438,   169,  2960,   299,   300,   258,  6263,   213,   214,
     215,   119,  3024,   174,  3888,   347,   348,   344,   584,   314,
     586,  4059,   584,  2980,   586,  2982,   329,  2984,   280,   506,
     383,   734,   586,   587,   195,  4073,   576,   577,   578,   351,
     481,   584,  3154,   586,   344,  4632,   584,   393,   586,   216,
     546,   532,   548,  3200,   349,   583,   583,   585,   570,   571,
     572,   424,   574,   575,   576,   577,   578,   579,   263,  3099,
    3149,   366,  5264,   445,   235,  3154,   328,   327,  3190,   331,
    4407,   494,   584,   496,   586,    89,    90,  4236,  6394,   442,
     342,   462,    74,    75,    76,    77,    89,    90,   567,    81,
     327,   584,  3114,   586,   170,   574,   575,   576,   577,   578,
     579,  3190,  3986,   584,    84,   586,   448,   281,   584,  3149,
     586,   584,    84,   586,  3154,    87,   378,   588,  3240,    91,
      92,    93,   329,  4575,  3365,   584,    71,   586,    70,   494,
     493,   496,    74,    75,    76,    77,    78,    79,  4208,    81,
    4210,  4370,  2770,   584,   116,   586,   272,   584,   490,   586,
    3190,  3240,   506,  6469,   126,   511,   344,   462,   521,   538,
     584,  3201,   586,  3290,  3291,   427,    74,    75,    76,    77,
     584,   162,   586,    81,  2433,  4223,   134,  4225,  4208,   481,
    4210,   153,   584,   546,   586,   548,   567,   449,  4161,  4162,
     532,  3213,   278,   574,   575,   576,   577,   578,   579,  3221,
    3240,   584,  3224,   586,   546,  4545,  4546,  4547,   305,   584,
     472,   586,   584,    84,   586,   584,    87,   586,  3340,  5859,
     583,   589,   584,  4293,   586,   445,  4193,   569,    74,    75,
      76,    77,  4199,   363,   947,    81,   363,   584,   951,   586,
     238,   583,   955,   583,  4704,   116,  3213,   418,   190,  5475,
      85,  3340,   965,   966,  3221,   126,   583,  3224,  3372,   584,
     442,   586,   567,  4293,   977,   570,   571,   572,   263,   574,
     575,   576,   577,   578,   579,   546,   136,   448,   991,   546,
     586,   584,   153,   586,   134,   584,  3443,   586,   238,   538,
      84,  4438,   584,    87,   586,   536,   120,    91,    92,    93,
    3340,   273,   584,  1016,   586,  4675,   278,   301,    74,    75,
      76,    77,   566,   173,   108,    81,  1029,   585,   584,   490,
     586,   584,  6079,   586,   367,  4472,  1039,    84,   270,   584,
      87,   586,   367,   501,    91,    92,    93,   584,   363,   586,
    1053,   584,   314,   586,   583,  4542,  4394,    74,    75,    76,
      77,   108,   363,   584,    81,   586,   584,   228,   586,  1072,
     584,   532,   586,   249,  3386,   536,  1079,   584,   566,   586,
    4517,  1084,  5163,   120,  2905,   546,  3644,  1090,   367,   253,
     240,  1094,  1095,  3011,   584,   566,   586,  4847,   330,   301,
     586,   333,  1105,   584,   366,   586,  4823,   584,   569,   586,
     583,  4738,   273,   384,   584,  1118,  1119,   278,   111,  5200,
     490,   584,   583,  1126,   584,   275,   586,   490,    84,  4350,
    3688,    87,   506,   490,  1137,    91,    92,    93,   584,  2960,
     586,  4768,   135,  2964,   506,  3457,  3458,    74,    75,    76,
      77,   586,   108,   314,    81,  4443,  4444,  4445,  4446,  2980,
     310,  4449,  4450,  4451,  4452,  4453,  4454,  4455,  4456,  4457,
    4458,    74,    75,    76,    77,   134,   490,    84,    81,   538,
      87,  6111,   546,  5097,   548,  4359,   433,   584,  4476,   586,
     584,   584,   586,   586,   187,   584,   346,   586,   297,   584,
     462,   586,   584,  3024,   586,   366,   584,   490,   586,   116,
     490,   584,  3522,   586,   446,   299,   254,  4505,  4506,   126,
    5150,  2770,  5152,  3731,  3732,  3733,  3538,   583,   576,    70,
     380,  3149,  1235,  1236,   587,   589,  3154,    78,    79,  1242,
     584,  1244,   586,  1246,   589,   584,   153,   586,   584,   293,
     586,  3663,   299,   583,   226,   405,  5006,  3669,    99,   501,
     501,  1264,  3820,   584,   584,   586,   586,  1270,   584,  1272,
     586,   584,  3190,   586,   501,   324,   426,  5027,   428,  5001,
     430,  3538,   366,  5005,  3663,   501,   501,   280,   438,   584,
    3669,   586,   584,   584,   586,   586,  5812,   447,   584,   134,
     586,   462,  3644,   111,   293,   567,   456,   299,   570,   571,
     572,   583,   574,   575,   576,   577,   578,   579,   501,   366,
     470,   228,  3240,   584,   165,   586,   584,   550,   586,   479,
     344,   585,   564,  3663,   383,   328,   422,   583,   331,  3669,
     584,   278,   586,   299,   236,   584,  3688,   586,   584,   342,
     586,   585,   583,  5806,   584,   584,   586,   586,   584,   584,
     586,   586,   584,  3705,   586,   584,   273,   586,   278,  1372,
    1373,   278,   584,   584,   586,   586,   584,   583,   586,  3721,
     584,   584,   586,   586,   225,   378,  5013,   236,   363,  5437,
     540,   278,  3213,   442,   584,  3737,   586,   584,   422,   586,
    3221,   363,   584,  3224,   586,   236,   567,   314,  1411,   584,
     366,   586,   422,   574,   575,   576,   577,   578,   579,   584,
     278,   586,  3340,   236,   584,   584,   586,   586,   584,   584,
     586,   586,   363,   584,   427,   586,   584,   278,   586,   584,
     249,   586,   283,  3755,   493,   584,  3758,   586,  3760,   584,
     584,   586,   586,   584,   422,   586,   449,   236,   584,   366,
     586,   584,  3011,   586,   198,  1468,  1469,   584,   584,   586,
     586,   584,   521,   586,  3816,   584,   587,   586,  3820,   472,
     584,  4738,   586,   313,   363,   134,   570,   571,   572,   363,
     574,   575,   576,   577,   578,   579,   526,   546,  1324,   548,
    1326,   329,  1505,  3760,   583,   506,   356,   538,   348,  1512,
     445,  4768,   324,  1516,   249,   305,   249,   584,   583,   146,
    5242,   346,   263,   570,   571,   572,   111,   574,   575,   576,
     577,   578,   579,  1536,   583,   324,   346,   263,   550,  4713,
      81,  4715,   583,   363,   324,   386,   249,   346,  6064,    84,
    1553,   120,    87,   120,   346,   462,    91,    92,    93,   511,
     346,   165,   379,   162,  5286,  5287,  4904,  4905,   538,  6499,
      84,   383,   538,    87,  6504,   249,   111,    91,    92,    93,
     401,  4830,   588,   236,   236,   324,   583,   535,   236,  4877,
     393,   236,   433,   583,   383,   583,   583,   110,   236,   550,
    3149,   236,  1605,   383,   586,  3154,   236,   236,   448,   263,
     236,   236,   249,  4834,   570,   571,   572,   236,   574,   575,
     576,   577,   578,   579,   324,   236,   236,  4006,  4007,  4008,
     442,   236,  4044,   236,   363,   490,   583,   583,   188,   583,
     583,  3190,   111,   313,   383,  5272,   487,  5084,   249,    84,
     490,  1654,    87,   442,  5376,  5377,    91,    92,    93,   249,
     567,   249,   442,   583,   363,  4044,   583,   574,   575,   576,
     577,   578,   579,   189,   515,   583,  4006,  4007,  4008,   249,
     375,   493,   583,   383,   525,   583,   583,   528,   583,   583,
     583,  3240,   532,  5195,   583,  1698,   547,   583,   583,   583,
     583,   583,   583,   442,   493,   583,   546,   583,   583,   521,
    1713,   583,  4159,   493,  4044,   583,   583,  3538,  1721,  1722,
     583,  1724,   238,   583,   583,   297,   583,   583,   111,   569,
     583,  1734,   521,  6249,   546,   178,   548,   297,   586,  1742,
     256,   521,   442,   583,   584,  3663,   249,   587,   586,   313,
     383,  3669,   299,   111,   493,   538,  4287,   546,   263,   548,
     538,   263,   538,   263,   299,   281,   546,   278,   548,   346,
     249,   583,   359,  6359,   249,  1778,   357,   456,   576,   446,
    5502,   293,   521,   195,   333,   299,  4198,   525,   572,  5511,
    5512,  3340,   586,   493,   583,  1798,    14,  1800,   586,   586,
     501,   583,   583,   583,   501,   501,   583,   546,  5530,   548,
     442,   327,  1815,   537,  4513,   501,  1819,  1820,   442,  4198,
    1823,   521,   585,   501,   501,   442,   315,   324,   344,   501,
     501,   366,   572,  1836,   166,  5009,  5010,  5011,   501,  4370,
      84,   236,  4254,    87,   583,   442,   546,   447,   548,  5137,
     501,   324,   366,   363,  5187,   363,   351,  4304,   501,   501,
     525,   383,   493,  1866,   299,   363,   344,  6383,  4198,   363,
     134,   281,   116,   357,   437,  4254,   583,   239,   501,   501,
    4307,  4193,   126,   583,   271,   583,   383,  4199,   166,   379,
     278,   236,   586,   501,  4206,  1898,  1899,  1900,   456,  1902,
     189,   490,   134,   501,   490,   526,   526,   501,   501,   153,
     383,  1914,   134,   335,  4226,   368,   442,   433,   501,  1922,
     493,   501,   501,  5261,  4254,   501,   442,   501,  4274,   383,
    5187,   366,  4274,   449,   404,   501,  4193,  4283,   383,  3760,
     501,  4283,  4199,   459,   501,   442,   501,   501,  5989,  6465,
     501,   118,   118,  4511,   442,  1958,   501,   501,  1961,   501,
     250,  4307,   501,  1966,  1967,  4307,   254,   363,  5417,   442,
     586,   299,  4530,   299,   490,   550,   299,   493,   299,   363,
     299,   363,   363,   299,  5614,   299,   146,   546,   511,   111,
     506,  5621,   501,   324,   236,   511,   493,  4307,   100,   583,
     363,   236,   346,  4315,   361,   196,  5344,   165,   546,   525,
    4322,  4519,  4520,  4521,  4522,  5452,   134,   236,   537,   526,
     493,  5980,   538,  5982,   521,   236,   263,   278,   236,   273,
     363,   346,   357,   346,   278,   570,   571,   572,   321,   574,
     575,   576,   577,   578,   579,   346,   111,   249,   521,   546,
     583,   548,   383,   111,   585,   305,   570,   571,   572,   444,
     574,   575,   576,   577,   578,   579,  4478,   236,   583,  5696,
     314,   110,  4384,   546,   499,   548,   499,   581,  2081,   236,
     581,   501,  2085,  2086,   501,  5777,   583,   236,  4006,  4007,
    4008,   236,   526,   236,   526,  4407,  5636,  2100,   236,  4478,
     236,   346,    14,  2106,  2107,  2108,   586,  5445,   356,   501,
     583,   442,   350,   188,  3663,   254,   346,   254,   146,   584,
    3669,   588,   366,   541,  2127,   583,  4044,    87,   335,   335,
     586,   499,   583,  5855,  5383,   570,   571,   572,   263,   574,
     575,   576,   577,   578,   579,   583,   501,   245,  4478,   254,
    4407,   572,   503,   586,  2157,  6196,  6204,  6205,   586,   271,
     584,  2164,   493,    84,   271,  2168,    87,   485,   263,  4511,
     542,   538,   585,   483,  2177,   295,   460,   586,   364,  5353,
    5354,   586,  5356,   526,  2187,  4527,   303,  2190,  4530,   111,
     521,  2194,    34,   584,   584,   116,    10,   372,   134,  4586,
    4586,  4586,  4586,   442,   584,   126,   583,   303,   501,   526,
     303,  5933,   583,   329,   501,   546,   351,   548,   462,   351,
     501,   506,   445,   249,   305,   351,  2229,   538,   238,   363,
     120,   467,   153,   346,  2237,   238,   313,   583,   212,   313,
    4586,   313,   437,   124,  4586,   501,   361,   493,  5775,  5879,
     586,  2254,   583,   363,   501,  6005,   404,   586,   422,  5547,
     363,   272,   452,  5985,   546,   409,   586,   501,  5556,   249,
    4988,  4988,   501,   111,   586,   299,   305,   526,   364,   403,
    4198,   361,   459,   526,   281,  2288,   572,   546,   263,   278,
     236,   357,   572,   490,    81,   249,   111,   538,   491,  4774,
     459,  6349,   251,   404,   357,   452,   583,   228,  2311,  4621,
     236,   583,   236,   236,   357,   235,   346,   111,   546,   346,
     305,   363,   363,   567,  5657,  4737,  5956,  4739,   269,   269,
     574,   575,   576,   577,   578,   579,  4254,   577,   249,   111,
     566,   566,   333,   305,   452,  6037,   249,   363,   236,   278,
     581,   584,   273,  4732,   550,  4767,    99,   278,  4737,   278,
    4739,  5699,  5989,   584,   584,   278,   261,   584,   584,  2372,
     501,   586,  4193,  4785,   586,   254,  5709,   332,  4199,   583,
     254,  4828,   236,   546,   363,   586,   134,   364,  4767,   356,
     490,   305,   506,   314,   254,   584,   538,   584,  2401,   584,
    5657,   584,  4732,   584,   584,  6446,  4785,  4737,   584,  4739,
     583,   375,   584,  2416,   584,   586,   584,   385,   254,   584,
     566,   583,   501,  2426,   374,   327,  4738,  5864,   583,   583,
    2433,   583,   583,  2436,   543,   568,  2439,  4767,  5708,  5696,
     524,   323,   532,   584,  5709,   366,   586,   363,   134,   543,
    6216,   572,  5709,   583,   363,  4785,  4768,  4006,  4007,  4008,
     587,   572,  4774,   586,  2467,   584,   367,   363,  5905,   281,
     236,   289,   550,   351,  2477,   346,   501,   236,   501,   583,
     586,  4738,  5752,   501,   501,   584,  2489,   236,   368,   447,
     236,   583,   583,   313,   583,  4044,   447,   546,  4910,   447,
     281,   583,  2505,   238,   196,   572,   501,   526,   315,   386,
     586,  4768,   325,   386,   523,  2518,   325,   501,  2521,   501,
     501,   325,  2525,   501,   442,   501,   363,   442,   501,   501,
    2533,  4910,   501,   236,   442,   501,  2539,  4849,   501,   456,
     501,   462,   442,   346,   501,   501,  4858,  4859,   118,  2552,
     583,   266,   299,   584,   501,   299,   501,   501,   299,   299,
    4478,   404,  2565,  2566,   584,  2568,  2569,   249,   511,   120,
     583,  5859,   586,   424,   188,   249,   584,   583,   363,   586,
    4910,   111,  2585,  4925,   584,   236,  4407,   236,   249,   266,
     582,  2594,  2595,   583,  2597,  2598,  5884,   501,   526,   526,
     586,  4858,  4859,   249,  4950,  4917,   367,  2610,  4950,  4988,
    2613,   111,   442,  4988,   442,   442,   234,  5977,   452,   234,
     299,   299,   226,  2626,   583,   501,   299,   299,    84,  5989,
     582,    87,   299,   299,   254,   135,    87,   375,   249,   581,
     537,   254,   370,   364,   543,   583,   567,   586,   254,  4198,
     584,   584,   584,   574,   575,   576,   577,   578,   579,   584,
     116,   263,  5008,  2666,   569,   429,  5008,   531,  6105,   164,
     126,   511,   249,   111,   584,   305,   583,  4989,  4990,  4991,
    4992,  4993,   526,   572,   501,  6122,   584,   187,   188,   583,
    6127,   526,  6129,   586,   586,   586,   196,   153,  5223,   584,
     583,  5013,  6151,   572,   289,  4254,   134,  6429,   236,   493,
     585,   583,  5024,  5887,  2717,  2718,   583,   258,   511,   501,
    2723,  2724,   447,   501,  5898,   501,  2729,  2730,  2731,  2732,
     442,   501,   501,  2736,   442,  2738,  2739,  2740,  2741,  2742,
    2743,   422,  2745,   584,  2747,  2748,     2,   546,  2751,   134,
     249,   584,   584,   532,   583,   238,  5013,   493,   258,   153,
     236,   188,  2765,  2766,  2767,  2768,  2769,  2770,   584,   511,
     299,  2774,   228,   299,   299,  2778,   299,   583,  2781,   303,
     280,  2784,  2785,  2786,  2787,  2788,  2789,  2790,  2791,  2792,
     402,  2794,   284,   583,   501,   550,   363,   586,   417,  2802,
     586,  5276,  2805,  5145,   584,   383,   159,  5149,   493,   586,
    5984,   511,   583,   586,  4732,  6148,   583,   273,   501,  4737,
      84,  4739,   278,  6111,   584,   582,   452,   260,   328,   188,
     501,   331,   254,    89,   299,   254,  6196,   134,   544,   584,
     415,   375,   342,   544,   583,   302,   346,   584,   302,  4767,
     584,  5197,  5198,   586,   584,  5197,  5198,  2860,   314,  2862,
     583,   583,  2865,   373,   584,   492,  5178,  4785,   371,   583,
     267,  5183,   134,   584,   584,   584,   357,   572,   378,   584,
     511,   254,   546,   153,   501,   283,   272,  5266,   351,   351,
     584,  6148,   572,   134,   493,   586,   586,  5209,   501,   146,
     501,   501,   236,   159,   299,   256,   254,   583,   196,   165,
     366,   111,   278,   357,   583,   452,   526,  4738,   263,   526,
     111,  5178,   251,   249,   546,   452,   357,   427,   134,  4478,
     546,   111,   254,   363,   249,   583,  5266,   193,   367,  2942,
     286,  2944,   584,   297,   584,  6119,   254,  4768,   583,   449,
     583,   415,  5209,  4774,   471,   531,   584,   383,   302,   584,
    5272,  2964,   583,   545,  5276,   166,   216,   363,   416,   501,
     111,   236,   472,   249,   474,   583,   585,   111,   478,  2982,
    6340,  2984,   501,  2986,   351,   583,   271,   584,   584,   584,
    2993,   583,  4910,   583,  2997,  2998,  5308,  5309,   326,   583,
     583,  5313,  5314,  3006,  6292,   584,   462,    96,  3011,  3012,
     583,    70,   101,  3016,   583,  5272,   452,   583,   281,    78,
      79,  3024,   402,   583,   188,    84,   221,   541,    87,   111,
     584,   368,    91,    92,    93,   438,   438,   511,   584,  3042,
     501,   572,  3045,   583,   469,   469,   134,   134,   546,   108,
     111,   140,   111,   156,  3057,  6325,   531,   116,  3061,   493,
     271,  3064,   583,   583,   586,   154,   584,   126,   583,   342,
    3073,   583,   249,   584,   583,   493,   526,   203,   583,   363,
     493,   170,   584,   583,  3087,   243,  6446,   583,   235,   583,
     550,   146,   367,   146,   153,   216,  3099,   546,   530,   546,
      84,   583,  3105,  3106,   415,   583,    98,   586,   531,   111,
     583,   567,   104,   456,  3117,   254,   584,   493,   574,   575,
     576,   577,   578,   579,   413,  3128,  6414,   543,   351,   218,
    6400,  6401,   283,   363,   363,   221,   452,   583,   111,   111,
     229,   402,   367,   367,   583,   256,  3149,  3150,   256,   584,
     437,  3154,   134,   201,   501,   524,   452,   437,   371,   151,
      97,   124,   251,   583,   423,   586,   583,   256,   108,   584,
     584,   583,   583,   351,   501,   583,   586,   586,   235,   583,
     254,   156,   402,  4732,   584,  3188,   469,  3190,  4737,   546,
    4739,   469,  5013,  3196,   546,   583,   477,   584,  3201,   583,
    3203,  3204,   256,   384,  3207,   256,   583,  2374,   420,   201,
     584,  6499,   204,  1423,   273,  1469,  6504,   209,  4767,   278,
    3370,   213,   214,   215,  3227,  1967,  3243,  3760,   220,  3166,
    3233,   223,  4041,  3974,  3237,  4737,  4785,  3240,   327,   231,
     299,   300,  4707,  6340,  1468,  6336,  6515,  3250,  4852,  3268,
    5398,  6208,  6194,  6446,  5635,   314,  4902,  5599,   250,  5806,
    3263,  5407,  5604,  5774,  3527,  5607,  3892,  6318,  5656,  6434,
    3273,  3274,  6224,  6223,  6361,  6469,  4951,   366,  3896,  4939,
    6157,  3345,  3345,  4732,  4922,  4007,  1464,  4248,  5784,  5446,
     349,   283,  5823,  3336,  4262,  5793,  6448,  6598,  5767,  6578,
    6022,  4198,  4192,  6373,  5711,  5963,  6167,   366,  5714,  2456,
     369,   195,   401,  5625,  5016,  1779,  5931,  2998,  1801,  4958,
    3868,  2518,  1549,  6079,  2581,  1116,  3329,  3330,  1080,  2697,
    6600,  6601,  2697,  4137,  5746,  4767,  6399,  3340,  2698,  2863,
    6569,  4785,  2194,  2862,  2870,  2076,  3349,  5905,  5266,    84,
     342,  2393,    87,   442,   346,  2395,    91,    92,    93,  2626,
     449,  4910,  2873,   452,  4941,   357,  3369,  5746,  5625,  5638,
    5199,  6310,  1259,   108,  4384,  2687,   368,  4617,  1737,  1993,
    3510,   116,  1938,  3795,  5696,  3388,  2929,   379,  3806,  4554,
    3801,   126,  6302,  6131,  5176,  5151,  2089,  2088,  2928,  2091,
    5134,   490,  4530,   462,  5895,  3408,  2096,  4527,   497,  4618,
    6108,  6107,  6573,  4527,  6418,   504,  5746,  6502,   153,  6292,
     412,  5862,   511,  4480,  3427,  5623,  6305,  6285,  3431,  3705,
     422,  6306,  2799,   425,   426,  3615,  5782,  3586,  5750,  5696,
    5782,  3444,  3703,   734,  2802,  4304,  3432,  2964,  2512,   538,
    6274,  5272,  1613,  2108,  2939,  5276,  2102,  1797,   429,  3754,
    1128,  2973,  4624,  2972,   456,  1395,  5177,  2980,  4625,  1375,
    1941,  4581,  2106,   462,  3523,  5821,  2984,  2655,   734,  5821,
       2,  5636,    -1,    -1,    -1,    -1,  3489,   136,    -1,  1375,
      -1,    -1,  1162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1721,   567,   501,
      -1,   570,   571,   572,    -1,   574,   575,   576,   577,   578,
     579,    -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,   273,  5851,
      -1,  3544,    -1,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5894,    -1,    -1,   204,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5905,   299,   300,  3569,    -1,  3571,    -1,
      -1,    -1,  5951,    -1,    -1,    -1,  3579,    -1,    -1,   314,
      -1,    -1,    -1,  3586,  3587,    -1,    -1,  3590,    -1,    -1,
    3593,   240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3614,    -1,    -1,   349,    -1,  3619,    -1,    -1,    -1,
      -1,  5951,    -1,    -1,    -1,    -1,   275,    -1,    -1,    -1,
      -1,   366,    -1,    -1,   369,    -1,    -1,    -1,    -1,  3642,
    3643,  3644,    -1,    -1,  3647,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3655,  3656,  3657,  3658,    -1,    -1,    -1,    -1,
    3663,   310,    -1,  5975,  5976,  3668,  3669,    -1,  3671,    -1,
    3673,    -1,    -1,    -1,    -1,    -1,    -1,  5989,    -1,    -1,
      -1,  3684,  3685,    -1,    -1,  3688,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,    -1,  3702,
      -1,  3704,  6044,  3706,    -1,    -1,    -1,    -1,  6054,    -1,
      -1,    -1,  6054,    -1,    -1,    -1,    -1,  5266,  5975,  5976,
      -1,    -1,    -1,  3726,    -1,    -1,    -1,   462,    -1,    -1,
     379,   380,  5989,    -1,  3737,    -1,  3739,  3740,  3741,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1010,    -1,   405,  3760,    -1,    -1,
      -1,  3764,  1018,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,    -1,    -1,    -1,   426,  6090,    -1,
      -1,   430,  6194,  6095,    -1,    -1,    -1,    -1,    -1,   438,
      -1,  6137,  3795,    -1,    -1,  6137,    -1,  3800,   447,    -1,
      -1,    -1,    -1,  3806,    -1,    -1,    -1,   456,    -1,    -1,
      -1,    -1,    -1,  3816,    -1,  6194,    -1,    -1,    -1,    -1,
      -1,   470,    -1,  1079,  1080,    -1,    -1,    -1,  5746,    -1,
     479,    -1,   567,    -1,    -1,   570,   571,   572,    -1,   574,
     575,   576,   577,   578,   579,    -1,    -1,    -1,    -1,    -1,
      -1,   586,    -1,    -1,    -1,  3858,    -1,    -1,  3861,    -1,
    3863,    -1,    -1,    -1,  6194,  3868,    -1,    -1,    -1,    -1,
    1126,    -1,    -1,    -1,  6186,  5696,    -1,    -1,    -1,    -1,
      -1,  6293,  3885,  3886,    -1,    -1,    -1,    -1,  3891,    -1,
      -1,   540,    -1,    84,    -1,    89,    87,    -1,    -1,    -1,
      91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,  3912,
      -1,   955,  3915,    -1,  6293,    -1,  3919,   108,    -1,    -1,
    6478,   965,    -1,    -1,    -1,   116,    -1,    -1,   189,    -1,
      -1,    -1,    -1,  3936,    -1,   126,    -1,  1193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3961,    -1,
      -1,    -1,   153,  6293,  6276,    -1,    -1,    -1,    -1,    -1,
      -1,  1227,  1016,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,  1239,    -1,    -1,    -1,  1243,  1244,  1245,
      -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4006,  4007,  4008,    -1,    -1,    -1,    -1,
      -1,    -1,  6399,  6399,  6399,  6399,    -1,    -1,    -1,    -1,
     281,    -1,    -1,    -1,  6336,    -1,  6338,    -1,  6374,    -1,
    4033,    -1,  6374,  5951,    -1,    -1,    -1,    -1,    -1,    -1,
    1084,  4044,    -1,    -1,    -1,    -1,  4049,    -1,  4051,    -1,
    1094,    -1,    -1,  6399,    -1,    -1,  4059,  6399,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,
    4073,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6336,
      -1,  6338,   273,   344,    -1,    -1,    -1,   278,    -1,    -1,
      -1,  6478,  6478,  6478,  6478,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,   300,
      -1,    -1,  6524,    -1,    -1,    -1,  1372,  1373,    -1,    -1,
      -1,  1377,    -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4134,  6478,    -1,    -1,    84,  6478,    -1,    87,    -1,
      -1,    -1,    91,    92,    93,  6524,    -1,    -1,    -1,    -1,
      -1,  4154,    -1,    -1,  5975,  5976,    -1,    -1,   349,   108,
      -1,    -1,    -1,    -1,    -1,  4168,  6578,   116,  5989,    -1,
      -1,    -1,   433,    -1,    -1,   366,    -1,   126,   369,    -1,
      -1,   442,  6569,  6569,  6569,  6569,  6598,    -1,   449,  4192,
    4193,    -1,    -1,    -1,  6524,  4198,  4199,  5746,   459,  6578,
      -1,    -1,    -1,  6515,   153,  4208,    -1,  4210,    -1,    -1,
      -1,    -1,  6524,    -1,    -1,    -1,    -1,    -1,    -1,  6598,
    4223,    -1,  4225,  6569,    -1,    -1,    -1,  6569,    -1,   490,
      -1,    -1,   493,    -1,  4237,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   506,    -1,    -1,  6578,    -1,
     511,  4254,    -1,    -1,    -1,    -1,    -1,    -1,  6515,    -1,
      -1,    -1,    -1,    -1,   525,    -1,  6578,  6524,  6598,  6090,
      -1,   462,    -1,    -1,    -1,  4278,  6194,   538,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6598,    -1,    -1,    -1,
    4293,  4294,    -1,    -1,    -1,    -1,    -1,    -1,  6610,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4309,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6578,    -1,    -1,   273,    -1,    -1,    -1,    -1,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4341,    -1,
      -1,  6598,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     299,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4363,    -1,    -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6293,   567,    -1,    -1,   570,
     571,   572,    -1,   574,   575,   576,   577,   578,   579,    -1,
      -1,  4394,    -1,    -1,  4397,   586,    -1,    -1,    -1,    -1,
     349,    -1,  5951,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4418,    -1,   366,  4421,    -1,
     369,    -1,    -1,    -1,  4427,    -1,    -1,    -1,    -1,    -1,
    4433,    -1,  4435,    -1,    -1,  4438,    -1,    -1,    -1,  4442,
    4443,  4444,  4445,  4446,   189,    -1,  4449,  4450,  4451,  4452,
    4453,  4454,  4455,  4456,  4457,  4458,    -1,  1713,    -1,  4462,
    4463,  1505,    -1,    -1,  4467,  1721,  1722,    -1,  1724,  4472,
      -1,    -1,  1516,  4476,    -1,  4478,    -1,  4480,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4488,  1742,    -1,  4491,    -1,
    4493,    -1,    -1,   238,    -1,    -1,    -1,    -1,  4501,  4502,
      -1,    -1,  4505,  4506,    -1,    -1,    -1,  4510,  4511,    -1,
      -1,   256,    -1,   462,  4517,  6336,    -1,  6338,    -1,    -1,
      -1,    -1,    -1,    -1,  4527,    -1,    -1,  4530,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   281,  1793,    -1,    -1,
    4543,    -1,    -1,    -1,    -1,    -1,  4549,  4550,  4551,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1605,    -1,    -1,    -1,    -1,    -1,  1823,    -1,    84,
      -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,    -1,
      -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,   344,
    4603,   116,    -1,    -1,    -1,    -1,  6524,    -1,    -1,    -1,
      -1,   126,    -1,    -1,    -1,    -1,  4619,    -1,   567,    -1,
      -1,   570,   571,   572,    -1,   574,   575,   576,   577,   578,
     579,    -1,  4635,    -1,    -1,   584,    -1,    -1,   153,    -1,
      -1,    -1,    -1,    -1,  4647,  6194,    -1,    -1,  1904,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1913,   101,    -1,
    6578,    84,    -1,    -1,    87,    -1,    -1,    -1,    91,    92,
      93,  1927,    -1,    -1,    -1,  4678,    -1,    -1,    -1,    -1,
    6598,    -1,    -1,    -1,    -1,   108,    -1,    -1,   433,    -1,
      -1,    -1,    -1,   116,  6515,    -1,    -1,   442,    -1,    -1,
      -1,    -1,  1958,   126,   449,  1961,  1962,    -1,    -1,    -1,
    1966,  1967,   155,    -1,    -1,    -1,    -1,    -1,    -1,  1090,
      -1,    -1,    -1,    -1,    -1,   226,    -1,    -1,    -1,  4732,
     153,    -1,    -1,    -1,  4737,  4738,  4739,  4740,    -1,    -1,
      -1,    -1,    -1,   488,  6293,   490,   189,  1118,   493,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,
      -1,   506,    -1,   278,  4767,  4768,   511,    -1,    -1,    -1,
      -1,    -1,   966,    -1,    -1,   218,    -1,    -1,    -1,    -1,
     525,    -1,  4785,   977,   299,   300,   229,    -1,    -1,    -1,
      -1,    -1,    -1,   538,    -1,    -1,    -1,   991,  4801,   314,
      -1,  4804,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4830,    -1,    -1,
      -1,    -1,    -1,    -1,   349,  1029,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1039,    -1,    -1,    -1,    -1,
     273,   366,    -1,    -1,   369,   278,    -1,    -1,    -1,  1053,
      -1,    -1,    -1,   306,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2127,    -1,    -1,  4877,    -1,   299,   300,    -1,    -1,
      -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,   111,
      -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4904,  4905,    -1,    -1,    -1,    -1,  4910,  4911,    -1,
      -1,    -1,    -1,    -1,   136,  4918,    -1,    -1,    -1,    -1,
      84,    -1,  4925,    87,    -1,    -1,   349,    91,    92,    93,
      -1,    -1,    -1,    -1,  4937,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   366,   108,    -1,   369,   462,    -1,    -1,
      -1,   173,   116,    -1,    -1,  4958,  4959,  4960,   401,    -1,
      -1,   404,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6524,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4988,    -1,    -1,    -1,   153,
     433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   442,
      -1,    -1,    -1,    -1,    -1,    -1,   449,    -1,    -1,    -1,
      -1,    -1,    -1,  5016,    -1,    -1,   111,    -1,   240,    -1,
      -1,    -1,   465,    -1,    -1,    -1,    -1,    -1,    -1,  6578,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   481,   462,
    5043,   136,    -1,    -1,    -1,    -1,    -1,   490,    -1,  6598,
     493,  5054,   567,   275,    -1,   570,   571,   572,    -1,   574,
     575,   576,   577,   578,   579,    -1,    -1,    -1,   511,   584,
      -1,    -1,    -1,  2329,    -1,    -1,    -1,    -1,   173,    -1,
    2336,  5084,    -1,   305,    -1,    -1,    -1,    -1,   310,    -1,
      -1,  5094,  5095,    -1,  5097,   538,    -1,    -1,  5101,  5102,
      -1,    -1,    -1,  5106,  5107,    -1,    -1,    -1,  5111,   273,
      -1,  5114,  5115,    -1,   278,    -1,  5119,    -1,    -1,    -1,
      -1,    -1,  5125,    -1,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5137,   299,   300,    -1,    -1,    -1,
      -1,  1512,  5145,    -1,   567,   240,  5149,   570,   571,   572,
     314,   574,   575,   576,   577,   578,   579,    -1,   380,  5162,
      -1,   584,    -1,    -1,  5167,  1536,    -1,    -1,    -1,    -1,
    5173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1372,  1373,
     275,    -1,  1553,   405,    -1,   349,    -1,    -1,    -1,    -1,
      -1,    -1,  5195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   366,    -1,   426,   369,  5209,    -1,   430,    -1,
     305,    -1,    -1,    -1,  2470,   310,   438,    -1,    -1,    -1,
    2476,    -1,    -1,  5226,    -1,   447,    -1,    -1,    84,    -1,
      -1,    87,    -1,    -1,   456,    91,    92,    93,    -1,    -1,
      -1,  5244,    -1,    -1,    -1,    -1,    -1,    -1,   470,    -1,
      -1,   346,   108,    -1,    -1,    -1,    -1,   479,  5261,    -1,
     116,    -1,    -1,  5266,    -1,    -1,    -1,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5282,
      -1,    -1,   504,    -1,    78,   380,    -1,    -1,    -1,    -1,
      84,    -1,    -1,    -1,    -1,    89,    -1,   153,   462,    -1,
      -1,    -1,  5305,    -1,    -1,    -1,    -1,  5310,    84,    -1,
     405,    87,    -1,    -1,  5317,    91,    92,    93,   540,    -1,
      -1,    -1,   116,   545,   546,    -1,    -1,    -1,    -1,    -1,
    5333,   426,   108,    -1,    -1,   430,    -1,    -1,    -1,    -1,
     116,  5344,    -1,   438,    -1,    -1,    -1,    -1,    -1,    -1,
     126,    -1,   447,    -1,  2610,    -1,    -1,  2613,    -1,    -1,
      -1,   456,  2618,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5375,    -1,   168,   470,    -1,   153,    -1,    -1,
    5383,    -1,    -1,    -1,   479,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5405,   567,    -1,    -1,   570,   571,   572,   504,
     574,   575,   576,   577,   578,   579,  5419,   273,    -1,    -1,
     584,    -1,   278,    -1,    -1,    -1,    -1,  1798,    -1,    -1,
    2686,  2687,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5445,   299,   300,   540,    -1,    -1,    -1,  5452,
     545,   245,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   968,    -1,    -1,
      -1,    -1,    -1,  2729,  2518,    -1,    -1,  2521,    -1,   980,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5493,   992,  5495,   349,    -1,    -1,    -1,   273,    -1,    -1,
      -1,    -1,   278,    -1,    -1,    -1,    -1,  1008,    -1,    -1,
     366,    -1,    -1,  1014,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2565,  2566,   299,   300,    -1,    -1,    -1,  5531,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,
      -1,    -1,    -1,    -1,  5547,    -1,    -1,    -1,  5551,    -1,
      -1,    -1,    -1,  5556,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5573,  5574,    -1,   349,  5577,    -1,    -1,    -1,    -1,    -1,
    2836,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5592,
     366,    -1,    -1,   369,    -1,    -1,  5599,    -1,    -1,    -1,
      -1,  5604,    -1,    -1,  5607,  5608,   462,    -1,    -1,    -1,
      -1,    -1,  5615,  5616,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   428,    -1,    -1,    -1,    -1,  5642,
      -1,  5644,    -1,    -1,    -1,    -1,    -1,  5650,    -1,  5652,
      -1,    -1,    -1,  5656,    -1,    -1,    84,    -1,    -1,    87,
      -1,    -1,    -1,    91,    92,    93,    -1,    -1,    -1,   463,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     108,    -1,    -1,    -1,    -1,    -1,   462,    -1,   116,    -1,
      -1,    -1,    -1,  5696,  5697,    -1,  5699,    -1,   126,    -1,
      -1,    -1,  1203,    -1,    -1,  5708,    -1,    -1,  2964,    -1,
      -1,   567,    -1,    -1,   570,   571,   572,    -1,   574,   575,
     576,   577,   578,   579,  2980,   153,  2982,    -1,  2984,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1241,    -1,    -1,  5746,    -1,    -1,    -1,    -1,    -1,  5752,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1260,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3024,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   567,    -1,    -1,   570,   571,   572,    -1,   574,   575,
     576,   577,   578,   579,    -1,    -1,  5809,    -1,   584,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5824,    -1,  5826,    -1,   230,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3094,   244,
      -1,    -1,    -1,    -1,   249,   273,    -1,    -1,    -1,   254,
     278,    -1,    -1,    -1,    -1,   260,  5859,  5860,   263,  5862,
      -1,  5864,   267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   299,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5884,    -1,    -1,    -1,    -1,   314,  5890,    -1,    -1,
     295,  5894,    -1,    -1,    -1,    -1,    -1,  5900,    -1,    -1,
      -1,    -1,  5905,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,    -1,    -1,    -1,  2288,    -1,    -1,
      -1,   349,    -1,  3179,    -1,    -1,    -1,    -1,  1429,    -1,
      -1,    -1,    -1,  2127,    -1,    -1,    -1,    -1,   366,    -1,
      -1,   369,    -1,    -1,    -1,    -1,    -1,    -1,  5951,    -1,
      -1,    -1,    -1,    -1,   359,    -1,    -1,  5960,   363,    -1,
      -1,    -1,  5965,  5966,    -1,   370,    -1,  5970,    -1,    84,
      -1,    -1,    87,    -1,  5977,    -1,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5989,    -1,    -1,    -1,
      -1,    -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3266,   126,    -1,  3057,    -1,    -1,    -1,    -1,  6021,    -1,
    3064,    -1,    -1,    -1,   429,    -1,    -1,    -1,    -1,    -1,
    2401,    -1,    -1,    -1,   462,    -1,    -1,    -1,   153,    -1,
      -1,  6044,    -1,  3299,    -1,  2416,  3302,    -1,  3304,    -1,
      -1,    -1,  3308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3317,  3318,  3319,  1565,    -1,    -1,    -1,  2439,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6079,  6080,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   490,    -1,  6090,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1599,  1600,
    1601,  3357,  6105,    -1,    -1,  6108,    -1,    -1,  6111,    -1,
      -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6122,
      -1,    -1,    -1,    -1,  6127,    -1,  6129,    -1,  6131,    -1,
      -1,    -1,    -1,    -1,  2505,  3391,    -1,  6140,   543,   567,
     545,   546,   570,   571,   572,    -1,   574,   575,   576,   577,
     578,   579,    -1,   947,  2525,  6158,   584,   951,   273,    -1,
      -1,    -1,    -1,   278,    -1,    -1,    -1,  3423,  2539,    -1,
      -1,   965,   966,    -1,    -1,  3431,   581,    -1,  2372,   584,
     585,  2552,   587,   977,   299,   300,    -1,    -1,    -1,    -1,
      -1,  6194,    -1,  6196,    -1,    -1,    -1,   991,    -1,   314,
      -1,    -1,  3458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2594,  2595,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3489,   349,  1029,    -1,    -1,    -1,    -1,
      -1,    -1,  6245,    -1,    -1,  1039,    -1,    -1,    -1,    -1,
    6253,   366,    -1,    -1,   369,    -1,    -1,    -1,    -1,  1053,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2467,    -1,    -1,  1777,    -1,    -1,    -1,
      -1,  6284,  6285,  2477,    -1,  1079,    -1,    -1,    -1,  6292,
    6293,    -1,    -1,  6296,    -1,  2489,    -1,    -1,    -1,  6302,
    1094,  1095,    -1,    -1,    -1,    -1,    -1,    -1,  6311,    -1,
      -1,  1105,    -1,  1814,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6325,    -1,    -1,  1119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6340,    -1,    -1,
      -1,    -1,    -1,  1137,    -1,    -1,    84,   462,    -1,    87,
      -1,    -1,    -1,    91,    92,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     108,    -1,    -1,    -1,    -1,  2569,  6379,    -1,   116,    -1,
      -1,  6384,    -1,    -1,    -1,    -1,    -1,    -1,   126,   101,
      -1,  6394,    -1,    -1,  2765,    -1,    -1,  6400,  6401,    -1,
      -1,    -1,  6405,    -1,  2598,    -1,    -1,    -1,    -1,    -1,
      -1,  6414,    -1,    -1,    -1,   153,    -1,  6420,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6431,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,   154,  6446,    -1,    -1,    -1,    -1,    -1,    -1,
    1244,    -1,   567,    -1,    -1,   570,   571,   572,   170,   574,
     575,   576,   577,   578,   579,    -1,  6469,    -1,    -1,   584,
    1264,    -1,  1973,    -1,    -1,    -1,    -1,   189,    -1,    -1,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6499,    -1,    -1,  6502,
      -1,  6504,    -1,    -1,  3760,    -1,   218,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,
      -1,  6524,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,   251,
     278,  6544,    -1,  3587,   256,    -1,    78,  6550,    -1,  3593,
      -1,   263,    84,   265,    -1,    -1,    -1,    89,    -1,    -1,
      -1,   299,   300,  6566,    -1,    -1,    -1,    -1,    -1,   281,
      -1,    -1,    -1,  6576,    -1,  6578,   314,    -1,  1372,  1373,
      -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   306,  6598,  2097,  6600,  6601,    -1,
    6603,    84,    -1,    -1,    87,    -1,    -1,    -1,    91,    92,
      93,   349,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   108,    -1,    -1,   366,    -1,
      -1,   369,   344,   116,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   365,   366,    -1,    -1,    -1,    -1,  3915,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   390,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,   401,
    3061,    -1,   404,  3737,    -1,    -1,    -1,    -1,   230,    -1,
     232,    -1,  3073,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   433,  1516,    -1,   462,    -1,    -1,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,    -1,    -1,   449,    -1,    -1,
     452,    -1,    -1,  2244,    -1,    -1,  3117,    -1,    -1,    -1,
      -1,    -1,    -1,   465,    -1,    -1,  4012,    -1,  2259,    -1,
      -1,    -1,   474,    -1,    -1,    -1,    -1,    -1,    -1,   481,
    2964,    -1,  3816,    -1,    -1,    -1,   488,    -1,   490,    -1,
      -1,   493,    -1,    -1,    -1,   497,    -1,    -1,    -1,    -1,
     273,    -1,  2986,  2294,   506,   278,    -1,    -1,    -1,   511,
      -1,    -1,    -1,    -1,    -1,    -1,  2307,    -1,    -1,  2310,
      -1,    -1,  3006,   525,    -1,  4071,   299,   300,  3012,    -1,
      -1,    -1,  3016,    -1,    -1,    -1,   538,    -1,    -1,   567,
      -1,   314,   570,   571,   572,    -1,   574,   575,   576,   577,
     578,   579,    -1,    -1,    -1,    -1,   584,    -1,  3042,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2362,    -1,    -1,    -1,    -1,   349,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2376,    -1,    -1,    -1,    -1,
    4136,    -1,    -1,   366,    -1,    -1,   369,    -1,    -1,    -1,
      -1,    -1,    -1,  3087,    -1,    -1,   428,  2398,    -1,    -1,
      -1,    -1,    -1,    -1,  1698,    -1,    -1,    -1,    -1,    -1,
      -1,  3105,    -1,    -1,    -1,    -1,    -1,  4173,    -1,  1713,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4186,   463,    -1,    -1,    -1,    -1,    -1,  4193,    -1,    -1,
      -1,    -1,    -1,  4199,    -1,    -1,    -1,    -1,  1742,    -1,
      -1,    -1,  4208,    -1,  4210,    -1,  3150,    -1,    -1,  3330,
    2461,    84,    -1,    -1,    87,    -1,    -1,    -1,    91,    92,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   462,
      -1,    -1,    -1,    -1,  1778,   108,    -1,    -1,    -1,    -1,
      -1,  2492,    -1,   116,  3188,    -1,    -1,    -1,  2499,    -1,
      -1,    -1,  3196,   126,    -1,    -1,  1800,  4263,    84,  3203,
      -1,    87,    -1,  3207,    -1,    91,    92,    93,    -1,    -1,
      -1,  1815,    -1,    -1,    -1,    -1,  1820,    -1,    -1,  1823,
     153,    -1,   108,  3227,    -1,    -1,  4292,  4293,    -1,  3233,
     116,    -1,    -1,  3237,    -1,    -1,    -1,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,  3250,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,  4322,    -1,    -1,  3263,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,    -1,  3273,
      -1,    -1,    -1,    -1,   567,    -1,    -1,   570,   571,   572,
      -1,   574,   575,   576,   577,   578,   579,    -1,    -1,    -1,
      -1,   584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,    -1,
      -1,    -1,  2623,    -1,    -1,    -1,    -1,    -1,  4384,    -1,
     244,    -1,    -1,    -1,    -1,   249,    84,    -1,    -1,    87,
     254,    -1,    -1,    91,    92,    93,   260,    -1,    -1,   263,
     273,    -1,    -1,   267,    -1,   278,    -1,    -1,    -1,    -1,
     108,    -1,    -1,    -1,  1958,    -1,    -1,    -1,   116,  2670,
    2671,    -1,  1966,  1967,    -1,    -1,   299,   300,   126,    -1,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   314,    -1,    -1,    -1,  2696,    -1,   273,  3569,    -1,
      -1,   315,   278,    -1,    -1,   153,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3590,
      -1,    -1,    -1,   299,   300,    -1,   349,    -1,    -1,    -1,
      -1,  4487,    -1,  3604,    -1,    -1,    -1,    -1,   314,    -1,
      -1,    -1,    -1,   366,    -1,   359,   369,    -1,    -1,   363,
      -1,    -1,    -1,    -1,    -1,    -1,   370,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   349,    84,    -1,    -1,    87,    -1,    -1,
      -1,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,
     366,    -1,    -1,   369,    -1,    -1,    -1,    -1,    -1,    -1,
    2801,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,  2106,  2107,  2108,   429,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,  2827,    -1,    -1,    84,
     278,    -1,    87,  2127,    -1,    -1,    91,    92,    93,   462,
      -1,    -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,
    3544,   299,   300,   108,    -1,    -1,    -1,    -1,    -1,    -1,
    2861,   116,  2863,  2157,    -1,    -1,   314,    -1,  2869,    -1,
    2164,   126,    -1,    -1,    -1,    -1,   490,  3571,    -1,    -1,
      -1,    -1,    -1,  2177,    -1,  3579,   462,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,    -1,
      -1,   349,   516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   947,    -1,    -1,   366,   951,
      -1,   369,    -1,    -1,    -1,  2926,    -1,    -1,    -1,   543,
      -1,   545,   546,    -1,   966,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   567,   977,    -1,   570,   571,   572,
      -1,   574,   575,   576,   577,   578,   579,    -1,    -1,   991,
      -1,   584,    -1,   273,    -1,    -1,    -1,   581,   278,    -1,
     584,   585,    -1,   587,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4738,  4527,    -1,    -1,  4530,    -1,    -1,   299,
     300,   567,    -1,    -1,   570,   571,   572,  1029,   574,   575,
     576,   577,   578,   579,   314,    -1,    -1,  1039,   584,    -1,
      -1,    -1,  4768,    -1,   462,    -1,    -1,    -1,   273,  4775,
      -1,  1053,  4778,   278,  4780,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   349,
      -1,    -1,    -1,    -1,   299,   300,    -1,  1079,  3919,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   366,    -1,    -1,   314,
      -1,    -1,    -1,  1095,    -1,  3936,  4822,    -1,    -1,    -1,
      -1,    -1,    -1,  1105,    -1,    -1,    -1,    -1,  2372,    -1,
      -1,  4837,    -1,    -1,    -1,  4841,  4842,  1119,  4844,    -1,
      -1,    -1,    -1,    -1,   349,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4647,    -1,  1137,    -1,    -1,    -1,    -1,
      -1,   366,    -1,    -1,   369,    -1,    -1,    -1,    -1,   567,
    3121,    -1,   570,   571,   572,    -1,   574,   575,   576,   577,
     578,   579,    -1,    -1,    -1,    -1,   584,    -1,    -1,  2433,
      -1,  3142,    -1,    -1,    -1,  3146,    -1,    -1,    -1,    -1,
      -1,    -1,   462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3169,    -1,
      -1,    -1,    -1,  2467,    -1,    -1,    -1,    -1,  4049,    -1,
    4051,    -1,    -1,  2477,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2489,  4740,    -1,  4954,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   462,    -1,    -1,
    1242,    -1,  1244,    -1,  1246,    -1,    -1,    -1,  3912,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1264,  4989,  4990,  4991,  4992,  4993,    -1,    -1,
      -1,    -1,    -1,  3244,  3245,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   567,    -1,    -1,
     570,   571,   572,  4134,   574,   575,   576,   577,   578,   579,
      -1,  2565,  2566,    -1,  2568,  2569,    -1,    -1,    -1,  5035,
    5036,  5037,    -1,  5039,  5040,  5041,    -1,    -1,    -1,    -1,
      -1,  2585,    -1,    -1,    -1,    -1,    -1,  4168,    -1,    -1,
      -1,    -1,    -1,  2597,  2598,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   567,    -1,    -1,   570,   571,   572,    -1,   574,
     575,   576,   577,   578,   579,    -1,    -1,    -1,    -1,   584,
      98,    -1,  2626,    -1,    -1,    -1,   104,    -1,    -1,  4033,
    1372,  1373,    -1,    84,    -1,    -1,    87,    -1,    -1,    -1,
      91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3362,    -1,    -1,    -1,    -1,    -1,   108,    -1,    -1,
      -1,    -1,  2666,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,  4925,    -1,   151,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4278,    -1,    -1,
      -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,  5175,
      -1,    -1,  5178,  5179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   201,    -1,    -1,  1468,  1469,  4309,    -1,
    1090,   209,    -1,    -1,    -1,   213,   214,   215,    -1,     5,
      -1,    -1,   220,  5209,    -1,   223,    -1,    -1,    -1,    -1,
    4154,    -1,    -1,   231,    -1,    -1,    -1,    -1,  1118,    25,
      -1,    -1,    -1,    -1,    -1,    -1,  2770,    -1,    -1,    35,
      36,    -1,   250,    -1,    40,    -1,    42,    43,    -1,    -1,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,   283,    72,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    -1,    -1,    -1,    85,
      -1,    -1,   273,    -1,    -1,    -1,    -1,   278,    -1,  5295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,   300,
      -1,    -1,    -1,    -1,    -1,    -1,  2860,    -1,    -1,    -1,
      -1,  4442,  3573,   314,   342,    -1,    -1,    -1,   346,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   143,    -1,   357,
      -1,    -1,    -1,    -1,    -1,    -1,  4467,    -1,    -1,    -1,
     368,  5145,    -1,    -1,    -1,  5149,    -1,    -1,   349,    -1,
      -1,   379,    -1,    -1,    -1,    -1,    -1,  5373,  5374,    -1,
      -1,    -1,    -1,    -1,    -1,   366,    -1,    -1,   369,    -1,
    4501,  5387,    -1,  5389,  5390,    -1,    -1,  5393,    -1,    -1,
      -1,    -1,  5398,    -1,   412,    -1,    -1,  4341,  2942,    -1,
    2944,    -1,    -1,    -1,   422,    -1,    -1,   425,   426,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1698,    -1,    -1,  4363,
    2964,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1713,    -1,    -1,    -1,    -1,    -1,    -1,   456,    -1,
      -1,   247,  2986,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5458,  4397,    -1,    -1,    -1,    -1,    -1,    -1,
    1742,    -1,  3006,    -1,   270,    -1,    -1,  3011,  3012,    -1,
      -1,   462,  3016,    -1,    -1,    -1,    -1,    -1,    -1,  3730,
    3024,    -1,    -1,   501,    -1,    -1,  5492,   293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1778,    -1,  3042,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   529,    -1,    -1,    -1,    -1,    -1,    -1,  1800,    -1,
    3064,    -1,    -1,    -1,   330,    -1,    -1,   333,    -1,    -1,
      -1,  5537,    -1,  1815,    -1,    -1,    -1,    -1,  1820,    -1,
      -1,  1823,    -1,  3087,    -1,   351,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3105,  3106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   567,    -1,    -1,   570,
     571,   572,    -1,   574,   575,   576,   577,   578,   579,    -1,
      -1,    -1,    -1,   584,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3149,  3150,    -1,    -1,    -1,
    3154,    -1,  1512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,  1536,    -1,    -1,    -1,
     446,    -1,    -1,    -1,  3188,    -1,  3190,    -1,    -1,    -1,
      -1,    -1,  3196,  1553,    -1,    -1,    -1,    -1,    -1,  3203,
     136,    -1,    -1,  3207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1958,    -1,    -1,    -1,
      -1,    -1,    -1,  3227,  1966,  1967,    -1,    -1,    -1,  3233,
    5696,    -1,    -1,  3237,    -1,   501,  3240,   173,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3250,    -1,    -1,    -1,
     516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3263,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,    -1,  3273,
      -1,    -1,    -1,    -1,  4678,  5741,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1654,    -1,    -1,    -1,   564,    -1,
      -1,    -1,    -1,    -1,   240,    -1,   572,    -1,   574,   575,
     576,   577,   578,    -1,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,    -1,    -1,    -1,    -1,    -1,
    4911,    -1,    -1,    -1,    -1,    -1,  3340,    -1,  5592,   275,
      -1,    -1,    -1,    -1,    -1,  5599,  4057,    -1,    -1,    -1,
    5604,    -1,    -1,  5607,  5608,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2106,  2107,  2108,    -1,    -1,   305,
      -1,    -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2127,    -1,    -1,  5642,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,  4801,    -1,    -1,
    4804,    -1,  5656,    -1,    84,    -1,    -1,    87,    -1,    -1,
     346,    91,    92,    93,    -1,  2157,    -1,    -1,    -1,    -1,
      -1,    -1,  2164,    -1,    -1,    -1,  4830,  3431,   108,    -1,
      -1,    -1,    -1,    -1,    -1,  2177,   116,    -1,  1798,    -1,
      -1,    -1,    -1,    -1,   380,  2187,   126,   230,    -1,    -1,
      -1,    -1,    -1,    -1,  5708,    -1,    -1,    -1,    -1,    -1,
      -1,   244,    -1,    -1,    -1,    -1,   249,    -1,    -1,   405,
      -1,   254,    -1,   153,    -1,    -1,    -1,   260,    -1,    -1,
     263,    -1,    -1,    -1,   267,  3489,    -1,  2229,    -1,    -1,
     426,    -1,    -1,    -1,   430,    -1,    -1,    -1,  5752,    -1,
      -1,    -1,   438,  4214,  4215,  4216,    -1,    -1,    -1,  5975,
    5976,   447,   295,    -1,  4918,    -1,    -1,    -1,    -1,    -1,
     456,    -1,    -1,  5989,  4235,    -1,  5107,  5993,    -1,    -1,
      -1,    -1,   315,  4937,   470,    -1,    -1,    -1,    -1,    -1,
    3544,    -1,    -1,   479,    -1,    -1,    -1,    -1,    -1,    -1,
    4261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4271,  4272,    -1,    -1,    -1,  4276,    -1,  3571,   504,    -1,
    5824,    -1,    -1,    -1,    -1,  3579,   359,    -1,    -1,    -1,
     363,    -1,    -1,    -1,    -1,    -1,    -1,   370,    -1,  3593,
      -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,   278,    -1,
      -1,  1961,    -1,    -1,   540,    -1,    -1,    -1,    -1,   545,
      -1,    -1,  5016,    -1,    -1,    -1,    -1,    -1,    -1,   299,
     300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2372,    -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,    -1,
    5894,    -1,    -1,    -1,    -1,    -1,   429,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3663,
      -1,    -1,    -1,  5244,    -1,  3669,    -1,    -1,    -1,   349,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4395,    -1,   366,    -1,    -1,   369,
      -1,  2433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5282,    -1,    -1,    -1,    -1,    -1,   490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2467,    -1,    -1,    -1,  5310,
    6196,    -1,    -1,   516,  6200,  2477,  6202,    -1,    -1,    -1,
    6206,  6207,    -1,  6209,    -1,    -1,    -1,  2489,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3760,    -1,    -1,    -1,
     543,    -1,   545,   546,    -1,    -1,    -1,  6021,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6044,    -1,    -1,    -1,  5375,    -1,    -1,    -1,   581,    -1,
      -1,   584,   585,    -1,   587,    -1,    -1,    -1,  2168,    -1,
      -1,    -1,    -1,  4524,  4525,  4526,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2568,  2569,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2585,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6108,  2597,  2598,  6323,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6336,    -1,  6338,    -1,    -1,    -1,    -1,  2237,    -1,    -1,
      -1,  3885,  3886,    96,  2626,    -1,  6140,   567,   101,    -1,
     570,   571,   572,    -1,   574,   575,   576,   577,   578,   579,
      -1,  5305,    -1,    -1,   584,    -1,    -1,    -1,  3912,    -1,
      -1,  3915,    -1,  5317,  5495,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   140,  2288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   154,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2311,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5551,    -1,    -1,    -1,    -1,    -1,   189,    -1,    -1,  5383,
    6446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6253,
      -1,    -1,  4006,  4007,  4008,   218,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4725,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,  2770,  4033,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
    4044,  2401,    -1,   256,    -1,    -1,    -1,    -1,    -1,  6515,
      -1,    -1,    -1,    -1,    -1,  4059,  2416,    -1,  6524,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2426,    -1,   281,  4073,
      -1,  6325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   306,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6578,    -1,   327,    -1,    -1,    -1,  2860,    -1,
      -1,    -1,    -1,    -1,    -1,  6379,    -1,  5531,    -1,    -1,
      -1,    -1,  6598,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6394,    -1,    -1,    -1,    -1,  2505,  6400,  6401,    -1,    -1,
    4154,    -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4872,    -1,    -1,    -1,  2525,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4884,    -1,    -1,    -1,   390,    -1,  2539,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,    -1,
      -1,   404,  2552,    -1,  4198,    -1,    -1,    -1,    -1,    -1,
    2942,    -1,  2944,    -1,  4208,    -1,  4210,    -1,    -1,    -1,
    4921,    -1,    -1,    -1,    -1,  6469,    -1,    -1,    -1,  4223,
     433,  4225,  2964,    -1,    -1,    -1,   439,    -1,    -1,   442,
      -1,    -1,    -1,    -1,  2594,  2595,   449,    -1,    -1,   452,
    4951,    -1,    -1,    -1,  2986,    -1,  5650,    -1,  5652,    -1,
    4254,    -1,   465,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   474,    -1,    -1,  3006,    -1,    -1,    -1,   481,  3011,
    3012,    -1,    -1,    -1,  3016,    -1,    -1,   490,    -1,  5860,
     493,    -1,  3024,    -1,   497,    -1,    -1,    -1,    -1,  4293,
      -1,   504,    -1,   506,    -1,    -1,    -1,    -1,   511,    -1,
    3042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6566,    -1,    -1,    -1,    -1,    -1,    -1,  5900,
      -1,    -1,  6576,    -1,    -1,   538,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4341,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3087,  6600,  6601,    -1,  6603,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3099,    -1,  4363,
      -1,    -1,    -1,  3105,  3106,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5960,
      -1,    -1,    -1,    -1,  5965,  5966,    -1,    -1,    -1,    -1,
    4394,    -1,    -1,  4397,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2765,    -1,  3149,  3150,    -1,
      -1,    -1,  3154,    -1,    -1,  5126,  5127,  5128,  5129,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,     9,    -1,    -1,    -1,    13,  3188,    15,  3190,    17,
      18,    -1,    -1,    -1,  3196,    -1,    -1,    -1,    -1,  3201,
      28,  3203,    -1,    -1,    -1,  3207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4478,    -1,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3227,    -1,    -1,    -1,    -1,
      -1,  3233,    -1,    -1,    -1,  3237,    -1,    -1,  3240,  6080,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3250,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3263,    -1,    -1,    -1,    -1,    94,    -1,    -1,    -1,
      -1,  3273,    -1,    -1,    -1,    -1,   104,    -1,   106,   107,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   119,    -1,    -1,    -1,    -1,   124,   125,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,   147,
      -1,   149,   150,   151,    -1,    -1,    -1,    -1,    -1,   157,
      -1,   159,   160,    -1,    -1,    -1,    -1,    -1,  3340,    -1,
      -1,    -1,    -1,    -1,   172,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   189,    -1,    -1,   192,    -1,    -1,   195,    -1,    -1,
      -1,    -1,    -1,  2993,    -1,    -1,    -1,  2997,  2998,    -1,
      -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,   216,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,   237,
      -1,    -1,    -1,    -1,  4678,    -1,   244,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3431,
      -1,    -1,   260,    -1,    -1,    84,    -1,    -1,    87,    -1,
      -1,  3061,    91,    92,    93,    -1,    -1,    -1,    -1,   277,
      -1,    -1,    -1,  3073,    -1,  6296,    -1,    -1,    -1,   108,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,  4732,    -1,
      -1,    -1,    -1,  4737,    -1,  4739,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3489,   316,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,  3117,    -1,    -1,
      -1,    -1,    -1,  4767,   153,    -1,   334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   343,   344,    -1,    -1,    -1,
     348,  4785,    -1,    -1,    -1,    -1,  5497,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4801,    -1,    -1,
    4804,    -1,  3544,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   387,
      -1,    -1,    -1,    -1,    -1,    -1,  4830,    -1,   396,  3571,
      -1,    -1,    -1,    84,    -1,    -1,    87,  3579,    -1,    -1,
      91,    92,    93,   411,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,   421,    -1,    -1,    -1,   108,   426,    -1,
      -1,    -1,    -1,   431,    -1,   116,   434,   435,    -1,    -1,
      -1,    -1,   440,   441,    -1,   126,    -1,    -1,    -1,   447,
     448,    -1,    -1,    -1,   273,    -1,    -1,    -1,   456,   278,
      -1,    -1,    -1,   461,    -1,    -1,    -1,    -1,    -1,    -1,
    4904,  4905,   153,    -1,   472,    -1,  4910,  6311,    -1,    -1,
     299,   300,    -1,    -1,  4918,    -1,    -1,    -1,    -1,    -1,
      -1,  3663,   490,    -1,    -1,   314,    -1,  3669,    -1,    -1,
      -1,    84,    -1,  4937,    87,    -1,    -1,    -1,    91,    92,
      93,   509,    -1,   511,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   519,    -1,    -1,   522,   108,    -1,    -1,    -1,   527,
     349,    -1,    -1,   116,   532,    -1,    -1,    -1,    -1,    -1,
    3330,    -1,    -1,   126,    -1,    -1,    -1,   366,   546,    -1,
     369,    -1,    -1,    -1,  4988,    -1,    -1,    -1,    -1,    94,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     153,   569,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5016,    -1,    -1,   583,    -1,    -1,  3760,   587,
      -1,    -1,   273,    -1,    -1,    -1,   131,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5755,    -1,    -1,    -1,   299,   300,
      -1,    -1,    -1,    -1,   159,    -1,    -1,    -1,    -1,  5770,
      -1,    -1,    -1,   314,  5775,    -1,    -1,  3427,    -1,    -1,
      -1,    -1,   177,   462,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,    -1,    -1,
      -1,  5802,    -1,    -1,    -1,    -1,    -1,   202,   349,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   219,   366,   221,    -1,   369,    -1,
     273,   226,   227,    -1,    -1,   278,    -1,    -1,    -1,    -1,
      -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,  3885,  3886,    -1,   299,   300,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3912,    -1,    -1,  3915,    -1,    -1,    -1,    -1,   567,    -1,
      -1,   570,   571,   572,    -1,   574,   575,   576,   577,   578,
     579,    -1,    -1,    -1,    -1,   584,   349,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3569,
      -1,   462,    -1,   366,    -1,    -1,   369,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3590,    -1,  5943,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    87,    -1,  3604,    -1,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5261,    -1,    -1,
      -1,    -1,  5266,   108,  4006,  4007,  4008,    -1,    -1,    -1,
      -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   126,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      84,  4033,    -1,    87,    -1,    -1,    -1,    91,    92,    93,
      -1,  5305,  4044,    -1,    -1,    -1,    -1,    -1,   153,   462,
      -1,    -1,    -1,  5317,   108,    -1,   567,  4059,    -1,   570,
     571,   572,   116,   574,   575,   576,   577,   578,   579,    -1,
      -1,  4073,   126,   584,    -1,   151,    -1,    -1,    -1,    -1,
    5344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5383,
      -1,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,   213,   214,   215,
      -1,    -1,    -1,    -1,   220,    -1,    -1,   223,    -1,    -1,
      -1,    -1,  4154,    -1,   567,   231,    -1,   570,   571,   572,
      -1,   574,   575,   576,   577,   578,   579,    -1,   273,    -1,
      -1,   584,    -1,   278,   250,    -1,    -1,    -1,    -1,    -1,
      -1,  5445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   299,   300,  4198,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4208,   283,  4210,   314,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
      -1,  4223,    -1,  4225,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3858,    -1,
      -1,  3861,    -1,  3863,   349,   299,   300,    -1,  3868,    -1,
      -1,    -1,  4254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     314,   366,    -1,    -1,   369,    -1,   342,  5531,    -1,    -1,
     346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4293,   368,    -1,    -1,   349,    -1,    -1,    -1,  3919,
      -1,    -1,    -1,   379,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   366,    -1,    -1,   369,  3936,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   412,    -1,    -1,  4341,
      -1,  3961,    -1,    -1,    -1,    -1,   422,    -1,    -1,   425,
     426,    -1,    -1,    -1,    -1,    -1,    -1,   462,    -1,    -1,
      -1,  4363,    -1,    -1,    -1,    84,    -1,    -1,    87,   734,
      -1,    -1,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,
     456,    -1,    -1,    -1,    -1,    -1,  5650,    -1,  5652,   108,
      -1,    -1,  4394,    -1,    -1,  4397,    -1,   116,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   126,   462,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   501,    -1,    -1,    -1,  4049,
      -1,  4051,    -1,    -1,   153,  5699,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5708,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   567,    -1,    -1,   570,   571,   572,    -1,   574,
     575,   576,   577,   578,   579,    -1,  4478,    -1,    -1,   584,
      -1,    -1,  5746,    -1,    -1,    -1,    -1,    -1,  5752,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    -1,    -1,    87,    -1,    -1,    -1,    91,
      92,    93,    -1,   567,  4134,    -1,   570,   571,   572,    -1,
     574,   575,   576,   577,   578,   579,   108,    -1,    -1,    -1,
     584,    -1,    -1,    84,   116,    -1,    87,    -1,    -1,    -1,
      91,    92,    93,    -1,   126,    -1,    -1,    -1,  4168,    -1,
      -1,    -1,    -1,    -1,   273,    -1,    -1,   108,    -1,   278,
      -1,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   153,    -1,  4193,    -1,   126,    -1,    -1,    -1,  4199,
     299,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     955,    -1,   957,   958,   959,   314,   961,    -1,    -1,    -1,
     965,    -1,   153,   968,    -1,    -1,   971,    -1,   973,    -1,
      -1,    -1,    -1,    -1,    -1,   980,    -1,    -1,   983,    -1,
      -1,   986,    -1,    -1,    -1,   990,    -1,   992,    -1,    -1,
     349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1008,    -1,    -1,    -1,   366,    -1,  1014,
     369,  1016,    -1,    -1,   205,  1020,    -1,  1022,  4278,  1024,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1033,    -1,
    1035,    -1,    -1,    -1,  4294,  1040,  4678,    -1,  1043,    -1,
      -1,    -1,    -1,    -1,    -1,  1050,    -1,  5951,    -1,  4309,
      -1,   273,    -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5977,    -1,    -1,    -1,   299,   300,  1084,
      -1,    -1,   273,    -1,  1089,  5989,    -1,   278,    -1,  1094,
    4732,    -1,   314,    -1,  1099,  4737,  1101,  4739,    -1,    -1,
      -1,    -1,    -1,   462,    -1,    -1,    -1,    -1,   299,   300,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1122,    -1,    -1,
      -1,    -1,    -1,   314,    -1,  4767,    -1,   349,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4785,   366,    -1,    -1,   369,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   349,  4801,
      -1,  4421,  4804,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   366,    -1,  1182,   369,    -1,
      -1,  1186,  4442,    -1,    -1,    -1,    -1,    -1,  4830,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1203,    -1,
    1205,    -1,    -1,    -1,    -1,    -1,    -1,  4467,   567,    -1,
      -1,   570,   571,   572,    -1,   574,   575,   576,   577,   578,
     579,    -1,    -1,    -1,    -1,   584,    -1,    -1,    -1,    -1,
    1235,  1236,    -1,    -1,    -1,  1240,  1241,    -1,    -1,    -1,
     462,  4501,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1260,    -1,    -1,  1263,    -1,
      -1,    -1,  4904,  4905,    -1,    -1,    -1,  1272,  4910,    -1,
      -1,   462,    -1,    -1,    -1,    -1,  4918,    -1,  1283,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6194,    -1,  6196,    -1,    -1,  4937,    -1,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    87,    -1,    -1,    -1,    91,    92,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,  1334,
      -1,    -1,    -1,   116,    -1,   526,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   126,    -1,   567,  4988,    -1,   570,   571,
     572,    -1,   574,   575,   576,   577,   578,   579,    84,    -1,
     582,    87,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
     153,    -1,    -1,    -1,  5016,  4635,   567,    -1,    -1,   570,
     571,   572,   108,   574,   575,   576,   577,   578,   579,  6293,
     116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     126,    -1,  1407,    -1,    -1,    -1,    -1,  6311,    -1,    -1,
      -1,    -1,  1417,    -1,    -1,    -1,    -1,    -1,    -1,  1424,
      -1,  6325,    -1,    -1,  1429,  1430,    -1,   153,    -1,    -1,
      -1,    -1,    -1,  1438,  1439,    -1,  6340,    -1,    -1,    -1,
      84,    -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   108,    -1,   249,    -1,    -1,    -1,
      -1,   254,   116,    -1,    -1,    -1,    -1,    -1,  4738,    -1,
      -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,    -1,  1497,    -1,    -1,   278,  6400,  6401,    -1,    -1,
    1505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4768,   153,
      -1,  1516,    -1,    -1,    -1,  1520,   299,   300,    -1,    -1,
      -1,    -1,    -1,  1090,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   314,    -1,    -1,  1539,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6446,    -1,    -1,    -1,    -1,   273,    -1,    -1,
      -1,  1118,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1565,    -1,    -1,    -1,  1569,    -1,   349,    -1,  1573,    -1,
      -1,  1576,  1577,   299,   300,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   366,    -1,    -1,   369,    -1,   314,    -1,
      -1,    -1,    -1,    -1,  1599,  1600,  1601,    -1,  1603,    -1,
    1605,    -1,    -1,    -1,   248,  1610,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5261,
    6524,    -1,    -1,   349,  5266,    -1,    -1,  1632,    -1,   273,
      -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,    -1,    -1,
     366,    -1,    -1,   369,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4911,    -1,    -1,    -1,   299,   300,    -1,    -1,    -1,
      -1,    -1,    -1,  5305,    -1,    -1,    -1,    -1,    -1,   395,
     314,    -1,    -1,    -1,  6578,  5317,    -1,    -1,    -1,   462,
      -1,    -1,  1687,  1688,    -1,  1690,    -1,    -1,  1693,  1694,
      -1,    -1,    84,    -1,  6598,    87,  6600,  6601,  4958,    91,
      92,    93,  5344,    -1,    -1,   349,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   108,    -1,    -1,   111,
      -1,    -1,   366,    -1,   116,   369,    -1,    -1,    -1,  1734,
      -1,    -1,    -1,    -1,   126,    -1,   462,    -1,    -1,    -1,
      -1,  5383,    -1,    -1,    -1,    -1,    -1,    -1,   392,    -1,
      -1,    -1,    -1,    -1,   480,    -1,    -1,    -1,    -1,    -1,
      -1,   153,    -1,    -1,    -1,    -1,    -1,  1772,  1773,    -1,
      -1,    -1,  1777,    -1,  1779,    -1,    -1,    -1,    -1,    -1,
      -1,  1786,    -1,    -1,   567,    -1,    -1,   570,   571,   572,
      -1,   574,   575,   576,   577,   578,   579,    -1,    -1,    -1,
      -1,    -1,    -1,  5445,    -1,    -1,  1811,    -1,    -1,  1814,
      -1,    -1,  1817,    -1,  1819,    -1,    -1,    -1,   462,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1836,    -1,    -1,    -1,    -1,    -1,  5097,    -1,    -1,
      -1,   567,    -1,    -1,   570,   571,   572,  5107,   574,   575,
     576,   577,   578,   579,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1866,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,    -1,    -1,    -1,    -1,   278,    -1,    -1,  5531,
      -1,    -1,    -1,  1898,  1899,  1900,    -1,  1902,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,   300,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1922,    -1,    -1,
      -1,    -1,   314,   567,    -1,    -1,   570,   571,   572,    -1,
     574,   575,   576,   577,   578,   579,    -1,    -1,    -1,  1944,
    1945,    -1,    -1,    -1,    -1,  1512,    -1,    84,    -1,    -1,
      87,    -1,    -1,    -1,    91,    92,    93,   349,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1973,  1536,
      -1,   108,    -1,    -1,   366,    -1,    -1,   369,    -1,   116,
      -1,    -1,    -1,    -1,  5244,    -1,  1553,    -1,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5650,    -1,
    5652,    -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,
      -1,    -1,  5282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    -1,    -1,    87,    -1,    -1,    -1,    91,
      92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5310,    -1,    -1,    -1,    -1,    -1,   108,  5699,    -1,   111,
      -1,    -1,    -1,    -1,   116,    -1,    -1,  2072,  2073,    -1,
     462,    -1,    -1,    -1,   126,    -1,  2081,    -1,    -1,    -1,
    2085,  2086,    -1,    -1,    -1,    -1,    -1,  1654,    -1,    -1,
      -1,  2096,  2097,  2098,    -1,  2100,    -1,    -1,    -1,    -1,
      -1,   153,    -1,    -1,  5746,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5375,    -1,    -1,    -1,    -1,
    2125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,
      -1,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   299,   300,    -1,    -1,  2171,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   567,    -1,   314,   570,   571,
     572,    -1,   574,   575,   576,   577,   578,   579,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   349,    -1,    -1,    -1,    -1,    -1,  2223,    -1,
      -1,   273,    -1,    -1,    -1,    -1,   278,    -1,    -1,   366,
      -1,  1798,   369,    -1,    -1,  5495,    -1,    -1,    -1,  2244,
    2245,    -1,    -1,    -1,    -1,    -1,    -1,   299,   300,    -1,
      -1,   388,    -1,    -1,  2259,    -1,    -1,  2262,    -1,    -1,
      -1,    -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2283,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2292,    -1,  2294,
      -1,  5551,    -1,    -1,    -1,    -1,    -1,   349,    -1,    -1,
      -1,    -1,  2307,    -1,    -1,  2310,    -1,    -1,    -1,  5951,
      -1,    -1,    -1,    -1,   366,    -1,    -1,   369,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   462,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5977,    -1,    -1,    -1,    -1,
      -1,    -1,  2347,    -1,    -1,    -1,    98,  5989,    -1,    -1,
      -1,    -1,   104,  2358,  2359,  2360,  2361,  2362,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2393,    -1,
    2395,  2396,    -1,  2398,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,  2410,  2411,    -1,    -1,    -1,
     462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2432,    -1,    -1,
     567,    -1,  2437,   570,   571,   572,  5696,   574,   575,   576,
     577,   578,   579,    -1,    -1,    -1,    -1,    -1,    -1,   201,
      -1,    -1,    -1,    -1,    -1,    -1,  2461,   209,    -1,    -1,
      -1,   213,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
      -1,   223,    -1,    -1,  2479,  2480,  2481,  2482,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2492,    -1,    -1,
      -1,    -1,    -1,    -1,  2499,    -1,    -1,  2502,   250,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2518,    -1,   567,  2521,    -1,   570,   571,
     572,  2526,   574,   575,   576,   577,   578,   579,  2533,    -1,
      -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6194,    -1,  6196,    -1,    -1,    -1,    -1,    -1,
    2565,  2566,    -1,    -1,    -1,    -1,  5826,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2581,  2582,    -1,    -1,
      -1,  2586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     342,    -1,    -1,    -1,   346,    -1,    -1,  2602,  2603,    -1,
    5860,  2168,    -1,  2608,    -1,   357,    -1,    -1,    -1,    -1,
      -1,    -1,  2617,    -1,    -1,    -1,   368,    -1,  2623,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   379,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5900,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6293,  2657,    -1,    -1,    -1,    -1,    -1,    -1,  2664,
     412,  2666,    -1,    -1,    -1,  2670,  2671,    -1,  2673,  6311,
    2237,    -1,    -1,   425,   426,  2680,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2696,    -1,    -1,    -1,    -1,  2701,  2702,  6340,    -1,
    5960,  2706,    -1,    -1,   456,  5965,  5966,    -1,    -1,    -1,
      -1,    -1,  2717,  2718,    -1,    -1,    -1,    -1,  2723,  2724,
      -1,  2288,    -1,    -1,    -1,  2730,  2731,  2732,    -1,    -1,
      -1,  2736,  2737,  2738,  2739,  2740,  2741,  2742,  2743,    -1,
    2745,    -1,  2747,  2748,  2311,    -1,  2751,    -1,    -1,   501,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2766,  2767,  2768,  2769,    -1,    -1,    -1,  2773,  2774,
      -1,    -1,    -1,  2778,    -1,    -1,  2781,   529,    -1,  2784,
    2785,  2786,  2787,  2788,  2789,  2790,  2791,  2792,    -1,  2794,
      -1,    -1,    -1,    -1,    -1,    -1,  2801,  2802,    -1,    -1,
    2805,    -1,    -1,    -1,  6446,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6080,    -1,  2827,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2401,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2416,
      -1,    -1,    -1,    -1,    -1,    -1,  2861,    -1,  2863,  2426,
    2865,    -1,    -1,    -1,  2869,    -1,    -1,  2872,  2873,    -1,
      -1,    -1,  2439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6524,    -1,    -1,    -1,  2891,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2926,    -1,    -1,    -1,    -1,    -1,    -1,  2933,    -1,
    2935,    -1,    -1,    -1,    -1,    -1,  6578,    -1,  2505,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6598,    -1,  2525,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2539,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2552,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    -1,    -1,    87,    -1,    -1,    -1,
      91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3017,    -1,    -1,    -1,    -1,   108,    -1,    -1,
      -1,  3026,    -1,  3028,    -1,   116,    -1,  2594,  2595,    -1,
      -1,    -1,    -1,    -1,    -1,   126,  6296,    -1,    -1,    -1,
    3045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3057,    -1,  3059,  3060,    -1,    -1,    -1,  3064,
      -1,  3066,   153,  3068,    -1,  3070,    -1,    -1,    -1,  3074,
      -1,    -1,  3077,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,    -1,  3110,   111,    -1,    -1,    -1,
      -1,   116,    -1,    -1,    -1,  3120,  3121,    -1,    -1,    -1,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3136,    -1,    -1,    -1,    -1,    84,  3142,    -1,    87,
      -1,  3146,    -1,    91,    92,    93,    -1,    -1,   153,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3163,    -1,
     108,    -1,    -1,   254,  3169,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   126,  3184,
    3185,    -1,   273,    -1,    -1,    -1,    -1,   278,    -1,  3194,
    3195,    -1,    -1,  3198,    -1,  3200,    -1,    -1,  2765,    -1,
      -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,   299,   300,
      -1,    -1,    -1,    -1,  3219,    -1,    -1,  3222,    -1,    -1,
      -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3244,
    3245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3259,    -1,  3261,  3262,   349,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,
      -1,    -1,    -1,   278,    -1,   366,    -1,    -1,   369,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3292,    -1,  3294,
      -1,    -1,    -1,    -1,   299,   300,  3301,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3309,  3310,    -1,    -1,    -1,   314,
      -1,  3316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3329,   273,  3331,    -1,    -1,    -1,
     278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3348,   349,    -1,    -1,    -1,    -1,    -1,
      -1,   299,   300,    -1,    -1,  3360,    -1,  3362,    -1,    -1,
    3365,   366,    -1,    -1,   369,  3370,   314,    -1,  3373,    -1,
      -1,   462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3385,    -1,  3387,  3388,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,
    3405,   349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3415,    -1,  3417,    -1,   108,    -1,    -1,    -1,   366,    -1,
      -1,   369,   116,    -1,    -1,    -1,  2993,  3432,    -1,    -1,
    2997,  2998,   126,    -1,    -1,    -1,    -1,    -1,  3443,  3444,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3458,    -1,    -1,    -1,   462,    -1,   153,
      -1,    -1,    -1,  3468,    -1,    -1,    -1,    -1,  3473,  3474,
    3475,  3476,    -1,    -1,    -1,    -1,   567,    -1,    -1,   570,
     571,   572,    -1,   574,   575,   576,   577,   578,   579,    -1,
      -1,    -1,    84,    -1,  3061,    87,    -1,    -1,    -1,    91,
      92,    93,    -1,    -1,    -1,    -1,  3073,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   462,    -1,   108,    -1,    -1,   111,
      -1,    -1,  3527,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3117,    -1,    -1,    -1,    -1,  3560,    -1,    -1,    -1,    -1,
      -1,   153,   567,    -1,    -1,   570,   571,   572,  3573,   574,
     575,   576,   577,   578,   579,    -1,    -1,    -1,    -1,   273,
      -1,  3586,  3587,    -1,   278,    -1,    -1,    -1,  3593,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3607,    -1,    -1,   299,   300,    -1,    -1,  3614,
      -1,    -1,    -1,    -1,  3619,    -1,    -1,    -1,    -1,   567,
     314,    -1,   570,   571,   572,    -1,   574,   575,   576,   577,
     578,   579,    -1,    -1,    -1,    -1,    -1,  3642,  3643,  3644,
      -1,    -1,  3647,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3655,  3656,  3657,  3658,    -1,   349,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3668,    -1,    -1,  3671,    -1,  3673,    -1,
      -1,    -1,   366,    -1,    -1,   369,    -1,    -1,    -1,  3684,
    3685,   273,    -1,  3688,    -1,    -1,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3700,    -1,  3702,    -1,  3704,
      -1,  3706,    -1,    -1,    -1,    -1,    -1,   299,   300,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3726,   314,    -1,    -1,  3730,    -1,    -1,    -1,    -1,
      -1,    -1,  3737,    -1,  3739,  3740,  3741,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   349,    -1,  3764,
      -1,    -1,    -1,  3330,    -1,    -1,    -1,    -1,   462,    -1,
      -1,    -1,    -1,    -1,   366,    -1,    -1,   369,    -1,    -1,
      -1,    -1,    -1,  3788,    -1,    -1,    -1,    -1,  3793,    -1,
    3795,    -1,    -1,    -1,    -1,  3800,    -1,    -1,    -1,    -1,
      -1,  3806,    -1,    -1,   498,    -1,    -1,    -1,    -1,    -1,
      -1,  3816,    -1,    -1,    -1,  3820,    -1,    -1,  3823,    -1,
    3825,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     462,    -1,    -1,   567,    -1,    89,   570,   571,   572,    -1,
     574,   575,   576,   577,   578,   579,  3891,    -1,  3893,    -1,
      -1,    -1,    98,  3898,    -1,    -1,    -1,    -1,   104,    -1,
      -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3925,    -1,  3927,  3928,  3929,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   567,    -1,    -1,   570,   571,
     572,    -1,   574,   575,   576,   577,   578,   579,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,    -1,    -1,   204,    -1,
      -1,    -1,  3569,   209,    -1,    -1,   220,   213,   214,   215,
      -1,    -1,    -1,    -1,   220,    -1,   230,   223,   232,    -1,
      -1,    -1,    -1,  3590,  4029,   231,    -1,    -1,    -1,    -1,
      -1,   245,    -1,    -1,    -1,    -1,    -1,  3604,    -1,    -1,
      -1,    -1,    -1,    -1,   250,    -1,    -1,    -1,    -1,    -1,
      -1,     5,  4057,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,
      -1,    35,    36,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    -1,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    -1,    -1,
      -1,    85,    -1,    -1,    -1,    -1,   342,    -1,    -1,    -1,
     346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   357,    -1,    -1,  4159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   368,    -1,  4169,    -1,    -1,    -1,    -1,  4174,
    4175,    -1,    -1,   379,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   143,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4205,    -1,    -1,    -1,    -1,    -1,   412,    -1,    -1,  4214,
    4215,  4216,    -1,    -1,    -1,    -1,   422,    -1,    -1,   425,
     426,    -1,    -1,    -1,  4229,    -1,    -1,    -1,    -1,    -1,
    4235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     456,    -1,    -1,    -1,    -1,  4260,  4261,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4270,  4271,  4272,    -1,    -1,
      -1,  4276,    -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3858,    -1,   247,  3861,   501,  3863,    -1,    -1,  4304,
      -1,  3868,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   270,  4322,    -1,    -1,
      -1,    -1,    -1,   529,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,
    4345,    -1,    -1,    -1,    -1,  4350,    -1,    -1,    -1,    -1,
      -1,    -1,  3919,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4370,    -1,    -1,    -1,  3936,
      -1,    -1,    -1,    -1,  4379,    -1,   330,    -1,    -1,   333,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4395,    -1,    -1,    -1,  3961,    -1,    -1,   351,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4427,    -1,    -1,    -1,    -1,    -1,  4433,    -1,
    4435,    -1,    -1,  4438,    -1,    -1,    -1,    -1,  4443,  4444,
    4445,  4446,    -1,    -1,  4449,  4450,  4451,  4452,  4453,  4454,
    4455,  4456,  4457,  4458,    -1,    -1,    -1,  4462,  4463,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4472,    -1,    -1,
      -1,  4476,    -1,    -1,    -1,  4480,    -1,    -1,    -1,    -1,
      -1,    -1,  4049,  4488,  4051,    -1,  4491,    -1,  4493,    -1,
      -1,    -1,   446,    -1,    -1,    -1,    -1,  4502,    -1,    -1,
    4505,  4506,    -1,    -1,    -1,  4510,  4511,    -1,    -1,    -1,
    4515,    -1,  4517,    -1,    -1,    -1,    -1,    -1,    -1,  4524,
    4525,  4526,  4527,    -1,    -1,  4530,  4531,    -1,    -1,    -1,
    4535,  4536,  4537,    -1,    -1,    -1,    -1,    -1,  4543,    -1,
      -1,    -1,    -1,    -1,  4549,  4550,  4551,   501,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   516,    -1,    -1,    -1,    -1,  4134,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4603,    -1,
      -1,  4168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     564,    -1,  4617,    -1,  4619,    -1,    -1,    -1,   572,    -1,
     574,   575,   576,   577,   578,    -1,  4193,   581,   582,   583,
      -1,    -1,  4199,    -1,   588,   589,    -1,    -1,    -1,    -1,
      -1,    -1,  4647,  4648,  4649,    -1,  4651,    98,    -1,    -1,
      -1,   102,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4668,  4669,  4670,  4671,    -1,   119,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4697,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,
      -1,  4278,    -1,  4718,    -1,    -1,    -1,    -1,    -1,    -1,
    4725,    -1,    -1,   174,    -1,    -1,    -1,  4294,    -1,    -1,
      -1,    -1,    -1,   947,    -1,  4740,    -1,    -1,   189,    -1,
      -1,    -1,  4309,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,    -1,   966,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,   977,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,   223,    -1,    -1,    -1,    -1,   991,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,   260,
      -1,    -1,   263,    -1,  4819,  1029,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4828,    -1,  1039,    -1,    -1,    -1,  4834,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1053,
     291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,  4421,    -1,    -1,    -1,    -1,   104,
      -1,    -1,    -1,  4868,    -1,  1079,    -1,  4872,    -1,    -1,
    4875,   322,  4877,    -1,   119,  4442,   327,    -1,    -1,  4884,
      -1,  1095,    -1,    -1,    -1,  4890,    -1,    -1,    -1,    -1,
      -1,  1105,    -1,   344,    -1,    -1,    -1,  4902,    -1,    -1,
    4467,    -1,    -1,    -1,    -1,  1119,    -1,    -1,    -1,    -1,
      -1,    -1,   157,    -1,    -1,    -1,  4921,    -1,    -1,    -1,
    4925,    -1,    -1,  1137,    -1,    -1,    -1,    -1,    -1,   174,
    4935,    -1,   383,    -1,  4501,    -1,    -1,    -1,  4943,    -1,
      -1,    -1,    -1,    -1,   189,    -1,  4951,    -1,    -1,    -1,
    4955,    -1,    -1,    -1,  4959,  4960,   201,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,   422,    -1,    -1,    -1,   220,    -1,    -1,   223,    -1,
      -1,    -1,   433,    -1,  4989,  4990,  4991,  4992,  4993,    -1,
      -1,   442,  4997,   238,  4999,    -1,    -1,   448,   449,    -1,
      -1,    -1,    -1,    -1,    -1,   456,    -1,    -1,    -1,    -1,
      -1,   256,    -1,    -1,    -1,   260,    -1,    -1,   263,    -1,
    5025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1242,    -1,
    1244,    -1,  1246,    -1,    -1,    -1,   281,   488,  5043,   490,
      -1,    -1,   493,    -1,    -1,    -1,   291,    -1,    -1,  5054,
      -1,    -1,    -1,    -1,    -1,   506,    -1,    -1,   509,    -1,
     511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4635,    -1,
      -1,    -1,    -1,   524,   525,    -1,    -1,   322,    -1,  5084,
      -1,    -1,   327,    -1,    -1,    -1,    -1,   538,    -1,  5094,
    5095,    -1,    -1,    -1,    -1,    -1,  5101,  5102,    -1,   344,
      -1,  5106,    -1,    -1,    -1,    -1,  5111,    -1,    -1,  5114,
    5115,    -1,    -1,    -1,  5119,  5120,    -1,    -1,    -1,    -1,
    5125,  5126,  5127,  5128,  5129,    -1,    -1,    -1,  5133,  5134,
    5135,    -1,  5137,  5138,    -1,    -1,  5141,    -1,   383,    -1,
    5145,    -1,    -1,    -1,  5149,    -1,    -1,    -1,    -1,    -1,
    5155,    -1,    -1,    -1,    -1,    -1,    -1,  5162,  1372,  1373,
      -1,    -1,  5167,    -1,    -1,    -1,    -1,    -1,  5173,    -1,
      -1,  4738,    -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,
      -1,  5186,  5187,    -1,    -1,    -1,    98,    -1,   433,    -1,
    5195,    -1,   104,    -1,  5199,    -1,    -1,   442,    -1,  5204,
      -1,  4768,    -1,   448,   449,   117,    -1,    -1,    -1,    98,
      -1,   456,    -1,    -1,    -1,   104,    -1,    -1,  5223,    -1,
      -1,  5226,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,  5246,  5247,   488,    -1,   490,    -1,    -1,   493,    -1,
      -1,    -1,    -1,    -1,  1468,  1469,    -1,    98,    -1,  5264,
      -1,   506,   151,   104,   509,    -1,   511,    -1,    -1,    -1,
      -1,    -1,  5277,    -1,    -1,    -1,    -1,    -1,    -1,   524,
     525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
      -1,    -1,    -1,   538,   206,    -1,    -1,   209,    -1,    -1,
      -1,   213,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     151,   223,   201,    -1,    -1,    -1,    -1,   206,    -1,   231,
     209,    -1,    96,    -1,   213,   214,   215,   101,  5333,    -1,
      -1,   220,    -1,    -1,   223,    -1,    -1,    -1,   250,   113,
      -1,    -1,   231,    -1,  4911,    -1,    -1,    -1,    -1,    -1,
    5355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   250,    -1,    -1,    -1,  5370,   140,    -1,   209,    -1,
      -1,   283,   213,   214,   215,    -1,    -1,    -1,    -1,   220,
     154,    -1,   223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     231,  4958,    -1,    -1,   283,    -1,   170,    -1,    -1,    -1,
    5405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   250,
      -1,    -1,    -1,    -1,  5419,   189,    -1,    -1,    -1,    -1,
    5425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5434,
     342,    -1,  5437,    -1,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   283,    -1,   218,   357,    -1,  5452,    -1,    -1,
      -1,    -1,    -1,   342,    -1,   229,   368,   346,    -1,  5464,
      -1,  5466,    -1,    -1,   238,    -1,    -1,   379,   357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,   368,
      -1,    -1,   256,    -1,  1698,    -1,    -1,    -1,    -1,   263,
     379,   265,  5497,    -1,    -1,  5500,    -1,    -1,    -1,  1713,
     412,   342,    -1,    -1,    -1,   346,    -1,   281,    -1,    -1,
     422,    -1,    -1,   425,   426,    -1,   357,    -1,    -1,    -1,
    5525,    -1,    -1,   412,    -1,    -1,    -1,   368,  1742,    -1,
    5097,    -1,    -1,   422,    -1,    -1,   425,   426,   379,    -1,
    5107,    -1,  5547,    -1,   456,    -1,    -1,    -1,    -1,    -1,
      -1,  5556,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1778,    -1,    -1,   456,  5573,  5574,
     344,   412,  5577,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   422,    -1,    -1,   425,   426,  1800,  5592,    -1,   501,
    5595,   365,   366,    -1,  5599,    -1,    -1,    -1,    -1,  5604,
      -1,  1815,  5607,  5608,   378,  5610,  1820,  5612,    -1,  1823,
    5615,  5616,   501,    -1,    -1,   456,   390,   529,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,    -1,    -1,
     404,    -1,    -1,    -1,    -1,    -1,    -1,  5642,    -1,  5644,
     529,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5656,  5657,  5658,  5659,  5660,    -1,    -1,    -1,   433,
     501,    -1,    -1,    -1,    -1,   439,    -1,    -1,   442,    -1,
      -1,    -1,    -1,    -1,    -1,   449,    -1,  5244,   452,    -1,
      -1,    -1,    -1,    -1,    -1,   459,    -1,    -1,   529,    -1,
      -1,    -1,  5697,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     474,    -1,    -1,  5708,  5709,    -1,    -1,   481,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5282,   490,    -1,    -1,   493,
      -1,    -1,    -1,   497,    -1,    -1,    -1,    -1,    -1,    -1,
     504,    -1,   506,    -1,    -1,    -1,    -1,   511,    -1,    -1,
      -1,    -1,    -1,  5310,  1958,    -1,    -1,  5752,    -1,    -1,
    5755,   525,  1966,  1967,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5767,    -1,   538,  5770,    -1,    -1,    -1,    -1,
    5775,    -1,  5777,    -1,    -1,  5780,    -1,    -1,    -1,    -1,
      -1,    -1,  5787,   116,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5802,    -1,    -1,
      -1,  5806,    -1,    -1,    -1,    -1,    -1,    -1,  5375,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5822,  5823,  5824,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5859,    -1,    -1,  5862,    -1,  5864,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5884,
      -1,    -1,    -1,    -1,    -1,  5890,    -1,   220,    -1,  5894,
      -1,    -1,  2106,  5898,    -1,    -1,    -1,   230,    -1,   232,
    5905,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5914,
      -1,    -1,   245,  2127,    -1,    -1,  5921,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5495,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5943,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2177,    -1,  5970,    -1,    -1,    -1,    25,
      -1,    -1,    -1,  2187,    -1,  5980,  5981,  5982,  5983,    35,
      36,    -1,    -1,    -1,  5551,    -1,    42,    43,    -1,    -1,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,  2229,  6021,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    -1,    -1,    -1,    85,
      -1,    -1,  6037,    -1,    -1,    -1,    -1,    -1,    -1,  6044,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   143,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6105,    -1,    -1,  6108,    -1,    -1,  6111,    -1,    -1,    -1,
    6115,    -1,    -1,    -1,    -1,    -1,    -1,  6122,    -1,    -1,
      -1,    -1,  6127,    -1,  6129,    -1,  6131,    -1,    -1,  5696,
      -1,    -1,    -1,    -1,    -1,  6140,    -1,    -1,    -1,    -1,
      -1,  6146,    -1,  6148,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6158,    -1,    -1,    -1,    -1,  2372,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6204,
    6205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   270,    -1,    -1,    -1,    -1,  2433,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6235,    -1,    -1,    -1,    -1,    -1,  6241,   293,    -1,    -1,
    6245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6253,    -1,
      -1,    -1,    -1,  2467,    -1,    -1,    -1,    -1,    -1,  5826,
      -1,    -1,    -1,  2477,    -1,    -1,    -1,    -1,    -1,  6274,
      -1,    -1,    -1,    -1,   330,  2489,    -1,   333,    -1,  6284,
    6285,    -1,    -1,    -1,  6289,    -1,    -1,  6292,    -1,    -1,
      -1,    -1,    -1,  5860,    -1,   351,    -1,  6302,    -1,    -1,
    6305,    -1,    -1,    -1,    -1,  6310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5900,    -1,    -1,    -1,  6342,    -1,    -1,
      -1,    -1,    -1,    -1,  6349,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2568,  2569,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2585,    -1,    -1,  6379,    -1,    -1,    -1,    -1,  6384,
      -1,    -1,    -1,  2597,  2598,    -1,    -1,    -1,    -1,  6394,
     446,    -1,    -1,  5960,    -1,  6400,  6401,    -1,  5965,  5966,
    6405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6414,
      -1,    -1,  2626,  6418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6431,    -1,    -1,    -1,
      -1,    -1,    -1,  6438,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   501,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     516,    -1,    -1,    -1,  6469,  6470,  6471,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6499,    -1,    -1,    -1,    -1,  6504,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   564,    -1,
      -1,    -1,    -1,  6080,    -1,    -1,   572,    -1,   574,   575,
     576,   577,   578,    -1,    -1,   581,   582,   583,   584,    -1,
      -1,    -1,   588,    -1,    -1,    -1,    -1,    -1,    -1,  6544,
      -1,    -1,    -1,    -1,    -1,  6550,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2770,    -1,    -1,    -1,
    6565,  6566,    -1,    -1,    -1,    -1,    -1,    -1,  6573,    -1,
      -1,  6576,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6600,  6601,    -1,  6603,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   947,    -1,    -1,     5,    -1,    -1,
      -1,    -1,   955,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   965,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,  1016,    -1,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,  6296,
      -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
    2964,  1084,    -1,   104,    -1,   143,    -1,  1090,    -1,    -1,
     111,  1094,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2986,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     151,    -1,    -1,    -1,   135,  1118,    -1,    -1,    -1,    -1,
      -1,    -1,  3006,    -1,    -1,    -1,    -1,  3011,  3012,    -1,
     151,    -1,  3016,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3042,    -1,
     201,    -1,    -1,    -1,    -1,    -1,   187,    -1,   209,   227,
      -1,    -1,   213,   214,   215,    -1,    -1,    -1,    -1,   220,
     201,    -1,   223,    -1,    -1,    -1,    -1,    -1,   209,   247,
     231,    -1,   213,   214,   215,    -1,    -1,    -1,    -1,   220,
      -1,    -1,   223,  3087,    -1,    -1,    -1,    -1,    -1,   250,
     231,    -1,   270,    -1,    -1,  3099,    -1,    -1,    -1,    -1,
      -1,  3105,  3106,    -1,    -1,    -1,    -1,    -1,    -1,   250,
      -1,    -1,  1235,  1236,    -1,   293,    -1,    -1,    -1,  1242,
      -1,    -1,   283,  1246,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,
      -1,    -1,   283,    -1,    -1,  3149,  3150,    -1,    -1,  1272,
    3154,    -1,   330,    -1,    -1,   333,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   342,    -1,    -1,  3188,   346,  3190,   328,    -1,    -1,
     331,    -1,  3196,    -1,    -1,    -1,   357,  3201,    -1,  3203,
      -1,   342,    -1,  3207,    -1,   346,    -1,   368,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   357,    -1,   379,    -1,
      -1,    -1,    -1,  3227,    -1,    -1,    -1,   368,    -1,  3233,
      -1,    -1,    -1,  3237,    -1,    -1,  3240,   378,   379,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3250,    -1,    -1,    -1,
      -1,   412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3263,
      -1,   422,    -1,    -1,   425,   426,    -1,    -1,   446,  3273,
      -1,   412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   422,    -1,    -1,   425,   426,   427,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   456,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   449,    -1,
      -1,    -1,    -1,    -1,    -1,   456,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   472,    -1,    -1,    -1,    -1,  3340,    -1,   516,    -1,
     501,    -1,    -1,    -1,    -1,  1468,  1469,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   533,    -1,    -1,    -1,    -1,
     501,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1505,    -1,    -1,    -1,   564,    -1,   529,  1512,
      -1,    -1,    -1,  1516,   572,    -1,   574,   575,   576,   577,
     578,    -1,    -1,   581,   582,   583,   584,    -1,    -1,    -1,
     588,    -1,    -1,  1536,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,  3431,   104,    -1,
    1553,    -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,  1605,    -1,    -1,  3489,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      -1,  1654,    -1,   209,    -1,    -1,    -1,   213,   214,   215,
    3544,    -1,    -1,    -1,   220,    -1,    -1,   223,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3571,    -1,    -1,
      -1,     5,    -1,    -1,   250,  3579,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    36,    -1,   280,    -1,    -1,   283,    42,    43,
      -1,  1734,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    -1,    -1,
      -1,    85,   328,    -1,    -1,   331,    -1,    -1,    -1,  3663,
      -1,    -1,    -1,    -1,    -1,  3669,   342,    -1,    -1,    -1,
     346,    -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,    -1,
      -1,   357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   368,    -1,    98,    -1,  1819,  1820,    -1,    -1,
     104,    -1,   378,   379,    -1,    -1,    -1,    -1,    -1,   143,
      -1,    -1,    -1,  1836,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   412,    -1,    -1,    -1,
      -1,    -1,    -1,  1866,    -1,    -1,   422,   151,    -1,   425,
     426,   427,    -1,    -1,    -1,    -1,  3760,    -1,    -1,    -1,
      -1,   957,   958,    -1,    -1,   961,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   449,    -1,  1898,  1899,  1900,    -1,  1902,
     456,    -1,    -1,    -1,    -1,    -1,    -1,   983,    -1,    -1,
      -1,    -1,    -1,   227,   990,    -1,   472,   201,    -1,  1922,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,   213,
     214,   215,    -1,   247,    -1,    -1,   220,    -1,    -1,   223,
      -1,    -1,    -1,    -1,  1020,   501,    -1,   231,  1024,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   270,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   250,  1043,    -1,    -1,
      -1,    -1,    -1,   529,  1050,    -1,    -1,    -1,    -1,   293,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   283,
      -1,  3885,  3886,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   330,    -1,    -1,   333,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3912,    -1,
      -1,  3915,    -1,    -1,    -1,    -1,    -1,   351,   151,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   342,    -1,
      -1,    -1,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   357,    -1,    -1,    -1,    -1,  2081,    -1,
      -1,    -1,  2085,  2086,   368,    -1,    -1,    -1,   201,    -1,
      -1,    -1,    -1,    -1,    -1,   379,   209,  2100,    -1,    -1,
     213,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,    -1,
     223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,
      -1,    -1,  4006,  4007,  4008,    -1,    -1,    -1,   412,    -1,
      -1,    -1,   446,    -1,    -1,    -1,    -1,   250,   422,    -1,
      -1,   425,   426,    -1,    -1,    -1,    -1,    -1,    -1,  4033,
      -1,    89,    -1,    -1,    -1,    -1,    94,    -1,    96,    -1,
    4044,    -1,    -1,    -1,    -1,  2168,    -1,    -1,   106,    -1,
     283,    -1,   456,    -1,  2177,  4059,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2187,    -1,    -1,   501,    -1,  4073,
      -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,   147,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,    -1,   533,
      -1,   159,   160,    -1,    -1,   163,  2229,    -1,    -1,   342,
      -1,   169,    -1,   346,  2237,   173,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   357,   529,    -1,    -1,    -1,    -1,
     564,    -1,    -1,    -1,    -1,   368,    -1,   195,   572,    -1,
     574,   575,   576,   577,   578,    -1,   379,   581,   582,   583,
    4154,    -1,    -1,    -1,   588,    -1,   214,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2311,   422,
      -1,    -1,   425,   426,  4198,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4208,    -1,  4210,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4223,
      -1,  4225,    -1,   456,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1438,  1439,    -1,    -1,    -1,    -1,    -1,    -1,
    4254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2401,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4293,
      -1,    -1,    -1,  2416,    -1,    -1,   529,    -1,    -1,    -1,
      -1,    -1,    -1,  2426,    -1,    -1,    -1,    -1,    -1,    -1,
    2433,    -1,    -1,    -1,    -1,    -1,  2439,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4341,    -1,    -1,
      -1,    -1,    -1,  1539,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4363,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1576,  1577,  2505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4394,    -1,    -1,  4397,    -1,  2518,    -1,    -1,  2521,    -1,
      -1,    -1,  2525,    -1,    -1,    -1,   464,  1603,    -1,    -1,
    2533,    -1,    -1,    -1,    -1,    -1,  2539,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2552,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2565,  2566,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2594,  2595,    -1,  4478,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1693,  1694,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2666,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2717,  2718,    -1,    -1,    -1,    -1,
    2723,  2724,    -1,    -1,    -1,    -1,    -1,  2730,  2731,  2732,
      -1,    -1,    -1,  2736,    -1,  2738,  2739,  2740,  2741,  2742,
    2743,    -1,  2745,    -1,  2747,  2748,    -1,    -1,  2751,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2765,  2766,  2767,  2768,  2769,  2770,    -1,    -1,
      -1,  2774,    -1,    -1,    -1,  2778,    -1,    -1,  2781,    -1,
      -1,  2784,  2785,  2786,  2787,  2788,  2789,  2790,  2791,  2792,
      -1,  2794,    -1,    -1,  4678,    -1,   734,    -1,    -1,  2802,
      -1,    -1,  2805,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   784,   785,  4732,    -1,
      -1,   140,    -1,  4737,    -1,  4739,    -1,    -1,    -1,    -1,
      -1,    -1,  2865,    -1,    -1,   154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,  4767,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   832,    -1,    -1,    -1,    -1,    -1,
     189,  4785,    -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4801,    -1,    -1,
    4804,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     229,    -1,    -1,    -1,    -1,    -1,  4830,    -1,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     259,    -1,    -1,    -1,   263,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2993,    -1,   281,    -1,  2997,  2998,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3011,    -1,
      -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,    -1,
    4904,  4905,    -1,    -1,    -1,    -1,  4910,    -1,    -1,   318,
      -1,    -1,    -1,    -1,  4918,    -1,    -1,    -1,   327,    -1,
      -1,    -1,  3045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4937,  3057,   344,    -1,    -1,  3061,    -1,
      -1,  3064,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3073,    -1,    -1,    -1,    -1,    -1,   365,   366,    -1,    -1,
     369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3099,    -1,    -1,    -1,
      -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3117,   404,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   414,    -1,  1065,  1066,    -1,
    1068,    -1,  5016,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   433,    -1,  3149,    -1,    -1,    -1,
      -1,  3154,    -1,   442,    -1,    -1,    -1,    -1,    -1,    -1,
     449,    -1,    -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,
     459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   474,  2262,  3190,    -1,    -1,
      -1,    -1,   481,  1131,    -1,    -1,  1134,  1135,  3201,    -1,
      -1,   490,    -1,    -1,   493,   494,    -1,   496,   497,    -1,
      -1,  1149,    -1,  1151,    -1,  1153,    -1,   506,    -1,    -1,
      -1,  1159,   511,    -1,    -1,  1163,    -1,    -1,   517,    -1,
      -1,    -1,   521,    -1,    -1,    -1,   525,  3240,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1183,    -1,  1185,    -1,   538,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2358,  2359,  2360,  2361,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1238,    -1,  1240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3329,  3330,    -1,    -1,
      -1,    -1,    -1,    -1,  2410,  2411,    -1,  3340,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2432,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5261,    -1,    -1,
      -1,    -1,  5266,    -1,    -1,  3388,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2479,  2480,  2481,  2482,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1358,  5305,    -1,    -1,  3427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5317,  1372,  1373,    -1,    -1,  1376,    -1,
      -1,  3444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5383,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2603,    -1,    -1,
      -1,    -1,  2608,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5445,    -1,    -1,    -1,    -1,  3569,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3586,  3587,    -1,    -1,  3590,    -1,    -1,
    3593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3614,    -1,    -1,    -1,    -1,  3619,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3642,
    3643,  3644,    -1,    -1,  3647,    -1,    -1,  5531,    -1,    -1,
      -1,    -1,  3655,  3656,  3657,  3658,    -1,    -1,    -1,    -1,
    3663,    -1,    -1,    -1,    -1,  3668,  3669,    -1,  3671,    -1,
    3673,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3684,  3685,    -1,    -1,  3688,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2773,    -1,  3702,
      -1,  3704,    -1,  3706,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1090,    -1,    -1,  3726,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3737,    -1,  3739,  3740,  3741,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3764,    -1,    -1,    -1,    -1,  5650,    -1,  5652,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3795,    -1,    -1,    -1,    -1,  3800,    -1,    -1,
      -1,    -1,    -1,  3806,  1742,    -1,    -1,    -1,    -1,  1747,
      -1,  1749,    -1,  3816,  1752,  5699,  1754,    -1,    -1,  1757,
    1758,  1759,    -1,    -1,    -1,  1763,    -1,    -1,    -1,    -1,
      -1,    -1,  1770,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1784,    -1,    -1,  1787,
      -1,    -1,    -1,    -1,    -1,  3858,    -1,    -1,  3861,  1797,
    3863,    -1,  5746,    -1,    -1,  3868,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3891,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3919,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5809,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3936,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3961,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3059,  3060,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3068,    -1,  3070,  1933,    -1,    -1,  3074,    -1,
      -1,    -1,    -1,  4006,  4007,  4008,  1944,  1945,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1961,    -1,    -1,    -1,    -1,  1966,  1967,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4044,    -1,    -1,    -1,    -1,  4049,    -1,  4051,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5951,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5977,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5989,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1512,  3219,    -1,    -1,  3222,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4168,  1536,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1553,    -1,    -1,    -1,  2125,    -1,  2127,
    4193,    -1,    -1,    -1,    -1,  4198,  4199,    -1,    -1,  2137,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3301,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3309,  3310,    -1,    -1,    -1,    -1,    -1,
    3316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4254,    -1,    -1,    -1,  3331,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4278,    -1,    -1,  2216,    -1,
      -1,    -1,    -1,    -1,  1654,    -1,    -1,    -1,    -1,  2227,
      -1,  4294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4309,    -1,    -1,    -1,
    6194,  3387,  6196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3415,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2312,    -1,    -1,  2315,  2316,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3473,    -1,  3475,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6293,
      -1,    -1,    -1,    -1,    -1,  4418,    -1,    -1,  4421,    -1,
      -1,    -1,    -1,    -1,  4427,    -1,    -1,  6311,  1798,    -1,
    4433,    -1,  4435,    -1,    -1,  4438,    -1,    -1,    -1,  4442,
    4443,  4444,  4445,  4446,    -1,    -1,  4449,  4450,  4451,  4452,
    4453,  4454,  4455,  4456,  4457,  4458,  6340,    -1,    -1,  4462,
    4463,    -1,    -1,    -1,  4467,    -1,    -1,    -1,    -1,  4472,
    2408,    -1,    -1,  4476,    -1,  4478,    -1,  4480,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4488,    -1,    -1,  4491,    -1,
    4493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4501,  4502,
      -1,    -1,  4505,  4506,    -1,    -1,    -1,  4510,  4511,    -1,
      -1,    -1,    -1,    -1,  4517,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4527,    -1,    -1,  4530,    -1,    -1,
      -1,  3607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4543,    -1,    -1,    -1,    -1,    -1,  4549,  4550,  4551,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4619,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6524,    -1,    -1,    -1,  4647,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6578,    -1,    -1,  2635,    -1,  2637,
      -1,    -1,    -1,  2641,    -1,  2643,    -1,    -1,  2646,    -1,
      -1,    -1,  2650,    -1,  6598,    -1,    -1,  2655,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4732,
      -1,    -1,    -1,    -1,  4737,  4738,  4739,  4740,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1090,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4767,  4768,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1118,    -1,    -1,
      -1,    -1,  4785,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2168,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,  3925,
     232,  3927,  3928,  3929,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2801,    -1,    -1,    -1,  2237,    -1,    -1,
    2808,    -1,    -1,    -1,  4877,    -1,    -1,    -1,    -1,    -1,
    2818,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4910,  4911,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2288,    -1,
      -1,    -1,  4925,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4958,  4959,  4960,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2905,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2960,    -1,    -1,    -1,  2964,    -1,    -1,    -1,
      -1,  2401,  2970,    -1,  2972,    -1,    -1,  2975,    -1,    -1,
    5043,    -1,    -1,    -1,    -1,    -1,  2416,    -1,    -1,    -1,
      -1,  5054,    -1,    -1,    -1,    -1,  2426,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5084,    -1,    -1,    -1,    -1,  3024,    -1,    -1,    -1,
      -1,  5094,  5095,  4169,  5097,    -1,    -1,    -1,  5101,  5102,
      -1,    -1,    -1,  5106,  5107,    -1,    -1,    -1,  5111,    -1,
      -1,  5114,  5115,    -1,    -1,    -1,  5119,    -1,    -1,    -1,
      -1,    -1,  5125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5137,  2505,    -1,    -1,    -1,    -1,
      -1,    -1,  5145,    -1,    -1,    -1,  5149,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2525,    -1,    -1,    -1,  5162,
      -1,    -1,    -1,    -1,  5167,    -1,    -1,    -1,    -1,  2539,
    5173,  1512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5195,    -1,    -1,  1536,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1553,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5226,  2594,  2595,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5266,    -1,    -1,    -1,    -1,    -1,  4345,
      -1,    -1,    -1,    -1,    -1,  3213,    -1,    -1,    -1,  5282,
      -1,    -1,    -1,  3221,    -1,    -1,  3224,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5310,    -1,    -1,
      -1,    -1,    -1,  1654,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2765,    -1,    -1,    -1,    -1,
      -1,    -1,  5405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5452,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5493,    -1,  5495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5547,    -1,    -1,    -1,  5551,    -1,
      -1,    -1,    -1,  5556,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5573,  5574,    -1,   955,  5577,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   965,  3522,  3523,    -1,    -1,    -1,  5592,
      -1,    -1,  4668,  4669,  4670,  4671,  5599,    -1,    -1,    -1,
    3538,  5604,    -1,    -1,  5607,  5608,    -1,    -1,    -1,    -1,
      -1,    -1,  5615,  5616,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2993,    -1,    -1,    -1,  2997,  2998,    -1,
      -1,    -1,    -1,    -1,  1016,    -1,    -1,    -1,    -1,  5642,
      -1,  5644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5656,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3061,    -1,  5696,  5697,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1084,  3073,    -1,  5708,    -1,    -1,  1090,    -1,
      -1,    -1,  1094,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1118,    -1,    -1,    -1,
      -1,    -1,    -1,  5746,    -1,    -1,    -1,  3117,    -1,  5752,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4868,    -1,    -1,    -1,    -1,    -1,    -1,  4875,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3755,    -1,    -1,
      -1,  5824,  3760,  5826,    -1,    -1,    -1,  2168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1235,  1236,    -1,  5859,  5860,    -1,  5862,
    1242,  5864,    -1,    -1,  1246,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5884,    -1,    -1,    -1,    -1,    -1,  5890,    -1,    -1,
    1272,  5894,    -1,    -1,    -1,    -1,  2237,  5900,    -1,    -1,
      -1,    -1,  5905,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2288,  5951,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5960,    -1,    -1,
    3330,    -1,  5965,  5966,    -1,    -1,    -1,  5970,    -1,    -1,
    2311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6021,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6044,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3427,    -1,    -1,
    2401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2416,  6079,  6080,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2426,  1468,  1469,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2439,    -1,
      -1,    -1,  6105,    -1,    -1,  6108,    -1,    -1,  6111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6122,
      -1,    -1,    -1,  1505,  6127,    -1,  6129,    -1,  6131,    -1,
    1512,    -1,    -1,    -1,  1516,    -1,    -1,  6140,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1536,  6158,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2505,    -1,    -1,    -1,    -1,    -1,
      -1,  1553,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2525,    -1,    -1,    -1,    -1,    -1,
      -1,  6194,    -1,    -1,    -1,    -1,    -1,    -1,  2539,  3569,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3590,    -1,    -1,  1605,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3604,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6253,    -1,    -1,  2594,  2595,  4193,    -1,    -1,    -1,    -1,
      -1,  4199,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1654,    -1,    -1,    -1,    -1,    -1,    -1,  5355,
      -1,  6284,  6285,    -1,    -1,    -1,    -1,    -1,    -1,  6292,
    6293,    -1,    -1,  6296,  5370,    -1,    -1,    -1,    -1,  6302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1734,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4307,
      -1,    -1,    -1,    -1,    -1,    -1,  6379,    -1,    -1,    -1,
      -1,  6384,    -1,    -1,    -1,    -1,    -1,    -1,  5464,    -1,
      -1,  6394,    -1,    -1,    -1,    -1,    -1,  6400,  6401,    -1,
      -1,    -1,  6405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6414,    -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2765,    -1,    -1,    -1,  6431,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1819,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1836,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6469,    -1,    -1,  4407,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1866,    -1,    -1,    -1,  3858,    -1,
      -1,  3861,    -1,  3863,    -1,    -1,  6499,    -1,  3868,    -1,
      -1,  6504,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1898,  1899,  1900,    -1,
    1902,  6524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1922,  6544,    -1,    -1,    -1,    -1,    -1,  6550,    -1,  3919,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6566,    -1,    -1,  3936,    -1,    -1,    -1,
      -1,    -1,    -1,  6576,    -1,  6578,    -1,    -1,    -1,    -1,
      -1,    -1,  5658,  5659,  5660,    -1,    -1,    -1,    -1,    -1,
      -1,  3961,    -1,    -1,    -1,  6598,    -1,  6600,  6601,    -1,
    6603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2993,    -1,    -1,    -1,  2997,  2998,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4049,
      -1,  4051,    -1,    -1,    -1,    -1,  4624,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2081,
      -1,    -1,    -1,  2085,  2086,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2100,    -1,
    3061,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3073,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5822,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4168,    -1,
    4738,    -1,    -1,    -1,    -1,  2187,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4193,    -1,    -1,    -1,    -1,    -1,  4199,
    4768,    -1,    -1,    -1,    -1,    -1,  4774,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2229,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2237,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5981,  2288,  5983,  4278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4294,    -1,    -1,    -1,    -1,  2311,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4309,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3330,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2401,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2416,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2426,    -1,    -1,    -1,    -1,    -1,
      -1,  4421,    -1,    -1,    -1,    -1,    -1,  2439,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6146,    -1,  4442,    -1,    -1,  5013,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3427,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4467,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1090,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2505,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4501,    -1,    -1,  1118,    -1,  2518,    -1,    -1,  2521,
      -1,    -1,    -1,  2525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2533,    -1,    -1,    -1,    -1,    -1,  2539,    -1,  6235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2565,  2566,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2594,  2595,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3569,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3590,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3604,    -1,  4635,  6342,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2666,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5272,  2717,  2718,    -1,  5276,    -1,
      -1,  2723,  2724,    -1,    -1,    -1,    -1,    -1,  2730,  2731,
    2732,    -1,    -1,    -1,  2736,    -1,  2738,  2739,  2740,  2741,
    2742,  2743,  6438,  2745,    -1,  2747,  2748,    -1,  4738,  2751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2765,  2766,  2767,  2768,  2769,    -1,    -1,
      -1,    -1,  2774,    -1,  6470,  6471,  2778,    -1,  4768,  2781,
      -1,    -1,  2784,  2785,  2786,  2787,  2788,  2789,  2790,  2791,
    2792,    -1,  2794,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2802,    -1,    -1,  2805,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2865,    -1,    -1,    -1,    -1,    -1,  6565,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3858,    -1,    -1,
    3861,    -1,  3863,    -1,    -1,    -1,    -1,  3868,  1512,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4911,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1553,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3919,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4958,    -1,
      -1,    -1,    -1,    -1,    -1,  3936,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2993,    -1,    -1,    -1,  2997,  2998,    -1,    -1,    -1,
    3961,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3045,    -1,    -1,    -1,    -1,    -1,    -1,
    1654,    -1,    -1,    -1,    -1,  3057,    -1,    -1,    -1,  3061,
      -1,    -1,  3064,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3073,    -1,    -1,    -1,    -1,    -1,  5635,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4049,    -1,
    4051,    -1,    -1,    -1,    -1,    -1,    -1,  3099,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5097,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3117,    -1,  5107,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5696,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4134,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,    -1,  3201,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4193,    -1,    -1,    -1,    -1,    -1,  4199,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5244,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4278,    -1,    -1,
    5310,    -1,    -1,    -1,    -1,    -1,    -1,  3329,  3330,    -1,
      -1,    -1,    -1,  4294,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4309,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5375,  3388,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5975,  5976,    -1,
      -1,    -1,    -1,    -1,    -1,  3427,    -1,    -1,    -1,    -1,
      -1,  5989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5495,  4467,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6090,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4501,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5551,    -1,    -1,  2168,    -1,    -1,  3569,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3586,  3587,    -1,    -1,  3590,    -1,
      -1,  3593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3614,    -1,    -1,    -1,    -1,  3619,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2237,    -1,    -1,    -1,    -1,    -1,    -1,
    3642,  3643,  3644,    -1,    -1,  3647,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3655,  3656,  3657,  3658,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3668,    -1,    -1,  3671,
      -1,  3673,    -1,    -1,  4635,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3684,  3685,  2288,    -1,  3688,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3702,    -1,  3704,    -1,  3706,    -1,  5696,  2311,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3726,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3737,    -1,  3739,  3740,  3741,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3764,   169,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4738,  6336,    -1,
    6338,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3795,    -1,    -1,    -1,  2401,  3800,    -1,
      -1,    -1,    -1,    -1,  3806,    -1,    -1,  4768,   214,    -1,
      -1,    -1,  2416,    -1,  3816,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2439,  5826,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3858,    -1,   264,  3861,
      -1,  3863,    -1,    -1,    -1,    -1,  3868,    -1,    -1,    -1,
    5860,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3891,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5900,    -1,    -1,    -1,    -1,    -1,    -1,  3919,    -1,    -1,
      -1,  2525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3936,  2539,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2552,    -1,
    4911,    -1,    -1,    -1,    -1,    -1,    -1,  6515,    -1,  3961,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5960,    -1,    -1,    -1,    -1,  5965,  5966,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2594,  2595,    -1,    -1,    -1,    -1,    -1,  4958,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4049,    -1,  4051,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   464,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4134,    -1,    -1,    -1,  5097,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2765,    -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4193,    -1,    -1,    -1,    -1,    -1,  4199,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4278,    -1,    -1,    -1,
      -1,    -1,    -1,  5244,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6296,  4309,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5310,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   784,   785,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2993,
      -1,    -1,    -1,  2997,  2998,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5375,    -1,  4418,    -1,    -1,  4421,
      -1,    -1,    -1,    -1,    -1,  4427,   832,    -1,    -1,    -1,
      -1,  4433,    -1,  4435,    -1,    -1,  4438,    -1,    -1,    -1,
    4442,  4443,  4444,  4445,  4446,    -1,    -1,  4449,  4450,  4451,
    4452,  4453,  4454,  4455,  4456,  4457,  4458,  3061,    -1,    -1,
    4462,  4463,    -1,    -1,    -1,  4467,    -1,    -1,    -1,  3073,
    4472,    -1,    -1,    -1,  4476,    -1,    -1,    -1,  4480,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4488,    -1,    -1,  4491,
      -1,  4493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4501,
    4502,    -1,    -1,  4505,  4506,    -1,    -1,    -1,  4510,  4511,
      -1,    -1,    -1,  3117,    -1,  4517,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4527,    -1,    -1,  4530,    -1,
      -1,    -1,    -1,    -1,  5495,    -1,    -1,    -1,    -1,    -1,
      -1,  4543,    -1,    -1,    -1,    -1,    -1,  4549,  4550,  4551,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   963,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   974,    -1,
     976,    -1,   978,   979,    -1,   981,   982,    -1,   984,    -1,
      -1,   987,    -1,   989,    -1,    -1,    -1,    -1,    -1,    -1,
    5551,   997,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1017,    -1,    -1,    -1,    -1,    -1,  4619,    -1,    -1,
    1026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1037,  1038,  4635,    -1,  1041,    -1,    -1,  1044,  1045,
      -1,    -1,    -1,  1049,    -1,  4647,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1066,    -1,  1068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1085,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1112,    -1,  1114,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1123,  1124,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3330,    -1,    -1,  1135,
      -1,    -1,    -1,    -1,    -1,  5696,  4738,    -1,  4740,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4768,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1204,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3427,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5826,    -1,  1273,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4877,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5860,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4911,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4925,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5900,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4958,  4959,  4960,    -1,
      -1,    -1,    -1,    -1,    -1,  3569,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1385,
      -1,  1387,    -1,    -1,    -1,  1391,  3590,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5960,
    3604,    -1,    -1,    -1,  5965,  5966,    -1,    -1,  1414,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5043,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1483,    -1,    -1,
      -1,    -1,  5084,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5094,  5095,    -1,  5097,    -1,    -1,    -1,  5101,
    5102,    -1,    -1,  1509,  5106,  5107,    -1,    -1,    -1,  5111,
      -1,    -1,  5114,  5115,    -1,  1521,    -1,  5119,  1524,  6080,
      -1,    -1,    -1,  5125,    -1,    -1,    -1,    -1,    -1,  1535,
      -1,    -1,    -1,    -1,  1540,  5137,    -1,    -1,    -1,    -1,
      -1,    -1,  1548,  5145,    -1,    -1,    -1,  5149,    -1,    -1,
    1556,    -1,    -1,    -1,  1560,    -1,    -1,    -1,    -1,    -1,
    5162,    -1,    -1,    -1,    -1,  5167,    -1,    -1,    -1,  1575,
      -1,  5173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5195,    -1,    -1,    -1,    -1,    -1,    -1,
    1606,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3858,    -1,    -1,  3861,    -1,  3863,
      -1,    -1,    -1,    -1,  3868,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5282,    -1,    -1,    -1,    -1,    -1,  1692,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5310,    -1,
      -1,    -1,    -1,    -1,    -1,  3919,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1729,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5333,  3936,    -1,    -1,  6296,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3961,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5375,    -1,  1781,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1795,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5405,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4049,    -1,  4051,    -1,    -1,
    5452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5493,    -1,  5495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5547,    -1,    -1,    -1,  5551,
      -1,    -1,    -1,    -1,  5556,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,    -1,
      -1,  5573,  5574,    -1,    -1,  5577,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1993,  1994,  4193,
    5592,    -1,    -1,    -1,    -1,  4199,    -1,  5599,    -1,    -1,
      -1,    -1,  5604,    -1,    -1,  5607,  5608,    -1,    -1,    -1,
      -1,    -1,    -1,  5615,  5616,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5642,    -1,  5644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5656,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4294,    -1,    -1,    -1,  5696,  5697,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4309,  5708,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2130,    -1,    -1,  2133,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2141,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5752,    -1,    -1,  2159,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4421,    -1,    -1,
      -1,    -1,  5824,    -1,  5826,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4442,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5859,  5860,    -1,
    5862,    -1,  5864,  4467,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5884,    -1,    -1,    -1,    -1,  2293,  5890,    -1,
      -1,    -1,  5894,    -1,    -1,    -1,    -1,  4501,  5900,    -1,
      -1,    -1,    -1,  5905,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5960,    -1,
      -1,    -1,    -1,  5965,  5966,    -1,    -1,    -1,  5970,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2388,  2389,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6021,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4635,    -1,    -1,    -1,    -1,    -1,    -1,  2444,    -1,
      -1,    -1,  6044,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6079,  6080,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6105,    -1,    -1,  6108,    -1,    -1,  6111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6122,    -1,    -1,    -1,    -1,  6127,    -1,  6129,    -1,  6131,
      -1,    -1,    -1,    -1,  4738,    -1,    -1,    -1,  6140,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6158,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4768,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2587,    -1,  2589,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2605,
      -1,  2607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6245,    -1,  2651,    -1,    -1,    -1,    -1,
      -1,  6253,    -1,    -1,    -1,    -1,    -1,  2663,    -1,    -1,
      -1,  2667,    -1,  2669,    -1,    -1,  2672,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6284,  6285,    -1,    -1,    -1,    -1,    -1,    -1,
    6292,    -1,    -1,    -1,  6296,    -1,    -1,    -1,    -1,    -1,
    6302,    -1,    -1,    -1,    -1,    -1,    -1,  4911,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6325,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4958,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6379,    -1,    -1,
      -1,    -1,  6384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6394,    -1,    -1,    -1,    -1,    -1,  6400,  6401,
      -1,    -1,  2808,  6405,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6431,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6469,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5097,    -1,    -1,    -1,  6499,    -1,    -1,
      -1,    -1,  6504,  5107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6544,    -1,    -1,    -1,    -1,    -1,  6550,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6566,    -1,    -1,    -1,    -1,  2975,
      -1,    -1,    -1,    -1,  6576,    -1,    -1,    -1,    -1,    -1,
      -1,  2987,  2988,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6600,  6601,
      -1,  6603,  3008,  3009,    -1,    -1,    -1,  3013,  3014,    -1,
      -1,    -1,  3018,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3032,    -1,    -1,    -1,
      -1,    -1,    -1,  3039,    -1,    -1,    -1,  3043,  3044,    -1,
    5244,  3047,  3048,    -1,    -1,    -1,    -1,    -1,  3054,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3067,    -1,  3069,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5282,    -1,
      -1,    -1,    -1,  3089,    -1,    -1,    -1,    -1,  3094,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3108,    -1,    -1,    -1,  5310,    -1,    -1,    -1,
      -1,    -1,    -1,  3119,    -1,    -1,  3122,    -1,    -1,    -1,
    3126,  3127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3135,
      -1,    -1,    -1,    -1,  3140,  3141,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3152,    -1,    -1,    -1,
      -1,    -1,  3158,    -1,    -1,    -1,    -1,    -1,    -1,  3165,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3189,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3197,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3220,    -1,    -1,  3223,    -1,    -1,
      -1,    -1,  3228,    -1,    -1,    -1,  3232,    -1,  3234,  3235,
      -1,    -1,    -1,  3239,    -1,    -1,  3242,    -1,    -1,    -1,
    3246,  3247,  3248,  3249,    -1,  3251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3264,  3265,
      -1,  3267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3277,  3278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5495,    -1,    -1,    -1,     6,     7,     8,    -1,    10,
      11,    12,    -1,    -1,    -1,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    -1,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    -1,    -1,  3341,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5551,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,   955,    -1,    -1,    -1,  3381,    -1,    -1,    -1,    -1,
      -1,   965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,   126,   127,   128,   129,   130,
     131,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1016,   144,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   152,    -1,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   175,  3471,    -1,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   193,   194,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1084,    -1,    -1,    -1,    -1,    -1,  1090,    -1,    -1,    -1,
    1094,    -1,    -1,    -1,    -1,    -1,  3522,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,    -1,  3535,
     241,    -1,    -1,    -1,  1118,    -1,   247,    -1,    -1,    -1,
      -1,    -1,   253,    -1,   255,    -1,    -1,    -1,    -1,    -1,
      -1,   262,    -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,  3574,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,
      -1,    -1,    -1,   294,    -1,   296,    -1,    -1,   299,   300,
      -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     311,   312,  3608,   314,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5826,    -1,    -1,    -1,   337,   338,   339,    -1,
      -1,    -1,    -1,    -1,   345,    -1,    -1,    -1,   349,    -1,
      -1,   352,    -1,   354,   355,    -1,    -1,    -1,    -1,    -1,
      -1,  1235,  1236,    -1,    -1,    -1,  5860,    -1,    -1,    -1,
      -1,   372,   373,    -1,   375,   376,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     391,    -1,   393,    -1,    -1,    -1,    -1,    -1,  1272,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5900,    -1,    -1,   410,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   432,    -1,    -1,    -1,    -1,   437,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,
      -1,   462,    -1,    -1,    -1,   466,  5960,    -1,    -1,    -1,
      -1,  5965,  5966,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   482,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,   499,   500,
      -1,    -1,    -1,    -1,   505,    -1,   507,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   533,    -1,    -1,   536,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6080,    -1,    -1,    -1,
      -1,    -1,  3888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3913,    -1,    -1,
      -1,  3917,    -1,    -1,    -1,    -1,    -1,  3923,    -1,    -1,
      -1,  1505,    -1,    -1,    -1,    -1,    -1,    -1,  1512,    -1,
      -1,    -1,  1516,  3939,  3940,    -1,    -1,    -1,  3944,    -1,
      -1,    -1,    -1,  3949,  3950,  3951,    -1,  3953,    -1,    -1,
      -1,    -1,  1536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1553,
      -1,    -1,  3978,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3986,    -1,    -1,    -1,    -1,    -1,    -1,  3993,  3994,  3995,
    3996,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1605,    -1,    -1,    -1,    -1,    -1,    -1,  4034,    -1,
      -1,  4037,  4038,  4039,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4155,
    1734,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1819,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1836,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4268,    -1,    -1,    -1,    -1,  4273,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1866,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4301,    -1,    -1,    -1,    -1,
      -1,  4307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1898,  1899,  1900,    -1,  1902,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4338,    -1,  4340,    -1,    -1,    -1,  1922,    -1,
      -1,  4347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4359,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2081,    -1,    -1,
      -1,  2085,  2086,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4654,    -1,
    4656,    -1,    -1,  2237,    -1,    -1,    -1,  4663,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4679,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4695,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2288,    -1,    -1,  4713,    -1,  4715,
    4716,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2311,    -1,  4735,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4747,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4770,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4781,  4782,  4783,    -1,    -1,
      -1,    -1,    -1,  4789,  4790,  4791,  4792,    -1,    -1,    -1,
    4796,  4797,    -1,    -1,    -1,    -1,  4802,  4803,    -1,  4805,
    4806,  4807,  4808,  4809,  4810,    -1,  4812,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4821,    -1,  2401,  4824,  4825,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2416,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2426,    -1,    -1,    -1,    -1,  4853,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2439,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4876,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2518,    -1,    -1,  2521,    -1,    -1,
      -1,  2525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2533,
      -1,    -1,    -1,    -1,    -1,  2539,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2552,    -1,
      -1,  4977,    -1,    -1,  1235,  1236,    -1,    -1,    -1,    -1,
      -1,  2565,  2566,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5009,  5010,  5011,    -1,    -1,    -1,    -1,
    2594,  2595,    -1,    -1,  5020,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1090,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2717,  2718,  1118,    -1,    -1,    -1,  2723,
    2724,    -1,    -1,    -1,    -1,    -1,  2730,  2731,  2732,    -1,
      -1,    -1,  2736,    -1,  2738,  2739,  2740,  2741,  2742,  2743,
      -1,  2745,    -1,  2747,  2748,    -1,    -1,  2751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2765,  2766,  2767,  2768,  2769,    -1,    -1,    -1,    -1,
    2774,    -1,    -1,    -1,  2778,    -1,    -1,  2781,    -1,    -1,
    2784,  2785,  2786,  2787,  2788,  2789,  2790,  2791,  2792,    -1,
    2794,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2802,    -1,
      -1,  2805,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5252,    -1,    -1,    -1,
    5256,  5257,  5258,  5259,    -1,    -1,  5262,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5299,  5300,  5301,    -1,  5303,    -1,    -1,
    5306,  5307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5318,  5319,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5345,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5353,  5354,    -1,
    5356,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2993,
      -1,    -1,    -1,  2997,  2998,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5451,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3057,  5480,    -1,    -1,  3061,    -1,    -1,
    3064,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3073,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5514,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1512,
      -1,    -1,    -1,  3117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1536,    -1,    -1,    -1,    -1,  1819,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1553,    -1,    -1,    -1,    -1,  1836,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1866,  5612,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1898,  1899,  1900,
      -1,  1902,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5700,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5718,    -1,    -1,    -1,    -1,  5723,  5724,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3329,  3330,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5799,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3388,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,    -1,
    2081,    -1,    -1,    -1,  2085,  2086,    -1,    -1,    -1,    -1,
      -1,  5837,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5848,  3427,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5898,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1090,    -1,    -1,    -1,    -1,
    5926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5947,    -1,  1118,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5959,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5984,    -1,
      -1,    -1,    -1,    -1,    -1,  3569,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3586,  3587,    -1,    -1,  3590,    -1,    -1,  3593,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6025,
    3604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3614,    -1,    -1,    -1,    -1,  3619,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3642,  3643,
    3644,    -1,    -1,  3647,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3655,  3656,  3657,  3658,    -1,    -1,    -1,    -1,    -1,
      -1,  6087,    -1,    -1,  3668,    -1,    -1,  3671,    -1,  3673,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3684,  3685,    -1,    -1,  3688,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6119,    -1,    -1,    -1,    -1,  3702,    -1,
    3704,    -1,  3706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3726,    -1,    -1,    -1,    -1,    -1,    -1,  6155,
      -1,    -1,    -1,  3737,    -1,  3739,  3740,  3741,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6171,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3764,    -1,    -1,    -1,    -1,  2168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3795,    -1,    -1,    -1,    -1,  3800,    -1,    -1,  6225,
      -1,    -1,  3806,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3816,  6239,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2237,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3858,    -1,    -1,  3861,    -1,  3863,
      -1,    -1,    -1,    -1,  3868,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2288,    -1,  3891,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6324,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2311,    -1,
      -1,    -1,    -1,    -1,    -1,  3919,    -1,  1512,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3936,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1536,    -1,    -1,  6370,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3961,  1553,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2401,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2416,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2426,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6457,    -1,    -1,    -1,    -1,  2439,    -1,    -1,    -1,
      -1,    -1,  2723,    -1,    -1,  4049,    -1,  4051,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2736,    -1,  2738,    -1,  1654,
    2741,  2742,  2743,    -1,    -1,    -1,    -1,  2748,    -1,    -1,
    2751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2766,  2767,  2768,  2769,    -1,
      -1,    -1,    -1,  2774,    -1,    -1,    -1,  2778,    -1,    -1,
    2781,    -1,  2505,  2784,  2785,  2786,  2787,  2788,  2789,  2790,
    2791,  2792,    -1,  2794,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2802,  2525,    -1,  2805,    -1,    -1,    -1,    -1,    -1,
    4134,    -1,    -1,    -1,    -1,    -1,  2539,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2552,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2865,    -1,    -1,    -1,    -1,  4193,
      -1,  2594,  2595,    -1,    -1,  4199,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1798,    -1,    -1,  1090,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4309,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2765,    -1,  3045,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2805,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4418,    -1,    -1,  4421,    -1,    -1,
      -1,    -1,    -1,  4427,    -1,    -1,    -1,    -1,    -1,  4433,
      -1,  4435,    -1,    -1,  4438,    -1,    -1,    -1,  4442,  4443,
    4444,  4445,  4446,    -1,    -1,  4449,  4450,  4451,  4452,  4453,
    4454,  4455,  4456,  4457,  4458,    -1,    -1,    -1,  4462,  4463,
      -1,    -1,    -1,  4467,    -1,    -1,    -1,    -1,  4472,    -1,
      -1,    -1,  4476,    -1,    -1,    -1,  4480,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4488,    -1,    -1,  4491,    -1,  4493,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4501,  4502,    -1,
      -1,  4505,  4506,    -1,    -1,    -1,  4510,  4511,    -1,    -1,
      -1,    -1,    -1,  4517,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4527,    -1,    -1,  4530,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4543,
      -1,    -1,    -1,    -1,    -1,  4549,  4550,  4551,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2993,    -1,    -1,    -1,  2997,  2998,    -1,    -1,    -1,  4603,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4619,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1512,    -1,
      -1,  4635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2237,  4647,    -1,    -1,    -1,    -1,  3329,    -1,
      -1,    -1,  1536,    -1,    -1,    -1,    -1,    -1,  3061,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1553,
    3073,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3117,    -1,  2311,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4738,    -1,  4740,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4768,    -1,    -1,    -1,    -1,    -1,
    1654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2401,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2416,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2439,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4877,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3586,    -1,  4911,    -1,    -1,
    2505,    -1,    -1,    -1,  1798,    -1,    -1,    -1,    -1,    -1,
      -1,  4925,    -1,    -1,    -1,    -1,    -1,  3330,    -1,    -1,
    2525,    -1,    -1,  3614,    -1,    -1,    -1,    -1,  3619,    -1,
      -1,    -1,    -1,    -1,  2539,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4958,  4959,  4960,  2552,    -1,    -1,
      -1,    -1,    -1,  3644,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3655,    -1,  3657,  3658,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3668,    -1,    -1,
    3671,    -1,  3673,    -1,    -1,    -1,    -1,    -1,    -1,  2594,
    2595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3702,    -1,  3704,  3427,  3706,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5043,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3739,  3740,
    3741,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5084,    -1,    -1,  3764,    -1,    -1,    -1,    -1,    -1,    -1,
    5094,  5095,    -1,  5097,    -1,    -1,    -1,  5101,  5102,    -1,
      -1,    -1,  5106,  5107,    -1,    -1,    -1,  5111,    -1,    -1,
    5114,  5115,    -1,    -1,  3795,  5119,    -1,    -1,    -1,  3800,
      -1,  5125,    -1,    -1,    -1,  3806,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5137,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5145,    -1,    -1,    -1,  5149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5162,    -1,
      -1,    -1,    -1,  5167,    -1,    -1,  3569,    -1,    -1,  5173,
    2765,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3590,    -1,    -1,
      -1,  5195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3891,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5282,    -1,
      -1,    -1,    -1,    -1,  2168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5310,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5333,
      -1,    -1,    -1,    -1,    -1,    -1,  3739,  3740,  3741,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2237,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2993,    -1,
      -1,  5405,  2997,  2998,  2288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2311,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5452,    -1,
      -1,    -1,    -1,    -1,    -1,  3858,    -1,    -1,  3861,    -1,
    3863,    -1,    -1,    -1,    -1,  3868,  3061,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3073,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5493,
      -1,  5495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3919,  2401,    -1,    -1,
      -1,    -1,  3117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2416,  3936,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2426,  5547,    -1,    -1,    -1,  5551,    -1,    -1,
      -1,    -1,  5556,    -1,    -1,  2439,    -1,    -1,  3961,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5573,
    5574,    -1,    -1,  5577,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5592,    -1,
      -1,    -1,    -1,    -1,    -1,  5599,    -1,    -1,    -1,    -1,
    5604,    -1,    -1,  5607,  5608,    -1,    -1,    -1,    -1,    -1,
      -1,  5615,  5616,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5642,    -1,
    5644,  2525,    -1,    -1,    -1,    -1,  4049,    -1,  4051,    -1,
      -1,    -1,  5656,    -1,    -1,  2539,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2552,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5696,  5697,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5708,    -1,    -1,    -1,    -1,    -1,
    2594,  2595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4134,    -1,    -1,    -1,  3330,    -1,  4418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4427,    -1,  5752,    -1,
      -1,    -1,  4433,    -1,  4435,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4462,  4463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4193,    -1,    -1,    -1,    -1,    -1,  4199,    -1,    -1,  4480,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4488,    -1,    -1,
    4491,    -1,  4493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5824,  4502,  5826,    -1,    -1,    -1,    -1,    -1,    -1,  4510,
    4511,    -1,  3427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5859,  5860,    -1,  5862,    -1,
    5864,    -1,  4543,    -1,    -1,    -1,    -1,    -1,  4549,  4550,
    4551,    -1,    -1,    -1,    -1,  4278,    -1,    -1,    -1,    -1,
    5884,  2765,    -1,    -1,    -1,    -1,  5890,    -1,    -1,    -1,
    5894,  4294,    -1,    -1,    -1,    -1,  5900,    -1,    -1,    -1,
      -1,  5905,    -1,    -1,    -1,    -1,  4309,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4619,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5960,    -1,    -1,    -1,
      -1,  5965,  5966,    -1,    -1,    -1,  5970,  1914,    -1,    -1,
      -1,    -1,    -1,    -1,  3569,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3590,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3604,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6021,  4421,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4442,
    6044,    -1,    -1,  1990,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4467,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6079,  6080,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4501,    -1,
      -1,  6105,    -1,    -1,  6108,    -1,    -1,  6111,    -1,  2993,
      -1,    -1,    -1,  2997,  2998,    -1,    -1,    -1,  6122,    -1,
      -1,    -1,    -1,  6127,    -1,  6129,    -1,  6131,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6140,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4551,    -1,
      -1,    -1,    -1,    -1,  6158,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3061,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3073,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4635,  3117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6253,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3858,    -1,    -1,  3861,    -1,  3863,    -1,
      -1,    -1,    -1,  3868,    -1,    -1,    -1,    -1,  4959,  4960,
    6284,  6285,    -1,    -1,    -1,    -1,    -1,    -1,  6292,    -1,
      -1,    -1,  6296,    -1,    -1,    -1,    -1,    -1,  6302,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6325,    -1,    -1,  3919,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4738,    -1,    -1,    -1,    -1,
      -1,  3936,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5043,    -1,    -1,  4768,  3961,    -1,    -1,    -1,
      -1,    -1,    -1,  5054,    -1,  6379,    -1,    -1,    -1,    -1,
    6384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6394,    -1,    -1,    -1,    -1,    -1,  6400,  6401,    -1,    -1,
      -1,  6405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6414,    -1,    -1,  5094,  5095,    -1,    -1,    -1,    -1,    -1,
    5101,  5102,    -1,    -1,    -1,  5106,    -1,  6431,    -1,    -1,
    5111,    -1,    -1,  5114,  5115,    -1,    -1,    -1,  5119,    -1,
      -1,    -1,    -1,    -1,  5125,    -1,  3330,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4049,    -1,  4051,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6469,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5162,    -1,    -1,    -1,    -1,  5167,    -1,    -1,    -1,
      -1,    -1,  5173,    -1,    -1,  6499,    -1,    -1,    -1,    -1,
    6504,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4911,    -1,
      -1,    -1,    -1,    -1,  5195,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4134,
    6544,    -1,    -1,  3427,    -1,  5226,  6550,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4958,    -1,    -1,    -1,    -1,
      -1,    -1,  6566,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6576,  4168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6600,  6601,  4193,  6603,
      -1,    -1,    -1,    -1,  4199,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4278,    -1,  3569,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5097,    -1,    -1,    -1,    -1,  4294,
      -1,    -1,    -1,    -1,  5107,    -1,  3590,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4309,    -1,    -1,    -1,    -1,    -1,
    3604,    -1,    -1,    -1,  5405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5162,
      -1,    -1,  2709,    -1,  5167,    -1,    -1,    -1,    -1,    -1,
    5173,    -1,    -1,    -1,  2721,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2735,    -1,
      -1,    -1,  2739,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2753,  2754,  2755,    -1,
      -1,  2758,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4421,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5244,    -1,    -1,    -1,    -1,    -1,  4442,    -1,    -1,
      -1,    -1,    -1,  2800,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4467,    -1,    -1,    -1,    -1,    -1,    -1,  5282,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5573,  5574,    -1,    -1,  5577,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4501,  5310,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5615,  5616,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2901,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5644,    -1,    -1,  2913,    -1,    -1,  2916,
      -1,    -1,  5375,    -1,  3858,    -1,    -1,  3861,    -1,  3863,
      -1,    -1,    -1,    -1,  3868,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5697,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3919,    -1,    -1,    -1,    -1,
    4635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3936,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3961,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5493,    -1,  5495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4738,    -1,    -1,    -1,    -1,  5551,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4049,    -1,  4051,    -1,    -1,
      -1,    -1,    -1,  4768,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5862,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5890,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5905,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,  5970,
      -1,    -1,    -1,  5696,  5697,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4193,
      -1,    -1,    -1,    -1,    -1,  4199,  4911,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4958,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5826,    -1,  4309,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6131,    -1,    -1,    -1,    -1,    -1,    -1,  5860,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6158,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5900,    -1,    -1,
      -1,    -1,  5097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4421,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5960,  4442,    -1,
      -1,    -1,  5965,  5966,  6245,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4467,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6284,  6285,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4501,    -1,    -1,
      -1,  6302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3617,    -1,    -1,    -1,    -1,    -1,  6079,  6080,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5282,    -1,    -1,
    3637,    -1,  3639,    -1,    -1,  3642,  3643,    -1,  3645,    -1,
    3647,    -1,    -1,  6384,  3651,    -1,    -1,  3654,    -1,    -1,
      -1,    -1,  3659,    -1,    -1,  5310,    -1,    -1,  3665,    -1,
      -1,    -1,    -1,  3670,  6405,    -1,    -1,    -1,    -1,    -1,
    3677,  3678,  3679,  3680,    -1,    -1,    -1,  3684,  3685,    -1,
    3687,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6431,  4635,  3699,    -1,  3701,    -1,    -1,    -1,    -1,    -1,
      -1,  3708,  3709,  3710,  3711,  3712,  3713,  3714,  3715,  3716,
    3717,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3745,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3775,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4738,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6544,    -1,    -1,    -1,    -1,    -1,  6550,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4768,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6296,    -1,    -1,    -1,    -1,    -1,    -1,
    5495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5551,    -1,    -1,  3906,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4911,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4958,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5097,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5860,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5900,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5244,    -1,    -1,    -1,    -1,  5960,    -1,    -1,    -1,    -1,
    5965,  5966,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5282,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5310,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4400,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4417,    -1,    -1,    -1,    -1,    -1,  4423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6080,    -1,    -1,    -1,    -1,
      -1,  5375,  4439,  4440,    -1,    -1,  4443,  4444,  4445,  4446,
      -1,    -1,  4449,  4450,  4451,  4452,  4453,  4454,  4455,  4456,
    4457,  4458,  4459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4481,    -1,    -1,  4484,    -1,  4486,
      -1,    -1,  4489,  4490,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4504,  4505,  4506,
    4507,    -1,  4509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4580,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5551,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4644,    -1,    -1,
      -1,  6296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     6,
       7,     8,    -1,    10,    11,    12,    -1,    -1,    -1,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    -1,    -1,    -1,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    -1,    41,    42,    43,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,   126,
     127,   128,   129,   130,   131,   132,  5860,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   152,    -1,   154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5900,    -1,   175,    -1,
      -1,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     227,    -1,    -1,    -1,    -1,    -1,  5960,    -1,    -1,   236,
      -1,  5965,  5966,    -1,   241,    -1,    -1,    -1,    -1,    -1,
     247,    -1,    -1,    -1,    -1,    -1,   253,  5044,   255,    -1,
      -1,  5048,  5049,  5050,    -1,   262,    -1,   264,    -1,  5056,
    5057,  5058,  5059,    -1,    -1,    -1,   273,  5064,  5065,  5066,
    5067,  5068,  5069,  5070,  5071,  5072,  5073,  5074,  5075,    -1,
     287,   288,    -1,    -1,    -1,    -1,    -1,   294,    -1,   296,
      -1,    -1,   299,   300,    -1,   302,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5100,   311,   312,  5103,   314,  5105,    -1,
      -1,    -1,  5109,    -1,    -1,  5112,  5113,    -1,    -1,  5116,
    5117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     337,   338,   339,    -1,    -1,    -1,    -1,    -1,   345,    -1,
      -1,    -1,   349,    -1,    -1,   352,  6080,   354,   355,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,  5164,   375,   376,
      -1,    -1,    -1,    -1,  5171,  5172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   391,    -1,   393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5194,    -1,    -1,
      -1,    -1,    -1,   410,    -1,    -1,    -1,    -1,    -1,    -1,
    5207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,    -1,
     437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   458,    -1,    -1,    -1,   462,    -1,    -1,    -1,   466,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   482,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,    -1,
      -1,    -1,   499,   500,    -1,    -1,    -1,    -1,   505,    -1,
     507,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   516,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   533,    -1,    -1,   536,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,    -1,    -1,    -1,
      -1,    -1,  6296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   590,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5408,    -1,     6,     7,     8,    -1,    10,    11,    12,
      -1,    -1,    -1,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    -1,    -1,    -1,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    -1,    41,    42,
      43,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,  5490,  5491,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
      -1,    -1,    -1,   126,   127,   128,   129,   130,   131,   132,
      -1,    -1,    -1,    -1,  5541,    -1,    -1,    -1,    -1,  5546,
    5547,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,
      -1,   154,    -1,    -1,  5561,    -1,  5563,    -1,    -1,   162,
    5567,  5568,  5569,    -1,    -1,  5572,    -1,    -1,  5575,  5576,
      -1,    -1,   175,  5580,    -1,    -1,    -1,  5584,    -1,   182,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     193,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   236,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,    -1,   247,    -1,    -1,  5654,    -1,    -1,
     253,    -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,   262,
      -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   287,   288,    -1,    -1,    -1,    -1,
      -1,   294,    -1,   296,    -1,    -1,   299,   300,    -1,   302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,   312,
      -1,   314,  5719,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   337,   338,   339,    -1,    -1,    -1,
      -1,    -1,   345,    -1,    -1,    -1,   349,    -1,    -1,   352,
    5757,   354,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,
     373,    -1,   375,   376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   391,    -1,
     393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   432,
      -1,    -1,    -1,    -1,   437,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5858,  5859,    -1,    -1,   458,    -1,    -1,    -1,   462,
      -1,    -1,    -1,   466,    -1,    -1,    -1,  5874,  5875,  5876,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5884,    -1,   482,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,
      -1,    -1,    -1,    -1,    -1,    -1,   499,   500,    -1,    -1,
      -1,    -1,   505,    -1,   507,  5912,  5913,    -1,    -1,    -1,
      -1,    -1,    -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5930,    -1,    -1,    -1,    -1,    -1,    -1,
     533,    -1,    -1,   536,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   590,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6111,    -1,    -1,  6114,    -1,    -1,
      -1,  6118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6290,    -1,  6292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6499,    -1,    -1,    -1,    -1,  6504,    -1,    -1,
      -1,    -1,    -1,    -1,  6511,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6546,
      -1,    -1,  6549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,  6574,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     3,    -1,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,   589,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,   106,
     107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,   119,   120,    -1,    -1,    -1,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,   146,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,    -1,
     157,    -1,   159,   160,    -1,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,
      -1,    -1,   189,    -1,    -1,   192,   193,   194,   195,    -1,
      -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,   216,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,   226,
     227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,   236,
     237,    -1,    -1,    -1,   241,    -1,    -1,   244,    -1,    -1,
     247,    -1,    -1,    -1,    -1,    -1,   253,    -1,   255,    -1,
      -1,    -1,    -1,   260,    -1,   262,    -1,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,
     277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,    -1,    -1,   291,    -1,    -1,   294,    -1,   296,
      -1,    -1,   299,   300,    -1,   302,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   311,   312,    -1,   314,    -1,   316,
     317,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   334,    -1,    -1,
     337,   338,   339,    -1,    -1,    -1,   343,   344,   345,    -1,
      -1,   348,   349,    -1,    -1,   352,    -1,   354,   355,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,    -1,   375,   376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     387,    -1,    -1,    -1,   391,    -1,   393,    -1,    -1,   396,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   410,   411,    -1,    -1,    -1,    -1,    -1,
      -1,   418,   419,    -1,   421,    -1,    -1,    -1,    -1,   426,
      -1,    -1,    -1,    -1,   431,   432,    -1,   434,   435,    -1,
     437,    -1,    -1,   440,   441,    -1,    -1,    -1,    -1,    -1,
     447,   448,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   456,
      -1,   458,    -1,    -1,   461,   462,    -1,    -1,    -1,   466,
      -1,    -1,    -1,    -1,    -1,   472,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   482,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   490,    -1,   492,    -1,    -1,    -1,    -1,
      -1,    -1,   499,   500,    -1,    -1,    -1,    -1,   505,    -1,
     507,    -1,   509,    -1,   511,    -1,    -1,    -1,    -1,   516,
      -1,    -1,   519,    -1,    -1,   522,    -1,   524,    -1,    -1,
     527,    -1,    -1,    -1,    -1,   532,   533,    -1,    -1,   536,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   546,
      -1,    -1,    -1,    -1,    -1,    -1,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,    -1,    -1,    -1,
      -1,    -1,   569,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,   583,    15,    16,    -1,
     587,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,    -1,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,   576,    -1,
      -1,    -1,    -1,    -1,    -1,   583,   584,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,    -1,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
      -1,   569,    -1,    -1,    -1,    -1,   574,   575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   583,   584,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,    -1,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   583,   584,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,    -1,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   583,   584,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,    -1,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   583,   584,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,    -1,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,    -1,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,    -1,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,    -1,    -1,    -1,   265,   266,    -1,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,    -1,   312,   313,   314,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,    -1,    -1,   347,
     348,   349,   350,    -1,    -1,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,    -1,   392,    -1,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,    -1,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,    -1,   506,    -1,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   564,   565,   566,    -1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,   584,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,    -1,   127,   128,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
      -1,    -1,   154,    -1,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,
     182,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,    -1,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,    -1,   255,   256,   257,   258,   259,    -1,   261,
      -1,    -1,    -1,   265,   266,    -1,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,    -1,   310,    -1,
     312,   313,   314,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,    -1,    -1,   347,   348,   349,   350,    -1,
      -1,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,    -1,
     392,    -1,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
      -1,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
     492,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,    -1,   506,    -1,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   564,   565,   566,    -1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   584,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,   253,    -1,   255,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
      -1,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
     536,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,    -1,   569,    -1,    -1,    -1,    -1,   574,   575,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   583,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    71,    -1,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,   154,    -1,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,    -1,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,   486,
     487,   488,   489,    -1,   491,   492,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,    -1,
     517,   518,   519,   520,   521,   522,   523,   524,   525,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,   536,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,    -1,    -1,    -1,    -1,    -1,    -1,   574,   575,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   583,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,    -1,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,    -1,    -1,
      -1,    -1,    -1,   581,   582,   583,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    71,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,   253,    -1,   255,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,   486,   487,   488,
     489,    -1,   491,   492,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,    -1,   517,   518,
     519,   520,   521,   522,   523,   524,   525,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,   536,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,    -1,
      -1,    -1,    -1,    -1,    -1,   574,   575,   576,    -1,    -1,
      -1,    -1,    -1,    -1,   583,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    71,    -1,    -1,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,
     110,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,    -1,   255,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,   486,   487,   488,   489,
      -1,   491,   492,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,    -1,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,    -1,    -1,
      -1,    -1,    -1,    -1,   574,   575,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   583,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,   312,   313,   314,    -1,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,   486,   487,   488,   489,    -1,
     491,   492,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,    -1,   517,   518,   519,   520,
     521,   522,   523,   524,   525,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,   536,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,    -1,    -1,    -1,
      -1,    -1,    -1,   574,   575,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   583,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    71,
      -1,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,    -1,   255,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,   486,   487,   488,   489,    -1,   491,
     492,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,    -1,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,    -1,    -1,    -1,    -1,
      -1,    -1,   574,   575,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   583,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    71,    -1,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,   110,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,   154,    -1,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
     253,    -1,   255,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,   486,   487,   488,   489,    -1,   491,   492,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,    -1,   517,   518,   519,   520,   521,   522,
     523,   524,   525,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,   536,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,    -1,    -1,    -1,    -1,    -1,
      -1,   574,   575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     583,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,   110,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,   253,
      -1,   255,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,   486,   487,   488,   489,    -1,   491,   492,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,    -1,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,    -1,    -1,    -1,    -1,    -1,    -1,
     574,   575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   583,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,   486,   487,   488,   489,    -1,   491,   492,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,    -1,   517,   518,   519,   520,   521,   522,   523,   524,
     525,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,   536,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,    -1,    -1,    -1,    -1,    -1,    -1,   574,
     575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   583,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,   253,    -1,   255,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
     486,   487,   488,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
      -1,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
     536,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,    -1,    -1,    -1,    -1,    -1,    -1,   574,   575,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   583,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    71,    -1,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,   154,    -1,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,   253,    -1,   255,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,   312,   313,   314,    -1,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,   486,
     487,   488,   489,    -1,   491,   492,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,    -1,
     517,   518,   519,   520,   521,   522,   523,   524,   525,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,   536,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,    -1,    -1,    -1,    -1,    -1,    -1,   574,   575,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   583,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,    -1,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   583,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    71,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,   253,    -1,   255,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,   486,   487,   488,
     489,    -1,   491,   492,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,    -1,   517,   518,
     519,   520,   521,   522,   523,   524,   525,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,   536,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,    -1,
      -1,    -1,    -1,    -1,    -1,   574,   575,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   583,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    71,    -1,    -1,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
     110,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,    -1,   255,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,   302,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,   486,   487,   488,   489,
      -1,   491,   492,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,    -1,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,    -1,    -1,
      -1,    -1,    -1,    -1,   574,   575,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   583,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,   253,    -1,   255,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,   312,   313,   314,    -1,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,   486,   487,   488,   489,    -1,
     491,   492,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,   536,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   574,   575,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   583,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    71,
      -1,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,    -1,   255,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,   486,   487,   488,   489,    -1,   491,
     492,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   574,   575,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   583,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    71,    -1,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,   110,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,   154,    -1,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
     253,    -1,   255,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,    -1,   296,    -1,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,   486,   487,   488,   489,    -1,   491,   492,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,   536,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   574,   575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     583,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,   110,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,   253,
      -1,   255,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,   486,   487,   488,   489,    -1,   491,   492,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,    -1,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   583,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    71,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,   253,    -1,   255,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,   486,   487,   488,
     489,    -1,   491,   492,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,   525,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,   536,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   583,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,   110,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,   253,
      -1,   255,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,   486,   487,   488,   489,    -1,   491,   492,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,    -1,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   583,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    71,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,    -1,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,   253,    -1,   255,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,   302,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,   312,   313,    -1,    -1,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,   486,   487,   488,
     489,    -1,   491,   492,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,    -1,   517,   518,
     519,   520,   521,   522,   523,   524,   525,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,   536,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   574,   575,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   583,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
     140,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,    -1,   255,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,    -1,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,    -1,    -1,   569,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,   583,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,   140,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,    -1,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,   486,   487,   488,   489,    -1,   491,   492,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,   536,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   583,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
     140,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,    -1,   255,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,   486,   487,   488,   489,
      -1,   491,   492,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,   583,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,   140,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,   486,   487,   488,   489,    -1,   491,   492,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,   536,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   583,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
     140,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,    -1,   255,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,   486,   487,   488,   489,
      -1,   491,   492,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,   583,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,   492,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,   536,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,    -1,    -1,    -1,    -1,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   583,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,   111,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,   255,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,   302,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,   312,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,    -1,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   584,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    79,    -1,    81,    -1,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,    -1,    -1,    -1,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,   582,   583,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      79,    -1,    81,    -1,    -1,    -1,    85,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   583,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,   490,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,    -1,    -1,   569,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   583,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,   490,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,    -1,    -1,
     569,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   583,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,    -1,    -1,    -1,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   583,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   583,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,    -1,    -1,    -1,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   583,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   583,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    -1,    -1,
      84,    85,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
      -1,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,    -1,   392,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,    -1,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,    -1,   502,   503,
     504,    -1,   506,    -1,   508,   509,   510,   511,   512,   513,
     514,   515,    -1,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     564,   565,   566,    -1,    -1,    -1,   570,   571,   572,    -1,
     574,   575,   576,   577,   578,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    71,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    -1,    -1,    84,    85,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,    -1,   392,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,    -1,   502,   503,   504,    -1,   506,    -1,   508,
     509,   510,   511,   512,   513,   514,   515,    -1,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   564,   565,   566,    -1,    -1,
      -1,   570,   571,   572,    -1,   574,   575,   576,   577,   578,
     579,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,    -1,    -1,    -1,   570,   571,   572,    -1,   574,
     575,   576,   577,   578,   579,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,    -1,    -1,    -1,   570,
     571,   572,    -1,   574,   575,   576,   577,   578,   579,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
      -1,    -1,    -1,   570,   571,   572,    -1,   574,   575,   576,
     577,   578,   579,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,    -1,    -1,    -1,   570,   571,   572,
      -1,   574,   575,   576,   577,   578,   579,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,    -1,    -1,
      -1,   570,   571,   572,    -1,   574,   575,   576,   577,   578,
     579,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,    -1,    -1,    -1,   570,   571,   572,    -1,   574,
     575,   576,   577,   578,   579,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,    -1,    -1,    -1,   570,
     571,   572,    -1,   574,   575,   576,   577,   578,   579,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     5,     6,     7,     8,     9,    10,    11,    12,    13,
     576,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,    -1,   127,   128,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,    -1,    -1,
     154,    -1,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,   175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,    -1,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,   253,
      -1,   255,   256,   257,   258,   259,    -1,   261,    -1,    -1,
      -1,   265,   266,    -1,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,    -1,   310,    -1,   312,   313,
     314,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,    -1,    -1,   347,   348,   349,   350,    -1,    -1,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,    -1,   392,    -1,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,    -1,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,   492,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,    -1,   506,    -1,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     564,   565,   566,    -1,     6,     7,     8,     9,    10,    11,
      12,    13,   576,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,    -1,     6,     7,     8,     9,
      10,    11,    12,    13,   576,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,   576,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   574,   575,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,   501,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,    -1,
      -1,    -1,    -1,     4,   572,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    -1,    -1,    -1,    85,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,   140,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,   154,    -1,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
     253,    -1,   255,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,   486,   487,   488,   489,    -1,   491,   492,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,   536,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,   253,    -1,   255,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,   312,   313,   314,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,   492,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,   536,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,   253,    -1,   255,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,   492,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,   536,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,   154,    -1,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,   253,    -1,   255,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,   312,   313,   314,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,   492,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,   536,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,   492,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,   536,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,    -1,
      -1,   154,    -1,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
     253,    -1,   255,   256,   257,   258,   259,    -1,   261,    -1,
      -1,    -1,   265,   266,    -1,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,    -1,   310,    -1,   312,
     313,   314,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,    -1,    -1,   347,   348,   349,   350,    -1,    -1,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,    -1,   392,
      -1,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,    -1,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,   492,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,    -1,   506,    -1,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,    -1,
     533,   534,   535,   536,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   564,   565,   566,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,    -1,    -1,   154,    -1,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,   253,    -1,   255,   256,   257,   258,   259,    -1,
     261,    -1,    -1,    -1,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,    -1,    -1,   290,
     291,   292,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,    -1,   310,
      -1,   312,   313,   314,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,    -1,    -1,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,    -1,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
      -1,   392,    -1,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,    -1,    -1,    -1,   485,    -1,   487,   488,    -1,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,    -1,   506,    -1,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,    -1,   533,    -1,   535,   536,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   564,   565,   566,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,    -1,    -1,   154,    -1,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,   253,    -1,   255,   256,   257,   258,
     259,    -1,   261,    -1,    -1,    -1,   265,   266,    -1,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,    -1,
      -1,   290,   291,   292,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
      -1,   310,    -1,   312,   313,   314,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,    -1,    -1,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,    -1,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,    -1,   392,    -1,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,   492,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,    -1,   506,    -1,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,    -1,   533,    -1,   535,   536,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   564,   565,   566,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,    -1,
     127,   128,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,    -1,    -1,   154,    -1,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,   253,    -1,   255,   256,
     257,   258,   259,    -1,   261,    -1,    -1,    -1,   265,   266,
      -1,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,    -1,    -1,   290,   291,   292,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,    -1,   310,    -1,   312,   313,   314,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,    -1,    -1,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,    -1,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,    -1,   392,    -1,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,    -1,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,   492,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,    -1,   506,
      -1,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,    -1,   533,    -1,   535,   536,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   564,   565,   566,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,    -1,    -1,   154,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,    -1,   243,    -1,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,    -1,   261,    -1,    -1,    -1,
     265,   266,    -1,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,    -1,    -1,   290,   291,   292,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,    -1,   310,    -1,   312,   313,   314,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
      -1,    -1,   347,   348,   349,   350,    -1,    -1,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,    -1,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,    -1,   392,    -1,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,    -1,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,   492,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
      -1,   506,    -1,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,    -1,   533,    -1,
     535,   536,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   564,
     565,   566,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,    -1,
      -1,   154,    -1,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
     253,    -1,   255,   256,   257,   258,   259,    -1,   261,    -1,
      -1,    -1,   265,   266,    -1,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,    -1,    -1,   290,   291,   292,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,    -1,   310,    -1,   312,
     313,   314,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,    -1,    -1,   347,   348,   349,   350,    -1,    -1,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,    -1,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,    -1,   392,
      -1,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,    -1,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,   492,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,    -1,   506,    -1,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,    -1,
     533,    -1,   535,   536,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   564,   565,   566,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,    -1,    -1,   154,    -1,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,   253,    -1,   255,   256,   257,   258,   259,    -1,
     261,    -1,    -1,    -1,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,    -1,    -1,   290,
     291,   292,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,    -1,   310,
      -1,   312,   313,   314,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,    -1,    -1,   347,   348,   349,   350,
      -1,    -1,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,    -1,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
      -1,   392,    -1,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,    -1,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,   492,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,    -1,   506,    -1,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,    -1,   533,    -1,   535,   536,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   564,   565,   566,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,    -1,    -1,   154,    -1,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,   253,    -1,   255,   256,   257,   258,
     259,    -1,   261,    -1,    -1,    -1,   265,   266,    -1,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,    -1,
      -1,   290,   291,   292,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
      -1,   310,    -1,   312,   313,   314,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,    -1,    -1,   347,   348,
     349,   350,    -1,    -1,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,    -1,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,    -1,   392,    -1,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,   492,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,    -1,   506,    -1,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,    -1,   533,    -1,   535,   536,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   564,   565,   566,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,    -1,
     127,   128,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,    -1,    -1,   154,    -1,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,   253,    -1,   255,   256,
     257,   258,   259,    -1,   261,    -1,    -1,    -1,   265,   266,
      -1,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,    -1,    -1,   290,   291,   292,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,    -1,   310,    -1,   312,   313,   314,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,    -1,    -1,
     347,   348,   349,   350,    -1,    -1,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,    -1,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,    -1,   392,    -1,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,    -1,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,   492,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,    -1,   506,
      -1,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,    -1,   533,    -1,   535,   536,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   564,   565,   566,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,    -1,    -1,   154,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,    -1,   261,    -1,    -1,    -1,
     265,   266,    -1,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,    -1,    -1,   290,   291,   292,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,    -1,   310,    -1,   312,   313,   314,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
      -1,    -1,   347,   348,   349,   350,    -1,    -1,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,    -1,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,    -1,   392,    -1,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,    -1,   459,   460,   461,   462,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,    -1,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,   492,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
      -1,   506,    -1,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,    -1,   533,    -1,
     535,   536,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   564,
     565,   566,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,    -1,    -1,   128,    -1,    -1,    -1,    -1,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
      -1,    -1,   145,    -1,   147,   148,   149,   150,   151,    -1,
      -1,   154,    -1,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,    -1,
     243,    -1,   245,   246,    -1,   248,    -1,   250,    -1,   252,
     253,    -1,   255,   256,   257,   258,   259,    -1,   261,    -1,
      -1,    -1,   265,   266,    -1,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,    -1,    -1,   290,   291,   292,
      -1,    -1,    -1,    -1,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,    -1,   310,    -1,   312,
     313,   314,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,    -1,   340,   341,   342,
      -1,   344,    -1,    -1,   347,   348,   349,   350,    -1,    -1,
     353,    -1,    -1,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,    -1,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,    -1,   392,
      -1,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,    -1,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,    -1,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,   492,
     493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,    -1,
     503,   504,    -1,   506,    -1,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,    -1,
      -1,    -1,   535,   536,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,    -1,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,    -1,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,    -1,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    71,    -1,    -1,    74,    75,    76,    77,    78,    79,
      -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,    -1,    -1,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,   251,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,   517,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,   251,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,   314,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,   517,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,   174,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,   174,    -1,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,    -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,    -1,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
      -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    79,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,   251,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,   517,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,    -1,   176,   177,   178,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,   174,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,   251,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
     490,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,   174,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,   490,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,    -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,    -1,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
      -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
     174,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,   174,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
     490,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,   106,   107,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,    -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,    -1,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
      -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,    -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,    -1,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
      -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,   111,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,   111,
      -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,    -1,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,    -1,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,    -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,    -1,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
      -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,    -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,    -1,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
      -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,    -1,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,    -1,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,    -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,    -1,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
      -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,   111,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,    -1,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,    -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,    -1,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
      -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,
      -1,   301,    -1,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,    -1,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,    -1,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,    -1,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,   532,   533,    -1,   535,    -1,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,    -1,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,    -1,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
      -1,    -1,   301,    -1,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
      -1,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,   532,   533,    -1,   535,    -1,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,    -1,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,    -1,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
      -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,    -1,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,   532,   533,    -1,   535,    -1,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,    -1,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,    -1,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,    -1,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,    -1,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,   532,   533,    -1,   535,
      -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
      -1,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,    -1,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,    -1,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,    -1,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,   532,   533,    -1,
     535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,    -1,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,    -1,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,    -1,   313,
      -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,    -1,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,    -1,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,   532,   533,
      -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,    -1,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,    -1,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,    -1,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,    -1,
     313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
      -1,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,    -1,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,    -1,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,   532,
     533,    -1,   535,    -1,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,    -1,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,    -1,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,   301,
      -1,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
      -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,    -1,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,    -1,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
     532,   533,    -1,   535,    -1,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,    -1,    -1,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,    -1,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,    -1,    -1,
     301,    -1,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,    -1,   313,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,    -1,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,    -1,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,    -1,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,   532,   533,    -1,   535,    -1,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     6,     7,     8,    -1,
      10,    11,    12,    -1,    -1,    -1,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    -1,    -1,
      -1,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    72,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,    -1,    -1,    -1,    -1,   126,   127,   128,   129,
     130,   131,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   152,    -1,   154,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,    -1,    -1,    -1,    -1,
      -1,    -1,   182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   193,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,    -1,
      -1,   241,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,
      -1,    -1,    -1,   253,    -1,   255,    -1,    -1,    -1,    -1,
      -1,    -1,   262,    -1,   264,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,
      -1,    -1,    -1,    -1,   294,    -1,   296,    -1,    -1,   299,
     300,    -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   311,   312,    -1,   314,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,   338,   339,
      -1,    -1,    -1,    -1,    -1,   345,    -1,    -1,    -1,   349,
      -1,    -1,   352,    -1,   354,   355,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   372,   373,    -1,   375,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   391,    -1,   393,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   432,    -1,    -1,    -1,    -1,   437,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,
      -1,    -1,   462,    -1,    -1,    -1,   466,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   482,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,   499,
     500,    -1,    -1,    -1,    -1,   505,    -1,   507,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   516,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   533,    -1,    -1,   536,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,     6,     7,     8,    -1,    10,    11,
      12,    -1,    -1,    -1,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    -1,    -1,    -1,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      72,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
      -1,    -1,    -1,    -1,   126,   127,   128,   129,   130,   131,
     132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     152,    -1,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,
     182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   193,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   236,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,
      -1,   253,    -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,
     262,    -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,    -1,
      -1,    -1,   294,    -1,   296,    -1,    -1,   299,   300,    -1,
     302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,
     312,    -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   337,   338,   339,    -1,    -1,
      -1,    -1,    -1,   345,    -1,    -1,    -1,   349,    -1,    -1,
     352,    -1,   354,   355,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,   373,    -1,   375,   376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   391,
      -1,   393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   410,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     432,    -1,    -1,    -1,    -1,   437,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,    -1,
     462,    -1,    -1,    -1,   466,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     482,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,    -1,    -1,    -1,    -1,    -1,    -1,   499,   500,    -1,
      -1,    -1,    -1,   505,    -1,   507,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   533,    -1,    -1,   536,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,     6,     7,     8,    -1,    10,    11,    12,    -1,
      -1,    -1,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    -1,    -1,    -1,    31,    32,    33,
      34,    -1,    36,    37,    38,    39,    -1,    41,    42,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,
      -1,    -1,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,
     154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
     194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   236,    -1,    -1,    -1,    -1,   241,    -1,    -1,
      -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,    -1,   253,
      -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,
     264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   287,   288,    -1,    -1,    -1,    -1,    -1,
     294,    -1,   296,    -1,    -1,   299,   300,    -1,   302,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,   312,    -1,
     314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   337,   338,   339,    -1,    -1,    -1,    -1,
      -1,   345,    -1,    -1,    -1,   349,    -1,    -1,   352,    -1,
     354,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,   373,
      -1,   375,   376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   391,    -1,   393,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   410,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   432,    -1,
      -1,    -1,    -1,   437,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   458,    -1,    -1,    -1,   462,    -1,
      -1,    -1,   466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   482,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,
      -1,    -1,    -1,    -1,    -1,   499,   500,    -1,    -1,    -1,
      -1,   505,    -1,   507,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,
      -1,    -1,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
       6,     7,     8,    -1,    10,    11,    12,    -1,    -1,    -1,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    -1,    -1,    -1,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    -1,    41,    42,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
     126,   127,   128,   129,   130,   131,   132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
      -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,
      -1,   247,    -1,    -1,    -1,    -1,    -1,   253,    -1,   255,
      -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,   264,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   288,    -1,    -1,    -1,    -1,    -1,   294,    -1,
     296,    -1,    -1,   299,   300,    -1,   302,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   311,   312,    -1,   314,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   337,   338,   339,    -1,    -1,    -1,    -1,    -1,   345,
      -1,    -1,    -1,   349,    -1,    -1,   352,    -1,   354,   355,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   372,   373,    -1,   375,
     376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   391,    -1,   393,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   410,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,
      -1,   437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   458,    -1,    -1,    -1,   462,    -1,    -1,    -1,
     466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   482,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,
      -1,    -1,    -1,   499,   500,    -1,    -1,    -1,    -1,   505,
      -1,   507,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,    -1,    -1,
     536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,    70,    71,
      -1,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,    -1,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,
     182,    -1,    -1,    -1,   186,   187,   188,   189,    -1,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,    -1,   255,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
     492,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
      -1,   533,    -1,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,    70,   565,   566,    -1,    -1,    -1,    -1,    -1,
      78,    79,   574,   575,   576,    -1,    -1,    -1,    -1,    -1,
      -1,   583,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,   106,   107,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,    -1,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,   187,
     188,   189,    -1,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,   532,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,    -1,   565,   566,    70,
      71,   569,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    -1,    -1,    -1,    85,   583,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,    -1,    -1,
     141,   142,    -1,   144,   145,    -1,   147,   148,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,   187,   188,   189,    -1,
      -1,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,    -1,   250,
      -1,   252,   253,    -1,   255,   256,   257,   258,   259,    -1,
     261,   262,    -1,   264,   265,   266,    -1,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,    -1,   290,
     291,   292,    -1,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,    -1,   310,
     311,   312,   313,   314,    -1,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,    -1,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,    -1,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,
     491,   492,   493,   494,   495,   496,   497,    -1,   499,   500,
      -1,    -1,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,   530,
     531,    -1,   533,    -1,   535,   536,   537,   538,   539,   540,
      -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,    -1,   565,   566,    -1,    -1,    -1,    -1,
      -1,    70,    71,   574,   575,    74,    75,    76,    77,    78,
      79,    80,    81,    -1,    -1,    -1,    85,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
      -1,    -1,   141,   142,    -1,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,    -1,   167,   168,
     169,   170,   171,   172,   173,    -1,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,   187,   188,
     189,    -1,    -1,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,   227,   228,
     229,    -1,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,   246,   247,   248,
      -1,   250,    -1,   252,   253,    -1,   255,   256,   257,   258,
     259,    -1,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
      -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
      -1,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,    -1,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,    -1,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,    -1,
     449,   450,   451,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,    -1,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,    -1,    -1,   485,    -1,   487,   488,
      -1,    -1,   491,   492,   493,   494,   495,   496,   497,    -1,
     499,   500,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,   527,   528,
     529,   530,   531,    -1,   533,    -1,   535,   536,   537,   538,
     539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,    -1,   565,   566,    -1,    -1,
      -1,    -1,    -1,    70,    71,   574,   575,    74,    75,    76,
      77,    78,    79,    80,    81,    -1,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,    -1,    -1,   141,   142,    -1,   144,   145,    -1,
     147,   148,   149,   150,   151,   152,    -1,   154,    -1,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,    -1,
     167,   168,   169,   170,   171,   172,   173,    -1,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
     187,   188,   189,    -1,    -1,   192,   193,   194,   195,    -1,
     197,    -1,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,    -1,   245,   246,
     247,   248,    -1,   250,    -1,   252,   253,    -1,   255,   256,
     257,   258,   259,    -1,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,    -1,   290,   291,   292,    -1,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,    -1,   310,   311,   312,   313,   314,    -1,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,    -1,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,    -1,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,    -1,   449,   450,   451,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,   488,    -1,    -1,   491,   492,   493,   494,   495,   496,
     497,    -1,   499,   500,    -1,    -1,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,   528,   529,   530,   531,    -1,   533,    -1,   535,   536,
     537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,    -1,   565,   566,
      -1,    -1,    -1,    -1,    -1,    70,    71,   574,   575,    74,
      75,    76,    77,    78,    79,    -1,    81,    -1,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,   134,
     135,   136,   137,   138,    -1,    -1,   141,   142,    -1,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,    -1,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,   187,   188,   189,    -1,    -1,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,   246,   247,   248,    -1,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,    -1,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,    -1,   290,   291,   292,    -1,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,    -1,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,    -1,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,    -1,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,    -1,    -1,
     485,    -1,   487,   488,    -1,    -1,   491,   492,   493,   494,
     495,   496,   497,    -1,   499,   500,    -1,    -1,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,   531,    -1,   533,    -1,
     535,   536,   537,   538,   539,   540,    -1,    -1,    -1,   544,
      -1,    -1,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,    -1,
     565,   566,    -1,    -1,    -1,    -1,    -1,    70,    71,   574,
     575,    74,    75,    76,    77,    78,    79,    -1,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
      -1,   134,   135,   136,   137,   138,    -1,    -1,   141,   142,
      -1,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
      -1,   154,    -1,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,   185,   186,   187,   188,   189,    -1,    -1,   192,
     193,   194,   195,    -1,   197,    -1,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,    -1,   250,    -1,   252,
     253,    -1,   255,   256,   257,   258,   259,    -1,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,    -1,   290,   291,   292,
      -1,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,    -1,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,    -1,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,    -1,   449,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
      -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,   492,
     493,   494,   495,   496,   497,    -1,   499,   500,   501,    -1,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,   527,   528,   529,   530,   531,    -1,
     533,    -1,   535,   536,   537,   538,   539,   540,    -1,    -1,
      -1,   544,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,    -1,   565,   566,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,    -1,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,   175,
     176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,   185,
     186,   187,   188,   189,    -1,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,   253,    -1,   255,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,   492,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,    -1,   533,    -1,   535,
     536,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,    70,   565,
     566,    -1,    74,    75,    76,    77,    78,    79,    -1,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,    -1,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,
     182,    -1,    -1,    -1,   186,   187,   188,   189,    -1,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,    -1,   255,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
     492,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
      -1,   533,    -1,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,    70,   565,   566,    -1,    74,    75,    76,    77,
      78,    79,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,    -1,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,   187,
     188,   189,    -1,    -1,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,    -1,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,    70,   565,   566,    -1,
      74,    75,    76,    77,    78,    79,    -1,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,    -1,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,   175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,
      -1,    -1,   186,   187,   188,   189,    -1,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,   253,
      -1,   255,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,    -1,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,   492,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,    -1,   533,
      -1,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
      70,   565,   566,    -1,    74,    75,    76,    77,    78,    79,
      -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,    -1,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,    -1,    -1,
      -1,    -1,   182,    -1,    -1,    -1,   186,   187,   188,   189,
      -1,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,    -1,   255,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,   492,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,    -1,   533,    -1,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,    70,   565,   566,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,    -1,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,   175,
     176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,   185,
     186,   187,   188,   189,    -1,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,   253,    -1,   255,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,   492,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,    -1,   533,    -1,   535,
     536,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,    70,   565,
     566,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,    -1,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,
     182,    -1,    -1,   185,   186,   187,   188,   189,    -1,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,    -1,   255,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,    -1,   449,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
     492,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
      -1,   533,    -1,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,    70,   565,   566,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,    -1,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,    -1,    -1,    -1,   182,    -1,    -1,   185,   186,   187,
     188,   189,    -1,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
      -1,   449,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,    -1,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,    70,   565,   566,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,    -1,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,   175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,
      -1,   185,   186,   187,   188,   189,    -1,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,   253,
      -1,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,    -1,   449,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,   492,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,    -1,   533,
      -1,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
      70,   565,   566,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,    -1,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,    -1,    -1,
      -1,    -1,   182,    -1,    -1,   185,   186,   187,   188,   189,
      -1,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,    -1,   255,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,   492,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,    -1,   533,    -1,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,    70,   565,   566,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,    -1,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,   175,
     176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,   185,
     186,   187,   188,   189,    -1,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,   253,    -1,   255,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,   492,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,    -1,   533,    -1,   535,
     536,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,    70,   565,
     566,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,    -1,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,
     182,    -1,    -1,   185,   186,   187,   188,   189,    -1,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,    -1,   255,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,    -1,   449,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
     492,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
      -1,   533,    -1,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,    70,   565,   566,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,    -1,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,   175,   176,   177,
      -1,    -1,    -1,    -1,   182,    -1,    -1,   185,   186,   187,
     188,   189,    -1,    -1,   192,   193,   194,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,    -1,   243,    -1,   245,   246,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,   257,
     258,   259,    -1,   261,   262,    -1,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,    -1,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,    -1,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
      -1,   449,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,   492,   493,   494,   495,   496,   497,
      -1,   499,   500,    -1,    -1,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,    -1,   533,    -1,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,    70,   565,   566,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,    -1,    -1,   141,   142,    -1,
     144,   145,    -1,   147,   148,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,    -1,   167,   168,   169,   170,   171,   172,   173,
      -1,   175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,
      -1,   185,   186,   187,   188,   189,    -1,    -1,   192,   193,
     194,   195,    -1,   197,    -1,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,    -1,   250,    -1,   252,   253,
      -1,   255,   256,   257,   258,   259,    -1,   261,   262,    -1,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,    -1,   290,   291,   292,    -1,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,    -1,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,    -1,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,    -1,   449,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
      -1,   485,    -1,   487,   488,    -1,    -1,   491,   492,   493,
     494,   495,   496,   497,    -1,   499,   500,    -1,    -1,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,   527,   528,   529,   530,   531,    -1,   533,
      -1,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
     544,    -1,    -1,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
      70,   565,   566,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,   134,   135,   136,   137,   138,    -1,
      -1,   141,   142,    -1,   144,   145,    -1,   147,   148,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,    -1,    -1,
      -1,    -1,   182,    -1,    -1,   185,   186,   187,   188,   189,
      -1,    -1,   192,   193,   194,   195,    -1,   197,    -1,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,    -1,   243,    -1,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,    -1,   255,   256,   257,   258,   259,
      -1,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,    -1,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,    -1,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,    -1,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,   485,    -1,   487,   488,    -1,
      -1,   491,   492,   493,   494,   495,   496,   497,    -1,   499,
     500,    -1,    -1,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,   527,   528,   529,
     530,   531,    -1,   533,    -1,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,   544,    -1,    -1,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,    70,   565,   566,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
     106,   107,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   141,   142,    -1,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
      -1,   167,   168,   169,   170,   171,   172,   173,    -1,   175,
     176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,
     186,   187,   188,   189,    -1,    -1,   192,   193,   194,   195,
      -1,   197,    -1,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,    -1,   245,
     246,   247,   248,    -1,   250,    -1,   252,   253,    -1,   255,
     256,   257,   258,   259,    -1,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,    -1,   290,   291,   292,    -1,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,    -1,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,    -1,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,    -1,    -1,   485,
      -1,   487,   488,    -1,    -1,   491,   492,   493,   494,   495,
     496,   497,    -1,   499,   500,    -1,    -1,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,   531,    -1,   533,    -1,   535,
     536,   537,   538,   539,   540,    -1,    -1,    -1,   544,    -1,
      -1,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,    70,   565,
     566,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,   134,   135,   136,   137,   138,    -1,    -1,   141,
     142,    -1,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,    -1,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,
     182,    -1,    -1,    -1,   186,   187,   188,   189,    -1,    -1,
     192,   193,   194,   195,    -1,   197,    -1,   199,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
      -1,   243,    -1,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,    -1,   255,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,    -1,   290,   291,
     292,    -1,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,    -1,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,    -1,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,    -1,   449,   450,   451,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,   485,    -1,   487,   488,    -1,    -1,   491,
     492,   493,   494,   495,   496,   497,    -1,   499,   500,    -1,
      -1,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   531,
      -1,   533,    -1,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,   544,    -1,    -1,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,    70,   565,   566,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,    -1,    -1,   121,   122,   123,   124,   125,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,
     138,    -1,    -1,   141,   142,    -1,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,    -1,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,    -1,    -1,   167,
     168,   169,   170,   171,   172,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
     188,   189,    -1,    -1,   192,    -1,    -1,   195,    -1,   197,
      -1,   199,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,    -1,    -1,   243,    -1,   245,   246,    -1,
     248,    -1,   250,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,    -1,   261,    -1,    -1,    -1,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,    -1,   286,    -1,
      -1,    -1,   290,   291,   292,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,   301,    -1,   303,   304,   305,   306,   307,
      -1,    -1,   310,    -1,    -1,   313,    -1,    -1,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,    -1,
      -1,    -1,   340,   341,   342,    -1,   344,    -1,    -1,   347,
     348,    -1,   350,    -1,    -1,   353,    -1,    -1,   356,   357,
     358,    -1,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,    -1,   371,    -1,    -1,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
      -1,   389,   390,    -1,   392,    -1,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,    -1,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
      -1,   449,   450,   451,   452,   453,    -1,    -1,   456,   457,
      -1,   459,   460,   461,    -1,   463,   464,   465,    -1,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,    -1,    -1,    -1,   485,    -1,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
      -1,    -1,    -1,    -1,    -1,   503,   504,    -1,   506,    -1,
      -1,   509,   510,   511,   512,   513,   514,   515,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,   530,   531,    -1,    -1,    -1,   535,    -1,   537,
     538,   539,   540,    -1,    -1,    -1,   544,    -1,    -1,   547,
     548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   565,   566
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   592,  1303,     0,     5,    25,    35,    36,    40,    42,
      43,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    72,    74,    75,    76,
      77,    78,    79,    80,    81,    85,   143,   227,   247,   270,
     293,   330,   333,   351,   446,   501,   516,   533,   564,   572,
     574,   575,   576,   577,   578,   581,   582,   583,   584,   586,
     587,   588,   589,   590,  1293,  1304,  1332,  1334,  1425,  1435,
    1436,  1438,  1444,  1445,  1333,     3,     6,     7,     8,     9,
      10,    11,    12,    13,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    26,    27,    28,    31,    32,    33,
      34,    36,    37,    38,    39,    41,    42,    43,    44,    45,
      49,    50,    55,    64,    66,    68,    69,    94,   104,   106,
     107,   116,   119,   120,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   144,   146,   147,   149,   150,   151,   152,
     154,   157,   159,   160,   162,   172,   174,   175,   182,   189,
     192,   193,   194,   195,   210,   216,   220,   226,   227,   235,
     236,   237,   241,   244,   247,   253,   255,   260,   262,   264,
     273,   277,   287,   288,   294,   296,   299,   300,   302,   311,
     312,   314,   316,   317,   322,   334,   337,   338,   339,   343,
     344,   345,   348,   349,   352,   354,   355,   372,   373,   375,
     376,   387,   391,   393,   396,   410,   411,   418,   419,   421,
     426,   431,   432,   434,   435,   437,   440,   441,   447,   448,
     456,   458,   461,   462,   466,   472,   482,   490,   492,   499,
     500,   505,   507,   509,   511,   516,   519,   522,   527,   532,
     533,   536,   546,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   569,   583,   593,   594,   600,   601,
     603,   604,   605,   606,   608,   612,   624,   629,   630,   633,
     634,   635,   661,   664,   665,   682,   733,   736,   739,   740,
     741,   749,   755,   757,   759,   760,   763,   766,   767,   771,
     780,   784,   785,   786,   787,   790,   792,   793,   794,   795,
     803,   804,   823,   827,   829,   830,   831,   841,   843,   850,
     851,   854,   855,   856,   857,   858,   866,   868,   872,   877,
     881,   882,   890,   891,   894,   899,   910,   937,   940,   941,
     942,   947,   950,   952,   954,   956,   957,   962,   963,   966,
     967,   968,   972,   973,   978,   979,   982,   983,   984,   991,
     993,   994,   995,  1000,  1002,  1003,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1017,  1018,  1020,  1021,  1023,  1026,  1027,
    1035,  1036,  1045,  1046,  1047,  1048,  1050,  1055,  1056,  1057,
    1058,  1059,  1060,  1063,  1064,  1065,  1066,  1068,  1069,  1075,
    1077,  1081,  1084,  1086,  1095,  1097,  1102,  1105,  1110,  1114,
    1115,  1116,  1117,  1118,  1119,  1123,  1158,  1300,  1301,  1305,
    1307,  1308,  1325,  1326,  1327,  1328,  1339,  1341,  1345,  1346,
    1347,  1348,  1349,  1351,  1353,  1355,  1356,  1357,  1358,  1360,
    1365,  1366,  1370,  1371,  1380,  1382,  1383,  1384,  1387,  1392,
    1395,  1400,  1402,  1403,  1406,  1408,  1411,  1420,  1438,  1446,
      72,  1328,  1336,  1337,    14,    71,    94,    95,    96,    97,
      98,    99,   100,   101,   103,   104,   105,   113,   114,   116,
     117,   118,   121,   122,   123,   124,   125,   134,   135,   136,
     137,   138,   141,   142,   145,   147,   148,   149,   150,   151,
     156,   157,   158,   159,   160,   161,   163,   164,   167,   168,
     169,   170,   171,   172,   173,   176,   177,   185,   186,   187,
     188,   189,   192,   195,   197,   199,   200,   201,   202,   203,
     204,   206,   207,   208,   209,   210,   212,   213,   214,   215,
     217,   218,   219,   220,   221,   223,   224,   225,   227,   228,
     229,   231,   232,   233,   234,   235,   237,   238,   239,   240,
     243,   245,   246,   248,   250,   252,   256,   257,   258,   259,
     261,   265,   266,   268,   269,   271,   272,   274,   275,   276,
     277,   279,   280,   281,   282,   283,   284,   286,   290,   291,
     292,   298,   301,   303,   304,   305,   306,   307,   310,   313,
     316,   317,   318,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   331,   332,   334,   335,   336,   340,   341,   342,
     344,   347,   348,   350,   353,   356,   357,   358,   360,   361,
     362,   365,   366,   367,   368,   371,   374,   377,   378,   379,
     380,   381,   382,   384,   385,   386,   387,   389,   390,   392,
     394,   395,   396,   397,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   411,   412,   413,   414,   415,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   430,   431,   433,   434,   435,   436,   438,   439,
     440,   441,   442,   443,   444,   445,   447,   449,   450,   451,
     452,   453,   454,   456,   457,   459,   460,   461,   463,   464,
     465,   467,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   485,   487,   488,   491,   493,
     494,   495,   496,   497,   501,   503,   504,   506,   509,   510,
     511,   512,   513,   514,   515,   518,   519,   520,   521,   522,
     523,   524,   527,   528,   529,   530,   531,   535,   537,   538,
     539,   540,   544,   547,   548,   549,   550,   551,   552,   565,
     566,  1295,  1296,  1298,  1299,  1300,  1301,  1318,  1319,  1430,
    1432,  1436,  1438,    29,   289,  1381,     9,    13,    15,    28,
      44,    45,    49,    50,    55,    64,    66,    68,    69,   102,
     143,   165,   178,   190,   196,   270,   330,   333,   446,   532,
     564,  1286,  1299,  1300,  1320,  1367,  1368,  1410,  1411,  1412,
    1416,  1421,  1422,  1423,  1432,  1438,   102,  1111,  1285,  1320,
    1416,  1429,    14,  1111,     5,    25,    29,    35,    36,    42,
      43,   102,   106,   107,   108,   109,   110,   111,   112,   115,
     119,   133,   139,   140,   143,   146,   153,   155,   165,   166,
     174,   178,   179,   180,   181,   183,   184,   185,   191,   196,
     198,   205,   211,   216,   222,   226,   230,   242,   244,   249,
     251,   254,   260,   263,   267,   278,   285,   289,   293,   295,
     297,   308,   309,   315,   319,   320,   343,   346,   351,   359,
     363,   364,   369,   370,   383,   388,   398,   416,   429,   448,
     454,   455,   468,   483,   484,   486,   489,   490,   498,   501,
     502,   508,   516,   517,   525,   526,   532,   534,   541,   542,
     543,   545,   546,  1299,  1302,  1412,  1413,  1414,  1418,  1419,
    1420,  1421,  1423,    25,    35,   143,   293,  1407,    37,    39,
     346,  1340,   503,   549,   996,   101,   151,   154,   170,   189,
     196,   218,   229,   238,   251,   256,   263,   265,   281,   306,
     327,   344,   365,   366,   390,   401,   404,   433,   439,   442,
     449,   452,   465,   474,   481,   488,   490,   493,   497,   506,
     511,   525,   538,   756,  1368,   195,   996,   375,   102,   165,
     356,   459,   473,   518,   525,   102,  1111,   536,  1029,   363,
     397,   996,   128,   583,   673,    96,   101,   113,   122,   140,
     154,   166,   189,   196,   218,   229,   238,   251,   259,   263,
     265,   303,   318,   344,   365,   366,   369,   390,   404,   433,
     442,   452,   459,   474,   481,   493,   494,   496,   497,   506,
     511,   517,   521,   525,   683,   738,   846,   900,   911,  1286,
    1309,  1310,  1311,  1320,  1436,  1438,    14,   102,   396,  1285,
    1320,  1324,   473,  1111,   102,   389,   450,   494,   496,   305,
     948,   949,  1436,    96,   101,   113,   140,   154,   170,   189,
     218,   229,   238,   251,   256,   263,   265,   281,   327,   344,
     365,   366,   378,   390,   404,   433,   439,   442,   449,   452,
     459,   474,   481,   490,   493,   497,   504,   506,   511,   525,
     538,   756,   859,   860,   861,   996,   589,  1350,  1414,   174,
     208,   274,  1324,   174,   195,   235,   536,   583,   736,   739,
    1027,  1070,  1084,  1086,  1095,  1105,  1110,  1114,  1305,    95,
     102,   121,   246,   252,   254,   278,   307,   341,   399,   420,
     574,   575,   878,   879,  1111,  1293,  1294,  1430,  1432,   102,
     174,   416,   448,   883,   884,   885,  1416,   251,  1416,  1290,
    1436,   490,  1126,   121,   238,   252,   263,   878,   322,   520,
    1416,   151,   174,   503,  1324,   378,   327,   189,   281,   442,
     488,   490,   583,   958,   959,   441,  1416,   102,   143,   453,
     499,   503,   532,   616,   625,   626,  1299,  1300,  1410,  1415,
    1421,  1423,  1438,    99,   260,   883,   884,   397,   996,  1283,
    1416,  1416,   304,   102,   211,  1128,  1129,     4,    14,   141,
     165,   167,   318,   336,   433,   442,   453,   499,   503,   552,
     613,   614,   615,   616,   102,   453,   499,   503,   616,   503,
     364,  1169,  1283,  1126,  1404,  1414,   576,  1416,   151,   255,
     583,  1030,   583,   414,  1120,  1121,  1285,  1120,  1115,  1116,
    1119,   587,   583,  1029,    98,   102,   104,   119,   157,   174,
     189,   201,   209,   220,   223,   238,   256,   260,   263,   281,
     291,   322,   327,   344,   383,   422,   433,   442,   448,   449,
     456,   488,   490,   493,   506,   509,   511,   524,   525,   538,
    1039,  1040,  1041,   230,   295,   370,   516,  1130,  1131,  1115,
    1117,  1118,   201,   291,   524,   586,   124,   593,  1348,  1351,
    1347,  1343,   587,  1352,  1354,     5,    25,    35,   143,   219,
     293,  1359,   190,   270,   330,   333,   446,   564,   583,  1214,
    1215,  1331,  1335,  1425,    72,  1328,  1285,  1320,  1439,   196,
    1309,    21,   526,   577,  1324,  1324,  1439,   526,  1372,  1373,
    1374,    25,   293,   293,  1418,     7,    19,    20,    38,    41,
     169,   216,  1409,  1409,    16,  1348,   927,  1291,  1301,  1410,
    1413,  1416,  1417,  1421,  1422,  1438,   265,   344,   863,  1416,
     863,  1286,   400,   863,   506,  1285,   188,   490,   915,  1291,
    1301,  1416,  1295,  1296,   344,   102,   272,  1283,   356,   538,
     263,  1051,  1416,   481,    84,    91,    92,    93,   148,   243,
     570,   571,   572,   574,   575,   576,   577,   578,   579,   944,
     946,  1247,  1248,  1416,   272,  1285,  1285,   102,  1295,  1296,
    1285,  1285,   272,  1283,  1285,  1285,   863,  1285,   426,   456,
     102,   272,  1169,  1285,   445,  1285,   863,   102,   325,  1295,
    1296,   272,  1283,   305,    34,   198,   301,   346,   409,   997,
     998,   999,  1284,  1285,   119,   501,   119,   263,   119,   119,
     119,  1283,  1289,  1416,    96,   101,   140,   154,   155,   166,
     170,   189,   218,   229,   238,   251,   256,   281,   306,   327,
     366,   390,   404,   433,   439,   442,   449,   452,   465,   474,
     481,   490,   493,   497,   504,   506,   511,   538,   756,   869,
     870,  1436,  1083,  1086,  1095,  1105,  1114,  1283,   329,  1291,
    1285,  1049,  1436,   583,   272,   863,   506,  1286,   344,   863,
     506,   272,   459,  1285,   188,   490,   494,   496,  1295,   344,
     532,   494,   496,   263,  1051,   481,   148,   243,   944,   424,
    1285,  1285,  1295,   272,   609,  1416,   272,  1285,   263,   272,
     863,  1285,  1285,   445,  1285,   863,   325,  1295,   414,   449,
     490,   538,   327,   170,   281,   256,   439,   504,   510,   750,
      84,  1312,  1313,   588,  1432,  1439,   102,  1324,  1438,  1112,
     623,  1298,  1436,   949,   329,   272,   927,   928,  1285,   272,
     953,   272,   396,  1286,   127,   129,   130,   131,   132,   143,
     144,   193,   194,   219,   247,   272,   293,   294,   296,   337,
     339,   354,   355,   410,   458,   466,   499,   500,   533,   865,
    1193,  1195,  1197,  1199,  1201,  1203,  1204,  1205,  1207,  1208,
    1209,  1211,  1212,  1410,  1417,  1421,  1422,  1438,   506,   188,
     490,   272,   914,   915,   272,  1296,  1297,   344,   162,   538,
     263,  1051,   481,   148,   243,   272,   945,   946,   134,   272,
    1297,   278,   272,  1285,   272,  1285,   445,   953,   272,   865,
     272,   325,  1297,   305,   272,   862,   863,   272,  1284,   272,
    1285,   583,   589,  1440,  1441,  1442,  1443,  1445,  1350,   238,
     363,    70,  1320,  1369,   583,  1085,   683,  1111,  1070,  1027,
    1071,  1072,  1073,  1298,  1029,  1294,   879,   880,   102,   879,
    1111,  1294,   880,   102,   879,  1111,  1294,   880,   880,   880,
    1294,  1293,  1293,   297,   526,  1374,  1375,  1449,  1451,  1111,
     880,   400,   583,   583,   703,   703,   703,   363,   501,   586,
     703,   442,  1169,  1172,   879,  1111,   263,   879,  1111,  1052,
    1416,   546,   546,   586,   992,   238,  1436,   254,   583,  1082,
     134,   538,   536,   960,   961,  1283,  1285,  1416,   120,   566,
     301,   585,   367,   367,   363,   254,  1436,   501,   583,   581,
     585,  1274,  1276,   249,   873,   363,    82,    83,    84,    86,
     110,   127,   129,   130,   131,   132,   139,   140,   143,   144,
     152,   154,   179,   180,   181,   182,   183,   184,   185,   191,
     193,   194,   196,   236,   241,   242,   247,   262,   264,   294,
     296,   311,   319,   320,   337,   339,   346,   351,   352,   354,
     355,   366,   376,   391,   410,   437,   454,   455,   466,   482,
     486,   489,   499,   500,   505,   507,   508,   517,   525,   533,
     554,   555,   556,   557,   559,   560,   561,   562,   567,   574,
     575,   576,   583,  1115,  1196,  1199,  1202,  1203,  1204,  1206,
    1207,  1208,  1211,  1212,  1216,  1218,  1219,  1220,  1222,  1243,
    1244,  1245,  1249,  1268,  1273,  1280,  1281,  1291,  1292,  1293,
    1416,  1428,  1430,  1432,  1433,  1434,  1435,  1436,  1279,  1280,
     501,   572,  1439,  1436,   501,   572,  1368,   102,   631,  1282,
    1283,   453,   613,   196,   622,  1436,   623,  1436,   120,   145,
     613,   566,   467,   998,   367,   254,   501,   572,   120,   566,
     301,  1449,   999,   583,  1283,   383,   576,  1170,  1171,  1172,
    1420,   253,   255,   536,  1024,  1025,  1027,  1438,   253,  1031,
    1216,  1252,  1120,   586,   583,  1034,   584,   584,   171,   536,
    1032,  1033,   485,  1028,  1283,   384,   189,   238,   256,   281,
     327,   344,   433,   442,   449,   488,   490,   493,   506,   511,
     525,   538,   490,   189,   238,   256,   281,   327,   344,   433,
     442,   449,   459,   490,   493,   506,   511,   525,   538,   490,
     506,   189,   238,   256,   281,   327,   344,   433,   442,   449,
     459,   490,   493,   506,   511,   525,   538,   506,   256,   449,
     490,   511,   490,   490,   538,   449,   490,   433,   119,   260,
     490,   490,   134,   363,   542,  1037,   586,   102,   211,  1127,
    1127,   134,  1127,   244,   249,   315,   359,  1134,  1136,  1137,
    1152,  1154,  1155,  1156,  1130,  1131,   254,   297,  1169,  1173,
     583,   587,  1342,   576,  1361,  1362,  1364,   589,   589,    25,
     293,   293,   501,   501,   501,   501,   583,   501,   574,   575,
     747,  1294,  1329,  1435,   226,   111,  1316,   134,  1319,  1319,
     297,  1374,  1376,   297,  1374,  1375,  1376,   531,  1385,  1386,
    1432,    14,    83,   469,   574,   575,  1293,  1377,  1378,  1379,
    1428,  1430,  1434,  1435,  1436,  1437,   293,   299,  1285,   501,
    1285,     6,  1285,  1409,  1364,   379,   422,   456,   583,   925,
    1276,   344,  1051,   379,   418,   422,   456,   585,   864,   379,
     422,   456,   165,   224,   321,   379,   422,   456,   493,   495,
     546,   624,   627,  1004,  1005,  1006,  1007,  1438,   895,    98,
     220,   379,   422,   456,   529,   642,  1285,    98,   220,   456,
     524,   607,   550,   272,  1169,   136,   173,   204,   240,   275,
     310,   346,   379,   380,   405,   422,   430,   438,   447,   456,
     470,   479,   540,   624,   628,   930,   938,   583,   912,  1276,
     422,   607,  1051,   278,   236,    98,   104,   117,   151,   201,
     204,   209,   213,   214,   215,   220,   223,   231,   250,   283,
     342,   346,   357,   368,   379,   412,   422,   425,   426,   456,
     501,   529,   636,   640,   641,   728,   730,   774,   747,   102,
     272,  1283,  1052,   278,   647,  1285,   863,   863,   583,   943,
     379,   456,   585,   236,   363,    98,   220,   379,   422,   456,
     278,   602,   422,   546,   569,   595,   602,   363,   379,   422,
     236,   111,   135,   187,   280,   328,   331,   342,   378,   422,
     427,   449,   456,   472,   636,   744,   745,   379,   422,   537,
     774,   782,   422,   379,   422,   456,   165,   209,   223,   379,
     418,   422,   456,   626,   614,   616,   278,   236,   117,   206,
     422,   456,   636,   638,   379,   422,   426,   456,   163,   207,
     381,   495,   363,    98,   104,   220,   379,   422,   456,   662,
     663,   602,   249,   422,   595,   602,   236,   422,   456,   636,
    1285,   587,   313,   198,   364,   551,   586,   997,   501,   586,
     102,   171,   344,   363,  1052,   134,   526,  1022,   363,   329,
     927,   583,  1285,  1193,   506,   188,   490,   915,   356,   538,
     148,   243,   946,  1285,  1285,   445,   249,  1285,  1193,   305,
     863,  1285,   249,   584,   703,  1285,   583,   836,   925,   146,
    1193,   346,   254,   583,   832,  1285,   595,   263,   111,  1016,
    1285,   346,   263,   595,   550,   272,  1283,   595,  1051,    81,
     826,  1052,   546,   548,   721,  1285,   863,   863,   832,   521,
     683,   363,   249,   974,   975,   595,   346,   120,   610,   346,
     511,   781,   501,  1293,   346,  1034,   165,   379,   758,   163,
     207,   381,   495,   100,   123,   292,   805,   111,   832,   249,
     272,   595,   538,   272,  1283,   272,   734,  1283,  1283,   538,
     863,   162,   901,  1291,  1285,   249,   756,    73,  1314,  1416,
     588,  1315,  1312,   128,   186,   290,   342,   444,   236,   137,
     428,   586,   643,   643,   236,   583,   236,   272,  1286,   535,
    1210,  1210,  1210,   583,  1198,  1198,   393,   583,  1200,   236,
     143,   144,  1210,  1198,  1198,  1195,   548,   569,   583,  1213,
     583,  1213,   586,   643,   110,  1194,   583,   190,   333,   564,
     583,  1214,   864,  1198,   550,   236,   586,   643,   236,   586,
    1051,   272,   862,  1052,   647,   272,  1285,   272,   863,   272,
     863,   236,   586,   643,  1297,   236,   263,   236,   643,   236,
     163,   207,   381,   495,   249,   236,   643,   236,   249,   272,
     272,   623,   236,   586,   643,   236,   643,   236,   363,   584,
    1441,  1442,  1440,   586,   590,   272,  1285,   583,  1053,  1252,
    1373,  1448,  1449,   490,  1112,   584,   586,   242,   363,   508,
     620,   623,   747,  1074,  1070,   880,  1111,   880,  1111,  1451,
    1452,   880,  1111,   880,  1111,  1452,   880,  1111,  1111,  1111,
     880,    14,   469,  1424,  1427,  1432,  1111,   583,   704,   705,
    1416,   704,   102,   189,   218,   251,   256,   305,   306,   442,
     449,   490,   493,   511,   886,  1282,  1297,   885,  1285,   278,
     586,  1098,  1111,  1052,  1111,   188,   583,   583,  1436,   272,
    1285,  1369,  1193,  1255,   111,  1297,   901,   584,   586,   313,
    1416,   249,   249,   886,  1297,   249,   441,  1416,  1293,  1216,
    1275,   576,  1288,  1418,  1274,   623,   363,   583,   581,  1115,
    1256,  1216,  1272,   583,   583,   249,   583,   583,  1115,   583,
     583,   583,   583,   583,   583,  1216,   583,   583,   583,   583,
     583,   583,   583,   583,  1115,   583,   583,   583,   583,   583,
     583,   583,   583,  1216,  1216,  1216,   532,  1115,  1216,  1252,
    1276,  1436,   583,  1436,    84,    87,    91,    92,    93,   108,
     111,   116,   126,   153,   273,   278,   299,   300,   314,   349,
     366,   369,   462,   567,   570,   571,   572,   574,   575,   576,
     577,   578,   579,  1247,  1249,  1251,  1438,   547,  1231,   375,
    1216,   297,   586,  1124,  1449,   583,  1436,  1276,    22,  1431,
    1432,  1277,  1124,   358,   363,  1401,  1401,    10,   531,  1388,
    1389,  1391,  1368,  1368,   199,   274,   632,   586,   145,   196,
     623,   111,   196,   318,   621,   747,  1212,  1436,  1438,  1436,
     168,   217,  1228,   178,   196,   617,   618,   620,   747,   196,
     617,  1449,  1449,   313,  1283,  1170,   249,   169,   427,   867,
     299,   584,   586,  1029,   584,   586,  1121,  1284,   111,   584,
     586,   102,   254,   501,  1034,   538,   538,   263,   263,   538,
     263,   278,  1042,  1416,   196,   256,   327,   449,   490,   511,
     538,  1043,  1044,  1416,   346,  1038,  1041,  1117,  1117,  1132,
    1133,  1216,  1117,   246,   341,  1143,   303,   342,   409,   460,
     524,   102,  1138,  1216,  1139,  1141,  1216,  1218,  1152,  1153,
    1137,  1136,  1134,  1135,   249,  1155,   357,  1157,  1134,  1152,
    1173,  1087,  1283,   111,  1416,   456,  1252,  1361,   576,   586,
     587,  1419,  1338,  1341,  1338,   293,   190,   270,   330,  1215,
     330,  1215,  1215,   333,  1293,   330,   333,   446,  1435,  1435,
     586,  1330,   195,  1368,   525,  1317,  1319,  1285,   469,  1293,
    1390,  1432,   586,   572,  1285,    14,  1293,  1435,  1293,  1435,
     586,  1348,   583,  1285,   583,  1420,   501,   501,   442,   278,
     288,   370,   372,   458,   534,   576,   918,   919,   920,   922,
     924,   926,  1193,  1417,  1051,   647,   501,   537,   501,   442,
    1288,   585,   501,   501,   442,   315,   501,   501,   493,   613,
     379,  1004,  1006,   572,  1008,   249,   260,   278,   431,   896,
     897,   146,   166,   232,   251,   398,   517,   700,   701,   166,
     196,   346,   501,   166,   501,   196,   346,   442,   166,   209,
     223,   379,   422,   828,   442,   764,    96,   101,   140,   154,
     170,   218,   229,   251,   256,   327,   366,   442,   449,   452,
     490,   497,   504,   511,   538,   756,  1285,   236,   422,   456,
     636,   363,   747,   363,   447,   310,   405,   501,  1416,   501,
     351,   747,   200,   298,   442,   453,   503,   615,   428,   456,
     930,   939,   584,   913,   918,   501,   525,   721,   493,  1283,
     155,   232,   272,   344,   384,   690,   700,  1416,   155,   166,
     964,   383,   363,   344,   363,   437,   439,   506,   134,   134,
     407,   102,   303,   726,  1438,   166,   964,   105,   425,   437,
     439,   506,   281,   437,  1283,   250,   283,   357,   863,   583,
     501,   239,   501,   271,   583,   648,   324,   383,   493,   521,
     546,   548,   648,   263,   344,   166,   586,   379,   278,   236,
     204,   422,   456,   636,   456,   637,   639,  1416,   721,   165,
     209,   223,   418,   456,   526,   526,   345,  1193,   501,   442,
     583,   944,  1285,  1283,   490,   490,   501,   501,   490,   832,
     189,   456,   627,   501,   597,   627,  1283,   501,   501,  1283,
    1195,   747,   134,   746,   747,   747,   187,   328,   331,   134,
     501,   595,   335,   442,   595,   342,   745,   501,   501,   351,
    1436,   774,   501,   501,   501,   442,  1436,   501,   404,   501,
     404,   832,   493,  1169,   383,   383,   166,   501,   964,   442,
     501,   501,   648,   648,   863,   863,   863,   863,  1283,   118,
     531,   118,   118,   501,   118,   501,   531,   442,   586,   627,
     525,   791,  1296,   501,   597,   627,  1283,   501,   442,   379,
     422,   409,   423,   451,   619,   997,  1284,  1285,   250,  1080,
    1053,  1053,  1043,  1044,   254,  1042,  1289,  1416,  1283,   299,
    1193,   363,   299,   550,   299,   747,   863,   863,   299,   363,
     363,   163,   207,   381,   495,  1193,   363,   299,   299,   299,
     146,   501,   546,   674,   511,   837,   838,  1438,   832,   583,
     111,   236,   863,   833,   834,  1418,   100,  1004,  1052,  1193,
     363,   236,   501,  1293,   761,  1285,   346,   383,   583,   596,
     721,   249,   586,   546,   361,   648,   361,   165,   196,   846,
     526,   414,   538,  1283,   102,   490,   134,   976,   977,   596,
     236,  1296,   174,   260,   611,   682,   740,   804,   881,   899,
    1000,   236,  1436,   782,   783,   263,   278,   236,   363,  1436,
    1296,   321,   863,   863,   863,   863,   357,   201,   291,   509,
     524,   806,   807,   227,   408,   583,   791,   346,   596,  1283,
     346,   742,   744,   346,   111,   357,   383,   583,   703,   703,
     272,   737,  1283,   249,   272,   902,  1289,   583,   916,   111,
    1193,   305,   585,  1293,  1315,   546,   548,  1113,   444,   928,
     927,  1193,  1286,   236,   583,  1252,  1293,   865,  1210,  1210,
     110,  1194,   499,   499,  1293,  1293,  1193,   581,   581,  1293,
     501,   501,  1293,  1198,   914,   915,  1297,  1296,   236,   643,
     721,   236,   643,   236,   526,   236,   526,   945,   946,   643,
    1297,  1052,  1285,  1285,  1193,   865,  1297,   791,   236,   236,
     643,   862,   863,  1284,  1285,   863,   584,   590,  1443,   346,
     595,  1051,  1054,  1076,  1436,   584,  1449,  1450,  1373,  1283,
     186,  1070,  1072,  1111,  1111,  1452,  1111,  1111,  1452,  1111,
    1111,  1285,    14,   586,  1431,   704,   584,   586,   584,   257,
     450,   491,  1284,   862,   188,   452,   914,  1284,   356,  1284,
    1282,  1282,  1284,   862,   501,   546,   892,   230,   315,   788,
     789,    96,   234,   437,   460,  1099,  1169,   350,  1100,   188,
     254,  1103,  1104,  1293,  1436,  1103,   346,   595,   584,   586,
    1083,   501,  1283,   958,   959,   961,   884,   883,   884,   254,
     261,   893,   146,  1416,   584,   582,   588,   101,   155,   189,
     218,   229,   251,   256,   306,   327,   404,   433,   442,   449,
     465,   481,   490,   493,   511,   538,   756,   874,   875,  1252,
     582,  1252,  1256,  1257,   541,  1269,  1270,  1216,  1252,   583,
    1293,  1293,   190,   270,   330,   333,   446,   564,  1258,  1259,
    1436,  1438,  1252,  1252,  1252,  1293,  1293,  1216,   944,  1216,
    1260,   437,   574,   575,   583,  1217,  1218,  1249,  1262,   584,
    1252,  1216,  1252,  1263,  1216,   133,   254,   309,   502,  1216,
    1252,  1266,  1252,   335,  1218,  1216,  1226,  1227,  1228,   335,
    1216,  1228,   584,   586,  1293,  1214,  1193,  1216,  1216,  1216,
    1216,  1418,   499,   115,   484,  1278,   863,  1216,   583,  1115,
    1267,   211,   217,   242,   346,   351,   357,   508,   518,  1216,
     583,  1216,   501,   126,   273,   278,   314,   462,  1216,  1216,
    1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,   102,   109,
     468,  1246,   263,   245,  1232,   437,   583,  1243,   259,   318,
     490,   494,   496,   521,  1125,  1283,  1281,   254,  1159,   102,
     211,   534,   576,   584,   920,  1216,  1253,  1254,  1417,  1285,
    1432,  1274,  1159,  1390,   586,   572,  1283,   503,   583,  1436,
     586,  1449,   584,   196,   583,   271,   271,   643,  1348,  1028,
    1283,  1025,  1026,  1028,  1283,  1216,   584,   327,   346,  1122,
    1028,  1283,  1033,  1051,  1054,   485,  1028,   263,   586,  1037,
     538,  1044,  1037,   585,   483,   586,   112,   205,   526,   908,
     583,  1140,  1294,   460,   303,   364,   586,   437,   438,  1142,
    1282,   350,   464,  1101,  1153,  1135,   526,  1096,   196,   377,
     583,  1088,  1114,   111,  1416,   583,  1106,  1107,  1108,  1416,
     584,   587,  1362,  1194,   590,  1341,   590,   584,   747,   584,
      34,  1318,  1393,  1394,  1432,  1386,  1391,  1439,  1377,  1194,
    1426,  1442,  1426,  1194,  1296,  1285,  1285,   372,   134,  1417,
     584,   920,   922,   919,   922,  1417,   370,   584,   586,   864,
     721,   721,  1296,  1285,  1285,  1288,  1296,  1285,  1285,  1296,
    1286,  1285,   196,   620,  1294,   433,   525,   883,   442,   260,
     883,   583,  1285,   526,   903,   303,   303,   526,   583,   732,
     272,  1285,   351,  1296,  1285,  1285,  1216,   351,  1285,  1285,
     105,   425,   501,   501,  1285,   501,   765,   329,   927,   583,
     863,   863,  1193,   506,   188,   490,   915,   538,   148,   243,
     946,  1285,   863,  1285,   863,   445,   249,  1193,   863,   305,
     266,   342,   379,   422,   530,   768,   769,   770,  1169,   501,
     964,   442,   351,   238,   200,   298,  1296,  1285,   363,  1285,
     584,   586,  1295,  1297,  1285,   422,   636,   272,   690,   346,
    1053,  1293,  1193,  1285,  1416,  1283,  1285,  1053,   238,   313,
    1285,   102,   525,  1285,   725,  1438,   583,   212,   727,   272,
    1285,   272,  1416,   439,   506,   439,   506,   313,  1285,   102,
     525,  1285,  1283,   313,   437,  1283,    98,   220,   456,   775,
     776,   777,   778,  1418,  1296,  1285,   196,   255,   347,   526,
     646,   650,   651,  1418,   124,  1285,   361,   151,   361,  1052,
    1053,  1285,   641,   501,   493,  1283,   363,   501,   964,   442,
     501,   586,  1436,   404,   404,   832,  1287,  1416,  1287,   586,
     584,   586,  1296,  1285,   969,   970,  1418,   363,   422,   501,
     799,  1172,  1172,  1296,  1285,  1172,  1286,  1295,   165,   225,
     283,   386,   515,   525,   528,   598,  1438,   422,  1296,  1285,
     422,   456,   636,   744,   747,   863,  1285,   747,   863,  1285,
     747,  1296,  1285,  1285,  1296,  1285,  1285,  1296,   546,   934,
    1285,   980,   981,  1418,  1285,   422,   456,   636,   638,  1283,
    1283,  1285,  1285,  1285,  1285,  1296,  1285,    98,   104,   220,
     379,   422,   456,   379,   422,   456,   832,   422,   456,   422,
     456,   204,   422,  1185,  1416,   272,   842,  1416,   272,  1416,
    1296,  1285,  1285,  1436,  1285,    98,   663,   452,  1295,   422,
     456,   636,  1285,  1285,   501,   501,   161,   514,   409,   249,
    1078,  1078,  1078,  1044,  1051,   351,   871,  1436,   111,   218,
     863,   871,   871,   299,   526,   526,   871,   863,   863,   305,
     863,   871,   871,   871,   364,   403,   667,   361,   459,   668,
     281,   584,   586,   572,  1216,  1193,   863,   584,   586,   572,
     806,   546,   692,  1418,  1285,   263,   278,   137,   254,   442,
     537,   762,   769,   770,   236,   357,   314,   684,   686,   688,
     690,   697,   700,    99,   278,   433,   487,   598,   599,   490,
      81,  1053,  1436,   249,  1287,   538,  1283,   111,   800,   491,
    1172,   459,   934,   609,  1416,   610,   369,   683,  1285,   251,
    1052,  1293,   863,  1252,   404,  1436,   832,   832,   832,   832,
     357,   363,   369,   583,   832,  1183,  1184,  1185,   452,   236,
     583,   236,   236,   235,  1306,   863,   357,   684,  1416,   721,
     546,   649,   346,   111,   703,  1436,   346,   363,   584,   917,
     918,   923,   111,   305,   430,   504,   545,   929,   930,   931,
     363,   305,   623,  1314,   577,   269,   269,   249,   643,   111,
    1286,  1252,   584,   584,   643,   581,   566,   566,   584,   584,
    1293,   582,   583,  1293,  1416,  1436,  1447,   584,   584,   643,
     862,  1285,   863,  1287,   863,  1287,   643,   643,   305,   643,
     452,   249,   623,   643,   643,   363,   643,   236,   761,   584,
     586,  1113,  1439,  1427,   584,   705,   278,   278,   278,   550,
    1284,   747,   748,   263,   887,   888,  1296,    99,   893,   501,
     583,   254,   234,   460,   234,   460,   437,   524,   332,   254,
     360,  1051,  1061,   584,   586,   584,   236,   761,  1193,  1296,
     546,   735,  1283,  1285,   254,   363,   887,   134,   643,   364,
    1216,  1275,   927,  1193,   506,   490,   915,   356,   538,  1193,
     305,   863,  1285,   584,   582,   582,   586,  1216,   222,  1270,
    1271,   111,   584,  1216,   584,   584,   584,   254,   584,   584,
     584,   584,   584,   586,   584,   388,  1261,   584,   583,  1217,
    1217,  1252,    87,    91,    92,    93,   278,   299,   366,   570,
     571,   572,   574,   575,   576,   577,   578,   579,  1249,  1217,
     584,   584,   249,   254,  1264,  1265,   584,   111,  1266,  1252,
    1266,  1266,   254,   584,   584,  1418,   385,  1230,   111,   584,
     586,  1216,  1418,   586,  1216,  1277,  1216,   584,   566,  1217,
    1217,   228,  1252,   254,   211,   217,   242,   351,   357,   508,
     518,   583,   228,   944,  1216,   484,  1278,  1216,  1267,  1216,
     501,   583,  1115,   583,   583,   374,  1236,   583,  1252,   494,
     496,   494,   496,  1283,  1126,  1126,  1126,   308,   438,   563,
     583,  1115,  1160,  1161,  1162,  1169,  1176,  1186,  1219,  1221,
    1222,  1291,  1416,   543,  1181,  1253,  1253,  1254,   584,    89,
      90,   586,  1130,  1131,  1181,     8,    11,    12,    22,    23,
      24,    26,    27,    31,    32,    33,   188,   335,   393,   511,
    1396,  1397,  1399,  1389,  1390,   998,  1293,  1214,   618,  1170,
    1216,  1194,  1034,   459,  1028,   327,   583,  1034,  1416,  1037,
    1416,  1133,   366,  1247,  1250,   568,   909,  1216,  1142,   524,
    1139,   323,  1160,   543,  1182,   532,   488,   525,  1089,  1090,
    1091,  1416,   363,  1092,  1416,  1108,  1109,   586,  1159,   572,
    1277,   588,  1344,   587,   586,   572,    30,  1405,   584,   584,
     587,   926,   864,   922,   922,   134,   924,   578,  1297,  1297,
     363,  1284,   367,   363,  1216,   701,  1287,   583,   583,   583,
     732,   281,   704,   821,   236,   643,   501,  1296,  1285,   623,
    1285,  1193,  1285,   550,   863,   863,   863,   863,   163,   207,
     381,   495,  1193,  1285,   751,  1285,   266,   530,   501,   501,
     751,   768,   774,   422,   456,   636,  1285,  1285,  1285,   289,
    1285,   351,   918,   378,   456,   501,   346,   236,   368,   772,
     821,    98,   220,   426,   427,   456,   642,   652,   653,   774,
     965,  1285,   447,   583,  1284,   583,   236,   643,   236,   643,
    1285,  1285,  1285,  1285,   447,   546,   447,   313,   777,   778,
     777,   584,   586,   779,  1436,   281,   584,   586,   572,   585,
     583,  1052,  1296,  1285,   422,   456,   636,   238,  1285,  1285,
    1285,   196,   639,   934,   980,   379,   422,   456,    98,   220,
     379,   422,   456,  1193,   345,  1193,   584,   586,   572,  1283,
     501,  1297,   526,   796,   315,   386,   351,  1436,   386,  1297,
     523,   501,   501,   442,   832,   586,   934,   378,   456,   166,
     501,   964,   442,   196,   249,   654,   501,   501,   325,   325,
     325,   501,   501,   442,   501,   501,   442,   501,   442,   501,
     442,   363,   501,   643,  1193,   346,  1436,   456,   965,   236,
     643,   501,   501,  1285,   501,   442,  1296,  1285,   189,  1286,
     501,  1079,  1079,  1079,   501,  1193,   863,   299,   871,  1287,
    1287,   299,   299,  1285,   299,   475,   476,   669,  1436,   583,
     254,   501,   666,   266,   838,  1438,   345,   366,   574,   575,
     747,   835,   922,  1250,  1302,  1436,   584,   584,   254,   832,
     834,   835,   363,  1053,   146,   153,   166,   196,   198,   258,
     285,   346,   351,   398,   416,   517,   693,   694,   696,   235,
     541,   595,  1052,  1293,   623,  1285,   623,   772,  1283,  1283,
    1283,   584,   586,  1297,   263,   433,  1297,  1293,  1067,  1416,
     404,   511,  1283,   703,  1438,   249,   801,   583,   120,   610,
     424,   490,   781,   188,  1034,   254,   980,   649,   704,  1283,
     807,   839,   840,  1436,   584,   586,  1285,   249,   704,  1283,
    1283,  1285,  1114,   583,   685,  1283,   584,   363,   722,   648,
     111,   236,  1114,   649,   501,   236,  1169,   584,   586,   196,
     572,   932,  1436,   623,   490,   921,   922,   249,   933,   931,
     934,   201,   291,   448,   524,   989,  1285,   266,  1310,  1114,
    1324,  1193,   584,  1293,  1213,  1213,   582,  1447,   583,   574,
     575,   576,   577,   578,   582,   643,   643,   526,   643,   526,
     643,  1285,  1285,   791,   643,   863,  1285,  1051,   249,   442,
     442,   442,  1284,   586,  1296,   546,   586,   889,   367,  1172,
     452,   234,   234,  1061,   583,   501,  1104,  1285,   188,   342,
    1297,   886,   643,  1296,   582,   299,   299,   299,   747,   299,
     299,   299,  1256,   498,  1216,   226,  1193,   584,  1216,  1216,
    1216,  1264,   584,  1252,   586,  1193,  1217,  1217,  1217,  1217,
     211,   217,   346,   357,  1217,  1217,  1217,  1217,  1217,  1217,
    1217,  1217,  1217,  1217,  1216,  1216,  1265,  1264,  1193,   584,
     584,   584,  1252,   584,   586,   134,  1218,   584,  1418,  1227,
     395,   480,  1229,   584,   586,   537,  1223,   111,   584,  1436,
    1216,   108,   108,  1216,   584,  1216,   254,   583,  1255,  1216,
     584,   228,  1217,  1217,   228,   228,  1216,  1216,  1131,   543,
     583,  1237,  1416,   584,  1252,   586,  1126,  1126,  1126,  1126,
    1283,  1283,  1283,  1115,  1176,  1186,   254,   583,  1115,  1161,
    1162,   111,  1163,  1164,  1416,   586,   175,   255,   287,   302,
     312,   338,   432,  1166,  1164,   111,  1163,  1165,  1416,  1164,
     569,  1180,   583,  1276,  1216,   263,  1144,   586,  1130,  1130,
    1130,  1216,  1216,   534,  1254,   584,  1144,   586,   572,   584,
     584,  1405,  1028,   583,  1083,  1028,   585,   583,   909,   246,
     307,   584,   364,   178,  1216,   429,  1094,   531,   584,   586,
    1277,   164,  1094,   584,   586,  1107,  1182,  1216,  1293,   572,
    1363,  1394,  1399,   584,   578,   926,   511,   257,   443,   450,
     491,   512,   898,   249,   898,   584,   583,   707,   708,   905,
    1221,  1416,   704,   704,   821,  1289,   584,   198,   285,   342,
     346,   822,  1285,  1285,   111,  1285,   526,   526,   863,   863,
     863,   863,   305,   864,  1296,  1285,   501,   964,   442,   501,
     289,   134,   493,  1285,   236,   690,   583,   692,   258,   271,
     346,   648,   595,   188,   258,   346,   474,   478,   648,   745,
     456,   653,   511,  1284,   584,  1284,  1285,  1416,  1283,   447,
     776,  1285,   651,   835,  1418,  1291,  1292,   378,   456,   501,
     964,   442,  1285,   501,   934,   501,   501,   442,   256,   366,
     478,   844,   845,   256,   366,   852,   853,   501,   501,   442,
     584,   584,   584,   970,   345,   747,   922,   971,  1250,  1302,
    1436,   422,  1285,   583,   546,   797,  1294,  1436,  1436,  1436,
    1285,  1285,  1285,   981,   134,   493,  1285,  1285,  1285,  1285,
     532,  1285,  1285,   249,   249,   424,   249,   272,  1296,  1285,
    1285,  1296,  1285,  1285,  1285,  1285,  1285,  1285,   238,  1285,
     153,   644,   236,   100,   123,   511,  1416,  1285,  1436,   774,
    1285,  1285,  1286,   525,  1295,  1051,   584,   299,   871,   299,
     299,   871,   871,   299,   871,   595,  1062,  1293,   667,   751,
     821,   546,   548,   863,  1283,   583,   863,  1285,  1217,   105,
     134,   695,   199,   274,   198,   351,   303,  1283,   934,   402,
     824,   825,  1416,   761,   383,   583,   685,   698,   284,   714,
     688,  1297,  1297,   501,   585,   980,  1193,   583,   649,   102,
     201,   291,   448,   524,   802,   501,   798,  1062,  1296,  1283,
     783,   550,   363,  1160,   934,   417,   808,   584,   586,  1185,
     772,   791,   584,   742,   357,   383,   583,  1085,   735,   687,
     689,   691,   700,  1416,   383,   715,   716,   685,   714,   159,
     493,   723,  1114,   737,   735,   723,  1436,  1289,   903,   923,
    1216,  1216,   586,   583,   929,   511,   586,   501,   583,   751,
      84,  1321,   584,   582,   584,  1348,  1447,  1447,  1447,  1447,
    1447,  1287,  1287,   643,   452,   643,   595,  1284,  1284,  1284,
     747,   260,   888,   584,  1285,   501,  1293,  1061,   595,   188,
     893,   254,   351,   876,  1436,   876,   876,   299,   876,   876,
     876,  1216,   584,   584,  1265,   584,  1216,   254,   211,   217,
     357,   583,   584,   553,  1225,  1252,   415,   134,   544,   544,
     584,  1216,   342,  1216,   586,  1224,  1195,  1216,  1216,  1216,
    1255,   584,  1216,   108,   108,  1216,  1216,   228,   584,   584,
    1216,  1238,  1416,   584,  1216,  1283,  1283,  1283,  1283,  1164,
    1165,  1164,   583,   558,  1218,   584,  1416,   583,  1161,   302,
     373,  1167,  1161,  1167,   302,  1166,  1167,   302,   492,  1174,
     583,  1416,   583,   371,  1253,   134,   267,  1151,   584,   584,
     584,  1254,  1436,  1151,  1397,   575,  1390,  1398,  1435,  1436,
    1436,  1293,   584,  1416,   944,   357,  1280,  1114,   377,  1114,
    1091,   363,   583,  1093,   572,  1108,  1094,  1443,   511,   584,
     501,   883,   254,   821,  1216,   584,   586,   546,   153,   906,
     906,   584,   584,   934,   199,   274,   283,   198,   528,   643,
    1193,  1287,  1287,  1285,  1285,  1285,  1285,  1285,  1297,  1285,
     690,   773,   777,   695,   272,   351,   747,   695,   351,  1294,
    1416,  1193,   584,   584,   643,   643,   572,   583,   584,   134,
     493,  1285,  1285,  1285,  1285,  1296,  1285,  1285,  1293,  1293,
    1193,   586,  1293,  1293,   586,  1296,  1285,  1285,   501,  1216,
     146,  1297,  1285,   501,   501,   254,   278,   546,  1284,  1284,
     863,  1284,   236,  1285,   863,  1436,  1436,  1193,   643,   643,
    1295,   299,   871,   871,   871,   871,   583,   670,   671,   584,
     586,   669,   256,   288,   256,   254,   820,  1216,   346,   694,
     196,   111,   934,   703,   526,   731,  1291,   108,   235,   278,
     357,   684,   654,   233,   279,   583,   452,   263,  1416,   934,
     526,   704,   111,  1297,   796,   584,   610,   583,   251,  1285,
    1252,   340,   362,   809,   810,   811,   249,   814,  1436,   452,
     649,   863,   357,   684,   735,   584,   586,   546,   692,   134,
     721,   654,   715,   201,   220,   395,  1285,   724,   728,   546,
    1001,   111,   254,   363,   583,  1436,   920,   935,   936,  1417,
     934,  1193,   249,  1283,   254,   501,   955,   286,   752,  1322,
    1416,   643,   584,   643,   643,  1285,   761,   367,   297,  1061,
     584,   116,   546,   761,   643,   887,   876,   584,  1217,   254,
     583,  1255,   583,   584,   586,   584,  1218,   415,   584,   531,
     471,   584,   584,   584,  1216,  1216,  1216,   584,   383,  1239,
     584,  1177,  1178,  1221,   583,  1230,  1163,   583,  1284,  1161,
     363,   526,  1168,  1161,   302,  1161,  1291,  1184,   583,  1184,
    1416,  1130,   177,   264,   436,   583,  1145,  1146,  1147,  1148,
    1149,  1150,  1216,  1216,   545,  1233,  1130,  1233,  1293,  1435,
     584,   585,   584,  1111,  1450,  1089,   166,   904,   905,   216,
    1216,   887,   363,   887,   584,   934,   708,   366,   944,   863,
     863,   907,   907,   416,   934,   731,   584,   501,   456,  1100,
     584,   586,   111,   236,   644,   835,  1253,  1297,  1285,   501,
     583,   915,   944,   946,   845,   583,   583,   853,  1285,   584,
     583,   456,  1100,  1285,  1285,   583,   583,   583,   546,   569,
    1019,   424,  1019,  1019,   249,   644,   871,   677,   678,  1418,
     128,   176,   202,   224,   228,   250,   253,   268,   351,   361,
     406,   438,   672,  1293,   526,   675,   676,   915,   111,   951,
     951,  1283,   821,   584,   271,   731,   326,   706,   281,   583,
     825,   402,   583,  1283,   584,   452,   102,   158,   167,   197,
     271,   282,   478,   699,   699,  1282,  1285,  1052,  1287,   584,
    1114,   797,   188,   772,   254,   810,   437,   490,   812,   221,
     815,   541,   817,  1285,   111,   685,  1283,   584,   689,   368,
     718,  1299,  1438,   722,   715,   721,   438,   438,   729,   730,
     138,   146,   318,  1114,   863,  1169,   904,   922,   584,   586,
     511,  1181,   469,   469,   584,   751,   342,   530,   753,   754,
     572,  1323,  1285,   546,  1293,   583,   643,  1217,  1255,   584,
    1226,  1252,   134,   342,   565,   134,  1130,   584,   586,   111,
    1179,   196,  1191,  1192,  1217,   156,  1284,   584,  1216,   583,
    1161,  1168,   583,   584,  1184,   584,   584,   583,   457,   583,
     584,   586,  1234,  1235,  1416,   584,  1416,   531,  1285,   584,
     586,   347,   524,   889,   898,   643,   906,   731,   583,   908,
     908,  1283,   731,   821,  1285,   493,   777,   271,   526,   645,
    1130,   456,  1100,  1285,  1255,   249,   848,   848,  1255,  1255,
    1216,   493,   242,   328,   331,   351,   508,   657,   659,   660,
     747,  1436,   657,   658,   655,   656,  1298,   862,   863,   862,
     863,  1284,   643,   584,   586,   576,   583,   620,   679,   747,
    1016,  1436,  1016,   346,   351,   406,  1016,  1016,   595,   203,
     951,   114,   276,   249,   342,   702,   583,   743,   255,   382,
     463,   363,   710,   711,   712,   493,   584,  1291,   826,   685,
     714,  1285,   584,   772,  1052,   243,   847,   649,  1001,   550,
    1160,  1016,   437,   473,   816,   583,   235,   772,  1114,   715,
     685,   714,   692,   583,   723,   721,   722,   146,   367,   146,
     735,   903,   584,   929,   935,  1193,   216,   546,   546,   530,
     751,  1293,  1430,  1438,    84,   772,   583,  1062,   584,   584,
     584,   415,   531,  1252,   408,   438,  1240,  1180,  1177,   583,
    1217,   584,   586,   111,  1187,  1188,  1416,   584,  1284,  1252,
     584,  1252,   583,  1252,  1146,   586,   111,  1114,  1181,   905,
     456,   254,   907,   543,   709,   944,   909,   909,   703,   821,
    1285,   743,  1216,   584,   493,   584,   370,   445,   413,   849,
     849,   584,   584,   584,  1285,   584,   586,   584,   586,   584,
     586,  1293,  1019,   678,   620,   680,   681,  1436,  1436,   351,
     704,   576,   704,  1436,  1436,   670,  1436,   221,   283,   744,
     201,   524,   363,   712,   363,   711,  1285,   583,   584,   654,
     452,   772,   863,   111,   111,  1285,   813,  1416,  1216,   402,
    1001,   721,   654,   715,   583,   719,   720,  1221,  1416,   724,
     722,   723,   367,   367,   583,   649,   934,   103,   292,   990,
     256,   256,  1322,  1062,   584,   126,   178,   513,  1216,  1241,
    1242,  1241,   584,  1184,   586,  1192,  1418,   584,   586,   249,
    1193,   584,   584,   584,  1145,   584,  1235,  1237,  1106,   887,
     908,   583,   821,   584,   706,  1100,  1285,   915,   134,  1100,
     501,   660,   657,   655,   863,   584,   586,   704,   437,   584,
     137,   342,   428,   456,   713,   713,   584,   452,  1285,   844,
    1114,   772,   584,  1291,   722,   715,   721,  1216,   584,   586,
     906,   906,   729,   723,   724,   904,   723,   347,   583,   985,
     987,   991,  1086,  1095,  1105,  1114,   915,   915,   584,  1242,
     437,   248,   392,   248,   392,   584,  1218,  1188,   371,   196,
     346,   351,  1189,  1190,  1438,   423,  1175,   584,  1181,   643,
     909,  1216,   710,  1100,   863,   583,   681,   817,    97,   196,
     351,  1285,   772,  1001,   583,   723,   721,   722,   584,   124,
     717,   720,   907,   907,   729,   584,  1181,   986,   987,   988,
    1115,  1116,   586,   586,   108,  1230,  1217,   351,  1190,  1217,
     583,   584,   821,   659,   235,   772,   818,   819,  1293,  1418,
    1435,  1436,   724,   722,   723,   906,   583,   649,   584,   587,
     501,   254,  1242,   156,  1216,   584,   402,   584,   586,   729,
     723,   724,   907,  1292,   723,   988,   469,   469,  1187,   584,
    1291,   819,   729,   584,  1181,   546,   546,   584,   583,   477,
     256,   256,   818,   583,   915,   915,   584,  1292,   584,   384,
     583,  1293,   584
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   591,   592,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   594,   595,   595,   595,
     596,   596,   597,   597,   598,   598,   598,   598,   598,   598,
     598,   598,   598,   599,   599,   599,   599,   599,   599,   600,
     601,   601,   602,   602,   603,   603,   603,   603,   604,   604,
     604,   604,   604,   604,   605,   606,   607,   607,   608,   608,
     608,   608,   609,   609,   610,   610,   611,   611,   611,   611,
     611,   611,   612,   612,   612,   613,   613,   613,   614,   614,
     614,   614,   615,   615,   615,   615,   615,   615,   615,   615,
     615,   615,   615,   616,   616,   617,   617,   618,   618,   619,
     619,   619,   619,   620,   620,   620,   620,   621,   621,   621,
     621,   621,   621,   621,   622,   622,   622,   623,   623,   624,
     625,   625,   625,   625,   626,   626,   627,   627,   628,   628,
     629,   629,   629,   629,   629,   630,   631,   631,   632,   632,
     633,   634,   634,   634,   634,   634,   635,   635,   635,   635,
     635,   635,   635,   635,   635,   635,   635,   635,   635,   635,
     635,   635,   635,   635,   635,   636,   636,   637,   637,   638,
     638,   639,   640,   641,   641,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   641,   641,   642,   642,   643,
     643,   643,   644,   644,   645,   645,   646,   646,   646,   646,
     647,   647,   648,   649,   649,   650,   650,   651,   651,   651,
     651,   652,   652,   653,   653,   653,   653,   654,   654,   654,
     654,   655,   656,   656,   657,   657,   657,   657,   657,   658,
     658,   659,   659,   660,   660,   660,   661,   662,   662,   663,
     663,   663,   663,   664,   664,   665,   665,   666,   666,   667,
     667,   668,   668,   669,   669,   669,   670,   670,   671,   671,
     672,   672,   672,   672,   672,   672,   672,   672,   672,   672,
     672,   672,   672,   672,   672,   673,   673,   674,   674,   675,
     675,   676,   676,   677,   677,   678,   679,   679,   679,   679,
     679,   680,   680,   681,   682,   682,   682,   682,   682,   682,
     683,   683,   683,   683,   683,   683,   683,   683,   684,   684,
     685,   685,   686,   686,   687,   687,   688,   688,   688,   689,
     689,   690,   691,   691,   692,   692,   693,   693,   693,   693,
     694,   694,   694,   694,   694,   694,   694,   694,   695,   695,
     696,   696,   696,   696,   697,   698,   698,   698,   699,   699,
     699,   699,   699,   699,   699,   700,   700,   701,   701,   701,
     701,   701,   701,   701,   702,   702,   703,   703,   704,   704,
     705,   706,   706,   706,   706,   707,   707,   708,   708,   709,
     709,   710,   710,   710,   710,   710,   711,   712,   713,   713,
     713,   713,   713,   714,   714,   715,   715,   716,   717,   717,
     718,   718,   719,   719,   720,   720,   720,   721,   721,   721,
     721,   722,   722,   722,   722,   723,   723,   724,   724,   725,
     726,   726,   726,   727,   727,   728,   728,   728,   728,   728,
     729,   729,   730,   730,   730,   731,   731,   731,   732,   733,
     733,   734,   735,   735,   735,   736,   736,   737,   738,   738,
     739,   740,   740,   741,   741,   742,   742,   743,   743,   744,
     744,   745,   745,   745,   745,   745,   745,   745,   745,   745,
     745,   745,   745,   745,   745,   746,   746,   747,   747,   747,
     747,   748,   748,   749,   749,   750,   750,   751,   751,   752,
     752,   753,   753,   754,   754,   755,   755,   756,   756,   757,
     758,   758,   759,   759,   760,   760,   760,   760,   760,   760,
     761,   761,   762,   762,   762,   762,   763,   764,   764,   765,
     766,   766,   766,   766,   766,   766,   766,   766,   766,   766,
     766,   766,   766,   766,   766,   766,   766,   766,   766,   766,
     766,   766,   766,   766,   766,   766,   767,   768,   768,   768,
     768,   769,   769,   770,   770,   771,   771,   772,   772,   773,
     773,   774,   775,   775,   776,   776,   776,   776,   777,   778,
     779,   780,   780,   781,   781,   782,   782,   783,   783,   784,
     784,   784,   785,   785,   785,   785,   786,   786,   787,   788,
     788,   789,   789,   790,   790,   791,   791,   792,   792,   793,
     794,   795,   796,   796,   797,   797,   798,   798,   799,   799,
     800,   800,   801,   801,   802,   802,   802,   802,   802,   803,
     804,   804,   805,   805,   805,   806,   806,   807,   807,   807,
     807,   807,   808,   808,   809,   809,   810,   811,   811,   812,
     812,   813,   814,   814,   815,   815,   816,   816,   817,   817,
     818,   818,   818,   819,   819,   819,   819,   820,   820,   821,
     821,   822,   822,   822,   822,   822,   822,   823,   823,   824,
     824,   825,   826,   826,   827,   828,   828,   828,   828,   829,
     830,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   832,   833,   833,
     834,   834,   835,   835,   835,   835,   835,   835,   836,   837,
     837,   838,   839,   839,   840,   840,   841,   841,   841,   841,
     842,   842,   843,   844,   844,   845,   845,   845,   845,   845,
     846,   846,   847,   847,   848,   848,   848,   849,   849,   850,
     851,   851,   852,   852,   853,   853,   854,   854,   855,   855,
     856,   857,   858,   858,   858,   858,   858,   858,   858,   858,
     858,   858,   858,   858,   859,   859,   859,   859,   859,   859,
     859,   859,   859,   859,   859,   859,   859,   860,   860,   860,
     860,   860,   860,   860,   861,   861,   861,   862,   862,   863,
     863,   864,   864,   865,   865,   866,   867,   867,   867,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   869,   869,   869,   869,
     869,   869,   869,   869,   869,   869,   869,   869,   869,   869,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   871,   871,   872,   872,   872,   872,   872,
     872,   872,   873,   873,   874,   874,   874,   874,   874,   874,
     875,   875,   875,   875,   875,   875,   875,   875,   875,   876,
     876,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   878,   878,   878,   878,   878,   878,   878,   878,
     878,   878,   878,   878,   878,   878,   879,   879,   880,   880,
     881,   882,   882,   883,   883,   883,   883,   883,   884,   884,
     885,   885,   885,   885,   886,   886,   886,   886,   886,   886,
     886,   886,   886,   886,   886,   886,   886,   886,   886,   886,
     887,   887,   888,   888,   889,   889,   890,   891,   891,   892,
     892,   893,   893,   894,   895,   895,   896,   896,   896,   897,
     897,   897,   898,   898,   898,   898,   898,   899,   899,   900,
     900,   901,   901,   902,   902,   903,   903,   904,   904,   905,
     905,   905,   906,   906,   907,   907,   908,   908,   908,   909,
     909,   909,   910,   910,   910,   911,   911,   912,   912,   913,
     913,   914,   914,   915,   915,   915,   915,   916,   916,   917,
     917,   918,   918,   918,   918,   918,   919,   919,   919,   919,
     919,   920,   921,   922,   922,   922,   923,   923,   923,   924,
     925,   925,   925,   925,   926,   926,   927,   928,   928,   929,
     929,   930,   930,   930,   930,   930,   930,   930,   930,   930,
     930,   930,   930,   930,   930,   930,   930,   930,   930,   931,
     931,   931,   931,   931,   932,   932,   933,   933,   934,   934,
     935,   936,   936,   937,   938,   938,   939,   939,   940,   940,
     941,   941,   942,   942,   943,   943,   943,   943,   944,   944,
     945,   945,   946,   947,   948,   948,   949,   949,   950,   950,
     950,   951,   951,   951,   952,   953,   953,   954,   955,   955,
     955,   955,   956,   957,   957,   957,   957,   958,   958,   959,
     959,   959,   960,   960,   961,   962,   962,   963,   963,   963,
     963,   963,   963,   963,   963,   963,   963,   963,   963,   963,
     963,   963,   963,   963,   963,   963,   963,   963,   963,   963,
     963,   963,   963,   963,   963,   963,   963,   963,   963,   963,
     963,   963,   963,   963,   963,   963,   963,   963,   963,   963,
     963,   963,   963,   963,   963,   963,   963,   963,   963,   964,
     964,   965,   965,   966,   966,   966,   966,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   968,   969,   969,   970,   970,   971,   971,   971,
     971,   971,   972,   972,   972,   972,   972,   972,   972,   972,
     972,   972,   972,   972,   972,   972,   972,   972,   972,   972,
     972,   972,   972,   972,   973,   974,   974,   975,   975,   976,
     976,   977,   978,   978,   978,   978,   979,   979,   980,   980,
     981,   982,   982,   982,   982,   982,   982,   982,   982,   982,
     982,   982,   982,   983,   983,   983,   983,   984,   985,   985,
     985,   986,   986,   987,   987,   987,   987,   987,   988,   988,
     989,   989,   989,   989,   990,   990,   990,   991,   992,   992,
     993,   994,   994,   995,   995,   995,   995,   995,   995,   995,
     995,   995,   995,   995,   995,   995,   995,   995,   995,   995,
     995,   995,   996,   996,   996,   997,   997,   997,   997,   997,
     998,   998,   998,   999,   999,  1000,  1000,  1000,  1000,  1001,
    1001,  1001,  1001,  1002,  1003,  1004,  1004,  1005,  1005,  1006,
    1006,  1006,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1008,
    1008,  1009,  1009,  1009,  1010,  1011,  1011,  1011,  1011,  1012,
    1013,  1013,  1014,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1016,  1016,  1017,  1018,  1018,  1018,  1018,  1018,  1018,  1019,
    1019,  1020,  1021,  1021,  1021,  1022,  1022,  1023,  1023,  1023,
    1023,  1023,  1023,  1024,  1024,  1025,  1025,  1025,  1025,  1025,
    1026,  1026,  1026,  1026,  1027,  1027,  1028,  1028,  1028,  1028,
    1029,  1029,  1030,  1030,  1031,  1031,  1032,  1032,  1033,  1033,
    1034,  1034,  1035,  1035,  1035,  1035,  1036,  1036,  1037,  1037,
    1038,  1038,  1039,  1039,  1040,  1040,  1041,  1041,  1041,  1041,
    1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,
    1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,
    1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,
    1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,
    1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,
    1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,
    1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,
    1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,
    1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,
    1041,  1042,  1042,  1043,  1043,  1043,  1043,  1043,  1043,  1044,
    1044,  1044,  1044,  1044,  1045,  1045,  1045,  1045,  1045,  1045,
    1045,  1045,  1046,  1047,  1047,  1048,  1049,  1049,  1050,  1050,
    1051,  1052,  1053,  1054,  1054,  1055,  1055,  1055,  1055,  1056,
    1056,  1057,  1057,  1058,  1059,  1060,  1060,  1060,  1060,  1061,
    1061,  1062,  1062,  1063,  1063,  1063,  1063,  1064,  1065,  1065,
    1066,  1066,  1067,  1067,  1068,  1068,  1069,  1069,  1069,  1069,
    1070,  1070,  1070,  1070,  1070,  1070,  1070,  1070,  1070,  1071,
    1071,  1072,  1073,  1073,  1074,  1074,  1074,  1075,  1076,  1077,
    1077,  1077,  1078,  1078,  1078,  1079,  1079,  1079,  1080,  1080,
    1081,  1081,  1082,  1082,  1083,  1083,  1083,  1083,  1084,  1084,
    1085,  1085,  1086,  1087,  1087,  1088,  1088,  1088,  1088,  1088,
    1089,  1089,  1090,  1090,  1091,  1092,  1092,  1092,  1093,  1093,
    1093,  1094,  1094,  1095,  1096,  1096,  1097,  1098,  1098,  1099,
    1099,  1099,  1099,  1099,  1099,  1099,  1099,  1100,  1100,  1101,
    1101,  1101,  1102,  1102,  1103,  1103,  1104,  1104,  1105,  1106,
    1106,  1107,  1107,  1108,  1109,  1109,  1110,  1111,  1111,  1112,
    1112,  1112,  1112,  1112,  1113,  1113,  1113,  1114,  1114,  1115,
    1115,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1117,
    1117,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1119,  1119,
    1119,  1120,  1120,  1121,  1122,  1122,  1122,  1123,  1123,  1124,
    1124,  1124,  1125,  1125,  1125,  1125,  1125,  1125,  1125,  1125,
    1125,  1126,  1126,  1127,  1127,  1127,  1128,  1128,  1129,  1129,
    1130,  1130,  1131,  1132,  1132,  1133,  1133,  1134,  1134,  1134,
    1134,  1135,  1135,  1136,  1136,  1136,  1137,  1137,  1138,  1138,
    1139,  1140,  1140,  1140,  1141,  1142,  1142,  1143,  1143,  1144,
    1144,  1145,  1145,  1146,  1146,  1146,  1146,  1146,  1147,  1148,
    1149,  1150,  1151,  1151,  1152,  1152,  1153,  1153,  1154,  1154,
    1155,  1156,  1156,  1156,  1156,  1157,  1157,  1158,  1158,  1159,
    1159,  1160,  1160,  1161,  1161,  1161,  1161,  1161,  1161,  1161,
    1161,  1161,  1161,  1162,  1162,  1162,  1162,  1162,  1162,  1163,
    1163,  1163,  1163,  1164,  1164,  1165,  1165,  1165,  1165,  1165,
    1166,  1166,  1166,  1166,  1167,  1167,  1168,  1168,  1169,  1169,
    1169,  1169,  1170,  1170,  1171,  1171,  1172,  1172,  1173,  1173,
    1173,  1174,  1175,  1175,  1176,  1176,  1177,  1178,  1178,  1179,
    1179,  1180,  1180,  1181,  1181,  1182,  1182,  1182,  1183,  1183,
    1184,  1184,  1185,  1186,  1186,  1187,  1187,  1188,  1188,  1188,
    1189,  1189,  1190,  1190,  1190,  1190,  1191,  1191,  1192,  1192,
    1193,  1193,  1193,  1193,  1193,  1193,  1194,  1194,  1194,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1196,  1196,  1196,  1196,
    1197,  1197,  1198,  1198,  1199,  1199,  1199,  1199,  1199,  1199,
    1199,  1199,  1199,  1199,  1199,  1199,  1199,  1199,  1200,  1200,
    1201,  1201,  1202,  1202,  1203,  1204,  1205,  1205,  1206,  1206,
    1207,  1208,  1209,  1209,  1209,  1209,  1209,  1209,  1210,  1210,
    1211,  1211,  1211,  1211,  1212,  1213,  1213,  1213,  1214,  1214,
    1214,  1214,  1214,  1214,  1214,  1214,  1214,  1214,  1214,  1214,
    1214,  1214,  1215,  1215,  1216,  1216,  1216,  1216,  1216,  1216,
    1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,
    1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,
    1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,
    1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,
    1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,
    1216,  1216,  1216,  1216,  1216,  1216,  1216,  1216,  1217,  1217,
    1217,  1217,  1217,  1217,  1217,  1217,  1217,  1217,  1217,  1217,
    1217,  1217,  1217,  1217,  1217,  1217,  1217,  1217,  1217,  1217,
    1217,  1217,  1217,  1218,  1218,  1218,  1218,  1218,  1218,  1218,
    1218,  1218,  1218,  1218,  1218,  1218,  1218,  1219,  1219,  1219,
    1219,  1219,  1219,  1219,  1220,  1220,  1221,  1221,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1223,  1223,  1224,  1224,  1224,  1224,
    1225,  1226,  1226,  1227,  1227,  1228,  1228,  1229,  1229,  1229,
    1230,  1230,  1230,  1230,  1231,  1231,  1232,  1232,  1233,  1233,
    1234,  1234,  1235,  1236,  1236,  1236,  1237,  1238,  1238,  1239,
    1239,  1240,  1240,  1240,  1241,  1241,  1242,  1242,  1242,  1242,
    1242,  1243,  1243,  1243,  1244,  1244,  1245,  1246,  1246,  1246,
    1247,  1247,  1248,  1248,  1248,  1248,  1248,  1248,  1248,  1248,
    1248,  1248,  1248,  1248,  1249,  1249,  1250,  1250,  1251,  1251,
    1251,  1251,  1251,  1251,  1252,  1252,  1253,  1253,  1254,  1254,
    1254,  1255,  1255,  1256,  1256,  1256,  1257,  1257,  1258,  1258,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1260,  1260,
    1261,  1262,  1262,  1263,  1263,  1263,  1263,  1263,  1263,  1264,
    1265,  1266,  1266,  1266,  1267,  1267,  1268,  1269,  1269,  1270,
    1271,  1271,  1272,  1272,  1273,  1273,  1274,  1274,  1274,  1274,
    1275,  1275,  1276,  1276,  1277,  1277,  1278,  1278,  1279,  1279,
    1280,  1280,  1281,  1281,  1281,  1281,  1282,  1282,  1283,  1283,
    1284,  1284,  1285,  1286,  1287,  1288,  1289,  1290,  1291,  1291,
    1292,  1292,  1292,  1292,  1292,  1292,  1292,  1292,  1292,  1292,
    1292,  1292,  1292,  1292,  1292,  1293,  1294,  1294,  1294,  1294,
    1295,  1296,  1296,  1296,  1297,  1297,  1298,  1298,  1298,  1298,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,  1299,
    1299,  1299,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,
    1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,
    1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,
    1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,
    1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,
    1300,  1300,  1301,  1301,  1301,  1301,  1301,  1301,  1301,  1301,
    1301,  1301,  1301,  1301,  1301,  1301,  1301,  1301,  1301,  1301,
    1301,  1301,  1301,  1301,  1301,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1303,
    1303,  1304,  1304,  1304,  1304,  1304,  1304,  1304,  1304,  1306,
    1305,  1307,  1308,  1308,  1308,  1308,  1309,  1309,  1309,  1309,
    1310,  1310,  1311,  1312,  1313,  1313,  1314,  1314,  1314,  1315,
    1315,  1316,  1316,  1317,  1317,  1318,  1318,  1318,  1318,  1319,
    1319,  1319,  1320,  1321,  1321,  1322,  1322,  1323,  1323,  1323,
    1323,  1324,  1324,  1325,  1326,  1327,  1328,  1328,  1329,  1330,
    1330,  1331,  1331,  1331,  1331,  1331,  1333,  1332,  1334,  1335,
    1336,  1336,  1337,  1337,  1337,  1337,  1338,  1338,  1340,  1339,
    1342,  1341,  1343,  1341,  1341,  1344,  1344,  1345,  1345,  1345,
    1346,  1346,  1346,  1346,  1347,  1347,  1348,  1348,  1348,  1348,
    1348,  1348,  1349,  1349,  1349,  1350,  1352,  1351,  1353,  1354,
    1353,  1355,  1355,  1356,  1356,  1357,  1357,  1358,  1358,  1358,
    1358,  1358,  1358,  1358,  1358,  1358,  1359,  1359,  1359,  1359,
    1359,  1359,  1359,  1359,  1359,  1359,  1360,  1360,  1361,  1361,
    1362,  1363,  1363,  1364,  1364,  1364,  1365,  1366,  1367,  1367,
    1367,  1367,  1368,  1368,  1368,  1369,  1369,  1370,  1370,  1371,
    1372,  1372,  1373,  1373,  1374,  1374,  1375,  1375,  1376,  1377,
    1377,  1378,  1378,  1378,  1379,  1379,  1379,  1379,  1379,  1379,
    1379,  1379,  1379,  1380,  1380,  1380,  1380,  1380,  1381,  1381,
    1382,  1383,  1384,  1385,  1385,  1386,  1387,  1388,  1388,  1389,
    1390,  1390,  1391,  1392,  1393,  1393,  1394,  1395,  1396,  1396,
    1397,  1398,  1398,  1398,  1398,  1398,  1399,  1399,  1399,  1399,
    1399,  1399,  1399,  1399,  1399,  1399,  1399,  1399,  1399,  1399,
    1399,  1400,  1400,  1401,  1401,  1402,  1402,  1402,  1404,  1403,
    1405,  1405,  1407,  1406,  1408,  1408,  1408,  1409,  1409,  1409,
    1409,  1409,  1409,  1409,  1409,  1409,  1410,  1410,  1411,  1411,
    1411,  1411,  1411,  1411,  1411,  1411,  1411,  1411,  1411,  1411,
    1411,  1411,  1411,  1411,  1411,  1411,  1411,  1411,  1411,  1411,
    1411,  1412,  1412,  1412,  1412,  1412,  1412,  1413,  1413,  1413,
    1413,  1413,  1413,  1413,  1414,  1415,  1415,  1415,  1415,  1415,
    1415,  1415,  1415,  1416,  1416,  1416,  1416,  1416,  1416,  1416,
    1417,  1417,  1417,  1417,  1417,  1417,  1418,  1418,  1418,  1418,
    1418,  1418,  1418,  1418,  1418,  1418,  1418,  1419,  1419,  1419,
    1419,  1419,  1420,  1420,  1420,  1420,  1421,  1421,  1421,  1421,
    1421,  1421,  1421,  1422,  1422,  1422,  1423,  1423,  1423,  1423,
    1423,  1423,  1424,  1424,  1425,  1426,  1426,  1427,  1427,  1428,
    1429,  1430,  1431,  1431,  1431,  1432,  1433,  1434,  1435,  1436,
    1436,  1436,  1436,  1436,  1437,  1438,  1438,  1438,  1439,  1439,
    1440,  1440,  1440,  1441,  1441,  1442,  1442,  1443,  1443,  1444,
    1444,  1444,  1444,  1444,  1445,  1445,  1445,  1445,  1445,  1445,
    1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,
    1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,
    1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,
    1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,
    1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,  1445,
    1446,  1446,  1446,  1446,  1447,  1447,  1447,  1447,  1447,  1447,
    1447,  1447,  1447,  1447,  1448,  1448,  1448,  1448,  1449,  1449,
    1450,  1450,  1451,  1451,  1452,  1452
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     1,     1,     0,
       2,     0,     2,     0,     2,     2,     3,     3,     1,     3,
       3,     2,     1,     1,     2,     2,     2,     3,     3,     5,
       5,     5,     0,     3,     5,     5,     5,     5,     3,     5,
       3,     5,     3,     5,     5,     6,     1,     1,     6,     4,
       9,     7,     1,     0,     2,     0,     1,     1,     1,     1,
       1,     1,     2,     3,     3,     2,     5,     1,     3,     3,
       3,     3,     1,     3,     3,     2,     2,     2,     2,     3,
       3,     3,     3,     1,     3,     1,     3,     1,     1,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     2,     3,     2,     1,     1,     2,     1,     2,     1,
       3,     4,     5,     4,     2,     4,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     4,     6,     4,     6,
      10,    13,     4,     6,     4,    10,    13,     4,     6,     4,
       6,     5,     7,    11,    14,     1,     3,     1,     3,     4,
       3,     3,     3,     2,     5,     3,     6,     4,     6,     6,
       6,     5,     5,     6,     9,     4,     5,     7,     6,     4,
       8,     4,     2,     3,     5,     6,     4,     3,     6,     4,
       3,     3,     3,     3,     2,     2,     3,     4,     4,     3,
       3,     3,     3,     3,     3,     4,     4,     3,     2,     3,
       2,     2,     3,     3,     2,     2,     3,     4,     4,     4,
       5,     1,     1,     1,     3,     3,     2,     3,     2,     1,
       1,     0,     2,     0,     2,     0,     1,     1,     1,     3,
       2,     0,     3,     2,     0,     1,     3,     3,     1,     5,
       3,     1,     2,     1,     3,     2,     3,     6,     6,    10,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     1,     1,     1,     4,     1,     3,     4,
       6,     4,     8,     2,     2,    12,     9,     1,     1,     1,
       0,     4,     0,     1,     1,     1,     1,     3,     2,     0,
       1,     1,     1,     3,     3,     1,     1,     1,     3,     3,
       3,     3,     4,     3,     2,     1,     0,     2,     0,     3,
       0,     1,     0,     1,     3,     2,     1,     1,     1,     3,
       0,     1,     3,     1,    14,    17,    13,    16,    13,    16,
       1,     1,     2,     2,     2,     2,     1,     0,     1,     0,
       3,     0,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     4,     2,     4,     2,     0,     3,     1,     1,     2,
       2,     1,     3,     4,     5,     2,     5,     5,     1,     2,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     5,     7,     3,
       8,     4,     9,    11,     2,     0,     3,     0,     1,     3,
       1,     2,     2,     2,     0,     1,     3,     3,     6,     4,
       0,     1,     1,     2,     2,     0,     3,     3,     2,     1,
       1,     2,     2,     4,     0,     1,     0,     7,    12,     0,
       1,     1,     1,     3,     3,     3,     5,     2,     2,     2,
       0,     3,     4,     4,     0,     2,     0,     1,     0,     1,
       1,     1,     1,     4,     0,     6,     3,     5,     2,     3,
       1,     0,     3,     3,     4,     4,     2,     0,     3,     8,
      11,     7,     2,     3,     0,     8,    11,     4,     1,     0,
       6,     5,     8,     4,     6,     1,     0,     3,     0,     1,
       2,     2,     2,     1,     2,     3,     2,     2,     2,     2,
       3,     3,     3,     1,     3,     1,     0,     1,     2,     2,
       1,     1,     3,     6,    10,     1,     0,     1,     2,     2,
       0,     2,     2,     1,     0,     5,     7,     1,     0,     7,
       2,     0,     3,     5,     5,     8,     6,     9,     6,     9,
       2,     0,     2,     2,     2,     1,     5,     2,     0,     2,
       7,     6,    10,     6,     6,     6,     6,     7,     6,     9,
       9,     6,     7,     6,     8,     8,     8,     8,     6,     6,
       7,     7,     8,     6,     9,     6,     7,     2,     2,     2,
       2,     1,     2,     1,     0,     7,     6,     4,     0,     1,
       3,     4,     1,     3,     1,     2,     2,     2,     2,     1,
       1,    10,    13,     2,     0,     2,     2,     1,     0,     5,
       4,     4,    11,    14,    12,    15,     5,     7,    11,     2,
       1,     4,     0,     8,    11,     1,     1,     7,     9,     8,
      10,     8,     4,     0,     5,     0,     2,     0,     2,     0,
       2,     0,     2,     0,     1,     1,     1,     1,     1,     8,
      16,    20,     1,     1,     2,     1,     3,     1,     1,     1,
       3,     1,     2,     0,     1,     2,     4,     1,     1,     1,
       1,     1,     3,     0,     1,     0,     1,     1,     4,     0,
       1,     3,     0,     1,     1,     1,     1,     2,     0,     0,
       2,     2,     1,     2,     2,     2,     2,    11,    13,     1,
       3,     5,     1,     3,     5,     1,     2,     2,     1,     8,
       4,     5,     4,     4,     4,     3,     7,     8,     6,     6,
       6,     6,     6,     4,     7,     5,     8,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     3,     1,     0,     1,     3,     7,     9,     9,     8,
       3,     0,    13,     1,     3,     5,     5,     3,     6,     2,
       1,     0,     2,     0,     2,     4,     0,     1,     0,     6,
       8,     8,     1,     3,     5,     5,     7,     9,     7,     9,
       5,     6,     6,     4,     6,     4,     6,     8,     4,     6,
       4,     6,     5,     7,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     3,     3,     3,     3,     2,     2,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       2,     2,     3,     1,     3,     5,     2,     2,     0,     6,
       6,     6,     6,     6,     6,     6,     8,     9,     8,     8,
       9,     8,     9,     9,     7,    10,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     2,     3,     3,     3,     3,
       2,     1,     2,     1,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     8,     8,     8,     8,     8,
       8,     9,     2,     0,     1,     2,     1,     1,     1,     2,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     3,     4,     5,     4,     5,     3,     4,
       3,     4,     1,     2,     3,     3,     3,     3,     4,     4,
       3,     3,     4,     4,     4,     4,     1,     1,     1,     0,
       7,     7,    10,     1,     1,     2,     4,     5,     1,     3,
       2,     2,     2,     2,     1,     2,     2,     4,     3,     2,
       2,     2,     2,     3,     2,     2,     2,     5,     5,     5,
       1,     3,     1,     2,     3,     0,     6,     6,     9,     3,
       0,     3,     0,     5,     2,     0,     3,     3,     3,     7,
       7,    10,     1,     1,     1,     1,     1,    14,    17,     1,
       0,     1,     0,     1,     0,     2,     0,     1,     3,     5,
       5,     7,     2,     0,     1,     0,     1,     1,     0,     2,
       2,     0,     9,    12,     7,     2,     0,     3,     2,     1,
       3,     1,     3,     2,     1,     1,     2,     3,     2,     1,
       3,     3,     3,     2,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     4,     5,     1,     3,     3,     1,
       3,     3,     5,     6,     1,     3,     2,     1,     3,     1,
       2,     4,     5,     1,     1,     1,     1,     3,     3,     2,
       2,     1,     2,     1,     2,     2,     2,     1,     2,     2,
       2,     2,     1,     1,     1,     3,     3,     5,     2,     0,
       2,     1,     3,     5,     1,     2,     1,     0,     4,     6,
       4,     6,     4,     6,     3,     5,     5,     5,     1,     3,
       1,     3,     2,     2,     1,     2,     1,     2,    11,    10,
      10,     2,     2,     0,     9,     2,     0,    10,    11,    11,
       5,     5,     8,     3,     3,     6,     6,     1,     1,     1,
       1,     1,     1,     3,     1,     5,     5,     6,     6,     6,
       6,     6,     8,     8,     6,     6,     7,     9,     9,     8,
      10,     6,     6,     6,     6,     6,     6,     8,     6,     8,
       6,     8,     7,     9,     6,     8,     7,     9,     8,    10,
       9,    11,     8,    10,     9,    11,     8,     8,     7,     6,
       6,     6,     6,     8,     8,     8,     8,     6,     9,     1,
       0,     2,     0,     7,     9,     8,     7,     6,     6,     6,
       6,     6,     6,     6,     9,     9,     6,     8,     6,     8,
       8,     8,     8,     6,     8,     6,     8,     7,     9,     7,
       9,     6,     7,     1,     3,     3,     3,     1,     1,     1,
       1,     1,     6,     6,     6,     6,     6,     6,     7,     7,
       6,     9,     9,     6,     6,     6,     6,     8,     8,     8,
       6,     7,     6,     6,     6,     1,     0,     3,     3,     1,
       0,     5,     5,     6,     6,     6,     8,     9,     1,     3,
       1,     5,     6,     5,     6,     6,     7,     7,     8,     4,
       5,     4,     5,     4,     5,     6,     7,    13,     1,     1,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     0,     3,     2,     0,
       2,     2,     2,     2,     3,     1,     3,     1,     2,     2,
       1,     2,     2,     3,     2,     5,     4,     3,     3,     3,
       6,     6,     1,     1,     0,     3,     2,     2,     1,     2,
       1,     3,     2,     1,     0,     9,    11,    12,    14,     3,
       4,     4,     0,     2,     5,     1,     0,     1,     2,     3,
       3,     3,     1,     2,     1,     1,     1,     1,     1,     1,
       0,     5,     4,     6,     4,     3,     5,     4,     6,     5,
       4,     4,     6,     4,     6,     6,     5,     7,     9,     6,
       1,     0,     6,    11,    11,    11,    13,     9,    11,     1,
       1,    10,     4,     2,     5,     2,     0,     5,     6,     5,
       5,     7,     9,     1,     3,     1,     1,     1,     1,     1,
       3,     5,     5,     7,     1,     1,     2,     3,     3,     0,
       1,     0,     1,     0,     1,     0,     1,     3,     1,     1,
       3,     0,     3,     5,     6,     5,     1,     1,     3,     0,
       1,     0,     1,     1,     1,     3,     2,     1,     2,     2,
       2,     1,     2,     2,     2,     1,     2,     2,     2,     1,
       3,     3,     3,     4,     1,     2,     2,     2,     2,     3,
       3,     3,     1,     2,     2,     2,     1,     2,     1,     2,
       2,     2,     2,     1,     2,     2,     2,     1,     2,     2,
       1,     2,     2,     2,     1,     2,     2,     2,     1,     2,
       2,     2,     2,     2,     1,     2,     2,     2,     1,     2,
       2,     2,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     2,     1,     1,     1,
       3,     5,     7,     1,     3,     3,     3,     5,     3,     6,
       5,     3,     5,     2,     2,     3,     1,     0,     4,     5,
       1,     1,     3,     3,     1,     6,     5,     5,     6,     5,
       4,     6,     7,     5,     4,     8,    12,    10,    13,     1,
       4,     1,     3,     6,     7,     6,     7,     5,     2,     8,
      10,    11,     1,     3,     5,     3,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     2,     1,     1,     1,     1,     0,     5,     1,     7,
       7,     7,     3,     2,     0,     3,     2,     0,     1,     0,
       5,     4,     3,     0,     1,     1,     1,     1,     4,     9,
       3,     0,     7,     1,     3,     1,     4,     4,     7,     2,
       1,     1,     1,     3,     2,     8,     5,     0,     4,     3,
       0,     3,     0,     7,     2,     0,     5,     3,     0,     2,
       2,     2,     3,     1,     3,     1,     2,     1,     0,     1,
       2,     0,     6,     6,     1,     3,     1,     1,     8,     1,
       3,     3,     5,     2,     1,     3,     7,     1,     1,     0,
       3,     2,     2,     2,     0,     2,     2,     1,     1,     3,
       3,     1,     2,     4,     4,     2,     3,     5,     5,     1,
       1,     9,     9,     1,     2,     4,     4,     4,     2,     2,
       3,     1,     3,     7,     1,     2,     0,     1,     0,     2,
       1,     0,     3,     3,     4,     4,     4,     4,     3,     2,
       1,     1,     0,     1,     1,     0,     1,     5,     1,     0,
       1,     0,     3,     1,     3,     4,     3,     2,     2,     1,
       1,     1,     0,     2,     4,     5,     2,     3,     1,     1,
       1,     1,     3,     0,     1,     1,     1,     1,     1,     3,
       0,     1,     3,     1,     1,     1,     1,     1,     2,     4,
       4,     5,     2,     0,     1,     3,     1,     0,     1,     2,
       3,     2,     4,     2,     3,     2,     0,     4,     5,     2,
       0,     1,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     1,     4,     3,     4,     5,     4,     5,     4,     5,
       2,     4,     1,     1,     0,     1,     4,     5,     4,     0,
       2,     2,     2,     1,     1,     0,     4,     2,     2,     2,
       3,     5,     1,     0,     5,     3,     1,     3,     1,     2,
       3,     6,     4,     0,     2,     6,     2,     1,     3,     4,
       0,     2,     0,     2,     0,     2,     4,     0,     1,     0,
       1,     3,     3,     7,    12,     1,     3,     2,     3,     3,
       1,     2,     2,     2,     2,     1,     1,     3,     3,     2,
       2,     3,     5,     6,     2,     3,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     4,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       2,     2,     1,     2,     2,     2,     2,     1,     3,     0,
       1,     1,     1,     1,     5,     2,     1,     1,     1,     1,
       4,     1,     2,     2,     1,     3,     3,     2,     1,     0,
       5,     2,     5,     2,     1,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     0,     1,     4,     1,     3,     3,     5,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     3,     3,     2,     2,     3,
       5,     4,     6,     3,     5,     4,     6,     4,     6,     5,
       7,     3,     2,     4,     2,     3,     3,     4,     3,     4,
       3,     4,     5,     6,     6,     7,     6,     7,     6,     7,
       3,     4,     4,     6,     2,     3,     4,     1,     1,     3,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     5,     6,     6,
       7,     3,     4,     1,     1,     2,     4,     1,     1,     1,
       2,     2,     2,     2,     1,     1,     4,     3,     5,     6,
       8,     6,     6,     4,     4,     1,     1,     1,     5,     1,
       1,     4,     1,     4,     1,     4,     1,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     6,     4,
       4,     4,     4,     6,     5,     5,     5,     4,     6,     4,
       4,     4,     4,     5,     7,     7,     9,     5,     4,     6,
       5,     7,     7,     7,     2,     3,     3,     3,     4,     0,
       4,     1,     3,     3,     1,     1,     1,     2,     2,     0,
       2,     4,     4,     6,     5,     0,     5,     0,     2,     0,
       1,     3,     3,     2,     2,     0,     6,     1,     0,     3,
       0,     2,     2,     0,     1,     4,     2,     2,     2,     2,
       2,     4,     3,     5,     4,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     4,     1,     4,
       1,     2,     1,     2,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     2,     1,     3,     3,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       2,     3,     0,     3,     3,     2,     2,     1,     0,     2,
       2,     3,     2,     1,     1,     3,     5,     1,     2,     4,
       2,     0,     1,     0,     1,     2,     2,     2,     3,     5,
       1,     0,     1,     2,     0,     2,     1,     0,     1,     0,
       1,     3,     3,     2,     1,     1,     1,     3,     1,     2,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     2,     6,     2,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     4,     3,     2,     1,     1,     1,     1,     1,     0,
       8,     2,     5,     3,     2,     2,     3,     7,     1,     1,
       1,     0,     2,     2,     1,     0,     1,     3,     1,     2,
       0,     2,     0,     2,     0,     1,     3,     4,     3,     1,
       1,     1,     1,     2,     0,     2,     4,     0,     2,     2,
       2,     1,     1,     7,     3,     1,     1,     1,     1,     2,
       0,     1,     3,     3,     3,     3,     0,     4,     5,     5,
       0,     1,     1,     1,     2,     2,     1,     2,     0,     7,
       0,     5,     0,     4,     2,     2,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       2,     1,     3,     2,     2,     3,     0,     5,     1,     0,
       5,     2,     2,     1,     1,     1,     2,     2,     3,     1,
       2,     2,     3,     3,     4,     2,     1,     2,     1,     1,
       2,     2,     3,     1,     1,     1,     1,     0,     1,     3,
       5,     0,     2,     0,     1,     2,     3,     2,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     2,     2,     3,
       0,     1,     2,     1,     4,     3,     4,     3,     2,     1,
       3,     1,     1,     1,     1,     2,     2,     1,     2,     2,
       1,     1,     1,     4,     4,     4,     4,     4,     1,     0,
       3,     3,     4,     1,     3,     3,     4,     1,     3,     3,
       1,     1,     1,     6,     1,     3,     3,     6,     1,     3,
       3,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     4,     1,     1,     4,     4,     3,     0,     7,
       1,     0,     0,     7,     3,     4,     3,     1,     1,     1,
       2,     3,     5,     2,     5,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     0,     1,     2,     1,     2,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     1,     2,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     3,     2,     3,     1,     3,     3,     3,     3,     3,
       3,     1,     1,     4,     0,     2,     2,     1,     2,     1,
       0,     1,     1,     1,     0,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* stmt: AlterEventTrigStmt  */
#line 1673 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37471 "preproc.c"
    break;

  case 4: /* stmt: AlterCollationStmt  */
#line 1675 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37477 "preproc.c"
    break;

  case 5: /* stmt: AlterDatabaseStmt  */
#line 1677 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37483 "preproc.c"
    break;

  case 6: /* stmt: AlterDatabaseSetStmt  */
#line 1679 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37489 "preproc.c"
    break;

  case 7: /* stmt: AlterDefaultPrivilegesStmt  */
#line 1681 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37495 "preproc.c"
    break;

  case 8: /* stmt: AlterDomainStmt  */
#line 1683 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37501 "preproc.c"
    break;

  case 9: /* stmt: AlterEnumStmt  */
#line 1685 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37507 "preproc.c"
    break;

  case 10: /* stmt: AlterExtensionStmt  */
#line 1687 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37513 "preproc.c"
    break;

  case 11: /* stmt: AlterExtensionContentsStmt  */
#line 1689 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37519 "preproc.c"
    break;

  case 12: /* stmt: AlterFdwStmt  */
#line 1691 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37525 "preproc.c"
    break;

  case 13: /* stmt: AlterForeignServerStmt  */
#line 1693 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37531 "preproc.c"
    break;

  case 14: /* stmt: AlterForeignTableStmt  */
#line 1695 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37537 "preproc.c"
    break;

  case 15: /* stmt: AlterFunctionStmt  */
#line 1697 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37543 "preproc.c"
    break;

  case 16: /* stmt: AlterGroupStmt  */
#line 1699 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37549 "preproc.c"
    break;

  case 17: /* stmt: AlterNodeStmt  */
#line 1701 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37555 "preproc.c"
    break;

  case 18: /* stmt: AlterNodeGroupStmt  */
#line 1703 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37561 "preproc.c"
    break;

  case 19: /* stmt: AlterObjectDependsStmt  */
#line 1705 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37567 "preproc.c"
    break;

  case 20: /* stmt: AlterObjectSchemaStmt  */
#line 1707 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37573 "preproc.c"
    break;

  case 21: /* stmt: AlterOwnerStmt  */
#line 1709 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37579 "preproc.c"
    break;

  case 22: /* stmt: AlterOperatorStmt  */
#line 1711 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37585 "preproc.c"
    break;

  case 23: /* stmt: AlterPolicyStmt  */
#line 1713 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37591 "preproc.c"
    break;

  case 24: /* stmt: AlterSeqStmt  */
#line 1715 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37597 "preproc.c"
    break;

  case 25: /* stmt: AlterSystemStmt  */
#line 1717 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37603 "preproc.c"
    break;

  case 26: /* stmt: AlterTableStmt  */
#line 1719 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37609 "preproc.c"
    break;

  case 27: /* stmt: AlterTblSpcStmt  */
#line 1721 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37615 "preproc.c"
    break;

  case 28: /* stmt: AlterCompositeTypeStmt  */
#line 1723 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37621 "preproc.c"
    break;

  case 29: /* stmt: AlterPublicationStmt  */
#line 1725 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37627 "preproc.c"
    break;

  case 30: /* stmt: AlterRoleSetStmt  */
#line 1727 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37633 "preproc.c"
    break;

  case 31: /* stmt: AlterRoleStmt  */
#line 1729 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37639 "preproc.c"
    break;

  case 32: /* stmt: AlterSubscriptionStmt  */
#line 1731 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37645 "preproc.c"
    break;

  case 33: /* stmt: AlterTSConfigurationStmt  */
#line 1733 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37651 "preproc.c"
    break;

  case 34: /* stmt: AlterTSDictionaryStmt  */
#line 1735 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37657 "preproc.c"
    break;

  case 35: /* stmt: AlterUserMappingStmt  */
#line 1737 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37663 "preproc.c"
    break;

  case 36: /* stmt: AnalyzeStmt  */
#line 1739 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37669 "preproc.c"
    break;

  case 37: /* stmt: AuditStmt  */
#line 1741 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37675 "preproc.c"
    break;

  case 38: /* stmt: BarrierStmt  */
#line 1743 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37681 "preproc.c"
    break;

  case 39: /* stmt: CheckOverLapStmt  */
#line 1745 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37687 "preproc.c"
    break;

  case 40: /* stmt: CheckPointStmt  */
#line 1747 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37693 "preproc.c"
    break;

  case 41: /* stmt: CleanAuditStmt  */
#line 1749 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37699 "preproc.c"
    break;

  case 42: /* stmt: CleanConnStmt  */
#line 1751 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37705 "preproc.c"
    break;

  case 43: /* stmt: CleanShardingStmt  */
#line 1753 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37711 "preproc.c"
    break;

  case 44: /* stmt: ClosePortalStmt  */
#line 1755 "preproc.y"
        {
		if (INFORMIX_MODE)
		{
			if (pg_strcasecmp((yyvsp[0].str)+strlen("close "), "database") == 0)
			{
				if (connection)
					mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CLOSE DATABASE statement");

				fprintf(base_yyout, "{ ECPGdisconnect(__LINE__, \"CURRENT\");");
				whenever_action(2);
				free((yyvsp[0].str));
				break;
			}
		}

		output_statement((yyvsp[0].str), 0, ECPGst_normal);
	}
#line 37733 "preproc.c"
    break;

  case 45: /* stmt: ClusterStmt  */
#line 1773 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37739 "preproc.c"
    break;

  case 46: /* stmt: CommentStmt  */
#line 1775 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37745 "preproc.c"
    break;

  case 47: /* stmt: ConstraintsSetStmt  */
#line 1777 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37751 "preproc.c"
    break;

  case 48: /* stmt: CopyStmt  */
#line 1779 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37757 "preproc.c"
    break;

  case 49: /* stmt: CreateAmStmt  */
#line 1781 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37763 "preproc.c"
    break;

  case 50: /* stmt: CreateAsStmt  */
#line 1783 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37769 "preproc.c"
    break;

  case 51: /* stmt: CreateAssertStmt  */
#line 1785 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37775 "preproc.c"
    break;

  case 52: /* stmt: CreateCastStmt  */
#line 1787 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37781 "preproc.c"
    break;

  case 53: /* stmt: CreateConversionStmt  */
#line 1789 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37787 "preproc.c"
    break;

  case 54: /* stmt: CreateDomainStmt  */
#line 1791 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37793 "preproc.c"
    break;

  case 55: /* stmt: CreateExtensionStmt  */
#line 1793 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37799 "preproc.c"
    break;

  case 56: /* stmt: CreateFdwStmt  */
#line 1795 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37805 "preproc.c"
    break;

  case 57: /* stmt: CreateForeignServerStmt  */
#line 1797 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37811 "preproc.c"
    break;

  case 58: /* stmt: CreateForeignTableStmt  */
#line 1799 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37817 "preproc.c"
    break;

  case 59: /* stmt: CreateFunctionStmt  */
#line 1801 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37823 "preproc.c"
    break;

  case 60: /* stmt: CreateGroupStmt  */
#line 1803 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37829 "preproc.c"
    break;

  case 61: /* stmt: CreateKeyValuesStmt  */
#line 1805 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37835 "preproc.c"
    break;

  case 62: /* stmt: CreateMatViewStmt  */
#line 1807 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37841 "preproc.c"
    break;

  case 63: /* stmt: CreateNodeGroupStmt  */
#line 1809 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37847 "preproc.c"
    break;

  case 64: /* stmt: CreateNodeStmt  */
#line 1811 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37853 "preproc.c"
    break;

  case 65: /* stmt: CreateOpClassStmt  */
#line 1813 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37859 "preproc.c"
    break;

  case 66: /* stmt: CreateOpFamilyStmt  */
#line 1815 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37865 "preproc.c"
    break;

  case 67: /* stmt: CreatePublicationStmt  */
#line 1817 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37871 "preproc.c"
    break;

  case 68: /* stmt: AlterOpFamilyStmt  */
#line 1819 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37877 "preproc.c"
    break;

  case 69: /* stmt: CreatePolicyStmt  */
#line 1821 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37883 "preproc.c"
    break;

  case 70: /* stmt: CreatePLangStmt  */
#line 1823 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37889 "preproc.c"
    break;

  case 71: /* stmt: CreateSchemaStmt  */
#line 1825 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37895 "preproc.c"
    break;

  case 72: /* stmt: CreateSeqStmt  */
#line 1827 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37901 "preproc.c"
    break;

  case 73: /* stmt: CreateShardStmt  */
#line 1829 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37907 "preproc.c"
    break;

  case 74: /* stmt: CreateStmt  */
#line 1831 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37913 "preproc.c"
    break;

  case 75: /* stmt: CreateSubscriptionStmt  */
#line 1833 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37919 "preproc.c"
    break;

  case 76: /* stmt: CreateStatsStmt  */
#line 1835 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37925 "preproc.c"
    break;

  case 77: /* stmt: CreateTableSpaceStmt  */
#line 1837 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37931 "preproc.c"
    break;

  case 78: /* stmt: CreateTransformStmt  */
#line 1839 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37937 "preproc.c"
    break;

  case 79: /* stmt: CreateTrigStmt  */
#line 1841 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37943 "preproc.c"
    break;

  case 80: /* stmt: CreateEventTrigStmt  */
#line 1843 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37949 "preproc.c"
    break;

  case 81: /* stmt: CreateRoleStmt  */
#line 1845 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37955 "preproc.c"
    break;

  case 82: /* stmt: CreateUserStmt  */
#line 1847 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37961 "preproc.c"
    break;

  case 83: /* stmt: CreateUserMappingStmt  */
#line 1849 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37967 "preproc.c"
    break;

  case 84: /* stmt: CreatedbStmt  */
#line 1851 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37973 "preproc.c"
    break;

  case 85: /* stmt: DeallocateStmt  */
#line 1853 "preproc.y"
        {
		output_deallocate_prepare_statement((yyvsp[0].str));
	}
#line 37981 "preproc.c"
    break;

  case 86: /* stmt: DeclareCursorStmt  */
#line 1857 "preproc.y"
        { output_simple_statement((yyvsp[0].str)); }
#line 37987 "preproc.c"
    break;

  case 87: /* stmt: DefineStmt  */
#line 1859 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 37993 "preproc.c"
    break;

  case 88: /* stmt: DeleteStmt  */
#line 1861 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 37999 "preproc.c"
    break;

  case 89: /* stmt: DiscardStmt  */
#line 1863 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_normal); }
#line 38005 "preproc.c"
    break;

  case 90: /* stmt: DoStmt  */
#line 1865 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38011 "preproc.c"
    break;

  case 91: /* stmt: DropAssertStmt  */
#line 1867 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38017 "preproc.c"
    break;

  case 92: /* stmt: DropCastStmt  */
#line 1869 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38023 "preproc.c"
    break;

  case 93: /* stmt: DropNodeGroupStmt  */
#line 1871 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38029 "preproc.c"
    break;

  case 94: /* stmt: DropNodeStmt  */
#line 1873 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38035 "preproc.c"
    break;

  case 95: /* stmt: DropOpClassStmt  */
#line 1875 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38041 "preproc.c"
    break;

  case 96: /* stmt: DropOpFamilyStmt  */
#line 1877 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38047 "preproc.c"
    break;

  case 97: /* stmt: DropOwnedStmt  */
#line 1879 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38053 "preproc.c"
    break;

  case 98: /* stmt: DropPLangStmt  */
#line 1881 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38059 "preproc.c"
    break;

  case 99: /* stmt: DropShardStmt  */
#line 1883 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38065 "preproc.c"
    break;

  case 100: /* stmt: DropStmt  */
#line 1885 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38071 "preproc.c"
    break;

  case 101: /* stmt: DropSubscriptionStmt  */
#line 1887 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38077 "preproc.c"
    break;

  case 102: /* stmt: DropTableSpaceStmt  */
#line 1889 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38083 "preproc.c"
    break;

  case 103: /* stmt: DropTransformStmt  */
#line 1891 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38089 "preproc.c"
    break;

  case 104: /* stmt: DropRoleStmt  */
#line 1893 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38095 "preproc.c"
    break;

  case 105: /* stmt: DropUserMappingStmt  */
#line 1895 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38101 "preproc.c"
    break;

  case 106: /* stmt: DropdbStmt  */
#line 1897 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38107 "preproc.c"
    break;

  case 107: /* stmt: ExecuteStmt  */
#line 1899 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_execute); }
#line 38113 "preproc.c"
    break;

  case 108: /* stmt: ExecDirectStmt  */
#line 1901 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38119 "preproc.c"
    break;

  case 109: /* stmt: ExplainStmt  */
#line 1903 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38125 "preproc.c"
    break;

  case 110: /* stmt: FetchStmt  */
#line 1905 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_normal); }
#line 38131 "preproc.c"
    break;

  case 111: /* stmt: GrantStmt  */
#line 1907 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38137 "preproc.c"
    break;

  case 112: /* stmt: GrantRoleStmt  */
#line 1909 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38143 "preproc.c"
    break;

  case 113: /* stmt: ImportForeignSchemaStmt  */
#line 1911 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38149 "preproc.c"
    break;

  case 114: /* stmt: IndexStmt  */
#line 1913 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38155 "preproc.c"
    break;

  case 115: /* stmt: InsertStmt  */
#line 1915 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 38161 "preproc.c"
    break;

  case 116: /* stmt: ListenStmt  */
#line 1917 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38167 "preproc.c"
    break;

  case 117: /* stmt: RefreshMatViewStmt  */
#line 1919 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38173 "preproc.c"
    break;

  case 118: /* stmt: LoadStmt  */
#line 1921 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38179 "preproc.c"
    break;

  case 119: /* stmt: LockStmt  */
#line 1923 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38185 "preproc.c"
    break;

  case 120: /* stmt: LockNodeStmt  */
#line 1925 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38191 "preproc.c"
    break;

  case 121: /* stmt: MoveDataStmt  */
#line 1927 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38197 "preproc.c"
    break;

  case 122: /* stmt: NotifyStmt  */
#line 1929 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38203 "preproc.c"
    break;

  case 123: /* stmt: PauseStmt  */
#line 1931 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38209 "preproc.c"
    break;

  case 124: /* stmt: PrepareStmt  */
#line 1933 "preproc.y"
        {
		if ((yyvsp[0].prep).type == NULL || strlen((yyvsp[0].prep).type) == 0)
			output_prepare_statement((yyvsp[0].prep).name, (yyvsp[0].prep).stmt);
		else
			output_statement(cat_str(5, mm_strdup("prepare"), (yyvsp[0].prep).name, (yyvsp[0].prep).type, mm_strdup("as"), (yyvsp[0].prep).stmt), 0, ECPGst_normal);
	}
#line 38220 "preproc.c"
    break;

  case 125: /* stmt: ReassignOwnedStmt  */
#line 1940 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38226 "preproc.c"
    break;

  case 126: /* stmt: ReindexStmt  */
#line 1942 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38232 "preproc.c"
    break;

  case 127: /* stmt: RemoveAggrStmt  */
#line 1944 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38238 "preproc.c"
    break;

  case 128: /* stmt: RemoveFuncStmt  */
#line 1946 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38244 "preproc.c"
    break;

  case 129: /* stmt: RemoveOperStmt  */
#line 1948 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38250 "preproc.c"
    break;

  case 130: /* stmt: RenameStmt  */
#line 1950 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38256 "preproc.c"
    break;

  case 131: /* stmt: RevokeStmt  */
#line 1952 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38262 "preproc.c"
    break;

  case 132: /* stmt: RevokeRoleStmt  */
#line 1954 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38268 "preproc.c"
    break;

  case 133: /* stmt: RuleStmt  */
#line 1956 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38274 "preproc.c"
    break;

  case 134: /* stmt: SampleStmt  */
#line 1958 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38280 "preproc.c"
    break;

  case 135: /* stmt: SecLabelStmt  */
#line 1960 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38286 "preproc.c"
    break;

  case 136: /* stmt: SelectStmt  */
#line 1962 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 38292 "preproc.c"
    break;

  case 137: /* stmt: TransactionStmt  */
#line 1964 "preproc.y"
        {
		fprintf(base_yyout, "{ ECPGtrans(__LINE__, %s, \"%s\");", connection ? connection : "NULL", (yyvsp[0].str));
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 38302 "preproc.c"
    break;

  case 138: /* stmt: TruncateStmt  */
#line 1970 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38308 "preproc.c"
    break;

  case 139: /* stmt: UnlistenStmt  */
#line 1972 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38314 "preproc.c"
    break;

  case 140: /* stmt: UpdateStmt  */
#line 1974 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 38320 "preproc.c"
    break;

  case 141: /* stmt: VacuumStmt  */
#line 1976 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38326 "preproc.c"
    break;

  case 142: /* stmt: VariableResetStmt  */
#line 1978 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38332 "preproc.c"
    break;

  case 143: /* stmt: VariableSetStmt  */
#line 1980 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38338 "preproc.c"
    break;

  case 144: /* stmt: VariableShowStmt  */
#line 1982 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38344 "preproc.c"
    break;

  case 145: /* stmt: ViewStmt  */
#line 1984 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 38350 "preproc.c"
    break;

  case 146: /* stmt: ECPGAllocateDescr  */
#line 1986 "preproc.y"
        {
		fprintf(base_yyout,"ECPGallocate_desc(__LINE__, %s);",(yyvsp[0].str));
		whenever_action(0);
		free((yyvsp[0].str));
	}
#line 38360 "preproc.c"
    break;

  case 147: /* stmt: ECPGConnect  */
#line 1992 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CONNECT statement");

		fprintf(base_yyout, "{ ECPGconnect(__LINE__, %d, %s, %d); ", compat, (yyvsp[0].str), autocommit);
		reset_variables();
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 38374 "preproc.c"
    break;

  case 148: /* stmt: ECPGCursorStmt  */
#line 2002 "preproc.y"
        {
		output_simple_statement((yyvsp[0].str));
	}
#line 38382 "preproc.c"
    break;

  case 149: /* stmt: ECPGDeallocateDescr  */
#line 2006 "preproc.y"
        {
		fprintf(base_yyout,"ECPGdeallocate_desc(__LINE__, %s);",(yyvsp[0].str));
		whenever_action(0);
		free((yyvsp[0].str));
	}
#line 38392 "preproc.c"
    break;

  case 150: /* stmt: ECPGDeclare  */
#line 2012 "preproc.y"
        {
		output_simple_statement((yyvsp[0].str));
	}
#line 38400 "preproc.c"
    break;

  case 151: /* stmt: ECPGDescribe  */
#line 2016 "preproc.y"
        {
		fprintf(base_yyout, "{ ECPGdescribe(__LINE__, %d, %s,", compat, (yyvsp[0].str));
		dump_variables(argsresult, 1);
		fputs("ECPGt_EORT);", base_yyout);
		fprintf(base_yyout, "}");
		output_line_number();

		free((yyvsp[0].str));
	}
#line 38414 "preproc.c"
    break;

  case 152: /* stmt: ECPGDisconnect  */
#line 2026 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in DISCONNECT statement");

		fprintf(base_yyout, "{ ECPGdisconnect(__LINE__, %s);",
				(yyvsp[0].str) ? (yyvsp[0].str) : "\"CURRENT\"");
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 38428 "preproc.c"
    break;

  case 153: /* stmt: ECPGExecuteImmediateStmt  */
#line 2035 "preproc.y"
                                        { output_statement((yyvsp[0].str), 0, ECPGst_exec_immediate); }
#line 38434 "preproc.c"
    break;

  case 154: /* stmt: ECPGFree  */
#line 2037 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";

		if (strcmp((yyvsp[0].str), "all") == 0)
			fprintf(base_yyout, "{ ECPGdeallocate_all(__LINE__, %d, %s);", compat, con);
		else if ((yyvsp[0].str)[0] == ':')
			fprintf(base_yyout, "{ ECPGdeallocate(__LINE__, %d, %s, %s);", compat, con, (yyvsp[0].str)+1);
		else
			fprintf(base_yyout, "{ ECPGdeallocate(__LINE__, %d, %s, \"%s\");", compat, con, (yyvsp[0].str));

		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 38452 "preproc.c"
    break;

  case 155: /* stmt: ECPGGetDescriptor  */
#line 2051 "preproc.y"
        {
		lookup_descriptor((yyvsp[0].descriptor).name, connection);
		output_get_descr((yyvsp[0].descriptor).name, (yyvsp[0].descriptor).str);
		free((yyvsp[0].descriptor).name);
		free((yyvsp[0].descriptor).str);
	}
#line 38463 "preproc.c"
    break;

  case 156: /* stmt: ECPGGetDescriptorHeader  */
#line 2058 "preproc.y"
        {
		lookup_descriptor((yyvsp[0].str), connection);
		output_get_descr_header((yyvsp[0].str));
		free((yyvsp[0].str));
	}
#line 38473 "preproc.c"
    break;

  case 157: /* stmt: ECPGOpen  */
#line 2064 "preproc.y"
        {
		struct cursor *ptr;

		if ((ptr = add_additional_variables((yyvsp[0].str), true)) != NULL)
		{
			connection = ptr->connection ? mm_strdup(ptr->connection) : NULL;
			output_statement(mm_strdup(ptr->command), 0, ECPGst_normal);
			ptr->opened = true;
		}
	}
#line 38488 "preproc.c"
    break;

  case 158: /* stmt: ECPGSetAutocommit  */
#line 2075 "preproc.y"
        {
		fprintf(base_yyout, "{ ECPGsetcommit(__LINE__, \"%s\", %s);", (yyvsp[0].str), connection ? connection : "NULL");
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 38498 "preproc.c"
    break;

  case 159: /* stmt: ECPGSetConnection  */
#line 2081 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in SET CONNECTION statement");

		fprintf(base_yyout, "{ ECPGsetconn(__LINE__, %s);", (yyvsp[0].str));
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 38511 "preproc.c"
    break;

  case 160: /* stmt: ECPGSetDescriptor  */
#line 2090 "preproc.y"
        {
		lookup_descriptor((yyvsp[0].descriptor).name, connection);
		output_set_descr((yyvsp[0].descriptor).name, (yyvsp[0].descriptor).str);
		free((yyvsp[0].descriptor).name);
		free((yyvsp[0].descriptor).str);
	}
#line 38522 "preproc.c"
    break;

  case 161: /* stmt: ECPGSetDescriptorHeader  */
#line 2097 "preproc.y"
        {
		lookup_descriptor((yyvsp[0].str), connection);
		output_set_descr_header((yyvsp[0].str));
		free((yyvsp[0].str));
	}
#line 38532 "preproc.c"
    break;

  case 162: /* stmt: ECPGTypedef  */
#line 2103 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in TYPE statement");

		fprintf(base_yyout, "%s", (yyvsp[0].str));
		free((yyvsp[0].str));
		output_line_number();
	}
#line 38545 "preproc.c"
    break;

  case 163: /* stmt: ECPGVar  */
#line 2112 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in VAR statement");

		output_simple_statement((yyvsp[0].str));
	}
#line 38556 "preproc.c"
    break;

  case 164: /* stmt: ECPGWhenever  */
#line 2119 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in WHENEVER statement");

		output_simple_statement((yyvsp[0].str));
	}
#line 38567 "preproc.c"
    break;

  case 165: /* stmt: %empty  */
#line 2126 "preproc.y"
 { (yyval.str) = NULL; }
#line 38573 "preproc.c"
    break;

  case 166: /* CreateRoleStmt: CREATE ROLE RoleId opt_with OptRoleList  */
#line 2132 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38581 "preproc.c"
    break;

  case 167: /* opt_with: WITH  */
#line 2140 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with");
}
#line 38589 "preproc.c"
    break;

  case 168: /* opt_with: WITH_LA  */
#line 2144 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with");
}
#line 38597 "preproc.c"
    break;

  case 169: /* opt_with: %empty  */
#line 2148 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38604 "preproc.c"
    break;

  case 170: /* OptRoleList: OptRoleList CreateOptRoleElem  */
#line 2155 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38612 "preproc.c"
    break;

  case 171: /* OptRoleList: %empty  */
#line 2159 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38619 "preproc.c"
    break;

  case 172: /* AlterOptRoleList: AlterOptRoleList AlterOptRoleElem  */
#line 2166 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38627 "preproc.c"
    break;

  case 173: /* AlterOptRoleList: %empty  */
#line 2170 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38634 "preproc.c"
    break;

  case 174: /* AlterOptRoleElem: PASSWORD ecpg_sconst  */
#line 2177 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("password"),(yyvsp[0].str));
}
#line 38642 "preproc.c"
    break;

  case 175: /* AlterOptRoleElem: PASSWORD NULL_P  */
#line 2181 "preproc.y"
 { 
 (yyval.str) = mm_strdup("password null");
}
#line 38650 "preproc.c"
    break;

  case 176: /* AlterOptRoleElem: ENCRYPTED PASSWORD ecpg_sconst  */
#line 2185 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("encrypted password"),(yyvsp[0].str));
}
#line 38658 "preproc.c"
    break;

  case 177: /* AlterOptRoleElem: UNENCRYPTED PASSWORD ecpg_sconst  */
#line 2189 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("unencrypted password"),(yyvsp[0].str));
}
#line 38667 "preproc.c"
    break;

  case 178: /* AlterOptRoleElem: INHERIT  */
#line 2194 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inherit");
}
#line 38675 "preproc.c"
    break;

  case 179: /* AlterOptRoleElem: CONNECTION LIMIT SignedIconst  */
#line 2198 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("connection limit"),(yyvsp[0].str));
}
#line 38683 "preproc.c"
    break;

  case 180: /* AlterOptRoleElem: VALID UNTIL ecpg_sconst  */
#line 2202 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("valid until"),(yyvsp[0].str));
}
#line 38691 "preproc.c"
    break;

  case 181: /* AlterOptRoleElem: USER role_list  */
#line 2206 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("user"),(yyvsp[0].str));
}
#line 38699 "preproc.c"
    break;

  case 182: /* AlterOptRoleElem: ecpg_ident  */
#line 2210 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38707 "preproc.c"
    break;

  case 183: /* CreateOptRoleElem: AlterOptRoleElem  */
#line 2218 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38715 "preproc.c"
    break;

  case 184: /* CreateOptRoleElem: SYSID Iconst  */
#line 2222 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("sysid"),(yyvsp[0].str));
}
#line 38723 "preproc.c"
    break;

  case 185: /* CreateOptRoleElem: ADMIN role_list  */
#line 2226 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("admin"),(yyvsp[0].str));
}
#line 38731 "preproc.c"
    break;

  case 186: /* CreateOptRoleElem: ROLE role_list  */
#line 2230 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("role"),(yyvsp[0].str));
}
#line 38739 "preproc.c"
    break;

  case 187: /* CreateOptRoleElem: IN_P ROLE role_list  */
#line 2234 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("in role"),(yyvsp[0].str));
}
#line 38747 "preproc.c"
    break;

  case 188: /* CreateOptRoleElem: IN_P GROUP_P role_list  */
#line 2238 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("in group"),(yyvsp[0].str));
}
#line 38755 "preproc.c"
    break;

  case 189: /* CreateUserStmt: CREATE USER RoleId opt_with OptRoleList  */
#line 2246 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38763 "preproc.c"
    break;

  case 190: /* AlterRoleStmt: ALTER ROLE RoleSpec opt_with AlterOptRoleList  */
#line 2254 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38771 "preproc.c"
    break;

  case 191: /* AlterRoleStmt: ALTER USER RoleSpec opt_with AlterOptRoleList  */
#line 2258 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38779 "preproc.c"
    break;

  case 192: /* opt_in_database: %empty  */
#line 2266 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38786 "preproc.c"
    break;

  case 193: /* opt_in_database: IN_P DATABASE database_name  */
#line 2269 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("in database"),(yyvsp[0].str));
}
#line 38794 "preproc.c"
    break;

  case 194: /* AlterRoleSetStmt: ALTER ROLE RoleSpec opt_in_database SetResetClause  */
#line 2277 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38802 "preproc.c"
    break;

  case 195: /* AlterRoleSetStmt: ALTER ROLE ALL opt_in_database SetResetClause  */
#line 2281 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter role all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38810 "preproc.c"
    break;

  case 196: /* AlterRoleSetStmt: ALTER USER RoleSpec opt_in_database SetResetClause  */
#line 2285 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38818 "preproc.c"
    break;

  case 197: /* AlterRoleSetStmt: ALTER USER ALL opt_in_database SetResetClause  */
#line 2289 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter user all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38826 "preproc.c"
    break;

  case 198: /* DropRoleStmt: DROP ROLE role_list  */
#line 2297 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop role"),(yyvsp[0].str));
}
#line 38834 "preproc.c"
    break;

  case 199: /* DropRoleStmt: DROP ROLE IF_P EXISTS role_list  */
#line 2301 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop role if exists"),(yyvsp[0].str));
}
#line 38842 "preproc.c"
    break;

  case 200: /* DropRoleStmt: DROP USER role_list  */
#line 2305 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop user"),(yyvsp[0].str));
}
#line 38850 "preproc.c"
    break;

  case 201: /* DropRoleStmt: DROP USER IF_P EXISTS role_list  */
#line 2309 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop user if exists"),(yyvsp[0].str));
}
#line 38858 "preproc.c"
    break;

  case 202: /* DropRoleStmt: DROP GROUP_P role_list  */
#line 2313 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop group"),(yyvsp[0].str));
}
#line 38866 "preproc.c"
    break;

  case 203: /* DropRoleStmt: DROP GROUP_P IF_P EXISTS role_list  */
#line 2317 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop group if exists"),(yyvsp[0].str));
}
#line 38874 "preproc.c"
    break;

  case 204: /* CreateGroupStmt: CREATE GROUP_P RoleId opt_with OptRoleList  */
#line 2325 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create group"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38882 "preproc.c"
    break;

  case 205: /* AlterGroupStmt: ALTER GROUP_P RoleSpec add_drop USER role_list  */
#line 2333 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter group"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("user"),(yyvsp[0].str));
}
#line 38890 "preproc.c"
    break;

  case 206: /* add_drop: ADD_P  */
#line 2341 "preproc.y"
 { 
 (yyval.str) = mm_strdup("add");
}
#line 38898 "preproc.c"
    break;

  case 207: /* add_drop: DROP  */
#line 2345 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop");
}
#line 38906 "preproc.c"
    break;

  case 208: /* CreateSchemaStmt: CREATE SCHEMA OptSchemaName AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 2353 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create schema"),(yyvsp[-3].str),mm_strdup("authorization"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38914 "preproc.c"
    break;

  case 209: /* CreateSchemaStmt: CREATE SCHEMA ColId OptSchemaEltList  */
#line 2357 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create schema"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38922 "preproc.c"
    break;

  case 210: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS OptSchemaName AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 2361 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(5,mm_strdup("create schema if not exists"),(yyvsp[-3].str),mm_strdup("authorization"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38931 "preproc.c"
    break;

  case 211: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS ColId OptSchemaEltList  */
#line 2366 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,mm_strdup("create schema if not exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38940 "preproc.c"
    break;

  case 212: /* OptSchemaName: ColId  */
#line 2375 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38948 "preproc.c"
    break;

  case 213: /* OptSchemaName: %empty  */
#line 2379 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38955 "preproc.c"
    break;

  case 214: /* OptSchemaEltList: OptSchemaEltList schema_stmt  */
#line 2386 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38963 "preproc.c"
    break;

  case 215: /* OptSchemaEltList: %empty  */
#line 2390 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38970 "preproc.c"
    break;

  case 216: /* schema_stmt: CreateStmt  */
#line 2397 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38978 "preproc.c"
    break;

  case 217: /* schema_stmt: IndexStmt  */
#line 2401 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38986 "preproc.c"
    break;

  case 218: /* schema_stmt: CreateSeqStmt  */
#line 2405 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38994 "preproc.c"
    break;

  case 219: /* schema_stmt: CreateTrigStmt  */
#line 2409 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39002 "preproc.c"
    break;

  case 220: /* schema_stmt: GrantStmt  */
#line 2413 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39010 "preproc.c"
    break;

  case 221: /* schema_stmt: ViewStmt  */
#line 2417 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39018 "preproc.c"
    break;

  case 222: /* VariableSetStmt: SET set_rest  */
#line 2425 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 39026 "preproc.c"
    break;

  case 223: /* VariableSetStmt: SET LOCAL set_rest  */
#line 2429 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set local"),(yyvsp[0].str));
}
#line 39034 "preproc.c"
    break;

  case 224: /* VariableSetStmt: SET SESSION set_rest  */
#line 2433 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set session"),(yyvsp[0].str));
}
#line 39042 "preproc.c"
    break;

  case 225: /* set_rest: TRANSACTION transaction_mode_list  */
#line 2441 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("transaction"),(yyvsp[0].str));
}
#line 39050 "preproc.c"
    break;

  case 226: /* set_rest: SESSION CHARACTERISTICS AS TRANSACTION transaction_mode_list  */
#line 2445 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("session characteristics as transaction"),(yyvsp[0].str));
}
#line 39058 "preproc.c"
    break;

  case 227: /* set_rest: set_rest_more  */
#line 2449 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39066 "preproc.c"
    break;

  case 228: /* generic_set: var_name TO var_list  */
#line 2457 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 39074 "preproc.c"
    break;

  case 229: /* generic_set: var_name '=' var_list  */
#line 2461 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 39082 "preproc.c"
    break;

  case 230: /* generic_set: var_name TO DEFAULT  */
#line 2465 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("to default"));
}
#line 39090 "preproc.c"
    break;

  case 232: /* set_rest_more: generic_set  */
#line 2470 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39098 "preproc.c"
    break;

  case 233: /* set_rest_more: var_name FROM CURRENT_P  */
#line 2474 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("from current"));
}
#line 39106 "preproc.c"
    break;

  case 234: /* set_rest_more: TIME ZONE zone_value  */
#line 2478 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("time zone"),(yyvsp[0].str));
}
#line 39114 "preproc.c"
    break;

  case 235: /* set_rest_more: CATALOG_P ecpg_sconst  */
#line 2482 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("catalog"),(yyvsp[0].str));
}
#line 39123 "preproc.c"
    break;

  case 236: /* set_rest_more: SCHEMA ecpg_sconst  */
#line 2487 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 39131 "preproc.c"
    break;

  case 237: /* set_rest_more: NAMES opt_encoding  */
#line 2491 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("names"),(yyvsp[0].str));
}
#line 39139 "preproc.c"
    break;

  case 238: /* set_rest_more: ROLE NonReservedWord_or_Sconst  */
#line 2495 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("role"),(yyvsp[0].str));
}
#line 39147 "preproc.c"
    break;

  case 239: /* set_rest_more: SESSION AUTHORIZATION NonReservedWord_or_Sconst  */
#line 2499 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("session authorization"),(yyvsp[0].str));
}
#line 39155 "preproc.c"
    break;

  case 240: /* set_rest_more: SESSION AUTHORIZATION DEFAULT  */
#line 2503 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session authorization default");
}
#line 39163 "preproc.c"
    break;

  case 241: /* set_rest_more: XML_P OPTION document_or_content  */
#line 2507 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("xml option"),(yyvsp[0].str));
}
#line 39171 "preproc.c"
    break;

  case 242: /* set_rest_more: TRANSACTION SNAPSHOT ecpg_sconst  */
#line 2511 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("transaction snapshot"),(yyvsp[0].str));
}
#line 39179 "preproc.c"
    break;

  case 243: /* var_name: ECPGColId  */
#line 2519 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39187 "preproc.c"
    break;

  case 244: /* var_name: var_name '.' ColId  */
#line 2523 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 39195 "preproc.c"
    break;

  case 245: /* var_list: var_value  */
#line 2531 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39203 "preproc.c"
    break;

  case 246: /* var_list: var_list ',' var_value  */
#line 2535 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39211 "preproc.c"
    break;

  case 247: /* var_value: opt_boolean_or_string  */
#line 2543 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39219 "preproc.c"
    break;

  case 248: /* var_value: NumericOnly  */
#line 2547 "preproc.y"
 { 
		if ((yyvsp[0].str)[0] == '$')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = (yyvsp[0].str);
}
#line 39233 "preproc.c"
    break;

  case 249: /* iso_level: READ UNCOMMITTED  */
#line 2561 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read uncommitted");
}
#line 39241 "preproc.c"
    break;

  case 250: /* iso_level: READ COMMITTED  */
#line 2565 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read committed");
}
#line 39249 "preproc.c"
    break;

  case 251: /* iso_level: REPEATABLE READ  */
#line 2569 "preproc.y"
 { 
 (yyval.str) = mm_strdup("repeatable read");
}
#line 39257 "preproc.c"
    break;

  case 252: /* iso_level: SERIALIZABLE  */
#line 2573 "preproc.y"
 { 
 (yyval.str) = mm_strdup("serializable");
}
#line 39265 "preproc.c"
    break;

  case 253: /* opt_boolean_or_string: TRUE_P  */
#line 2581 "preproc.y"
 { 
 (yyval.str) = mm_strdup("true");
}
#line 39273 "preproc.c"
    break;

  case 254: /* opt_boolean_or_string: FALSE_P  */
#line 2585 "preproc.y"
 { 
 (yyval.str) = mm_strdup("false");
}
#line 39281 "preproc.c"
    break;

  case 255: /* opt_boolean_or_string: ON  */
#line 2589 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on");
}
#line 39289 "preproc.c"
    break;

  case 256: /* opt_boolean_or_string: NonReservedWord_or_Sconst  */
#line 2593 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39297 "preproc.c"
    break;

  case 257: /* zone_value: ecpg_sconst  */
#line 2601 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39305 "preproc.c"
    break;

  case 258: /* zone_value: ecpg_ident  */
#line 2605 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39313 "preproc.c"
    break;

  case 259: /* zone_value: ConstInterval ecpg_sconst opt_interval  */
#line 2609 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39321 "preproc.c"
    break;

  case 260: /* zone_value: ConstInterval '(' Iconst ')' ecpg_sconst  */
#line 2613 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 39329 "preproc.c"
    break;

  case 261: /* zone_value: NumericOnly  */
#line 2617 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39337 "preproc.c"
    break;

  case 262: /* zone_value: DEFAULT  */
#line 2621 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 39345 "preproc.c"
    break;

  case 263: /* zone_value: LOCAL  */
#line 2625 "preproc.y"
 { 
 (yyval.str) = mm_strdup("local");
}
#line 39353 "preproc.c"
    break;

  case 264: /* opt_encoding: ecpg_sconst  */
#line 2633 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39361 "preproc.c"
    break;

  case 265: /* opt_encoding: DEFAULT  */
#line 2637 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 39369 "preproc.c"
    break;

  case 266: /* opt_encoding: %empty  */
#line 2641 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39376 "preproc.c"
    break;

  case 267: /* NonReservedWord_or_Sconst: NonReservedWord  */
#line 2648 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39384 "preproc.c"
    break;

  case 268: /* NonReservedWord_or_Sconst: ecpg_sconst  */
#line 2652 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39392 "preproc.c"
    break;

  case 269: /* VariableResetStmt: RESET reset_rest  */
#line 2660 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("reset"),(yyvsp[0].str));
}
#line 39400 "preproc.c"
    break;

  case 270: /* reset_rest: generic_reset  */
#line 2668 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39408 "preproc.c"
    break;

  case 271: /* reset_rest: TIME ZONE  */
#line 2672 "preproc.y"
 { 
 (yyval.str) = mm_strdup("time zone");
}
#line 39416 "preproc.c"
    break;

  case 272: /* reset_rest: TRANSACTION ISOLATION LEVEL  */
#line 2676 "preproc.y"
 { 
 (yyval.str) = mm_strdup("transaction isolation level");
}
#line 39424 "preproc.c"
    break;

  case 273: /* reset_rest: SESSION AUTHORIZATION  */
#line 2680 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session authorization");
}
#line 39432 "preproc.c"
    break;

  case 274: /* generic_reset: var_name  */
#line 2688 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39440 "preproc.c"
    break;

  case 275: /* generic_reset: ALL  */
#line 2692 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 39448 "preproc.c"
    break;

  case 276: /* SetResetClause: SET set_rest  */
#line 2700 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 39456 "preproc.c"
    break;

  case 277: /* SetResetClause: VariableResetStmt  */
#line 2704 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39464 "preproc.c"
    break;

  case 278: /* FunctionSetResetClause: SET set_rest_more  */
#line 2712 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 39472 "preproc.c"
    break;

  case 279: /* FunctionSetResetClause: VariableResetStmt  */
#line 2716 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39480 "preproc.c"
    break;

  case 280: /* VariableShowStmt: SHOW var_name ecpg_into  */
#line 2724 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("show"),(yyvsp[-1].str));
}
#line 39488 "preproc.c"
    break;

  case 281: /* VariableShowStmt: SHOW TIME ZONE ecpg_into  */
#line 2728 "preproc.y"
 { 
 (yyval.str) = mm_strdup("show time zone");
}
#line 39496 "preproc.c"
    break;

  case 282: /* VariableShowStmt: SHOW TRANSACTION ISOLATION LEVEL ecpg_into  */
#line 2732 "preproc.y"
 { 
 (yyval.str) = mm_strdup("show transaction isolation level");
}
#line 39504 "preproc.c"
    break;

  case 283: /* VariableShowStmt: SHOW SESSION AUTHORIZATION ecpg_into  */
#line 2736 "preproc.y"
 { 
 (yyval.str) = mm_strdup("show session authorization");
}
#line 39512 "preproc.c"
    break;

  case 284: /* VariableShowStmt: SHOW ALL  */
#line 2740 "preproc.y"
        {
		mmerror(PARSE_ERROR, ET_ERROR, "SHOW ALL is not implemented");
		(yyval.str) = EMPTY;
	}
#line 39521 "preproc.c"
    break;

  case 285: /* ConstraintsSetStmt: SET CONSTRAINTS constraints_set_list constraints_set_mode  */
#line 2749 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("set constraints"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39529 "preproc.c"
    break;

  case 286: /* constraints_set_list: ALL  */
#line 2757 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 39537 "preproc.c"
    break;

  case 287: /* constraints_set_list: qualified_name_list  */
#line 2761 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39545 "preproc.c"
    break;

  case 288: /* constraints_set_mode: DEFERRED  */
#line 2769 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferred");
}
#line 39553 "preproc.c"
    break;

  case 289: /* constraints_set_mode: IMMEDIATE  */
#line 2773 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immediate");
}
#line 39561 "preproc.c"
    break;

  case 290: /* CheckPointStmt: CHECKPOINT  */
#line 2781 "preproc.y"
 { 
 (yyval.str) = mm_strdup("checkpoint");
}
#line 39569 "preproc.c"
    break;

  case 291: /* DiscardStmt: DISCARD ALL  */
#line 2789 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard all");
}
#line 39577 "preproc.c"
    break;

  case 292: /* DiscardStmt: DISCARD TEMP  */
#line 2793 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard temp");
}
#line 39585 "preproc.c"
    break;

  case 293: /* DiscardStmt: DISCARD TEMPORARY  */
#line 2797 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard temporary");
}
#line 39593 "preproc.c"
    break;

  case 294: /* DiscardStmt: DISCARD PLANS  */
#line 2801 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard plans");
}
#line 39601 "preproc.c"
    break;

  case 295: /* DiscardStmt: DISCARD SEQUENCES  */
#line 2805 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard sequences");
}
#line 39609 "preproc.c"
    break;

  case 296: /* AlterTableStmt: ALTER TABLE relation_expr alter_table_cmds  */
#line 2813 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39617 "preproc.c"
    break;

  case 297: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 2817 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39625 "preproc.c"
    break;

  case 298: /* AlterTableStmt: ALTER TABLE relation_expr partition_cmd  */
#line 2821 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39633 "preproc.c"
    break;

  case 299: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr partition_cmd  */
#line 2825 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39641 "preproc.c"
    break;

  case 300: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2829 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter table all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39649 "preproc.c"
    break;

  case 301: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2833 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter table all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39657 "preproc.c"
    break;

  case 302: /* AlterTableStmt: ALTER INDEX qualified_name alter_table_cmds  */
#line 2837 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter index"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39665 "preproc.c"
    break;

  case 303: /* AlterTableStmt: ALTER INDEX IF_P EXISTS qualified_name alter_table_cmds  */
#line 2841 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter index if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39673 "preproc.c"
    break;

  case 304: /* AlterTableStmt: ALTER INDEX qualified_name index_partition_cmd  */
#line 2845 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter index"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39681 "preproc.c"
    break;

  case 305: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2849 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter index all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39689 "preproc.c"
    break;

  case 306: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2853 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter index all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39697 "preproc.c"
    break;

  case 307: /* AlterTableStmt: ALTER SEQUENCE qualified_name alter_table_cmds  */
#line 2857 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39705 "preproc.c"
    break;

  case 308: /* AlterTableStmt: ALTER SEQUENCE IF_P EXISTS qualified_name alter_table_cmds  */
#line 2861 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39713 "preproc.c"
    break;

  case 309: /* AlterTableStmt: ALTER VIEW qualified_name alter_table_cmds  */
#line 2865 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter view"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39721 "preproc.c"
    break;

  case 310: /* AlterTableStmt: ALTER VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 2869 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter view if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39729 "preproc.c"
    break;

  case 311: /* AlterTableStmt: ALTER MATERIALIZED VIEW qualified_name alter_table_cmds  */
#line 2873 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter materialized view"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39737 "preproc.c"
    break;

  case 312: /* AlterTableStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 2877 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter materialized view if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39745 "preproc.c"
    break;

  case 313: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2881 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter materialized view all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39753 "preproc.c"
    break;

  case 314: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2885 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39761 "preproc.c"
    break;

  case 315: /* alter_table_cmds: alter_table_cmd  */
#line 2893 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39769 "preproc.c"
    break;

  case 316: /* alter_table_cmds: alter_table_cmds ',' alter_table_cmd  */
#line 2897 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39777 "preproc.c"
    break;

  case 317: /* alter_group_cmds: alter_group_cmd  */
#line 2905 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39785 "preproc.c"
    break;

  case 318: /* alter_group_cmds: alter_group_cmds ',' alter_group_cmd  */
#line 2909 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39793 "preproc.c"
    break;

  case 319: /* partition_cmd: ATTACH PARTITION qualified_name PartitionBoundSpec  */
#line 2917 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("attach partition"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39801 "preproc.c"
    break;

  case 320: /* partition_cmd: DETACH PARTITION qualified_name  */
#line 2921 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("detach partition"),(yyvsp[0].str));
}
#line 39809 "preproc.c"
    break;

  case 321: /* alter_group_cmd: SET TO DEFAULT  */
#line 2929 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set to default");
}
#line 39817 "preproc.c"
    break;

  case 322: /* index_partition_cmd: ATTACH PARTITION qualified_name  */
#line 2937 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("attach partition"),(yyvsp[0].str));
}
#line 39825 "preproc.c"
    break;

  case 323: /* alter_table_cmd: ADD_P columnDef  */
#line 2945 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 39833 "preproc.c"
    break;

  case 324: /* alter_table_cmd: ADD_P IF_P NOT EXISTS columnDef  */
#line 2949 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add if not exists"),(yyvsp[0].str));
}
#line 39841 "preproc.c"
    break;

  case 325: /* alter_table_cmd: ADD_P COLUMN columnDef  */
#line 2953 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add column"),(yyvsp[0].str));
}
#line 39849 "preproc.c"
    break;

  case 326: /* alter_table_cmd: ADD_P COLUMN IF_P NOT EXISTS columnDef  */
#line 2957 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add column if not exists"),(yyvsp[0].str));
}
#line 39857 "preproc.c"
    break;

  case 327: /* alter_table_cmd: ALTER opt_column ColId alter_column_default  */
#line 2961 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39865 "preproc.c"
    break;

  case 328: /* alter_table_cmd: ALTER opt_column ColId DROP NOT NULL_P  */
#line 2965 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("drop not null"));
}
#line 39873 "preproc.c"
    break;

  case 329: /* alter_table_cmd: ALTER opt_column ColId SET NOT NULL_P  */
#line 2969 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set not null"));
}
#line 39881 "preproc.c"
    break;

  case 330: /* alter_table_cmd: ALTER opt_column ColId SET STATISTICS SignedIconst  */
#line 2973 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set statistics"),(yyvsp[0].str));
}
#line 39889 "preproc.c"
    break;

  case 331: /* alter_table_cmd: ALTER opt_column ColId SET reloptions  */
#line 2977 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 39897 "preproc.c"
    break;

  case 332: /* alter_table_cmd: ALTER opt_column ColId RESET reloptions  */
#line 2981 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("reset"),(yyvsp[0].str));
}
#line 39905 "preproc.c"
    break;

  case 333: /* alter_table_cmd: ALTER opt_column ColId SET STORAGE ColId  */
#line 2985 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set storage"),(yyvsp[0].str));
}
#line 39913 "preproc.c"
    break;

  case 334: /* alter_table_cmd: ALTER opt_column ColId ADD_P GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 2989 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("add generated"),(yyvsp[-3].str),mm_strdup("as identity"),(yyvsp[0].str));
}
#line 39921 "preproc.c"
    break;

  case 335: /* alter_table_cmd: ALTER opt_column ColId alter_identity_column_option_list  */
#line 2993 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39929 "preproc.c"
    break;

  case 336: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P  */
#line 2997 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("drop identity"));
}
#line 39937 "preproc.c"
    break;

  case 337: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P IF_P EXISTS  */
#line 3001 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("drop identity if exists"));
}
#line 39945 "preproc.c"
    break;

  case 338: /* alter_table_cmd: DROP opt_column IF_P EXISTS ColId opt_drop_behavior  */
#line 3005 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39953 "preproc.c"
    break;

  case 339: /* alter_table_cmd: DROP opt_column ColId opt_drop_behavior  */
#line 3009 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39961 "preproc.c"
    break;

  case 340: /* alter_table_cmd: ALTER opt_column ColId opt_set_data TYPE_P Typename opt_collate_clause alter_using  */
#line 3013 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("alter"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("type"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39969 "preproc.c"
    break;

  case 341: /* alter_table_cmd: ALTER opt_column ColId alter_generic_options  */
#line 3017 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39977 "preproc.c"
    break;

  case 342: /* alter_table_cmd: ADD_P TableConstraint  */
#line 3021 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 39985 "preproc.c"
    break;

  case 343: /* alter_table_cmd: ADD_P PARTITIONS Iconst  */
#line 3025 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add partitions"),(yyvsp[0].str));
}
#line 39993 "preproc.c"
    break;

  case 344: /* alter_table_cmd: EXCHANGE INDEX qualified_name WITH qualified_name  */
#line 3029 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("exchange index"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 40001 "preproc.c"
    break;

  case 345: /* alter_table_cmd: SET PARTITION BEGIN_P '(' AexprConst ')'  */
#line 3033 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("set partition begin ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40009 "preproc.c"
    break;

  case 346: /* alter_table_cmd: ALTER CONSTRAINT name ConstraintAttributeSpec  */
#line 3037 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40017 "preproc.c"
    break;

  case 347: /* alter_table_cmd: VALIDATE CONSTRAINT name  */
#line 3041 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("validate constraint"),(yyvsp[0].str));
}
#line 40025 "preproc.c"
    break;

  case 348: /* alter_table_cmd: DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 3045 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop constraint if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40033 "preproc.c"
    break;

  case 349: /* alter_table_cmd: DROP CONSTRAINT name opt_drop_behavior  */
#line 3049 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40041 "preproc.c"
    break;

  case 350: /* alter_table_cmd: SET WITH OIDS  */
#line 3053 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set with oids");
}
#line 40049 "preproc.c"
    break;

  case 351: /* alter_table_cmd: SET WITHOUT OIDS  */
#line 3057 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set without oids");
}
#line 40057 "preproc.c"
    break;

  case 352: /* alter_table_cmd: CLUSTER ON name  */
#line 3061 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cluster on"),(yyvsp[0].str));
}
#line 40065 "preproc.c"
    break;

  case 353: /* alter_table_cmd: SET WITHOUT CLUSTER  */
#line 3065 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set without cluster");
}
#line 40073 "preproc.c"
    break;

  case 354: /* alter_table_cmd: SET LOGGED  */
#line 3069 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set logged");
}
#line 40081 "preproc.c"
    break;

  case 355: /* alter_table_cmd: SET UNLOGGED  */
#line 3073 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set unlogged");
}
#line 40089 "preproc.c"
    break;

  case 356: /* alter_table_cmd: ENABLE_P TRIGGER name  */
#line 3077 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable trigger"),(yyvsp[0].str));
}
#line 40097 "preproc.c"
    break;

  case 357: /* alter_table_cmd: ENABLE_P ALWAYS TRIGGER name  */
#line 3081 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable always trigger"),(yyvsp[0].str));
}
#line 40105 "preproc.c"
    break;

  case 358: /* alter_table_cmd: ENABLE_P REPLICA TRIGGER name  */
#line 3085 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable replica trigger"),(yyvsp[0].str));
}
#line 40113 "preproc.c"
    break;

  case 359: /* alter_table_cmd: ENABLE_P TRIGGER ALL  */
#line 3089 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable trigger all");
}
#line 40121 "preproc.c"
    break;

  case 360: /* alter_table_cmd: ENABLE_P TRIGGER USER  */
#line 3093 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable trigger user");
}
#line 40129 "preproc.c"
    break;

  case 361: /* alter_table_cmd: DISABLE_P TRIGGER name  */
#line 3097 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("disable trigger"),(yyvsp[0].str));
}
#line 40137 "preproc.c"
    break;

  case 362: /* alter_table_cmd: DISABLE_P TRIGGER ALL  */
#line 3101 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable trigger all");
}
#line 40145 "preproc.c"
    break;

  case 363: /* alter_table_cmd: DISABLE_P TRIGGER USER  */
#line 3105 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable trigger user");
}
#line 40153 "preproc.c"
    break;

  case 364: /* alter_table_cmd: ENABLE_P RULE name  */
#line 3109 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable rule"),(yyvsp[0].str));
}
#line 40161 "preproc.c"
    break;

  case 365: /* alter_table_cmd: ENABLE_P ALWAYS RULE name  */
#line 3113 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable always rule"),(yyvsp[0].str));
}
#line 40169 "preproc.c"
    break;

  case 366: /* alter_table_cmd: ENABLE_P REPLICA RULE name  */
#line 3117 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable replica rule"),(yyvsp[0].str));
}
#line 40177 "preproc.c"
    break;

  case 367: /* alter_table_cmd: DISABLE_P RULE name  */
#line 3121 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("disable rule"),(yyvsp[0].str));
}
#line 40185 "preproc.c"
    break;

  case 368: /* alter_table_cmd: INHERIT qualified_name  */
#line 3125 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("inherit"),(yyvsp[0].str));
}
#line 40193 "preproc.c"
    break;

  case 369: /* alter_table_cmd: NO INHERIT qualified_name  */
#line 3129 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("no inherit"),(yyvsp[0].str));
}
#line 40201 "preproc.c"
    break;

  case 370: /* alter_table_cmd: OF any_name  */
#line 3133 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("of"),(yyvsp[0].str));
}
#line 40209 "preproc.c"
    break;

  case 371: /* alter_table_cmd: NOT OF  */
#line 3137 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not of");
}
#line 40217 "preproc.c"
    break;

  case 372: /* alter_table_cmd: OWNER TO RoleSpec  */
#line 3141 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("owner to"),(yyvsp[0].str));
}
#line 40225 "preproc.c"
    break;

  case 373: /* alter_table_cmd: SET TABLESPACE name  */
#line 3145 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set tablespace"),(yyvsp[0].str));
}
#line 40233 "preproc.c"
    break;

  case 374: /* alter_table_cmd: SET reloptions  */
#line 3149 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 40241 "preproc.c"
    break;

  case 375: /* alter_table_cmd: RESET reloptions  */
#line 3153 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("reset"),(yyvsp[0].str));
}
#line 40249 "preproc.c"
    break;

  case 376: /* alter_table_cmd: REPLICA IDENTITY_P replica_identity  */
#line 3157 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("replica identity"),(yyvsp[0].str));
}
#line 40257 "preproc.c"
    break;

  case 377: /* alter_table_cmd: ENABLE_P ROW LEVEL SECURITY  */
#line 3161 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable row level security");
}
#line 40265 "preproc.c"
    break;

  case 378: /* alter_table_cmd: DISABLE_P ROW LEVEL SECURITY  */
#line 3165 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable row level security");
}
#line 40273 "preproc.c"
    break;

  case 379: /* alter_table_cmd: FORCE ROW LEVEL SECURITY  */
#line 3169 "preproc.y"
 { 
 (yyval.str) = mm_strdup("force row level security");
}
#line 40281 "preproc.c"
    break;

  case 380: /* alter_table_cmd: NO FORCE ROW LEVEL SECURITY  */
#line 3173 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no force row level security");
}
#line 40289 "preproc.c"
    break;

  case 381: /* alter_table_cmd: alter_generic_options  */
#line 3177 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40297 "preproc.c"
    break;

  case 382: /* alter_table_cmd: OptDistributeByInternal  */
#line 3181 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40305 "preproc.c"
    break;

  case 383: /* alter_table_cmd: OptSubClusterInternal  */
#line 3185 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40313 "preproc.c"
    break;

  case 384: /* alter_table_cmd: ADD_P NODE pgxcnodes  */
#line 3189 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add node"),(yyvsp[0].str));
}
#line 40321 "preproc.c"
    break;

  case 385: /* alter_table_cmd: DELETE_P NODE pgxcnodes  */
#line 3193 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("delete node"),(yyvsp[0].str));
}
#line 40329 "preproc.c"
    break;

  case 386: /* alter_table_cmd: REBUILD EXTENT  */
#line 3197 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rebuild extent");
}
#line 40337 "preproc.c"
    break;

  case 387: /* alter_column_default: SET DEFAULT a_expr  */
#line 3205 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set default"),(yyvsp[0].str));
}
#line 40345 "preproc.c"
    break;

  case 388: /* alter_column_default: DROP DEFAULT  */
#line 3209 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop default");
}
#line 40353 "preproc.c"
    break;

  case 389: /* opt_drop_behavior: CASCADE  */
#line 3217 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascade");
}
#line 40361 "preproc.c"
    break;

  case 390: /* opt_drop_behavior: RESTRICT  */
#line 3221 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restrict");
}
#line 40369 "preproc.c"
    break;

  case 391: /* opt_drop_behavior: %empty  */
#line 3225 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40376 "preproc.c"
    break;

  case 392: /* opt_collate_clause: COLLATE any_name  */
#line 3232 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 40384 "preproc.c"
    break;

  case 393: /* opt_collate_clause: %empty  */
#line 3236 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40391 "preproc.c"
    break;

  case 394: /* alter_using: USING a_expr  */
#line 3243 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 40399 "preproc.c"
    break;

  case 395: /* alter_using: %empty  */
#line 3247 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40406 "preproc.c"
    break;

  case 396: /* replica_identity: NOTHING  */
#line 3254 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nothing");
}
#line 40414 "preproc.c"
    break;

  case 397: /* replica_identity: FULL  */
#line 3258 "preproc.y"
 { 
 (yyval.str) = mm_strdup("full");
}
#line 40422 "preproc.c"
    break;

  case 398: /* replica_identity: DEFAULT  */
#line 3262 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 40430 "preproc.c"
    break;

  case 399: /* replica_identity: USING INDEX name  */
#line 3266 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using index"),(yyvsp[0].str));
}
#line 40438 "preproc.c"
    break;

  case 400: /* Identified_cluster: IN_P ColId  */
#line 3274 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("in"),(yyvsp[0].str));
}
#line 40446 "preproc.c"
    break;

  case 401: /* Identified_cluster: %empty  */
#line 3278 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40453 "preproc.c"
    break;

  case 402: /* reloptions: '(' reloption_list ')'  */
#line 3285 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40461 "preproc.c"
    break;

  case 403: /* opt_reloptions: WITH reloptions  */
#line 3293 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 40469 "preproc.c"
    break;

  case 404: /* opt_reloptions: %empty  */
#line 3297 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40476 "preproc.c"
    break;

  case 405: /* reloption_list: reloption_elem  */
#line 3304 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40484 "preproc.c"
    break;

  case 406: /* reloption_list: reloption_list ',' reloption_elem  */
#line 3308 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40492 "preproc.c"
    break;

  case 407: /* reloption_elem: ColLabel '=' def_arg  */
#line 3316 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 40500 "preproc.c"
    break;

  case 408: /* reloption_elem: ColLabel  */
#line 3320 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40508 "preproc.c"
    break;

  case 409: /* reloption_elem: ColLabel '.' ColLabel '=' def_arg  */
#line 3324 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("."),(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 40516 "preproc.c"
    break;

  case 410: /* reloption_elem: ColLabel '.' ColLabel  */
#line 3328 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 40524 "preproc.c"
    break;

  case 411: /* alter_identity_column_option_list: alter_identity_column_option  */
#line 3336 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40532 "preproc.c"
    break;

  case 412: /* alter_identity_column_option_list: alter_identity_column_option_list alter_identity_column_option  */
#line 3340 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40540 "preproc.c"
    break;

  case 413: /* alter_identity_column_option: RESTART  */
#line 3348 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restart");
}
#line 40548 "preproc.c"
    break;

  case 414: /* alter_identity_column_option: RESTART opt_with NumericOnly  */
#line 3352 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("restart"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40556 "preproc.c"
    break;

  case 415: /* alter_identity_column_option: SET SeqOptElem  */
#line 3356 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 40564 "preproc.c"
    break;

  case 416: /* alter_identity_column_option: SET GENERATED generated_when  */
#line 3360 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set generated"),(yyvsp[0].str));
}
#line 40572 "preproc.c"
    break;

  case 417: /* PartitionBoundSpec: FOR VALUES WITH '(' hash_partbound ')'  */
#line 3368 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("for values with ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40580 "preproc.c"
    break;

  case 418: /* PartitionBoundSpec: FOR VALUES IN_P '(' partbound_datum_list ')'  */
#line 3372 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("for values in ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40588 "preproc.c"
    break;

  case 419: /* PartitionBoundSpec: FOR VALUES FROM '(' range_datum_list ')' TO '(' range_datum_list ')'  */
#line 3376 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("for values from ("),(yyvsp[-5].str),mm_strdup(") to ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40596 "preproc.c"
    break;

  case 420: /* PartitionBoundSpec: DEFAULT  */
#line 3380 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 40604 "preproc.c"
    break;

  case 421: /* hash_partbound_elem: NonReservedWord Iconst  */
#line 3388 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40612 "preproc.c"
    break;

  case 422: /* hash_partbound: hash_partbound_elem  */
#line 3396 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40620 "preproc.c"
    break;

  case 423: /* hash_partbound: hash_partbound ',' hash_partbound_elem  */
#line 3400 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40628 "preproc.c"
    break;

  case 424: /* partbound_datum: ecpg_sconst  */
#line 3408 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40636 "preproc.c"
    break;

  case 425: /* partbound_datum: NumericOnly  */
#line 3412 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40644 "preproc.c"
    break;

  case 426: /* partbound_datum: TRUE_P  */
#line 3416 "preproc.y"
 { 
 (yyval.str) = mm_strdup("true");
}
#line 40652 "preproc.c"
    break;

  case 427: /* partbound_datum: FALSE_P  */
#line 3420 "preproc.y"
 { 
 (yyval.str) = mm_strdup("false");
}
#line 40660 "preproc.c"
    break;

  case 428: /* partbound_datum: NULL_P  */
#line 3424 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 40668 "preproc.c"
    break;

  case 429: /* partbound_datum_list: partbound_datum  */
#line 3432 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40676 "preproc.c"
    break;

  case 430: /* partbound_datum_list: partbound_datum_list ',' partbound_datum  */
#line 3436 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40684 "preproc.c"
    break;

  case 431: /* range_datum_list: PartitionRangeDatum  */
#line 3444 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40692 "preproc.c"
    break;

  case 432: /* range_datum_list: range_datum_list ',' PartitionRangeDatum  */
#line 3448 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40700 "preproc.c"
    break;

  case 433: /* PartitionRangeDatum: MINVALUE  */
#line 3456 "preproc.y"
 { 
 (yyval.str) = mm_strdup("minvalue");
}
#line 40708 "preproc.c"
    break;

  case 434: /* PartitionRangeDatum: MAXVALUE  */
#line 3460 "preproc.y"
 { 
 (yyval.str) = mm_strdup("maxvalue");
}
#line 40716 "preproc.c"
    break;

  case 435: /* PartitionRangeDatum: partbound_datum  */
#line 3464 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40724 "preproc.c"
    break;

  case 436: /* AlterCompositeTypeStmt: ALTER TYPE_P any_name alter_type_cmds  */
#line 3472 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40732 "preproc.c"
    break;

  case 437: /* alter_type_cmds: alter_type_cmd  */
#line 3480 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40740 "preproc.c"
    break;

  case 438: /* alter_type_cmds: alter_type_cmds ',' alter_type_cmd  */
#line 3484 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40748 "preproc.c"
    break;

  case 439: /* alter_type_cmd: ADD_P ATTRIBUTE TableFuncElement opt_drop_behavior  */
#line 3492 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("add attribute"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40756 "preproc.c"
    break;

  case 440: /* alter_type_cmd: DROP ATTRIBUTE IF_P EXISTS ColId opt_drop_behavior  */
#line 3496 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop attribute if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40764 "preproc.c"
    break;

  case 441: /* alter_type_cmd: DROP ATTRIBUTE ColId opt_drop_behavior  */
#line 3500 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop attribute"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40772 "preproc.c"
    break;

  case 442: /* alter_type_cmd: ALTER ATTRIBUTE ColId opt_set_data TYPE_P Typename opt_collate_clause opt_drop_behavior  */
#line 3504 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter attribute"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("type"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40780 "preproc.c"
    break;

  case 443: /* ClosePortalStmt: CLOSE cursor_name  */
#line 3512 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		(yyval.str) = cat2_str(mm_strdup("close"), cursor_marker);
	}
#line 40789 "preproc.c"
    break;

  case 444: /* ClosePortalStmt: CLOSE ALL  */
#line 3517 "preproc.y"
 { 
 (yyval.str) = mm_strdup("close all");
}
#line 40797 "preproc.c"
    break;

  case 445: /* CopyStmt: COPY opt_binary qualified_name opt_column_list opt_oids opt_shard_list copy_from opt_program copy_file_name copy_delimiter opt_with copy_options  */
#line 3525 "preproc.y"
 { 
			if (strcmp((yyvsp[-6].str), "from") == 0 &&
			   (strcmp((yyvsp[-5].str), "stdin") == 0 || strcmp((yyvsp[-5].str), "stdout") == 0))
				mmerror(PARSE_ERROR, ET_WARNING, "COPY FROM STDIN is not implemented");

 (yyval.str) = cat_str(12,mm_strdup("copy"),(yyvsp[-10].str),(yyvsp[-9].str),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40809 "preproc.c"
    break;

  case 446: /* CopyStmt: COPY '(' PreparableStmt ')' TO opt_program copy_file_name opt_with copy_options  */
#line 3533 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("copy ("),(yyvsp[-6].str),mm_strdup(") to"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40817 "preproc.c"
    break;

  case 447: /* copy_from: FROM  */
#line 3541 "preproc.y"
 { 
 (yyval.str) = mm_strdup("from");
}
#line 40825 "preproc.c"
    break;

  case 448: /* copy_from: TO  */
#line 3545 "preproc.y"
 { 
 (yyval.str) = mm_strdup("to");
}
#line 40833 "preproc.c"
    break;

  case 449: /* opt_program: PROGRAM  */
#line 3553 "preproc.y"
 { 
 (yyval.str) = mm_strdup("program");
}
#line 40841 "preproc.c"
    break;

  case 450: /* opt_program: %empty  */
#line 3557 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40848 "preproc.c"
    break;

  case 451: /* opt_shard_list: SHARDING '(' shard_list ')'  */
#line 3564 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("sharding ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40856 "preproc.c"
    break;

  case 452: /* opt_shard_list: %empty  */
#line 3568 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40863 "preproc.c"
    break;

  case 453: /* copy_file_name: ecpg_sconst  */
#line 3575 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40871 "preproc.c"
    break;

  case 454: /* copy_file_name: STDIN  */
#line 3579 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdin");
}
#line 40879 "preproc.c"
    break;

  case 455: /* copy_file_name: STDOUT  */
#line 3583 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdout");
}
#line 40887 "preproc.c"
    break;

  case 456: /* copy_options: copy_opt_list  */
#line 3591 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40895 "preproc.c"
    break;

  case 457: /* copy_options: '(' copy_generic_opt_list ')'  */
#line 3595 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40903 "preproc.c"
    break;

  case 458: /* copy_opt_list: copy_opt_list copy_opt_item  */
#line 3603 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40911 "preproc.c"
    break;

  case 459: /* copy_opt_list: %empty  */
#line 3607 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40918 "preproc.c"
    break;

  case 460: /* copy_opt_item: BINARY  */
#line 3614 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary");
}
#line 40926 "preproc.c"
    break;

  case 461: /* copy_opt_item: OIDS  */
#line 3618 "preproc.y"
 { 
 (yyval.str) = mm_strdup("oids");
}
#line 40934 "preproc.c"
    break;

  case 462: /* copy_opt_item: FREEZE  */
#line 3622 "preproc.y"
 { 
 (yyval.str) = mm_strdup("freeze");
}
#line 40942 "preproc.c"
    break;

  case 463: /* copy_opt_item: DELIMITER opt_as ecpg_sconst  */
#line 3626 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("delimiter"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40950 "preproc.c"
    break;

  case 464: /* copy_opt_item: NULL_P opt_as ecpg_sconst  */
#line 3630 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("null"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40958 "preproc.c"
    break;

  case 465: /* copy_opt_item: CSV  */
#line 3634 "preproc.y"
 { 
 (yyval.str) = mm_strdup("csv");
}
#line 40966 "preproc.c"
    break;

  case 466: /* copy_opt_item: ROWS  */
#line 3638 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rows");
}
#line 40974 "preproc.c"
    break;

  case 467: /* copy_opt_item: HEADER_P  */
#line 3642 "preproc.y"
 { 
 (yyval.str) = mm_strdup("header");
}
#line 40982 "preproc.c"
    break;

  case 468: /* copy_opt_item: QUOTE opt_as ecpg_sconst  */
#line 3646 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("quote"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40990 "preproc.c"
    break;

  case 469: /* copy_opt_item: ESCAPE opt_as ecpg_sconst  */
#line 3650 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("escape"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40998 "preproc.c"
    break;

  case 470: /* copy_opt_item: FORCE QUOTE columnList  */
#line 3654 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("force quote"),(yyvsp[0].str));
}
#line 41006 "preproc.c"
    break;

  case 471: /* copy_opt_item: FORCE QUOTE '*'  */
#line 3658 "preproc.y"
 { 
 (yyval.str) = mm_strdup("force quote *");
}
#line 41014 "preproc.c"
    break;

  case 472: /* copy_opt_item: FORCE NOT NULL_P columnList  */
#line 3662 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("force not null"),(yyvsp[0].str));
}
#line 41022 "preproc.c"
    break;

  case 473: /* copy_opt_item: FORCE NULL_P columnList  */
#line 3666 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("force null"),(yyvsp[0].str));
}
#line 41030 "preproc.c"
    break;

  case 474: /* copy_opt_item: ENCODING ecpg_sconst  */
#line 3670 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("encoding"),(yyvsp[0].str));
}
#line 41038 "preproc.c"
    break;

  case 475: /* opt_binary: BINARY  */
#line 3678 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary");
}
#line 41046 "preproc.c"
    break;

  case 476: /* opt_binary: %empty  */
#line 3682 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41053 "preproc.c"
    break;

  case 477: /* opt_oids: WITH OIDS  */
#line 3689 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with oids");
}
#line 41061 "preproc.c"
    break;

  case 478: /* opt_oids: %empty  */
#line 3693 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41068 "preproc.c"
    break;

  case 479: /* copy_delimiter: opt_using DELIMITERS ecpg_sconst  */
#line 3700 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("delimiters"),(yyvsp[0].str));
}
#line 41076 "preproc.c"
    break;

  case 480: /* copy_delimiter: %empty  */
#line 3704 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41083 "preproc.c"
    break;

  case 481: /* opt_using: USING  */
#line 3711 "preproc.y"
 { 
 (yyval.str) = mm_strdup("using");
}
#line 41091 "preproc.c"
    break;

  case 482: /* opt_using: %empty  */
#line 3715 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41098 "preproc.c"
    break;

  case 483: /* copy_generic_opt_list: copy_generic_opt_elem  */
#line 3722 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41106 "preproc.c"
    break;

  case 484: /* copy_generic_opt_list: copy_generic_opt_list ',' copy_generic_opt_elem  */
#line 3726 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41114 "preproc.c"
    break;

  case 485: /* copy_generic_opt_elem: ColLabel copy_generic_opt_arg  */
#line 3734 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41122 "preproc.c"
    break;

  case 486: /* copy_generic_opt_arg: opt_boolean_or_string  */
#line 3742 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41130 "preproc.c"
    break;

  case 487: /* copy_generic_opt_arg: NumericOnly  */
#line 3746 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41138 "preproc.c"
    break;

  case 488: /* copy_generic_opt_arg: '*'  */
#line 3750 "preproc.y"
 { 
 (yyval.str) = mm_strdup("*");
}
#line 41146 "preproc.c"
    break;

  case 489: /* copy_generic_opt_arg: '(' copy_generic_opt_arg_list ')'  */
#line 3754 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41154 "preproc.c"
    break;

  case 490: /* copy_generic_opt_arg: %empty  */
#line 3758 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41161 "preproc.c"
    break;

  case 491: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list_item  */
#line 3765 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41169 "preproc.c"
    break;

  case 492: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list ',' copy_generic_opt_arg_list_item  */
#line 3769 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41177 "preproc.c"
    break;

  case 493: /* copy_generic_opt_arg_list_item: opt_boolean_or_string  */
#line 3777 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41185 "preproc.c"
    break;

  case 494: /* CreateStmt: CREATE OptTemp TABLE qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec OptWith OnCommitOption OptTableSpace OptDistributeBy OptSubCluster  */
#line 3785 "preproc.y"
 { 
 (yyval.str) = cat_str(14,mm_strdup("create"),(yyvsp[-12].str),mm_strdup("table"),(yyvsp[-10].str),mm_strdup("("),(yyvsp[-8].str),mm_strdup(")"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41193 "preproc.c"
    break;

  case 495: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec OptWith OnCommitOption OptTableSpace OptDistributeBy OptSubCluster  */
#line 3789 "preproc.y"
 { 
 (yyval.str) = cat_str(14,mm_strdup("create"),(yyvsp[-15].str),mm_strdup("table if not exists"),(yyvsp[-10].str),mm_strdup("("),(yyvsp[-8].str),mm_strdup(")"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41201 "preproc.c"
    break;

  case 496: /* CreateStmt: CREATE OptTemp TABLE qualified_name OF any_name OptTypedTableElementList OptPartitionSpec OptWith OnCommitOption OptTableSpace OptDistributeBy OptSubCluster  */
#line 3793 "preproc.y"
 { 
 (yyval.str) = cat_str(13,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("table"),(yyvsp[-9].str),mm_strdup("of"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41209 "preproc.c"
    break;

  case 497: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name OF any_name OptTypedTableElementList OptPartitionSpec OptWith OnCommitOption OptTableSpace OptDistributeBy OptSubCluster  */
#line 3797 "preproc.y"
 { 
 (yyval.str) = cat_str(13,mm_strdup("create"),(yyvsp[-14].str),mm_strdup("table if not exists"),(yyvsp[-9].str),mm_strdup("of"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41217 "preproc.c"
    break;

  case 498: /* CreateStmt: CREATE OptTemp TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec OptPartitionSpec OptWith OnCommitOption OptTableSpace  */
#line 3801 "preproc.y"
 { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("table"),(yyvsp[-9].str),mm_strdup("partition of"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41225 "preproc.c"
    break;

  case 499: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec OptPartitionSpec OptWith OnCommitOption OptTableSpace  */
#line 3805 "preproc.y"
 { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-14].str),mm_strdup("table if not exists"),(yyvsp[-9].str),mm_strdup("partition of"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41233 "preproc.c"
    break;

  case 500: /* OptTemp: TEMPORARY  */
#line 3813 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temporary");
}
#line 41241 "preproc.c"
    break;

  case 501: /* OptTemp: TEMP  */
#line 3817 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temp");
}
#line 41249 "preproc.c"
    break;

  case 502: /* OptTemp: LOCAL TEMPORARY  */
#line 3821 "preproc.y"
 { 
 (yyval.str) = mm_strdup("local temporary");
}
#line 41257 "preproc.c"
    break;

  case 503: /* OptTemp: LOCAL TEMP  */
#line 3825 "preproc.y"
 { 
 (yyval.str) = mm_strdup("local temp");
}
#line 41265 "preproc.c"
    break;

  case 504: /* OptTemp: GLOBAL TEMPORARY  */
#line 3829 "preproc.y"
 { 
 (yyval.str) = mm_strdup("global temporary");
}
#line 41273 "preproc.c"
    break;

  case 505: /* OptTemp: GLOBAL TEMP  */
#line 3833 "preproc.y"
 { 
 (yyval.str) = mm_strdup("global temp");
}
#line 41281 "preproc.c"
    break;

  case 506: /* OptTemp: UNLOGGED  */
#line 3837 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 41289 "preproc.c"
    break;

  case 507: /* OptTemp: %empty  */
#line 3841 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41296 "preproc.c"
    break;

  case 508: /* OptTableElementList: TableElementList  */
#line 3848 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41304 "preproc.c"
    break;

  case 509: /* OptTableElementList: %empty  */
#line 3852 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41311 "preproc.c"
    break;

  case 510: /* OptTypedTableElementList: '(' TypedTableElementList ')'  */
#line 3859 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41319 "preproc.c"
    break;

  case 511: /* OptTypedTableElementList: %empty  */
#line 3863 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41326 "preproc.c"
    break;

  case 512: /* TableElementList: TableElement  */
#line 3870 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41334 "preproc.c"
    break;

  case 513: /* TableElementList: TableElementList ',' TableElement  */
#line 3874 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41342 "preproc.c"
    break;

  case 514: /* TypedTableElementList: TypedTableElement  */
#line 3882 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41350 "preproc.c"
    break;

  case 515: /* TypedTableElementList: TypedTableElementList ',' TypedTableElement  */
#line 3886 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41358 "preproc.c"
    break;

  case 516: /* TableElement: columnDef  */
#line 3894 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41366 "preproc.c"
    break;

  case 517: /* TableElement: TableLikeClause  */
#line 3898 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41374 "preproc.c"
    break;

  case 518: /* TableElement: TableConstraint  */
#line 3902 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41382 "preproc.c"
    break;

  case 519: /* TypedTableElement: columnOptions  */
#line 3910 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41390 "preproc.c"
    break;

  case 520: /* TypedTableElement: TableConstraint  */
#line 3914 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41398 "preproc.c"
    break;

  case 521: /* columnDef: ColId Typename create_generic_options ColQualList  */
#line 3922 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41406 "preproc.c"
    break;

  case 522: /* columnOptions: ColId ColQualList  */
#line 3930 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41414 "preproc.c"
    break;

  case 523: /* columnOptions: ColId WITH OPTIONS ColQualList  */
#line 3934 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("with options"),(yyvsp[0].str));
}
#line 41422 "preproc.c"
    break;

  case 524: /* ColQualList: ColQualList ColConstraint  */
#line 3942 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41430 "preproc.c"
    break;

  case 525: /* ColQualList: %empty  */
#line 3946 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41437 "preproc.c"
    break;

  case 526: /* ColConstraint: CONSTRAINT name ColConstraintElem  */
#line 3953 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41445 "preproc.c"
    break;

  case 527: /* ColConstraint: ColConstraintElem  */
#line 3957 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41453 "preproc.c"
    break;

  case 528: /* ColConstraint: ConstraintAttr  */
#line 3961 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41461 "preproc.c"
    break;

  case 529: /* ColConstraint: COLLATE any_name  */
#line 3965 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 41469 "preproc.c"
    break;

  case 530: /* ColConstraintElem: NOT NULL_P  */
#line 3973 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not null");
}
#line 41477 "preproc.c"
    break;

  case 531: /* ColConstraintElem: NULL_P  */
#line 3977 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 41485 "preproc.c"
    break;

  case 532: /* ColConstraintElem: UNIQUE opt_definition OptConsTableSpace  */
#line 3981 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("unique"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41493 "preproc.c"
    break;

  case 533: /* ColConstraintElem: PRIMARY KEY opt_definition OptConsTableSpace  */
#line 3985 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("primary key"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41501 "preproc.c"
    break;

  case 534: /* ColConstraintElem: CHECK '(' a_expr ')' opt_no_inherit  */
#line 3989 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 41509 "preproc.c"
    break;

  case 535: /* ColConstraintElem: DEFAULT b_expr  */
#line 3993 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("default"),(yyvsp[0].str));
}
#line 41517 "preproc.c"
    break;

  case 536: /* ColConstraintElem: GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 3997 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("generated"),(yyvsp[-3].str),mm_strdup("as identity"),(yyvsp[0].str));
}
#line 41525 "preproc.c"
    break;

  case 537: /* ColConstraintElem: REFERENCES qualified_name opt_column_list key_match key_actions  */
#line 4001 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("references"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41533 "preproc.c"
    break;

  case 538: /* generated_when: ALWAYS  */
#line 4009 "preproc.y"
 { 
 (yyval.str) = mm_strdup("always");
}
#line 41541 "preproc.c"
    break;

  case 539: /* generated_when: BY DEFAULT  */
#line 4013 "preproc.y"
 { 
 (yyval.str) = mm_strdup("by default");
}
#line 41549 "preproc.c"
    break;

  case 540: /* ConstraintAttr: DEFERRABLE  */
#line 4021 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 41557 "preproc.c"
    break;

  case 541: /* ConstraintAttr: NOT DEFERRABLE  */
#line 4025 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 41565 "preproc.c"
    break;

  case 542: /* ConstraintAttr: INITIALLY DEFERRED  */
#line 4029 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially deferred");
}
#line 41573 "preproc.c"
    break;

  case 543: /* ConstraintAttr: INITIALLY IMMEDIATE  */
#line 4033 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially immediate");
}
#line 41581 "preproc.c"
    break;

  case 544: /* TableLikeClause: LIKE qualified_name TableLikeOptionList  */
#line 4041 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("like"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41589 "preproc.c"
    break;

  case 545: /* TableLikeOptionList: TableLikeOptionList INCLUDING TableLikeOption  */
#line 4049 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("including"),(yyvsp[0].str));
}
#line 41597 "preproc.c"
    break;

  case 546: /* TableLikeOptionList: TableLikeOptionList EXCLUDING TableLikeOption  */
#line 4053 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("excluding"),(yyvsp[0].str));
}
#line 41605 "preproc.c"
    break;

  case 547: /* TableLikeOptionList: %empty  */
#line 4057 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41612 "preproc.c"
    break;

  case 548: /* TableLikeOption: DEFAULTS  */
#line 4064 "preproc.y"
 { 
 (yyval.str) = mm_strdup("defaults");
}
#line 41620 "preproc.c"
    break;

  case 549: /* TableLikeOption: CONSTRAINTS  */
#line 4068 "preproc.y"
 { 
 (yyval.str) = mm_strdup("constraints");
}
#line 41628 "preproc.c"
    break;

  case 550: /* TableLikeOption: IDENTITY_P  */
#line 4072 "preproc.y"
 { 
 (yyval.str) = mm_strdup("identity");
}
#line 41636 "preproc.c"
    break;

  case 551: /* TableLikeOption: INDEXES  */
#line 4076 "preproc.y"
 { 
 (yyval.str) = mm_strdup("indexes");
}
#line 41644 "preproc.c"
    break;

  case 552: /* TableLikeOption: STORAGE  */
#line 4080 "preproc.y"
 { 
 (yyval.str) = mm_strdup("storage");
}
#line 41652 "preproc.c"
    break;

  case 553: /* TableLikeOption: COMMENTS  */
#line 4084 "preproc.y"
 { 
 (yyval.str) = mm_strdup("comments");
}
#line 41660 "preproc.c"
    break;

  case 554: /* TableLikeOption: ALL  */
#line 4088 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 41668 "preproc.c"
    break;

  case 555: /* TableConstraint: CONSTRAINT name ConstraintElem  */
#line 4096 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41676 "preproc.c"
    break;

  case 556: /* TableConstraint: ConstraintElem  */
#line 4100 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41684 "preproc.c"
    break;

  case 557: /* ConstraintElem: CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 4108 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 41692 "preproc.c"
    break;

  case 558: /* ConstraintElem: UNIQUE '(' columnList ')' opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 4112 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("unique ("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41700 "preproc.c"
    break;

  case 559: /* ConstraintElem: UNIQUE ExistingIndex ConstraintAttributeSpec  */
#line 4116 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("unique"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41708 "preproc.c"
    break;

  case 560: /* ConstraintElem: PRIMARY KEY '(' columnList ')' opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 4120 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("primary key ("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41716 "preproc.c"
    break;

  case 561: /* ConstraintElem: PRIMARY KEY ExistingIndex ConstraintAttributeSpec  */
#line 4124 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("primary key"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41724 "preproc.c"
    break;

  case 562: /* ConstraintElem: EXCLUDE access_method_clause '(' ExclusionConstraintList ')' opt_definition OptConsTableSpace ExclusionWhereClause ConstraintAttributeSpec  */
#line 4128 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("exclude"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41732 "preproc.c"
    break;

  case 563: /* ConstraintElem: FOREIGN KEY '(' columnList ')' REFERENCES qualified_name opt_column_list key_match key_actions ConstraintAttributeSpec  */
#line 4132 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("foreign key ("),(yyvsp[-7].str),mm_strdup(") references"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41740 "preproc.c"
    break;

  case 564: /* opt_no_inherit: NO INHERIT  */
#line 4140 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no inherit");
}
#line 41748 "preproc.c"
    break;

  case 565: /* opt_no_inherit: %empty  */
#line 4144 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41755 "preproc.c"
    break;

  case 566: /* opt_column_list: '(' columnList ')'  */
#line 4151 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41763 "preproc.c"
    break;

  case 567: /* opt_column_list: %empty  */
#line 4155 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41770 "preproc.c"
    break;

  case 568: /* columnList: columnElem  */
#line 4162 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41778 "preproc.c"
    break;

  case 569: /* columnList: columnList ',' columnElem  */
#line 4166 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41786 "preproc.c"
    break;

  case 570: /* columnElem: ColId  */
#line 4174 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41794 "preproc.c"
    break;

  case 571: /* key_match: MATCH FULL  */
#line 4182 "preproc.y"
 { 
 (yyval.str) = mm_strdup("match full");
}
#line 41802 "preproc.c"
    break;

  case 572: /* key_match: MATCH PARTIAL  */
#line 4186 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = mm_strdup("match partial");
}
#line 41811 "preproc.c"
    break;

  case 573: /* key_match: MATCH SIMPLE  */
#line 4191 "preproc.y"
 { 
 (yyval.str) = mm_strdup("match simple");
}
#line 41819 "preproc.c"
    break;

  case 574: /* key_match: %empty  */
#line 4195 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41826 "preproc.c"
    break;

  case 575: /* ExclusionConstraintList: ExclusionConstraintElem  */
#line 4202 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41834 "preproc.c"
    break;

  case 576: /* ExclusionConstraintList: ExclusionConstraintList ',' ExclusionConstraintElem  */
#line 4206 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41842 "preproc.c"
    break;

  case 577: /* ExclusionConstraintElem: index_elem WITH any_operator  */
#line 4214 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 41850 "preproc.c"
    break;

  case 578: /* ExclusionConstraintElem: index_elem WITH OPERATOR '(' any_operator ')'  */
#line 4218 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("with operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41858 "preproc.c"
    break;

  case 579: /* ExclusionWhereClause: WHERE '(' a_expr ')'  */
#line 4226 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("where ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41866 "preproc.c"
    break;

  case 580: /* ExclusionWhereClause: %empty  */
#line 4230 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41873 "preproc.c"
    break;

  case 581: /* key_actions: key_update  */
#line 4237 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41881 "preproc.c"
    break;

  case 582: /* key_actions: key_delete  */
#line 4241 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41889 "preproc.c"
    break;

  case 583: /* key_actions: key_update key_delete  */
#line 4245 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41897 "preproc.c"
    break;

  case 584: /* key_actions: key_delete key_update  */
#line 4249 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41905 "preproc.c"
    break;

  case 585: /* key_actions: %empty  */
#line 4253 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41912 "preproc.c"
    break;

  case 586: /* key_update: ON UPDATE key_action  */
#line 4260 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on update"),(yyvsp[0].str));
}
#line 41920 "preproc.c"
    break;

  case 587: /* key_delete: ON DELETE_P key_action  */
#line 4268 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on delete"),(yyvsp[0].str));
}
#line 41928 "preproc.c"
    break;

  case 588: /* key_action: NO ACTION  */
#line 4276 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no action");
}
#line 41936 "preproc.c"
    break;

  case 589: /* key_action: RESTRICT  */
#line 4280 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restrict");
}
#line 41944 "preproc.c"
    break;

  case 590: /* key_action: CASCADE  */
#line 4284 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascade");
}
#line 41952 "preproc.c"
    break;

  case 591: /* key_action: SET NULL_P  */
#line 4288 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set null");
}
#line 41960 "preproc.c"
    break;

  case 592: /* key_action: SET DEFAULT  */
#line 4292 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set default");
}
#line 41968 "preproc.c"
    break;

  case 593: /* OptInherit: INHERITS '(' qualified_name_list ')'  */
#line 4300 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("inherits ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41976 "preproc.c"
    break;

  case 594: /* OptInherit: %empty  */
#line 4304 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41983 "preproc.c"
    break;

  case 595: /* OptPartitionSpec: PartitionSpec  */
#line 4311 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41991 "preproc.c"
    break;

  case 596: /* OptPartitionSpec: %empty  */
#line 4315 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41998 "preproc.c"
    break;

  case 597: /* PartitionSpec: PARTITION BY part_strategy '(' part_params ')' interval_expr  */
#line 4322 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("partition by"),(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 42006 "preproc.c"
    break;

  case 598: /* interval_expr: BEGIN_P '(' AexprConst ')' STEP '(' AexprConst ')' PARTITIONS '(' Iconst ')'  */
#line 4330 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("begin ("),(yyvsp[-9].str),mm_strdup(") step ("),(yyvsp[-5].str),mm_strdup(") partitions ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42014 "preproc.c"
    break;

  case 599: /* interval_expr: %empty  */
#line 4334 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42021 "preproc.c"
    break;

  case 600: /* part_strategy: ecpg_ident  */
#line 4341 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42029 "preproc.c"
    break;

  case 601: /* part_strategy: unreserved_keyword  */
#line 4345 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42037 "preproc.c"
    break;

  case 602: /* part_params: part_elem  */
#line 4353 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42045 "preproc.c"
    break;

  case 603: /* part_params: part_params ',' part_elem  */
#line 4357 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42053 "preproc.c"
    break;

  case 604: /* part_elem: ColId opt_collate opt_class  */
#line 4365 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42061 "preproc.c"
    break;

  case 605: /* part_elem: func_expr_windowless opt_collate opt_class  */
#line 4369 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42069 "preproc.c"
    break;

  case 606: /* part_elem: '(' a_expr ')' opt_collate opt_class  */
#line 4373 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42077 "preproc.c"
    break;

  case 607: /* OptWith: WITH reloptions  */
#line 4381 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 42085 "preproc.c"
    break;

  case 608: /* OptWith: WITH OIDS  */
#line 4385 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with oids");
}
#line 42093 "preproc.c"
    break;

  case 609: /* OptWith: WITHOUT OIDS  */
#line 4389 "preproc.y"
 { 
 (yyval.str) = mm_strdup("without oids");
}
#line 42101 "preproc.c"
    break;

  case 610: /* OptWith: %empty  */
#line 4393 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42108 "preproc.c"
    break;

  case 611: /* OnCommitOption: ON COMMIT DROP  */
#line 4400 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on commit drop");
}
#line 42116 "preproc.c"
    break;

  case 612: /* OnCommitOption: ON COMMIT DELETE_P ROWS  */
#line 4404 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on commit delete rows");
}
#line 42124 "preproc.c"
    break;

  case 613: /* OnCommitOption: ON COMMIT PRESERVE ROWS  */
#line 4408 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on commit preserve rows");
}
#line 42132 "preproc.c"
    break;

  case 614: /* OnCommitOption: %empty  */
#line 4412 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42139 "preproc.c"
    break;

  case 615: /* OptTableSpace: TABLESPACE name  */
#line 4419 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 42147 "preproc.c"
    break;

  case 616: /* OptTableSpace: %empty  */
#line 4423 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42154 "preproc.c"
    break;

  case 617: /* OptDistributeBy: OptDistributeByInternal  */
#line 4430 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42162 "preproc.c"
    break;

  case 618: /* OptDistributeBy: %empty  */
#line 4434 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42169 "preproc.c"
    break;

  case 619: /* OptDistributeType: ecpg_ident  */
#line 4441 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42177 "preproc.c"
    break;

  case 620: /* DistributeStyle: ALL  */
#line 4449 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 42185 "preproc.c"
    break;

  case 621: /* DistributeStyle: KEY  */
#line 4453 "preproc.y"
 { 
 (yyval.str) = mm_strdup("key");
}
#line 42193 "preproc.c"
    break;

  case 622: /* DistributeStyle: ecpg_ident  */
#line 4457 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42201 "preproc.c"
    break;

  case 623: /* OptDistKey: DISTKEY '(' name_list ')'  */
#line 4465 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("distkey ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42209 "preproc.c"
    break;

  case 624: /* OptDistKey: %empty  */
#line 4469 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42216 "preproc.c"
    break;

  case 625: /* OptDistributeByInternal: DISTRIBUTE BY OptDistributeType '(' name_list ')'  */
#line 4476 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("distribute by"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42224 "preproc.c"
    break;

  case 626: /* OptDistributeByInternal: DISTRIBUTE BY OptDistributeType  */
#line 4480 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("distribute by"),(yyvsp[0].str));
}
#line 42232 "preproc.c"
    break;

  case 627: /* OptDistributeByInternal: DISTRIBUTED BY '(' name_list ')'  */
#line 4484 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("distributed by ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42240 "preproc.c"
    break;

  case 628: /* OptDistributeByInternal: DISTRIBUTED RANDOMLY  */
#line 4488 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distributed randomly");
}
#line 42248 "preproc.c"
    break;

  case 629: /* OptDistributeByInternal: DISTSTYLE DistributeStyle OptDistKey  */
#line 4492 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("diststyle"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42256 "preproc.c"
    break;

  case 630: /* OptSubCluster: OptSubClusterInternal  */
#line 4500 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42264 "preproc.c"
    break;

  case 631: /* OptSubCluster: %empty  */
#line 4504 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42271 "preproc.c"
    break;

  case 632: /* OptSubClusterInternal: TO NODE pgxcnodes  */
#line 4511 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("to node"),(yyvsp[0].str));
}
#line 42279 "preproc.c"
    break;

  case 633: /* OptSubClusterInternal: TO GROUP_P pgxcgroup_name  */
#line 4515 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("to group"),(yyvsp[0].str));
}
#line 42287 "preproc.c"
    break;

  case 634: /* OptSubClusterInternal: TO GROUP_P pgxcgroup_name pgxcgroup_name  */
#line 4519 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("to group"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42295 "preproc.c"
    break;

  case 635: /* OptConsTableSpace: USING INDEX TABLESPACE name  */
#line 4527 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using index tablespace"),(yyvsp[0].str));
}
#line 42303 "preproc.c"
    break;

  case 636: /* OptConsTableSpace: USING INDEX  */
#line 4531 "preproc.y"
 { 
 (yyval.str) = mm_strdup("using index");
}
#line 42311 "preproc.c"
    break;

  case 637: /* OptConsTableSpace: %empty  */
#line 4535 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42318 "preproc.c"
    break;

  case 638: /* ExistingIndex: USING INDEX index_name  */
#line 4542 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using index"),(yyvsp[0].str));
}
#line 42326 "preproc.c"
    break;

  case 639: /* CreateStatsStmt: CREATE STATISTICS any_name opt_name_list ON expr_list FROM from_list  */
#line 4550 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create statistics"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 42334 "preproc.c"
    break;

  case 640: /* CreateStatsStmt: CREATE STATISTICS IF_P NOT EXISTS any_name opt_name_list ON expr_list FROM from_list  */
#line 4554 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create statistics if not exists"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 42342 "preproc.c"
    break;

  case 641: /* create_as_target: qualified_name opt_column_list OptWith OnCommitOption OptTableSpace OptDistributeBy OptSubCluster  */
#line 4562 "preproc.y"
 { 
 (yyval.str) = cat_str(7,(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42350 "preproc.c"
    break;

  case 642: /* opt_with_data: WITH DATA_P  */
#line 4570 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with data");
}
#line 42358 "preproc.c"
    break;

  case 643: /* opt_with_data: WITH NO DATA_P  */
#line 4574 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with no data");
}
#line 42366 "preproc.c"
    break;

  case 644: /* opt_with_data: %empty  */
#line 4578 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42373 "preproc.c"
    break;

  case 645: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW create_mv_target AS SelectStmt opt_with_data  */
#line 4585 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create"),(yyvsp[-6].str),mm_strdup("materialized view"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42381 "preproc.c"
    break;

  case 646: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW IF_P NOT EXISTS create_mv_target AS SelectStmt opt_with_data  */
#line 4589 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create"),(yyvsp[-9].str),mm_strdup("materialized view if not exists"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42389 "preproc.c"
    break;

  case 647: /* create_mv_target: qualified_name opt_column_list opt_reloptions OptTableSpace  */
#line 4597 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42397 "preproc.c"
    break;

  case 648: /* OptNoLog: UNLOGGED  */
#line 4605 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 42405 "preproc.c"
    break;

  case 649: /* OptNoLog: %empty  */
#line 4609 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42412 "preproc.c"
    break;

  case 650: /* RefreshMatViewStmt: REFRESH MATERIALIZED VIEW opt_concurrently qualified_name opt_with_data  */
#line 4616 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("refresh materialized view"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42420 "preproc.c"
    break;

  case 651: /* CreateSeqStmt: CREATE OptTemp SEQUENCE qualified_name OptSeqOptList  */
#line 4624 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create"),(yyvsp[-3].str),mm_strdup("sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42428 "preproc.c"
    break;

  case 652: /* CreateSeqStmt: CREATE OptTemp SEQUENCE IF_P NOT EXISTS qualified_name OptSeqOptList  */
#line 4628 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create"),(yyvsp[-6].str),mm_strdup("sequence if not exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42436 "preproc.c"
    break;

  case 653: /* AlterSeqStmt: ALTER SEQUENCE qualified_name SeqOptList  */
#line 4636 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42444 "preproc.c"
    break;

  case 654: /* AlterSeqStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SeqOptList  */
#line 4640 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42452 "preproc.c"
    break;

  case 655: /* OptSeqOptList: SeqOptList  */
#line 4648 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42460 "preproc.c"
    break;

  case 656: /* OptSeqOptList: %empty  */
#line 4652 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42467 "preproc.c"
    break;

  case 657: /* OptParenthesizedSeqOptList: '(' SeqOptList ')'  */
#line 4659 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42475 "preproc.c"
    break;

  case 658: /* OptParenthesizedSeqOptList: %empty  */
#line 4663 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42482 "preproc.c"
    break;

  case 659: /* SeqOptList: SeqOptElem  */
#line 4670 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42490 "preproc.c"
    break;

  case 660: /* SeqOptList: SeqOptList SeqOptElem  */
#line 4674 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42498 "preproc.c"
    break;

  case 661: /* SeqOptElem: AS SimpleTypename  */
#line 4682 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 42506 "preproc.c"
    break;

  case 662: /* SeqOptElem: CACHE NumericOnly  */
#line 4686 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cache"),(yyvsp[0].str));
}
#line 42514 "preproc.c"
    break;

  case 663: /* SeqOptElem: CYCLE  */
#line 4690 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cycle");
}
#line 42522 "preproc.c"
    break;

  case 664: /* SeqOptElem: NO CYCLE  */
#line 4694 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no cycle");
}
#line 42530 "preproc.c"
    break;

  case 665: /* SeqOptElem: INCREMENT opt_by NumericOnly  */
#line 4698 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("increment"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42538 "preproc.c"
    break;

  case 666: /* SeqOptElem: MAXVALUE NumericOnly  */
#line 4702 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("maxvalue"),(yyvsp[0].str));
}
#line 42546 "preproc.c"
    break;

  case 667: /* SeqOptElem: MINVALUE NumericOnly  */
#line 4706 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("minvalue"),(yyvsp[0].str));
}
#line 42554 "preproc.c"
    break;

  case 668: /* SeqOptElem: NO MAXVALUE  */
#line 4710 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no maxvalue");
}
#line 42562 "preproc.c"
    break;

  case 669: /* SeqOptElem: NO MINVALUE  */
#line 4714 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no minvalue");
}
#line 42570 "preproc.c"
    break;

  case 670: /* SeqOptElem: OWNED BY any_name  */
#line 4718 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("owned by"),(yyvsp[0].str));
}
#line 42578 "preproc.c"
    break;

  case 671: /* SeqOptElem: SEQUENCE NAME_P any_name  */
#line 4722 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("sequence name"),(yyvsp[0].str));
}
#line 42586 "preproc.c"
    break;

  case 672: /* SeqOptElem: START opt_with NumericOnly  */
#line 4726 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("start"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42594 "preproc.c"
    break;

  case 673: /* SeqOptElem: RESTART  */
#line 4730 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restart");
}
#line 42602 "preproc.c"
    break;

  case 674: /* SeqOptElem: RESTART opt_with NumericOnly  */
#line 4734 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("restart"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42610 "preproc.c"
    break;

  case 675: /* opt_by: BY  */
#line 4742 "preproc.y"
 { 
 (yyval.str) = mm_strdup("by");
}
#line 42618 "preproc.c"
    break;

  case 676: /* opt_by: %empty  */
#line 4746 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42625 "preproc.c"
    break;

  case 677: /* NumericOnly: ecpg_fconst  */
#line 4753 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42633 "preproc.c"
    break;

  case 678: /* NumericOnly: '+' ecpg_fconst  */
#line 4757 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 42641 "preproc.c"
    break;

  case 679: /* NumericOnly: '-' ecpg_fconst  */
#line 4761 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 42649 "preproc.c"
    break;

  case 680: /* NumericOnly: SignedIconst  */
#line 4765 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42657 "preproc.c"
    break;

  case 681: /* NumericOnly_list: NumericOnly  */
#line 4773 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42665 "preproc.c"
    break;

  case 682: /* NumericOnly_list: NumericOnly_list ',' NumericOnly  */
#line 4777 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42673 "preproc.c"
    break;

  case 683: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE NonReservedWord_or_Sconst  */
#line 4785 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 42681 "preproc.c"
    break;

  case 684: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE NonReservedWord_or_Sconst HANDLER handler_name opt_inline_handler opt_validator  */
#line 4789 "preproc.y"
 { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("language"),(yyvsp[-4].str),mm_strdup("handler"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42689 "preproc.c"
    break;

  case 685: /* opt_trusted: TRUSTED  */
#line 4797 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trusted");
}
#line 42697 "preproc.c"
    break;

  case 686: /* opt_trusted: %empty  */
#line 4801 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42704 "preproc.c"
    break;

  case 687: /* handler_name: name  */
#line 4808 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42712 "preproc.c"
    break;

  case 688: /* handler_name: name attrs  */
#line 4812 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42720 "preproc.c"
    break;

  case 689: /* opt_inline_handler: INLINE_P handler_name  */
#line 4820 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("inline"),(yyvsp[0].str));
}
#line 42728 "preproc.c"
    break;

  case 690: /* opt_inline_handler: %empty  */
#line 4824 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42735 "preproc.c"
    break;

  case 691: /* validator_clause: VALIDATOR handler_name  */
#line 4831 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("validator"),(yyvsp[0].str));
}
#line 42743 "preproc.c"
    break;

  case 692: /* validator_clause: NO VALIDATOR  */
#line 4835 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no validator");
}
#line 42751 "preproc.c"
    break;

  case 693: /* opt_validator: validator_clause  */
#line 4843 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42759 "preproc.c"
    break;

  case 694: /* opt_validator: %empty  */
#line 4847 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42766 "preproc.c"
    break;

  case 695: /* DropPLangStmt: DROP opt_procedural LANGUAGE NonReservedWord_or_Sconst opt_drop_behavior  */
#line 4854 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-3].str),mm_strdup("language"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42774 "preproc.c"
    break;

  case 696: /* DropPLangStmt: DROP opt_procedural LANGUAGE IF_P EXISTS NonReservedWord_or_Sconst opt_drop_behavior  */
#line 4858 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-5].str),mm_strdup("language if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42782 "preproc.c"
    break;

  case 697: /* opt_procedural: PROCEDURAL  */
#line 4866 "preproc.y"
 { 
 (yyval.str) = mm_strdup("procedural");
}
#line 42790 "preproc.c"
    break;

  case 698: /* opt_procedural: %empty  */
#line 4870 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42797 "preproc.c"
    break;

  case 699: /* CreateTableSpaceStmt: CREATE TABLESPACE name OptTableSpaceOwner LOCATION ecpg_sconst opt_reloptions  */
#line 4877 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create tablespace"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("location"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42805 "preproc.c"
    break;

  case 700: /* OptTableSpaceOwner: OWNER RoleSpec  */
#line 4885 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("owner"),(yyvsp[0].str));
}
#line 42813 "preproc.c"
    break;

  case 701: /* OptTableSpaceOwner: %empty  */
#line 4889 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42820 "preproc.c"
    break;

  case 702: /* DropTableSpaceStmt: DROP TABLESPACE name  */
#line 4896 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop tablespace"),(yyvsp[0].str));
}
#line 42828 "preproc.c"
    break;

  case 703: /* DropTableSpaceStmt: DROP TABLESPACE IF_P EXISTS name  */
#line 4900 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop tablespace if exists"),(yyvsp[0].str));
}
#line 42836 "preproc.c"
    break;

  case 704: /* CreateExtensionStmt: CREATE EXTENSION name opt_with create_extension_opt_list  */
#line 4908 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create extension"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42844 "preproc.c"
    break;

  case 705: /* CreateExtensionStmt: CREATE EXTENSION IF_P NOT EXISTS name opt_with create_extension_opt_list  */
#line 4912 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create extension if not exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42852 "preproc.c"
    break;

  case 706: /* CreateExtensionStmt: PREPARE CREATE EXTENSION name opt_with create_extension_opt_list  */
#line 4916 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("prepare create extension"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42860 "preproc.c"
    break;

  case 707: /* CreateExtensionStmt: PREPARE CREATE EXTENSION IF_P NOT EXISTS name opt_with create_extension_opt_list  */
#line 4920 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("prepare create extension if not exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42868 "preproc.c"
    break;

  case 708: /* CreateExtensionStmt: EXECUTE CREATE EXTENSION name opt_with create_extension_opt_list  */
#line 4924 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("execute create extension"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42876 "preproc.c"
    break;

  case 709: /* CreateExtensionStmt: EXECUTE CREATE EXTENSION IF_P NOT EXISTS name opt_with create_extension_opt_list  */
#line 4928 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("execute create extension if not exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42884 "preproc.c"
    break;

  case 710: /* create_extension_opt_list: create_extension_opt_list create_extension_opt_item  */
#line 4936 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42892 "preproc.c"
    break;

  case 711: /* create_extension_opt_list: %empty  */
#line 4940 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42899 "preproc.c"
    break;

  case 712: /* create_extension_opt_item: SCHEMA name  */
#line 4947 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 42907 "preproc.c"
    break;

  case 713: /* create_extension_opt_item: VERSION_P NonReservedWord_or_Sconst  */
#line 4951 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 42915 "preproc.c"
    break;

  case 714: /* create_extension_opt_item: FROM NonReservedWord_or_Sconst  */
#line 4955 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 42923 "preproc.c"
    break;

  case 715: /* create_extension_opt_item: CASCADE  */
#line 4959 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascade");
}
#line 42931 "preproc.c"
    break;

  case 716: /* AlterExtensionStmt: ALTER EXTENSION name UPDATE alter_extension_opt_list  */
#line 4967 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter extension"),(yyvsp[-2].str),mm_strdup("update"),(yyvsp[0].str));
}
#line 42939 "preproc.c"
    break;

  case 717: /* alter_extension_opt_list: alter_extension_opt_list alter_extension_opt_item  */
#line 4975 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42947 "preproc.c"
    break;

  case 718: /* alter_extension_opt_list: %empty  */
#line 4979 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42954 "preproc.c"
    break;

  case 719: /* alter_extension_opt_item: TO NonReservedWord_or_Sconst  */
#line 4986 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 42962 "preproc.c"
    break;

  case 720: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop ACCESS METHOD name  */
#line 4994 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("access method"),(yyvsp[0].str));
}
#line 42970 "preproc.c"
    break;

  case 721: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop AGGREGATE aggregate_with_argtypes  */
#line 4998 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("aggregate"),(yyvsp[0].str));
}
#line 42978 "preproc.c"
    break;

  case 722: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop CAST '(' Typename AS Typename ')'  */
#line 5002 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("alter extension"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("cast ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42986 "preproc.c"
    break;

  case 723: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop COLLATION any_name  */
#line 5006 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("collation"),(yyvsp[0].str));
}
#line 42994 "preproc.c"
    break;

  case 724: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop CONVERSION_P any_name  */
#line 5010 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("conversion"),(yyvsp[0].str));
}
#line 43002 "preproc.c"
    break;

  case 725: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop DOMAIN_P Typename  */
#line 5014 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("domain"),(yyvsp[0].str));
}
#line 43010 "preproc.c"
    break;

  case 726: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop FUNCTION function_with_argtypes  */
#line 5018 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("function"),(yyvsp[0].str));
}
#line 43018 "preproc.c"
    break;

  case 727: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop opt_procedural LANGUAGE name  */
#line 5022 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 43026 "preproc.c"
    break;

  case 728: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR operator_with_argtypes  */
#line 5026 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("operator"),(yyvsp[0].str));
}
#line 43034 "preproc.c"
    break;

  case 729: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR CLASS any_name USING access_method  */
#line 5030 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("operator class"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 43042 "preproc.c"
    break;

  case 730: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR FAMILY any_name USING access_method  */
#line 5034 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("operator family"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 43050 "preproc.c"
    break;

  case 731: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop SCHEMA name  */
#line 5038 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("schema"),(yyvsp[0].str));
}
#line 43058 "preproc.c"
    break;

  case 732: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop EVENT TRIGGER name  */
#line 5042 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("event trigger"),(yyvsp[0].str));
}
#line 43066 "preproc.c"
    break;

  case 733: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TABLE any_name  */
#line 5046 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("table"),(yyvsp[0].str));
}
#line 43074 "preproc.c"
    break;

  case 734: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TEXT_P SEARCH PARSER any_name  */
#line 5050 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search parser"),(yyvsp[0].str));
}
#line 43082 "preproc.c"
    break;

  case 735: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TEXT_P SEARCH DICTIONARY any_name  */
#line 5054 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search dictionary"),(yyvsp[0].str));
}
#line 43090 "preproc.c"
    break;

  case 736: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TEXT_P SEARCH TEMPLATE any_name  */
#line 5058 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search template"),(yyvsp[0].str));
}
#line 43098 "preproc.c"
    break;

  case 737: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TEXT_P SEARCH CONFIGURATION any_name  */
#line 5062 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search configuration"),(yyvsp[0].str));
}
#line 43106 "preproc.c"
    break;

  case 738: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop SEQUENCE any_name  */
#line 5066 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("sequence"),(yyvsp[0].str));
}
#line 43114 "preproc.c"
    break;

  case 739: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop VIEW any_name  */
#line 5070 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("view"),(yyvsp[0].str));
}
#line 43122 "preproc.c"
    break;

  case 740: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop MATERIALIZED VIEW any_name  */
#line 5074 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("materialized view"),(yyvsp[0].str));
}
#line 43130 "preproc.c"
    break;

  case 741: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop FOREIGN TABLE any_name  */
#line 5078 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("foreign table"),(yyvsp[0].str));
}
#line 43138 "preproc.c"
    break;

  case 742: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop FOREIGN DATA_P WRAPPER name  */
#line 5082 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("foreign data wrapper"),(yyvsp[0].str));
}
#line 43146 "preproc.c"
    break;

  case 743: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop SERVER name  */
#line 5086 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 43154 "preproc.c"
    break;

  case 744: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TRANSFORM FOR Typename LANGUAGE name  */
#line 5090 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("transform for"),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 43162 "preproc.c"
    break;

  case 745: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TYPE_P Typename  */
#line 5094 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("type"),(yyvsp[0].str));
}
#line 43170 "preproc.c"
    break;

  case 746: /* CreateFdwStmt: CREATE FOREIGN DATA_P WRAPPER name opt_fdw_options create_generic_options  */
#line 5102 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create foreign data wrapper"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43178 "preproc.c"
    break;

  case 747: /* fdw_option: HANDLER handler_name  */
#line 5110 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("handler"),(yyvsp[0].str));
}
#line 43186 "preproc.c"
    break;

  case 748: /* fdw_option: NO HANDLER  */
#line 5114 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no handler");
}
#line 43194 "preproc.c"
    break;

  case 749: /* fdw_option: VALIDATOR handler_name  */
#line 5118 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("validator"),(yyvsp[0].str));
}
#line 43202 "preproc.c"
    break;

  case 750: /* fdw_option: NO VALIDATOR  */
#line 5122 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no validator");
}
#line 43210 "preproc.c"
    break;

  case 751: /* fdw_options: fdw_option  */
#line 5130 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43218 "preproc.c"
    break;

  case 752: /* fdw_options: fdw_options fdw_option  */
#line 5134 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43226 "preproc.c"
    break;

  case 753: /* opt_fdw_options: fdw_options  */
#line 5142 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43234 "preproc.c"
    break;

  case 754: /* opt_fdw_options: %empty  */
#line 5146 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43241 "preproc.c"
    break;

  case 755: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name opt_fdw_options alter_generic_options  */
#line 5153 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43249 "preproc.c"
    break;

  case 756: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name fdw_options  */
#line 5157 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43257 "preproc.c"
    break;

  case 757: /* create_generic_options: OPTIONS '(' generic_option_list ')'  */
#line 5165 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("options ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43265 "preproc.c"
    break;

  case 758: /* create_generic_options: %empty  */
#line 5169 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43272 "preproc.c"
    break;

  case 759: /* generic_option_list: generic_option_elem  */
#line 5176 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43280 "preproc.c"
    break;

  case 760: /* generic_option_list: generic_option_list ',' generic_option_elem  */
#line 5180 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43288 "preproc.c"
    break;

  case 761: /* alter_generic_options: OPTIONS '(' alter_generic_option_list ')'  */
#line 5188 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("options ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43296 "preproc.c"
    break;

  case 762: /* alter_generic_option_list: alter_generic_option_elem  */
#line 5196 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43304 "preproc.c"
    break;

  case 763: /* alter_generic_option_list: alter_generic_option_list ',' alter_generic_option_elem  */
#line 5200 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43312 "preproc.c"
    break;

  case 764: /* alter_generic_option_elem: generic_option_elem  */
#line 5208 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43320 "preproc.c"
    break;

  case 765: /* alter_generic_option_elem: SET generic_option_elem  */
#line 5212 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 43328 "preproc.c"
    break;

  case 766: /* alter_generic_option_elem: ADD_P generic_option_elem  */
#line 5216 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 43336 "preproc.c"
    break;

  case 767: /* alter_generic_option_elem: DROP generic_option_name  */
#line 5220 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop"),(yyvsp[0].str));
}
#line 43344 "preproc.c"
    break;

  case 768: /* generic_option_elem: generic_option_name generic_option_arg  */
#line 5228 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43352 "preproc.c"
    break;

  case 769: /* generic_option_name: ColLabel  */
#line 5236 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43360 "preproc.c"
    break;

  case 770: /* generic_option_arg: ecpg_sconst  */
#line 5244 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43368 "preproc.c"
    break;

  case 771: /* CreateForeignServerStmt: CREATE SERVER name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 5252 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create server"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43376 "preproc.c"
    break;

  case 772: /* CreateForeignServerStmt: CREATE SERVER IF_P NOT EXISTS name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 5256 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create server if not exists"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43384 "preproc.c"
    break;

  case 773: /* opt_type: TYPE_P ecpg_sconst  */
#line 5264 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("type"),(yyvsp[0].str));
}
#line 43392 "preproc.c"
    break;

  case 774: /* opt_type: %empty  */
#line 5268 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43399 "preproc.c"
    break;

  case 775: /* foreign_server_version: VERSION_P ecpg_sconst  */
#line 5275 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 43407 "preproc.c"
    break;

  case 776: /* foreign_server_version: VERSION_P NULL_P  */
#line 5279 "preproc.y"
 { 
 (yyval.str) = mm_strdup("version null");
}
#line 43415 "preproc.c"
    break;

  case 777: /* opt_foreign_server_version: foreign_server_version  */
#line 5287 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43423 "preproc.c"
    break;

  case 778: /* opt_foreign_server_version: %empty  */
#line 5291 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43430 "preproc.c"
    break;

  case 779: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version alter_generic_options  */
#line 5298 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43438 "preproc.c"
    break;

  case 780: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version  */
#line 5302 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43446 "preproc.c"
    break;

  case 781: /* AlterForeignServerStmt: ALTER SERVER name alter_generic_options  */
#line 5306 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43454 "preproc.c"
    break;

  case 782: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 5314 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43462 "preproc.c"
    break;

  case 783: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 5318 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table if not exists"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43470 "preproc.c"
    break;

  case 784: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec SERVER name create_generic_options  */
#line 5322 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table"),(yyvsp[-8].str),mm_strdup("partition of"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43478 "preproc.c"
    break;

  case 785: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec SERVER name create_generic_options  */
#line 5326 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table if not exists"),(yyvsp[-8].str),mm_strdup("partition of"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43486 "preproc.c"
    break;

  case 786: /* AlterForeignTableStmt: ALTER FOREIGN TABLE relation_expr alter_table_cmds  */
#line 5334 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43494 "preproc.c"
    break;

  case 787: /* AlterForeignTableStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 5338 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43502 "preproc.c"
    break;

  case 788: /* ImportForeignSchemaStmt: IMPORT_P FOREIGN SCHEMA name import_qualification FROM SERVER name INTO name create_generic_options  */
#line 5346 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("import foreign schema"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("from server"),(yyvsp[-3].str),mm_strdup("into"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43510 "preproc.c"
    break;

  case 789: /* import_qualification_type: LIMIT TO  */
#line 5354 "preproc.y"
 { 
 (yyval.str) = mm_strdup("limit to");
}
#line 43518 "preproc.c"
    break;

  case 790: /* import_qualification_type: EXCEPT  */
#line 5358 "preproc.y"
 { 
 (yyval.str) = mm_strdup("except");
}
#line 43526 "preproc.c"
    break;

  case 791: /* import_qualification: import_qualification_type '(' relation_expr_list ')'  */
#line 5366 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43534 "preproc.c"
    break;

  case 792: /* import_qualification: %empty  */
#line 5370 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43541 "preproc.c"
    break;

  case 793: /* CreateUserMappingStmt: CREATE USER MAPPING FOR auth_ident SERVER name create_generic_options  */
#line 5377 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create user mapping for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43549 "preproc.c"
    break;

  case 794: /* CreateUserMappingStmt: CREATE USER MAPPING IF_P NOT EXISTS FOR auth_ident SERVER name create_generic_options  */
#line 5381 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create user mapping if not exists for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43557 "preproc.c"
    break;

  case 795: /* auth_ident: RoleSpec  */
#line 5389 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43565 "preproc.c"
    break;

  case 796: /* auth_ident: USER  */
#line 5393 "preproc.y"
 { 
 (yyval.str) = mm_strdup("user");
}
#line 43573 "preproc.c"
    break;

  case 797: /* DropUserMappingStmt: DROP USER MAPPING FOR auth_ident SERVER name  */
#line 5401 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop user mapping for"),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 43581 "preproc.c"
    break;

  case 798: /* DropUserMappingStmt: DROP USER MAPPING IF_P EXISTS FOR auth_ident SERVER name  */
#line 5405 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop user mapping if exists for"),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 43589 "preproc.c"
    break;

  case 799: /* AlterUserMappingStmt: ALTER USER MAPPING FOR auth_ident SERVER name alter_generic_options  */
#line 5413 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter user mapping for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43597 "preproc.c"
    break;

  case 800: /* CreatePolicyStmt: CREATE POLICY name ON qualified_name RowSecurityDefaultPermissive RowSecurityDefaultForCmd RowSecurityDefaultToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5421 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create policy"),(yyvsp[-7].str),mm_strdup("on"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43605 "preproc.c"
    break;

  case 801: /* AlterPolicyStmt: ALTER POLICY name ON qualified_name RowSecurityOptionalToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5429 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter policy"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43613 "preproc.c"
    break;

  case 802: /* RowSecurityOptionalExpr: USING '(' a_expr ')'  */
#line 5437 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("using ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43621 "preproc.c"
    break;

  case 803: /* RowSecurityOptionalExpr: %empty  */
#line 5441 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43628 "preproc.c"
    break;

  case 804: /* RowSecurityOptionalWithCheck: WITH CHECK '(' a_expr ')'  */
#line 5448 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("with check ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43636 "preproc.c"
    break;

  case 805: /* RowSecurityOptionalWithCheck: %empty  */
#line 5452 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43643 "preproc.c"
    break;

  case 806: /* RowSecurityDefaultToRole: TO role_list  */
#line 5459 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 43651 "preproc.c"
    break;

  case 807: /* RowSecurityDefaultToRole: %empty  */
#line 5463 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43658 "preproc.c"
    break;

  case 808: /* RowSecurityOptionalToRole: TO role_list  */
#line 5470 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 43666 "preproc.c"
    break;

  case 809: /* RowSecurityOptionalToRole: %empty  */
#line 5474 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43673 "preproc.c"
    break;

  case 810: /* RowSecurityDefaultPermissive: AS ecpg_ident  */
#line 5481 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 43681 "preproc.c"
    break;

  case 811: /* RowSecurityDefaultPermissive: %empty  */
#line 5485 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43688 "preproc.c"
    break;

  case 812: /* RowSecurityDefaultForCmd: FOR row_security_cmd  */
#line 5492 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 43696 "preproc.c"
    break;

  case 813: /* RowSecurityDefaultForCmd: %empty  */
#line 5496 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43703 "preproc.c"
    break;

  case 814: /* row_security_cmd: ALL  */
#line 5503 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 43711 "preproc.c"
    break;

  case 815: /* row_security_cmd: SELECT  */
#line 5507 "preproc.y"
 { 
 (yyval.str) = mm_strdup("select");
}
#line 43719 "preproc.c"
    break;

  case 816: /* row_security_cmd: INSERT  */
#line 5511 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert");
}
#line 43727 "preproc.c"
    break;

  case 817: /* row_security_cmd: UPDATE  */
#line 5515 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update");
}
#line 43735 "preproc.c"
    break;

  case 818: /* row_security_cmd: DELETE_P  */
#line 5519 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete");
}
#line 43743 "preproc.c"
    break;

  case 819: /* CreateAmStmt: CREATE ACCESS METHOD name TYPE_P INDEX HANDLER handler_name  */
#line 5527 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create access method"),(yyvsp[-4].str),mm_strdup("type index handler"),(yyvsp[0].str));
}
#line 43751 "preproc.c"
    break;

  case 820: /* CreateTrigStmt: CREATE TRIGGER name TriggerActionTime TriggerEvents ON qualified_name TriggerReferencing TriggerForSpec TriggerWhen EXECUTE PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 5535 "preproc.y"
 { 
 (yyval.str) = cat_str(14,mm_strdup("create trigger"),(yyvsp[-13].str),(yyvsp[-12].str),(yyvsp[-11].str),mm_strdup("on"),(yyvsp[-9].str),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("execute procedure"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43759 "preproc.c"
    break;

  case 821: /* CreateTrigStmt: CREATE CONSTRAINT TRIGGER name AFTER TriggerEvents ON qualified_name OptConstrFromTable ConstraintAttributeSpec FOR EACH ROW TriggerWhen EXECUTE PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 5539 "preproc.y"
 { 
 (yyval.str) = cat_str(15,mm_strdup("create constraint trigger"),(yyvsp[-16].str),mm_strdup("after"),(yyvsp[-14].str),mm_strdup("on"),(yyvsp[-12].str),(yyvsp[-11].str),(yyvsp[-10].str),mm_strdup("for each row"),(yyvsp[-6].str),mm_strdup("execute procedure"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43767 "preproc.c"
    break;

  case 822: /* TriggerActionTime: BEFORE  */
#line 5547 "preproc.y"
 { 
 (yyval.str) = mm_strdup("before");
}
#line 43775 "preproc.c"
    break;

  case 823: /* TriggerActionTime: AFTER  */
#line 5551 "preproc.y"
 { 
 (yyval.str) = mm_strdup("after");
}
#line 43783 "preproc.c"
    break;

  case 824: /* TriggerActionTime: INSTEAD OF  */
#line 5555 "preproc.y"
 { 
 (yyval.str) = mm_strdup("instead of");
}
#line 43791 "preproc.c"
    break;

  case 825: /* TriggerEvents: TriggerOneEvent  */
#line 5563 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43799 "preproc.c"
    break;

  case 826: /* TriggerEvents: TriggerEvents OR TriggerOneEvent  */
#line 5567 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("or"),(yyvsp[0].str));
}
#line 43807 "preproc.c"
    break;

  case 827: /* TriggerOneEvent: INSERT  */
#line 5575 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert");
}
#line 43815 "preproc.c"
    break;

  case 828: /* TriggerOneEvent: DELETE_P  */
#line 5579 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete");
}
#line 43823 "preproc.c"
    break;

  case 829: /* TriggerOneEvent: UPDATE  */
#line 5583 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update");
}
#line 43831 "preproc.c"
    break;

  case 830: /* TriggerOneEvent: UPDATE OF columnList  */
#line 5587 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("update of"),(yyvsp[0].str));
}
#line 43839 "preproc.c"
    break;

  case 831: /* TriggerOneEvent: TRUNCATE  */
#line 5591 "preproc.y"
 { 
 (yyval.str) = mm_strdup("truncate");
}
#line 43847 "preproc.c"
    break;

  case 832: /* TriggerReferencing: REFERENCING TriggerTransitions  */
#line 5599 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("referencing"),(yyvsp[0].str));
}
#line 43855 "preproc.c"
    break;

  case 833: /* TriggerReferencing: %empty  */
#line 5603 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43862 "preproc.c"
    break;

  case 834: /* TriggerTransitions: TriggerTransition  */
#line 5610 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43870 "preproc.c"
    break;

  case 835: /* TriggerTransitions: TriggerTransitions TriggerTransition  */
#line 5614 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43878 "preproc.c"
    break;

  case 836: /* TriggerTransition: TransitionOldOrNew TransitionRowOrTable opt_as TransitionRelName  */
#line 5622 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43886 "preproc.c"
    break;

  case 837: /* TransitionOldOrNew: NEW  */
#line 5630 "preproc.y"
 { 
 (yyval.str) = mm_strdup("new");
}
#line 43894 "preproc.c"
    break;

  case 838: /* TransitionOldOrNew: OLD  */
#line 5634 "preproc.y"
 { 
 (yyval.str) = mm_strdup("old");
}
#line 43902 "preproc.c"
    break;

  case 839: /* TransitionRowOrTable: TABLE  */
#line 5642 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 43910 "preproc.c"
    break;

  case 840: /* TransitionRowOrTable: ROW  */
#line 5646 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row");
}
#line 43918 "preproc.c"
    break;

  case 841: /* TransitionRelName: ColId  */
#line 5654 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43926 "preproc.c"
    break;

  case 842: /* TriggerForSpec: FOR TriggerForOptEach TriggerForType  */
#line 5662 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("for"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43934 "preproc.c"
    break;

  case 843: /* TriggerForSpec: %empty  */
#line 5666 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43941 "preproc.c"
    break;

  case 844: /* TriggerForOptEach: EACH  */
#line 5673 "preproc.y"
 { 
 (yyval.str) = mm_strdup("each");
}
#line 43949 "preproc.c"
    break;

  case 845: /* TriggerForOptEach: %empty  */
#line 5677 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43956 "preproc.c"
    break;

  case 846: /* TriggerForType: ROW  */
#line 5684 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row");
}
#line 43964 "preproc.c"
    break;

  case 847: /* TriggerForType: STATEMENT  */
#line 5688 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statement");
}
#line 43972 "preproc.c"
    break;

  case 848: /* TriggerWhen: WHEN '(' a_expr ')'  */
#line 5696 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("when ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43980 "preproc.c"
    break;

  case 849: /* TriggerWhen: %empty  */
#line 5700 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43987 "preproc.c"
    break;

  case 850: /* TriggerFuncArgs: TriggerFuncArg  */
#line 5707 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43995 "preproc.c"
    break;

  case 851: /* TriggerFuncArgs: TriggerFuncArgs ',' TriggerFuncArg  */
#line 5711 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44003 "preproc.c"
    break;

  case 852: /* TriggerFuncArgs: %empty  */
#line 5715 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44010 "preproc.c"
    break;

  case 853: /* TriggerFuncArg: Iconst  */
#line 5722 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44018 "preproc.c"
    break;

  case 854: /* TriggerFuncArg: ecpg_fconst  */
#line 5726 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44026 "preproc.c"
    break;

  case 855: /* TriggerFuncArg: ecpg_sconst  */
#line 5730 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44034 "preproc.c"
    break;

  case 856: /* TriggerFuncArg: ColLabel  */
#line 5734 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44042 "preproc.c"
    break;

  case 857: /* OptConstrFromTable: FROM qualified_name  */
#line 5742 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 44050 "preproc.c"
    break;

  case 858: /* OptConstrFromTable: %empty  */
#line 5746 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44057 "preproc.c"
    break;

  case 859: /* ConstraintAttributeSpec: %empty  */
#line 5753 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44064 "preproc.c"
    break;

  case 860: /* ConstraintAttributeSpec: ConstraintAttributeSpec ConstraintAttributeElem  */
#line 5756 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44072 "preproc.c"
    break;

  case 861: /* ConstraintAttributeElem: NOT DEFERRABLE  */
#line 5764 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 44080 "preproc.c"
    break;

  case 862: /* ConstraintAttributeElem: DEFERRABLE  */
#line 5768 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 44088 "preproc.c"
    break;

  case 863: /* ConstraintAttributeElem: INITIALLY IMMEDIATE  */
#line 5772 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially immediate");
}
#line 44096 "preproc.c"
    break;

  case 864: /* ConstraintAttributeElem: INITIALLY DEFERRED  */
#line 5776 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially deferred");
}
#line 44104 "preproc.c"
    break;

  case 865: /* ConstraintAttributeElem: NOT VALID  */
#line 5780 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not valid");
}
#line 44112 "preproc.c"
    break;

  case 866: /* ConstraintAttributeElem: NO INHERIT  */
#line 5784 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no inherit");
}
#line 44120 "preproc.c"
    break;

  case 867: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel EXECUTE PROCEDURE func_name '(' ')'  */
#line 5792 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create event trigger"),(yyvsp[-7].str),mm_strdup("on"),(yyvsp[-5].str),mm_strdup("execute procedure"),(yyvsp[-2].str),mm_strdup("( )"));
}
#line 44128 "preproc.c"
    break;

  case 868: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel WHEN event_trigger_when_list EXECUTE PROCEDURE func_name '(' ')'  */
#line 5796 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create event trigger"),(yyvsp[-9].str),mm_strdup("on"),(yyvsp[-7].str),mm_strdup("when"),(yyvsp[-5].str),mm_strdup("execute procedure"),(yyvsp[-2].str),mm_strdup("( )"));
}
#line 44136 "preproc.c"
    break;

  case 869: /* event_trigger_when_list: event_trigger_when_item  */
#line 5804 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44144 "preproc.c"
    break;

  case 870: /* event_trigger_when_list: event_trigger_when_list AND event_trigger_when_item  */
#line 5808 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 44152 "preproc.c"
    break;

  case 871: /* event_trigger_when_item: ColId IN_P '(' event_trigger_value_list ')'  */
#line 5816 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("in ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44160 "preproc.c"
    break;

  case 872: /* event_trigger_value_list: SCONST  */
#line 5824 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sconst");
}
#line 44168 "preproc.c"
    break;

  case 873: /* event_trigger_value_list: event_trigger_value_list ',' SCONST  */
#line 5828 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup(", sconst"));
}
#line 44176 "preproc.c"
    break;

  case 874: /* AlterEventTrigStmt: ALTER EVENT TRIGGER name enable_trigger  */
#line 5836 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter event trigger"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44184 "preproc.c"
    break;

  case 875: /* enable_trigger: ENABLE_P  */
#line 5844 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable");
}
#line 44192 "preproc.c"
    break;

  case 876: /* enable_trigger: ENABLE_P REPLICA  */
#line 5848 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable replica");
}
#line 44200 "preproc.c"
    break;

  case 877: /* enable_trigger: ENABLE_P ALWAYS  */
#line 5852 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable always");
}
#line 44208 "preproc.c"
    break;

  case 878: /* enable_trigger: DISABLE_P  */
#line 5856 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable");
}
#line 44216 "preproc.c"
    break;

  case 879: /* CreateAssertStmt: CREATE ASSERTION name CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 5864 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(6,mm_strdup("create assertion"),(yyvsp[-5].str),mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 44225 "preproc.c"
    break;

  case 880: /* DropAssertStmt: DROP ASSERTION name opt_drop_behavior  */
#line 5873 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,mm_strdup("drop assertion"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44234 "preproc.c"
    break;

  case 881: /* DefineStmt: CREATE AGGREGATE func_name aggr_args definition  */
#line 5882 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create aggregate"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44242 "preproc.c"
    break;

  case 882: /* DefineStmt: CREATE AGGREGATE func_name old_aggr_definition  */
#line 5886 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create aggregate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44250 "preproc.c"
    break;

  case 883: /* DefineStmt: CREATE OPERATOR any_operator definition  */
#line 5890 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create operator"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44258 "preproc.c"
    break;

  case 884: /* DefineStmt: CREATE TYPE_P any_name definition  */
#line 5894 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44266 "preproc.c"
    break;

  case 885: /* DefineStmt: CREATE TYPE_P any_name  */
#line 5898 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("create type"),(yyvsp[0].str));
}
#line 44274 "preproc.c"
    break;

  case 886: /* DefineStmt: CREATE TYPE_P any_name AS '(' OptTableFuncElementList ')'  */
#line 5902 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create type"),(yyvsp[-4].str),mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44282 "preproc.c"
    break;

  case 887: /* DefineStmt: CREATE TYPE_P any_name AS ENUM_P '(' opt_enum_val_list ')'  */
#line 5906 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create type"),(yyvsp[-5].str),mm_strdup("as enum ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44290 "preproc.c"
    break;

  case 888: /* DefineStmt: CREATE TYPE_P any_name AS RANGE definition  */
#line 5910 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create type"),(yyvsp[-3].str),mm_strdup("as range"),(yyvsp[0].str));
}
#line 44298 "preproc.c"
    break;

  case 889: /* DefineStmt: CREATE TEXT_P SEARCH PARSER any_name definition  */
#line 5914 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create text search parser"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44306 "preproc.c"
    break;

  case 890: /* DefineStmt: CREATE TEXT_P SEARCH DICTIONARY any_name definition  */
#line 5918 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create text search dictionary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44314 "preproc.c"
    break;

  case 891: /* DefineStmt: CREATE TEXT_P SEARCH TEMPLATE any_name definition  */
#line 5922 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create text search template"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44322 "preproc.c"
    break;

  case 892: /* DefineStmt: CREATE TEXT_P SEARCH CONFIGURATION any_name definition  */
#line 5926 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create text search configuration"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44330 "preproc.c"
    break;

  case 893: /* DefineStmt: CREATE COLLATION any_name definition  */
#line 5930 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create collation"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44338 "preproc.c"
    break;

  case 894: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name definition  */
#line 5934 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create collation if not exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44346 "preproc.c"
    break;

  case 895: /* DefineStmt: CREATE COLLATION any_name FROM any_name  */
#line 5938 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create collation"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 44354 "preproc.c"
    break;

  case 896: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name FROM any_name  */
#line 5942 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create collation if not exists"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 44362 "preproc.c"
    break;

  case 897: /* definition: '(' def_list ')'  */
#line 5950 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44370 "preproc.c"
    break;

  case 898: /* def_list: def_elem  */
#line 5958 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44378 "preproc.c"
    break;

  case 899: /* def_list: def_list ',' def_elem  */
#line 5962 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44386 "preproc.c"
    break;

  case 900: /* def_elem: ColLabel '=' def_arg  */
#line 5970 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 44394 "preproc.c"
    break;

  case 901: /* def_elem: ColLabel  */
#line 5974 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44402 "preproc.c"
    break;

  case 902: /* def_arg: func_type  */
#line 5982 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44410 "preproc.c"
    break;

  case 903: /* def_arg: reserved_keyword  */
#line 5986 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44418 "preproc.c"
    break;

  case 904: /* def_arg: qual_all_Op  */
#line 5990 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44426 "preproc.c"
    break;

  case 905: /* def_arg: NumericOnly  */
#line 5994 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44434 "preproc.c"
    break;

  case 906: /* def_arg: ecpg_sconst  */
#line 5998 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44442 "preproc.c"
    break;

  case 907: /* def_arg: NONE  */
#line 6002 "preproc.y"
 { 
 (yyval.str) = mm_strdup("none");
}
#line 44450 "preproc.c"
    break;

  case 908: /* old_aggr_definition: '(' old_aggr_list ')'  */
#line 6010 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44458 "preproc.c"
    break;

  case 909: /* old_aggr_list: old_aggr_elem  */
#line 6018 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44466 "preproc.c"
    break;

  case 910: /* old_aggr_list: old_aggr_list ',' old_aggr_elem  */
#line 6022 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44474 "preproc.c"
    break;

  case 911: /* old_aggr_elem: ecpg_ident '=' def_arg  */
#line 6030 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 44482 "preproc.c"
    break;

  case 912: /* opt_enum_val_list: enum_val_list  */
#line 6038 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44490 "preproc.c"
    break;

  case 913: /* opt_enum_val_list: %empty  */
#line 6042 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44497 "preproc.c"
    break;

  case 914: /* enum_val_list: ecpg_sconst  */
#line 6049 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44505 "preproc.c"
    break;

  case 915: /* enum_val_list: enum_val_list ',' ecpg_sconst  */
#line 6053 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44513 "preproc.c"
    break;

  case 916: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists ecpg_sconst  */
#line 6061 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter type"),(yyvsp[-4].str),mm_strdup("add value"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44521 "preproc.c"
    break;

  case 917: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists ecpg_sconst BEFORE ecpg_sconst  */
#line 6065 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("add value"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("before"),(yyvsp[0].str));
}
#line 44529 "preproc.c"
    break;

  case 918: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists ecpg_sconst AFTER ecpg_sconst  */
#line 6069 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("add value"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("after"),(yyvsp[0].str));
}
#line 44537 "preproc.c"
    break;

  case 919: /* AlterEnumStmt: ALTER TYPE_P any_name RENAME VALUE_P ecpg_sconst TO ecpg_sconst  */
#line 6073 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter type"),(yyvsp[-5].str),mm_strdup("rename value"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 44545 "preproc.c"
    break;

  case 920: /* opt_if_not_exists: IF_P NOT EXISTS  */
#line 6081 "preproc.y"
 { 
 (yyval.str) = mm_strdup("if not exists");
}
#line 44553 "preproc.c"
    break;

  case 921: /* opt_if_not_exists: %empty  */
#line 6085 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44560 "preproc.c"
    break;

  case 922: /* CreateOpClassStmt: CREATE OPERATOR CLASS any_name opt_default FOR TYPE_P Typename USING access_method opt_opfamily AS opclass_item_list  */
#line 6092 "preproc.y"
 { 
 (yyval.str) = cat_str(10,mm_strdup("create operator class"),(yyvsp[-9].str),(yyvsp[-8].str),mm_strdup("for type"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 44568 "preproc.c"
    break;

  case 923: /* opclass_item_list: opclass_item  */
#line 6100 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44576 "preproc.c"
    break;

  case 924: /* opclass_item_list: opclass_item_list ',' opclass_item  */
#line 6104 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44584 "preproc.c"
    break;

  case 925: /* opclass_item: OPERATOR Iconst any_operator opclass_purpose opt_recheck  */
#line 6112 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44592 "preproc.c"
    break;

  case 926: /* opclass_item: OPERATOR Iconst operator_with_argtypes opclass_purpose opt_recheck  */
#line 6116 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44600 "preproc.c"
    break;

  case 927: /* opclass_item: FUNCTION Iconst function_with_argtypes  */
#line 6120 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("function"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44608 "preproc.c"
    break;

  case 928: /* opclass_item: FUNCTION Iconst '(' type_list ')' function_with_argtypes  */
#line 6124 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("function"),(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 44616 "preproc.c"
    break;

  case 929: /* opclass_item: STORAGE Typename  */
#line 6128 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("storage"),(yyvsp[0].str));
}
#line 44624 "preproc.c"
    break;

  case 930: /* opt_default: DEFAULT  */
#line 6136 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 44632 "preproc.c"
    break;

  case 931: /* opt_default: %empty  */
#line 6140 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44639 "preproc.c"
    break;

  case 932: /* opt_opfamily: FAMILY any_name  */
#line 6147 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("family"),(yyvsp[0].str));
}
#line 44647 "preproc.c"
    break;

  case 933: /* opt_opfamily: %empty  */
#line 6151 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44654 "preproc.c"
    break;

  case 934: /* opclass_purpose: FOR SEARCH  */
#line 6158 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for search");
}
#line 44662 "preproc.c"
    break;

  case 935: /* opclass_purpose: FOR ORDER BY any_name  */
#line 6162 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for order by"),(yyvsp[0].str));
}
#line 44670 "preproc.c"
    break;

  case 936: /* opclass_purpose: %empty  */
#line 6166 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44677 "preproc.c"
    break;

  case 937: /* opt_recheck: RECHECK  */
#line 6173 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = mm_strdup("recheck");
}
#line 44686 "preproc.c"
    break;

  case 938: /* opt_recheck: %empty  */
#line 6178 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44693 "preproc.c"
    break;

  case 939: /* CreateOpFamilyStmt: CREATE OPERATOR FAMILY any_name USING access_method  */
#line 6185 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create operator family"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 44701 "preproc.c"
    break;

  case 940: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING access_method ADD_P opclass_item_list  */
#line 6193 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("add"),(yyvsp[0].str));
}
#line 44709 "preproc.c"
    break;

  case 941: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING access_method DROP opclass_drop_list  */
#line 6197 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("drop"),(yyvsp[0].str));
}
#line 44717 "preproc.c"
    break;

  case 942: /* opclass_drop_list: opclass_drop  */
#line 6205 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44725 "preproc.c"
    break;

  case 943: /* opclass_drop_list: opclass_drop_list ',' opclass_drop  */
#line 6209 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44733 "preproc.c"
    break;

  case 944: /* opclass_drop: OPERATOR Iconst '(' type_list ')'  */
#line 6217 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44741 "preproc.c"
    break;

  case 945: /* opclass_drop: FUNCTION Iconst '(' type_list ')'  */
#line 6221 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("function"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44749 "preproc.c"
    break;

  case 946: /* DropOpClassStmt: DROP OPERATOR CLASS any_name USING access_method opt_drop_behavior  */
#line 6229 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator class"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44757 "preproc.c"
    break;

  case 947: /* DropOpClassStmt: DROP OPERATOR CLASS IF_P EXISTS any_name USING access_method opt_drop_behavior  */
#line 6233 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator class if exists"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44765 "preproc.c"
    break;

  case 948: /* DropOpFamilyStmt: DROP OPERATOR FAMILY any_name USING access_method opt_drop_behavior  */
#line 6241 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator family"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44773 "preproc.c"
    break;

  case 949: /* DropOpFamilyStmt: DROP OPERATOR FAMILY IF_P EXISTS any_name USING access_method opt_drop_behavior  */
#line 6245 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator family if exists"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44781 "preproc.c"
    break;

  case 950: /* DropOwnedStmt: DROP OWNED BY role_list opt_drop_behavior  */
#line 6253 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop owned by"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44789 "preproc.c"
    break;

  case 951: /* ReassignOwnedStmt: REASSIGN OWNED BY role_list TO RoleSpec  */
#line 6261 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("reassign owned by"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 44797 "preproc.c"
    break;

  case 952: /* DropStmt: DROP drop_type_any_name IF_P EXISTS any_name_list opt_drop_behavior  */
#line 6269 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44805 "preproc.c"
    break;

  case 953: /* DropStmt: DROP drop_type_any_name any_name_list opt_drop_behavior  */
#line 6273 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44813 "preproc.c"
    break;

  case 954: /* DropStmt: DROP drop_type_name IF_P EXISTS name_list opt_drop_behavior  */
#line 6277 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44821 "preproc.c"
    break;

  case 955: /* DropStmt: DROP drop_type_name name_list opt_drop_behavior  */
#line 6281 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44829 "preproc.c"
    break;

  case 956: /* DropStmt: DROP drop_type_name_on_any_name name ON any_name opt_drop_behavior  */
#line 6285 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("drop"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44837 "preproc.c"
    break;

  case 957: /* DropStmt: DROP drop_type_name_on_any_name IF_P EXISTS name ON any_name opt_drop_behavior  */
#line 6289 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("drop"),(yyvsp[-6].str),mm_strdup("if exists"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44845 "preproc.c"
    break;

  case 958: /* DropStmt: DROP TYPE_P type_name_list opt_drop_behavior  */
#line 6293 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44853 "preproc.c"
    break;

  case 959: /* DropStmt: DROP TYPE_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 6297 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop type if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44861 "preproc.c"
    break;

  case 960: /* DropStmt: DROP DOMAIN_P type_name_list opt_drop_behavior  */
#line 6301 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop domain"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44869 "preproc.c"
    break;

  case 961: /* DropStmt: DROP DOMAIN_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 6305 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop domain if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44877 "preproc.c"
    break;

  case 962: /* DropStmt: DROP INDEX CONCURRENTLY any_name_list opt_drop_behavior  */
#line 6309 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop index concurrently"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44885 "preproc.c"
    break;

  case 963: /* DropStmt: DROP INDEX CONCURRENTLY IF_P EXISTS any_name_list opt_drop_behavior  */
#line 6313 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop index concurrently if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44893 "preproc.c"
    break;

  case 964: /* drop_type_any_name: TABLE  */
#line 6321 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 44901 "preproc.c"
    break;

  case 965: /* drop_type_any_name: SEQUENCE  */
#line 6325 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 44909 "preproc.c"
    break;

  case 966: /* drop_type_any_name: VIEW  */
#line 6329 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 44917 "preproc.c"
    break;

  case 967: /* drop_type_any_name: MATERIALIZED VIEW  */
#line 6333 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 44925 "preproc.c"
    break;

  case 968: /* drop_type_any_name: INDEX  */
#line 6337 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 44933 "preproc.c"
    break;

  case 969: /* drop_type_any_name: FOREIGN TABLE  */
#line 6341 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 44941 "preproc.c"
    break;

  case 970: /* drop_type_any_name: COLLATION  */
#line 6345 "preproc.y"
 { 
 (yyval.str) = mm_strdup("collation");
}
#line 44949 "preproc.c"
    break;

  case 971: /* drop_type_any_name: CONVERSION_P  */
#line 6349 "preproc.y"
 { 
 (yyval.str) = mm_strdup("conversion");
}
#line 44957 "preproc.c"
    break;

  case 972: /* drop_type_any_name: STATISTICS  */
#line 6353 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statistics");
}
#line 44965 "preproc.c"
    break;

  case 973: /* drop_type_any_name: TEXT_P SEARCH PARSER  */
#line 6357 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search parser");
}
#line 44973 "preproc.c"
    break;

  case 974: /* drop_type_any_name: TEXT_P SEARCH DICTIONARY  */
#line 6361 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search dictionary");
}
#line 44981 "preproc.c"
    break;

  case 975: /* drop_type_any_name: TEXT_P SEARCH TEMPLATE  */
#line 6365 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search template");
}
#line 44989 "preproc.c"
    break;

  case 976: /* drop_type_any_name: TEXT_P SEARCH CONFIGURATION  */
#line 6369 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search configuration");
}
#line 44997 "preproc.c"
    break;

  case 977: /* drop_type_name: ACCESS METHOD  */
#line 6377 "preproc.y"
 { 
 (yyval.str) = mm_strdup("access method");
}
#line 45005 "preproc.c"
    break;

  case 978: /* drop_type_name: EVENT TRIGGER  */
#line 6381 "preproc.y"
 { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 45013 "preproc.c"
    break;

  case 979: /* drop_type_name: EXTENSION  */
#line 6385 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extension");
}
#line 45021 "preproc.c"
    break;

  case 980: /* drop_type_name: FOREIGN DATA_P WRAPPER  */
#line 6389 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign data wrapper");
}
#line 45029 "preproc.c"
    break;

  case 981: /* drop_type_name: PUBLICATION  */
#line 6393 "preproc.y"
 { 
 (yyval.str) = mm_strdup("publication");
}
#line 45037 "preproc.c"
    break;

  case 982: /* drop_type_name: SCHEMA  */
#line 6397 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 45045 "preproc.c"
    break;

  case 983: /* drop_type_name: SERVER  */
#line 6401 "preproc.y"
 { 
 (yyval.str) = mm_strdup("server");
}
#line 45053 "preproc.c"
    break;

  case 984: /* drop_type_name_on_any_name: POLICY  */
#line 6409 "preproc.y"
 { 
 (yyval.str) = mm_strdup("policy");
}
#line 45061 "preproc.c"
    break;

  case 985: /* drop_type_name_on_any_name: RULE  */
#line 6413 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rule");
}
#line 45069 "preproc.c"
    break;

  case 986: /* drop_type_name_on_any_name: TRIGGER  */
#line 6417 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trigger");
}
#line 45077 "preproc.c"
    break;

  case 987: /* any_name_list: any_name  */
#line 6425 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45085 "preproc.c"
    break;

  case 988: /* any_name_list: any_name_list ',' any_name  */
#line 6429 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45093 "preproc.c"
    break;

  case 989: /* any_name: ColId  */
#line 6437 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45101 "preproc.c"
    break;

  case 990: /* any_name: ColId attrs  */
#line 6441 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45109 "preproc.c"
    break;

  case 991: /* attrs: '.' attr_name  */
#line 6449 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("."),(yyvsp[0].str));
}
#line 45117 "preproc.c"
    break;

  case 992: /* attrs: attrs '.' attr_name  */
#line 6453 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 45125 "preproc.c"
    break;

  case 993: /* type_name_list: Typename  */
#line 6461 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45133 "preproc.c"
    break;

  case 995: /* TruncateStmt: TRUNCATE opt_table relation_expr_list opt_restart_seqs opt_drop_behavior  */
#line 6466 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("truncate"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45141 "preproc.c"
    break;

  case 996: /* opt_restart_seqs: CONTINUE_P IDENTITY_P  */
#line 6474 "preproc.y"
 { 
 (yyval.str) = mm_strdup("continue identity");
}
#line 45149 "preproc.c"
    break;

  case 997: /* opt_restart_seqs: RESTART IDENTITY_P  */
#line 6478 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restart identity");
}
#line 45157 "preproc.c"
    break;

  case 998: /* opt_restart_seqs: %empty  */
#line 6482 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45164 "preproc.c"
    break;

  case 999: /* CommentStmt: COMMENT ON comment_type_any_name any_name IS comment_text  */
#line 6489 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("comment on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45172 "preproc.c"
    break;

  case 1000: /* CommentStmt: COMMENT ON comment_type_name name IS comment_text  */
#line 6493 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("comment on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45180 "preproc.c"
    break;

  case 1001: /* CommentStmt: COMMENT ON TYPE_P Typename IS comment_text  */
#line 6497 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("comment on type"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45188 "preproc.c"
    break;

  case 1002: /* CommentStmt: COMMENT ON DOMAIN_P Typename IS comment_text  */
#line 6501 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("comment on domain"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45196 "preproc.c"
    break;

  case 1003: /* CommentStmt: COMMENT ON AGGREGATE aggregate_with_argtypes IS comment_text  */
#line 6505 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("comment on aggregate"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45204 "preproc.c"
    break;

  case 1004: /* CommentStmt: COMMENT ON FUNCTION function_with_argtypes IS comment_text  */
#line 6509 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("comment on function"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45212 "preproc.c"
    break;

  case 1005: /* CommentStmt: COMMENT ON OPERATOR operator_with_argtypes IS comment_text  */
#line 6513 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("comment on operator"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45220 "preproc.c"
    break;

  case 1006: /* CommentStmt: COMMENT ON CONSTRAINT name ON any_name IS comment_text  */
#line 6517 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on constraint"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45228 "preproc.c"
    break;

  case 1007: /* CommentStmt: COMMENT ON CONSTRAINT name ON DOMAIN_P any_name IS comment_text  */
#line 6521 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on constraint"),(yyvsp[-5].str),mm_strdup("on domain"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45236 "preproc.c"
    break;

  case 1008: /* CommentStmt: COMMENT ON POLICY name ON any_name IS comment_text  */
#line 6525 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on policy"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45244 "preproc.c"
    break;

  case 1009: /* CommentStmt: COMMENT ON RULE name ON any_name IS comment_text  */
#line 6529 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on rule"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45252 "preproc.c"
    break;

  case 1010: /* CommentStmt: COMMENT ON TRANSFORM FOR Typename LANGUAGE name IS comment_text  */
#line 6533 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on transform for"),(yyvsp[-4].str),mm_strdup("language"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45260 "preproc.c"
    break;

  case 1011: /* CommentStmt: COMMENT ON TRIGGER name ON any_name IS comment_text  */
#line 6537 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on trigger"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45268 "preproc.c"
    break;

  case 1012: /* CommentStmt: COMMENT ON OPERATOR CLASS any_name USING access_method IS comment_text  */
#line 6541 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on operator class"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45276 "preproc.c"
    break;

  case 1013: /* CommentStmt: COMMENT ON OPERATOR FAMILY any_name USING access_method IS comment_text  */
#line 6545 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45284 "preproc.c"
    break;

  case 1014: /* CommentStmt: COMMENT ON LARGE_P OBJECT_P NumericOnly IS comment_text  */
#line 6549 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("comment on large object"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45292 "preproc.c"
    break;

  case 1015: /* CommentStmt: COMMENT ON CAST '(' Typename AS Typename ')' IS comment_text  */
#line 6553 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on cast ("),(yyvsp[-5].str),mm_strdup("as"),(yyvsp[-3].str),mm_strdup(") is"),(yyvsp[0].str));
}
#line 45300 "preproc.c"
    break;

  case 1016: /* comment_type_any_name: COLUMN  */
#line 6561 "preproc.y"
 { 
 (yyval.str) = mm_strdup("column");
}
#line 45308 "preproc.c"
    break;

  case 1017: /* comment_type_any_name: INDEX  */
#line 6565 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 45316 "preproc.c"
    break;

  case 1018: /* comment_type_any_name: SEQUENCE  */
#line 6569 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 45324 "preproc.c"
    break;

  case 1019: /* comment_type_any_name: STATISTICS  */
#line 6573 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statistics");
}
#line 45332 "preproc.c"
    break;

  case 1020: /* comment_type_any_name: TABLE  */
#line 6577 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 45340 "preproc.c"
    break;

  case 1021: /* comment_type_any_name: VIEW  */
#line 6581 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 45348 "preproc.c"
    break;

  case 1022: /* comment_type_any_name: MATERIALIZED VIEW  */
#line 6585 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 45356 "preproc.c"
    break;

  case 1023: /* comment_type_any_name: COLLATION  */
#line 6589 "preproc.y"
 { 
 (yyval.str) = mm_strdup("collation");
}
#line 45364 "preproc.c"
    break;

  case 1024: /* comment_type_any_name: CONVERSION_P  */
#line 6593 "preproc.y"
 { 
 (yyval.str) = mm_strdup("conversion");
}
#line 45372 "preproc.c"
    break;

  case 1025: /* comment_type_any_name: FOREIGN TABLE  */
#line 6597 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 45380 "preproc.c"
    break;

  case 1026: /* comment_type_any_name: TEXT_P SEARCH CONFIGURATION  */
#line 6601 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search configuration");
}
#line 45388 "preproc.c"
    break;

  case 1027: /* comment_type_any_name: TEXT_P SEARCH DICTIONARY  */
#line 6605 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search dictionary");
}
#line 45396 "preproc.c"
    break;

  case 1028: /* comment_type_any_name: TEXT_P SEARCH PARSER  */
#line 6609 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search parser");
}
#line 45404 "preproc.c"
    break;

  case 1029: /* comment_type_any_name: TEXT_P SEARCH TEMPLATE  */
#line 6613 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search template");
}
#line 45412 "preproc.c"
    break;

  case 1030: /* comment_type_name: ACCESS METHOD  */
#line 6621 "preproc.y"
 { 
 (yyval.str) = mm_strdup("access method");
}
#line 45420 "preproc.c"
    break;

  case 1031: /* comment_type_name: DATABASE  */
#line 6625 "preproc.y"
 { 
 (yyval.str) = mm_strdup("database");
}
#line 45428 "preproc.c"
    break;

  case 1032: /* comment_type_name: EVENT TRIGGER  */
#line 6629 "preproc.y"
 { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 45436 "preproc.c"
    break;

  case 1033: /* comment_type_name: EXTENSION  */
#line 6633 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extension");
}
#line 45444 "preproc.c"
    break;

  case 1034: /* comment_type_name: FOREIGN DATA_P WRAPPER  */
#line 6637 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign data wrapper");
}
#line 45452 "preproc.c"
    break;

  case 1035: /* comment_type_name: opt_procedural LANGUAGE  */
#line 6641 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("language"));
}
#line 45460 "preproc.c"
    break;

  case 1036: /* comment_type_name: PUBLICATION  */
#line 6645 "preproc.y"
 { 
 (yyval.str) = mm_strdup("publication");
}
#line 45468 "preproc.c"
    break;

  case 1037: /* comment_type_name: ROLE  */
#line 6649 "preproc.y"
 { 
 (yyval.str) = mm_strdup("role");
}
#line 45476 "preproc.c"
    break;

  case 1038: /* comment_type_name: SCHEMA  */
#line 6653 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 45484 "preproc.c"
    break;

  case 1039: /* comment_type_name: SERVER  */
#line 6657 "preproc.y"
 { 
 (yyval.str) = mm_strdup("server");
}
#line 45492 "preproc.c"
    break;

  case 1040: /* comment_type_name: SLOT  */
#line 6661 "preproc.y"
 { 
 (yyval.str) = mm_strdup("slot");
}
#line 45500 "preproc.c"
    break;

  case 1041: /* comment_type_name: SUBSCRIPTION  */
#line 6665 "preproc.y"
 { 
 (yyval.str) = mm_strdup("subscription");
}
#line 45508 "preproc.c"
    break;

  case 1042: /* comment_type_name: TABLESPACE  */
#line 6669 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 45516 "preproc.c"
    break;

  case 1043: /* comment_text: ecpg_sconst  */
#line 6677 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45524 "preproc.c"
    break;

  case 1044: /* comment_text: NULL_P  */
#line 6681 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 45532 "preproc.c"
    break;

  case 1045: /* SecLabelStmt: SECURITY LABEL opt_provider ON security_label_type_any_name any_name IS security_label  */
#line 6689 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45540 "preproc.c"
    break;

  case 1046: /* SecLabelStmt: SECURITY LABEL opt_provider ON security_label_type_name name IS security_label  */
#line 6693 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45548 "preproc.c"
    break;

  case 1047: /* SecLabelStmt: SECURITY LABEL opt_provider ON TYPE_P Typename IS security_label  */
#line 6697 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on type"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45556 "preproc.c"
    break;

  case 1048: /* SecLabelStmt: SECURITY LABEL opt_provider ON DOMAIN_P Typename IS security_label  */
#line 6701 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on domain"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45564 "preproc.c"
    break;

  case 1049: /* SecLabelStmt: SECURITY LABEL opt_provider ON AGGREGATE aggregate_with_argtypes IS security_label  */
#line 6705 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on aggregate"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45572 "preproc.c"
    break;

  case 1050: /* SecLabelStmt: SECURITY LABEL opt_provider ON FUNCTION function_with_argtypes IS security_label  */
#line 6709 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on function"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45580 "preproc.c"
    break;

  case 1051: /* SecLabelStmt: SECURITY LABEL opt_provider ON LARGE_P OBJECT_P NumericOnly IS security_label  */
#line 6713 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on large object"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 45588 "preproc.c"
    break;

  case 1052: /* opt_provider: FOR NonReservedWord_or_Sconst  */
#line 6721 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 45596 "preproc.c"
    break;

  case 1053: /* opt_provider: %empty  */
#line 6725 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45603 "preproc.c"
    break;

  case 1054: /* security_label_type_any_name: COLUMN  */
#line 6732 "preproc.y"
 { 
 (yyval.str) = mm_strdup("column");
}
#line 45611 "preproc.c"
    break;

  case 1055: /* security_label_type_any_name: FOREIGN TABLE  */
#line 6736 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 45619 "preproc.c"
    break;

  case 1056: /* security_label_type_any_name: SEQUENCE  */
#line 6740 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 45627 "preproc.c"
    break;

  case 1057: /* security_label_type_any_name: TABLE  */
#line 6744 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 45635 "preproc.c"
    break;

  case 1058: /* security_label_type_any_name: VIEW  */
#line 6748 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 45643 "preproc.c"
    break;

  case 1059: /* security_label_type_any_name: MATERIALIZED VIEW  */
#line 6752 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 45651 "preproc.c"
    break;

  case 1060: /* security_label_type_name: DATABASE  */
#line 6760 "preproc.y"
 { 
 (yyval.str) = mm_strdup("database");
}
#line 45659 "preproc.c"
    break;

  case 1061: /* security_label_type_name: EVENT TRIGGER  */
#line 6764 "preproc.y"
 { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 45667 "preproc.c"
    break;

  case 1062: /* security_label_type_name: opt_procedural LANGUAGE  */
#line 6768 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("language"));
}
#line 45675 "preproc.c"
    break;

  case 1063: /* security_label_type_name: PUBLICATION  */
#line 6772 "preproc.y"
 { 
 (yyval.str) = mm_strdup("publication");
}
#line 45683 "preproc.c"
    break;

  case 1064: /* security_label_type_name: ROLE  */
#line 6776 "preproc.y"
 { 
 (yyval.str) = mm_strdup("role");
}
#line 45691 "preproc.c"
    break;

  case 1065: /* security_label_type_name: SCHEMA  */
#line 6780 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 45699 "preproc.c"
    break;

  case 1066: /* security_label_type_name: SLOT  */
#line 6784 "preproc.y"
 { 
 (yyval.str) = mm_strdup("slot");
}
#line 45707 "preproc.c"
    break;

  case 1067: /* security_label_type_name: SUBSCRIPTION  */
#line 6788 "preproc.y"
 { 
 (yyval.str) = mm_strdup("subscription");
}
#line 45715 "preproc.c"
    break;

  case 1068: /* security_label_type_name: TABLESPACE  */
#line 6792 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 45723 "preproc.c"
    break;

  case 1069: /* security_label: ecpg_sconst  */
#line 6800 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45731 "preproc.c"
    break;

  case 1070: /* security_label: NULL_P  */
#line 6804 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 45739 "preproc.c"
    break;

  case 1071: /* FetchStmt: FETCH fetch_args  */
#line 6812 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("fetch"),(yyvsp[0].str));
}
#line 45747 "preproc.c"
    break;

  case 1072: /* FetchStmt: MOVE fetch_args  */
#line 6816 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("move"),(yyvsp[0].str));
}
#line 45755 "preproc.c"
    break;

  case 1073: /* FetchStmt: FETCH fetch_args ecpg_fetch_into  */
#line 6820 "preproc.y"
        {
		(yyval.str) = cat2_str(mm_strdup("fetch"), (yyvsp[-1].str));
	}
#line 45763 "preproc.c"
    break;

  case 1074: /* FetchStmt: FETCH FORWARD cursor_name opt_ecpg_fetch_into  */
#line 6824 "preproc.y"
        {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch forward"), cursor_marker);
	}
#line 45773 "preproc.c"
    break;

  case 1075: /* FetchStmt: FETCH FORWARD from_in cursor_name opt_ecpg_fetch_into  */
#line 6830 "preproc.y"
        {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch forward from"), cursor_marker);
	}
#line 45783 "preproc.c"
    break;

  case 1076: /* FetchStmt: FETCH BACKWARD cursor_name opt_ecpg_fetch_into  */
#line 6836 "preproc.y"
        {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch backward"), cursor_marker);
	}
#line 45793 "preproc.c"
    break;

  case 1077: /* FetchStmt: FETCH BACKWARD from_in cursor_name opt_ecpg_fetch_into  */
#line 6842 "preproc.y"
        {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch backward from"), cursor_marker);
	}
#line 45803 "preproc.c"
    break;

  case 1078: /* FetchStmt: MOVE FORWARD cursor_name  */
#line 6848 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move forward"), cursor_marker);
	}
#line 45813 "preproc.c"
    break;

  case 1079: /* FetchStmt: MOVE FORWARD from_in cursor_name  */
#line 6854 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move forward from"), cursor_marker);
	}
#line 45823 "preproc.c"
    break;

  case 1080: /* FetchStmt: MOVE BACKWARD cursor_name  */
#line 6860 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move backward"), cursor_marker);
	}
#line 45833 "preproc.c"
    break;

  case 1081: /* FetchStmt: MOVE BACKWARD from_in cursor_name  */
#line 6866 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move backward from"), cursor_marker);
	}
#line 45843 "preproc.c"
    break;

  case 1082: /* fetch_args: cursor_name  */
#line 6876 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = (yyvsp[0].str);
}
#line 45858 "preproc.c"
    break;

  case 1083: /* fetch_args: from_in cursor_name  */
#line 6887 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45873 "preproc.c"
    break;

  case 1084: /* fetch_args: NEXT opt_from_in cursor_name  */
#line 6898 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("next"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45888 "preproc.c"
    break;

  case 1085: /* fetch_args: PRIOR opt_from_in cursor_name  */
#line 6909 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("prior"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45903 "preproc.c"
    break;

  case 1086: /* fetch_args: FIRST_P opt_from_in cursor_name  */
#line 6920 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("first"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45918 "preproc.c"
    break;

  case 1087: /* fetch_args: LAST_P opt_from_in cursor_name  */
#line 6931 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("last"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45933 "preproc.c"
    break;

  case 1088: /* fetch_args: ABSOLUTE_P SignedIconst opt_from_in cursor_name  */
#line 6942 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("absolute"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45953 "preproc.c"
    break;

  case 1089: /* fetch_args: RELATIVE_P SignedIconst opt_from_in cursor_name  */
#line 6958 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("relative"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45973 "preproc.c"
    break;

  case 1090: /* fetch_args: SignedIconst opt_from_in cursor_name  */
#line 6974 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45993 "preproc.c"
    break;

  case 1091: /* fetch_args: ALL opt_from_in cursor_name  */
#line 6990 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46008 "preproc.c"
    break;

  case 1092: /* fetch_args: FORWARD SignedIconst opt_from_in cursor_name  */
#line 7001 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("forward"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46028 "preproc.c"
    break;

  case 1093: /* fetch_args: FORWARD ALL opt_from_in cursor_name  */
#line 7017 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("forward all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46043 "preproc.c"
    break;

  case 1094: /* fetch_args: BACKWARD SignedIconst opt_from_in cursor_name  */
#line 7028 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("backward"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46063 "preproc.c"
    break;

  case 1095: /* fetch_args: BACKWARD ALL opt_from_in cursor_name  */
#line 7044 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("backward all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46078 "preproc.c"
    break;

  case 1096: /* from_in: FROM  */
#line 7059 "preproc.y"
 { 
 (yyval.str) = mm_strdup("from");
}
#line 46086 "preproc.c"
    break;

  case 1097: /* from_in: IN_P  */
#line 7063 "preproc.y"
 { 
 (yyval.str) = mm_strdup("in");
}
#line 46094 "preproc.c"
    break;

  case 1098: /* opt_from_in: from_in  */
#line 7071 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46102 "preproc.c"
    break;

  case 1099: /* opt_from_in: %empty  */
#line 7075 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46109 "preproc.c"
    break;

  case 1100: /* GrantStmt: GRANT privileges ON privilege_target TO grantee_list opt_grant_grant_option  */
#line 7082 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("grant"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46117 "preproc.c"
    break;

  case 1101: /* RevokeStmt: REVOKE privileges ON privilege_target FROM grantee_list opt_drop_behavior  */
#line 7090 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("revoke"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46125 "preproc.c"
    break;

  case 1102: /* RevokeStmt: REVOKE GRANT OPTION FOR privileges ON privilege_target FROM grantee_list opt_drop_behavior  */
#line 7094 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("revoke grant option for"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46133 "preproc.c"
    break;

  case 1103: /* privileges: privilege_list  */
#line 7102 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46141 "preproc.c"
    break;

  case 1104: /* privileges: ALL  */
#line 7106 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 46149 "preproc.c"
    break;

  case 1105: /* privileges: ALL PRIVILEGES  */
#line 7110 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all privileges");
}
#line 46157 "preproc.c"
    break;

  case 1106: /* privileges: ALL '(' columnList ')'  */
#line 7114 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("all ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46165 "preproc.c"
    break;

  case 1107: /* privileges: ALL PRIVILEGES '(' columnList ')'  */
#line 7118 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("all privileges ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46173 "preproc.c"
    break;

  case 1108: /* privilege_list: privilege  */
#line 7126 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46181 "preproc.c"
    break;

  case 1109: /* privilege_list: privilege_list ',' privilege  */
#line 7130 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46189 "preproc.c"
    break;

  case 1110: /* privilege: SELECT opt_column_list  */
#line 7138 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("select"),(yyvsp[0].str));
}
#line 46197 "preproc.c"
    break;

  case 1111: /* privilege: REFERENCES opt_column_list  */
#line 7142 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("references"),(yyvsp[0].str));
}
#line 46205 "preproc.c"
    break;

  case 1112: /* privilege: CREATE opt_column_list  */
#line 7146 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("create"),(yyvsp[0].str));
}
#line 46213 "preproc.c"
    break;

  case 1113: /* privilege: ColId opt_column_list  */
#line 7150 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46221 "preproc.c"
    break;

  case 1114: /* privilege_target: qualified_name_list  */
#line 7158 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46229 "preproc.c"
    break;

  case 1115: /* privilege_target: TABLE qualified_name_list  */
#line 7162 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 46237 "preproc.c"
    break;

  case 1116: /* privilege_target: SEQUENCE qualified_name_list  */
#line 7166 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("sequence"),(yyvsp[0].str));
}
#line 46245 "preproc.c"
    break;

  case 1117: /* privilege_target: FOREIGN DATA_P WRAPPER name_list  */
#line 7170 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("foreign data wrapper"),(yyvsp[0].str));
}
#line 46253 "preproc.c"
    break;

  case 1118: /* privilege_target: FOREIGN SERVER name_list  */
#line 7174 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("foreign server"),(yyvsp[0].str));
}
#line 46261 "preproc.c"
    break;

  case 1119: /* privilege_target: FUNCTION function_with_argtypes_list  */
#line 7178 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("function"),(yyvsp[0].str));
}
#line 46269 "preproc.c"
    break;

  case 1120: /* privilege_target: DATABASE name_list  */
#line 7182 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("database"),(yyvsp[0].str));
}
#line 46277 "preproc.c"
    break;

  case 1121: /* privilege_target: DOMAIN_P any_name_list  */
#line 7186 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("domain"),(yyvsp[0].str));
}
#line 46285 "preproc.c"
    break;

  case 1122: /* privilege_target: LANGUAGE name_list  */
#line 7190 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 46293 "preproc.c"
    break;

  case 1123: /* privilege_target: LARGE_P OBJECT_P NumericOnly_list  */
#line 7194 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("large object"),(yyvsp[0].str));
}
#line 46301 "preproc.c"
    break;

  case 1124: /* privilege_target: SCHEMA name_list  */
#line 7198 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 46309 "preproc.c"
    break;

  case 1125: /* privilege_target: TABLESPACE name_list  */
#line 7202 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 46317 "preproc.c"
    break;

  case 1126: /* privilege_target: TYPE_P any_name_list  */
#line 7206 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("type"),(yyvsp[0].str));
}
#line 46325 "preproc.c"
    break;

  case 1127: /* privilege_target: ALL TABLES IN_P SCHEMA name_list  */
#line 7210 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("all tables in schema"),(yyvsp[0].str));
}
#line 46333 "preproc.c"
    break;

  case 1128: /* privilege_target: ALL SEQUENCES IN_P SCHEMA name_list  */
#line 7214 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("all sequences in schema"),(yyvsp[0].str));
}
#line 46341 "preproc.c"
    break;

  case 1129: /* privilege_target: ALL FUNCTIONS IN_P SCHEMA name_list  */
#line 7218 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("all functions in schema"),(yyvsp[0].str));
}
#line 46349 "preproc.c"
    break;

  case 1130: /* grantee_list: grantee  */
#line 7226 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46357 "preproc.c"
    break;

  case 1131: /* grantee_list: grantee_list ',' grantee  */
#line 7230 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46365 "preproc.c"
    break;

  case 1132: /* grantee: RoleSpec  */
#line 7238 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46373 "preproc.c"
    break;

  case 1133: /* grantee: GROUP_P RoleSpec  */
#line 7242 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("group"),(yyvsp[0].str));
}
#line 46381 "preproc.c"
    break;

  case 1134: /* opt_grant_grant_option: WITH GRANT OPTION  */
#line 7250 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with grant option");
}
#line 46389 "preproc.c"
    break;

  case 1135: /* opt_grant_grant_option: %empty  */
#line 7254 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46396 "preproc.c"
    break;

  case 1136: /* GrantRoleStmt: GRANT privilege_list TO role_list opt_grant_admin_option opt_granted_by  */
#line 7261 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("grant"),(yyvsp[-4].str),mm_strdup("to"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46404 "preproc.c"
    break;

  case 1137: /* RevokeRoleStmt: REVOKE privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 7269 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("revoke"),(yyvsp[-4].str),mm_strdup("from"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46412 "preproc.c"
    break;

  case 1138: /* RevokeRoleStmt: REVOKE ADMIN OPTION FOR privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 7273 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("revoke admin option for"),(yyvsp[-4].str),mm_strdup("from"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46420 "preproc.c"
    break;

  case 1139: /* opt_grant_admin_option: WITH ADMIN OPTION  */
#line 7281 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with admin option");
}
#line 46428 "preproc.c"
    break;

  case 1140: /* opt_grant_admin_option: %empty  */
#line 7285 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46435 "preproc.c"
    break;

  case 1141: /* opt_granted_by: GRANTED BY RoleSpec  */
#line 7292 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("granted by"),(yyvsp[0].str));
}
#line 46443 "preproc.c"
    break;

  case 1142: /* opt_granted_by: %empty  */
#line 7296 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46450 "preproc.c"
    break;

  case 1143: /* AlterDefaultPrivilegesStmt: ALTER DEFAULT PRIVILEGES DefACLOptionList DefACLAction  */
#line 7303 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter default privileges"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46458 "preproc.c"
    break;

  case 1144: /* DefACLOptionList: DefACLOptionList DefACLOption  */
#line 7311 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46466 "preproc.c"
    break;

  case 1145: /* DefACLOptionList: %empty  */
#line 7315 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46473 "preproc.c"
    break;

  case 1146: /* DefACLOption: IN_P SCHEMA name_list  */
#line 7322 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("in schema"),(yyvsp[0].str));
}
#line 46481 "preproc.c"
    break;

  case 1147: /* DefACLOption: FOR ROLE role_list  */
#line 7326 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for role"),(yyvsp[0].str));
}
#line 46489 "preproc.c"
    break;

  case 1148: /* DefACLOption: FOR USER role_list  */
#line 7330 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for user"),(yyvsp[0].str));
}
#line 46497 "preproc.c"
    break;

  case 1149: /* DefACLAction: GRANT privileges ON defacl_privilege_target TO grantee_list opt_grant_grant_option  */
#line 7338 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("grant"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46505 "preproc.c"
    break;

  case 1150: /* DefACLAction: REVOKE privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 7342 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("revoke"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46513 "preproc.c"
    break;

  case 1151: /* DefACLAction: REVOKE GRANT OPTION FOR privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 7346 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("revoke grant option for"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46521 "preproc.c"
    break;

  case 1152: /* defacl_privilege_target: TABLES  */
#line 7354 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tables");
}
#line 46529 "preproc.c"
    break;

  case 1153: /* defacl_privilege_target: FUNCTIONS  */
#line 7358 "preproc.y"
 { 
 (yyval.str) = mm_strdup("functions");
}
#line 46537 "preproc.c"
    break;

  case 1154: /* defacl_privilege_target: SEQUENCES  */
#line 7362 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequences");
}
#line 46545 "preproc.c"
    break;

  case 1155: /* defacl_privilege_target: TYPES_P  */
#line 7366 "preproc.y"
 { 
 (yyval.str) = mm_strdup("types");
}
#line 46553 "preproc.c"
    break;

  case 1156: /* defacl_privilege_target: SCHEMAS  */
#line 7370 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schemas");
}
#line 46561 "preproc.c"
    break;

  case 1157: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently opt_index_name ON relation_expr access_method_clause '(' index_params ')' opt_reloptions OptTableSpace where_clause  */
#line 7378 "preproc.y"
 { 
 (yyval.str) = cat_str(14,mm_strdup("create"),(yyvsp[-12].str),mm_strdup("index"),(yyvsp[-10].str),(yyvsp[-9].str),mm_strdup("on"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46569 "preproc.c"
    break;

  case 1158: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently IF_P NOT EXISTS index_name ON relation_expr access_method_clause '(' index_params ')' opt_reloptions OptTableSpace where_clause  */
#line 7382 "preproc.y"
 { 
 (yyval.str) = cat_str(15,mm_strdup("create"),(yyvsp[-15].str),mm_strdup("index"),(yyvsp[-13].str),mm_strdup("if not exists"),(yyvsp[-9].str),mm_strdup("on"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46577 "preproc.c"
    break;

  case 1159: /* opt_unique: UNIQUE  */
#line 7390 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unique");
}
#line 46585 "preproc.c"
    break;

  case 1160: /* opt_unique: %empty  */
#line 7394 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46592 "preproc.c"
    break;

  case 1161: /* opt_concurrently: CONCURRENTLY  */
#line 7401 "preproc.y"
 { 
 (yyval.str) = mm_strdup("concurrently");
}
#line 46600 "preproc.c"
    break;

  case 1162: /* opt_concurrently: %empty  */
#line 7405 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46607 "preproc.c"
    break;

  case 1163: /* opt_index_name: index_name  */
#line 7412 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46615 "preproc.c"
    break;

  case 1164: /* opt_index_name: %empty  */
#line 7416 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46622 "preproc.c"
    break;

  case 1165: /* access_method_clause: USING access_method  */
#line 7423 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 46630 "preproc.c"
    break;

  case 1166: /* access_method_clause: %empty  */
#line 7427 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46637 "preproc.c"
    break;

  case 1167: /* index_params: index_elem  */
#line 7434 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46645 "preproc.c"
    break;

  case 1168: /* index_params: index_params ',' index_elem  */
#line 7438 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46653 "preproc.c"
    break;

  case 1169: /* index_elem: ColId opt_collate opt_class opt_asc_desc opt_nulls_order  */
#line 7446 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46661 "preproc.c"
    break;

  case 1170: /* index_elem: func_expr_windowless opt_collate opt_class opt_asc_desc opt_nulls_order  */
#line 7450 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46669 "preproc.c"
    break;

  case 1171: /* index_elem: '(' a_expr ')' opt_collate opt_class opt_asc_desc opt_nulls_order  */
#line 7454 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46677 "preproc.c"
    break;

  case 1172: /* opt_collate: COLLATE any_name  */
#line 7462 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 46685 "preproc.c"
    break;

  case 1173: /* opt_collate: %empty  */
#line 7466 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46692 "preproc.c"
    break;

  case 1174: /* opt_class: any_name  */
#line 7473 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46700 "preproc.c"
    break;

  case 1175: /* opt_class: %empty  */
#line 7477 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46707 "preproc.c"
    break;

  case 1176: /* opt_asc_desc: ASC  */
#line 7484 "preproc.y"
 { 
 (yyval.str) = mm_strdup("asc");
}
#line 46715 "preproc.c"
    break;

  case 1177: /* opt_asc_desc: DESC  */
#line 7488 "preproc.y"
 { 
 (yyval.str) = mm_strdup("desc");
}
#line 46723 "preproc.c"
    break;

  case 1178: /* opt_asc_desc: %empty  */
#line 7492 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46730 "preproc.c"
    break;

  case 1179: /* opt_nulls_order: NULLS_LA FIRST_P  */
#line 7499 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nulls first");
}
#line 46738 "preproc.c"
    break;

  case 1180: /* opt_nulls_order: NULLS_LA LAST_P  */
#line 7503 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nulls last");
}
#line 46746 "preproc.c"
    break;

  case 1181: /* opt_nulls_order: %empty  */
#line 7507 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46753 "preproc.c"
    break;

  case 1182: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS func_return createfunc_opt_list opt_definition  */
#line 7514 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("function"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("returns"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46761 "preproc.c"
    break;

  case 1183: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS TABLE '(' table_func_column_list ')' createfunc_opt_list opt_definition  */
#line 7518 "preproc.y"
 { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("function"),(yyvsp[-8].str),(yyvsp[-7].str),mm_strdup("returns table ("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46769 "preproc.c"
    break;

  case 1184: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults createfunc_opt_list opt_definition  */
#line 7522 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create"),(yyvsp[-5].str),mm_strdup("function"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46777 "preproc.c"
    break;

  case 1185: /* opt_or_replace: OR REPLACE  */
#line 7530 "preproc.y"
 { 
 (yyval.str) = mm_strdup("or replace");
}
#line 46785 "preproc.c"
    break;

  case 1186: /* opt_or_replace: %empty  */
#line 7534 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46792 "preproc.c"
    break;

  case 1187: /* func_args: '(' func_args_list ')'  */
#line 7541 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46800 "preproc.c"
    break;

  case 1188: /* func_args: '(' ')'  */
#line 7545 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( )");
}
#line 46808 "preproc.c"
    break;

  case 1189: /* func_args_list: func_arg  */
#line 7553 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46816 "preproc.c"
    break;

  case 1190: /* func_args_list: func_args_list ',' func_arg  */
#line 7557 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46824 "preproc.c"
    break;

  case 1191: /* function_with_argtypes_list: function_with_argtypes  */
#line 7565 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46832 "preproc.c"
    break;

  case 1192: /* function_with_argtypes_list: function_with_argtypes_list ',' function_with_argtypes  */
#line 7569 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46840 "preproc.c"
    break;

  case 1193: /* function_with_argtypes: func_name func_args  */
#line 7577 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46848 "preproc.c"
    break;

  case 1194: /* function_with_argtypes: type_func_name_keyword  */
#line 7581 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46856 "preproc.c"
    break;

  case 1195: /* function_with_argtypes: ColId  */
#line 7585 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46864 "preproc.c"
    break;

  case 1196: /* function_with_argtypes: ColId indirection  */
#line 7589 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46872 "preproc.c"
    break;

  case 1197: /* func_args_with_defaults: '(' func_args_with_defaults_list ')'  */
#line 7597 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46880 "preproc.c"
    break;

  case 1198: /* func_args_with_defaults: '(' ')'  */
#line 7601 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( )");
}
#line 46888 "preproc.c"
    break;

  case 1199: /* func_args_with_defaults_list: func_arg_with_default  */
#line 7609 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46896 "preproc.c"
    break;

  case 1200: /* func_args_with_defaults_list: func_args_with_defaults_list ',' func_arg_with_default  */
#line 7613 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46904 "preproc.c"
    break;

  case 1201: /* func_arg: arg_class param_name func_type  */
#line 7621 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46912 "preproc.c"
    break;

  case 1202: /* func_arg: param_name arg_class func_type  */
#line 7625 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46920 "preproc.c"
    break;

  case 1203: /* func_arg: param_name func_type  */
#line 7629 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46928 "preproc.c"
    break;

  case 1204: /* func_arg: arg_class func_type  */
#line 7633 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46936 "preproc.c"
    break;

  case 1205: /* func_arg: func_type  */
#line 7637 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46944 "preproc.c"
    break;

  case 1206: /* arg_class: IN_P  */
#line 7645 "preproc.y"
 { 
 (yyval.str) = mm_strdup("in");
}
#line 46952 "preproc.c"
    break;

  case 1207: /* arg_class: OUT_P  */
#line 7649 "preproc.y"
 { 
 (yyval.str) = mm_strdup("out");
}
#line 46960 "preproc.c"
    break;

  case 1208: /* arg_class: INOUT  */
#line 7653 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inout");
}
#line 46968 "preproc.c"
    break;

  case 1209: /* arg_class: IN_P OUT_P  */
#line 7657 "preproc.y"
 { 
 (yyval.str) = mm_strdup("in out");
}
#line 46976 "preproc.c"
    break;

  case 1210: /* arg_class: VARIADIC  */
#line 7661 "preproc.y"
 { 
 (yyval.str) = mm_strdup("variadic");
}
#line 46984 "preproc.c"
    break;

  case 1211: /* param_name: type_function_name  */
#line 7669 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46992 "preproc.c"
    break;

  case 1212: /* func_return: func_type  */
#line 7677 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47000 "preproc.c"
    break;

  case 1213: /* func_type: Typename  */
#line 7685 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47008 "preproc.c"
    break;

  case 1214: /* func_type: type_function_name attrs '%' TYPE_P  */
#line 7689 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("% type"));
}
#line 47016 "preproc.c"
    break;

  case 1215: /* func_type: SETOF type_function_name attrs '%' TYPE_P  */
#line 7693 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("setof"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("% type"));
}
#line 47024 "preproc.c"
    break;

  case 1216: /* func_arg_with_default: func_arg  */
#line 7701 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47032 "preproc.c"
    break;

  case 1217: /* func_arg_with_default: func_arg DEFAULT a_expr  */
#line 7705 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("default"),(yyvsp[0].str));
}
#line 47040 "preproc.c"
    break;

  case 1218: /* func_arg_with_default: func_arg '=' a_expr  */
#line 7709 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 47048 "preproc.c"
    break;

  case 1219: /* aggr_arg: func_arg  */
#line 7717 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = (yyvsp[0].str);
}
#line 47057 "preproc.c"
    break;

  case 1220: /* aggr_args: '(' '*' ')'  */
#line 7726 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( * )");
}
#line 47065 "preproc.c"
    break;

  case 1221: /* aggr_args: '(' aggr_args_list ')'  */
#line 7730 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47073 "preproc.c"
    break;

  case 1222: /* aggr_args: '(' ORDER BY aggr_args_list ')'  */
#line 7734 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("( order by"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47081 "preproc.c"
    break;

  case 1223: /* aggr_args: '(' aggr_args_list ORDER BY aggr_args_list ')'  */
#line 7738 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-4].str),mm_strdup("order by"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47089 "preproc.c"
    break;

  case 1224: /* aggr_args_list: aggr_arg  */
#line 7746 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47097 "preproc.c"
    break;

  case 1225: /* aggr_args_list: aggr_args_list ',' aggr_arg  */
#line 7750 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47105 "preproc.c"
    break;

  case 1226: /* aggregate_with_argtypes: func_name aggr_args  */
#line 7758 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47113 "preproc.c"
    break;

  case 1227: /* aggregate_with_argtypes_list: aggregate_with_argtypes  */
#line 7766 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47121 "preproc.c"
    break;

  case 1228: /* aggregate_with_argtypes_list: aggregate_with_argtypes_list ',' aggregate_with_argtypes  */
#line 7770 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47129 "preproc.c"
    break;

  case 1229: /* createfunc_opt_list: createfunc_opt_item  */
#line 7778 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47137 "preproc.c"
    break;

  case 1230: /* createfunc_opt_list: createfunc_opt_list createfunc_opt_item  */
#line 7782 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47145 "preproc.c"
    break;

  case 1231: /* common_func_opt_item: CALLED ON NULL_P INPUT_P  */
#line 7790 "preproc.y"
 { 
 (yyval.str) = mm_strdup("called on null input");
}
#line 47153 "preproc.c"
    break;

  case 1232: /* common_func_opt_item: RETURNS NULL_P ON NULL_P INPUT_P  */
#line 7794 "preproc.y"
 { 
 (yyval.str) = mm_strdup("returns null on null input");
}
#line 47161 "preproc.c"
    break;

  case 1233: /* common_func_opt_item: STRICT_P  */
#line 7798 "preproc.y"
 { 
 (yyval.str) = mm_strdup("strict");
}
#line 47169 "preproc.c"
    break;

  case 1234: /* common_func_opt_item: IMMUTABLE  */
#line 7802 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immutable");
}
#line 47177 "preproc.c"
    break;

  case 1235: /* common_func_opt_item: STABLE  */
#line 7806 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stable");
}
#line 47185 "preproc.c"
    break;

  case 1236: /* common_func_opt_item: VOLATILE  */
#line 7810 "preproc.y"
 { 
 (yyval.str) = mm_strdup("volatile");
}
#line 47193 "preproc.c"
    break;

  case 1237: /* common_func_opt_item: EXTERNAL SECURITY DEFINER  */
#line 7814 "preproc.y"
 { 
 (yyval.str) = mm_strdup("external security definer");
}
#line 47201 "preproc.c"
    break;

  case 1238: /* common_func_opt_item: EXTERNAL SECURITY INVOKER  */
#line 7818 "preproc.y"
 { 
 (yyval.str) = mm_strdup("external security invoker");
}
#line 47209 "preproc.c"
    break;

  case 1239: /* common_func_opt_item: SECURITY DEFINER  */
#line 7822 "preproc.y"
 { 
 (yyval.str) = mm_strdup("security definer");
}
#line 47217 "preproc.c"
    break;

  case 1240: /* common_func_opt_item: SECURITY INVOKER  */
#line 7826 "preproc.y"
 { 
 (yyval.str) = mm_strdup("security invoker");
}
#line 47225 "preproc.c"
    break;

  case 1241: /* common_func_opt_item: LEAKPROOF  */
#line 7830 "preproc.y"
 { 
 (yyval.str) = mm_strdup("leakproof");
}
#line 47233 "preproc.c"
    break;

  case 1242: /* common_func_opt_item: NOT LEAKPROOF  */
#line 7834 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not leakproof");
}
#line 47241 "preproc.c"
    break;

  case 1243: /* common_func_opt_item: PUSHDOWN  */
#line 7838 "preproc.y"
 { 
 (yyval.str) = mm_strdup("pushdown");
}
#line 47249 "preproc.c"
    break;

  case 1244: /* common_func_opt_item: NOT PUSHDOWN  */
#line 7842 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not pushdown");
}
#line 47257 "preproc.c"
    break;

  case 1245: /* common_func_opt_item: COST NumericOnly  */
#line 7846 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cost"),(yyvsp[0].str));
}
#line 47265 "preproc.c"
    break;

  case 1246: /* common_func_opt_item: ROWS NumericOnly  */
#line 7850 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("rows"),(yyvsp[0].str));
}
#line 47273 "preproc.c"
    break;

  case 1247: /* common_func_opt_item: FunctionSetResetClause  */
#line 7854 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47281 "preproc.c"
    break;

  case 1248: /* common_func_opt_item: PARALLEL ColId  */
#line 7858 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("parallel"),(yyvsp[0].str));
}
#line 47289 "preproc.c"
    break;

  case 1249: /* createfunc_opt_item: AS func_as  */
#line 7866 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 47297 "preproc.c"
    break;

  case 1250: /* createfunc_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 7870 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 47305 "preproc.c"
    break;

  case 1251: /* createfunc_opt_item: TRANSFORM transform_type_list  */
#line 7874 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("transform"),(yyvsp[0].str));
}
#line 47313 "preproc.c"
    break;

  case 1252: /* createfunc_opt_item: WINDOW  */
#line 7878 "preproc.y"
 { 
 (yyval.str) = mm_strdup("window");
}
#line 47321 "preproc.c"
    break;

  case 1253: /* createfunc_opt_item: common_func_opt_item  */
#line 7882 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47329 "preproc.c"
    break;

  case 1254: /* func_as: ecpg_sconst  */
#line 7890 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47337 "preproc.c"
    break;

  case 1255: /* func_as: ecpg_sconst ',' ecpg_sconst  */
#line 7894 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47345 "preproc.c"
    break;

  case 1256: /* transform_type_list: FOR TYPE_P Typename  */
#line 7902 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for type"),(yyvsp[0].str));
}
#line 47353 "preproc.c"
    break;

  case 1257: /* transform_type_list: transform_type_list ',' FOR TYPE_P Typename  */
#line 7906 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup(", for type"),(yyvsp[0].str));
}
#line 47361 "preproc.c"
    break;

  case 1258: /* opt_definition: WITH definition  */
#line 7914 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 47369 "preproc.c"
    break;

  case 1259: /* opt_definition: %empty  */
#line 7918 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47376 "preproc.c"
    break;

  case 1260: /* table_func_column: param_name func_type  */
#line 7925 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47384 "preproc.c"
    break;

  case 1261: /* table_func_column_list: table_func_column  */
#line 7933 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47392 "preproc.c"
    break;

  case 1262: /* table_func_column_list: table_func_column_list ',' table_func_column  */
#line 7937 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47400 "preproc.c"
    break;

  case 1263: /* AlterFunctionStmt: ALTER FUNCTION function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 7945 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47408 "preproc.c"
    break;

  case 1264: /* alterfunc_opt_list: common_func_opt_item  */
#line 7953 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47416 "preproc.c"
    break;

  case 1265: /* alterfunc_opt_list: alterfunc_opt_list common_func_opt_item  */
#line 7957 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47424 "preproc.c"
    break;

  case 1266: /* opt_restrict: RESTRICT  */
#line 7965 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restrict");
}
#line 47432 "preproc.c"
    break;

  case 1267: /* opt_restrict: %empty  */
#line 7969 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47439 "preproc.c"
    break;

  case 1268: /* RemoveFuncStmt: DROP FUNCTION function_with_argtypes_list opt_drop_behavior  */
#line 7976 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop function"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47447 "preproc.c"
    break;

  case 1269: /* RemoveFuncStmt: DROP FUNCTION IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 7980 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop function if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47455 "preproc.c"
    break;

  case 1270: /* RemoveAggrStmt: DROP AGGREGATE aggregate_with_argtypes_list opt_drop_behavior  */
#line 7988 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop aggregate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47463 "preproc.c"
    break;

  case 1271: /* RemoveAggrStmt: DROP AGGREGATE IF_P EXISTS aggregate_with_argtypes_list opt_drop_behavior  */
#line 7992 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop aggregate if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47471 "preproc.c"
    break;

  case 1272: /* RemoveOperStmt: DROP OPERATOR operator_with_argtypes_list opt_drop_behavior  */
#line 8000 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop operator"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47479 "preproc.c"
    break;

  case 1273: /* RemoveOperStmt: DROP OPERATOR IF_P EXISTS operator_with_argtypes_list opt_drop_behavior  */
#line 8004 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop operator if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47487 "preproc.c"
    break;

  case 1274: /* oper_argtypes: '(' Typename ')'  */
#line 8012 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47495 "preproc.c"
    break;

  case 1275: /* oper_argtypes: '(' Typename ',' Typename ')'  */
#line 8016 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47503 "preproc.c"
    break;

  case 1276: /* oper_argtypes: '(' NONE ',' Typename ')'  */
#line 8020 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("( none ,"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47511 "preproc.c"
    break;

  case 1277: /* oper_argtypes: '(' Typename ',' NONE ')'  */
#line 8024 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-3].str),mm_strdup(", none )"));
}
#line 47519 "preproc.c"
    break;

  case 1278: /* any_operator: all_Op  */
#line 8032 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47527 "preproc.c"
    break;

  case 1279: /* any_operator: ColId '.' any_operator  */
#line 8036 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 47535 "preproc.c"
    break;

  case 1280: /* operator_with_argtypes_list: operator_with_argtypes  */
#line 8044 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47543 "preproc.c"
    break;

  case 1281: /* operator_with_argtypes_list: operator_with_argtypes_list ',' operator_with_argtypes  */
#line 8048 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47551 "preproc.c"
    break;

  case 1282: /* operator_with_argtypes: any_operator oper_argtypes  */
#line 8056 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47559 "preproc.c"
    break;

  case 1283: /* DoStmt: DO dostmt_opt_list  */
#line 8064 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("do"),(yyvsp[0].str));
}
#line 47567 "preproc.c"
    break;

  case 1284: /* dostmt_opt_list: dostmt_opt_item  */
#line 8072 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47575 "preproc.c"
    break;

  case 1285: /* dostmt_opt_list: dostmt_opt_list dostmt_opt_item  */
#line 8076 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47583 "preproc.c"
    break;

  case 1286: /* dostmt_opt_item: ecpg_sconst  */
#line 8084 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47591 "preproc.c"
    break;

  case 1287: /* dostmt_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 8088 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 47599 "preproc.c"
    break;

  case 1288: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH FUNCTION function_with_argtypes cast_context  */
#line 8096 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create cast ("),(yyvsp[-7].str),mm_strdup("as"),(yyvsp[-5].str),mm_strdup(") with function"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47607 "preproc.c"
    break;

  case 1289: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITHOUT FUNCTION cast_context  */
#line 8100 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create cast ("),(yyvsp[-6].str),mm_strdup("as"),(yyvsp[-4].str),mm_strdup(") without function"),(yyvsp[0].str));
}
#line 47615 "preproc.c"
    break;

  case 1290: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH INOUT cast_context  */
#line 8104 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create cast ("),(yyvsp[-6].str),mm_strdup("as"),(yyvsp[-4].str),mm_strdup(") with inout"),(yyvsp[0].str));
}
#line 47623 "preproc.c"
    break;

  case 1291: /* cast_context: AS IMPLICIT_P  */
#line 8112 "preproc.y"
 { 
 (yyval.str) = mm_strdup("as implicit");
}
#line 47631 "preproc.c"
    break;

  case 1292: /* cast_context: AS ASSIGNMENT  */
#line 8116 "preproc.y"
 { 
 (yyval.str) = mm_strdup("as assignment");
}
#line 47639 "preproc.c"
    break;

  case 1293: /* cast_context: %empty  */
#line 8120 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47646 "preproc.c"
    break;

  case 1294: /* DropCastStmt: DROP CAST opt_if_exists '(' Typename AS Typename ')' opt_drop_behavior  */
#line 8127 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("drop cast"),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup("as"),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 47654 "preproc.c"
    break;

  case 1295: /* opt_if_exists: IF_P EXISTS  */
#line 8135 "preproc.y"
 { 
 (yyval.str) = mm_strdup("if exists");
}
#line 47662 "preproc.c"
    break;

  case 1296: /* opt_if_exists: %empty  */
#line 8139 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47669 "preproc.c"
    break;

  case 1297: /* CreateTransformStmt: CREATE opt_or_replace TRANSFORM FOR Typename LANGUAGE name '(' transform_element_list ')'  */
#line 8146 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-8].str),mm_strdup("transform for"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47677 "preproc.c"
    break;

  case 1298: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes ',' TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 8154 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("from sql with function"),(yyvsp[-6].str),mm_strdup(", to sql with function"),(yyvsp[0].str));
}
#line 47685 "preproc.c"
    break;

  case 1299: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes ',' FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 8158 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("to sql with function"),(yyvsp[-6].str),mm_strdup(", from sql with function"),(yyvsp[0].str));
}
#line 47693 "preproc.c"
    break;

  case 1300: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 8162 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from sql with function"),(yyvsp[0].str));
}
#line 47701 "preproc.c"
    break;

  case 1301: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 8166 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("to sql with function"),(yyvsp[0].str));
}
#line 47709 "preproc.c"
    break;

  case 1302: /* DropTransformStmt: DROP TRANSFORM opt_if_exists FOR Typename LANGUAGE name opt_drop_behavior  */
#line 8174 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("drop transform"),(yyvsp[-5].str),mm_strdup("for"),(yyvsp[-3].str),mm_strdup("language"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47717 "preproc.c"
    break;

  case 1303: /* ReindexStmt: REINDEX reindex_target_type qualified_name  */
#line 8182 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("reindex"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47725 "preproc.c"
    break;

  case 1304: /* ReindexStmt: REINDEX reindex_target_multitable name  */
#line 8186 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("reindex"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47733 "preproc.c"
    break;

  case 1305: /* ReindexStmt: REINDEX '(' reindex_option_list ')' reindex_target_type qualified_name  */
#line 8190 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("reindex ("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47741 "preproc.c"
    break;

  case 1306: /* ReindexStmt: REINDEX '(' reindex_option_list ')' reindex_target_multitable name  */
#line 8194 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("reindex ("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47749 "preproc.c"
    break;

  case 1307: /* reindex_target_type: INDEX  */
#line 8202 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 47757 "preproc.c"
    break;

  case 1308: /* reindex_target_type: TABLE  */
#line 8206 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 47765 "preproc.c"
    break;

  case 1309: /* reindex_target_multitable: SCHEMA  */
#line 8214 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 47773 "preproc.c"
    break;

  case 1310: /* reindex_target_multitable: SYSTEM_P  */
#line 8218 "preproc.y"
 { 
 (yyval.str) = mm_strdup("system");
}
#line 47781 "preproc.c"
    break;

  case 1311: /* reindex_target_multitable: DATABASE  */
#line 8222 "preproc.y"
 { 
 (yyval.str) = mm_strdup("database");
}
#line 47789 "preproc.c"
    break;

  case 1312: /* reindex_option_list: reindex_option_elem  */
#line 8230 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47797 "preproc.c"
    break;

  case 1313: /* reindex_option_list: reindex_option_list ',' reindex_option_elem  */
#line 8234 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47805 "preproc.c"
    break;

  case 1314: /* reindex_option_elem: VERBOSE  */
#line 8242 "preproc.y"
 { 
 (yyval.str) = mm_strdup("verbose");
}
#line 47813 "preproc.c"
    break;

  case 1315: /* AlterTblSpcStmt: ALTER TABLESPACE name SET reloptions  */
#line 8250 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 47821 "preproc.c"
    break;

  case 1316: /* AlterTblSpcStmt: ALTER TABLESPACE name RESET reloptions  */
#line 8254 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-2].str),mm_strdup("reset"),(yyvsp[0].str));
}
#line 47829 "preproc.c"
    break;

  case 1317: /* RenameStmt: ALTER AGGREGATE aggregate_with_argtypes RENAME TO name  */
#line 8262 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter aggregate"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47837 "preproc.c"
    break;

  case 1318: /* RenameStmt: ALTER COLLATION any_name RENAME TO name  */
#line 8266 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47845 "preproc.c"
    break;

  case 1319: /* RenameStmt: ALTER CONVERSION_P any_name RENAME TO name  */
#line 8270 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47853 "preproc.c"
    break;

  case 1320: /* RenameStmt: ALTER DATABASE database_name RENAME TO database_name  */
#line 8274 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47861 "preproc.c"
    break;

  case 1321: /* RenameStmt: ALTER DOMAIN_P any_name RENAME TO name  */
#line 8278 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47869 "preproc.c"
    break;

  case 1322: /* RenameStmt: ALTER DOMAIN_P any_name RENAME CONSTRAINT name TO name  */
#line 8282 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter domain"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 47877 "preproc.c"
    break;

  case 1323: /* RenameStmt: ALTER FOREIGN DATA_P WRAPPER name RENAME TO name  */
#line 8286 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47885 "preproc.c"
    break;

  case 1324: /* RenameStmt: ALTER FUNCTION function_with_argtypes RENAME TO name  */
#line 8290 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47893 "preproc.c"
    break;

  case 1325: /* RenameStmt: ALTER GROUP_P RoleId RENAME TO RoleId  */
#line 8294 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter group"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47901 "preproc.c"
    break;

  case 1326: /* RenameStmt: ALTER opt_procedural LANGUAGE name RENAME TO name  */
#line 8298 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47909 "preproc.c"
    break;

  case 1327: /* RenameStmt: ALTER OPERATOR CLASS any_name USING access_method RENAME TO name  */
#line 8302 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47917 "preproc.c"
    break;

  case 1328: /* RenameStmt: ALTER OPERATOR FAMILY any_name USING access_method RENAME TO name  */
#line 8306 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47925 "preproc.c"
    break;

  case 1329: /* RenameStmt: ALTER POLICY name ON qualified_name RENAME TO name  */
#line 8310 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter policy"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47933 "preproc.c"
    break;

  case 1330: /* RenameStmt: ALTER POLICY IF_P EXISTS name ON qualified_name RENAME TO name  */
#line 8314 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter policy if exists"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47941 "preproc.c"
    break;

  case 1331: /* RenameStmt: ALTER PUBLICATION name RENAME TO name  */
#line 8318 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47949 "preproc.c"
    break;

  case 1332: /* RenameStmt: ALTER SCHEMA name RENAME TO name  */
#line 8322 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter schema"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47957 "preproc.c"
    break;

  case 1333: /* RenameStmt: ALTER SERVER name RENAME TO name  */
#line 8326 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47965 "preproc.c"
    break;

  case 1334: /* RenameStmt: ALTER SLOT name RENAME TO name  */
#line 8330 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter slot"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47973 "preproc.c"
    break;

  case 1335: /* RenameStmt: ALTER SUBSCRIPTION name RENAME TO name  */
#line 8334 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47981 "preproc.c"
    break;

  case 1336: /* RenameStmt: ALTER TABLE relation_expr RENAME TO name  */
#line 8338 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter table"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47989 "preproc.c"
    break;

  case 1337: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 8342 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter table if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 47997 "preproc.c"
    break;

  case 1338: /* RenameStmt: ALTER SEQUENCE qualified_name RENAME TO name  */
#line 8346 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48005 "preproc.c"
    break;

  case 1339: /* RenameStmt: ALTER SEQUENCE IF_P EXISTS qualified_name RENAME TO name  */
#line 8350 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48013 "preproc.c"
    break;

  case 1340: /* RenameStmt: ALTER VIEW qualified_name RENAME TO name  */
#line 8354 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter view"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48021 "preproc.c"
    break;

  case 1341: /* RenameStmt: ALTER VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 8358 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter view if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48029 "preproc.c"
    break;

  case 1342: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME TO name  */
#line 8362 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48037 "preproc.c"
    break;

  case 1343: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 8366 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48045 "preproc.c"
    break;

  case 1344: /* RenameStmt: ALTER INDEX qualified_name RENAME TO name  */
#line 8370 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter index"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48053 "preproc.c"
    break;

  case 1345: /* RenameStmt: ALTER INDEX IF_P EXISTS qualified_name RENAME TO name  */
#line 8374 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter index if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48061 "preproc.c"
    break;

  case 1346: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME TO name  */
#line 8378 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48069 "preproc.c"
    break;

  case 1347: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 8382 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48077 "preproc.c"
    break;

  case 1348: /* RenameStmt: ALTER TABLE relation_expr RENAME opt_column name TO name  */
#line 8386 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter table"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 48085 "preproc.c"
    break;

  case 1349: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 8390 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter table if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 48093 "preproc.c"
    break;

  case 1350: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME opt_column name TO name  */
#line 8394 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 48101 "preproc.c"
    break;

  case 1351: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME opt_column name TO name  */
#line 8398 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 48109 "preproc.c"
    break;

  case 1352: /* RenameStmt: ALTER TABLE relation_expr RENAME CONSTRAINT name TO name  */
#line 8402 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter table"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 48117 "preproc.c"
    break;

  case 1353: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME CONSTRAINT name TO name  */
#line 8406 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter table if exists"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 48125 "preproc.c"
    break;

  case 1354: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME opt_column name TO name  */
#line 8410 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter foreign table"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 48133 "preproc.c"
    break;

  case 1355: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 8414 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter foreign table if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 48141 "preproc.c"
    break;

  case 1356: /* RenameStmt: ALTER RULE name ON qualified_name RENAME TO name  */
#line 8418 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter rule"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48149 "preproc.c"
    break;

  case 1357: /* RenameStmt: ALTER TRIGGER name ON qualified_name RENAME TO name  */
#line 8422 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter trigger"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48157 "preproc.c"
    break;

  case 1358: /* RenameStmt: ALTER EVENT TRIGGER name RENAME TO name  */
#line 8426 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter event trigger"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48165 "preproc.c"
    break;

  case 1359: /* RenameStmt: ALTER ROLE RoleId RENAME TO RoleId  */
#line 8430 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48173 "preproc.c"
    break;

  case 1360: /* RenameStmt: ALTER USER RoleId RENAME TO RoleId  */
#line 8434 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48181 "preproc.c"
    break;

  case 1361: /* RenameStmt: ALTER TABLESPACE name RENAME TO name  */
#line 8438 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48189 "preproc.c"
    break;

  case 1362: /* RenameStmt: ALTER STATISTICS any_name RENAME TO name  */
#line 8442 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter statistics"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48197 "preproc.c"
    break;

  case 1363: /* RenameStmt: ALTER TEXT_P SEARCH PARSER any_name RENAME TO name  */
#line 8446 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search parser"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48205 "preproc.c"
    break;

  case 1364: /* RenameStmt: ALTER TEXT_P SEARCH DICTIONARY any_name RENAME TO name  */
#line 8450 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48213 "preproc.c"
    break;

  case 1365: /* RenameStmt: ALTER TEXT_P SEARCH TEMPLATE any_name RENAME TO name  */
#line 8454 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search template"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48221 "preproc.c"
    break;

  case 1366: /* RenameStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name RENAME TO name  */
#line 8458 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48229 "preproc.c"
    break;

  case 1367: /* RenameStmt: ALTER TYPE_P any_name RENAME TO name  */
#line 8462 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 48237 "preproc.c"
    break;

  case 1368: /* RenameStmt: ALTER TYPE_P any_name RENAME ATTRIBUTE name TO name opt_drop_behavior  */
#line 8466 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("rename attribute"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48245 "preproc.c"
    break;

  case 1369: /* opt_column: COLUMN  */
#line 8474 "preproc.y"
 { 
 (yyval.str) = mm_strdup("column");
}
#line 48253 "preproc.c"
    break;

  case 1370: /* opt_column: %empty  */
#line 8478 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48260 "preproc.c"
    break;

  case 1371: /* opt_set_data: SET DATA_P  */
#line 8485 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set data");
}
#line 48268 "preproc.c"
    break;

  case 1372: /* opt_set_data: %empty  */
#line 8489 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48275 "preproc.c"
    break;

  case 1373: /* AlterObjectDependsStmt: ALTER FUNCTION function_with_argtypes DEPENDS ON EXTENSION name  */
#line 8496 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 48283 "preproc.c"
    break;

  case 1374: /* AlterObjectDependsStmt: ALTER TRIGGER name ON qualified_name DEPENDS ON EXTENSION name  */
#line 8500 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter trigger"),(yyvsp[-6].str),mm_strdup("on"),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 48291 "preproc.c"
    break;

  case 1375: /* AlterObjectDependsStmt: ALTER MATERIALIZED VIEW qualified_name DEPENDS ON EXTENSION name  */
#line 8504 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 48299 "preproc.c"
    break;

  case 1376: /* AlterObjectDependsStmt: ALTER INDEX qualified_name DEPENDS ON EXTENSION name  */
#line 8508 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter index"),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 48307 "preproc.c"
    break;

  case 1377: /* AlterObjectSchemaStmt: ALTER AGGREGATE aggregate_with_argtypes SET SCHEMA name  */
#line 8516 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter aggregate"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48315 "preproc.c"
    break;

  case 1378: /* AlterObjectSchemaStmt: ALTER COLLATION any_name SET SCHEMA name  */
#line 8520 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48323 "preproc.c"
    break;

  case 1379: /* AlterObjectSchemaStmt: ALTER CONVERSION_P any_name SET SCHEMA name  */
#line 8524 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48331 "preproc.c"
    break;

  case 1380: /* AlterObjectSchemaStmt: ALTER DOMAIN_P any_name SET SCHEMA name  */
#line 8528 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48339 "preproc.c"
    break;

  case 1381: /* AlterObjectSchemaStmt: ALTER EXTENSION name SET SCHEMA name  */
#line 8532 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter extension"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48347 "preproc.c"
    break;

  case 1382: /* AlterObjectSchemaStmt: ALTER FUNCTION function_with_argtypes SET SCHEMA name  */
#line 8536 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48355 "preproc.c"
    break;

  case 1383: /* AlterObjectSchemaStmt: ALTER OPERATOR operator_with_argtypes SET SCHEMA name  */
#line 8540 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter operator"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48363 "preproc.c"
    break;

  case 1384: /* AlterObjectSchemaStmt: ALTER OPERATOR CLASS any_name USING access_method SET SCHEMA name  */
#line 8544 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48371 "preproc.c"
    break;

  case 1385: /* AlterObjectSchemaStmt: ALTER OPERATOR FAMILY any_name USING access_method SET SCHEMA name  */
#line 8548 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48379 "preproc.c"
    break;

  case 1386: /* AlterObjectSchemaStmt: ALTER TABLE relation_expr SET SCHEMA name  */
#line 8552 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter table"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48387 "preproc.c"
    break;

  case 1387: /* AlterObjectSchemaStmt: ALTER TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 8556 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter table if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48395 "preproc.c"
    break;

  case 1388: /* AlterObjectSchemaStmt: ALTER STATISTICS any_name SET SCHEMA name  */
#line 8560 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter statistics"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48403 "preproc.c"
    break;

  case 1389: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH PARSER any_name SET SCHEMA name  */
#line 8564 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search parser"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48411 "preproc.c"
    break;

  case 1390: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH DICTIONARY any_name SET SCHEMA name  */
#line 8568 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48419 "preproc.c"
    break;

  case 1391: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH TEMPLATE any_name SET SCHEMA name  */
#line 8572 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search template"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48427 "preproc.c"
    break;

  case 1392: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name SET SCHEMA name  */
#line 8576 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48435 "preproc.c"
    break;

  case 1393: /* AlterObjectSchemaStmt: ALTER SEQUENCE qualified_name SET SCHEMA name  */
#line 8580 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48443 "preproc.c"
    break;

  case 1394: /* AlterObjectSchemaStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SET SCHEMA name  */
#line 8584 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48451 "preproc.c"
    break;

  case 1395: /* AlterObjectSchemaStmt: ALTER VIEW qualified_name SET SCHEMA name  */
#line 8588 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter view"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48459 "preproc.c"
    break;

  case 1396: /* AlterObjectSchemaStmt: ALTER VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 8592 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter view if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48467 "preproc.c"
    break;

  case 1397: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW qualified_name SET SCHEMA name  */
#line 8596 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48475 "preproc.c"
    break;

  case 1398: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 8600 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48483 "preproc.c"
    break;

  case 1399: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE relation_expr SET SCHEMA name  */
#line 8604 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48491 "preproc.c"
    break;

  case 1400: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 8608 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48499 "preproc.c"
    break;

  case 1401: /* AlterObjectSchemaStmt: ALTER TYPE_P any_name SET SCHEMA name  */
#line 8612 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 48507 "preproc.c"
    break;

  case 1402: /* AlterOperatorStmt: ALTER OPERATOR operator_with_argtypes SET '(' operator_def_list ')'  */
#line 8620 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter operator"),(yyvsp[-4].str),mm_strdup("set ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48515 "preproc.c"
    break;

  case 1403: /* operator_def_list: operator_def_elem  */
#line 8628 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48523 "preproc.c"
    break;

  case 1404: /* operator_def_list: operator_def_list ',' operator_def_elem  */
#line 8632 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48531 "preproc.c"
    break;

  case 1405: /* operator_def_elem: ColLabel '=' NONE  */
#line 8640 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("= none"));
}
#line 48539 "preproc.c"
    break;

  case 1406: /* operator_def_elem: ColLabel '=' operator_def_arg  */
#line 8644 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 48547 "preproc.c"
    break;

  case 1407: /* operator_def_arg: func_type  */
#line 8652 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48555 "preproc.c"
    break;

  case 1408: /* operator_def_arg: reserved_keyword  */
#line 8656 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48563 "preproc.c"
    break;

  case 1409: /* operator_def_arg: qual_all_Op  */
#line 8660 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48571 "preproc.c"
    break;

  case 1410: /* operator_def_arg: NumericOnly  */
#line 8664 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48579 "preproc.c"
    break;

  case 1411: /* operator_def_arg: ecpg_sconst  */
#line 8668 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48587 "preproc.c"
    break;

  case 1412: /* AlterOwnerStmt: ALTER AGGREGATE aggregate_with_argtypes OWNER TO RoleSpec  */
#line 8676 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter aggregate"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48595 "preproc.c"
    break;

  case 1413: /* AlterOwnerStmt: ALTER COLLATION any_name OWNER TO RoleSpec  */
#line 8680 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48603 "preproc.c"
    break;

  case 1414: /* AlterOwnerStmt: ALTER CONVERSION_P any_name OWNER TO RoleSpec  */
#line 8684 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48611 "preproc.c"
    break;

  case 1415: /* AlterOwnerStmt: ALTER DATABASE database_name OWNER TO RoleSpec  */
#line 8688 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48619 "preproc.c"
    break;

  case 1416: /* AlterOwnerStmt: ALTER DOMAIN_P any_name OWNER TO RoleSpec  */
#line 8692 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48627 "preproc.c"
    break;

  case 1417: /* AlterOwnerStmt: ALTER FUNCTION function_with_argtypes OWNER TO RoleSpec  */
#line 8696 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48635 "preproc.c"
    break;

  case 1418: /* AlterOwnerStmt: ALTER opt_procedural LANGUAGE name OWNER TO RoleSpec  */
#line 8700 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48643 "preproc.c"
    break;

  case 1419: /* AlterOwnerStmt: ALTER LARGE_P OBJECT_P NumericOnly OWNER TO RoleSpec  */
#line 8704 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter large object"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48651 "preproc.c"
    break;

  case 1420: /* AlterOwnerStmt: ALTER OPERATOR operator_with_argtypes OWNER TO RoleSpec  */
#line 8708 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter operator"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48659 "preproc.c"
    break;

  case 1421: /* AlterOwnerStmt: ALTER OPERATOR CLASS any_name USING access_method OWNER TO RoleSpec  */
#line 8712 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48667 "preproc.c"
    break;

  case 1422: /* AlterOwnerStmt: ALTER OPERATOR FAMILY any_name USING access_method OWNER TO RoleSpec  */
#line 8716 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48675 "preproc.c"
    break;

  case 1423: /* AlterOwnerStmt: ALTER SCHEMA name OWNER TO RoleSpec  */
#line 8720 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter schema"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48683 "preproc.c"
    break;

  case 1424: /* AlterOwnerStmt: ALTER TYPE_P any_name OWNER TO RoleSpec  */
#line 8724 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48691 "preproc.c"
    break;

  case 1425: /* AlterOwnerStmt: ALTER TABLESPACE name OWNER TO RoleSpec  */
#line 8728 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48699 "preproc.c"
    break;

  case 1426: /* AlterOwnerStmt: ALTER STATISTICS any_name OWNER TO RoleSpec  */
#line 8732 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter statistics"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48707 "preproc.c"
    break;

  case 1427: /* AlterOwnerStmt: ALTER TEXT_P SEARCH DICTIONARY any_name OWNER TO RoleSpec  */
#line 8736 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48715 "preproc.c"
    break;

  case 1428: /* AlterOwnerStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name OWNER TO RoleSpec  */
#line 8740 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48723 "preproc.c"
    break;

  case 1429: /* AlterOwnerStmt: ALTER FOREIGN DATA_P WRAPPER name OWNER TO RoleSpec  */
#line 8744 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48731 "preproc.c"
    break;

  case 1430: /* AlterOwnerStmt: ALTER SERVER name OWNER TO RoleSpec  */
#line 8748 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48739 "preproc.c"
    break;

  case 1431: /* AlterOwnerStmt: ALTER EVENT TRIGGER name OWNER TO RoleSpec  */
#line 8752 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter event trigger"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48747 "preproc.c"
    break;

  case 1432: /* AlterOwnerStmt: ALTER PUBLICATION name OWNER TO RoleSpec  */
#line 8756 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48755 "preproc.c"
    break;

  case 1433: /* AlterOwnerStmt: ALTER SUBSCRIPTION name OWNER TO RoleSpec  */
#line 8760 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 48763 "preproc.c"
    break;

  case 1434: /* CreatePublicationStmt: CREATE PUBLICATION name opt_publication_for_tables opt_publication_for_shards opt_definition  */
#line 8768 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create publication"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48771 "preproc.c"
    break;

  case 1435: /* opt_publication_for_tables: publication_for_tables  */
#line 8776 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48779 "preproc.c"
    break;

  case 1436: /* opt_publication_for_tables: %empty  */
#line 8780 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48786 "preproc.c"
    break;

  case 1437: /* publication_for_tables: FOR TABLE relation_expr_list  */
#line 8787 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for table"),(yyvsp[0].str));
}
#line 48794 "preproc.c"
    break;

  case 1438: /* publication_for_tables: FOR ALL TABLES  */
#line 8791 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for all tables");
}
#line 48802 "preproc.c"
    break;

  case 1439: /* opt_publication_for_shards: publication_for_shards  */
#line 8799 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48810 "preproc.c"
    break;

  case 1440: /* opt_publication_for_shards: %empty  */
#line 8803 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48817 "preproc.c"
    break;

  case 1441: /* publication_for_shards: BY SHARDING '(' shard_list ')'  */
#line 8810 "preproc.y"
 { 
 (yyval.str) = mm_strdup("by sharding (shard_list)");
}
#line 48825 "preproc.c"
    break;

  case 1442: /* AlterPublicationStmt: ALTER PUBLICATION name SET definition  */
#line 8818 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 48833 "preproc.c"
    break;

  case 1443: /* AlterPublicationStmt: ALTER PUBLICATION name ADD_P TABLE relation_expr_list  */
#line 8822 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("add table"),(yyvsp[0].str));
}
#line 48841 "preproc.c"
    break;

  case 1444: /* AlterPublicationStmt: ALTER PUBLICATION name SET TABLE relation_expr_list  */
#line 8826 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("set table"),(yyvsp[0].str));
}
#line 48849 "preproc.c"
    break;

  case 1445: /* AlterPublicationStmt: ALTER PUBLICATION name DROP TABLE relation_expr_list  */
#line 8830 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("drop table"),(yyvsp[0].str));
}
#line 48857 "preproc.c"
    break;

  case 1446: /* CreateSubscriptionStmt: CREATE SUBSCRIPTION name CONNECTION ecpg_sconst PUBLICATION publication_name_list opt_definition  */
#line 8838 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create subscription"),(yyvsp[-5].str),mm_strdup("connection"),(yyvsp[-3].str),mm_strdup("publication"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48865 "preproc.c"
    break;

  case 1447: /* CreateSubscriptionStmt: CREATE OPENTENBASE_P SUBSCRIPTION name CONNECTION ecpg_sconst PUBLICATION publication_name_list opt_definition  */
#line 8842 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create opentenbase subscription"),(yyvsp[-5].str),mm_strdup("connection"),(yyvsp[-3].str),mm_strdup("publication"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48873 "preproc.c"
    break;

  case 1448: /* publication_name_list: publication_name_item  */
#line 8850 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48881 "preproc.c"
    break;

  case 1449: /* publication_name_list: publication_name_list ',' publication_name_item  */
#line 8854 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48889 "preproc.c"
    break;

  case 1450: /* publication_name_item: ColLabel  */
#line 8862 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48897 "preproc.c"
    break;

  case 1451: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET definition  */
#line 8870 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 48905 "preproc.c"
    break;

  case 1452: /* AlterSubscriptionStmt: ALTER OPENTENBASE_P SUBSCRIPTION name SET definition  */
#line 8874 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter opentenbase subscription"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 48913 "preproc.c"
    break;

  case 1453: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name CONNECTION ecpg_sconst  */
#line 8878 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-2].str),mm_strdup("connection"),(yyvsp[0].str));
}
#line 48921 "preproc.c"
    break;

  case 1454: /* AlterSubscriptionStmt: ALTER OPENTENBASE_P SUBSCRIPTION name CONNECTION ecpg_sconst  */
#line 8882 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter opentenbase subscription"),(yyvsp[-2].str),mm_strdup("connection"),(yyvsp[0].str));
}
#line 48929 "preproc.c"
    break;

  case 1455: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name REFRESH PUBLICATION opt_definition  */
#line 8886 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-3].str),mm_strdup("refresh publication"),(yyvsp[0].str));
}
#line 48937 "preproc.c"
    break;

  case 1456: /* AlterSubscriptionStmt: ALTER OPENTENBASE_P SUBSCRIPTION name REFRESH PUBLICATION opt_definition  */
#line 8890 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter opentenbase subscription"),(yyvsp[-3].str),mm_strdup("refresh publication"),(yyvsp[0].str));
}
#line 48945 "preproc.c"
    break;

  case 1457: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET PUBLICATION publication_name_list opt_definition  */
#line 8894 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter subscription"),(yyvsp[-4].str),mm_strdup("set publication"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48953 "preproc.c"
    break;

  case 1458: /* AlterSubscriptionStmt: ALTER OPENTENBASE_P SUBSCRIPTION name SET PUBLICATION publication_name_list opt_definition  */
#line 8898 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter opentenbase subscription"),(yyvsp[-4].str),mm_strdup("set publication"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48961 "preproc.c"
    break;

  case 1459: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name ENABLE_P  */
#line 8902 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter subscription"),(yyvsp[-1].str),mm_strdup("enable"));
}
#line 48969 "preproc.c"
    break;

  case 1460: /* AlterSubscriptionStmt: ALTER OPENTENBASE_P SUBSCRIPTION name ENABLE_P  */
#line 8906 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter opentenbase subscription"),(yyvsp[-1].str),mm_strdup("enable"));
}
#line 48977 "preproc.c"
    break;

  case 1461: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name DISABLE_P  */
#line 8910 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter subscription"),(yyvsp[-1].str),mm_strdup("disable"));
}
#line 48985 "preproc.c"
    break;

  case 1462: /* AlterSubscriptionStmt: ALTER OPENTENBASE_P SUBSCRIPTION name DISABLE_P  */
#line 8914 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter opentenbase subscription"),(yyvsp[-1].str),mm_strdup("disable"));
}
#line 48993 "preproc.c"
    break;

  case 1463: /* DropSubscriptionStmt: DROP SUBSCRIPTION name opt_drop_behavior  */
#line 8922 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop subscription"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49001 "preproc.c"
    break;

  case 1464: /* DropSubscriptionStmt: DROP OPENTENBASE_P SUBSCRIPTION name opt_drop_behavior  */
#line 8926 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop opentenbase subscription"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49009 "preproc.c"
    break;

  case 1465: /* DropSubscriptionStmt: DROP SUBSCRIPTION IF_P EXISTS name opt_drop_behavior  */
#line 8930 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop subscription if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49017 "preproc.c"
    break;

  case 1466: /* DropSubscriptionStmt: DROP OPENTENBASE_P SUBSCRIPTION IF_P EXISTS name opt_drop_behavior  */
#line 8934 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop opentenbase subscription if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49025 "preproc.c"
    break;

  case 1467: /* RuleStmt: CREATE opt_or_replace RULE name AS ON event TO qualified_name where_clause DO opt_instead RuleActionList  */
#line 8942 "preproc.y"
 { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("rule"),(yyvsp[-9].str),mm_strdup("as on"),(yyvsp[-6].str),mm_strdup("to"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("do"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49033 "preproc.c"
    break;

  case 1468: /* RuleActionList: NOTHING  */
#line 8950 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nothing");
}
#line 49041 "preproc.c"
    break;

  case 1469: /* RuleActionList: RuleActionStmt  */
#line 8954 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49049 "preproc.c"
    break;

  case 1470: /* RuleActionList: '(' RuleActionMulti ')'  */
#line 8958 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49057 "preproc.c"
    break;

  case 1471: /* RuleActionMulti: RuleActionMulti ';' RuleActionStmtOrEmpty  */
#line 8966 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(";"),(yyvsp[0].str));
}
#line 49065 "preproc.c"
    break;

  case 1472: /* RuleActionMulti: RuleActionStmtOrEmpty  */
#line 8970 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49073 "preproc.c"
    break;

  case 1473: /* RuleActionStmt: SelectStmt  */
#line 8978 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49081 "preproc.c"
    break;

  case 1474: /* RuleActionStmt: InsertStmt  */
#line 8982 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49089 "preproc.c"
    break;

  case 1475: /* RuleActionStmt: UpdateStmt  */
#line 8986 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49097 "preproc.c"
    break;

  case 1476: /* RuleActionStmt: DeleteStmt  */
#line 8990 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49105 "preproc.c"
    break;

  case 1477: /* RuleActionStmt: NotifyStmt  */
#line 8994 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49113 "preproc.c"
    break;

  case 1478: /* RuleActionStmtOrEmpty: RuleActionStmt  */
#line 9002 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49121 "preproc.c"
    break;

  case 1479: /* RuleActionStmtOrEmpty: %empty  */
#line 9006 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49128 "preproc.c"
    break;

  case 1480: /* event: SELECT  */
#line 9013 "preproc.y"
 { 
 (yyval.str) = mm_strdup("select");
}
#line 49136 "preproc.c"
    break;

  case 1481: /* event: UPDATE  */
#line 9017 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update");
}
#line 49144 "preproc.c"
    break;

  case 1482: /* event: DELETE_P  */
#line 9021 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete");
}
#line 49152 "preproc.c"
    break;

  case 1483: /* event: INSERT  */
#line 9025 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert");
}
#line 49160 "preproc.c"
    break;

  case 1484: /* opt_instead: INSTEAD  */
#line 9033 "preproc.y"
 { 
 (yyval.str) = mm_strdup("instead");
}
#line 49168 "preproc.c"
    break;

  case 1485: /* opt_instead: ALSO  */
#line 9037 "preproc.y"
 { 
 (yyval.str) = mm_strdup("also");
}
#line 49176 "preproc.c"
    break;

  case 1486: /* opt_instead: %empty  */
#line 9041 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49183 "preproc.c"
    break;

  case 1487: /* NotifyStmt: NOTIFY ColId notify_payload  */
#line 9048 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("notify"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49191 "preproc.c"
    break;

  case 1488: /* notify_payload: ',' ecpg_sconst  */
#line 9056 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup(","),(yyvsp[0].str));
}
#line 49199 "preproc.c"
    break;

  case 1489: /* notify_payload: %empty  */
#line 9060 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49206 "preproc.c"
    break;

  case 1490: /* ListenStmt: LISTEN ColId  */
#line 9067 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("listen"),(yyvsp[0].str));
}
#line 49214 "preproc.c"
    break;

  case 1491: /* UnlistenStmt: UNLISTEN ColId  */
#line 9075 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("unlisten"),(yyvsp[0].str));
}
#line 49222 "preproc.c"
    break;

  case 1492: /* UnlistenStmt: UNLISTEN '*'  */
#line 9079 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlisten *");
}
#line 49230 "preproc.c"
    break;

  case 1493: /* TransactionStmt: ABORT_P opt_transaction  */
#line 9087 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("abort"),(yyvsp[0].str));
}
#line 49238 "preproc.c"
    break;

  case 1494: /* TransactionStmt: BEGIN_P opt_transaction transaction_mode_list_or_empty  */
#line 9091 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("begin"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49246 "preproc.c"
    break;

  case 1495: /* TransactionStmt: BEGIN_SUBTXN  */
#line 9095 "preproc.y"
 { 
 (yyval.str) = mm_strdup("begin_subtxn");
}
#line 49254 "preproc.c"
    break;

  case 1496: /* TransactionStmt: START TRANSACTION transaction_mode_list_or_empty  */
#line 9099 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("start transaction"),(yyvsp[0].str));
}
#line 49262 "preproc.c"
    break;

  case 1497: /* TransactionStmt: COMMIT_SUBTXN  */
#line 9103 "preproc.y"
 { 
 (yyval.str) = mm_strdup("commit_subtxn");
}
#line 49270 "preproc.c"
    break;

  case 1498: /* TransactionStmt: COMMIT opt_transaction  */
#line 9107 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("commit"),(yyvsp[0].str));
}
#line 49278 "preproc.c"
    break;

  case 1499: /* TransactionStmt: END_P opt_transaction  */
#line 9111 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("end"),(yyvsp[0].str));
}
#line 49286 "preproc.c"
    break;

  case 1500: /* TransactionStmt: ROLLBACK_SUBTXN  */
#line 9115 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rollback_subtxn");
}
#line 49294 "preproc.c"
    break;

  case 1501: /* TransactionStmt: ROLLBACK opt_transaction  */
#line 9119 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("rollback"),(yyvsp[0].str));
}
#line 49302 "preproc.c"
    break;

  case 1502: /* TransactionStmt: SAVEPOINT ColId  */
#line 9123 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("savepoint"),(yyvsp[0].str));
}
#line 49310 "preproc.c"
    break;

  case 1503: /* TransactionStmt: RELEASE SAVEPOINT ColId  */
#line 9127 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("release savepoint"),(yyvsp[0].str));
}
#line 49318 "preproc.c"
    break;

  case 1504: /* TransactionStmt: RELEASE ColId  */
#line 9131 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("release"),(yyvsp[0].str));
}
#line 49326 "preproc.c"
    break;

  case 1505: /* TransactionStmt: ROLLBACK opt_transaction TO SAVEPOINT ColId  */
#line 9135 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("rollback"),(yyvsp[-3].str),mm_strdup("to savepoint"),(yyvsp[0].str));
}
#line 49334 "preproc.c"
    break;

  case 1506: /* TransactionStmt: ROLLBACK opt_transaction TO ColId  */
#line 9139 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("rollback"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 49342 "preproc.c"
    break;

  case 1507: /* TransactionStmt: PREPARE TRANSACTION ecpg_sconst  */
#line 9143 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("prepare transaction"),(yyvsp[0].str));
}
#line 49350 "preproc.c"
    break;

  case 1508: /* TransactionStmt: COMMIT PREPARED ecpg_sconst  */
#line 9147 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("commit prepared"),(yyvsp[0].str));
}
#line 49358 "preproc.c"
    break;

  case 1509: /* TransactionStmt: ROLLBACK PREPARED ecpg_sconst  */
#line 9151 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("rollback prepared"),(yyvsp[0].str));
}
#line 49366 "preproc.c"
    break;

  case 1510: /* TransactionStmt: COMMIT PREPARED ecpg_sconst FOR CHECK ONLY  */
#line 9155 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("commit prepared"),(yyvsp[-3].str),mm_strdup("for check only"));
}
#line 49374 "preproc.c"
    break;

  case 1511: /* TransactionStmt: ROLLBACK PREPARED ecpg_sconst FOR CHECK ONLY  */
#line 9159 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("rollback prepared"),(yyvsp[-3].str),mm_strdup("for check only"));
}
#line 49382 "preproc.c"
    break;

  case 1512: /* opt_transaction: WORK  */
#line 9167 "preproc.y"
 { 
 (yyval.str) = mm_strdup("work");
}
#line 49390 "preproc.c"
    break;

  case 1513: /* opt_transaction: TRANSACTION  */
#line 9171 "preproc.y"
 { 
 (yyval.str) = mm_strdup("transaction");
}
#line 49398 "preproc.c"
    break;

  case 1514: /* opt_transaction: %empty  */
#line 9175 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49405 "preproc.c"
    break;

  case 1515: /* transaction_mode_item: ISOLATION LEVEL iso_level  */
#line 9182 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("isolation level"),(yyvsp[0].str));
}
#line 49413 "preproc.c"
    break;

  case 1516: /* transaction_mode_item: READ ONLY  */
#line 9186 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read only");
}
#line 49421 "preproc.c"
    break;

  case 1517: /* transaction_mode_item: READ WRITE  */
#line 9190 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read write");
}
#line 49429 "preproc.c"
    break;

  case 1518: /* transaction_mode_item: DEFERRABLE  */
#line 9194 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 49437 "preproc.c"
    break;

  case 1519: /* transaction_mode_item: NOT DEFERRABLE  */
#line 9198 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 49445 "preproc.c"
    break;

  case 1520: /* transaction_mode_list: transaction_mode_item  */
#line 9206 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49453 "preproc.c"
    break;

  case 1521: /* transaction_mode_list: transaction_mode_list ',' transaction_mode_item  */
#line 9210 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49461 "preproc.c"
    break;

  case 1522: /* transaction_mode_list: transaction_mode_list transaction_mode_item  */
#line 9214 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49469 "preproc.c"
    break;

  case 1523: /* transaction_mode_list_or_empty: transaction_mode_list  */
#line 9222 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49477 "preproc.c"
    break;

  case 1524: /* transaction_mode_list_or_empty: %empty  */
#line 9226 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49484 "preproc.c"
    break;

  case 1525: /* ViewStmt: CREATE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 9233 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("view"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49492 "preproc.c"
    break;

  case 1526: /* ViewStmt: CREATE OR REPLACE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 9237 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create or replace"),(yyvsp[-7].str),mm_strdup("view"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49500 "preproc.c"
    break;

  case 1527: /* ViewStmt: CREATE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 9241 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(11,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("recursive view"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49509 "preproc.c"
    break;

  case 1528: /* ViewStmt: CREATE OR REPLACE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 9246 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(11,mm_strdup("create or replace"),(yyvsp[-10].str),mm_strdup("recursive view"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49518 "preproc.c"
    break;

  case 1529: /* opt_check_option: WITH CHECK OPTION  */
#line 9255 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with check option");
}
#line 49526 "preproc.c"
    break;

  case 1530: /* opt_check_option: WITH CASCADED CHECK OPTION  */
#line 9259 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with cascaded check option");
}
#line 49534 "preproc.c"
    break;

  case 1531: /* opt_check_option: WITH LOCAL CHECK OPTION  */
#line 9263 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with local check option");
}
#line 49542 "preproc.c"
    break;

  case 1532: /* opt_check_option: %empty  */
#line 9267 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49549 "preproc.c"
    break;

  case 1533: /* LoadStmt: LOAD file_name  */
#line 9274 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("load"),(yyvsp[0].str));
}
#line 49557 "preproc.c"
    break;

  case 1534: /* CreatedbStmt: CREATE DATABASE database_name opt_with createdb_opt_list  */
#line 9282 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create database"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49565 "preproc.c"
    break;

  case 1535: /* createdb_opt_list: createdb_opt_items  */
#line 9290 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49573 "preproc.c"
    break;

  case 1536: /* createdb_opt_list: %empty  */
#line 9294 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49580 "preproc.c"
    break;

  case 1537: /* createdb_opt_items: createdb_opt_item  */
#line 9301 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49588 "preproc.c"
    break;

  case 1538: /* createdb_opt_items: createdb_opt_items createdb_opt_item  */
#line 9305 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49596 "preproc.c"
    break;

  case 1539: /* createdb_opt_item: createdb_opt_name opt_equal SignedIconst  */
#line 9313 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49604 "preproc.c"
    break;

  case 1540: /* createdb_opt_item: createdb_opt_name opt_equal opt_boolean_or_string  */
#line 9317 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49612 "preproc.c"
    break;

  case 1541: /* createdb_opt_item: createdb_opt_name opt_equal DEFAULT  */
#line 9321 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("default"));
}
#line 49620 "preproc.c"
    break;

  case 1542: /* createdb_opt_name: ecpg_ident  */
#line 9329 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49628 "preproc.c"
    break;

  case 1543: /* createdb_opt_name: CONNECTION LIMIT  */
#line 9333 "preproc.y"
 { 
 (yyval.str) = mm_strdup("connection limit");
}
#line 49636 "preproc.c"
    break;

  case 1544: /* createdb_opt_name: ENCODING  */
#line 9337 "preproc.y"
 { 
 (yyval.str) = mm_strdup("encoding");
}
#line 49644 "preproc.c"
    break;

  case 1545: /* createdb_opt_name: LOCATION  */
#line 9341 "preproc.y"
 { 
 (yyval.str) = mm_strdup("location");
}
#line 49652 "preproc.c"
    break;

  case 1546: /* createdb_opt_name: OWNER  */
#line 9345 "preproc.y"
 { 
 (yyval.str) = mm_strdup("owner");
}
#line 49660 "preproc.c"
    break;

  case 1547: /* createdb_opt_name: TABLESPACE  */
#line 9349 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 49668 "preproc.c"
    break;

  case 1548: /* createdb_opt_name: TEMPLATE  */
#line 9353 "preproc.y"
 { 
 (yyval.str) = mm_strdup("template");
}
#line 49676 "preproc.c"
    break;

  case 1549: /* opt_equal: '='  */
#line 9361 "preproc.y"
 { 
 (yyval.str) = mm_strdup("=");
}
#line 49684 "preproc.c"
    break;

  case 1550: /* opt_equal: %empty  */
#line 9365 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49691 "preproc.c"
    break;

  case 1551: /* AlterDatabaseStmt: ALTER DATABASE database_name WITH createdb_opt_list  */
#line 9372 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 49699 "preproc.c"
    break;

  case 1552: /* AlterDatabaseStmt: ALTER DATABASE database_name createdb_opt_list  */
#line 9376 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter database"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49707 "preproc.c"
    break;

  case 1553: /* AlterDatabaseStmt: ALTER DATABASE database_name SET TABLESPACE name  */
#line 9380 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("set tablespace"),(yyvsp[0].str));
}
#line 49715 "preproc.c"
    break;

  case 1554: /* AlterDatabaseSetStmt: ALTER DATABASE database_name SetResetClause  */
#line 9388 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter database"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49723 "preproc.c"
    break;

  case 1555: /* DropdbStmt: DROP DATABASE database_name  */
#line 9396 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop database"),(yyvsp[0].str));
}
#line 49731 "preproc.c"
    break;

  case 1556: /* DropdbStmt: DROP DATABASE IF_P EXISTS database_name  */
#line 9400 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop database if exists"),(yyvsp[0].str));
}
#line 49739 "preproc.c"
    break;

  case 1557: /* DropdbStmt: DROP DATABASE PREPARE database_name  */
#line 9404 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop database prepare"),(yyvsp[0].str));
}
#line 49747 "preproc.c"
    break;

  case 1558: /* DropdbStmt: DROP DATABASE PREPARE IF_P EXISTS database_name  */
#line 9408 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop database prepare if exists"),(yyvsp[0].str));
}
#line 49755 "preproc.c"
    break;

  case 1559: /* AlterCollationStmt: ALTER COLLATION any_name REFRESH VERSION_P  */
#line 9416 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter collation"),(yyvsp[-2].str),mm_strdup("refresh version"));
}
#line 49763 "preproc.c"
    break;

  case 1560: /* AlterSystemStmt: ALTER SYSTEM_P SET generic_set  */
#line 9424 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("alter system set"),(yyvsp[0].str));
}
#line 49771 "preproc.c"
    break;

  case 1561: /* AlterSystemStmt: ALTER SYSTEM_P RESET generic_reset  */
#line 9428 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("alter system reset"),(yyvsp[0].str));
}
#line 49779 "preproc.c"
    break;

  case 1562: /* CreateDomainStmt: CREATE DOMAIN_P any_name opt_as Typename ColQualList  */
#line 9436 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create domain"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49787 "preproc.c"
    break;

  case 1563: /* AlterDomainStmt: ALTER DOMAIN_P any_name alter_column_default  */
#line 9444 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49795 "preproc.c"
    break;

  case 1564: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP NOT NULL_P  */
#line 9448 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("drop not null"));
}
#line 49803 "preproc.c"
    break;

  case 1565: /* AlterDomainStmt: ALTER DOMAIN_P any_name SET NOT NULL_P  */
#line 9452 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("set not null"));
}
#line 49811 "preproc.c"
    break;

  case 1566: /* AlterDomainStmt: ALTER DOMAIN_P any_name ADD_P TableConstraint  */
#line 9456 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-2].str),mm_strdup("add"),(yyvsp[0].str));
}
#line 49819 "preproc.c"
    break;

  case 1567: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT name opt_drop_behavior  */
#line 9460 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter domain"),(yyvsp[-4].str),mm_strdup("drop constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49827 "preproc.c"
    break;

  case 1568: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 9464 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter domain"),(yyvsp[-6].str),mm_strdup("drop constraint if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49835 "preproc.c"
    break;

  case 1569: /* AlterDomainStmt: ALTER DOMAIN_P any_name VALIDATE CONSTRAINT name  */
#line 9468 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("validate constraint"),(yyvsp[0].str));
}
#line 49843 "preproc.c"
    break;

  case 1570: /* opt_as: AS  */
#line 9476 "preproc.y"
 { 
 (yyval.str) = mm_strdup("as");
}
#line 49851 "preproc.c"
    break;

  case 1571: /* opt_as: %empty  */
#line 9480 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49858 "preproc.c"
    break;

  case 1572: /* AlterTSDictionaryStmt: ALTER TEXT_P SEARCH DICTIONARY any_name definition  */
#line 9487 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter text search dictionary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49866 "preproc.c"
    break;

  case 1573: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ADD_P MAPPING FOR name_list any_with any_name_list  */
#line 9495 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("add mapping for"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49874 "preproc.c"
    break;

  case 1574: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list any_with any_name_list  */
#line 9499 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("alter mapping for"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49882 "preproc.c"
    break;

  case 1575: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING REPLACE any_name any_with any_name  */
#line 9503 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("alter mapping replace"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49890 "preproc.c"
    break;

  case 1576: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list REPLACE any_name any_with any_name  */
#line 9507 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("alter text search configuration"),(yyvsp[-8].str),mm_strdup("alter mapping for"),(yyvsp[-4].str),mm_strdup("replace"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49898 "preproc.c"
    break;

  case 1577: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING FOR name_list  */
#line 9511 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-4].str),mm_strdup("drop mapping for"),(yyvsp[0].str));
}
#line 49906 "preproc.c"
    break;

  case 1578: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING IF_P EXISTS FOR name_list  */
#line 9515 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("drop mapping if exists for"),(yyvsp[0].str));
}
#line 49914 "preproc.c"
    break;

  case 1579: /* any_with: WITH  */
#line 9523 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with");
}
#line 49922 "preproc.c"
    break;

  case 1580: /* any_with: WITH_LA  */
#line 9527 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with");
}
#line 49930 "preproc.c"
    break;

  case 1581: /* CreateConversionStmt: CREATE opt_default CONVERSION_P any_name FOR ecpg_sconst TO ecpg_sconst FROM any_name  */
#line 9535 "preproc.y"
 { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-8].str),mm_strdup("conversion"),(yyvsp[-6].str),mm_strdup("for"),(yyvsp[-4].str),mm_strdup("to"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 49938 "preproc.c"
    break;

  case 1582: /* ClusterStmt: CLUSTER opt_verbose qualified_name cluster_index_specification  */
#line 9543 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("cluster"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49946 "preproc.c"
    break;

  case 1583: /* ClusterStmt: CLUSTER opt_verbose  */
#line 9547 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cluster"),(yyvsp[0].str));
}
#line 49954 "preproc.c"
    break;

  case 1584: /* ClusterStmt: CLUSTER opt_verbose index_name ON qualified_name  */
#line 9551 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("cluster"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("on"),(yyvsp[0].str));
}
#line 49962 "preproc.c"
    break;

  case 1585: /* cluster_index_specification: USING index_name  */
#line 9559 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 49970 "preproc.c"
    break;

  case 1586: /* cluster_index_specification: %empty  */
#line 9563 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49977 "preproc.c"
    break;

  case 1587: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose analyze_sync_option  */
#line 9570 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("vacuum"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49985 "preproc.c"
    break;

  case 1588: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose qualified_name analyze_sync_option  */
#line 9574 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("vacuum"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49993 "preproc.c"
    break;

  case 1589: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose AnalyzeStmt  */
#line 9578 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("vacuum"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50001 "preproc.c"
    break;

  case 1590: /* VacuumStmt: VACUUM '(' vacuum_option_list ')' analyze_sync_option  */
#line 9582 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("vacuum ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 50009 "preproc.c"
    break;

  case 1591: /* VacuumStmt: VACUUM '(' vacuum_option_list ')' qualified_name opt_name_list analyze_sync_option  */
#line 9586 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("vacuum ("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50017 "preproc.c"
    break;

  case 1592: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose qualified_name SHARDING '(' Iconst ')'  */
#line 9590 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("vacuum"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("sharding ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50025 "preproc.c"
    break;

  case 1593: /* vacuum_option_list: vacuum_option_elem  */
#line 9598 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50033 "preproc.c"
    break;

  case 1594: /* vacuum_option_list: vacuum_option_list ',' vacuum_option_elem  */
#line 9602 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 50041 "preproc.c"
    break;

  case 1595: /* vacuum_option_elem: analyze_keyword  */
#line 9610 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50049 "preproc.c"
    break;

  case 1596: /* vacuum_option_elem: VERBOSE  */
#line 9614 "preproc.y"
 { 
 (yyval.str) = mm_strdup("verbose");
}
#line 50057 "preproc.c"
    break;

  case 1597: /* vacuum_option_elem: FREEZE  */
#line 9618 "preproc.y"
 { 
 (yyval.str) = mm_strdup("freeze");
}
#line 50065 "preproc.c"
    break;

  case 1598: /* vacuum_option_elem: FULL  */
#line 9622 "preproc.y"
 { 
 (yyval.str) = mm_strdup("full");
}
#line 50073 "preproc.c"
    break;

  case 1599: /* vacuum_option_elem: ecpg_ident  */
#line 9626 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50081 "preproc.c"
    break;

  case 1600: /* AnalyzeStmt: analyze_keyword opt_verbose analyze_sync_option  */
#line 9634 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50089 "preproc.c"
    break;

  case 1601: /* AnalyzeStmt: analyze_keyword opt_verbose qualified_name opt_name_list analyze_sync_option  */
#line 9638 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50097 "preproc.c"
    break;

  case 1602: /* AnalyzeStmt: analyze_keyword '(' analyze_option_list ')' analyze_sync_option  */
#line 9642 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 50105 "preproc.c"
    break;

  case 1603: /* AnalyzeStmt: analyze_keyword '(' analyze_option_list ')' qualified_name opt_name_list analyze_sync_option  */
#line 9646 "preproc.y"
 { 
 (yyval.str) = cat_str(7,(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50113 "preproc.c"
    break;

  case 1604: /* analyze_keyword: ANALYZE  */
#line 9654 "preproc.y"
 { 
 (yyval.str) = mm_strdup("analyze");
}
#line 50121 "preproc.c"
    break;

  case 1605: /* analyze_keyword: ANALYSE  */
#line 9658 "preproc.y"
 { 
 (yyval.str) = mm_strdup("analyse");
}
#line 50129 "preproc.c"
    break;

  case 1606: /* analyze_sync_option: SYNC ALL  */
#line 9666 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sync all");
}
#line 50137 "preproc.c"
    break;

  case 1607: /* analyze_sync_option: SYNC TO pgxcnode_list  */
#line 9670 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("sync to"),(yyvsp[0].str));
}
#line 50145 "preproc.c"
    break;

  case 1608: /* analyze_sync_option: SYNC FROM pgxcnode_name  */
#line 9674 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("sync from"),(yyvsp[0].str));
}
#line 50153 "preproc.c"
    break;

  case 1609: /* analyze_sync_option: %empty  */
#line 9678 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50160 "preproc.c"
    break;

  case 1610: /* opt_verbose: VERBOSE  */
#line 9685 "preproc.y"
 { 
 (yyval.str) = mm_strdup("verbose");
}
#line 50168 "preproc.c"
    break;

  case 1611: /* opt_verbose: %empty  */
#line 9689 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50175 "preproc.c"
    break;

  case 1612: /* opt_full: FULL  */
#line 9696 "preproc.y"
 { 
 (yyval.str) = mm_strdup("full");
}
#line 50183 "preproc.c"
    break;

  case 1613: /* opt_full: %empty  */
#line 9700 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50190 "preproc.c"
    break;

  case 1614: /* opt_freeze: FREEZE  */
#line 9707 "preproc.y"
 { 
 (yyval.str) = mm_strdup("freeze");
}
#line 50198 "preproc.c"
    break;

  case 1615: /* opt_freeze: %empty  */
#line 9711 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50205 "preproc.c"
    break;

  case 1616: /* analyze_option_list: analyze_option_elem  */
#line 9718 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50213 "preproc.c"
    break;

  case 1617: /* analyze_option_list: analyze_option_list ',' analyze_option_elem  */
#line 9722 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 50221 "preproc.c"
    break;

  case 1618: /* analyze_option_elem: VERBOSE  */
#line 9730 "preproc.y"
 { 
 (yyval.str) = mm_strdup("verbose");
}
#line 50229 "preproc.c"
    break;

  case 1619: /* analyze_option_elem: COORDINATOR  */
#line 9734 "preproc.y"
 { 
 (yyval.str) = mm_strdup("coordinator");
}
#line 50237 "preproc.c"
    break;

  case 1620: /* opt_name_list: '(' name_list ')'  */
#line 9742 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50245 "preproc.c"
    break;

  case 1621: /* opt_name_list: %empty  */
#line 9746 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50252 "preproc.c"
    break;

  case 1622: /* AuditStmt: audit_or_noaudit audit_stmt_list opt_when_success_or_not  */
#line 9753 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50260 "preproc.c"
    break;

  case 1623: /* AuditStmt: audit_or_noaudit audit_stmt_list BY audit_user_list opt_when_success_or_not  */
#line 9757 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("by"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50268 "preproc.c"
    break;

  case 1624: /* AuditStmt: audit_or_noaudit audit_stmt_list ON audit_obj_type audit_obj opt_when_success_or_not  */
#line 9761 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50276 "preproc.c"
    break;

  case 1625: /* AuditStmt: audit_or_noaudit audit_stmt_list ON audit_obj opt_when_success_or_not  */
#line 9765 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50284 "preproc.c"
    break;

  case 1626: /* audit_or_noaudit: AUDIT  */
#line 9773 "preproc.y"
 { 
 (yyval.str) = mm_strdup("audit");
}
#line 50292 "preproc.c"
    break;

  case 1627: /* audit_or_noaudit: NOAUDIT  */
#line 9777 "preproc.y"
 { 
 (yyval.str) = mm_strdup("noaudit");
}
#line 50300 "preproc.c"
    break;

  case 1628: /* opt_when_success_or_not: WHENEVER success_or_not SUCCESSFUL  */
#line 9785 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("whenever"),(yyvsp[-1].str),mm_strdup("successful"));
}
#line 50308 "preproc.c"
    break;

  case 1629: /* opt_when_success_or_not: %empty  */
#line 9789 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50315 "preproc.c"
    break;

  case 1630: /* success_or_not: NOT  */
#line 9796 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not");
}
#line 50323 "preproc.c"
    break;

  case 1631: /* success_or_not: %empty  */
#line 9800 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50330 "preproc.c"
    break;

  case 1632: /* audit_stmt_list: audit_stmts  */
#line 9807 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50338 "preproc.c"
    break;

  case 1633: /* audit_stmt_list: ALL  */
#line 9811 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 50346 "preproc.c"
    break;

  case 1634: /* audit_stmts: audit_stmt  */
#line 9819 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50354 "preproc.c"
    break;

  case 1635: /* audit_stmts: audit_stmts ',' audit_stmt  */
#line 9823 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 50362 "preproc.c"
    break;

  case 1636: /* audit_stmt: ALTER SYSTEM_P  */
#line 9831 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter system");
}
#line 50370 "preproc.c"
    break;

  case 1637: /* audit_stmt: DATABASE  */
#line 9835 "preproc.y"
 { 
 (yyval.str) = mm_strdup("database");
}
#line 50378 "preproc.c"
    break;

  case 1638: /* audit_stmt: ALTER DATABASE  */
#line 9839 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter database");
}
#line 50386 "preproc.c"
    break;

  case 1639: /* audit_stmt: CREATE DATABASE  */
#line 9843 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create database");
}
#line 50394 "preproc.c"
    break;

  case 1640: /* audit_stmt: DROP DATABASE  */
#line 9847 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop database");
}
#line 50402 "preproc.c"
    break;

  case 1641: /* audit_stmt: EXTENSION  */
#line 9851 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extension");
}
#line 50410 "preproc.c"
    break;

  case 1642: /* audit_stmt: ALTER EXTENSION  */
#line 9855 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter extension");
}
#line 50418 "preproc.c"
    break;

  case 1643: /* audit_stmt: CREATE EXTENSION  */
#line 9859 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create extension");
}
#line 50426 "preproc.c"
    break;

  case 1644: /* audit_stmt: DROP EXTENSION  */
#line 9863 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop extension");
}
#line 50434 "preproc.c"
    break;

  case 1645: /* audit_stmt: FUNCTION  */
#line 9867 "preproc.y"
 { 
 (yyval.str) = mm_strdup("function");
}
#line 50442 "preproc.c"
    break;

  case 1646: /* audit_stmt: ALTER FUNCTION  */
#line 9871 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter function");
}
#line 50450 "preproc.c"
    break;

  case 1647: /* audit_stmt: CREATE FUNCTION  */
#line 9875 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create function");
}
#line 50458 "preproc.c"
    break;

  case 1648: /* audit_stmt: DROP FUNCTION  */
#line 9879 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop function");
}
#line 50466 "preproc.c"
    break;

  case 1649: /* audit_stmt: GROUP_P  */
#line 9883 "preproc.y"
 { 
 (yyval.str) = mm_strdup("group");
}
#line 50474 "preproc.c"
    break;

  case 1650: /* audit_stmt: CREATE NODE GROUP_P  */
#line 9887 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create node group");
}
#line 50482 "preproc.c"
    break;

  case 1651: /* audit_stmt: CREATE SHARDING GROUP_P  */
#line 9891 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create sharding group");
}
#line 50490 "preproc.c"
    break;

  case 1652: /* audit_stmt: DROP NODE GROUP_P  */
#line 9895 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop node group");
}
#line 50498 "preproc.c"
    break;

  case 1653: /* audit_stmt: DROP SHARDING IN_P GROUP_P  */
#line 9899 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop sharding in group");
}
#line 50506 "preproc.c"
    break;

  case 1654: /* audit_stmt: INDEX  */
#line 9903 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 50514 "preproc.c"
    break;

  case 1655: /* audit_stmt: ALTER INDEX  */
#line 9907 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter index");
}
#line 50522 "preproc.c"
    break;

  case 1656: /* audit_stmt: CREATE INDEX  */
#line 9911 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create index");
}
#line 50530 "preproc.c"
    break;

  case 1657: /* audit_stmt: DROP INDEX  */
#line 9915 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop index");
}
#line 50538 "preproc.c"
    break;

  case 1658: /* audit_stmt: MATERIALIZED VIEW  */
#line 9919 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 50546 "preproc.c"
    break;

  case 1659: /* audit_stmt: ALTER MATERIALIZED VIEW  */
#line 9923 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter materialized view");
}
#line 50554 "preproc.c"
    break;

  case 1660: /* audit_stmt: CREATE MATERIALIZED VIEW  */
#line 9927 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create materialized view");
}
#line 50562 "preproc.c"
    break;

  case 1661: /* audit_stmt: DROP MATERIALIZED VIEW  */
#line 9931 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop materialized view");
}
#line 50570 "preproc.c"
    break;

  case 1662: /* audit_stmt: NODE  */
#line 9935 "preproc.y"
 { 
 (yyval.str) = mm_strdup("node");
}
#line 50578 "preproc.c"
    break;

  case 1663: /* audit_stmt: ALTER NODE  */
#line 9939 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter node");
}
#line 50586 "preproc.c"
    break;

  case 1664: /* audit_stmt: CREATE NODE  */
#line 9943 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create node");
}
#line 50594 "preproc.c"
    break;

  case 1665: /* audit_stmt: DROP NODE  */
#line 9947 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop node");
}
#line 50602 "preproc.c"
    break;

  case 1666: /* audit_stmt: PARTITION  */
#line 9951 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partition");
}
#line 50610 "preproc.c"
    break;

  case 1667: /* audit_stmt: ADD_P PARTITIONS  */
#line 9955 "preproc.y"
 { 
 (yyval.str) = mm_strdup("add partitions");
}
#line 50618 "preproc.c"
    break;

  case 1668: /* audit_stmt: ROLE  */
#line 9959 "preproc.y"
 { 
 (yyval.str) = mm_strdup("role");
}
#line 50626 "preproc.c"
    break;

  case 1669: /* audit_stmt: ALTER ROLE  */
#line 9963 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter role");
}
#line 50634 "preproc.c"
    break;

  case 1670: /* audit_stmt: CREATE ROLE  */
#line 9967 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create role");
}
#line 50642 "preproc.c"
    break;

  case 1671: /* audit_stmt: DROP ROLE  */
#line 9971 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop role");
}
#line 50650 "preproc.c"
    break;

  case 1672: /* audit_stmt: SET ROLE  */
#line 9975 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set role");
}
#line 50658 "preproc.c"
    break;

  case 1673: /* audit_stmt: SCHEMA  */
#line 9979 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 50666 "preproc.c"
    break;

  case 1674: /* audit_stmt: ALTER SCHEMA  */
#line 9983 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter schema");
}
#line 50674 "preproc.c"
    break;

  case 1675: /* audit_stmt: CREATE SCHEMA  */
#line 9987 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create schema");
}
#line 50682 "preproc.c"
    break;

  case 1676: /* audit_stmt: DROP SCHEMA  */
#line 9991 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop schema");
}
#line 50690 "preproc.c"
    break;

  case 1677: /* audit_stmt: SEQUENCE  */
#line 9995 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 50698 "preproc.c"
    break;

  case 1678: /* audit_stmt: CREATE SEQUENCE  */
#line 9999 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create sequence");
}
#line 50706 "preproc.c"
    break;

  case 1679: /* audit_stmt: DROP SEQUENCE  */
#line 10003 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop sequence");
}
#line 50714 "preproc.c"
    break;

  case 1680: /* audit_stmt: TABLE  */
#line 10007 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 50722 "preproc.c"
    break;

  case 1681: /* audit_stmt: CREATE TABLE  */
#line 10011 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create table");
}
#line 50730 "preproc.c"
    break;

  case 1682: /* audit_stmt: DROP TABLE  */
#line 10015 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop table");
}
#line 50738 "preproc.c"
    break;

  case 1683: /* audit_stmt: TRUNCATE TABLE  */
#line 10019 "preproc.y"
 { 
 (yyval.str) = mm_strdup("truncate table");
}
#line 50746 "preproc.c"
    break;

  case 1684: /* audit_stmt: TABLESPACE  */
#line 10023 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 50754 "preproc.c"
    break;

  case 1685: /* audit_stmt: ALTER TABLESPACE  */
#line 10027 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter tablespace");
}
#line 50762 "preproc.c"
    break;

  case 1686: /* audit_stmt: CREATE TABLESPACE  */
#line 10031 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create tablespace");
}
#line 50770 "preproc.c"
    break;

  case 1687: /* audit_stmt: DROP TABLESPACE  */
#line 10035 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop tablespace");
}
#line 50778 "preproc.c"
    break;

  case 1688: /* audit_stmt: TRIGGER  */
#line 10039 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trigger");
}
#line 50786 "preproc.c"
    break;

  case 1689: /* audit_stmt: ALTER TRIGGER  */
#line 10043 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter trigger");
}
#line 50794 "preproc.c"
    break;

  case 1690: /* audit_stmt: CREATE TRIGGER  */
#line 10047 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create trigger");
}
#line 50802 "preproc.c"
    break;

  case 1691: /* audit_stmt: DROP TRIGGER  */
#line 10051 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop trigger");
}
#line 50810 "preproc.c"
    break;

  case 1692: /* audit_stmt: DISABLE_P TRIGGER  */
#line 10055 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable trigger");
}
#line 50818 "preproc.c"
    break;

  case 1693: /* audit_stmt: ENABLE_P TRIGGER  */
#line 10059 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable trigger");
}
#line 50826 "preproc.c"
    break;

  case 1694: /* audit_stmt: TYPE_P  */
#line 10063 "preproc.y"
 { 
 (yyval.str) = mm_strdup("type");
}
#line 50834 "preproc.c"
    break;

  case 1695: /* audit_stmt: ALTER TYPE_P  */
#line 10067 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter type");
}
#line 50842 "preproc.c"
    break;

  case 1696: /* audit_stmt: CREATE TYPE_P  */
#line 10071 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create type");
}
#line 50850 "preproc.c"
    break;

  case 1697: /* audit_stmt: DROP TYPE_P  */
#line 10075 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop type");
}
#line 50858 "preproc.c"
    break;

  case 1698: /* audit_stmt: USER  */
#line 10079 "preproc.y"
 { 
 (yyval.str) = mm_strdup("user");
}
#line 50866 "preproc.c"
    break;

  case 1699: /* audit_stmt: ALTER USER  */
#line 10083 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter user");
}
#line 50874 "preproc.c"
    break;

  case 1700: /* audit_stmt: CREATE USER  */
#line 10087 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create user");
}
#line 50882 "preproc.c"
    break;

  case 1701: /* audit_stmt: DROP USER  */
#line 10091 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop user");
}
#line 50890 "preproc.c"
    break;

  case 1702: /* audit_stmt: VIEW  */
#line 10095 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 50898 "preproc.c"
    break;

  case 1703: /* audit_stmt: ALTER VIEW  */
#line 10099 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter view");
}
#line 50906 "preproc.c"
    break;

  case 1704: /* audit_stmt: CREATE VIEW  */
#line 10103 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create view");
}
#line 50914 "preproc.c"
    break;

  case 1705: /* audit_stmt: DROP VIEW  */
#line 10107 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop view");
}
#line 50922 "preproc.c"
    break;

  case 1706: /* audit_stmt: ALTER SEQUENCE  */
#line 10111 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter sequence");
}
#line 50930 "preproc.c"
    break;

  case 1707: /* audit_stmt: ALTER TABLE  */
#line 10115 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter table");
}
#line 50938 "preproc.c"
    break;

  case 1708: /* audit_stmt: COMMENT TABLE  */
#line 10119 "preproc.y"
 { 
 (yyval.str) = mm_strdup("comment table");
}
#line 50946 "preproc.c"
    break;

  case 1709: /* audit_stmt: DELETE_P TABLE  */
#line 10123 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete table");
}
#line 50954 "preproc.c"
    break;

  case 1710: /* audit_stmt: GRANT FUNCTION  */
#line 10127 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grant function");
}
#line 50962 "preproc.c"
    break;

  case 1711: /* audit_stmt: GRANT SEQUENCE  */
#line 10131 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grant sequence");
}
#line 50970 "preproc.c"
    break;

  case 1712: /* audit_stmt: GRANT TABLE  */
#line 10135 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grant table");
}
#line 50978 "preproc.c"
    break;

  case 1713: /* audit_stmt: GRANT TYPE_P  */
#line 10139 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grant type");
}
#line 50986 "preproc.c"
    break;

  case 1714: /* audit_stmt: INSERT TABLE  */
#line 10143 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert table");
}
#line 50994 "preproc.c"
    break;

  case 1715: /* audit_stmt: LOCK_P TABLE  */
#line 10147 "preproc.y"
 { 
 (yyval.str) = mm_strdup("lock table");
}
#line 51002 "preproc.c"
    break;

  case 1716: /* audit_stmt: SELECT SEQUENCE  */
#line 10151 "preproc.y"
 { 
 (yyval.str) = mm_strdup("select sequence");
}
#line 51010 "preproc.c"
    break;

  case 1717: /* audit_stmt: SELECT TABLE  */
#line 10155 "preproc.y"
 { 
 (yyval.str) = mm_strdup("select table");
}
#line 51018 "preproc.c"
    break;

  case 1718: /* audit_stmt: SYSTEM_P AUDIT  */
#line 10159 "preproc.y"
 { 
 (yyval.str) = mm_strdup("system audit");
}
#line 51026 "preproc.c"
    break;

  case 1719: /* audit_stmt: SYSTEM_P GRANT  */
#line 10163 "preproc.y"
 { 
 (yyval.str) = mm_strdup("system grant");
}
#line 51034 "preproc.c"
    break;

  case 1720: /* audit_stmt: UPDATE TABLE  */
#line 10167 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update table");
}
#line 51042 "preproc.c"
    break;

  case 1721: /* audit_stmt: ALTER  */
#line 10171 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter");
}
#line 51050 "preproc.c"
    break;

  case 1722: /* audit_stmt: AUDIT  */
#line 10175 "preproc.y"
 { 
 (yyval.str) = mm_strdup("audit");
}
#line 51058 "preproc.c"
    break;

  case 1723: /* audit_stmt: COMMENT  */
#line 10179 "preproc.y"
 { 
 (yyval.str) = mm_strdup("comment");
}
#line 51066 "preproc.c"
    break;

  case 1724: /* audit_stmt: DELETE_P  */
#line 10183 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete");
}
#line 51074 "preproc.c"
    break;

  case 1725: /* audit_stmt: GRANT  */
#line 10187 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grant");
}
#line 51082 "preproc.c"
    break;

  case 1726: /* audit_stmt: INSERT  */
#line 10191 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert");
}
#line 51090 "preproc.c"
    break;

  case 1727: /* audit_stmt: LOCK_P  */
#line 10195 "preproc.y"
 { 
 (yyval.str) = mm_strdup("lock");
}
#line 51098 "preproc.c"
    break;

  case 1728: /* audit_stmt: RENAME  */
#line 10199 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rename");
}
#line 51106 "preproc.c"
    break;

  case 1729: /* audit_stmt: SELECT  */
#line 10203 "preproc.y"
 { 
 (yyval.str) = mm_strdup("select");
}
#line 51114 "preproc.c"
    break;

  case 1730: /* audit_stmt: UPDATE  */
#line 10207 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update");
}
#line 51122 "preproc.c"
    break;

  case 1731: /* audit_user_list: ColId  */
#line 10215 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51130 "preproc.c"
    break;

  case 1732: /* audit_user_list: audit_user_list ',' ColId  */
#line 10219 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 51138 "preproc.c"
    break;

  case 1733: /* audit_obj_type: SEQUENCE  */
#line 10227 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 51146 "preproc.c"
    break;

  case 1734: /* audit_obj_type: TABLE  */
#line 10231 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 51154 "preproc.c"
    break;

  case 1735: /* audit_obj_type: VIEW  */
#line 10235 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 51162 "preproc.c"
    break;

  case 1736: /* audit_obj_type: MATERIALIZED VIEW  */
#line 10239 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 51170 "preproc.c"
    break;

  case 1737: /* audit_obj_type: FUNCTION  */
#line 10243 "preproc.y"
 { 
 (yyval.str) = mm_strdup("function");
}
#line 51178 "preproc.c"
    break;

  case 1738: /* audit_obj_type: TYPE_P  */
#line 10247 "preproc.y"
 { 
 (yyval.str) = mm_strdup("type");
}
#line 51186 "preproc.c"
    break;

  case 1739: /* audit_obj: ColId  */
#line 10255 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51194 "preproc.c"
    break;

  case 1740: /* audit_obj: ColId '.' ColId  */
#line 10259 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 51202 "preproc.c"
    break;

  case 1741: /* audit_obj: ColId '.' ColId '.' ColId  */
#line 10263 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("."),(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 51210 "preproc.c"
    break;

  case 1742: /* audit_obj: ColId '.' ColId '.' ColId '.' ColId  */
#line 10267 "preproc.y"
 { 
 (yyval.str) = cat_str(7,(yyvsp[-6].str),mm_strdup("."),(yyvsp[-4].str),mm_strdup("."),(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 51218 "preproc.c"
    break;

  case 1743: /* audit_obj: DEFAULT  */
#line 10271 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 51226 "preproc.c"
    break;

  case 1744: /* CleanAuditStmt: CLEAN ALL AUDIT  */
#line 10279 "preproc.y"
 { 
 (yyval.str) = mm_strdup("clean all audit");
}
#line 51234 "preproc.c"
    break;

  case 1745: /* CleanAuditStmt: CLEAN STATEMENT AUDIT  */
#line 10283 "preproc.y"
 { 
 (yyval.str) = mm_strdup("clean statement audit");
}
#line 51242 "preproc.c"
    break;

  case 1746: /* CleanAuditStmt: CLEAN USER AUDIT  */
#line 10287 "preproc.y"
 { 
 (yyval.str) = mm_strdup("clean user audit");
}
#line 51250 "preproc.c"
    break;

  case 1747: /* CleanAuditStmt: CLEAN USER AUDIT BY audit_user_list  */
#line 10291 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("clean user audit by"),(yyvsp[0].str));
}
#line 51258 "preproc.c"
    break;

  case 1748: /* CleanAuditStmt: CLEAN OBJECT_P AUDIT  */
#line 10295 "preproc.y"
 { 
 (yyval.str) = mm_strdup("clean object audit");
}
#line 51266 "preproc.c"
    break;

  case 1749: /* CleanAuditStmt: CLEAN OBJECT_P AUDIT ON audit_obj_type audit_obj  */
#line 10299 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("clean object audit on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51274 "preproc.c"
    break;

  case 1750: /* CleanAuditStmt: CLEAN OBJECT_P AUDIT ON audit_obj  */
#line 10303 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("clean object audit on"),(yyvsp[0].str));
}
#line 51282 "preproc.c"
    break;

  case 1751: /* CleanAuditStmt: CLEAN UNKNOWN AUDIT  */
#line 10307 "preproc.y"
 { 
 (yyval.str) = mm_strdup("clean unknown audit");
}
#line 51290 "preproc.c"
    break;

  case 1752: /* SampleStmt: SAMPLE qualified_name '(' Iconst ')'  */
#line 10315 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("sample"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51298 "preproc.c"
    break;

  case 1753: /* PauseStmt: PAUSE CLUSTER  */
#line 10323 "preproc.y"
 { 
 (yyval.str) = mm_strdup("pause cluster");
}
#line 51306 "preproc.c"
    break;

  case 1754: /* PauseStmt: UNPAUSE CLUSTER  */
#line 10327 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unpause cluster");
}
#line 51314 "preproc.c"
    break;

  case 1755: /* BarrierStmt: CREATE BARRIER opt_barrier_id  */
#line 10335 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("create barrier"),(yyvsp[0].str));
}
#line 51322 "preproc.c"
    break;

  case 1756: /* opt_barrier_id: ecpg_sconst  */
#line 10343 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51330 "preproc.c"
    break;

  case 1757: /* opt_barrier_id: %empty  */
#line 10347 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 51337 "preproc.c"
    break;

  case 1758: /* CreateNodeStmt: CREATE NODE pgxcnode_name OptWith  */
#line 10354 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create node"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51345 "preproc.c"
    break;

  case 1759: /* CreateNodeStmt: CREATE GTM NODE pgxcnode_name OptWith  */
#line 10358 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create gtm node"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51353 "preproc.c"
    break;

  case 1760: /* pgxcnode_name: ColId  */
#line 10366 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51361 "preproc.c"
    break;

  case 1761: /* pgxcgroup_name: ColId  */
#line 10374 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51369 "preproc.c"
    break;

  case 1762: /* pgxcnodes: '(' pgxcnode_list ')'  */
#line 10382 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51377 "preproc.c"
    break;

  case 1763: /* pgxcnode_list: pgxcnode_list ',' pgxcnode_name  */
#line 10390 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 51385 "preproc.c"
    break;

  case 1764: /* pgxcnode_list: pgxcnode_name  */
#line 10394 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51393 "preproc.c"
    break;

  case 1765: /* AlterNodeStmt: ALTER CLUSTER NODE pgxcnode_name Identified_cluster OptWith  */
#line 10402 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter cluster node"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51401 "preproc.c"
    break;

  case 1766: /* AlterNodeStmt: ALTER NODE pgxcnode_name Identified_cluster OptWith  */
#line 10406 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter node"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51409 "preproc.c"
    break;

  case 1767: /* AlterNodeStmt: ALTER GTM NODE pgxcnode_name OptWith  */
#line 10410 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter gtm node"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51417 "preproc.c"
    break;

  case 1768: /* AlterNodeStmt: ALTER CLUSTER GTM NODE pgxcnode_name OptWith  */
#line 10414 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter cluster gtm node"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51425 "preproc.c"
    break;

  case 1769: /* DropNodeStmt: DROP NODE pgxcnode_name Identified_cluster OptWith  */
#line 10422 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop node"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51433 "preproc.c"
    break;

  case 1770: /* DropNodeStmt: DROP GTM NODE pgxcnode_name  */
#line 10426 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop gtm node"),(yyvsp[0].str));
}
#line 51441 "preproc.c"
    break;

  case 1771: /* CreateNodeGroupStmt: CREATE NODE GROUP_P pgxcgroup_name WITH pgxcnodes  */
#line 10434 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create node group"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 51449 "preproc.c"
    break;

  case 1772: /* CreateNodeGroupStmt: CREATE DEFAULT NODE GROUP_P pgxcgroup_name WITH pgxcnodes  */
#line 10438 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create default node group"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 51457 "preproc.c"
    break;

  case 1773: /* AlterNodeGroupStmt: ALTER NODE GROUP_P pgxcgroup_name alter_group_cmds  */
#line 10446 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter node group"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51465 "preproc.c"
    break;

  case 1774: /* DropNodeGroupStmt: DROP NODE GROUP_P pgxcgroup_name  */
#line 10454 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop node group"),(yyvsp[0].str));
}
#line 51473 "preproc.c"
    break;

  case 1775: /* MoveDataStmt: MOVE GROUP_P pgxcgroup_name DATA_P FROM data_node TO data_node  */
#line 10462 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("move group"),(yyvsp[-5].str),mm_strdup("data from"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 51481 "preproc.c"
    break;

  case 1776: /* MoveDataStmt: MOVE GROUP_P pgxcgroup_name DATA_P FROM data_node TO data_node WITH '(' shard_list ')'  */
#line 10466 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("move group"),(yyvsp[-9].str),mm_strdup("data from"),(yyvsp[-6].str),mm_strdup("to"),(yyvsp[-4].str),mm_strdup("with ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51489 "preproc.c"
    break;

  case 1777: /* MoveDataStmt: MOVE GROUP_P pgxcgroup_name DATA_P FROM data_node TO data_node AT Iconst  */
#line 10470 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("move group"),(yyvsp[-7].str),mm_strdup("data from"),(yyvsp[-4].str),mm_strdup("to"),(yyvsp[-2].str),mm_strdup("at"),(yyvsp[0].str));
}
#line 51497 "preproc.c"
    break;

  case 1778: /* MoveDataStmt: MOVE EXTENSION GROUP_P pgxcgroup_name DATA_P FROM data_node TO data_node WITH '(' shard_list ')'  */
#line 10474 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("move extension group"),(yyvsp[-9].str),mm_strdup("data from"),(yyvsp[-6].str),mm_strdup("to"),(yyvsp[-4].str),mm_strdup("with ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51505 "preproc.c"
    break;

  case 1779: /* data_node: pgxcnode_name  */
#line 10482 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51513 "preproc.c"
    break;

  case 1780: /* data_node: OID_P '(' Iconst ')'  */
#line 10486 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("oid ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51521 "preproc.c"
    break;

  case 1781: /* shard_list: Iconst  */
#line 10494 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51529 "preproc.c"
    break;

  case 1782: /* shard_list: shard_list ',' Iconst  */
#line 10498 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 51537 "preproc.c"
    break;

  case 1783: /* CreateShardStmt: CREATE SHARDING GROUP_P Iconst IN_P Iconst  */
#line 10506 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create sharding group"),(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 51545 "preproc.c"
    break;

  case 1784: /* CreateShardStmt: CREATE EXTENSION SHARDING GROUP_P Iconst IN_P Iconst  */
#line 10510 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create extension sharding group"),(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 51553 "preproc.c"
    break;

  case 1785: /* CreateShardStmt: CREATE SHARDING GROUP_P TO GROUP_P pgxcgroup_name  */
#line 10514 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("create sharding group to group"),(yyvsp[0].str));
}
#line 51561 "preproc.c"
    break;

  case 1786: /* CreateShardStmt: CREATE EXTENSION SHARDING GROUP_P TO GROUP_P pgxcgroup_name  */
#line 10518 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("create extension sharding group to group"),(yyvsp[0].str));
}
#line 51569 "preproc.c"
    break;

  case 1787: /* DropShardStmt: DROP SHARDING IN_P GROUP_P pgxcgroup_name  */
#line 10526 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop sharding in group"),(yyvsp[0].str));
}
#line 51577 "preproc.c"
    break;

  case 1788: /* CleanShardingStmt: CLEAN SHARDING  */
#line 10534 "preproc.y"
 { 
 (yyval.str) = mm_strdup("clean sharding");
}
#line 51585 "preproc.c"
    break;

  case 1789: /* CleanShardingStmt: CLEAN SHARDING GROUP_P pgxcgroup_name FROM pgxcnode_name TO pgxcnode_name  */
#line 10538 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("clean sharding group"),(yyvsp[-4].str),mm_strdup("from"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 51593 "preproc.c"
    break;

  case 1790: /* CreateKeyValuesStmt: CREATE KEY VALUES event_trigger_value_list FOR TABLE qual_table_list TO GROUP_P pgxcgroup_name  */
#line 10546 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(6,mm_strdup("create key values"),(yyvsp[-6].str),mm_strdup("for table"),(yyvsp[-3].str),mm_strdup("to group"),(yyvsp[0].str));
}
#line 51602 "preproc.c"
    break;

  case 1791: /* CreateKeyValuesStmt: CREATE KEY VALUES event_trigger_value_list FOR TABLE qual_table_list TO GROUP_P pgxcgroup_name pgxcgroup_name  */
#line 10551 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(7,mm_strdup("create key values"),(yyvsp[-7].str),mm_strdup("for table"),(yyvsp[-4].str),mm_strdup("to group"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51611 "preproc.c"
    break;

  case 1792: /* qual_table_list: ColId  */
#line 10560 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51619 "preproc.c"
    break;

  case 1793: /* qual_table_list: qual_table_list '.' ColId  */
#line 10564 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 51627 "preproc.c"
    break;

  case 1794: /* CheckOverLapStmt: CHECK OVERLAPS name_list TO name_list  */
#line 10572 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("check overlaps"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 51635 "preproc.c"
    break;

  case 1795: /* CheckOverLapStmt: CHECK OVERLAPS name_list  */
#line 10576 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("check overlaps"),(yyvsp[0].str));
}
#line 51643 "preproc.c"
    break;

  case 1796: /* ExplainStmt: EXPLAIN ExplainableStmt  */
#line 10584 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("explain"),(yyvsp[0].str));
}
#line 51651 "preproc.c"
    break;

  case 1797: /* ExplainStmt: EXPLAIN analyze_keyword opt_verbose ExplainableStmt  */
#line 10588 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("explain"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51659 "preproc.c"
    break;

  case 1798: /* ExplainStmt: EXPLAIN VERBOSE ExplainableStmt  */
#line 10592 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("explain verbose"),(yyvsp[0].str));
}
#line 51667 "preproc.c"
    break;

  case 1799: /* ExplainStmt: EXPLAIN '(' explain_option_list ')' ExplainableStmt  */
#line 10596 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("explain ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 51675 "preproc.c"
    break;

  case 1800: /* ExplainableStmt: SelectStmt  */
#line 10604 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51683 "preproc.c"
    break;

  case 1801: /* ExplainableStmt: InsertStmt  */
#line 10608 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51691 "preproc.c"
    break;

  case 1802: /* ExplainableStmt: UpdateStmt  */
#line 10612 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51699 "preproc.c"
    break;

  case 1803: /* ExplainableStmt: DeleteStmt  */
#line 10616 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51707 "preproc.c"
    break;

  case 1804: /* ExplainableStmt: DeclareCursorStmt  */
#line 10620 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51715 "preproc.c"
    break;

  case 1805: /* ExplainableStmt: CreateAsStmt  */
#line 10624 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51723 "preproc.c"
    break;

  case 1806: /* ExplainableStmt: CreateMatViewStmt  */
#line 10628 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51731 "preproc.c"
    break;

  case 1807: /* ExplainableStmt: RefreshMatViewStmt  */
#line 10632 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51739 "preproc.c"
    break;

  case 1808: /* ExplainableStmt: ExecuteStmt  */
#line 10636 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51747 "preproc.c"
    break;

  case 1809: /* explain_option_list: explain_option_elem  */
#line 10644 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51755 "preproc.c"
    break;

  case 1810: /* explain_option_list: explain_option_list ',' explain_option_elem  */
#line 10648 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 51763 "preproc.c"
    break;

  case 1811: /* explain_option_elem: explain_option_name explain_option_arg  */
#line 10656 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51771 "preproc.c"
    break;

  case 1812: /* explain_option_name: NonReservedWord  */
#line 10664 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51779 "preproc.c"
    break;

  case 1813: /* explain_option_name: analyze_keyword  */
#line 10668 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51787 "preproc.c"
    break;

  case 1814: /* explain_option_arg: opt_boolean_or_string  */
#line 10676 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51795 "preproc.c"
    break;

  case 1815: /* explain_option_arg: NumericOnly  */
#line 10680 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51803 "preproc.c"
    break;

  case 1816: /* explain_option_arg: %empty  */
#line 10684 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 51810 "preproc.c"
    break;

  case 1817: /* ExecDirectStmt: EXECUTE DIRECT ON pgxcnodes DirectStmt  */
#line 10691 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("execute direct on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51818 "preproc.c"
    break;

  case 1818: /* DirectStmt: ecpg_sconst  */
#line 10699 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51826 "preproc.c"
    break;

  case 1819: /* CleanConnStmt: CLEAN CONNECTION TO COORDINATOR pgxcnodes CleanConnDbName CleanConnUserName  */
#line 10707 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("clean connection to coordinator"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51834 "preproc.c"
    break;

  case 1820: /* CleanConnStmt: CLEAN CONNECTION TO NODE pgxcnodes CleanConnDbName CleanConnUserName  */
#line 10711 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("clean connection to node"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51842 "preproc.c"
    break;

  case 1821: /* CleanConnStmt: CLEAN CONNECTION TO ALL opt_force CleanConnDbName CleanConnUserName  */
#line 10715 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("clean connection to all"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51850 "preproc.c"
    break;

  case 1822: /* CleanConnDbName: FOR DATABASE database_name  */
#line 10723 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for database"),(yyvsp[0].str));
}
#line 51858 "preproc.c"
    break;

  case 1823: /* CleanConnDbName: FOR database_name  */
#line 10727 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 51866 "preproc.c"
    break;

  case 1824: /* CleanConnDbName: %empty  */
#line 10731 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 51873 "preproc.c"
    break;

  case 1825: /* CleanConnUserName: TO USER RoleId  */
#line 10738 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("to user"),(yyvsp[0].str));
}
#line 51881 "preproc.c"
    break;

  case 1826: /* CleanConnUserName: TO RoleId  */
#line 10742 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 51889 "preproc.c"
    break;

  case 1827: /* CleanConnUserName: %empty  */
#line 10746 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 51896 "preproc.c"
    break;

  case 1828: /* opt_force: FORCE  */
#line 10753 "preproc.y"
 { 
 (yyval.str) = mm_strdup("force");
}
#line 51904 "preproc.c"
    break;

  case 1829: /* opt_force: %empty  */
#line 10757 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 51911 "preproc.c"
    break;

  case 1830: /* PrepareStmt: PREPARE prepared_name prep_type_clause AS PreparableStmt  */
#line 10764 "preproc.y"
        {
		(yyval.prep).name = (yyvsp[-3].str);
		(yyval.prep).type = (yyvsp[-2].str);
		(yyval.prep).stmt = cat_str(3, mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
	}
#line 51921 "preproc.c"
    break;

  case 1831: /* PrepareStmt: PREPARE prepared_name FROM execstring  */
#line 10770 "preproc.y"
        {
		(yyval.prep).name = (yyvsp[-2].str);
		(yyval.prep).type = NULL;
		(yyval.prep).stmt = (yyvsp[0].str);
	}
#line 51931 "preproc.c"
    break;

  case 1832: /* prep_type_clause: '(' type_list ')'  */
#line 10780 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51939 "preproc.c"
    break;

  case 1833: /* prep_type_clause: %empty  */
#line 10784 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 51946 "preproc.c"
    break;

  case 1834: /* PreparableStmt: SelectStmt  */
#line 10791 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51954 "preproc.c"
    break;

  case 1835: /* PreparableStmt: InsertStmt  */
#line 10795 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51962 "preproc.c"
    break;

  case 1836: /* PreparableStmt: UpdateStmt  */
#line 10799 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51970 "preproc.c"
    break;

  case 1837: /* PreparableStmt: DeleteStmt  */
#line 10803 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51978 "preproc.c"
    break;

  case 1838: /* ExecuteStmt: EXECUTE prepared_name execute_param_clause execute_rest  */
#line 10811 "preproc.y"
        { (yyval.str) = (yyvsp[-2].str); }
#line 51984 "preproc.c"
    break;

  case 1839: /* ExecuteStmt: CREATE OptTemp TABLE create_as_target AS EXECUTE name execute_param_clause opt_with_data  */
#line 10813 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("table"),(yyvsp[-5].str),mm_strdup("as execute"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51992 "preproc.c"
    break;

  case 1840: /* execute_param_clause: '(' expr_list ')'  */
#line 10821 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52000 "preproc.c"
    break;

  case 1841: /* execute_param_clause: %empty  */
#line 10825 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52007 "preproc.c"
    break;

  case 1842: /* InsertStmt: opt_with_clause INSERT INTO insert_target insert_rest opt_on_conflict returning_clause  */
#line 10832 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("insert into"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52015 "preproc.c"
    break;

  case 1843: /* insert_target: qualified_name  */
#line 10840 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52023 "preproc.c"
    break;

  case 1844: /* insert_target: qualified_name AS ColId  */
#line 10844 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 52031 "preproc.c"
    break;

  case 1845: /* insert_rest: SelectStmt  */
#line 10852 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52039 "preproc.c"
    break;

  case 1846: /* insert_rest: OVERRIDING override_kind VALUE_P SelectStmt  */
#line 10856 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("overriding"),(yyvsp[-2].str),mm_strdup("value"),(yyvsp[0].str));
}
#line 52047 "preproc.c"
    break;

  case 1847: /* insert_rest: '(' insert_column_list ')' SelectStmt  */
#line 10860 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 52055 "preproc.c"
    break;

  case 1848: /* insert_rest: '(' insert_column_list ')' OVERRIDING override_kind VALUE_P SelectStmt  */
#line 10864 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("("),(yyvsp[-5].str),mm_strdup(") overriding"),(yyvsp[-2].str),mm_strdup("value"),(yyvsp[0].str));
}
#line 52063 "preproc.c"
    break;

  case 1849: /* insert_rest: DEFAULT VALUES  */
#line 10868 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default values");
}
#line 52071 "preproc.c"
    break;

  case 1850: /* override_kind: USER  */
#line 10876 "preproc.y"
 { 
 (yyval.str) = mm_strdup("user");
}
#line 52079 "preproc.c"
    break;

  case 1851: /* override_kind: SYSTEM_P  */
#line 10880 "preproc.y"
 { 
 (yyval.str) = mm_strdup("system");
}
#line 52087 "preproc.c"
    break;

  case 1852: /* insert_column_list: insert_column_item  */
#line 10888 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52095 "preproc.c"
    break;

  case 1853: /* insert_column_list: insert_column_list ',' insert_column_item  */
#line 10892 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52103 "preproc.c"
    break;

  case 1854: /* insert_column_item: ColId opt_indirection  */
#line 10900 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52111 "preproc.c"
    break;

  case 1855: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO UPDATE SET set_clause_list where_clause  */
#line 10908 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("on conflict"),(yyvsp[-5].str),mm_strdup("do update set"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52119 "preproc.c"
    break;

  case 1856: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO NOTHING  */
#line 10912 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("on conflict"),(yyvsp[-2].str),mm_strdup("do nothing"));
}
#line 52127 "preproc.c"
    break;

  case 1857: /* opt_on_conflict: %empty  */
#line 10916 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52134 "preproc.c"
    break;

  case 1858: /* opt_conf_expr: '(' index_params ')' where_clause  */
#line 10923 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 52142 "preproc.c"
    break;

  case 1859: /* opt_conf_expr: ON CONSTRAINT name  */
#line 10927 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on constraint"),(yyvsp[0].str));
}
#line 52150 "preproc.c"
    break;

  case 1860: /* opt_conf_expr: %empty  */
#line 10931 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52157 "preproc.c"
    break;

  case 1861: /* returning_clause: RETURNING target_list opt_ecpg_into  */
#line 10938 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("returning"),(yyvsp[-1].str));
}
#line 52165 "preproc.c"
    break;

  case 1862: /* returning_clause: %empty  */
#line 10942 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52172 "preproc.c"
    break;

  case 1863: /* DeleteStmt: opt_with_clause DELETE_P FROM relation_expr_opt_alias using_clause where_or_current_clause returning_clause  */
#line 10949 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("delete from"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52180 "preproc.c"
    break;

  case 1864: /* using_clause: USING from_list  */
#line 10957 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 52188 "preproc.c"
    break;

  case 1865: /* using_clause: %empty  */
#line 10961 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52195 "preproc.c"
    break;

  case 1866: /* LockStmt: LOCK_P opt_table relation_expr_list opt_lock opt_nowait  */
#line 10968 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("lock"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52203 "preproc.c"
    break;

  case 1867: /* opt_lock: IN_P lock_type MODE  */
#line 10976 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("in"),(yyvsp[-1].str),mm_strdup("mode"));
}
#line 52211 "preproc.c"
    break;

  case 1868: /* opt_lock: %empty  */
#line 10980 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52218 "preproc.c"
    break;

  case 1869: /* lock_type: ACCESS SHARE  */
#line 10987 "preproc.y"
 { 
 (yyval.str) = mm_strdup("access share");
}
#line 52226 "preproc.c"
    break;

  case 1870: /* lock_type: ROW SHARE  */
#line 10991 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row share");
}
#line 52234 "preproc.c"
    break;

  case 1871: /* lock_type: ROW EXCLUSIVE  */
#line 10995 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row exclusive");
}
#line 52242 "preproc.c"
    break;

  case 1872: /* lock_type: SHARE UPDATE EXCLUSIVE  */
#line 10999 "preproc.y"
 { 
 (yyval.str) = mm_strdup("share update exclusive");
}
#line 52250 "preproc.c"
    break;

  case 1873: /* lock_type: SHARE  */
#line 11003 "preproc.y"
 { 
 (yyval.str) = mm_strdup("share");
}
#line 52258 "preproc.c"
    break;

  case 1874: /* lock_type: SHARE ROW EXCLUSIVE  */
#line 11007 "preproc.y"
 { 
 (yyval.str) = mm_strdup("share row exclusive");
}
#line 52266 "preproc.c"
    break;

  case 1875: /* lock_type: EXCLUSIVE  */
#line 11011 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 52274 "preproc.c"
    break;

  case 1876: /* lock_type: ACCESS EXCLUSIVE  */
#line 11015 "preproc.y"
 { 
 (yyval.str) = mm_strdup("access exclusive");
}
#line 52282 "preproc.c"
    break;

  case 1877: /* opt_nowait: NOWAIT  */
#line 11023 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nowait");
}
#line 52290 "preproc.c"
    break;

  case 1878: /* opt_nowait: %empty  */
#line 11027 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52297 "preproc.c"
    break;

  case 1879: /* opt_nowait_or_skip: NOWAIT  */
#line 11034 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nowait");
}
#line 52305 "preproc.c"
    break;

  case 1880: /* opt_nowait_or_skip: SKIP LOCKED  */
#line 11038 "preproc.y"
 { 
 (yyval.str) = mm_strdup("skip locked");
}
#line 52313 "preproc.c"
    break;

  case 1881: /* opt_nowait_or_skip: %empty  */
#line 11042 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52320 "preproc.c"
    break;

  case 1882: /* LockNodeStmt: NODE LOCK_P WITH '(' lock_param_list ')'  */
#line 11049 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("node lock with ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52328 "preproc.c"
    break;

  case 1883: /* LockNodeStmt: NODE UNLOCK_P WITH '(' lock_param_list ')'  */
#line 11053 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("node unlock with ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52336 "preproc.c"
    break;

  case 1884: /* lock_param_list: lock_param  */
#line 11061 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52344 "preproc.c"
    break;

  case 1885: /* lock_param_list: lock_param_list ',' lock_param  */
#line 11065 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52352 "preproc.c"
    break;

  case 1886: /* lock_param: Iconst  */
#line 11073 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52360 "preproc.c"
    break;

  case 1887: /* lock_param: ecpg_sconst  */
#line 11077 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52368 "preproc.c"
    break;

  case 1888: /* UpdateStmt: opt_with_clause UPDATE relation_expr_opt_alias SET set_clause_list from_clause where_or_current_clause returning_clause  */
#line 11085 "preproc.y"
 { 
 (yyval.str) = cat_str(8,(yyvsp[-7].str),mm_strdup("update"),(yyvsp[-5].str),mm_strdup("set"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52376 "preproc.c"
    break;

  case 1889: /* set_clause_list: set_clause  */
#line 11093 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52384 "preproc.c"
    break;

  case 1890: /* set_clause_list: set_clause_list ',' set_clause  */
#line 11097 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52392 "preproc.c"
    break;

  case 1891: /* set_clause: set_target '=' a_expr  */
#line 11105 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 52400 "preproc.c"
    break;

  case 1892: /* set_clause: '(' set_target_list ')' '=' a_expr  */
#line 11109 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-3].str),mm_strdup(") ="),(yyvsp[0].str));
}
#line 52408 "preproc.c"
    break;

  case 1893: /* set_target: ColId opt_indirection  */
#line 11117 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52416 "preproc.c"
    break;

  case 1894: /* set_target_list: set_target  */
#line 11125 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52424 "preproc.c"
    break;

  case 1895: /* set_target_list: set_target_list ',' set_target  */
#line 11129 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52432 "preproc.c"
    break;

  case 1896: /* DeclareCursorStmt: DECLARE cursor_name cursor_options CURSOR opt_hold FOR SelectStmt  */
#line 11137 "preproc.y"
        {
		struct cursor *ptr, *this;
		char *cursor_marker = (yyvsp[-5].str)[0] == ':' ? mm_strdup("$0") : mm_strdup((yyvsp[-5].str));
		char *comment, *c1, *c2;
		int (* strcmp_fn)(const char *, const char *) = (((yyvsp[-5].str)[0] == ':' || (yyvsp[-5].str)[0] == '"') ? strcmp : pg_strcasecmp);

		for (ptr = cur; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp_fn((yyvsp[-5].str), ptr->name) == 0)
			{
				if ((yyvsp[-5].str)[0] == ':')
					mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[-5].str)+1);
				else
					mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[-5].str));
			}
		}

		this = (struct cursor *) mm_alloc(sizeof(struct cursor));

		this->next = cur;
		this->name = (yyvsp[-5].str);
		this->function = (current_function ? mm_strdup(current_function) : NULL);
		this->connection = connection;
		this->opened = false;
		this->command =  cat_str(7, mm_strdup("declare"), cursor_marker, (yyvsp[-4].str), mm_strdup("cursor"), (yyvsp[-2].str), mm_strdup("for"), (yyvsp[0].str));
		this->argsinsert = argsinsert;
		this->argsinsert_oos = NULL;
		this->argsresult = argsresult;
		this->argsresult_oos = NULL;
		argsinsert = argsresult = NULL;
		cur = this;

		c1 = mm_strdup(this->command);
		if ((c2 = strstr(c1, "*/")) != NULL)
		{
			/* We put this text into a comment, so we better remove [*][/]. */
			c2[0] = '.';
			c2[1] = '.';
		}
		comment = cat_str(3, mm_strdup("/*"), c1, mm_strdup("*/"));

		if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
			(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
				mm_strdup("ECPG_informix_reset_sqlca();"),
				comment);
		else
			(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
	}
#line 52485 "preproc.c"
    break;

  case 1897: /* cursor_name: name  */
#line 11190 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52493 "preproc.c"
    break;

  case 1898: /* cursor_name: char_civar  */
#line 11194 "preproc.y"
                {
			char *curname = mm_alloc(strlen((yyvsp[0].str)) + 2);
			sprintf(curname, ":%s", (yyvsp[0].str));
			free((yyvsp[0].str));
			(yyvsp[0].str) = curname;
			(yyval.str) = (yyvsp[0].str);
		}
#line 52505 "preproc.c"
    break;

  case 1899: /* cursor_options: %empty  */
#line 11206 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52512 "preproc.c"
    break;

  case 1900: /* cursor_options: cursor_options NO SCROLL  */
#line 11209 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("no scroll"));
}
#line 52520 "preproc.c"
    break;

  case 1901: /* cursor_options: cursor_options SCROLL  */
#line 11213 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("scroll"));
}
#line 52528 "preproc.c"
    break;

  case 1902: /* cursor_options: cursor_options BINARY  */
#line 11217 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("binary"));
}
#line 52536 "preproc.c"
    break;

  case 1903: /* cursor_options: cursor_options INSENSITIVE  */
#line 11221 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("insensitive"));
}
#line 52544 "preproc.c"
    break;

  case 1904: /* opt_hold: %empty  */
#line 11229 "preproc.y"
        {
		if (compat == ECPG_COMPAT_INFORMIX_SE && autocommit)
			(yyval.str) = mm_strdup("with hold");
		else
			(yyval.str) = EMPTY;
	}
#line 52555 "preproc.c"
    break;

  case 1905: /* opt_hold: WITH HOLD  */
#line 11236 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with hold");
}
#line 52563 "preproc.c"
    break;

  case 1906: /* opt_hold: WITHOUT HOLD  */
#line 11240 "preproc.y"
 { 
 (yyval.str) = mm_strdup("without hold");
}
#line 52571 "preproc.c"
    break;

  case 1907: /* SelectStmt: select_no_parens  */
#line 11248 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52579 "preproc.c"
    break;

  case 1908: /* SelectStmt: select_with_parens  */
#line 11252 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52587 "preproc.c"
    break;

  case 1909: /* select_with_parens: '(' select_no_parens ')'  */
#line 11260 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52595 "preproc.c"
    break;

  case 1910: /* select_with_parens: '(' select_with_parens ')'  */
#line 11264 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52603 "preproc.c"
    break;

  case 1911: /* select_no_parens: simple_select  */
#line 11272 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52611 "preproc.c"
    break;

  case 1912: /* select_no_parens: select_clause sort_clause  */
#line 11276 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52619 "preproc.c"
    break;

  case 1913: /* select_no_parens: select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 11280 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52627 "preproc.c"
    break;

  case 1914: /* select_no_parens: select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 11284 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52635 "preproc.c"
    break;

  case 1915: /* select_no_parens: with_clause select_clause  */
#line 11288 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52643 "preproc.c"
    break;

  case 1916: /* select_no_parens: with_clause select_clause sort_clause  */
#line 11292 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52651 "preproc.c"
    break;

  case 1917: /* select_no_parens: with_clause select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 11296 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52659 "preproc.c"
    break;

  case 1918: /* select_no_parens: with_clause select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 11300 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52667 "preproc.c"
    break;

  case 1919: /* select_clause: simple_select  */
#line 11308 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52675 "preproc.c"
    break;

  case 1920: /* select_clause: select_with_parens  */
#line 11312 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52683 "preproc.c"
    break;

  case 1921: /* simple_select: SELECT opt_all_clause opt_target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 11320 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("select"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52691 "preproc.c"
    break;

  case 1922: /* simple_select: SELECT distinct_clause target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 11324 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("select"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52699 "preproc.c"
    break;

  case 1923: /* simple_select: values_clause  */
#line 11328 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52707 "preproc.c"
    break;

  case 1924: /* simple_select: TABLE relation_expr  */
#line 11332 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 52715 "preproc.c"
    break;

  case 1925: /* simple_select: select_clause UNION all_or_distinct select_clause  */
#line 11336 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("union"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52723 "preproc.c"
    break;

  case 1926: /* simple_select: select_clause INTERSECT all_or_distinct select_clause  */
#line 11340 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("intersect"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52731 "preproc.c"
    break;

  case 1927: /* simple_select: select_clause EXCEPT all_or_distinct select_clause  */
#line 11344 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("except"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52739 "preproc.c"
    break;

  case 1928: /* with_clause: WITH cte_list  */
#line 11352 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 52747 "preproc.c"
    break;

  case 1929: /* with_clause: WITH_LA cte_list  */
#line 11356 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 52755 "preproc.c"
    break;

  case 1930: /* with_clause: WITH RECURSIVE cte_list  */
#line 11360 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with recursive"),(yyvsp[0].str));
}
#line 52763 "preproc.c"
    break;

  case 1931: /* cte_list: common_table_expr  */
#line 11368 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52771 "preproc.c"
    break;

  case 1932: /* cte_list: cte_list ',' common_table_expr  */
#line 11372 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52779 "preproc.c"
    break;

  case 1933: /* common_table_expr: name opt_name_list AS opt_materialized '(' PreparableStmt ')'  */
#line 11380 "preproc.y"
 { 
 (yyval.str) = cat_str(7,(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52787 "preproc.c"
    break;

  case 1934: /* opt_materialized: MATERIALIZED  */
#line 11388 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized");
}
#line 52795 "preproc.c"
    break;

  case 1935: /* opt_materialized: NOT MATERIALIZED  */
#line 11392 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not materialized");
}
#line 52803 "preproc.c"
    break;

  case 1936: /* opt_materialized: %empty  */
#line 11396 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52810 "preproc.c"
    break;

  case 1937: /* opt_with_clause: with_clause  */
#line 11403 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52818 "preproc.c"
    break;

  case 1938: /* opt_with_clause: %empty  */
#line 11407 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52825 "preproc.c"
    break;

  case 1939: /* into_clause: INTO OptTempTableName  */
#line 11414 "preproc.y"
                                        {
						FoundInto = 1;
						(yyval.str)= cat2_str(mm_strdup("into"), (yyvsp[0].str));
					}
#line 52834 "preproc.c"
    break;

  case 1940: /* into_clause: ecpg_into  */
#line 11418 "preproc.y"
                    { (yyval.str) = EMPTY; }
#line 52840 "preproc.c"
    break;

  case 1941: /* into_clause: %empty  */
#line 11420 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52847 "preproc.c"
    break;

  case 1942: /* OptTempTableName: TEMPORARY opt_table qualified_name  */
#line 11427 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52855 "preproc.c"
    break;

  case 1943: /* OptTempTableName: TEMP opt_table qualified_name  */
#line 11431 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52863 "preproc.c"
    break;

  case 1944: /* OptTempTableName: LOCAL TEMPORARY opt_table qualified_name  */
#line 11435 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("local temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52871 "preproc.c"
    break;

  case 1945: /* OptTempTableName: LOCAL TEMP opt_table qualified_name  */
#line 11439 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("local temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52879 "preproc.c"
    break;

  case 1946: /* OptTempTableName: GLOBAL TEMPORARY opt_table qualified_name  */
#line 11443 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("global temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52887 "preproc.c"
    break;

  case 1947: /* OptTempTableName: GLOBAL TEMP opt_table qualified_name  */
#line 11447 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("global temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52895 "preproc.c"
    break;

  case 1948: /* OptTempTableName: UNLOGGED opt_table qualified_name  */
#line 11451 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("unlogged"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52903 "preproc.c"
    break;

  case 1949: /* OptTempTableName: TABLE qualified_name  */
#line 11455 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 52911 "preproc.c"
    break;

  case 1950: /* OptTempTableName: qualified_name  */
#line 11459 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52919 "preproc.c"
    break;

  case 1951: /* opt_table: TABLE  */
#line 11467 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 52927 "preproc.c"
    break;

  case 1952: /* opt_table: %empty  */
#line 11471 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52934 "preproc.c"
    break;

  case 1953: /* all_or_distinct: ALL  */
#line 11478 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 52942 "preproc.c"
    break;

  case 1954: /* all_or_distinct: DISTINCT  */
#line 11482 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distinct");
}
#line 52950 "preproc.c"
    break;

  case 1955: /* all_or_distinct: %empty  */
#line 11486 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52957 "preproc.c"
    break;

  case 1956: /* distinct_clause: DISTINCT  */
#line 11493 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distinct");
}
#line 52965 "preproc.c"
    break;

  case 1957: /* distinct_clause: DISTINCT ON '(' expr_list ')'  */
#line 11497 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("distinct on ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52973 "preproc.c"
    break;

  case 1958: /* opt_all_clause: ALL  */
#line 11505 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 52981 "preproc.c"
    break;

  case 1959: /* opt_all_clause: %empty  */
#line 11509 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52988 "preproc.c"
    break;

  case 1960: /* opt_sort_clause: sort_clause  */
#line 11516 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52996 "preproc.c"
    break;

  case 1961: /* opt_sort_clause: %empty  */
#line 11520 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53003 "preproc.c"
    break;

  case 1962: /* sort_clause: ORDER BY sortby_list  */
#line 11527 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("order by"),(yyvsp[0].str));
}
#line 53011 "preproc.c"
    break;

  case 1963: /* sortby_list: sortby  */
#line 11535 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53019 "preproc.c"
    break;

  case 1964: /* sortby_list: sortby_list ',' sortby  */
#line 11539 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53027 "preproc.c"
    break;

  case 1965: /* sortby: a_expr USING qual_all_Op opt_nulls_order  */
#line 11547 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53035 "preproc.c"
    break;

  case 1966: /* sortby: a_expr opt_asc_desc opt_nulls_order  */
#line 11551 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53043 "preproc.c"
    break;

  case 1967: /* select_limit: limit_clause offset_clause  */
#line 11559 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53051 "preproc.c"
    break;

  case 1968: /* select_limit: offset_clause limit_clause  */
#line 11563 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53059 "preproc.c"
    break;

  case 1969: /* select_limit: limit_clause  */
#line 11567 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53067 "preproc.c"
    break;

  case 1970: /* select_limit: offset_clause  */
#line 11571 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53075 "preproc.c"
    break;

  case 1971: /* opt_select_limit: select_limit  */
#line 11579 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53083 "preproc.c"
    break;

  case 1972: /* opt_select_limit: %empty  */
#line 11583 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53090 "preproc.c"
    break;

  case 1973: /* limit_clause: LIMIT select_limit_value  */
#line 11590 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("limit"),(yyvsp[0].str));
}
#line 53098 "preproc.c"
    break;

  case 1974: /* limit_clause: LIMIT select_limit_value ',' select_offset_value  */
#line 11594 "preproc.y"
        {
		mmerror(PARSE_ERROR, ET_WARNING, "no longer supported LIMIT #,# syntax passed to server");
		(yyval.str) = cat_str(4, mm_strdup("limit"), (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str));
	}
#line 53107 "preproc.c"
    break;

  case 1975: /* limit_clause: FETCH first_or_next opt_select_fetch_first_value row_or_rows ONLY  */
#line 11599 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("fetch"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("only"));
}
#line 53115 "preproc.c"
    break;

  case 1976: /* offset_clause: OFFSET select_offset_value  */
#line 11607 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("offset"),(yyvsp[0].str));
}
#line 53123 "preproc.c"
    break;

  case 1977: /* offset_clause: OFFSET select_offset_value2 row_or_rows  */
#line 11611 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("offset"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53131 "preproc.c"
    break;

  case 1978: /* select_limit_value: a_expr  */
#line 11619 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53139 "preproc.c"
    break;

  case 1979: /* select_limit_value: ALL  */
#line 11623 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 53147 "preproc.c"
    break;

  case 1980: /* select_offset_value: a_expr  */
#line 11631 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53155 "preproc.c"
    break;

  case 1981: /* opt_select_fetch_first_value: SignedIconst  */
#line 11639 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53163 "preproc.c"
    break;

  case 1982: /* opt_select_fetch_first_value: '(' a_expr ')'  */
#line 11643 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53171 "preproc.c"
    break;

  case 1983: /* opt_select_fetch_first_value: %empty  */
#line 11647 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53178 "preproc.c"
    break;

  case 1984: /* select_offset_value2: c_expr  */
#line 11654 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53186 "preproc.c"
    break;

  case 1985: /* row_or_rows: ROW  */
#line 11662 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row");
}
#line 53194 "preproc.c"
    break;

  case 1986: /* row_or_rows: ROWS  */
#line 11666 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rows");
}
#line 53202 "preproc.c"
    break;

  case 1987: /* first_or_next: FIRST_P  */
#line 11674 "preproc.y"
 { 
 (yyval.str) = mm_strdup("first");
}
#line 53210 "preproc.c"
    break;

  case 1988: /* first_or_next: NEXT  */
#line 11678 "preproc.y"
 { 
 (yyval.str) = mm_strdup("next");
}
#line 53218 "preproc.c"
    break;

  case 1989: /* group_clause: GROUP_P BY group_by_list  */
#line 11686 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("group by"),(yyvsp[0].str));
}
#line 53226 "preproc.c"
    break;

  case 1990: /* group_clause: %empty  */
#line 11690 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53233 "preproc.c"
    break;

  case 1991: /* group_by_list: group_by_item  */
#line 11697 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53241 "preproc.c"
    break;

  case 1992: /* group_by_list: group_by_list ',' group_by_item  */
#line 11701 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53249 "preproc.c"
    break;

  case 1993: /* group_by_item: a_expr  */
#line 11709 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53257 "preproc.c"
    break;

  case 1994: /* group_by_item: empty_grouping_set  */
#line 11713 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53265 "preproc.c"
    break;

  case 1995: /* group_by_item: cube_clause  */
#line 11717 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53273 "preproc.c"
    break;

  case 1996: /* group_by_item: rollup_clause  */
#line 11721 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53281 "preproc.c"
    break;

  case 1997: /* group_by_item: grouping_sets_clause  */
#line 11725 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53289 "preproc.c"
    break;

  case 1998: /* empty_grouping_set: '(' ')'  */
#line 11733 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( )");
}
#line 53297 "preproc.c"
    break;

  case 1999: /* rollup_clause: ROLLUP '(' expr_list ')'  */
#line 11741 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("rollup ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53305 "preproc.c"
    break;

  case 2000: /* cube_clause: CUBE '(' expr_list ')'  */
#line 11749 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("cube ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53313 "preproc.c"
    break;

  case 2001: /* grouping_sets_clause: GROUPING SETS '(' group_by_list ')'  */
#line 11757 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("grouping sets ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53321 "preproc.c"
    break;

  case 2002: /* having_clause: HAVING a_expr  */
#line 11765 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("having"),(yyvsp[0].str));
}
#line 53329 "preproc.c"
    break;

  case 2003: /* having_clause: %empty  */
#line 11769 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53336 "preproc.c"
    break;

  case 2004: /* for_locking_clause: for_locking_items  */
#line 11776 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53344 "preproc.c"
    break;

  case 2005: /* for_locking_clause: FOR READ ONLY  */
#line 11780 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for read only");
}
#line 53352 "preproc.c"
    break;

  case 2006: /* opt_for_locking_clause: for_locking_clause  */
#line 11788 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53360 "preproc.c"
    break;

  case 2007: /* opt_for_locking_clause: %empty  */
#line 11792 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53367 "preproc.c"
    break;

  case 2008: /* for_locking_items: for_locking_item  */
#line 11799 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53375 "preproc.c"
    break;

  case 2009: /* for_locking_items: for_locking_items for_locking_item  */
#line 11803 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53383 "preproc.c"
    break;

  case 2010: /* for_locking_item: for_locking_strength locked_rels_list opt_nowait_or_skip  */
#line 11811 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53391 "preproc.c"
    break;

  case 2011: /* for_locking_strength: FOR UPDATE  */
#line 11819 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for update");
}
#line 53399 "preproc.c"
    break;

  case 2012: /* for_locking_strength: FOR NO KEY UPDATE  */
#line 11823 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for no key update");
}
#line 53407 "preproc.c"
    break;

  case 2013: /* for_locking_strength: FOR SHARE  */
#line 11827 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for share");
}
#line 53415 "preproc.c"
    break;

  case 2014: /* for_locking_strength: FOR KEY SHARE  */
#line 11831 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for key share");
}
#line 53423 "preproc.c"
    break;

  case 2015: /* locked_rels_list: OF qualified_name_list  */
#line 11839 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("of"),(yyvsp[0].str));
}
#line 53431 "preproc.c"
    break;

  case 2016: /* locked_rels_list: %empty  */
#line 11843 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53438 "preproc.c"
    break;

  case 2017: /* values_clause: VALUES '(' expr_list ')'  */
#line 11850 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("values ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53446 "preproc.c"
    break;

  case 2018: /* values_clause: values_clause ',' '(' expr_list ')'  */
#line 11854 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup(", ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53454 "preproc.c"
    break;

  case 2019: /* from_clause: FROM from_list  */
#line 11862 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 53462 "preproc.c"
    break;

  case 2020: /* from_clause: %empty  */
#line 11866 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53469 "preproc.c"
    break;

  case 2021: /* from_list: table_ref  */
#line 11873 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53477 "preproc.c"
    break;

  case 2022: /* from_list: from_list ',' table_ref  */
#line 11877 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53485 "preproc.c"
    break;

  case 2023: /* table_ref: relation_expr opt_alias_clause  */
#line 11885 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53493 "preproc.c"
    break;

  case 2024: /* table_ref: relation_expr opt_alias_clause tablesample_clause  */
#line 11889 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53501 "preproc.c"
    break;

  case 2025: /* table_ref: func_table func_alias_clause  */
#line 11893 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53509 "preproc.c"
    break;

  case 2026: /* table_ref: LATERAL_P func_table func_alias_clause  */
#line 11897 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53517 "preproc.c"
    break;

  case 2027: /* table_ref: xmltable opt_alias_clause  */
#line 11901 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53525 "preproc.c"
    break;

  case 2028: /* table_ref: LATERAL_P xmltable opt_alias_clause  */
#line 11905 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53533 "preproc.c"
    break;

  case 2029: /* table_ref: select_with_parens opt_alias_clause  */
#line 11909 "preproc.y"
 { 
	if ((yyvsp[0].str) == NULL)
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53544 "preproc.c"
    break;

  case 2030: /* table_ref: LATERAL_P select_with_parens opt_alias_clause  */
#line 11916 "preproc.y"
 { 
	if ((yyvsp[0].str) == NULL)
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53555 "preproc.c"
    break;

  case 2031: /* table_ref: joined_table  */
#line 11923 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53563 "preproc.c"
    break;

  case 2032: /* table_ref: '(' joined_table ')' alias_clause  */
#line 11927 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 53571 "preproc.c"
    break;

  case 2033: /* joined_table: '(' joined_table ')'  */
#line 11935 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53579 "preproc.c"
    break;

  case 2034: /* joined_table: table_ref CROSS JOIN table_ref  */
#line 11939 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("cross join"),(yyvsp[0].str));
}
#line 53587 "preproc.c"
    break;

  case 2035: /* joined_table: table_ref join_type JOIN table_ref join_qual  */
#line 11943 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("join"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53595 "preproc.c"
    break;

  case 2036: /* joined_table: table_ref JOIN table_ref join_qual  */
#line 11947 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("join"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53603 "preproc.c"
    break;

  case 2037: /* joined_table: table_ref NATURAL join_type JOIN table_ref  */
#line 11951 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("natural"),(yyvsp[-2].str),mm_strdup("join"),(yyvsp[0].str));
}
#line 53611 "preproc.c"
    break;

  case 2038: /* joined_table: table_ref NATURAL JOIN table_ref  */
#line 11955 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("natural join"),(yyvsp[0].str));
}
#line 53619 "preproc.c"
    break;

  case 2039: /* alias_clause: AS ColId '(' name_list ')'  */
#line 11963 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53627 "preproc.c"
    break;

  case 2040: /* alias_clause: AS ColId  */
#line 11967 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 53635 "preproc.c"
    break;

  case 2041: /* alias_clause: ColId '(' name_list ')'  */
#line 11971 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53643 "preproc.c"
    break;

  case 2042: /* alias_clause: ColId  */
#line 11975 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53651 "preproc.c"
    break;

  case 2043: /* opt_alias_clause: alias_clause  */
#line 11983 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53659 "preproc.c"
    break;

  case 2044: /* opt_alias_clause: %empty  */
#line 11987 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53666 "preproc.c"
    break;

  case 2045: /* func_alias_clause: alias_clause  */
#line 11994 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53674 "preproc.c"
    break;

  case 2046: /* func_alias_clause: AS '(' TableFuncElementList ')'  */
#line 11998 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53682 "preproc.c"
    break;

  case 2047: /* func_alias_clause: AS ColId '(' TableFuncElementList ')'  */
#line 12002 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53690 "preproc.c"
    break;

  case 2048: /* func_alias_clause: ColId '(' TableFuncElementList ')'  */
#line 12006 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53698 "preproc.c"
    break;

  case 2049: /* func_alias_clause: %empty  */
#line 12010 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53705 "preproc.c"
    break;

  case 2050: /* join_type: FULL join_outer  */
#line 12017 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("full"),(yyvsp[0].str));
}
#line 53713 "preproc.c"
    break;

  case 2051: /* join_type: LEFT join_outer  */
#line 12021 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("left"),(yyvsp[0].str));
}
#line 53721 "preproc.c"
    break;

  case 2052: /* join_type: RIGHT join_outer  */
#line 12025 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("right"),(yyvsp[0].str));
}
#line 53729 "preproc.c"
    break;

  case 2053: /* join_type: INNER_P  */
#line 12029 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inner");
}
#line 53737 "preproc.c"
    break;

  case 2054: /* join_outer: OUTER_P  */
#line 12037 "preproc.y"
 { 
 (yyval.str) = mm_strdup("outer");
}
#line 53745 "preproc.c"
    break;

  case 2055: /* join_outer: %empty  */
#line 12041 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53752 "preproc.c"
    break;

  case 2056: /* join_qual: USING '(' name_list ')'  */
#line 12048 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("using ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53760 "preproc.c"
    break;

  case 2057: /* join_qual: ON a_expr  */
#line 12052 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on"),(yyvsp[0].str));
}
#line 53768 "preproc.c"
    break;

  case 2058: /* relation_expr: qualified_name opt_partition_for  */
#line 12060 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53776 "preproc.c"
    break;

  case 2059: /* relation_expr: qualified_name '*'  */
#line 12064 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("*"));
}
#line 53784 "preproc.c"
    break;

  case 2060: /* relation_expr: ONLY qualified_name opt_partition_for  */
#line 12068 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("only"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53792 "preproc.c"
    break;

  case 2061: /* relation_expr: ONLY '(' qualified_name ')' opt_partition_for  */
#line 12072 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("only ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 53800 "preproc.c"
    break;

  case 2062: /* opt_partition_for: partition_for  */
#line 12080 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53808 "preproc.c"
    break;

  case 2063: /* opt_partition_for: %empty  */
#line 12084 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53815 "preproc.c"
    break;

  case 2064: /* partition_for: PARTITION FOR '(' a_expr ')'  */
#line 12091 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("partition for ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53823 "preproc.c"
    break;

  case 2065: /* partition_for: PARTITION FOR DEFAULT  */
#line 12095 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partition for default");
}
#line 53831 "preproc.c"
    break;

  case 2066: /* relation_expr_list: relation_expr  */
#line 12103 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53839 "preproc.c"
    break;

  case 2067: /* relation_expr_list: relation_expr_list ',' relation_expr  */
#line 12107 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53847 "preproc.c"
    break;

  case 2068: /* relation_expr_opt_alias: relation_expr  */
#line 12115 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53855 "preproc.c"
    break;

  case 2069: /* relation_expr_opt_alias: relation_expr ColId  */
#line 12119 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53863 "preproc.c"
    break;

  case 2070: /* relation_expr_opt_alias: relation_expr AS ColId  */
#line 12123 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 53871 "preproc.c"
    break;

  case 2071: /* tablesample_clause: TABLESAMPLE func_name '(' expr_list ')' opt_repeatable_clause  */
#line 12131 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("tablesample"),(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 53879 "preproc.c"
    break;

  case 2072: /* opt_repeatable_clause: REPEATABLE '(' a_expr ')'  */
#line 12139 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("repeatable ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53887 "preproc.c"
    break;

  case 2073: /* opt_repeatable_clause: %empty  */
#line 12143 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53894 "preproc.c"
    break;

  case 2074: /* func_table: func_expr_windowless opt_ordinality  */
#line 12150 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53902 "preproc.c"
    break;

  case 2075: /* func_table: ROWS FROM '(' rowsfrom_list ')' opt_ordinality  */
#line 12154 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("rows from ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 53910 "preproc.c"
    break;

  case 2076: /* rowsfrom_item: func_expr_windowless opt_col_def_list  */
#line 12162 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53918 "preproc.c"
    break;

  case 2077: /* rowsfrom_list: rowsfrom_item  */
#line 12170 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53926 "preproc.c"
    break;

  case 2078: /* rowsfrom_list: rowsfrom_list ',' rowsfrom_item  */
#line 12174 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53934 "preproc.c"
    break;

  case 2079: /* opt_col_def_list: AS '(' TableFuncElementList ')'  */
#line 12182 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53942 "preproc.c"
    break;

  case 2080: /* opt_col_def_list: %empty  */
#line 12186 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53949 "preproc.c"
    break;

  case 2081: /* opt_ordinality: WITH_LA ORDINALITY  */
#line 12193 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with ordinality");
}
#line 53957 "preproc.c"
    break;

  case 2082: /* opt_ordinality: %empty  */
#line 12197 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53964 "preproc.c"
    break;

  case 2083: /* where_clause: WHERE a_expr  */
#line 12204 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("where"),(yyvsp[0].str));
}
#line 53972 "preproc.c"
    break;

  case 2084: /* where_clause: %empty  */
#line 12208 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53979 "preproc.c"
    break;

  case 2085: /* where_or_current_clause: WHERE a_expr  */
#line 12215 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("where"),(yyvsp[0].str));
}
#line 53987 "preproc.c"
    break;

  case 2086: /* where_or_current_clause: WHERE CURRENT_P OF cursor_name  */
#line 12219 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		(yyval.str) = cat_str(2,mm_strdup("where current of"), cursor_marker);
	}
#line 53996 "preproc.c"
    break;

  case 2087: /* where_or_current_clause: %empty  */
#line 12224 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 54003 "preproc.c"
    break;

  case 2088: /* OptTableFuncElementList: TableFuncElementList  */
#line 12231 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54011 "preproc.c"
    break;

  case 2089: /* OptTableFuncElementList: %empty  */
#line 12235 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 54018 "preproc.c"
    break;

  case 2090: /* TableFuncElementList: TableFuncElement  */
#line 12242 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54026 "preproc.c"
    break;

  case 2091: /* TableFuncElementList: TableFuncElementList ',' TableFuncElement  */
#line 12246 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 54034 "preproc.c"
    break;

  case 2092: /* TableFuncElement: ColId Typename opt_collate_clause  */
#line 12254 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 54042 "preproc.c"
    break;

  case 2093: /* xmltable: XMLTABLE '(' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 12262 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("xmltable ("),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("columns"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 54050 "preproc.c"
    break;

  case 2094: /* xmltable: XMLTABLE '(' XMLNAMESPACES '(' xml_namespace_list ')' ',' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 12266 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("xmltable ( xmlnamespaces ("),(yyvsp[-7].str),mm_strdup(") ,"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("columns"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 54058 "preproc.c"
    break;

  case 2095: /* xmltable_column_list: xmltable_column_el  */
#line 12274 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54066 "preproc.c"
    break;

  case 2096: /* xmltable_column_list: xmltable_column_list ',' xmltable_column_el  */
#line 12278 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 54074 "preproc.c"
    break;

  case 2097: /* xmltable_column_el: ColId Typename  */
#line 12286 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 54082 "preproc.c"
    break;

  case 2098: /* xmltable_column_el: ColId Typename xmltable_column_option_list  */
#line 12290 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 54090 "preproc.c"
    break;

  case 2099: /* xmltable_column_el: ColId FOR ORDINALITY  */
#line 12294 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("for ordinality"));
}
#line 54098 "preproc.c"
    break;

  case 2100: /* xmltable_column_option_list: xmltable_column_option_el  */
#line 12302 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54106 "preproc.c"
    break;

  case 2101: /* xmltable_column_option_list: xmltable_column_option_list xmltable_column_option_el  */
#line 12306 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 54114 "preproc.c"
    break;

  case 2102: /* xmltable_column_option_el: ecpg_ident b_expr  */
#line 12314 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 54122 "preproc.c"
    break;

  case 2103: /* xmltable_column_option_el: DEFAULT b_expr  */
#line 12318 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("default"),(yyvsp[0].str));
}
#line 54130 "preproc.c"
    break;

  case 2104: /* xmltable_column_option_el: NOT NULL_P  */
#line 12322 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not null");
}
#line 54138 "preproc.c"
    break;

  case 2105: /* xmltable_column_option_el: NULL_P  */
#line 12326 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 54146 "preproc.c"
    break;

  case 2106: /* xml_namespace_list: xml_namespace_el  */
#line 12334 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54154 "preproc.c"
    break;

  case 2107: /* xml_namespace_list: xml_namespace_list ',' xml_namespace_el  */
#line 12338 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 54162 "preproc.c"
    break;

  case 2108: /* xml_namespace_el: b_expr AS ColLabel  */
#line 12346 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 54170 "preproc.c"
    break;

  case 2109: /* xml_namespace_el: DEFAULT b_expr  */
#line 12350 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("default"),(yyvsp[0].str));
}
#line 54178 "preproc.c"
    break;

  case 2110: /* Typename: SimpleTypename opt_array_bounds  */
#line 12358 "preproc.y"
        {	(yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].index).str); }
#line 54184 "preproc.c"
    break;

  case 2111: /* Typename: SETOF SimpleTypename opt_array_bounds  */
#line 12360 "preproc.y"
        {	(yyval.str) = cat_str(3, mm_strdup("setof"), (yyvsp[-1].str), (yyvsp[0].index).str); }
#line 54190 "preproc.c"
    break;

  case 2112: /* Typename: SimpleTypename ARRAY '[' Iconst ']'  */
#line 12362 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("array ["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 54198 "preproc.c"
    break;

  case 2113: /* Typename: SETOF SimpleTypename ARRAY '[' Iconst ']'  */
#line 12366 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("setof"),(yyvsp[-4].str),mm_strdup("array ["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 54206 "preproc.c"
    break;

  case 2114: /* Typename: SimpleTypename ARRAY  */
#line 12370 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("array"));
}
#line 54214 "preproc.c"
    break;

  case 2115: /* Typename: SETOF SimpleTypename ARRAY  */
#line 12374 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("setof"),(yyvsp[-1].str),mm_strdup("array"));
}
#line 54222 "preproc.c"
    break;

  case 2116: /* opt_array_bounds: opt_array_bounds '[' ']'  */
#line 12382 "preproc.y"
        {
		(yyval.index).index1 = (yyvsp[-2].index).index1;
		(yyval.index).index2 = (yyvsp[-2].index).index2;
		if (strcmp((yyval.index).index1, "-1") == 0)
			(yyval.index).index1 = mm_strdup("0");
		else if (strcmp((yyvsp[-2].index).index2, "-1") == 0)
			(yyval.index).index2 = mm_strdup("0");
		(yyval.index).str = cat_str(2, (yyvsp[-2].index).str, mm_strdup("[]"));
	}
#line 54236 "preproc.c"
    break;

  case 2117: /* opt_array_bounds: opt_array_bounds '[' Iresult ']'  */
#line 12392 "preproc.y"
        {
		(yyval.index).index1 = (yyvsp[-3].index).index1;
		(yyval.index).index2 = (yyvsp[-3].index).index2;
		if (strcmp((yyvsp[-3].index).index1, "-1") == 0)
			(yyval.index).index1 = mm_strdup((yyvsp[-1].str));
		else if (strcmp((yyvsp[-3].index).index2, "-1") == 0)
			(yyval.index).index2 = mm_strdup((yyvsp[-1].str));
		(yyval.index).str = cat_str(4, (yyvsp[-3].index).str, mm_strdup("["), (yyvsp[-1].str), mm_strdup("]"));
	}
#line 54250 "preproc.c"
    break;

  case 2118: /* opt_array_bounds: %empty  */
#line 12402 "preproc.y"
        {
		(yyval.index).index1 = mm_strdup("-1");
		(yyval.index).index2 = mm_strdup("-1");
		(yyval.index).str= EMPTY;
	}
#line 54260 "preproc.c"
    break;

  case 2119: /* SimpleTypename: GenericType  */
#line 12412 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54268 "preproc.c"
    break;

  case 2120: /* SimpleTypename: Numeric  */
#line 12416 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54276 "preproc.c"
    break;

  case 2121: /* SimpleTypename: Bit  */
#line 12420 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54284 "preproc.c"
    break;

  case 2122: /* SimpleTypename: Character  */
#line 12424 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54292 "preproc.c"
    break;

  case 2123: /* SimpleTypename: ConstDatetime  */
#line 12428 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54300 "preproc.c"
    break;

  case 2124: /* SimpleTypename: ConstInterval opt_interval  */
#line 12432 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 54308 "preproc.c"
    break;

  case 2125: /* SimpleTypename: ConstInterval '(' Iconst ')'  */
#line 12436 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 54316 "preproc.c"
    break;

  case 2126: /* ConstTypename: Numeric  */
#line 12444 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54324 "preproc.c"
    break;

  case 2127: /* ConstTypename: ConstBit  */
#line 12448 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54332 "preproc.c"
    break;

  case 2128: /* ConstTypename: ConstCharacter  */
#line 12452 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54340 "preproc.c"
    break;

  case 2129: /* ConstTypename: ConstDatetime  */
#line 12456 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54348 "preproc.c"
    break;

  case 2130: /* GenericType: type_function_name opt_type_modifiers  */
#line 12464 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 54356 "preproc.c"
    break;

  case 2131: /* GenericType: type_function_name attrs opt_type_modifiers  */
#line 12468 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 54364 "preproc.c"
    break;

  case 2132: /* opt_type_modifiers: '(' expr_list ')'  */
#line 12476 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 54372 "preproc.c"
    break;

  case 2133: /* opt_type_modifiers: %empty  */
#line 12480 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 54379 "preproc.c"
    break;

  case 2134: /* Numeric: INT_P  */
#line 12487 "preproc.y"
 { 
 (yyval.str) = mm_strdup("int");
}
#line 54387 "preproc.c"
    break;

  case 2135: /* Numeric: INTEGER  */
#line 12491 "preproc.y"
 { 
 (yyval.str) = mm_strdup("integer");
}
#line 54395 "preproc.c"
    break;

  case 2136: /* Numeric: SMALLINT  */
#line 12495 "preproc.y"
 { 
 (yyval.str) = mm_strdup("smallint");
}
#line 54403 "preproc.c"
    break;

  case 2137: /* Numeric: BIGINT  */
#line 12499 "preproc.y"
 { 
 (yyval.str) = mm_strdup("bigint");
}
#line 54411 "preproc.c"
    break;

  case 2138: /* Numeric: REAL  */
#line 12503 "preproc.y"
 { 
 (yyval.str) = mm_strdup("real");
}
#line 54419 "preproc.c"
    break;

  case 2139: /* Numeric: BINARY_FLOAT  */
#line 12507 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary_float");
}
#line 54427 "preproc.c"
    break;

  case 2140: /* Numeric: FLOAT_P opt_float  */
#line 12511 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("float"),(yyvsp[0].str));
}
#line 54435 "preproc.c"
    break;

  case 2141: /* Numeric: DOUBLE_P PRECISION  */
#line 12515 "preproc.y"
 { 
 (yyval.str) = mm_strdup("double precision");
}
#line 54443 "preproc.c"
    break;

  case 2142: /* Numeric: BINARY_DOUBLE  */
#line 12519 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary_double");
}
#line 54451 "preproc.c"
    break;

  case 2143: /* Numeric: DECIMAL_P opt_type_modifiers  */
#line 12523 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("decimal"),(yyvsp[0].str));
}
#line 54459 "preproc.c"
    break;

  case 2144: /* Numeric: DEC opt_type_modifiers  */
#line 12527 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("dec"),(yyvsp[0].str));
}
#line 54467 "preproc.c"
    break;

  case 2145: /* Numeric: NUMERIC opt_type_modifiers  */
#line 12531 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("numeric"),(yyvsp[0].str));
}
#line 54475 "preproc.c"
    break;

  case 2146: /* Numeric: NUMBER opt_type_modifiers  */
#line 12535 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("number"),(yyvsp[0].str));
}
#line 54483 "preproc.c"
    break;

  case 2147: /* Numeric: BOOLEAN_P  */
#line 12539 "preproc.y"
 { 
 (yyval.str) = mm_strdup("boolean");
}
#line 54491 "preproc.c"
    break;

  case 2148: /* opt_float: '(' Iconst ')'  */
#line 12547 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 54499 "preproc.c"
    break;

  case 2149: /* opt_float: %empty  */
#line 12551 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 54506 "preproc.c"
    break;

  case 2150: /* Bit: BitWithLength  */
#line 12558 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54514 "preproc.c"
    break;

  case 2151: /* Bit: BitWithoutLength  */
#line 12562 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54522 "preproc.c"
    break;

  case 2152: /* ConstBit: BitWithLength  */
#line 12570 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54530 "preproc.c"
    break;

  case 2153: /* ConstBit: BitWithoutLength  */
#line 12574 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54538 "preproc.c"
    break;

  case 2154: /* BitWithLength: BIT opt_varying '(' expr_list ')'  */
#line 12582 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("bit"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 54546 "preproc.c"
    break;

  case 2155: /* BitWithoutLength: BIT opt_varying  */
#line 12590 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("bit"),(yyvsp[0].str));
}
#line 54554 "preproc.c"
    break;

  case 2156: /* Character: CharacterWithLength  */
#line 12598 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54562 "preproc.c"
    break;

  case 2157: /* Character: CharacterWithoutLength  */
#line 12602 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54570 "preproc.c"
    break;

  case 2158: /* ConstCharacter: CharacterWithLength  */
#line 12610 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54578 "preproc.c"
    break;

  case 2159: /* ConstCharacter: CharacterWithoutLength  */
#line 12614 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54586 "preproc.c"
    break;

  case 2160: /* CharacterWithLength: character '(' Iconst ')'  */
#line 12622 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 54594 "preproc.c"
    break;

  case 2161: /* CharacterWithoutLength: character  */
#line 12630 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54602 "preproc.c"
    break;

  case 2162: /* character: CHARACTER opt_varying  */
#line 12638 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("character"),(yyvsp[0].str));
}
#line 54610 "preproc.c"
    break;

  case 2163: /* character: CHAR_P opt_varying  */
#line 12642 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("char"),(yyvsp[0].str));
}
#line 54618 "preproc.c"
    break;

  case 2164: /* character: VARCHAR  */
#line 12646 "preproc.y"
 { 
 (yyval.str) = mm_strdup("varchar");
}
#line 54626 "preproc.c"
    break;

  case 2165: /* character: NATIONAL CHARACTER opt_varying  */
#line 12650 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("national character"),(yyvsp[0].str));
}
#line 54634 "preproc.c"
    break;

  case 2166: /* character: NATIONAL CHAR_P opt_varying  */
#line 12654 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("national char"),(yyvsp[0].str));
}
#line 54642 "preproc.c"
    break;

  case 2167: /* character: NCHAR opt_varying  */
#line 12658 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("nchar"),(yyvsp[0].str));
}
#line 54650 "preproc.c"
    break;

  case 2168: /* opt_varying: VARYING  */
#line 12666 "preproc.y"
 { 
 (yyval.str) = mm_strdup("varying");
}
#line 54658 "preproc.c"
    break;

  case 2169: /* opt_varying: %empty  */
#line 12670 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 54665 "preproc.c"
    break;

  case 2170: /* ConstDatetime: TIMESTAMP '(' Iconst ')' opt_timezone  */
#line 12677 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("timestamp ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 54673 "preproc.c"
    break;

  case 2171: /* ConstDatetime: TIMESTAMP opt_timezone  */
#line 12681 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("timestamp"),(yyvsp[0].str));
}
#line 54681 "preproc.c"
    break;

  case 2172: /* ConstDatetime: TIME '(' Iconst ')' opt_timezone  */
#line 12685 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("time ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 54689 "preproc.c"
    break;

  case 2173: /* ConstDatetime: TIME opt_timezone  */
#line 12689 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("time"),(yyvsp[0].str));
}
#line 54697 "preproc.c"
    break;

  case 2174: /* ConstInterval: INTERVAL  */
#line 12697 "preproc.y"
 { 
 (yyval.str) = mm_strdup("interval");
}
#line 54705 "preproc.c"
    break;

  case 2175: /* opt_timezone: WITH_LA TIME ZONE  */
#line 12705 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with time zone");
}
#line 54713 "preproc.c"
    break;

  case 2176: /* opt_timezone: WITHOUT TIME ZONE  */
#line 12709 "preproc.y"
 { 
 (yyval.str) = mm_strdup("without time zone");
}
#line 54721 "preproc.c"
    break;

  case 2177: /* opt_timezone: %empty  */
#line 12713 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 54728 "preproc.c"
    break;

  case 2178: /* opt_interval: YEAR_P  */
#line 12720 "preproc.y"
 { 
 (yyval.str) = mm_strdup("year");
}
#line 54736 "preproc.c"
    break;

  case 2179: /* opt_interval: MONTH_P  */
#line 12724 "preproc.y"
 { 
 (yyval.str) = mm_strdup("month");
}
#line 54744 "preproc.c"
    break;

  case 2180: /* opt_interval: DAY_P  */
#line 12728 "preproc.y"
 { 
 (yyval.str) = mm_strdup("day");
}
#line 54752 "preproc.c"
    break;

  case 2181: /* opt_interval: HOUR_P  */
#line 12732 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hour");
}
#line 54760 "preproc.c"
    break;

  case 2182: /* opt_interval: MINUTE_P  */
#line 12736 "preproc.y"
 { 
 (yyval.str) = mm_strdup("minute");
}
#line 54768 "preproc.c"
    break;

  case 2183: /* opt_interval: interval_second  */
#line 12740 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54776 "preproc.c"
    break;

  case 2184: /* opt_interval: YEAR_P TO MONTH_P  */
#line 12744 "preproc.y"
 { 
 (yyval.str) = mm_strdup("year to month");
}
#line 54784 "preproc.c"
    break;

  case 2185: /* opt_interval: DAY_P TO HOUR_P  */
#line 12748 "preproc.y"
 { 
 (yyval.str) = mm_strdup("day to hour");
}
#line 54792 "preproc.c"
    break;

  case 2186: /* opt_interval: DAY_P TO MINUTE_P  */
#line 12752 "preproc.y"
 { 
 (yyval.str) = mm_strdup("day to minute");
}
#line 54800 "preproc.c"
    break;

  case 2187: /* opt_interval: DAY_P TO interval_second  */
#line 12756 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("day to"),(yyvsp[0].str));
}
#line 54808 "preproc.c"
    break;

  case 2188: /* opt_interval: HOUR_P TO MINUTE_P  */
#line 12760 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hour to minute");
}
#line 54816 "preproc.c"
    break;

  case 2189: /* opt_interval: HOUR_P TO interval_second  */
#line 12764 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("hour to"),(yyvsp[0].str));
}
#line 54824 "preproc.c"
    break;

  case 2190: /* opt_interval: MINUTE_P TO interval_second  */
#line 12768 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("minute to"),(yyvsp[0].str));
}
#line 54832 "preproc.c"
    break;

  case 2191: /* opt_interval: %empty  */
#line 12772 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 54839 "preproc.c"
    break;

  case 2192: /* interval_second: SECOND_P  */
#line 12779 "preproc.y"
 { 
 (yyval.str) = mm_strdup("second");
}
#line 54847 "preproc.c"
    break;

  case 2193: /* interval_second: SECOND_P '(' Iconst ')'  */
#line 12783 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("second ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 54855 "preproc.c"
    break;

  case 2194: /* a_expr: c_expr  */
#line 12791 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54863 "preproc.c"
    break;

  case 2195: /* a_expr: a_expr TYPECAST Typename  */
#line 12795 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("::"),(yyvsp[0].str));
}
#line 54871 "preproc.c"
    break;

  case 2196: /* a_expr: a_expr COLLATE any_name  */
#line 12799 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("collate"),(yyvsp[0].str));
}
#line 54879 "preproc.c"
    break;

  case 2197: /* a_expr: a_expr AT TIME ZONE a_expr  */
#line 12803 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("at time zone"),(yyvsp[0].str));
}
#line 54887 "preproc.c"
    break;

  case 2198: /* a_expr: '+' a_expr  */
#line 12807 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 54895 "preproc.c"
    break;

  case 2199: /* a_expr: '-' a_expr  */
#line 12811 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 54903 "preproc.c"
    break;

  case 2200: /* a_expr: a_expr '+' a_expr  */
#line 12815 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("+"),(yyvsp[0].str));
}
#line 54911 "preproc.c"
    break;

  case 2201: /* a_expr: a_expr '-' a_expr  */
#line 12819 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("-"),(yyvsp[0].str));
}
#line 54919 "preproc.c"
    break;

  case 2202: /* a_expr: a_expr '*' a_expr  */
#line 12823 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("*"),(yyvsp[0].str));
}
#line 54927 "preproc.c"
    break;

  case 2203: /* a_expr: a_expr '/' a_expr  */
#line 12827 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("/"),(yyvsp[0].str));
}
#line 54935 "preproc.c"
    break;

  case 2204: /* a_expr: a_expr '%' a_expr  */
#line 12831 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("%"),(yyvsp[0].str));
}
#line 54943 "preproc.c"
    break;

  case 2205: /* a_expr: a_expr '^' a_expr  */
#line 12835 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("^"),(yyvsp[0].str));
}
#line 54951 "preproc.c"
    break;

  case 2206: /* a_expr: a_expr '<' a_expr  */
#line 12839 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<"),(yyvsp[0].str));
}
#line 54959 "preproc.c"
    break;

  case 2207: /* a_expr: a_expr '>' a_expr  */
#line 12843 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">"),(yyvsp[0].str));
}
#line 54967 "preproc.c"
    break;

  case 2208: /* a_expr: a_expr '=' a_expr  */
#line 12847 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 54975 "preproc.c"
    break;

  case 2209: /* a_expr: a_expr LESS_EQUALS a_expr  */
#line 12851 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<="),(yyvsp[0].str));
}
#line 54983 "preproc.c"
    break;

  case 2210: /* a_expr: a_expr GREATER_EQUALS a_expr  */
#line 12855 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">="),(yyvsp[0].str));
}
#line 54991 "preproc.c"
    break;

  case 2211: /* a_expr: a_expr NOT_EQUALS a_expr  */
#line 12859 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<>"),(yyvsp[0].str));
}
#line 54999 "preproc.c"
    break;

  case 2212: /* a_expr: a_expr qual_Op a_expr  */
#line 12863 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55007 "preproc.c"
    break;

  case 2213: /* a_expr: qual_Op a_expr  */
#line 12867 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55015 "preproc.c"
    break;

  case 2214: /* a_expr: a_expr qual_Op  */
#line 12871 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55023 "preproc.c"
    break;

  case 2215: /* a_expr: a_expr AND a_expr  */
#line 12875 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 55031 "preproc.c"
    break;

  case 2216: /* a_expr: a_expr OR a_expr  */
#line 12879 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("or"),(yyvsp[0].str));
}
#line 55039 "preproc.c"
    break;

  case 2217: /* a_expr: NOT a_expr  */
#line 12883 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("not"),(yyvsp[0].str));
}
#line 55047 "preproc.c"
    break;

  case 2218: /* a_expr: NOT_LA a_expr  */
#line 12887 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("not"),(yyvsp[0].str));
}
#line 55055 "preproc.c"
    break;

  case 2219: /* a_expr: a_expr LIKE a_expr  */
#line 12891 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("like"),(yyvsp[0].str));
}
#line 55063 "preproc.c"
    break;

  case 2220: /* a_expr: a_expr LIKE a_expr ESCAPE a_expr  */
#line 12895 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("like"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 55071 "preproc.c"
    break;

  case 2221: /* a_expr: a_expr NOT_LA LIKE a_expr  */
#line 12899 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not like"),(yyvsp[0].str));
}
#line 55079 "preproc.c"
    break;

  case 2222: /* a_expr: a_expr NOT_LA LIKE a_expr ESCAPE a_expr  */
#line 12903 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("not like"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 55087 "preproc.c"
    break;

  case 2223: /* a_expr: a_expr ILIKE a_expr  */
#line 12907 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("ilike"),(yyvsp[0].str));
}
#line 55095 "preproc.c"
    break;

  case 2224: /* a_expr: a_expr ILIKE a_expr ESCAPE a_expr  */
#line 12911 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("ilike"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 55103 "preproc.c"
    break;

  case 2225: /* a_expr: a_expr NOT_LA ILIKE a_expr  */
#line 12915 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not ilike"),(yyvsp[0].str));
}
#line 55111 "preproc.c"
    break;

  case 2226: /* a_expr: a_expr NOT_LA ILIKE a_expr ESCAPE a_expr  */
#line 12919 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("not ilike"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 55119 "preproc.c"
    break;

  case 2227: /* a_expr: a_expr SIMILAR TO a_expr  */
#line 12923 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("similar to"),(yyvsp[0].str));
}
#line 55127 "preproc.c"
    break;

  case 2228: /* a_expr: a_expr SIMILAR TO a_expr ESCAPE a_expr  */
#line 12927 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("similar to"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 55135 "preproc.c"
    break;

  case 2229: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr  */
#line 12931 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("not similar to"),(yyvsp[0].str));
}
#line 55143 "preproc.c"
    break;

  case 2230: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr ESCAPE a_expr  */
#line 12935 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-6].str),mm_strdup("not similar to"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 55151 "preproc.c"
    break;

  case 2231: /* a_expr: a_expr IS NULL_P  */
#line 12939 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is null"));
}
#line 55159 "preproc.c"
    break;

  case 2232: /* a_expr: a_expr ISNULL  */
#line 12943 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("isnull"));
}
#line 55167 "preproc.c"
    break;

  case 2233: /* a_expr: a_expr IS NOT NULL_P  */
#line 12947 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not null"));
}
#line 55175 "preproc.c"
    break;

  case 2234: /* a_expr: a_expr NOTNULL  */
#line 12951 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("notnull"));
}
#line 55183 "preproc.c"
    break;

  case 2235: /* a_expr: row OVERLAPS row  */
#line 12955 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("overlaps"),(yyvsp[0].str));
}
#line 55191 "preproc.c"
    break;

  case 2236: /* a_expr: a_expr IS TRUE_P  */
#line 12959 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is true"));
}
#line 55199 "preproc.c"
    break;

  case 2237: /* a_expr: a_expr IS NOT TRUE_P  */
#line 12963 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not true"));
}
#line 55207 "preproc.c"
    break;

  case 2238: /* a_expr: a_expr IS FALSE_P  */
#line 12967 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is false"));
}
#line 55215 "preproc.c"
    break;

  case 2239: /* a_expr: a_expr IS NOT FALSE_P  */
#line 12971 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not false"));
}
#line 55223 "preproc.c"
    break;

  case 2240: /* a_expr: a_expr IS UNKNOWN  */
#line 12975 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is unknown"));
}
#line 55231 "preproc.c"
    break;

  case 2241: /* a_expr: a_expr IS NOT UNKNOWN  */
#line 12979 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not unknown"));
}
#line 55239 "preproc.c"
    break;

  case 2242: /* a_expr: a_expr IS DISTINCT FROM a_expr  */
#line 12983 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("is distinct from"),(yyvsp[0].str));
}
#line 55247 "preproc.c"
    break;

  case 2243: /* a_expr: a_expr IS NOT DISTINCT FROM a_expr  */
#line 12987 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-5].str),mm_strdup("is not distinct from"),(yyvsp[0].str));
}
#line 55255 "preproc.c"
    break;

  case 2244: /* a_expr: a_expr IS OF '(' type_list ')'  */
#line 12991 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("is of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55263 "preproc.c"
    break;

  case 2245: /* a_expr: a_expr IS NOT OF '(' type_list ')'  */
#line 12995 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-6].str),mm_strdup("is not of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55271 "preproc.c"
    break;

  case 2246: /* a_expr: a_expr BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 12999 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("between"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 55279 "preproc.c"
    break;

  case 2247: /* a_expr: a_expr NOT_LA BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 13003 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("not between"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 55287 "preproc.c"
    break;

  case 2248: /* a_expr: a_expr BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 13007 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("between symmetric"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 55295 "preproc.c"
    break;

  case 2249: /* a_expr: a_expr NOT_LA BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 13011 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-6].str),mm_strdup("not between symmetric"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 55303 "preproc.c"
    break;

  case 2250: /* a_expr: a_expr IN_P in_expr  */
#line 13015 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 55311 "preproc.c"
    break;

  case 2251: /* a_expr: a_expr NOT_LA IN_P in_expr  */
#line 13019 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not in"),(yyvsp[0].str));
}
#line 55319 "preproc.c"
    break;

  case 2252: /* a_expr: a_expr subquery_Op sub_type select_with_parens  */
#line 13023 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55327 "preproc.c"
    break;

  case 2253: /* a_expr: a_expr subquery_Op sub_type '(' a_expr ')'  */
#line 13027 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55335 "preproc.c"
    break;

  case 2254: /* a_expr: UNIQUE select_with_parens  */
#line 13031 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("unique"),(yyvsp[0].str));
}
#line 55344 "preproc.c"
    break;

  case 2255: /* a_expr: a_expr IS DOCUMENT_P  */
#line 13036 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is document"));
}
#line 55352 "preproc.c"
    break;

  case 2256: /* a_expr: a_expr IS NOT DOCUMENT_P  */
#line 13040 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not document"));
}
#line 55360 "preproc.c"
    break;

  case 2257: /* a_expr: DEFAULT  */
#line 13044 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 55368 "preproc.c"
    break;

  case 2258: /* b_expr: c_expr  */
#line 13052 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55376 "preproc.c"
    break;

  case 2259: /* b_expr: b_expr TYPECAST Typename  */
#line 13056 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("::"),(yyvsp[0].str));
}
#line 55384 "preproc.c"
    break;

  case 2260: /* b_expr: '+' b_expr  */
#line 13060 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 55392 "preproc.c"
    break;

  case 2261: /* b_expr: '-' b_expr  */
#line 13064 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 55400 "preproc.c"
    break;

  case 2262: /* b_expr: b_expr '+' b_expr  */
#line 13068 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("+"),(yyvsp[0].str));
}
#line 55408 "preproc.c"
    break;

  case 2263: /* b_expr: b_expr '-' b_expr  */
#line 13072 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("-"),(yyvsp[0].str));
}
#line 55416 "preproc.c"
    break;

  case 2264: /* b_expr: b_expr '*' b_expr  */
#line 13076 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("*"),(yyvsp[0].str));
}
#line 55424 "preproc.c"
    break;

  case 2265: /* b_expr: b_expr '/' b_expr  */
#line 13080 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("/"),(yyvsp[0].str));
}
#line 55432 "preproc.c"
    break;

  case 2266: /* b_expr: b_expr '%' b_expr  */
#line 13084 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("%"),(yyvsp[0].str));
}
#line 55440 "preproc.c"
    break;

  case 2267: /* b_expr: b_expr '^' b_expr  */
#line 13088 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("^"),(yyvsp[0].str));
}
#line 55448 "preproc.c"
    break;

  case 2268: /* b_expr: b_expr '<' b_expr  */
#line 13092 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<"),(yyvsp[0].str));
}
#line 55456 "preproc.c"
    break;

  case 2269: /* b_expr: b_expr '>' b_expr  */
#line 13096 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">"),(yyvsp[0].str));
}
#line 55464 "preproc.c"
    break;

  case 2270: /* b_expr: b_expr '=' b_expr  */
#line 13100 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 55472 "preproc.c"
    break;

  case 2271: /* b_expr: b_expr LESS_EQUALS b_expr  */
#line 13104 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<="),(yyvsp[0].str));
}
#line 55480 "preproc.c"
    break;

  case 2272: /* b_expr: b_expr GREATER_EQUALS b_expr  */
#line 13108 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">="),(yyvsp[0].str));
}
#line 55488 "preproc.c"
    break;

  case 2273: /* b_expr: b_expr NOT_EQUALS b_expr  */
#line 13112 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<>"),(yyvsp[0].str));
}
#line 55496 "preproc.c"
    break;

  case 2274: /* b_expr: b_expr qual_Op b_expr  */
#line 13116 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55504 "preproc.c"
    break;

  case 2275: /* b_expr: qual_Op b_expr  */
#line 13120 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55512 "preproc.c"
    break;

  case 2276: /* b_expr: b_expr qual_Op  */
#line 13124 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55520 "preproc.c"
    break;

  case 2277: /* b_expr: b_expr IS DISTINCT FROM b_expr  */
#line 13128 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("is distinct from"),(yyvsp[0].str));
}
#line 55528 "preproc.c"
    break;

  case 2278: /* b_expr: b_expr IS NOT DISTINCT FROM b_expr  */
#line 13132 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-5].str),mm_strdup("is not distinct from"),(yyvsp[0].str));
}
#line 55536 "preproc.c"
    break;

  case 2279: /* b_expr: b_expr IS OF '(' type_list ')'  */
#line 13136 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("is of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55544 "preproc.c"
    break;

  case 2280: /* b_expr: b_expr IS NOT OF '(' type_list ')'  */
#line 13140 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-6].str),mm_strdup("is not of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55552 "preproc.c"
    break;

  case 2281: /* b_expr: b_expr IS DOCUMENT_P  */
#line 13144 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is document"));
}
#line 55560 "preproc.c"
    break;

  case 2282: /* b_expr: b_expr IS NOT DOCUMENT_P  */
#line 13148 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not document"));
}
#line 55568 "preproc.c"
    break;

  case 2283: /* c_expr: columnref  */
#line 13156 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55576 "preproc.c"
    break;

  case 2284: /* c_expr: AexprConst  */
#line 13160 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55584 "preproc.c"
    break;

  case 2285: /* c_expr: ecpg_param opt_indirection  */
#line 13164 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55592 "preproc.c"
    break;

  case 2286: /* c_expr: '(' a_expr ')' opt_indirection  */
#line 13168 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 55600 "preproc.c"
    break;

  case 2287: /* c_expr: case_expr  */
#line 13172 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55608 "preproc.c"
    break;

  case 2288: /* c_expr: func_expr  */
#line 13176 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55616 "preproc.c"
    break;

  case 2289: /* c_expr: select_with_parens  */
#line 13180 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55624 "preproc.c"
    break;

  case 2290: /* c_expr: select_with_parens indirection  */
#line 13184 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55632 "preproc.c"
    break;

  case 2291: /* c_expr: EXISTS select_with_parens  */
#line 13188 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("exists"),(yyvsp[0].str));
}
#line 55640 "preproc.c"
    break;

  case 2292: /* c_expr: ARRAY select_with_parens  */
#line 13192 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("array"),(yyvsp[0].str));
}
#line 55648 "preproc.c"
    break;

  case 2293: /* c_expr: ARRAY array_expr  */
#line 13196 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("array"),(yyvsp[0].str));
}
#line 55656 "preproc.c"
    break;

  case 2294: /* c_expr: explicit_row  */
#line 13200 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55664 "preproc.c"
    break;

  case 2295: /* c_expr: implicit_row  */
#line 13204 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55672 "preproc.c"
    break;

  case 2296: /* c_expr: GROUPING '(' expr_list ')'  */
#line 13208 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("grouping ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55680 "preproc.c"
    break;

  case 2297: /* func_application: func_name '(' ')'  */
#line 13216 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("( )"));
}
#line 55688 "preproc.c"
    break;

  case 2298: /* func_application: func_name '(' func_arg_list opt_sort_clause ')'  */
#line 13220 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55696 "preproc.c"
    break;

  case 2299: /* func_application: func_name '(' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 13224 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( variadic"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55704 "preproc.c"
    break;

  case 2300: /* func_application: func_name '(' func_arg_list ',' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 13228 "preproc.y"
 { 
 (yyval.str) = cat_str(7,(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(", variadic"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55712 "preproc.c"
    break;

  case 2301: /* func_application: func_name '(' ALL func_arg_list opt_sort_clause ')'  */
#line 13232 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( all"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55720 "preproc.c"
    break;

  case 2302: /* func_application: func_name '(' DISTINCT func_arg_list opt_sort_clause ')'  */
#line 13236 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( distinct"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55728 "preproc.c"
    break;

  case 2303: /* func_application: func_name '(' '*' ')'  */
#line 13240 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("( * )"));
}
#line 55736 "preproc.c"
    break;

  case 2304: /* func_expr: func_application within_group_clause filter_clause over_clause  */
#line 13248 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 55744 "preproc.c"
    break;

  case 2305: /* func_expr: func_expr_common_subexpr  */
#line 13252 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55752 "preproc.c"
    break;

  case 2306: /* func_expr_windowless: func_application  */
#line 13260 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55760 "preproc.c"
    break;

  case 2307: /* func_expr_windowless: func_expr_common_subexpr  */
#line 13264 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 55768 "preproc.c"
    break;

  case 2308: /* func_expr_common_subexpr: COLLATION FOR '(' a_expr ')'  */
#line 13272 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("collation for ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55776 "preproc.c"
    break;

  case 2309: /* func_expr_common_subexpr: CURRENT_DATE  */
#line 13276 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_date");
}
#line 55784 "preproc.c"
    break;

  case 2310: /* func_expr_common_subexpr: CURRENT_TIME  */
#line 13280 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_time");
}
#line 55792 "preproc.c"
    break;

  case 2311: /* func_expr_common_subexpr: CURRENT_TIME '(' Iconst ')'  */
#line 13284 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("current_time ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55800 "preproc.c"
    break;

  case 2312: /* func_expr_common_subexpr: CURRENT_TIMESTAMP  */
#line 13288 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_timestamp");
}
#line 55808 "preproc.c"
    break;

  case 2313: /* func_expr_common_subexpr: CURRENT_TIMESTAMP '(' Iconst ')'  */
#line 13292 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("current_timestamp ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55816 "preproc.c"
    break;

  case 2314: /* func_expr_common_subexpr: LOCALTIME  */
#line 13296 "preproc.y"
 { 
 (yyval.str) = mm_strdup("localtime");
}
#line 55824 "preproc.c"
    break;

  case 2315: /* func_expr_common_subexpr: LOCALTIME '(' Iconst ')'  */
#line 13300 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("localtime ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55832 "preproc.c"
    break;

  case 2316: /* func_expr_common_subexpr: LOCALTIMESTAMP  */
#line 13304 "preproc.y"
 { 
 (yyval.str) = mm_strdup("localtimestamp");
}
#line 55840 "preproc.c"
    break;

  case 2317: /* func_expr_common_subexpr: LOCALTIMESTAMP '(' Iconst ')'  */
#line 13308 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("localtimestamp ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55848 "preproc.c"
    break;

  case 2318: /* func_expr_common_subexpr: SYSDATE  */
#line 13312 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sysdate");
}
#line 55856 "preproc.c"
    break;

  case 2319: /* func_expr_common_subexpr: SYSTIMESTAMP  */
#line 13316 "preproc.y"
 { 
 (yyval.str) = mm_strdup("systimestamp");
}
#line 55864 "preproc.c"
    break;

  case 2320: /* func_expr_common_subexpr: CURRENT_ROLE  */
#line 13320 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_role");
}
#line 55872 "preproc.c"
    break;

  case 2321: /* func_expr_common_subexpr: CURRENT_USER  */
#line 13324 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_user");
}
#line 55880 "preproc.c"
    break;

  case 2322: /* func_expr_common_subexpr: SESSION_USER  */
#line 13328 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session_user");
}
#line 55888 "preproc.c"
    break;

  case 2323: /* func_expr_common_subexpr: SESSIONTIMEZONE  */
#line 13332 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sessiontimezone");
}
#line 55896 "preproc.c"
    break;

  case 2324: /* func_expr_common_subexpr: DBTIMEZONE  */
#line 13336 "preproc.y"
 { 
 (yyval.str) = mm_strdup("dbtimezone");
}
#line 55904 "preproc.c"
    break;

  case 2325: /* func_expr_common_subexpr: USER  */
#line 13340 "preproc.y"
 { 
 (yyval.str) = mm_strdup("user");
}
#line 55912 "preproc.c"
    break;

  case 2326: /* func_expr_common_subexpr: CURRENT_CATALOG  */
#line 13344 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_catalog");
}
#line 55920 "preproc.c"
    break;

  case 2327: /* func_expr_common_subexpr: CURRENT_SCHEMA  */
#line 13348 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_schema");
}
#line 55928 "preproc.c"
    break;

  case 2328: /* func_expr_common_subexpr: CAST '(' a_expr AS Typename ')'  */
#line 13352 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("cast ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55936 "preproc.c"
    break;

  case 2329: /* func_expr_common_subexpr: EXTRACT '(' extract_list ')'  */
#line 13356 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("extract ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55944 "preproc.c"
    break;

  case 2330: /* func_expr_common_subexpr: OVERLAY '(' overlay_list ')'  */
#line 13360 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("overlay ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55952 "preproc.c"
    break;

  case 2331: /* func_expr_common_subexpr: POSITION '(' position_list ')'  */
#line 13364 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("position ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55960 "preproc.c"
    break;

  case 2332: /* func_expr_common_subexpr: SUBSTRING '(' substr_list ')'  */
#line 13368 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("substring ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55968 "preproc.c"
    break;

  case 2333: /* func_expr_common_subexpr: TREAT '(' a_expr AS Typename ')'  */
#line 13372 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("treat ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55976 "preproc.c"
    break;

  case 2334: /* func_expr_common_subexpr: TRIM '(' BOTH trim_list ')'  */
#line 13376 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( both"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55984 "preproc.c"
    break;

  case 2335: /* func_expr_common_subexpr: TRIM '(' LEADING trim_list ')'  */
#line 13380 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( leading"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 55992 "preproc.c"
    break;

  case 2336: /* func_expr_common_subexpr: TRIM '(' TRAILING trim_list ')'  */
#line 13384 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( trailing"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56000 "preproc.c"
    break;

  case 2337: /* func_expr_common_subexpr: TRIM '(' trim_list ')'  */
#line 13388 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("trim ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56008 "preproc.c"
    break;

  case 2338: /* func_expr_common_subexpr: NULLIF '(' a_expr ',' a_expr ')'  */
#line 13392 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("nullif ("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56016 "preproc.c"
    break;

  case 2339: /* func_expr_common_subexpr: COALESCE '(' expr_list ')'  */
#line 13396 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("coalesce ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56024 "preproc.c"
    break;

  case 2340: /* func_expr_common_subexpr: GREATEST '(' expr_list ')'  */
#line 13400 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("greatest ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56032 "preproc.c"
    break;

  case 2341: /* func_expr_common_subexpr: LEAST '(' expr_list ')'  */
#line 13404 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("least ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56040 "preproc.c"
    break;

  case 2342: /* func_expr_common_subexpr: XMLCONCAT '(' expr_list ')'  */
#line 13408 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlconcat ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56048 "preproc.c"
    break;

  case 2343: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ')'  */
#line 13412 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlelement ( name"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56056 "preproc.c"
    break;

  case 2344: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ')'  */
#line 13416 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("xmlelement ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56064 "preproc.c"
    break;

  case 2345: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' expr_list ')'  */
#line 13420 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("xmlelement ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56072 "preproc.c"
    break;

  case 2346: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ',' expr_list ')'  */
#line 13424 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("xmlelement ( name"),(yyvsp[-5].str),mm_strdup(","),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56080 "preproc.c"
    break;

  case 2347: /* func_expr_common_subexpr: XMLEXISTS '(' c_expr xmlexists_argument ')'  */
#line 13428 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("xmlexists ("),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56088 "preproc.c"
    break;

  case 2348: /* func_expr_common_subexpr: XMLFOREST '(' xml_attribute_list ')'  */
#line 13432 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlforest ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56096 "preproc.c"
    break;

  case 2349: /* func_expr_common_subexpr: XMLPARSE '(' document_or_content a_expr xml_whitespace_option ')'  */
#line 13436 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("xmlparse ("),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56104 "preproc.c"
    break;

  case 2350: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ')'  */
#line 13440 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlpi ( name"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56112 "preproc.c"
    break;

  case 2351: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ',' a_expr ')'  */
#line 13444 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("xmlpi ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56120 "preproc.c"
    break;

  case 2352: /* func_expr_common_subexpr: XMLROOT '(' a_expr ',' xml_root_version opt_xml_root_standalone ')'  */
#line 13448 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("xmlroot ("),(yyvsp[-4].str),mm_strdup(","),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56128 "preproc.c"
    break;

  case 2353: /* func_expr_common_subexpr: XMLSERIALIZE '(' document_or_content a_expr AS SimpleTypename ')'  */
#line 13452 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("xmlserialize ("),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56136 "preproc.c"
    break;

  case 2354: /* xml_root_version: VERSION_P a_expr  */
#line 13460 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 56144 "preproc.c"
    break;

  case 2355: /* xml_root_version: VERSION_P NO VALUE_P  */
#line 13464 "preproc.y"
 { 
 (yyval.str) = mm_strdup("version no value");
}
#line 56152 "preproc.c"
    break;

  case 2356: /* opt_xml_root_standalone: ',' STANDALONE_P YES_P  */
#line 13472 "preproc.y"
 { 
 (yyval.str) = mm_strdup(", standalone yes");
}
#line 56160 "preproc.c"
    break;

  case 2357: /* opt_xml_root_standalone: ',' STANDALONE_P NO  */
#line 13476 "preproc.y"
 { 
 (yyval.str) = mm_strdup(", standalone no");
}
#line 56168 "preproc.c"
    break;

  case 2358: /* opt_xml_root_standalone: ',' STANDALONE_P NO VALUE_P  */
#line 13480 "preproc.y"
 { 
 (yyval.str) = mm_strdup(", standalone no value");
}
#line 56176 "preproc.c"
    break;

  case 2359: /* opt_xml_root_standalone: %empty  */
#line 13484 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56183 "preproc.c"
    break;

  case 2360: /* xml_attributes: XMLATTRIBUTES '(' xml_attribute_list ')'  */
#line 13491 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlattributes ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56191 "preproc.c"
    break;

  case 2361: /* xml_attribute_list: xml_attribute_el  */
#line 13499 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56199 "preproc.c"
    break;

  case 2362: /* xml_attribute_list: xml_attribute_list ',' xml_attribute_el  */
#line 13503 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 56207 "preproc.c"
    break;

  case 2363: /* xml_attribute_el: a_expr AS ColLabel  */
#line 13511 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 56215 "preproc.c"
    break;

  case 2364: /* xml_attribute_el: a_expr  */
#line 13515 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56223 "preproc.c"
    break;

  case 2365: /* document_or_content: DOCUMENT_P  */
#line 13523 "preproc.y"
 { 
 (yyval.str) = mm_strdup("document");
}
#line 56231 "preproc.c"
    break;

  case 2366: /* document_or_content: CONTENT_P  */
#line 13527 "preproc.y"
 { 
 (yyval.str) = mm_strdup("content");
}
#line 56239 "preproc.c"
    break;

  case 2367: /* xml_whitespace_option: PRESERVE WHITESPACE_P  */
#line 13535 "preproc.y"
 { 
 (yyval.str) = mm_strdup("preserve whitespace");
}
#line 56247 "preproc.c"
    break;

  case 2368: /* xml_whitespace_option: STRIP_P WHITESPACE_P  */
#line 13539 "preproc.y"
 { 
 (yyval.str) = mm_strdup("strip whitespace");
}
#line 56255 "preproc.c"
    break;

  case 2369: /* xml_whitespace_option: %empty  */
#line 13543 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56262 "preproc.c"
    break;

  case 2370: /* xmlexists_argument: PASSING c_expr  */
#line 13550 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("passing"),(yyvsp[0].str));
}
#line 56270 "preproc.c"
    break;

  case 2371: /* xmlexists_argument: PASSING c_expr BY REF  */
#line 13554 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("passing"),(yyvsp[-2].str),mm_strdup("by ref"));
}
#line 56278 "preproc.c"
    break;

  case 2372: /* xmlexists_argument: PASSING BY REF c_expr  */
#line 13558 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("passing by ref"),(yyvsp[0].str));
}
#line 56286 "preproc.c"
    break;

  case 2373: /* xmlexists_argument: PASSING BY REF c_expr BY REF  */
#line 13562 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("passing by ref"),(yyvsp[-2].str),mm_strdup("by ref"));
}
#line 56294 "preproc.c"
    break;

  case 2374: /* within_group_clause: WITHIN GROUP_P '(' sort_clause ')'  */
#line 13570 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("within group ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56302 "preproc.c"
    break;

  case 2375: /* within_group_clause: %empty  */
#line 13574 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56309 "preproc.c"
    break;

  case 2376: /* filter_clause: FILTER '(' WHERE a_expr ')'  */
#line 13581 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("filter ( where"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56317 "preproc.c"
    break;

  case 2377: /* filter_clause: %empty  */
#line 13585 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56324 "preproc.c"
    break;

  case 2378: /* window_clause: WINDOW window_definition_list  */
#line 13592 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("window"),(yyvsp[0].str));
}
#line 56332 "preproc.c"
    break;

  case 2379: /* window_clause: %empty  */
#line 13596 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56339 "preproc.c"
    break;

  case 2380: /* window_definition_list: window_definition  */
#line 13603 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56347 "preproc.c"
    break;

  case 2381: /* window_definition_list: window_definition_list ',' window_definition  */
#line 13607 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 56355 "preproc.c"
    break;

  case 2382: /* window_definition: ColId AS window_specification  */
#line 13615 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 56363 "preproc.c"
    break;

  case 2383: /* over_clause: OVER window_specification  */
#line 13623 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("over"),(yyvsp[0].str));
}
#line 56371 "preproc.c"
    break;

  case 2384: /* over_clause: OVER ColId  */
#line 13627 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("over"),(yyvsp[0].str));
}
#line 56379 "preproc.c"
    break;

  case 2385: /* over_clause: %empty  */
#line 13631 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56386 "preproc.c"
    break;

  case 2386: /* window_specification: '(' opt_existing_window_name opt_partition_clause opt_sort_clause opt_frame_clause ')'  */
#line 13638 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("("),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56394 "preproc.c"
    break;

  case 2387: /* opt_existing_window_name: ColId  */
#line 13646 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56402 "preproc.c"
    break;

  case 2388: /* opt_existing_window_name: %empty  */
#line 13650 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56409 "preproc.c"
    break;

  case 2389: /* opt_partition_clause: PARTITION BY expr_list  */
#line 13657 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("partition by"),(yyvsp[0].str));
}
#line 56417 "preproc.c"
    break;

  case 2390: /* opt_partition_clause: %empty  */
#line 13661 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56424 "preproc.c"
    break;

  case 2391: /* opt_frame_clause: RANGE frame_extent  */
#line 13668 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("range"),(yyvsp[0].str));
}
#line 56433 "preproc.c"
    break;

  case 2392: /* opt_frame_clause: ROWS frame_extent  */
#line 13673 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("rows"),(yyvsp[0].str));
}
#line 56441 "preproc.c"
    break;

  case 2393: /* opt_frame_clause: %empty  */
#line 13677 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56448 "preproc.c"
    break;

  case 2394: /* frame_extent: frame_bound  */
#line 13684 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56456 "preproc.c"
    break;

  case 2395: /* frame_extent: BETWEEN frame_bound AND frame_bound  */
#line 13688 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("between"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 56464 "preproc.c"
    break;

  case 2396: /* frame_bound: UNBOUNDED PRECEDING  */
#line 13696 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unbounded preceding");
}
#line 56472 "preproc.c"
    break;

  case 2397: /* frame_bound: UNBOUNDED FOLLOWING  */
#line 13700 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unbounded following");
}
#line 56480 "preproc.c"
    break;

  case 2398: /* frame_bound: CURRENT_P ROW  */
#line 13704 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current row");
}
#line 56488 "preproc.c"
    break;

  case 2399: /* frame_bound: a_expr PRECEDING  */
#line 13708 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("preceding"));
}
#line 56496 "preproc.c"
    break;

  case 2400: /* frame_bound: a_expr FOLLOWING  */
#line 13712 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("following"));
}
#line 56504 "preproc.c"
    break;

  case 2401: /* row: ROW '(' expr_list ')'  */
#line 13720 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("row ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56512 "preproc.c"
    break;

  case 2402: /* row: ROW '(' ')'  */
#line 13724 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row ( )");
}
#line 56520 "preproc.c"
    break;

  case 2403: /* row: '(' expr_list ',' a_expr ')'  */
#line 13728 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56528 "preproc.c"
    break;

  case 2404: /* explicit_row: ROW '(' expr_list ')'  */
#line 13736 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("row ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56536 "preproc.c"
    break;

  case 2405: /* explicit_row: ROW '(' ')'  */
#line 13740 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row ( )");
}
#line 56544 "preproc.c"
    break;

  case 2406: /* implicit_row: '(' expr_list ',' a_expr ')'  */
#line 13748 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56552 "preproc.c"
    break;

  case 2407: /* sub_type: ANY  */
#line 13756 "preproc.y"
 { 
 (yyval.str) = mm_strdup("any");
}
#line 56560 "preproc.c"
    break;

  case 2408: /* sub_type: SOME  */
#line 13760 "preproc.y"
 { 
 (yyval.str) = mm_strdup("some");
}
#line 56568 "preproc.c"
    break;

  case 2409: /* sub_type: ALL  */
#line 13764 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 56576 "preproc.c"
    break;

  case 2410: /* all_Op: Op  */
#line 13772 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56584 "preproc.c"
    break;

  case 2411: /* all_Op: MathOp  */
#line 13776 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56592 "preproc.c"
    break;

  case 2412: /* MathOp: '+'  */
#line 13784 "preproc.y"
 { 
 (yyval.str) = mm_strdup("+");
}
#line 56600 "preproc.c"
    break;

  case 2413: /* MathOp: '-'  */
#line 13788 "preproc.y"
 { 
 (yyval.str) = mm_strdup("-");
}
#line 56608 "preproc.c"
    break;

  case 2414: /* MathOp: '*'  */
#line 13792 "preproc.y"
 { 
 (yyval.str) = mm_strdup("*");
}
#line 56616 "preproc.c"
    break;

  case 2415: /* MathOp: '/'  */
#line 13796 "preproc.y"
 { 
 (yyval.str) = mm_strdup("/");
}
#line 56624 "preproc.c"
    break;

  case 2416: /* MathOp: '%'  */
#line 13800 "preproc.y"
 { 
 (yyval.str) = mm_strdup("%");
}
#line 56632 "preproc.c"
    break;

  case 2417: /* MathOp: '^'  */
#line 13804 "preproc.y"
 { 
 (yyval.str) = mm_strdup("^");
}
#line 56640 "preproc.c"
    break;

  case 2418: /* MathOp: '<'  */
#line 13808 "preproc.y"
 { 
 (yyval.str) = mm_strdup("<");
}
#line 56648 "preproc.c"
    break;

  case 2419: /* MathOp: '>'  */
#line 13812 "preproc.y"
 { 
 (yyval.str) = mm_strdup(">");
}
#line 56656 "preproc.c"
    break;

  case 2420: /* MathOp: '='  */
#line 13816 "preproc.y"
 { 
 (yyval.str) = mm_strdup("=");
}
#line 56664 "preproc.c"
    break;

  case 2421: /* MathOp: LESS_EQUALS  */
#line 13820 "preproc.y"
 { 
 (yyval.str) = mm_strdup("<=");
}
#line 56672 "preproc.c"
    break;

  case 2422: /* MathOp: GREATER_EQUALS  */
#line 13824 "preproc.y"
 { 
 (yyval.str) = mm_strdup(">=");
}
#line 56680 "preproc.c"
    break;

  case 2423: /* MathOp: NOT_EQUALS  */
#line 13828 "preproc.y"
 { 
 (yyval.str) = mm_strdup("<>");
}
#line 56688 "preproc.c"
    break;

  case 2424: /* qual_Op: Op  */
#line 13836 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56696 "preproc.c"
    break;

  case 2425: /* qual_Op: OPERATOR '(' any_operator ')'  */
#line 13840 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56704 "preproc.c"
    break;

  case 2426: /* qual_all_Op: all_Op  */
#line 13848 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56712 "preproc.c"
    break;

  case 2427: /* qual_all_Op: OPERATOR '(' any_operator ')'  */
#line 13852 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56720 "preproc.c"
    break;

  case 2428: /* subquery_Op: all_Op  */
#line 13860 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56728 "preproc.c"
    break;

  case 2429: /* subquery_Op: OPERATOR '(' any_operator ')'  */
#line 13864 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 56736 "preproc.c"
    break;

  case 2430: /* subquery_Op: LIKE  */
#line 13868 "preproc.y"
 { 
 (yyval.str) = mm_strdup("like");
}
#line 56744 "preproc.c"
    break;

  case 2431: /* subquery_Op: NOT_LA LIKE  */
#line 13872 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not like");
}
#line 56752 "preproc.c"
    break;

  case 2432: /* subquery_Op: ILIKE  */
#line 13876 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ilike");
}
#line 56760 "preproc.c"
    break;

  case 2433: /* subquery_Op: NOT_LA ILIKE  */
#line 13880 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not ilike");
}
#line 56768 "preproc.c"
    break;

  case 2434: /* expr_list: a_expr  */
#line 13888 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56776 "preproc.c"
    break;

  case 2435: /* expr_list: expr_list ',' a_expr  */
#line 13892 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 56784 "preproc.c"
    break;

  case 2436: /* func_arg_list: func_arg_expr  */
#line 13900 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56792 "preproc.c"
    break;

  case 2437: /* func_arg_list: func_arg_list ',' func_arg_expr  */
#line 13904 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 56800 "preproc.c"
    break;

  case 2438: /* func_arg_expr: a_expr  */
#line 13912 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56808 "preproc.c"
    break;

  case 2439: /* func_arg_expr: param_name COLON_EQUALS a_expr  */
#line 13916 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(":="),(yyvsp[0].str));
}
#line 56816 "preproc.c"
    break;

  case 2440: /* func_arg_expr: param_name EQUALS_GREATER a_expr  */
#line 13920 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("=>"),(yyvsp[0].str));
}
#line 56824 "preproc.c"
    break;

  case 2441: /* type_list: Typename  */
#line 13928 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56832 "preproc.c"
    break;

  case 2442: /* type_list: type_list ',' Typename  */
#line 13932 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 56840 "preproc.c"
    break;

  case 2443: /* array_expr: '[' expr_list ']'  */
#line 13940 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 56848 "preproc.c"
    break;

  case 2444: /* array_expr: '[' array_expr_list ']'  */
#line 13944 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 56856 "preproc.c"
    break;

  case 2445: /* array_expr: '[' ']'  */
#line 13948 "preproc.y"
 { 
 (yyval.str) = mm_strdup("[ ]");
}
#line 56864 "preproc.c"
    break;

  case 2446: /* array_expr_list: array_expr  */
#line 13956 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56872 "preproc.c"
    break;

  case 2447: /* array_expr_list: array_expr_list ',' array_expr  */
#line 13960 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 56880 "preproc.c"
    break;

  case 2448: /* extract_list: extract_arg FROM a_expr  */
#line 13968 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 56888 "preproc.c"
    break;

  case 2449: /* extract_list: %empty  */
#line 13972 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56895 "preproc.c"
    break;

  case 2450: /* extract_arg: ecpg_ident  */
#line 13979 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56903 "preproc.c"
    break;

  case 2451: /* extract_arg: YEAR_P  */
#line 13983 "preproc.y"
 { 
 (yyval.str) = mm_strdup("year");
}
#line 56911 "preproc.c"
    break;

  case 2452: /* extract_arg: MONTH_P  */
#line 13987 "preproc.y"
 { 
 (yyval.str) = mm_strdup("month");
}
#line 56919 "preproc.c"
    break;

  case 2453: /* extract_arg: DAY_P  */
#line 13991 "preproc.y"
 { 
 (yyval.str) = mm_strdup("day");
}
#line 56927 "preproc.c"
    break;

  case 2454: /* extract_arg: HOUR_P  */
#line 13995 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hour");
}
#line 56935 "preproc.c"
    break;

  case 2455: /* extract_arg: MINUTE_P  */
#line 13999 "preproc.y"
 { 
 (yyval.str) = mm_strdup("minute");
}
#line 56943 "preproc.c"
    break;

  case 2456: /* extract_arg: SECOND_P  */
#line 14003 "preproc.y"
 { 
 (yyval.str) = mm_strdup("second");
}
#line 56951 "preproc.c"
    break;

  case 2457: /* extract_arg: ecpg_sconst  */
#line 14007 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56959 "preproc.c"
    break;

  case 2458: /* overlay_list: a_expr overlay_placing substr_from substr_for  */
#line 14015 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 56967 "preproc.c"
    break;

  case 2459: /* overlay_list: a_expr overlay_placing substr_from  */
#line 14019 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 56975 "preproc.c"
    break;

  case 2460: /* overlay_placing: PLACING a_expr  */
#line 14027 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("placing"),(yyvsp[0].str));
}
#line 56983 "preproc.c"
    break;

  case 2461: /* position_list: b_expr IN_P b_expr  */
#line 14035 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 56991 "preproc.c"
    break;

  case 2462: /* position_list: %empty  */
#line 14039 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 56998 "preproc.c"
    break;

  case 2463: /* substr_list: a_expr substr_from substr_for  */
#line 14046 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57006 "preproc.c"
    break;

  case 2464: /* substr_list: a_expr substr_for substr_from  */
#line 14050 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57014 "preproc.c"
    break;

  case 2465: /* substr_list: a_expr substr_from  */
#line 14054 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57022 "preproc.c"
    break;

  case 2466: /* substr_list: a_expr substr_for  */
#line 14058 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57030 "preproc.c"
    break;

  case 2467: /* substr_list: expr_list  */
#line 14062 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57038 "preproc.c"
    break;

  case 2468: /* substr_list: %empty  */
#line 14066 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 57045 "preproc.c"
    break;

  case 2469: /* substr_from: FROM a_expr  */
#line 14073 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 57053 "preproc.c"
    break;

  case 2470: /* substr_for: FOR a_expr  */
#line 14081 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 57061 "preproc.c"
    break;

  case 2471: /* trim_list: a_expr FROM expr_list  */
#line 14089 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 57069 "preproc.c"
    break;

  case 2472: /* trim_list: FROM expr_list  */
#line 14093 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 57077 "preproc.c"
    break;

  case 2473: /* trim_list: expr_list  */
#line 14097 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57085 "preproc.c"
    break;

  case 2474: /* in_expr: select_with_parens  */
#line 14105 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57093 "preproc.c"
    break;

  case 2475: /* in_expr: '(' expr_list ')'  */
#line 14109 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 57101 "preproc.c"
    break;

  case 2476: /* case_expr: CASE case_arg when_clause_list case_default END_P  */
#line 14117 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("case"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("end"));
}
#line 57109 "preproc.c"
    break;

  case 2477: /* when_clause_list: when_clause  */
#line 14125 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57117 "preproc.c"
    break;

  case 2478: /* when_clause_list: when_clause_list when_clause  */
#line 14129 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57125 "preproc.c"
    break;

  case 2479: /* when_clause: WHEN a_expr THEN a_expr  */
#line 14137 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("when"),(yyvsp[-2].str),mm_strdup("then"),(yyvsp[0].str));
}
#line 57133 "preproc.c"
    break;

  case 2480: /* case_default: ELSE a_expr  */
#line 14145 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("else"),(yyvsp[0].str));
}
#line 57141 "preproc.c"
    break;

  case 2481: /* case_default: %empty  */
#line 14149 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 57148 "preproc.c"
    break;

  case 2482: /* case_arg: a_expr  */
#line 14156 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57156 "preproc.c"
    break;

  case 2483: /* case_arg: %empty  */
#line 14160 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 57163 "preproc.c"
    break;

  case 2484: /* columnref: ColId  */
#line 14167 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57171 "preproc.c"
    break;

  case 2485: /* columnref: ColId indirection  */
#line 14171 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57179 "preproc.c"
    break;

  case 2486: /* indirection_el: '.' attr_name  */
#line 14179 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("."),(yyvsp[0].str));
}
#line 57187 "preproc.c"
    break;

  case 2487: /* indirection_el: '.' '*'  */
#line 14183 "preproc.y"
 { 
 (yyval.str) = mm_strdup(". *");
}
#line 57195 "preproc.c"
    break;

  case 2488: /* indirection_el: '[' a_expr ']'  */
#line 14187 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 57203 "preproc.c"
    break;

  case 2489: /* indirection_el: '[' opt_slice_bound ':' opt_slice_bound ']'  */
#line 14191 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("["),(yyvsp[-3].str),mm_strdup(":"),(yyvsp[-1].str),mm_strdup("]"));
}
#line 57211 "preproc.c"
    break;

  case 2490: /* opt_slice_bound: a_expr  */
#line 14199 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57219 "preproc.c"
    break;

  case 2491: /* opt_slice_bound: %empty  */
#line 14203 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 57226 "preproc.c"
    break;

  case 2492: /* indirection: indirection_el  */
#line 14210 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57234 "preproc.c"
    break;

  case 2493: /* indirection: indirection indirection_el  */
#line 14214 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57242 "preproc.c"
    break;

  case 2494: /* opt_indirection: %empty  */
#line 14222 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 57249 "preproc.c"
    break;

  case 2495: /* opt_indirection: opt_indirection indirection_el  */
#line 14225 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57257 "preproc.c"
    break;

  case 2496: /* opt_asymmetric: ASYMMETRIC  */
#line 14233 "preproc.y"
 { 
 (yyval.str) = mm_strdup("asymmetric");
}
#line 57265 "preproc.c"
    break;

  case 2497: /* opt_asymmetric: %empty  */
#line 14237 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 57272 "preproc.c"
    break;

  case 2498: /* opt_target_list: target_list  */
#line 14244 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57280 "preproc.c"
    break;

  case 2499: /* opt_target_list: %empty  */
#line 14248 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 57287 "preproc.c"
    break;

  case 2500: /* target_list: target_el  */
#line 14255 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57295 "preproc.c"
    break;

  case 2501: /* target_list: target_list ',' target_el  */
#line 14259 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 57303 "preproc.c"
    break;

  case 2502: /* target_el: a_expr AS ColLabel  */
#line 14267 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 57311 "preproc.c"
    break;

  case 2503: /* target_el: a_expr ecpg_ident  */
#line 14271 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57319 "preproc.c"
    break;

  case 2504: /* target_el: a_expr  */
#line 14275 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57327 "preproc.c"
    break;

  case 2505: /* target_el: '*'  */
#line 14279 "preproc.y"
 { 
 (yyval.str) = mm_strdup("*");
}
#line 57335 "preproc.c"
    break;

  case 2506: /* qualified_name_list: qualified_name  */
#line 14287 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57343 "preproc.c"
    break;

  case 2507: /* qualified_name_list: qualified_name_list ',' qualified_name  */
#line 14291 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 57351 "preproc.c"
    break;

  case 2508: /* qualified_name: ColId  */
#line 14299 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57359 "preproc.c"
    break;

  case 2509: /* qualified_name: ColId indirection  */
#line 14303 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57367 "preproc.c"
    break;

  case 2510: /* name_list: name  */
#line 14311 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57375 "preproc.c"
    break;

  case 2511: /* name_list: name_list ',' name  */
#line 14315 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 57383 "preproc.c"
    break;

  case 2512: /* name: ColId  */
#line 14323 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57391 "preproc.c"
    break;

  case 2513: /* database_name: ColId  */
#line 14331 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57399 "preproc.c"
    break;

  case 2514: /* access_method: ColId  */
#line 14339 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57407 "preproc.c"
    break;

  case 2515: /* attr_name: ColLabel  */
#line 14347 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57415 "preproc.c"
    break;

  case 2516: /* index_name: ColId  */
#line 14355 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57423 "preproc.c"
    break;

  case 2517: /* file_name: ecpg_sconst  */
#line 14363 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57431 "preproc.c"
    break;

  case 2518: /* func_name: type_function_name  */
#line 14371 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57439 "preproc.c"
    break;

  case 2519: /* func_name: ColId indirection  */
#line 14375 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57447 "preproc.c"
    break;

  case 2520: /* AexprConst: Iconst  */
#line 14383 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57455 "preproc.c"
    break;

  case 2521: /* AexprConst: ecpg_fconst  */
#line 14387 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57463 "preproc.c"
    break;

  case 2522: /* AexprConst: ecpg_sconst  */
#line 14391 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57471 "preproc.c"
    break;

  case 2523: /* AexprConst: ecpg_bconst  */
#line 14395 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57479 "preproc.c"
    break;

  case 2524: /* AexprConst: XCONST  */
#line 14399 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xconst");
}
#line 57487 "preproc.c"
    break;

  case 2525: /* AexprConst: func_name ecpg_sconst  */
#line 14403 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57495 "preproc.c"
    break;

  case 2526: /* AexprConst: func_name '(' func_arg_list opt_sort_clause ')' ecpg_sconst  */
#line 14407 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 57503 "preproc.c"
    break;

  case 2527: /* AexprConst: ConstTypename ecpg_sconst  */
#line 14411 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57511 "preproc.c"
    break;

  case 2528: /* AexprConst: ConstInterval ecpg_sconst opt_interval  */
#line 14415 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 57519 "preproc.c"
    break;

  case 2529: /* AexprConst: ConstInterval '(' Iconst ')' ecpg_sconst  */
#line 14419 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 57527 "preproc.c"
    break;

  case 2530: /* AexprConst: TRUE_P  */
#line 14423 "preproc.y"
 { 
 (yyval.str) = mm_strdup("true");
}
#line 57535 "preproc.c"
    break;

  case 2531: /* AexprConst: FALSE_P  */
#line 14427 "preproc.y"
 { 
 (yyval.str) = mm_strdup("false");
}
#line 57543 "preproc.c"
    break;

  case 2532: /* AexprConst: NULL_P  */
#line 14431 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 57551 "preproc.c"
    break;

  case 2533: /* AexprConst: civar  */
#line 14434 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 57557 "preproc.c"
    break;

  case 2534: /* AexprConst: civarind  */
#line 14435 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 57563 "preproc.c"
    break;

  case 2535: /* Iconst: ICONST  */
#line 14441 "preproc.y"
        { (yyval.str) = make_name(); }
#line 57569 "preproc.c"
    break;

  case 2536: /* SignedIconst: Iconst  */
#line 14447 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57577 "preproc.c"
    break;

  case 2537: /* SignedIconst: civar  */
#line 14450 "preproc.y"
                { (yyval.str) = (yyvsp[0].str); }
#line 57583 "preproc.c"
    break;

  case 2538: /* SignedIconst: '+' Iconst  */
#line 14452 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 57591 "preproc.c"
    break;

  case 2539: /* SignedIconst: '-' Iconst  */
#line 14456 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 57599 "preproc.c"
    break;

  case 2540: /* RoleId: RoleSpec  */
#line 14464 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57607 "preproc.c"
    break;

  case 2541: /* RoleSpec: NonReservedWord  */
#line 14472 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57615 "preproc.c"
    break;

  case 2542: /* RoleSpec: CURRENT_USER  */
#line 14476 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_user");
}
#line 57623 "preproc.c"
    break;

  case 2543: /* RoleSpec: SESSION_USER  */
#line 14480 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session_user");
}
#line 57631 "preproc.c"
    break;

  case 2544: /* role_list: RoleSpec  */
#line 14488 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57639 "preproc.c"
    break;

  case 2545: /* role_list: role_list ',' RoleSpec  */
#line 14492 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 57647 "preproc.c"
    break;

  case 2546: /* NonReservedWord: ecpg_ident  */
#line 14500 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57655 "preproc.c"
    break;

  case 2547: /* NonReservedWord: unreserved_keyword  */
#line 14504 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57663 "preproc.c"
    break;

  case 2548: /* NonReservedWord: col_name_keyword  */
#line 14508 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57671 "preproc.c"
    break;

  case 2549: /* NonReservedWord: type_func_name_keyword  */
#line 14512 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 57679 "preproc.c"
    break;

  case 2550: /* unreserved_keyword: ABORT_P  */
#line 14520 "preproc.y"
 { 
 (yyval.str) = mm_strdup("abort");
}
#line 57687 "preproc.c"
    break;

  case 2551: /* unreserved_keyword: ABSOLUTE_P  */
#line 14524 "preproc.y"
 { 
 (yyval.str) = mm_strdup("absolute");
}
#line 57695 "preproc.c"
    break;

  case 2552: /* unreserved_keyword: ACCESS  */
#line 14528 "preproc.y"
 { 
 (yyval.str) = mm_strdup("access");
}
#line 57703 "preproc.c"
    break;

  case 2553: /* unreserved_keyword: ACTION  */
#line 14532 "preproc.y"
 { 
 (yyval.str) = mm_strdup("action");
}
#line 57711 "preproc.c"
    break;

  case 2554: /* unreserved_keyword: ADD_P  */
#line 14536 "preproc.y"
 { 
 (yyval.str) = mm_strdup("add");
}
#line 57719 "preproc.c"
    break;

  case 2555: /* unreserved_keyword: ADMIN  */
#line 14540 "preproc.y"
 { 
 (yyval.str) = mm_strdup("admin");
}
#line 57727 "preproc.c"
    break;

  case 2556: /* unreserved_keyword: AFTER  */
#line 14544 "preproc.y"
 { 
 (yyval.str) = mm_strdup("after");
}
#line 57735 "preproc.c"
    break;

  case 2557: /* unreserved_keyword: AGGREGATE  */
#line 14548 "preproc.y"
 { 
 (yyval.str) = mm_strdup("aggregate");
}
#line 57743 "preproc.c"
    break;

  case 2558: /* unreserved_keyword: ALSO  */
#line 14552 "preproc.y"
 { 
 (yyval.str) = mm_strdup("also");
}
#line 57751 "preproc.c"
    break;

  case 2559: /* unreserved_keyword: ALTER  */
#line 14556 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter");
}
#line 57759 "preproc.c"
    break;

  case 2560: /* unreserved_keyword: ALWAYS  */
#line 14560 "preproc.y"
 { 
 (yyval.str) = mm_strdup("always");
}
#line 57767 "preproc.c"
    break;

  case 2561: /* unreserved_keyword: ASSERTION  */
#line 14564 "preproc.y"
 { 
 (yyval.str) = mm_strdup("assertion");
}
#line 57775 "preproc.c"
    break;

  case 2562: /* unreserved_keyword: ASSIGNMENT  */
#line 14568 "preproc.y"
 { 
 (yyval.str) = mm_strdup("assignment");
}
#line 57783 "preproc.c"
    break;

  case 2563: /* unreserved_keyword: AT  */
#line 14572 "preproc.y"
 { 
 (yyval.str) = mm_strdup("at");
}
#line 57791 "preproc.c"
    break;

  case 2564: /* unreserved_keyword: ATTACH  */
#line 14576 "preproc.y"
 { 
 (yyval.str) = mm_strdup("attach");
}
#line 57799 "preproc.c"
    break;

  case 2565: /* unreserved_keyword: ATTRIBUTE  */
#line 14580 "preproc.y"
 { 
 (yyval.str) = mm_strdup("attribute");
}
#line 57807 "preproc.c"
    break;

  case 2566: /* unreserved_keyword: BACKWARD  */
#line 14584 "preproc.y"
 { 
 (yyval.str) = mm_strdup("backward");
}
#line 57815 "preproc.c"
    break;

  case 2567: /* unreserved_keyword: BARRIER  */
#line 14588 "preproc.y"
 { 
 (yyval.str) = mm_strdup("barrier");
}
#line 57823 "preproc.c"
    break;

  case 2568: /* unreserved_keyword: BEFORE  */
#line 14592 "preproc.y"
 { 
 (yyval.str) = mm_strdup("before");
}
#line 57831 "preproc.c"
    break;

  case 2569: /* unreserved_keyword: BEGIN_P  */
#line 14596 "preproc.y"
 { 
 (yyval.str) = mm_strdup("begin");
}
#line 57839 "preproc.c"
    break;

  case 2570: /* unreserved_keyword: BEGIN_SUBTXN  */
#line 14600 "preproc.y"
 { 
 (yyval.str) = mm_strdup("begin_subtxn");
}
#line 57847 "preproc.c"
    break;

  case 2571: /* unreserved_keyword: BY  */
#line 14604 "preproc.y"
 { 
 (yyval.str) = mm_strdup("by");
}
#line 57855 "preproc.c"
    break;

  case 2572: /* unreserved_keyword: CACHE  */
#line 14608 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cache");
}
#line 57863 "preproc.c"
    break;

  case 2573: /* unreserved_keyword: CALLED  */
#line 14612 "preproc.y"
 { 
 (yyval.str) = mm_strdup("called");
}
#line 57871 "preproc.c"
    break;

  case 2574: /* unreserved_keyword: CASCADE  */
#line 14616 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascade");
}
#line 57879 "preproc.c"
    break;

  case 2575: /* unreserved_keyword: CASCADED  */
#line 14620 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascaded");
}
#line 57887 "preproc.c"
    break;

  case 2576: /* unreserved_keyword: CATALOG_P  */
#line 14624 "preproc.y"
 { 
 (yyval.str) = mm_strdup("catalog");
}
#line 57895 "preproc.c"
    break;

  case 2577: /* unreserved_keyword: CHAIN  */
#line 14628 "preproc.y"
 { 
 (yyval.str) = mm_strdup("chain");
}
#line 57903 "preproc.c"
    break;

  case 2578: /* unreserved_keyword: CHARACTERISTICS  */
#line 14632 "preproc.y"
 { 
 (yyval.str) = mm_strdup("characteristics");
}
#line 57911 "preproc.c"
    break;

  case 2579: /* unreserved_keyword: CHECKPOINT  */
#line 14636 "preproc.y"
 { 
 (yyval.str) = mm_strdup("checkpoint");
}
#line 57919 "preproc.c"
    break;

  case 2580: /* unreserved_keyword: CLASS  */
#line 14640 "preproc.y"
 { 
 (yyval.str) = mm_strdup("class");
}
#line 57927 "preproc.c"
    break;

  case 2581: /* unreserved_keyword: CLEAN  */
#line 14644 "preproc.y"
 { 
 (yyval.str) = mm_strdup("clean");
}
#line 57935 "preproc.c"
    break;

  case 2582: /* unreserved_keyword: CLOSE  */
#line 14648 "preproc.y"
 { 
 (yyval.str) = mm_strdup("close");
}
#line 57943 "preproc.c"
    break;

  case 2583: /* unreserved_keyword: CLUSTER  */
#line 14652 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cluster");
}
#line 57951 "preproc.c"
    break;

  case 2584: /* unreserved_keyword: COLUMNS  */
#line 14656 "preproc.y"
 { 
 (yyval.str) = mm_strdup("columns");
}
#line 57959 "preproc.c"
    break;

  case 2585: /* unreserved_keyword: COMMENT  */
#line 14660 "preproc.y"
 { 
 (yyval.str) = mm_strdup("comment");
}
#line 57967 "preproc.c"
    break;

  case 2586: /* unreserved_keyword: COMMENTS  */
#line 14664 "preproc.y"
 { 
 (yyval.str) = mm_strdup("comments");
}
#line 57975 "preproc.c"
    break;

  case 2587: /* unreserved_keyword: COMMIT  */
#line 14668 "preproc.y"
 { 
 (yyval.str) = mm_strdup("commit");
}
#line 57983 "preproc.c"
    break;

  case 2588: /* unreserved_keyword: COMMITTED  */
#line 14672 "preproc.y"
 { 
 (yyval.str) = mm_strdup("committed");
}
#line 57991 "preproc.c"
    break;

  case 2589: /* unreserved_keyword: COMMIT_SUBTXN  */
#line 14676 "preproc.y"
 { 
 (yyval.str) = mm_strdup("commit_subtxn");
}
#line 57999 "preproc.c"
    break;

  case 2590: /* unreserved_keyword: CONFIGURATION  */
#line 14680 "preproc.y"
 { 
 (yyval.str) = mm_strdup("configuration");
}
#line 58007 "preproc.c"
    break;

  case 2591: /* unreserved_keyword: CONFLICT  */
#line 14684 "preproc.y"
 { 
 (yyval.str) = mm_strdup("conflict");
}
#line 58015 "preproc.c"
    break;

  case 2592: /* unreserved_keyword: CONSTRAINTS  */
#line 14688 "preproc.y"
 { 
 (yyval.str) = mm_strdup("constraints");
}
#line 58023 "preproc.c"
    break;

  case 2593: /* unreserved_keyword: CONTENT_P  */
#line 14692 "preproc.y"
 { 
 (yyval.str) = mm_strdup("content");
}
#line 58031 "preproc.c"
    break;

  case 2594: /* unreserved_keyword: CONTINUE_P  */
#line 14696 "preproc.y"
 { 
 (yyval.str) = mm_strdup("continue");
}
#line 58039 "preproc.c"
    break;

  case 2595: /* unreserved_keyword: CONVERSION_P  */
#line 14700 "preproc.y"
 { 
 (yyval.str) = mm_strdup("conversion");
}
#line 58047 "preproc.c"
    break;

  case 2596: /* unreserved_keyword: COORDINATOR  */
#line 14704 "preproc.y"
 { 
 (yyval.str) = mm_strdup("coordinator");
}
#line 58055 "preproc.c"
    break;

  case 2597: /* unreserved_keyword: COPY  */
#line 14708 "preproc.y"
 { 
 (yyval.str) = mm_strdup("copy");
}
#line 58063 "preproc.c"
    break;

  case 2598: /* unreserved_keyword: COST  */
#line 14712 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cost");
}
#line 58071 "preproc.c"
    break;

  case 2599: /* unreserved_keyword: CSV  */
#line 14716 "preproc.y"
 { 
 (yyval.str) = mm_strdup("csv");
}
#line 58079 "preproc.c"
    break;

  case 2600: /* unreserved_keyword: CUBE  */
#line 14720 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cube");
}
#line 58087 "preproc.c"
    break;

  case 2601: /* unreserved_keyword: CURSOR  */
#line 14724 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cursor");
}
#line 58095 "preproc.c"
    break;

  case 2602: /* unreserved_keyword: CYCLE  */
#line 14728 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cycle");
}
#line 58103 "preproc.c"
    break;

  case 2603: /* unreserved_keyword: DATA_P  */
#line 14732 "preproc.y"
 { 
 (yyval.str) = mm_strdup("data");
}
#line 58111 "preproc.c"
    break;

  case 2604: /* unreserved_keyword: DATABASE  */
#line 14736 "preproc.y"
 { 
 (yyval.str) = mm_strdup("database");
}
#line 58119 "preproc.c"
    break;

  case 2605: /* unreserved_keyword: DEALLOCATE  */
#line 14740 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deallocate");
}
#line 58127 "preproc.c"
    break;

  case 2606: /* unreserved_keyword: DECLARE  */
#line 14744 "preproc.y"
 { 
 (yyval.str) = mm_strdup("declare");
}
#line 58135 "preproc.c"
    break;

  case 2607: /* unreserved_keyword: DEFAULTS  */
#line 14748 "preproc.y"
 { 
 (yyval.str) = mm_strdup("defaults");
}
#line 58143 "preproc.c"
    break;

  case 2608: /* unreserved_keyword: DEFERRED  */
#line 14752 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferred");
}
#line 58151 "preproc.c"
    break;

  case 2609: /* unreserved_keyword: DEFINER  */
#line 14756 "preproc.y"
 { 
 (yyval.str) = mm_strdup("definer");
}
#line 58159 "preproc.c"
    break;

  case 2610: /* unreserved_keyword: DELETE_P  */
#line 14760 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete");
}
#line 58167 "preproc.c"
    break;

  case 2611: /* unreserved_keyword: DELIMITER  */
#line 14764 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delimiter");
}
#line 58175 "preproc.c"
    break;

  case 2612: /* unreserved_keyword: DELIMITERS  */
#line 14768 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delimiters");
}
#line 58183 "preproc.c"
    break;

  case 2613: /* unreserved_keyword: DEPENDS  */
#line 14772 "preproc.y"
 { 
 (yyval.str) = mm_strdup("depends");
}
#line 58191 "preproc.c"
    break;

  case 2614: /* unreserved_keyword: DETACH  */
#line 14776 "preproc.y"
 { 
 (yyval.str) = mm_strdup("detach");
}
#line 58199 "preproc.c"
    break;

  case 2615: /* unreserved_keyword: DICTIONARY  */
#line 14780 "preproc.y"
 { 
 (yyval.str) = mm_strdup("dictionary");
}
#line 58207 "preproc.c"
    break;

  case 2616: /* unreserved_keyword: DIRECT  */
#line 14784 "preproc.y"
 { 
 (yyval.str) = mm_strdup("direct");
}
#line 58215 "preproc.c"
    break;

  case 2617: /* unreserved_keyword: DISABLE_P  */
#line 14788 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable");
}
#line 58223 "preproc.c"
    break;

  case 2618: /* unreserved_keyword: DISCARD  */
#line 14792 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard");
}
#line 58231 "preproc.c"
    break;

  case 2619: /* unreserved_keyword: DISTKEY  */
#line 14796 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distkey");
}
#line 58239 "preproc.c"
    break;

  case 2620: /* unreserved_keyword: DISTRIBUTE  */
#line 14800 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distribute");
}
#line 58247 "preproc.c"
    break;

  case 2621: /* unreserved_keyword: DISTRIBUTED  */
#line 14804 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distributed");
}
#line 58255 "preproc.c"
    break;

  case 2622: /* unreserved_keyword: DISTSTYLE  */
#line 14808 "preproc.y"
 { 
 (yyval.str) = mm_strdup("diststyle");
}
#line 58263 "preproc.c"
    break;

  case 2623: /* unreserved_keyword: DOCUMENT_P  */
#line 14812 "preproc.y"
 { 
 (yyval.str) = mm_strdup("document");
}
#line 58271 "preproc.c"
    break;

  case 2624: /* unreserved_keyword: DOMAIN_P  */
#line 14816 "preproc.y"
 { 
 (yyval.str) = mm_strdup("domain");
}
#line 58279 "preproc.c"
    break;

  case 2625: /* unreserved_keyword: DOUBLE_P  */
#line 14820 "preproc.y"
 { 
 (yyval.str) = mm_strdup("double");
}
#line 58287 "preproc.c"
    break;

  case 2626: /* unreserved_keyword: DROP  */
#line 14824 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop");
}
#line 58295 "preproc.c"
    break;

  case 2627: /* unreserved_keyword: EACH  */
#line 14828 "preproc.y"
 { 
 (yyval.str) = mm_strdup("each");
}
#line 58303 "preproc.c"
    break;

  case 2628: /* unreserved_keyword: ENABLE_P  */
#line 14832 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable");
}
#line 58311 "preproc.c"
    break;

  case 2629: /* unreserved_keyword: ENCODING  */
#line 14836 "preproc.y"
 { 
 (yyval.str) = mm_strdup("encoding");
}
#line 58319 "preproc.c"
    break;

  case 2630: /* unreserved_keyword: ENCRYPTED  */
#line 14840 "preproc.y"
 { 
 (yyval.str) = mm_strdup("encrypted");
}
#line 58327 "preproc.c"
    break;

  case 2631: /* unreserved_keyword: ENUM_P  */
#line 14844 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enum");
}
#line 58335 "preproc.c"
    break;

  case 2632: /* unreserved_keyword: ESCAPE  */
#line 14848 "preproc.y"
 { 
 (yyval.str) = mm_strdup("escape");
}
#line 58343 "preproc.c"
    break;

  case 2633: /* unreserved_keyword: EVENT  */
#line 14852 "preproc.y"
 { 
 (yyval.str) = mm_strdup("event");
}
#line 58351 "preproc.c"
    break;

  case 2634: /* unreserved_keyword: EXCHANGE  */
#line 14856 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exchange");
}
#line 58359 "preproc.c"
    break;

  case 2635: /* unreserved_keyword: EXCLUDE  */
#line 14860 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclude");
}
#line 58367 "preproc.c"
    break;

  case 2636: /* unreserved_keyword: EXCLUDING  */
#line 14864 "preproc.y"
 { 
 (yyval.str) = mm_strdup("excluding");
}
#line 58375 "preproc.c"
    break;

  case 2637: /* unreserved_keyword: EXCLUSIVE  */
#line 14868 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 58383 "preproc.c"
    break;

  case 2638: /* unreserved_keyword: EXECUTE  */
#line 14872 "preproc.y"
 { 
 (yyval.str) = mm_strdup("execute");
}
#line 58391 "preproc.c"
    break;

  case 2639: /* unreserved_keyword: EXPLAIN  */
#line 14876 "preproc.y"
 { 
 (yyval.str) = mm_strdup("explain");
}
#line 58399 "preproc.c"
    break;

  case 2640: /* unreserved_keyword: EXTENSION  */
#line 14880 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extension");
}
#line 58407 "preproc.c"
    break;

  case 2641: /* unreserved_keyword: EXTENT  */
#line 14884 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extent");
}
#line 58415 "preproc.c"
    break;

  case 2642: /* unreserved_keyword: EXTERNAL  */
#line 14888 "preproc.y"
 { 
 (yyval.str) = mm_strdup("external");
}
#line 58423 "preproc.c"
    break;

  case 2643: /* unreserved_keyword: FAMILY  */
#line 14892 "preproc.y"
 { 
 (yyval.str) = mm_strdup("family");
}
#line 58431 "preproc.c"
    break;

  case 2644: /* unreserved_keyword: FILTER  */
#line 14896 "preproc.y"
 { 
 (yyval.str) = mm_strdup("filter");
}
#line 58439 "preproc.c"
    break;

  case 2645: /* unreserved_keyword: FIRST_P  */
#line 14900 "preproc.y"
 { 
 (yyval.str) = mm_strdup("first");
}
#line 58447 "preproc.c"
    break;

  case 2646: /* unreserved_keyword: FOLLOWING  */
#line 14904 "preproc.y"
 { 
 (yyval.str) = mm_strdup("following");
}
#line 58455 "preproc.c"
    break;

  case 2647: /* unreserved_keyword: FORCE  */
#line 14908 "preproc.y"
 { 
 (yyval.str) = mm_strdup("force");
}
#line 58463 "preproc.c"
    break;

  case 2648: /* unreserved_keyword: FORWARD  */
#line 14912 "preproc.y"
 { 
 (yyval.str) = mm_strdup("forward");
}
#line 58471 "preproc.c"
    break;

  case 2649: /* unreserved_keyword: FUNCTION  */
#line 14916 "preproc.y"
 { 
 (yyval.str) = mm_strdup("function");
}
#line 58479 "preproc.c"
    break;

  case 2650: /* unreserved_keyword: FUNCTIONS  */
#line 14920 "preproc.y"
 { 
 (yyval.str) = mm_strdup("functions");
}
#line 58487 "preproc.c"
    break;

  case 2651: /* unreserved_keyword: GENERATED  */
#line 14924 "preproc.y"
 { 
 (yyval.str) = mm_strdup("generated");
}
#line 58495 "preproc.c"
    break;

  case 2652: /* unreserved_keyword: GLOBAL  */
#line 14928 "preproc.y"
 { 
 (yyval.str) = mm_strdup("global");
}
#line 58503 "preproc.c"
    break;

  case 2653: /* unreserved_keyword: GRANTED  */
#line 14932 "preproc.y"
 { 
 (yyval.str) = mm_strdup("granted");
}
#line 58511 "preproc.c"
    break;

  case 2654: /* unreserved_keyword: GTM  */
#line 14936 "preproc.y"
 { 
 (yyval.str) = mm_strdup("gtm");
}
#line 58519 "preproc.c"
    break;

  case 2655: /* unreserved_keyword: HANDLER  */
#line 14940 "preproc.y"
 { 
 (yyval.str) = mm_strdup("handler");
}
#line 58527 "preproc.c"
    break;

  case 2656: /* unreserved_keyword: HEADER_P  */
#line 14944 "preproc.y"
 { 
 (yyval.str) = mm_strdup("header");
}
#line 58535 "preproc.c"
    break;

  case 2657: /* unreserved_keyword: HOLD  */
#line 14948 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hold");
}
#line 58543 "preproc.c"
    break;

  case 2658: /* unreserved_keyword: IDENTITY_P  */
#line 14952 "preproc.y"
 { 
 (yyval.str) = mm_strdup("identity");
}
#line 58551 "preproc.c"
    break;

  case 2659: /* unreserved_keyword: IF_P  */
#line 14956 "preproc.y"
 { 
 (yyval.str) = mm_strdup("if");
}
#line 58559 "preproc.c"
    break;

  case 2660: /* unreserved_keyword: IMMEDIATE  */
#line 14960 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immediate");
}
#line 58567 "preproc.c"
    break;

  case 2661: /* unreserved_keyword: IMMUTABLE  */
#line 14964 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immutable");
}
#line 58575 "preproc.c"
    break;

  case 2662: /* unreserved_keyword: IMPLICIT_P  */
#line 14968 "preproc.y"
 { 
 (yyval.str) = mm_strdup("implicit");
}
#line 58583 "preproc.c"
    break;

  case 2663: /* unreserved_keyword: IMPORT_P  */
#line 14972 "preproc.y"
 { 
 (yyval.str) = mm_strdup("import");
}
#line 58591 "preproc.c"
    break;

  case 2664: /* unreserved_keyword: INCLUDING  */
#line 14976 "preproc.y"
 { 
 (yyval.str) = mm_strdup("including");
}
#line 58599 "preproc.c"
    break;

  case 2665: /* unreserved_keyword: INCREMENT  */
#line 14980 "preproc.y"
 { 
 (yyval.str) = mm_strdup("increment");
}
#line 58607 "preproc.c"
    break;

  case 2666: /* unreserved_keyword: INDEX  */
#line 14984 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 58615 "preproc.c"
    break;

  case 2667: /* unreserved_keyword: INDEXES  */
#line 14988 "preproc.y"
 { 
 (yyval.str) = mm_strdup("indexes");
}
#line 58623 "preproc.c"
    break;

  case 2668: /* unreserved_keyword: INHERIT  */
#line 14992 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inherit");
}
#line 58631 "preproc.c"
    break;

  case 2669: /* unreserved_keyword: INHERITS  */
#line 14996 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inherits");
}
#line 58639 "preproc.c"
    break;

  case 2670: /* unreserved_keyword: INLINE_P  */
#line 15000 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inline");
}
#line 58647 "preproc.c"
    break;

  case 2671: /* unreserved_keyword: INSENSITIVE  */
#line 15004 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insensitive");
}
#line 58655 "preproc.c"
    break;

  case 2672: /* unreserved_keyword: INSERT  */
#line 15008 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert");
}
#line 58663 "preproc.c"
    break;

  case 2673: /* unreserved_keyword: INSTEAD  */
#line 15012 "preproc.y"
 { 
 (yyval.str) = mm_strdup("instead");
}
#line 58671 "preproc.c"
    break;

  case 2674: /* unreserved_keyword: INVOKER  */
#line 15016 "preproc.y"
 { 
 (yyval.str) = mm_strdup("invoker");
}
#line 58679 "preproc.c"
    break;

  case 2675: /* unreserved_keyword: ISOLATION  */
#line 15020 "preproc.y"
 { 
 (yyval.str) = mm_strdup("isolation");
}
#line 58687 "preproc.c"
    break;

  case 2676: /* unreserved_keyword: KEY  */
#line 15024 "preproc.y"
 { 
 (yyval.str) = mm_strdup("key");
}
#line 58695 "preproc.c"
    break;

  case 2677: /* unreserved_keyword: LABEL  */
#line 15028 "preproc.y"
 { 
 (yyval.str) = mm_strdup("label");
}
#line 58703 "preproc.c"
    break;

  case 2678: /* unreserved_keyword: LANGUAGE  */
#line 15032 "preproc.y"
 { 
 (yyval.str) = mm_strdup("language");
}
#line 58711 "preproc.c"
    break;

  case 2679: /* unreserved_keyword: LARGE_P  */
#line 15036 "preproc.y"
 { 
 (yyval.str) = mm_strdup("large");
}
#line 58719 "preproc.c"
    break;

  case 2680: /* unreserved_keyword: LAST_P  */
#line 15040 "preproc.y"
 { 
 (yyval.str) = mm_strdup("last");
}
#line 58727 "preproc.c"
    break;

  case 2681: /* unreserved_keyword: LEAKPROOF  */
#line 15044 "preproc.y"
 { 
 (yyval.str) = mm_strdup("leakproof");
}
#line 58735 "preproc.c"
    break;

  case 2682: /* unreserved_keyword: LEVEL  */
#line 15048 "preproc.y"
 { 
 (yyval.str) = mm_strdup("level");
}
#line 58743 "preproc.c"
    break;

  case 2683: /* unreserved_keyword: LISTEN  */
#line 15052 "preproc.y"
 { 
 (yyval.str) = mm_strdup("listen");
}
#line 58751 "preproc.c"
    break;

  case 2684: /* unreserved_keyword: LOAD  */
#line 15056 "preproc.y"
 { 
 (yyval.str) = mm_strdup("load");
}
#line 58759 "preproc.c"
    break;

  case 2685: /* unreserved_keyword: LOCAL  */
#line 15060 "preproc.y"
 { 
 (yyval.str) = mm_strdup("local");
}
#line 58767 "preproc.c"
    break;

  case 2686: /* unreserved_keyword: LOCATION  */
#line 15064 "preproc.y"
 { 
 (yyval.str) = mm_strdup("location");
}
#line 58775 "preproc.c"
    break;

  case 2687: /* unreserved_keyword: LOCK_P  */
#line 15068 "preproc.y"
 { 
 (yyval.str) = mm_strdup("lock");
}
#line 58783 "preproc.c"
    break;

  case 2688: /* unreserved_keyword: LOCKED  */
#line 15072 "preproc.y"
 { 
 (yyval.str) = mm_strdup("locked");
}
#line 58791 "preproc.c"
    break;

  case 2689: /* unreserved_keyword: LOGGED  */
#line 15076 "preproc.y"
 { 
 (yyval.str) = mm_strdup("logged");
}
#line 58799 "preproc.c"
    break;

  case 2690: /* unreserved_keyword: MAPPING  */
#line 15080 "preproc.y"
 { 
 (yyval.str) = mm_strdup("mapping");
}
#line 58807 "preproc.c"
    break;

  case 2691: /* unreserved_keyword: MATCH  */
#line 15084 "preproc.y"
 { 
 (yyval.str) = mm_strdup("match");
}
#line 58815 "preproc.c"
    break;

  case 2692: /* unreserved_keyword: MATERIALIZED  */
#line 15088 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized");
}
#line 58823 "preproc.c"
    break;

  case 2693: /* unreserved_keyword: MAXVALUE  */
#line 15092 "preproc.y"
 { 
 (yyval.str) = mm_strdup("maxvalue");
}
#line 58831 "preproc.c"
    break;

  case 2694: /* unreserved_keyword: METHOD  */
#line 15096 "preproc.y"
 { 
 (yyval.str) = mm_strdup("method");
}
#line 58839 "preproc.c"
    break;

  case 2695: /* unreserved_keyword: MINVALUE  */
#line 15100 "preproc.y"
 { 
 (yyval.str) = mm_strdup("minvalue");
}
#line 58847 "preproc.c"
    break;

  case 2696: /* unreserved_keyword: MODE  */
#line 15104 "preproc.y"
 { 
 (yyval.str) = mm_strdup("mode");
}
#line 58855 "preproc.c"
    break;

  case 2697: /* unreserved_keyword: MOVE  */
#line 15108 "preproc.y"
 { 
 (yyval.str) = mm_strdup("move");
}
#line 58863 "preproc.c"
    break;

  case 2698: /* unreserved_keyword: NAME_P  */
#line 15112 "preproc.y"
 { 
 (yyval.str) = mm_strdup("name");
}
#line 58871 "preproc.c"
    break;

  case 2699: /* unreserved_keyword: NAMES  */
#line 15116 "preproc.y"
 { 
 (yyval.str) = mm_strdup("names");
}
#line 58879 "preproc.c"
    break;

  case 2700: /* unreserved_keyword: NEW  */
#line 15120 "preproc.y"
 { 
 (yyval.str) = mm_strdup("new");
}
#line 58887 "preproc.c"
    break;

  case 2701: /* unreserved_keyword: NEXT  */
#line 15124 "preproc.y"
 { 
 (yyval.str) = mm_strdup("next");
}
#line 58895 "preproc.c"
    break;

  case 2702: /* unreserved_keyword: NO  */
#line 15128 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no");
}
#line 58903 "preproc.c"
    break;

  case 2703: /* unreserved_keyword: NODE  */
#line 15132 "preproc.y"
 { 
 (yyval.str) = mm_strdup("node");
}
#line 58911 "preproc.c"
    break;

  case 2704: /* unreserved_keyword: NOTHING  */
#line 15136 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nothing");
}
#line 58919 "preproc.c"
    break;

  case 2705: /* unreserved_keyword: NOTIFY  */
#line 15140 "preproc.y"
 { 
 (yyval.str) = mm_strdup("notify");
}
#line 58927 "preproc.c"
    break;

  case 2706: /* unreserved_keyword: NOWAIT  */
#line 15144 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nowait");
}
#line 58935 "preproc.c"
    break;

  case 2707: /* unreserved_keyword: NULLS_P  */
#line 15148 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nulls");
}
#line 58943 "preproc.c"
    break;

  case 2708: /* unreserved_keyword: OBJECT_P  */
#line 15152 "preproc.y"
 { 
 (yyval.str) = mm_strdup("object");
}
#line 58951 "preproc.c"
    break;

  case 2709: /* unreserved_keyword: OF  */
#line 15156 "preproc.y"
 { 
 (yyval.str) = mm_strdup("of");
}
#line 58959 "preproc.c"
    break;

  case 2710: /* unreserved_keyword: OFF  */
#line 15160 "preproc.y"
 { 
 (yyval.str) = mm_strdup("off");
}
#line 58967 "preproc.c"
    break;

  case 2711: /* unreserved_keyword: OID_P  */
#line 15164 "preproc.y"
 { 
 (yyval.str) = mm_strdup("oid");
}
#line 58975 "preproc.c"
    break;

  case 2712: /* unreserved_keyword: OIDS  */
#line 15168 "preproc.y"
 { 
 (yyval.str) = mm_strdup("oids");
}
#line 58983 "preproc.c"
    break;

  case 2713: /* unreserved_keyword: OLD  */
#line 15172 "preproc.y"
 { 
 (yyval.str) = mm_strdup("old");
}
#line 58991 "preproc.c"
    break;

  case 2714: /* unreserved_keyword: OPENTENBASE_P  */
#line 15176 "preproc.y"
 { 
 (yyval.str) = mm_strdup("opentenbase");
}
#line 58999 "preproc.c"
    break;

  case 2715: /* unreserved_keyword: OPERATOR  */
#line 15180 "preproc.y"
 { 
 (yyval.str) = mm_strdup("operator");
}
#line 59007 "preproc.c"
    break;

  case 2716: /* unreserved_keyword: OPTION  */
#line 15184 "preproc.y"
 { 
 (yyval.str) = mm_strdup("option");
}
#line 59015 "preproc.c"
    break;

  case 2717: /* unreserved_keyword: OPTIONS  */
#line 15188 "preproc.y"
 { 
 (yyval.str) = mm_strdup("options");
}
#line 59023 "preproc.c"
    break;

  case 2718: /* unreserved_keyword: ORDINALITY  */
#line 15192 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ordinality");
}
#line 59031 "preproc.c"
    break;

  case 2719: /* unreserved_keyword: OVER  */
#line 15196 "preproc.y"
 { 
 (yyval.str) = mm_strdup("over");
}
#line 59039 "preproc.c"
    break;

  case 2720: /* unreserved_keyword: OVERRIDING  */
#line 15200 "preproc.y"
 { 
 (yyval.str) = mm_strdup("overriding");
}
#line 59047 "preproc.c"
    break;

  case 2721: /* unreserved_keyword: OWNED  */
#line 15204 "preproc.y"
 { 
 (yyval.str) = mm_strdup("owned");
}
#line 59055 "preproc.c"
    break;

  case 2722: /* unreserved_keyword: OWNER  */
#line 15208 "preproc.y"
 { 
 (yyval.str) = mm_strdup("owner");
}
#line 59063 "preproc.c"
    break;

  case 2723: /* unreserved_keyword: PARALLEL  */
#line 15212 "preproc.y"
 { 
 (yyval.str) = mm_strdup("parallel");
}
#line 59071 "preproc.c"
    break;

  case 2724: /* unreserved_keyword: PARSER  */
#line 15216 "preproc.y"
 { 
 (yyval.str) = mm_strdup("parser");
}
#line 59079 "preproc.c"
    break;

  case 2725: /* unreserved_keyword: PARTIAL  */
#line 15220 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partial");
}
#line 59087 "preproc.c"
    break;

  case 2726: /* unreserved_keyword: PARTITIONS  */
#line 15224 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partitions");
}
#line 59095 "preproc.c"
    break;

  case 2727: /* unreserved_keyword: PASSING  */
#line 15228 "preproc.y"
 { 
 (yyval.str) = mm_strdup("passing");
}
#line 59103 "preproc.c"
    break;

  case 2728: /* unreserved_keyword: PASSWORD  */
#line 15232 "preproc.y"
 { 
 (yyval.str) = mm_strdup("password");
}
#line 59111 "preproc.c"
    break;

  case 2729: /* unreserved_keyword: PAUSE  */
#line 15236 "preproc.y"
 { 
 (yyval.str) = mm_strdup("pause");
}
#line 59119 "preproc.c"
    break;

  case 2730: /* unreserved_keyword: PLANS  */
#line 15240 "preproc.y"
 { 
 (yyval.str) = mm_strdup("plans");
}
#line 59127 "preproc.c"
    break;

  case 2731: /* unreserved_keyword: POLICY  */
#line 15244 "preproc.y"
 { 
 (yyval.str) = mm_strdup("policy");
}
#line 59135 "preproc.c"
    break;

  case 2732: /* unreserved_keyword: PRECEDING  */
#line 15248 "preproc.y"
 { 
 (yyval.str) = mm_strdup("preceding");
}
#line 59143 "preproc.c"
    break;

  case 2733: /* unreserved_keyword: PREFERRED  */
#line 15252 "preproc.y"
 { 
 (yyval.str) = mm_strdup("preferred");
}
#line 59151 "preproc.c"
    break;

  case 2734: /* unreserved_keyword: PREPARE  */
#line 15256 "preproc.y"
 { 
 (yyval.str) = mm_strdup("prepare");
}
#line 59159 "preproc.c"
    break;

  case 2735: /* unreserved_keyword: PREPARED  */
#line 15260 "preproc.y"
 { 
 (yyval.str) = mm_strdup("prepared");
}
#line 59167 "preproc.c"
    break;

  case 2736: /* unreserved_keyword: PRESERVE  */
#line 15264 "preproc.y"
 { 
 (yyval.str) = mm_strdup("preserve");
}
#line 59175 "preproc.c"
    break;

  case 2737: /* unreserved_keyword: PRIOR  */
#line 15268 "preproc.y"
 { 
 (yyval.str) = mm_strdup("prior");
}
#line 59183 "preproc.c"
    break;

  case 2738: /* unreserved_keyword: PRIVILEGES  */
#line 15272 "preproc.y"
 { 
 (yyval.str) = mm_strdup("privileges");
}
#line 59191 "preproc.c"
    break;

  case 2739: /* unreserved_keyword: PROCEDURAL  */
#line 15276 "preproc.y"
 { 
 (yyval.str) = mm_strdup("procedural");
}
#line 59199 "preproc.c"
    break;

  case 2740: /* unreserved_keyword: PROCEDURE  */
#line 15280 "preproc.y"
 { 
 (yyval.str) = mm_strdup("procedure");
}
#line 59207 "preproc.c"
    break;

  case 2741: /* unreserved_keyword: PROGRAM  */
#line 15284 "preproc.y"
 { 
 (yyval.str) = mm_strdup("program");
}
#line 59215 "preproc.c"
    break;

  case 2742: /* unreserved_keyword: PUBLICATION  */
#line 15288 "preproc.y"
 { 
 (yyval.str) = mm_strdup("publication");
}
#line 59223 "preproc.c"
    break;

  case 2743: /* unreserved_keyword: PUSHDOWN  */
#line 15292 "preproc.y"
 { 
 (yyval.str) = mm_strdup("pushdown");
}
#line 59231 "preproc.c"
    break;

  case 2744: /* unreserved_keyword: QUOTE  */
#line 15296 "preproc.y"
 { 
 (yyval.str) = mm_strdup("quote");
}
#line 59239 "preproc.c"
    break;

  case 2745: /* unreserved_keyword: RANDOMLY  */
#line 15300 "preproc.y"
 { 
 (yyval.str) = mm_strdup("randomly");
}
#line 59247 "preproc.c"
    break;

  case 2746: /* unreserved_keyword: RANGE  */
#line 15304 "preproc.y"
 { 
 (yyval.str) = mm_strdup("range");
}
#line 59255 "preproc.c"
    break;

  case 2747: /* unreserved_keyword: READ  */
#line 15308 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read");
}
#line 59263 "preproc.c"
    break;

  case 2748: /* unreserved_keyword: REASSIGN  */
#line 15312 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reassign");
}
#line 59271 "preproc.c"
    break;

  case 2749: /* unreserved_keyword: REBUILD  */
#line 15316 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rebuild");
}
#line 59279 "preproc.c"
    break;

  case 2750: /* unreserved_keyword: RECHECK  */
#line 15320 "preproc.y"
 { 
 (yyval.str) = mm_strdup("recheck");
}
#line 59287 "preproc.c"
    break;

  case 2751: /* unreserved_keyword: RECURSIVE  */
#line 15324 "preproc.y"
 { 
 (yyval.str) = mm_strdup("recursive");
}
#line 59295 "preproc.c"
    break;

  case 2752: /* unreserved_keyword: REF  */
#line 15328 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ref");
}
#line 59303 "preproc.c"
    break;

  case 2753: /* unreserved_keyword: REFERENCING  */
#line 15332 "preproc.y"
 { 
 (yyval.str) = mm_strdup("referencing");
}
#line 59311 "preproc.c"
    break;

  case 2754: /* unreserved_keyword: REFRESH  */
#line 15336 "preproc.y"
 { 
 (yyval.str) = mm_strdup("refresh");
}
#line 59319 "preproc.c"
    break;

  case 2755: /* unreserved_keyword: REINDEX  */
#line 15340 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reindex");
}
#line 59327 "preproc.c"
    break;

  case 2756: /* unreserved_keyword: RELATIVE_P  */
#line 15344 "preproc.y"
 { 
 (yyval.str) = mm_strdup("relative");
}
#line 59335 "preproc.c"
    break;

  case 2757: /* unreserved_keyword: RELEASE  */
#line 15348 "preproc.y"
 { 
 (yyval.str) = mm_strdup("release");
}
#line 59343 "preproc.c"
    break;

  case 2758: /* unreserved_keyword: RENAME  */
#line 15352 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rename");
}
#line 59351 "preproc.c"
    break;

  case 2759: /* unreserved_keyword: REPEATABLE  */
#line 15356 "preproc.y"
 { 
 (yyval.str) = mm_strdup("repeatable");
}
#line 59359 "preproc.c"
    break;

  case 2760: /* unreserved_keyword: REPLACE  */
#line 15360 "preproc.y"
 { 
 (yyval.str) = mm_strdup("replace");
}
#line 59367 "preproc.c"
    break;

  case 2761: /* unreserved_keyword: REPLICA  */
#line 15364 "preproc.y"
 { 
 (yyval.str) = mm_strdup("replica");
}
#line 59375 "preproc.c"
    break;

  case 2762: /* unreserved_keyword: RESET  */
#line 15368 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reset");
}
#line 59383 "preproc.c"
    break;

  case 2763: /* unreserved_keyword: RESTART  */
#line 15372 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restart");
}
#line 59391 "preproc.c"
    break;

  case 2764: /* unreserved_keyword: RESTRICT  */
#line 15376 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restrict");
}
#line 59399 "preproc.c"
    break;

  case 2765: /* unreserved_keyword: RETURNS  */
#line 15380 "preproc.y"
 { 
 (yyval.str) = mm_strdup("returns");
}
#line 59407 "preproc.c"
    break;

  case 2766: /* unreserved_keyword: REVOKE  */
#line 15384 "preproc.y"
 { 
 (yyval.str) = mm_strdup("revoke");
}
#line 59415 "preproc.c"
    break;

  case 2767: /* unreserved_keyword: ROLE  */
#line 15388 "preproc.y"
 { 
 (yyval.str) = mm_strdup("role");
}
#line 59423 "preproc.c"
    break;

  case 2768: /* unreserved_keyword: ROLLBACK  */
#line 15392 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rollback");
}
#line 59431 "preproc.c"
    break;

  case 2769: /* unreserved_keyword: ROLLBACK_SUBTXN  */
#line 15396 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rollback_subtxn");
}
#line 59439 "preproc.c"
    break;

  case 2770: /* unreserved_keyword: ROLLUP  */
#line 15400 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rollup");
}
#line 59447 "preproc.c"
    break;

  case 2771: /* unreserved_keyword: ROWS  */
#line 15404 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rows");
}
#line 59455 "preproc.c"
    break;

  case 2772: /* unreserved_keyword: RULE  */
#line 15408 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rule");
}
#line 59463 "preproc.c"
    break;

  case 2773: /* unreserved_keyword: SAMPLE  */
#line 15412 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sample");
}
#line 59471 "preproc.c"
    break;

  case 2774: /* unreserved_keyword: SAVEPOINT  */
#line 15416 "preproc.y"
 { 
 (yyval.str) = mm_strdup("savepoint");
}
#line 59479 "preproc.c"
    break;

  case 2775: /* unreserved_keyword: SCHEMA  */
#line 15420 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 59487 "preproc.c"
    break;

  case 2776: /* unreserved_keyword: SCHEMAS  */
#line 15424 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schemas");
}
#line 59495 "preproc.c"
    break;

  case 2777: /* unreserved_keyword: SCROLL  */
#line 15428 "preproc.y"
 { 
 (yyval.str) = mm_strdup("scroll");
}
#line 59503 "preproc.c"
    break;

  case 2778: /* unreserved_keyword: SEARCH  */
#line 15432 "preproc.y"
 { 
 (yyval.str) = mm_strdup("search");
}
#line 59511 "preproc.c"
    break;

  case 2779: /* unreserved_keyword: SECURITY  */
#line 15436 "preproc.y"
 { 
 (yyval.str) = mm_strdup("security");
}
#line 59519 "preproc.c"
    break;

  case 2780: /* unreserved_keyword: SEQUENCE  */
#line 15440 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 59527 "preproc.c"
    break;

  case 2781: /* unreserved_keyword: SEQUENCES  */
#line 15444 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequences");
}
#line 59535 "preproc.c"
    break;

  case 2782: /* unreserved_keyword: SERIALIZABLE  */
#line 15448 "preproc.y"
 { 
 (yyval.str) = mm_strdup("serializable");
}
#line 59543 "preproc.c"
    break;

  case 2783: /* unreserved_keyword: SERVER  */
#line 15452 "preproc.y"
 { 
 (yyval.str) = mm_strdup("server");
}
#line 59551 "preproc.c"
    break;

  case 2784: /* unreserved_keyword: SESSION  */
#line 15456 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session");
}
#line 59559 "preproc.c"
    break;

  case 2785: /* unreserved_keyword: SET  */
#line 15460 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set");
}
#line 59567 "preproc.c"
    break;

  case 2786: /* unreserved_keyword: SETS  */
#line 15464 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sets");
}
#line 59575 "preproc.c"
    break;

  case 2787: /* unreserved_keyword: SHARDING  */
#line 15468 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sharding");
}
#line 59583 "preproc.c"
    break;

  case 2788: /* unreserved_keyword: SHARE  */
#line 15472 "preproc.y"
 { 
 (yyval.str) = mm_strdup("share");
}
#line 59591 "preproc.c"
    break;

  case 2789: /* unreserved_keyword: SHOW  */
#line 15476 "preproc.y"
 { 
 (yyval.str) = mm_strdup("show");
}
#line 59599 "preproc.c"
    break;

  case 2790: /* unreserved_keyword: SIMPLE  */
#line 15480 "preproc.y"
 { 
 (yyval.str) = mm_strdup("simple");
}
#line 59607 "preproc.c"
    break;

  case 2791: /* unreserved_keyword: SKIP  */
#line 15484 "preproc.y"
 { 
 (yyval.str) = mm_strdup("skip");
}
#line 59615 "preproc.c"
    break;

  case 2792: /* unreserved_keyword: SLOT  */
#line 15488 "preproc.y"
 { 
 (yyval.str) = mm_strdup("slot");
}
#line 59623 "preproc.c"
    break;

  case 2793: /* unreserved_keyword: SNAPSHOT  */
#line 15492 "preproc.y"
 { 
 (yyval.str) = mm_strdup("snapshot");
}
#line 59631 "preproc.c"
    break;

  case 2794: /* unreserved_keyword: SQL_P  */
#line 15496 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sql");
}
#line 59639 "preproc.c"
    break;

  case 2795: /* unreserved_keyword: STABLE  */
#line 15500 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stable");
}
#line 59647 "preproc.c"
    break;

  case 2796: /* unreserved_keyword: STANDALONE_P  */
#line 15504 "preproc.y"
 { 
 (yyval.str) = mm_strdup("standalone");
}
#line 59655 "preproc.c"
    break;

  case 2797: /* unreserved_keyword: START  */
#line 15508 "preproc.y"
 { 
 (yyval.str) = mm_strdup("start");
}
#line 59663 "preproc.c"
    break;

  case 2798: /* unreserved_keyword: STATEMENT  */
#line 15512 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statement");
}
#line 59671 "preproc.c"
    break;

  case 2799: /* unreserved_keyword: STATISTICS  */
#line 15516 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statistics");
}
#line 59679 "preproc.c"
    break;

  case 2800: /* unreserved_keyword: STDIN  */
#line 15520 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdin");
}
#line 59687 "preproc.c"
    break;

  case 2801: /* unreserved_keyword: STDOUT  */
#line 15524 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdout");
}
#line 59695 "preproc.c"
    break;

  case 2802: /* unreserved_keyword: STEP  */
#line 15528 "preproc.y"
 { 
 (yyval.str) = mm_strdup("step");
}
#line 59703 "preproc.c"
    break;

  case 2803: /* unreserved_keyword: STORAGE  */
#line 15532 "preproc.y"
 { 
 (yyval.str) = mm_strdup("storage");
}
#line 59711 "preproc.c"
    break;

  case 2804: /* unreserved_keyword: STRICT_P  */
#line 15536 "preproc.y"
 { 
 (yyval.str) = mm_strdup("strict");
}
#line 59719 "preproc.c"
    break;

  case 2805: /* unreserved_keyword: STRIP_P  */
#line 15540 "preproc.y"
 { 
 (yyval.str) = mm_strdup("strip");
}
#line 59727 "preproc.c"
    break;

  case 2806: /* unreserved_keyword: SUBSCRIPTION  */
#line 15544 "preproc.y"
 { 
 (yyval.str) = mm_strdup("subscription");
}
#line 59735 "preproc.c"
    break;

  case 2807: /* unreserved_keyword: SYNC  */
#line 15548 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sync");
}
#line 59743 "preproc.c"
    break;

  case 2808: /* unreserved_keyword: SYSID  */
#line 15552 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sysid");
}
#line 59751 "preproc.c"
    break;

  case 2809: /* unreserved_keyword: SYSTEM_P  */
#line 15556 "preproc.y"
 { 
 (yyval.str) = mm_strdup("system");
}
#line 59759 "preproc.c"
    break;

  case 2810: /* unreserved_keyword: TABLES  */
#line 15560 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tables");
}
#line 59767 "preproc.c"
    break;

  case 2811: /* unreserved_keyword: TABLESPACE  */
#line 15564 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 59775 "preproc.c"
    break;

  case 2812: /* unreserved_keyword: TEMP  */
#line 15568 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temp");
}
#line 59783 "preproc.c"
    break;

  case 2813: /* unreserved_keyword: TEMPLATE  */
#line 15572 "preproc.y"
 { 
 (yyval.str) = mm_strdup("template");
}
#line 59791 "preproc.c"
    break;

  case 2814: /* unreserved_keyword: TEMPORARY  */
#line 15576 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temporary");
}
#line 59799 "preproc.c"
    break;

  case 2815: /* unreserved_keyword: TEXT_P  */
#line 15580 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text");
}
#line 59807 "preproc.c"
    break;

  case 2816: /* unreserved_keyword: TRANSACTION  */
#line 15584 "preproc.y"
 { 
 (yyval.str) = mm_strdup("transaction");
}
#line 59815 "preproc.c"
    break;

  case 2817: /* unreserved_keyword: TRANSFORM  */
#line 15588 "preproc.y"
 { 
 (yyval.str) = mm_strdup("transform");
}
#line 59823 "preproc.c"
    break;

  case 2818: /* unreserved_keyword: TRIGGER  */
#line 15592 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trigger");
}
#line 59831 "preproc.c"
    break;

  case 2819: /* unreserved_keyword: TRUNCATE  */
#line 15596 "preproc.y"
 { 
 (yyval.str) = mm_strdup("truncate");
}
#line 59839 "preproc.c"
    break;

  case 2820: /* unreserved_keyword: TRUSTED  */
#line 15600 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trusted");
}
#line 59847 "preproc.c"
    break;

  case 2821: /* unreserved_keyword: TYPE_P  */
#line 15604 "preproc.y"
 { 
 (yyval.str) = mm_strdup("type");
}
#line 59855 "preproc.c"
    break;

  case 2822: /* unreserved_keyword: TYPES_P  */
#line 15608 "preproc.y"
 { 
 (yyval.str) = mm_strdup("types");
}
#line 59863 "preproc.c"
    break;

  case 2823: /* unreserved_keyword: UNBOUNDED  */
#line 15612 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unbounded");
}
#line 59871 "preproc.c"
    break;

  case 2824: /* unreserved_keyword: UNCOMMITTED  */
#line 15616 "preproc.y"
 { 
 (yyval.str) = mm_strdup("uncommitted");
}
#line 59879 "preproc.c"
    break;

  case 2825: /* unreserved_keyword: UNENCRYPTED  */
#line 15620 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unencrypted");
}
#line 59887 "preproc.c"
    break;

  case 2826: /* unreserved_keyword: UNKNOWN  */
#line 15624 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unknown");
}
#line 59895 "preproc.c"
    break;

  case 2827: /* unreserved_keyword: UNLISTEN  */
#line 15628 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlisten");
}
#line 59903 "preproc.c"
    break;

  case 2828: /* unreserved_keyword: UNLOCK_P  */
#line 15632 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlock");
}
#line 59911 "preproc.c"
    break;

  case 2829: /* unreserved_keyword: UNLOGGED  */
#line 15636 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 59919 "preproc.c"
    break;

  case 2830: /* unreserved_keyword: UNPAUSE  */
#line 15640 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unpause");
}
#line 59927 "preproc.c"
    break;

  case 2831: /* unreserved_keyword: UNTIL  */
#line 15644 "preproc.y"
 { 
 (yyval.str) = mm_strdup("until");
}
#line 59935 "preproc.c"
    break;

  case 2832: /* unreserved_keyword: UPDATE  */
#line 15648 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update");
}
#line 59943 "preproc.c"
    break;

  case 2833: /* unreserved_keyword: VACUUM  */
#line 15652 "preproc.y"
 { 
 (yyval.str) = mm_strdup("vacuum");
}
#line 59951 "preproc.c"
    break;

  case 2834: /* unreserved_keyword: VALID  */
#line 15656 "preproc.y"
 { 
 (yyval.str) = mm_strdup("valid");
}
#line 59959 "preproc.c"
    break;

  case 2835: /* unreserved_keyword: VALIDATE  */
#line 15660 "preproc.y"
 { 
 (yyval.str) = mm_strdup("validate");
}
#line 59967 "preproc.c"
    break;

  case 2836: /* unreserved_keyword: VALIDATOR  */
#line 15664 "preproc.y"
 { 
 (yyval.str) = mm_strdup("validator");
}
#line 59975 "preproc.c"
    break;

  case 2837: /* unreserved_keyword: VALUE_P  */
#line 15668 "preproc.y"
 { 
 (yyval.str) = mm_strdup("value");
}
#line 59983 "preproc.c"
    break;

  case 2838: /* unreserved_keyword: VARYING  */
#line 15672 "preproc.y"
 { 
 (yyval.str) = mm_strdup("varying");
}
#line 59991 "preproc.c"
    break;

  case 2839: /* unreserved_keyword: VERSION_P  */
#line 15676 "preproc.y"
 { 
 (yyval.str) = mm_strdup("version");
}
#line 59999 "preproc.c"
    break;

  case 2840: /* unreserved_keyword: VIEW  */
#line 15680 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 60007 "preproc.c"
    break;

  case 2841: /* unreserved_keyword: VIEWS  */
#line 15684 "preproc.y"
 { 
 (yyval.str) = mm_strdup("views");
}
#line 60015 "preproc.c"
    break;

  case 2842: /* unreserved_keyword: VOLATILE  */
#line 15688 "preproc.y"
 { 
 (yyval.str) = mm_strdup("volatile");
}
#line 60023 "preproc.c"
    break;

  case 2843: /* unreserved_keyword: WHITESPACE_P  */
#line 15692 "preproc.y"
 { 
 (yyval.str) = mm_strdup("whitespace");
}
#line 60031 "preproc.c"
    break;

  case 2844: /* unreserved_keyword: WITHIN  */
#line 15696 "preproc.y"
 { 
 (yyval.str) = mm_strdup("within");
}
#line 60039 "preproc.c"
    break;

  case 2845: /* unreserved_keyword: WITHOUT  */
#line 15700 "preproc.y"
 { 
 (yyval.str) = mm_strdup("without");
}
#line 60047 "preproc.c"
    break;

  case 2846: /* unreserved_keyword: WORK  */
#line 15704 "preproc.y"
 { 
 (yyval.str) = mm_strdup("work");
}
#line 60055 "preproc.c"
    break;

  case 2847: /* unreserved_keyword: WRAPPER  */
#line 15708 "preproc.y"
 { 
 (yyval.str) = mm_strdup("wrapper");
}
#line 60063 "preproc.c"
    break;

  case 2848: /* unreserved_keyword: WRITE  */
#line 15712 "preproc.y"
 { 
 (yyval.str) = mm_strdup("write");
}
#line 60071 "preproc.c"
    break;

  case 2849: /* unreserved_keyword: XML_P  */
#line 15716 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xml");
}
#line 60079 "preproc.c"
    break;

  case 2850: /* unreserved_keyword: YES_P  */
#line 15720 "preproc.y"
 { 
 (yyval.str) = mm_strdup("yes");
}
#line 60087 "preproc.c"
    break;

  case 2851: /* unreserved_keyword: ZONE  */
#line 15724 "preproc.y"
 { 
 (yyval.str) = mm_strdup("zone");
}
#line 60095 "preproc.c"
    break;

  case 2852: /* col_name_keyword: BETWEEN  */
#line 15732 "preproc.y"
 { 
 (yyval.str) = mm_strdup("between");
}
#line 60103 "preproc.c"
    break;

  case 2853: /* col_name_keyword: BIGINT  */
#line 15736 "preproc.y"
 { 
 (yyval.str) = mm_strdup("bigint");
}
#line 60111 "preproc.c"
    break;

  case 2854: /* col_name_keyword: BINARY_DOUBLE  */
#line 15740 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary_double");
}
#line 60119 "preproc.c"
    break;

  case 2855: /* col_name_keyword: BINARY_FLOAT  */
#line 15744 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary_float");
}
#line 60127 "preproc.c"
    break;

  case 2856: /* col_name_keyword: BIT  */
#line 15748 "preproc.y"
 { 
 (yyval.str) = mm_strdup("bit");
}
#line 60135 "preproc.c"
    break;

  case 2857: /* col_name_keyword: BOOLEAN_P  */
#line 15752 "preproc.y"
 { 
 (yyval.str) = mm_strdup("boolean");
}
#line 60143 "preproc.c"
    break;

  case 2858: /* col_name_keyword: CHARACTER  */
#line 15756 "preproc.y"
 { 
 (yyval.str) = mm_strdup("character");
}
#line 60151 "preproc.c"
    break;

  case 2859: /* col_name_keyword: COALESCE  */
#line 15760 "preproc.y"
 { 
 (yyval.str) = mm_strdup("coalesce");
}
#line 60159 "preproc.c"
    break;

  case 2860: /* col_name_keyword: DEC  */
#line 15764 "preproc.y"
 { 
 (yyval.str) = mm_strdup("dec");
}
#line 60167 "preproc.c"
    break;

  case 2861: /* col_name_keyword: DECIMAL_P  */
#line 15768 "preproc.y"
 { 
 (yyval.str) = mm_strdup("decimal");
}
#line 60175 "preproc.c"
    break;

  case 2862: /* col_name_keyword: EXISTS  */
#line 15772 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exists");
}
#line 60183 "preproc.c"
    break;

  case 2863: /* col_name_keyword: EXTRACT  */
#line 15776 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extract");
}
#line 60191 "preproc.c"
    break;

  case 2864: /* col_name_keyword: FLOAT_P  */
#line 15780 "preproc.y"
 { 
 (yyval.str) = mm_strdup("float");
}
#line 60199 "preproc.c"
    break;

  case 2865: /* col_name_keyword: GREATEST  */
#line 15784 "preproc.y"
 { 
 (yyval.str) = mm_strdup("greatest");
}
#line 60207 "preproc.c"
    break;

  case 2866: /* col_name_keyword: GROUPING  */
#line 15788 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grouping");
}
#line 60215 "preproc.c"
    break;

  case 2867: /* col_name_keyword: INOUT  */
#line 15792 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inout");
}
#line 60223 "preproc.c"
    break;

  case 2868: /* col_name_keyword: INTEGER  */
#line 15796 "preproc.y"
 { 
 (yyval.str) = mm_strdup("integer");
}
#line 60231 "preproc.c"
    break;

  case 2869: /* col_name_keyword: INTERVAL  */
#line 15800 "preproc.y"
 { 
 (yyval.str) = mm_strdup("interval");
}
#line 60239 "preproc.c"
    break;

  case 2870: /* col_name_keyword: LEAST  */
#line 15804 "preproc.y"
 { 
 (yyval.str) = mm_strdup("least");
}
#line 60247 "preproc.c"
    break;

  case 2871: /* col_name_keyword: NATIONAL  */
#line 15808 "preproc.y"
 { 
 (yyval.str) = mm_strdup("national");
}
#line 60255 "preproc.c"
    break;

  case 2872: /* col_name_keyword: NCHAR  */
#line 15812 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nchar");
}
#line 60263 "preproc.c"
    break;

  case 2873: /* col_name_keyword: NONE  */
#line 15816 "preproc.y"
 { 
 (yyval.str) = mm_strdup("none");
}
#line 60271 "preproc.c"
    break;

  case 2874: /* col_name_keyword: NULLIF  */
#line 15820 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nullif");
}
#line 60279 "preproc.c"
    break;

  case 2875: /* col_name_keyword: NUMBER  */
#line 15824 "preproc.y"
 { 
 (yyval.str) = mm_strdup("number");
}
#line 60287 "preproc.c"
    break;

  case 2876: /* col_name_keyword: NUMERIC  */
#line 15828 "preproc.y"
 { 
 (yyval.str) = mm_strdup("numeric");
}
#line 60295 "preproc.c"
    break;

  case 2877: /* col_name_keyword: OUT_P  */
#line 15832 "preproc.y"
 { 
 (yyval.str) = mm_strdup("out");
}
#line 60303 "preproc.c"
    break;

  case 2878: /* col_name_keyword: OVERLAY  */
#line 15836 "preproc.y"
 { 
 (yyval.str) = mm_strdup("overlay");
}
#line 60311 "preproc.c"
    break;

  case 2879: /* col_name_keyword: POSITION  */
#line 15840 "preproc.y"
 { 
 (yyval.str) = mm_strdup("position");
}
#line 60319 "preproc.c"
    break;

  case 2880: /* col_name_keyword: PRECISION  */
#line 15844 "preproc.y"
 { 
 (yyval.str) = mm_strdup("precision");
}
#line 60327 "preproc.c"
    break;

  case 2881: /* col_name_keyword: REAL  */
#line 15848 "preproc.y"
 { 
 (yyval.str) = mm_strdup("real");
}
#line 60335 "preproc.c"
    break;

  case 2882: /* col_name_keyword: ROW  */
#line 15852 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row");
}
#line 60343 "preproc.c"
    break;

  case 2883: /* col_name_keyword: SETOF  */
#line 15856 "preproc.y"
 { 
 (yyval.str) = mm_strdup("setof");
}
#line 60351 "preproc.c"
    break;

  case 2884: /* col_name_keyword: SMALLINT  */
#line 15860 "preproc.y"
 { 
 (yyval.str) = mm_strdup("smallint");
}
#line 60359 "preproc.c"
    break;

  case 2885: /* col_name_keyword: SUBSTRING  */
#line 15864 "preproc.y"
 { 
 (yyval.str) = mm_strdup("substring");
}
#line 60367 "preproc.c"
    break;

  case 2886: /* col_name_keyword: TIME  */
#line 15868 "preproc.y"
 { 
 (yyval.str) = mm_strdup("time");
}
#line 60375 "preproc.c"
    break;

  case 2887: /* col_name_keyword: TIMESTAMP  */
#line 15872 "preproc.y"
 { 
 (yyval.str) = mm_strdup("timestamp");
}
#line 60383 "preproc.c"
    break;

  case 2888: /* col_name_keyword: TREAT  */
#line 15876 "preproc.y"
 { 
 (yyval.str) = mm_strdup("treat");
}
#line 60391 "preproc.c"
    break;

  case 2889: /* col_name_keyword: TRIM  */
#line 15880 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trim");
}
#line 60399 "preproc.c"
    break;

  case 2890: /* col_name_keyword: VARCHAR  */
#line 15884 "preproc.y"
 { 
 (yyval.str) = mm_strdup("varchar");
}
#line 60407 "preproc.c"
    break;

  case 2891: /* col_name_keyword: XMLATTRIBUTES  */
#line 15888 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlattributes");
}
#line 60415 "preproc.c"
    break;

  case 2892: /* col_name_keyword: XMLCONCAT  */
#line 15892 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlconcat");
}
#line 60423 "preproc.c"
    break;

  case 2893: /* col_name_keyword: XMLELEMENT  */
#line 15896 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlelement");
}
#line 60431 "preproc.c"
    break;

  case 2894: /* col_name_keyword: XMLEXISTS  */
#line 15900 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlexists");
}
#line 60439 "preproc.c"
    break;

  case 2895: /* col_name_keyword: XMLFOREST  */
#line 15904 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlforest");
}
#line 60447 "preproc.c"
    break;

  case 2896: /* col_name_keyword: XMLNAMESPACES  */
#line 15908 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlnamespaces");
}
#line 60455 "preproc.c"
    break;

  case 2897: /* col_name_keyword: XMLPARSE  */
#line 15912 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlparse");
}
#line 60463 "preproc.c"
    break;

  case 2898: /* col_name_keyword: XMLPI  */
#line 15916 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlpi");
}
#line 60471 "preproc.c"
    break;

  case 2899: /* col_name_keyword: XMLROOT  */
#line 15920 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlroot");
}
#line 60479 "preproc.c"
    break;

  case 2900: /* col_name_keyword: XMLSERIALIZE  */
#line 15924 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlserialize");
}
#line 60487 "preproc.c"
    break;

  case 2901: /* col_name_keyword: XMLTABLE  */
#line 15928 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmltable");
}
#line 60495 "preproc.c"
    break;

  case 2902: /* type_func_name_keyword: AUTHORIZATION  */
#line 15936 "preproc.y"
 { 
 (yyval.str) = mm_strdup("authorization");
}
#line 60503 "preproc.c"
    break;

  case 2903: /* type_func_name_keyword: BINARY  */
#line 15940 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary");
}
#line 60511 "preproc.c"
    break;

  case 2904: /* type_func_name_keyword: COLLATION  */
#line 15944 "preproc.y"
 { 
 (yyval.str) = mm_strdup("collation");
}
#line 60519 "preproc.c"
    break;

  case 2905: /* type_func_name_keyword: CONCURRENTLY  */
#line 15948 "preproc.y"
 { 
 (yyval.str) = mm_strdup("concurrently");
}
#line 60527 "preproc.c"
    break;

  case 2906: /* type_func_name_keyword: CROSS  */
#line 15952 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cross");
}
#line 60535 "preproc.c"
    break;

  case 2907: /* type_func_name_keyword: CURRENT_SCHEMA  */
#line 15956 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_schema");
}
#line 60543 "preproc.c"
    break;

  case 2908: /* type_func_name_keyword: FREEZE  */
#line 15960 "preproc.y"
 { 
 (yyval.str) = mm_strdup("freeze");
}
#line 60551 "preproc.c"
    break;

  case 2909: /* type_func_name_keyword: FULL  */
#line 15964 "preproc.y"
 { 
 (yyval.str) = mm_strdup("full");
}
#line 60559 "preproc.c"
    break;

  case 2910: /* type_func_name_keyword: ILIKE  */
#line 15968 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ilike");
}
#line 60567 "preproc.c"
    break;

  case 2911: /* type_func_name_keyword: INNER_P  */
#line 15972 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inner");
}
#line 60575 "preproc.c"
    break;

  case 2912: /* type_func_name_keyword: IS  */
#line 15976 "preproc.y"
 { 
 (yyval.str) = mm_strdup("is");
}
#line 60583 "preproc.c"
    break;

  case 2913: /* type_func_name_keyword: ISNULL  */
#line 15980 "preproc.y"
 { 
 (yyval.str) = mm_strdup("isnull");
}
#line 60591 "preproc.c"
    break;

  case 2914: /* type_func_name_keyword: JOIN  */
#line 15984 "preproc.y"
 { 
 (yyval.str) = mm_strdup("join");
}
#line 60599 "preproc.c"
    break;

  case 2915: /* type_func_name_keyword: LEFT  */
#line 15988 "preproc.y"
 { 
 (yyval.str) = mm_strdup("left");
}
#line 60607 "preproc.c"
    break;

  case 2916: /* type_func_name_keyword: LIKE  */
#line 15992 "preproc.y"
 { 
 (yyval.str) = mm_strdup("like");
}
#line 60615 "preproc.c"
    break;

  case 2917: /* type_func_name_keyword: NATURAL  */
#line 15996 "preproc.y"
 { 
 (yyval.str) = mm_strdup("natural");
}
#line 60623 "preproc.c"
    break;

  case 2918: /* type_func_name_keyword: NOTNULL  */
#line 16000 "preproc.y"
 { 
 (yyval.str) = mm_strdup("notnull");
}
#line 60631 "preproc.c"
    break;

  case 2919: /* type_func_name_keyword: OUTER_P  */
#line 16004 "preproc.y"
 { 
 (yyval.str) = mm_strdup("outer");
}
#line 60639 "preproc.c"
    break;

  case 2920: /* type_func_name_keyword: OVERLAPS  */
#line 16008 "preproc.y"
 { 
 (yyval.str) = mm_strdup("overlaps");
}
#line 60647 "preproc.c"
    break;

  case 2921: /* type_func_name_keyword: RIGHT  */
#line 16012 "preproc.y"
 { 
 (yyval.str) = mm_strdup("right");
}
#line 60655 "preproc.c"
    break;

  case 2922: /* type_func_name_keyword: SIMILAR  */
#line 16016 "preproc.y"
 { 
 (yyval.str) = mm_strdup("similar");
}
#line 60663 "preproc.c"
    break;

  case 2923: /* type_func_name_keyword: TABLESAMPLE  */
#line 16020 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablesample");
}
#line 60671 "preproc.c"
    break;

  case 2924: /* type_func_name_keyword: VERBOSE  */
#line 16024 "preproc.y"
 { 
 (yyval.str) = mm_strdup("verbose");
}
#line 60679 "preproc.c"
    break;

  case 2925: /* reserved_keyword: ALL  */
#line 16032 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 60687 "preproc.c"
    break;

  case 2926: /* reserved_keyword: ANALYSE  */
#line 16036 "preproc.y"
 { 
 (yyval.str) = mm_strdup("analyse");
}
#line 60695 "preproc.c"
    break;

  case 2927: /* reserved_keyword: ANALYZE  */
#line 16040 "preproc.y"
 { 
 (yyval.str) = mm_strdup("analyze");
}
#line 60703 "preproc.c"
    break;

  case 2928: /* reserved_keyword: AND  */
#line 16044 "preproc.y"
 { 
 (yyval.str) = mm_strdup("and");
}
#line 60711 "preproc.c"
    break;

  case 2929: /* reserved_keyword: ANY  */
#line 16048 "preproc.y"
 { 
 (yyval.str) = mm_strdup("any");
}
#line 60719 "preproc.c"
    break;

  case 2930: /* reserved_keyword: ARRAY  */
#line 16052 "preproc.y"
 { 
 (yyval.str) = mm_strdup("array");
}
#line 60727 "preproc.c"
    break;

  case 2931: /* reserved_keyword: AS  */
#line 16056 "preproc.y"
 { 
 (yyval.str) = mm_strdup("as");
}
#line 60735 "preproc.c"
    break;

  case 2932: /* reserved_keyword: ASC  */
#line 16060 "preproc.y"
 { 
 (yyval.str) = mm_strdup("asc");
}
#line 60743 "preproc.c"
    break;

  case 2933: /* reserved_keyword: ASYMMETRIC  */
#line 16064 "preproc.y"
 { 
 (yyval.str) = mm_strdup("asymmetric");
}
#line 60751 "preproc.c"
    break;

  case 2934: /* reserved_keyword: AUDIT  */
#line 16068 "preproc.y"
 { 
 (yyval.str) = mm_strdup("audit");
}
#line 60759 "preproc.c"
    break;

  case 2935: /* reserved_keyword: BOTH  */
#line 16072 "preproc.y"
 { 
 (yyval.str) = mm_strdup("both");
}
#line 60767 "preproc.c"
    break;

  case 2936: /* reserved_keyword: CASE  */
#line 16076 "preproc.y"
 { 
 (yyval.str) = mm_strdup("case");
}
#line 60775 "preproc.c"
    break;

  case 2937: /* reserved_keyword: CAST  */
#line 16080 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cast");
}
#line 60783 "preproc.c"
    break;

  case 2938: /* reserved_keyword: CHECK  */
#line 16084 "preproc.y"
 { 
 (yyval.str) = mm_strdup("check");
}
#line 60791 "preproc.c"
    break;

  case 2939: /* reserved_keyword: COLLATE  */
#line 16088 "preproc.y"
 { 
 (yyval.str) = mm_strdup("collate");
}
#line 60799 "preproc.c"
    break;

  case 2940: /* reserved_keyword: COLUMN  */
#line 16092 "preproc.y"
 { 
 (yyval.str) = mm_strdup("column");
}
#line 60807 "preproc.c"
    break;

  case 2941: /* reserved_keyword: CONSTRAINT  */
#line 16096 "preproc.y"
 { 
 (yyval.str) = mm_strdup("constraint");
}
#line 60815 "preproc.c"
    break;

  case 2942: /* reserved_keyword: CREATE  */
#line 16100 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create");
}
#line 60823 "preproc.c"
    break;

  case 2943: /* reserved_keyword: CURRENT_CATALOG  */
#line 16104 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_catalog");
}
#line 60831 "preproc.c"
    break;

  case 2944: /* reserved_keyword: CURRENT_DATE  */
#line 16108 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_date");
}
#line 60839 "preproc.c"
    break;

  case 2945: /* reserved_keyword: CURRENT_ROLE  */
#line 16112 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_role");
}
#line 60847 "preproc.c"
    break;

  case 2946: /* reserved_keyword: CURRENT_TIME  */
#line 16116 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_time");
}
#line 60855 "preproc.c"
    break;

  case 2947: /* reserved_keyword: CURRENT_TIMESTAMP  */
#line 16120 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_timestamp");
}
#line 60863 "preproc.c"
    break;

  case 2948: /* reserved_keyword: CURRENT_USER  */
#line 16124 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_user");
}
#line 60871 "preproc.c"
    break;

  case 2949: /* reserved_keyword: DBTIMEZONE  */
#line 16128 "preproc.y"
 { 
 (yyval.str) = mm_strdup("dbtimezone");
}
#line 60879 "preproc.c"
    break;

  case 2950: /* reserved_keyword: DEFAULT  */
#line 16132 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 60887 "preproc.c"
    break;

  case 2951: /* reserved_keyword: DEFERRABLE  */
#line 16136 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 60895 "preproc.c"
    break;

  case 2952: /* reserved_keyword: DESC  */
#line 16140 "preproc.y"
 { 
 (yyval.str) = mm_strdup("desc");
}
#line 60903 "preproc.c"
    break;

  case 2953: /* reserved_keyword: DISTINCT  */
#line 16144 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distinct");
}
#line 60911 "preproc.c"
    break;

  case 2954: /* reserved_keyword: DO  */
#line 16148 "preproc.y"
 { 
 (yyval.str) = mm_strdup("do");
}
#line 60919 "preproc.c"
    break;

  case 2955: /* reserved_keyword: ELSE  */
#line 16152 "preproc.y"
 { 
 (yyval.str) = mm_strdup("else");
}
#line 60927 "preproc.c"
    break;

  case 2956: /* reserved_keyword: END_P  */
#line 16156 "preproc.y"
 { 
 (yyval.str) = mm_strdup("end");
}
#line 60935 "preproc.c"
    break;

  case 2957: /* reserved_keyword: EXCEPT  */
#line 16160 "preproc.y"
 { 
 (yyval.str) = mm_strdup("except");
}
#line 60943 "preproc.c"
    break;

  case 2958: /* reserved_keyword: FALSE_P  */
#line 16164 "preproc.y"
 { 
 (yyval.str) = mm_strdup("false");
}
#line 60951 "preproc.c"
    break;

  case 2959: /* reserved_keyword: FETCH  */
#line 16168 "preproc.y"
 { 
 (yyval.str) = mm_strdup("fetch");
}
#line 60959 "preproc.c"
    break;

  case 2960: /* reserved_keyword: FOR  */
#line 16172 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for");
}
#line 60967 "preproc.c"
    break;

  case 2961: /* reserved_keyword: FOREIGN  */
#line 16176 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign");
}
#line 60975 "preproc.c"
    break;

  case 2962: /* reserved_keyword: FROM  */
#line 16180 "preproc.y"
 { 
 (yyval.str) = mm_strdup("from");
}
#line 60983 "preproc.c"
    break;

  case 2963: /* reserved_keyword: GRANT  */
#line 16184 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grant");
}
#line 60991 "preproc.c"
    break;

  case 2964: /* reserved_keyword: GROUP_P  */
#line 16188 "preproc.y"
 { 
 (yyval.str) = mm_strdup("group");
}
#line 60999 "preproc.c"
    break;

  case 2965: /* reserved_keyword: HAVING  */
#line 16192 "preproc.y"
 { 
 (yyval.str) = mm_strdup("having");
}
#line 61007 "preproc.c"
    break;

  case 2966: /* reserved_keyword: IN_P  */
#line 16196 "preproc.y"
 { 
 (yyval.str) = mm_strdup("in");
}
#line 61015 "preproc.c"
    break;

  case 2967: /* reserved_keyword: INITIALLY  */
#line 16200 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially");
}
#line 61023 "preproc.c"
    break;

  case 2968: /* reserved_keyword: INTERSECT  */
#line 16204 "preproc.y"
 { 
 (yyval.str) = mm_strdup("intersect");
}
#line 61031 "preproc.c"
    break;

  case 2969: /* reserved_keyword: INTO  */
#line 16208 "preproc.y"
 { 
 (yyval.str) = mm_strdup("into");
}
#line 61039 "preproc.c"
    break;

  case 2970: /* reserved_keyword: LATERAL_P  */
#line 16212 "preproc.y"
 { 
 (yyval.str) = mm_strdup("lateral");
}
#line 61047 "preproc.c"
    break;

  case 2971: /* reserved_keyword: LEADING  */
#line 16216 "preproc.y"
 { 
 (yyval.str) = mm_strdup("leading");
}
#line 61055 "preproc.c"
    break;

  case 2972: /* reserved_keyword: LIMIT  */
#line 16220 "preproc.y"
 { 
 (yyval.str) = mm_strdup("limit");
}
#line 61063 "preproc.c"
    break;

  case 2973: /* reserved_keyword: LOCALTIME  */
#line 16224 "preproc.y"
 { 
 (yyval.str) = mm_strdup("localtime");
}
#line 61071 "preproc.c"
    break;

  case 2974: /* reserved_keyword: LOCALTIMESTAMP  */
#line 16228 "preproc.y"
 { 
 (yyval.str) = mm_strdup("localtimestamp");
}
#line 61079 "preproc.c"
    break;

  case 2975: /* reserved_keyword: NOAUDIT  */
#line 16232 "preproc.y"
 { 
 (yyval.str) = mm_strdup("noaudit");
}
#line 61087 "preproc.c"
    break;

  case 2976: /* reserved_keyword: NOT  */
#line 16236 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not");
}
#line 61095 "preproc.c"
    break;

  case 2977: /* reserved_keyword: NULL_P  */
#line 16240 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 61103 "preproc.c"
    break;

  case 2978: /* reserved_keyword: OFFSET  */
#line 16244 "preproc.y"
 { 
 (yyval.str) = mm_strdup("offset");
}
#line 61111 "preproc.c"
    break;

  case 2979: /* reserved_keyword: ON  */
#line 16248 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on");
}
#line 61119 "preproc.c"
    break;

  case 2980: /* reserved_keyword: ONLY  */
#line 16252 "preproc.y"
 { 
 (yyval.str) = mm_strdup("only");
}
#line 61127 "preproc.c"
    break;

  case 2981: /* reserved_keyword: OR  */
#line 16256 "preproc.y"
 { 
 (yyval.str) = mm_strdup("or");
}
#line 61135 "preproc.c"
    break;

  case 2982: /* reserved_keyword: ORDER  */
#line 16260 "preproc.y"
 { 
 (yyval.str) = mm_strdup("order");
}
#line 61143 "preproc.c"
    break;

  case 2983: /* reserved_keyword: PARTITION  */
#line 16264 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partition");
}
#line 61151 "preproc.c"
    break;

  case 2984: /* reserved_keyword: PLACING  */
#line 16268 "preproc.y"
 { 
 (yyval.str) = mm_strdup("placing");
}
#line 61159 "preproc.c"
    break;

  case 2985: /* reserved_keyword: PRIMARY  */
#line 16272 "preproc.y"
 { 
 (yyval.str) = mm_strdup("primary");
}
#line 61167 "preproc.c"
    break;

  case 2986: /* reserved_keyword: REFERENCES  */
#line 16276 "preproc.y"
 { 
 (yyval.str) = mm_strdup("references");
}
#line 61175 "preproc.c"
    break;

  case 2987: /* reserved_keyword: RETURNING  */
#line 16280 "preproc.y"
 { 
 (yyval.str) = mm_strdup("returning");
}
#line 61183 "preproc.c"
    break;

  case 2988: /* reserved_keyword: SELECT  */
#line 16284 "preproc.y"
 { 
 (yyval.str) = mm_strdup("select");
}
#line 61191 "preproc.c"
    break;

  case 2989: /* reserved_keyword: SESSIONTIMEZONE  */
#line 16288 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sessiontimezone");
}
#line 61199 "preproc.c"
    break;

  case 2990: /* reserved_keyword: SESSION_USER  */
#line 16292 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session_user");
}
#line 61207 "preproc.c"
    break;

  case 2991: /* reserved_keyword: SOME  */
#line 16296 "preproc.y"
 { 
 (yyval.str) = mm_strdup("some");
}
#line 61215 "preproc.c"
    break;

  case 2992: /* reserved_keyword: SUCCESSFUL  */
#line 16300 "preproc.y"
 { 
 (yyval.str) = mm_strdup("successful");
}
#line 61223 "preproc.c"
    break;

  case 2993: /* reserved_keyword: SYMMETRIC  */
#line 16304 "preproc.y"
 { 
 (yyval.str) = mm_strdup("symmetric");
}
#line 61231 "preproc.c"
    break;

  case 2994: /* reserved_keyword: SYSDATE  */
#line 16308 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sysdate");
}
#line 61239 "preproc.c"
    break;

  case 2995: /* reserved_keyword: SYSTIMESTAMP  */
#line 16312 "preproc.y"
 { 
 (yyval.str) = mm_strdup("systimestamp");
}
#line 61247 "preproc.c"
    break;

  case 2996: /* reserved_keyword: TABLE  */
#line 16316 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 61255 "preproc.c"
    break;

  case 2997: /* reserved_keyword: THEN  */
#line 16320 "preproc.y"
 { 
 (yyval.str) = mm_strdup("then");
}
#line 61263 "preproc.c"
    break;

  case 2998: /* reserved_keyword: TRAILING  */
#line 16324 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trailing");
}
#line 61271 "preproc.c"
    break;

  case 2999: /* reserved_keyword: TRUE_P  */
#line 16328 "preproc.y"
 { 
 (yyval.str) = mm_strdup("true");
}
#line 61279 "preproc.c"
    break;

  case 3000: /* reserved_keyword: UNIQUE  */
#line 16332 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unique");
}
#line 61287 "preproc.c"
    break;

  case 3001: /* reserved_keyword: USER  */
#line 16336 "preproc.y"
 { 
 (yyval.str) = mm_strdup("user");
}
#line 61295 "preproc.c"
    break;

  case 3002: /* reserved_keyword: USING  */
#line 16340 "preproc.y"
 { 
 (yyval.str) = mm_strdup("using");
}
#line 61303 "preproc.c"
    break;

  case 3003: /* reserved_keyword: VARIADIC  */
#line 16344 "preproc.y"
 { 
 (yyval.str) = mm_strdup("variadic");
}
#line 61311 "preproc.c"
    break;

  case 3004: /* reserved_keyword: WHEN  */
#line 16348 "preproc.y"
 { 
 (yyval.str) = mm_strdup("when");
}
#line 61319 "preproc.c"
    break;

  case 3005: /* reserved_keyword: WHENEVER  */
#line 16352 "preproc.y"
 { 
 (yyval.str) = mm_strdup("whenever");
}
#line 61327 "preproc.c"
    break;

  case 3006: /* reserved_keyword: WHERE  */
#line 16356 "preproc.y"
 { 
 (yyval.str) = mm_strdup("where");
}
#line 61335 "preproc.c"
    break;

  case 3007: /* reserved_keyword: WINDOW  */
#line 16360 "preproc.y"
 { 
 (yyval.str) = mm_strdup("window");
}
#line 61343 "preproc.c"
    break;

  case 3008: /* reserved_keyword: WITH  */
#line 16364 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with");
}
#line 61351 "preproc.c"
    break;

  case 3011: /* statement: ecpgstart at stmt ';'  */
#line 16377 "preproc.y"
                                 { connection = NULL; }
#line 61357 "preproc.c"
    break;

  case 3013: /* statement: ecpgstart ECPGVarDeclaration  */
#line 16380 "preproc.y"
                                {
					fprintf(base_yyout, "%s", (yyvsp[0].str));
					free((yyvsp[0].str));
					output_line_number();
				}
#line 61367 "preproc.c"
    break;

  case 3015: /* statement: c_thing  */
#line 16386 "preproc.y"
                                                        { fprintf(base_yyout, "%s", (yyvsp[0].str)); free((yyvsp[0].str)); }
#line 61373 "preproc.c"
    break;

  case 3016: /* statement: CPP_LINE  */
#line 16387 "preproc.y"
                                                        { fprintf(base_yyout, "%s", (yyvsp[0].str)); free((yyvsp[0].str)); }
#line 61379 "preproc.c"
    break;

  case 3017: /* statement: '{'  */
#line 16388 "preproc.y"
                                                        { braces_open++; fputs("{", base_yyout); }
#line 61385 "preproc.c"
    break;

  case 3018: /* statement: '}'  */
#line 16390 "preproc.y"
                {
			remove_typedefs(braces_open);
			remove_variables(braces_open--);
			if (braces_open == 0)
			{
				free(current_function);
				current_function = NULL;
			}
			fputs("}", base_yyout);
		}
#line 61400 "preproc.c"
    break;

  case 3019: /* $@1: %empty  */
#line 16402 "preproc.y"
                                                       {FoundInto = 0;}
#line 61406 "preproc.c"
    break;

  case 3020: /* CreateAsStmt: CREATE OptTemp TABLE create_as_target AS $@1 SelectStmt opt_with_data  */
#line 16403 "preproc.y"
                {
			if (FoundInto == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "CREATE TABLE AS cannot specify INTO");

			(yyval.str) = cat_str(6, mm_strdup("create"), (yyvsp[-6].str), mm_strdup("table"), (yyvsp[-4].str), mm_strdup("as"), (yyvsp[-1].str));
		}
#line 61417 "preproc.c"
    break;

  case 3021: /* at: AT connection_object  */
#line 16412 "preproc.y"
                {
			connection = (yyvsp[0].str);
			/*
			 * Do we have a variable as connection target?  Remove the variable
			 * from the variable list or else it will be used twice.
			 */
			if (argsinsert != NULL)
				argsinsert = NULL;
		}
#line 61431 "preproc.c"
    break;

  case 3022: /* ECPGConnect: SQL_CONNECT TO connection_target opt_connection_name opt_user  */
#line 16427 "preproc.y"
                        { (yyval.str) = cat_str(5, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str), mm_strdup(","), (yyvsp[-1].str)); }
#line 61437 "preproc.c"
    break;

  case 3023: /* ECPGConnect: SQL_CONNECT TO DEFAULT  */
#line 16429 "preproc.y"
                        { (yyval.str) = mm_strdup("NULL, NULL, NULL, \"DEFAULT\""); }
#line 61443 "preproc.c"
    break;

  case 3024: /* ECPGConnect: SQL_CONNECT ora_user  */
#line 16432 "preproc.y"
                        { (yyval.str) = cat_str(3, mm_strdup("NULL,"), (yyvsp[0].str), mm_strdup(", NULL")); }
#line 61449 "preproc.c"
    break;

  case 3025: /* ECPGConnect: DATABASE connection_target  */
#line 16434 "preproc.y"
                        { (yyval.str) = cat2_str((yyvsp[0].str), mm_strdup(", NULL, NULL, NULL")); }
#line 61455 "preproc.c"
    break;

  case 3026: /* connection_target: opt_database_name opt_server opt_port  */
#line 16438 "preproc.y"
                {
			/* old style: dbname[@server][:port] */
			if (strlen((yyvsp[-1].str)) > 0 && *((yyvsp[-1].str)) != '@')
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\", found \"%s\"", (yyvsp[-1].str));

			/* C strings need to be handled differently */
			if ((yyvsp[-2].str)[0] == '\"')
				(yyval.str) = (yyvsp[-2].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), make3_str((yyvsp[-2].str), (yyvsp[-1].str), (yyvsp[0].str)), mm_strdup("\""));
		}
#line 61471 "preproc.c"
    break;

  case 3027: /* connection_target: db_prefix ':' server opt_port '/' opt_database_name opt_options  */
#line 16450 "preproc.y"
                {
			/* new style: <tcp|unix>:postgresql://server[:port][/dbname] */
			if (strncmp((yyvsp[-6].str), "unix:postgresql", strlen("unix:postgresql")) != 0 && strncmp((yyvsp[-6].str), "tcp:postgresql", strlen("tcp:postgresql")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "only protocols \"tcp\" and \"unix\" and database type \"postgresql\" are supported");

			if (strncmp((yyvsp[-4].str), "//", strlen("//")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"://\", found \"%s\"", (yyvsp[-4].str));

			if (strncmp((yyvsp[-6].str), "unix", strlen("unix")) == 0 &&
				strncmp((yyvsp[-4].str) + strlen("//"), "localhost", strlen("localhost")) != 0 &&
				strncmp((yyvsp[-4].str) + strlen("//"), "127.0.0.1", strlen("127.0.0.1")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "Unix-domain sockets only work on \"localhost\" but not on \"%s\"", (yyvsp[-4].str) + strlen("//"));

			(yyval.str) = make3_str(make3_str(mm_strdup("\""), (yyvsp[-6].str), mm_strdup(":")), (yyvsp[-4].str), make3_str(make3_str((yyvsp[-3].str), mm_strdup("/"), (yyvsp[-1].str)), (yyvsp[0].str), mm_strdup("\"")));
		}
#line 61491 "preproc.c"
    break;

  case 3028: /* connection_target: char_variable  */
#line 16466 "preproc.y"
                {
			(yyval.str) = (yyvsp[0].str);
		}
#line 61499 "preproc.c"
    break;

  case 3029: /* connection_target: ecpg_sconst  */
#line 16470 "preproc.y"
                {
			/* We can only process double quoted strings not single quotes ones,
			 * so we change the quotes.
			 * Note, that the rule for ecpg_sconst adds these single quotes. */
			(yyvsp[0].str)[0] = '\"';
			(yyvsp[0].str)[strlen((yyvsp[0].str))-1] = '\"';
			(yyval.str) = (yyvsp[0].str);
		}
#line 61512 "preproc.c"
    break;

  case 3030: /* opt_database_name: database_name  */
#line 16480 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 61518 "preproc.c"
    break;

  case 3031: /* opt_database_name: %empty  */
#line 16481 "preproc.y"
                                                { (yyval.str) = EMPTY; }
#line 61524 "preproc.c"
    break;

  case 3032: /* db_prefix: ecpg_ident cvariable  */
#line 16485 "preproc.y"
                {
			if (strcmp((yyvsp[0].str), "postgresql") != 0 && strcmp((yyvsp[0].str), "postgres") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"postgresql\", found \"%s\"", (yyvsp[0].str));

			if (strcmp((yyvsp[-1].str), "tcp") != 0 && strcmp((yyvsp[-1].str), "unix") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "invalid connection type: %s", (yyvsp[-1].str));

			(yyval.str) = make3_str((yyvsp[-1].str), mm_strdup(":"), (yyvsp[0].str));
		}
#line 61538 "preproc.c"
    break;

  case 3033: /* server: Op server_name  */
#line 16497 "preproc.y"
                {
			if (strcmp((yyvsp[-1].str), "@") != 0 && strcmp((yyvsp[-1].str), "//") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\" or \"://\", found \"%s\"", (yyvsp[-1].str));

			(yyval.str) = make2_str((yyvsp[-1].str), (yyvsp[0].str));
		}
#line 61549 "preproc.c"
    break;

  case 3034: /* opt_server: server  */
#line 16505 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 61555 "preproc.c"
    break;

  case 3035: /* opt_server: %empty  */
#line 16506 "preproc.y"
                                                { (yyval.str) = EMPTY; }
#line 61561 "preproc.c"
    break;

  case 3036: /* server_name: ColId  */
#line 16509 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 61567 "preproc.c"
    break;

  case 3037: /* server_name: ColId '.' server_name  */
#line 16510 "preproc.y"
                                                { (yyval.str) = make3_str((yyvsp[-2].str), mm_strdup("."), (yyvsp[0].str)); }
#line 61573 "preproc.c"
    break;

  case 3038: /* server_name: IP  */
#line 16511 "preproc.y"
                                                                { (yyval.str) = make_name(); }
#line 61579 "preproc.c"
    break;

  case 3039: /* opt_port: ':' Iconst  */
#line 16514 "preproc.y"
                                { (yyval.str) = make2_str(mm_strdup(":"), (yyvsp[0].str)); }
#line 61585 "preproc.c"
    break;

  case 3040: /* opt_port: %empty  */
#line 16515 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 61591 "preproc.c"
    break;

  case 3041: /* opt_connection_name: AS connection_object  */
#line 16518 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 61597 "preproc.c"
    break;

  case 3042: /* opt_connection_name: %empty  */
#line 16519 "preproc.y"
                                                { (yyval.str) = mm_strdup("NULL"); }
#line 61603 "preproc.c"
    break;

  case 3043: /* opt_user: USER ora_user  */
#line 16522 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 61609 "preproc.c"
    break;

  case 3044: /* opt_user: %empty  */
#line 16523 "preproc.y"
                                                { (yyval.str) = mm_strdup("NULL, NULL"); }
#line 61615 "preproc.c"
    break;

  case 3045: /* ora_user: user_name  */
#line 16527 "preproc.y"
                        { (yyval.str) = cat2_str((yyvsp[0].str), mm_strdup(", NULL")); }
#line 61621 "preproc.c"
    break;

  case 3046: /* ora_user: user_name '/' user_name  */
#line 16529 "preproc.y"
                        { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 61627 "preproc.c"
    break;

  case 3047: /* ora_user: user_name SQL_IDENTIFIED BY user_name  */
#line 16531 "preproc.y"
                        { (yyval.str) = cat_str(3, (yyvsp[-3].str), mm_strdup(","), (yyvsp[0].str)); }
#line 61633 "preproc.c"
    break;

  case 3048: /* ora_user: user_name USING user_name  */
#line 16533 "preproc.y"
                        { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 61639 "preproc.c"
    break;

  case 3049: /* user_name: RoleId  */
#line 16537 "preproc.y"
                {
			if ((yyvsp[0].str)[0] == '\"')
				(yyval.str) = (yyvsp[0].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
		}
#line 61650 "preproc.c"
    break;

  case 3050: /* user_name: ecpg_sconst  */
#line 16544 "preproc.y"
                {
			if ((yyvsp[0].str)[0] == '\"')
				(yyval.str) = (yyvsp[0].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
		}
#line 61661 "preproc.c"
    break;

  case 3051: /* user_name: civar  */
#line 16551 "preproc.y"
                {
			enum ECPGttype type = argsinsert->variable->type->type;

			/* if array see what's inside */
			if (type == ECPGt_array)
				type = argsinsert->variable->type->u.element->type;

			/* handle varchars */
			if (type == ECPGt_varchar)
				(yyval.str) = make2_str(mm_strdup(argsinsert->variable->name), mm_strdup(".arr"));
			else
				(yyval.str) = mm_strdup(argsinsert->variable->name);
		}
#line 61679 "preproc.c"
    break;

  case 3052: /* char_variable: cvariable  */
#line 16567 "preproc.y"
                {
			/* check if we have a string variable */
			struct variable *p = find_variable((yyvsp[0].str));
			enum ECPGttype type = p->type->type;

			/* If we have just one character this is not a string */
			if (atol(p->type->size) == 1)
					mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
			else
			{
				/* if array see what's inside */
				if (type == ECPGt_array)
					type = p->type->u.element->type;

				switch (type)
				{
					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						(yyval.str) = (yyvsp[0].str);
						break;
					case ECPGt_varchar:
						(yyval.str) = make2_str((yyvsp[0].str), mm_strdup(".arr"));
						break;
					default:
						mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
						(yyval.str) = (yyvsp[0].str);
						break;
				}
			}
		}
#line 61715 "preproc.c"
    break;

  case 3053: /* opt_options: Op connect_options  */
#line 16601 "preproc.y"
                {
			if (strlen((yyvsp[-1].str)) == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

			if (strcmp((yyvsp[-1].str), "?") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[-1].str));

			(yyval.str) = make2_str(mm_strdup("?"), (yyvsp[0].str));
		}
#line 61729 "preproc.c"
    break;

  case 3054: /* opt_options: %empty  */
#line 16610 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 61735 "preproc.c"
    break;

  case 3055: /* connect_options: ColId opt_opt_value  */
#line 16614 "preproc.y"
                        {
				(yyval.str) = make2_str((yyvsp[-1].str), (yyvsp[0].str));
			}
#line 61743 "preproc.c"
    break;

  case 3056: /* connect_options: ColId opt_opt_value Op connect_options  */
#line 16618 "preproc.y"
                        {
				if (strlen((yyvsp[-1].str)) == 0)
					mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

				if (strcmp((yyvsp[-1].str), "&") != 0)
					mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[-1].str));

				(yyval.str) = cat_str(3, make2_str((yyvsp[-3].str), (yyvsp[-2].str)), (yyvsp[-1].str), (yyvsp[0].str));
			}
#line 61757 "preproc.c"
    break;

  case 3057: /* opt_opt_value: %empty  */
#line 16630 "preproc.y"
                        { (yyval.str) = EMPTY; }
#line 61763 "preproc.c"
    break;

  case 3058: /* opt_opt_value: '=' Iconst  */
#line 16632 "preproc.y"
                        { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 61769 "preproc.c"
    break;

  case 3059: /* opt_opt_value: '=' ecpg_ident  */
#line 16634 "preproc.y"
                        { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 61775 "preproc.c"
    break;

  case 3060: /* opt_opt_value: '=' civar  */
#line 16636 "preproc.y"
                        { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 61781 "preproc.c"
    break;

  case 3061: /* prepared_name: name  */
#line 16640 "preproc.y"
                {
			if ((yyvsp[0].str)[0] == '\"' && (yyvsp[0].str)[strlen((yyvsp[0].str))-1] == '\"') /* already quoted? */
				(yyval.str) = (yyvsp[0].str);
			else /* not quoted => convert to lowercase */
			{
				size_t i;

				for (i = 0; i< strlen((yyvsp[0].str)); i++)
					(yyvsp[0].str)[i] = tolower((unsigned char) (yyvsp[0].str)[i]);

				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
			}
		}
#line 61799 "preproc.c"
    break;

  case 3062: /* prepared_name: char_variable  */
#line 16653 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 61805 "preproc.c"
    break;

  case 3063: /* ECPGCursorStmt: DECLARE cursor_name cursor_options CURSOR opt_hold FOR prepared_name  */
#line 16661 "preproc.y"
                {
			struct cursor *ptr, *this;
			char *cursor_marker = (yyvsp[-5].str)[0] == ':' ? mm_strdup("$0") : mm_strdup((yyvsp[-5].str));
			int (* strcmp_fn)(const char *, const char *) = (((yyvsp[-5].str)[0] == ':' || (yyvsp[-5].str)[0] == '"') ? strcmp : pg_strcasecmp);
			struct variable *thisquery = (struct variable *)mm_alloc(sizeof(struct variable));
			const char *con = connection ? connection : "NULL";
			char *comment;

			for (ptr = cur; ptr != NULL; ptr = ptr->next)
			{
				if (strcmp_fn((yyvsp[-5].str), ptr->name) == 0)
				{
					/* re-definition is a bug */
					if ((yyvsp[-5].str)[0] == ':')
						mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[-5].str)+1);
					else
						mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[-5].str));
				}
			}

			this = (struct cursor *) mm_alloc(sizeof(struct cursor));

			/* initial definition */
			this->next = cur;
			this->name = (yyvsp[-5].str);
			this->function = (current_function ? mm_strdup(current_function) : NULL);
			this->connection = connection;
			this->command =  cat_str(6, mm_strdup("declare"), cursor_marker, (yyvsp[-4].str), mm_strdup("cursor"), (yyvsp[-2].str), mm_strdup("for $1"));
			this->argsresult = NULL;
			this->argsresult_oos = NULL;

			thisquery->type = &ecpg_query;
			thisquery->brace_level = 0;
			thisquery->next = NULL;
			thisquery->name = (char *) mm_alloc(sizeof("ECPGprepared_statement(, , __LINE__)") + strlen(con) + strlen((yyvsp[0].str)));
			sprintf(thisquery->name, "ECPGprepared_statement(%s, %s, __LINE__)", con, (yyvsp[0].str));

			this->argsinsert = NULL;
			this->argsinsert_oos = NULL;
			if ((yyvsp[-5].str)[0] == ':')
			{
				struct variable *var = find_variable((yyvsp[-5].str) + 1);
				remove_variable_from_list(&argsinsert, var);
				add_variable_to_head(&(this->argsinsert), var, &no_indicator);
			}
			add_variable_to_head(&(this->argsinsert), thisquery, &no_indicator);

			cur = this;

			comment = cat_str(3, mm_strdup("/*"), mm_strdup(this->command), mm_strdup("*/"));

			if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
				(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
					mm_strdup("ECPG_informix_reset_sqlca();"),
					comment);
			else
				(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
		}
#line 61868 "preproc.c"
    break;

  case 3064: /* ECPGExecuteImmediateStmt: EXECUTE IMMEDIATE execstring  */
#line 16722 "preproc.y"
                        {
			  /* execute immediate means prepare the statement and
			   * immediately execute it */
			  (yyval.str) = (yyvsp[0].str);
			}
#line 61878 "preproc.c"
    break;

  case 3066: /* single_vt_declaration: type_declaration  */
#line 16732 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 61884 "preproc.c"
    break;

  case 3067: /* single_vt_declaration: var_declaration  */
#line 16733 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 61890 "preproc.c"
    break;

  case 3068: /* precision: NumericOnly  */
#line 16736 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 61896 "preproc.c"
    break;

  case 3069: /* opt_scale: ',' NumericOnly  */
#line 16738 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 61902 "preproc.c"
    break;

  case 3070: /* opt_scale: %empty  */
#line 16739 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 61908 "preproc.c"
    break;

  case 3071: /* ecpg_interval: opt_interval  */
#line 16742 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 61914 "preproc.c"
    break;

  case 3072: /* ecpg_interval: YEAR_P TO MINUTE_P  */
#line 16743 "preproc.y"
                                        { (yyval.str) = mm_strdup("year to minute"); }
#line 61920 "preproc.c"
    break;

  case 3073: /* ecpg_interval: YEAR_P TO SECOND_P  */
#line 16744 "preproc.y"
                                        { (yyval.str) = mm_strdup("year to second"); }
#line 61926 "preproc.c"
    break;

  case 3074: /* ecpg_interval: DAY_P TO DAY_P  */
#line 16745 "preproc.y"
                                                { (yyval.str) = mm_strdup("day to day"); }
#line 61932 "preproc.c"
    break;

  case 3075: /* ecpg_interval: MONTH_P TO MONTH_P  */
#line 16746 "preproc.y"
                                        { (yyval.str) = mm_strdup("month to month"); }
#line 61938 "preproc.c"
    break;

  case 3076: /* $@2: %empty  */
#line 16753 "preproc.y"
                { fputs("/* exec sql begin declare section */", base_yyout); }
#line 61944 "preproc.c"
    break;

  case 3077: /* ECPGDeclaration: sql_startdeclare $@2 var_type_declarations sql_enddeclare  */
#line 16755 "preproc.y"
                {
			fprintf(base_yyout, "%s/* exec sql end declare section */", (yyvsp[-1].str));
			free((yyvsp[-1].str));
			output_line_number();
		}
#line 61954 "preproc.c"
    break;

  case 3078: /* sql_startdeclare: ecpgstart BEGIN_P DECLARE SQL_SECTION ';'  */
#line 16762 "preproc.y"
                                                            {}
#line 61960 "preproc.c"
    break;

  case 3079: /* sql_enddeclare: ecpgstart END_P DECLARE SQL_SECTION ';'  */
#line 16764 "preproc.y"
                                                        {}
#line 61966 "preproc.c"
    break;

  case 3080: /* var_type_declarations: %empty  */
#line 16766 "preproc.y"
                                                        { (yyval.str) = EMPTY; }
#line 61972 "preproc.c"
    break;

  case 3081: /* var_type_declarations: vt_declarations  */
#line 16767 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 61978 "preproc.c"
    break;

  case 3082: /* vt_declarations: single_vt_declaration  */
#line 16770 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 61984 "preproc.c"
    break;

  case 3083: /* vt_declarations: CPP_LINE  */
#line 16771 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 61990 "preproc.c"
    break;

  case 3084: /* vt_declarations: vt_declarations single_vt_declaration  */
#line 16772 "preproc.y"
                                                        { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 61996 "preproc.c"
    break;

  case 3085: /* vt_declarations: vt_declarations CPP_LINE  */
#line 16773 "preproc.y"
                                                        { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 62002 "preproc.c"
    break;

  case 3086: /* variable_declarations: var_declaration  */
#line 16776 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62008 "preproc.c"
    break;

  case 3087: /* variable_declarations: variable_declarations var_declaration  */
#line 16777 "preproc.y"
                                                        { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 62014 "preproc.c"
    break;

  case 3088: /* $@3: %empty  */
#line 16781 "preproc.y"
        {
		/* reset this variable so we see if there was */
		/* an initializer specified */
		initializer = 0;
	}
#line 62024 "preproc.c"
    break;

  case 3089: /* type_declaration: S_TYPEDEF $@3 var_type opt_pointer ECPGColLabelCommon opt_array_bounds ';'  */
#line 16787 "preproc.y"
        {
		add_typedef((yyvsp[-2].str), (yyvsp[-1].index).index1, (yyvsp[-1].index).index2, (yyvsp[-4].type).type_enum, (yyvsp[-4].type).type_dimension, (yyvsp[-4].type).type_index, initializer, *(yyvsp[-3].str) ? 1 : 0);

		fprintf(base_yyout, "typedef %s %s %s %s;\n", (yyvsp[-4].type).type_str, *(yyvsp[-3].str) ? "*" : "", (yyvsp[-2].str), (yyvsp[-1].index).str);
		output_line_number();
		(yyval.str) = mm_strdup("");
	}
#line 62036 "preproc.c"
    break;

  case 3090: /* $@4: %empty  */
#line 16797 "preproc.y"
                {
			actual_type[struct_level].type_enum = (yyvsp[0].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[0].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[0].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[0].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[0].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		}
#line 62050 "preproc.c"
    break;

  case 3091: /* var_declaration: storage_declaration var_type $@4 variable_list ';'  */
#line 16807 "preproc.y"
                {
			(yyval.str) = cat_str(5, actual_startline[struct_level], (yyvsp[-4].str), (yyvsp[-3].type).type_str, (yyvsp[-1].str), mm_strdup(";\n"));
		}
#line 62058 "preproc.c"
    break;

  case 3092: /* $@5: %empty  */
#line 16811 "preproc.y"
                {
			actual_type[struct_level].type_enum = (yyvsp[0].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[0].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[0].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[0].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[0].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		}
#line 62072 "preproc.c"
    break;

  case 3093: /* var_declaration: var_type $@5 variable_list ';'  */
#line 16821 "preproc.y"
                {
			(yyval.str) = cat_str(4, actual_startline[struct_level], (yyvsp[-3].type).type_str, (yyvsp[-1].str), mm_strdup(";\n"));
		}
#line 62080 "preproc.c"
    break;

  case 3094: /* var_declaration: struct_union_type_with_symbol ';'  */
#line 16825 "preproc.y"
                {
			(yyval.str) = cat2_str((yyvsp[-1].str), mm_strdup(";"));
		}
#line 62088 "preproc.c"
    break;

  case 3095: /* opt_bit_field: ':' Iconst  */
#line 16830 "preproc.y"
                                { (yyval.str) =cat2_str(mm_strdup(":"), (yyvsp[0].str)); }
#line 62094 "preproc.c"
    break;

  case 3096: /* opt_bit_field: %empty  */
#line 16831 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 62100 "preproc.c"
    break;

  case 3097: /* storage_declaration: storage_clause storage_modifier  */
#line 16835 "preproc.y"
                        {(yyval.str) = cat2_str ((yyvsp[-1].str), (yyvsp[0].str)); }
#line 62106 "preproc.c"
    break;

  case 3098: /* storage_declaration: storage_clause  */
#line 16836 "preproc.y"
                                                {(yyval.str) = (yyvsp[0].str); }
#line 62112 "preproc.c"
    break;

  case 3099: /* storage_declaration: storage_modifier  */
#line 16837 "preproc.y"
                                                {(yyval.str) = (yyvsp[0].str); }
#line 62118 "preproc.c"
    break;

  case 3100: /* storage_clause: S_EXTERN  */
#line 16840 "preproc.y"
                                { (yyval.str) = mm_strdup("extern"); }
#line 62124 "preproc.c"
    break;

  case 3101: /* storage_clause: S_STATIC  */
#line 16841 "preproc.y"
                                                { (yyval.str) = mm_strdup("static"); }
#line 62130 "preproc.c"
    break;

  case 3102: /* storage_clause: S_REGISTER  */
#line 16842 "preproc.y"
                                        { (yyval.str) = mm_strdup("register"); }
#line 62136 "preproc.c"
    break;

  case 3103: /* storage_clause: S_AUTO  */
#line 16843 "preproc.y"
                                                { (yyval.str) = mm_strdup("auto"); }
#line 62142 "preproc.c"
    break;

  case 3104: /* storage_modifier: S_CONST  */
#line 16846 "preproc.y"
                                { (yyval.str) = mm_strdup("const"); }
#line 62148 "preproc.c"
    break;

  case 3105: /* storage_modifier: S_VOLATILE  */
#line 16847 "preproc.y"
                                        { (yyval.str) = mm_strdup("volatile"); }
#line 62154 "preproc.c"
    break;

  case 3106: /* var_type: simple_type  */
#line 16851 "preproc.y"
                {
			(yyval.type).type_enum = (yyvsp[0].type_enum);
			(yyval.type).type_str = mm_strdup(ecpg_type_name((yyvsp[0].type_enum)));
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 62166 "preproc.c"
    break;

  case 3107: /* var_type: struct_union_type  */
#line 16859 "preproc.y"
                {
			(yyval.type).type_str = (yyvsp[0].str);
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");

			if (strncmp((yyvsp[0].str), "struct", sizeof("struct")-1) == 0)
			{
				(yyval.type).type_enum = ECPGt_struct;
				(yyval.type).type_sizeof = ECPGstruct_sizeof;
			}
			else
			{
				(yyval.type).type_enum = ECPGt_union;
				(yyval.type).type_sizeof = NULL;
			}
		}
#line 62187 "preproc.c"
    break;

  case 3108: /* var_type: enum_type  */
#line 16876 "preproc.y"
                {
			(yyval.type).type_str = (yyvsp[0].str);
			(yyval.type).type_enum = ECPGt_int;
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 62199 "preproc.c"
    break;

  case 3109: /* var_type: ECPGColLabelCommon '(' precision opt_scale ')'  */
#line 16884 "preproc.y"
                {
			if (strcmp((yyvsp[-4].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
			}
			else if (strcmp((yyvsp[-4].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = mm_strdup("decimal");
			}
			else
			{
				mmerror(PARSE_ERROR, ET_ERROR, "only data types numeric and decimal have precision/scale argument");
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
			}

			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 62226 "preproc.c"
    break;

  case 3110: /* var_type: ECPGColLabelCommon ecpg_interval  */
#line 16907 "preproc.y"
                {
			if (strlen((yyvsp[0].str)) != 0 && strcmp ((yyvsp[-1].str), "datetime") != 0 && strcmp ((yyvsp[-1].str), "interval") != 0)
				mmerror (PARSE_ERROR, ET_ERROR, "interval specification not allowed here");

			/*
			 * Check for type names that the SQL grammar treats as
			 * unreserved keywords
			 */
			if (strcmp((yyvsp[-1].str), "varchar") == 0)
			{
				(yyval.type).type_enum = ECPGt_varchar;
				(yyval.type).type_str = EMPTY; /*mm_strdup("varchar");*/
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "float") == 0)
			{
				(yyval.type).type_enum = ECPGt_float;
				(yyval.type).type_str = mm_strdup("float");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "double") == 0)
			{
				(yyval.type).type_enum = ECPGt_double;
				(yyval.type).type_str = mm_strdup("double");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = mm_strdup("decimal");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "date") == 0)
			{
				(yyval.type).type_enum = ECPGt_date;
				(yyval.type).type_str = mm_strdup("date");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "timestamp") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = mm_strdup("timestamp");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "interval") == 0)
			{
				(yyval.type).type_enum = ECPGt_interval;
				(yyval.type).type_str = mm_strdup("interval");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "datetime") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = mm_strdup("timestamp");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if ((strcmp((yyvsp[-1].str), "string") == 0) && INFORMIX_MODE)
			{
				(yyval.type).type_enum = ECPGt_string;
				(yyval.type).type_str = mm_strdup("char");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else
			{
				/* this is for typedef'ed types */
				struct typedefs *this = get_typedef((yyvsp[-1].str));

				(yyval.type).type_str = (this->type->type_enum == ECPGt_varchar) ? EMPTY : mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				if (this->type->type_sizeof && strlen(this->type->type_sizeof) != 0)
					(yyval.type).type_sizeof = this->type->type_sizeof;
				else
					(yyval.type).type_sizeof = cat_str(3, mm_strdup("sizeof("), mm_strdup(this->name), mm_strdup(")"));

				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
			}
		}
#line 62336 "preproc.c"
    break;

  case 3111: /* var_type: s_struct_union_symbol  */
#line 17013 "preproc.y"
                {
			/* this is for named structs/unions */
			char *name;
			struct typedefs *this;
			bool forward = (forward_name != NULL && strcmp((yyvsp[0].struct_union).symbol, forward_name) == 0 && strcmp((yyvsp[0].struct_union).su, "struct") == 0);

			name = cat2_str((yyvsp[0].struct_union).su, (yyvsp[0].struct_union).symbol);
			/* Do we have a forward definition? */
			if (!forward)
			{
				/* No */

				this = get_typedef(name);
				(yyval.type).type_str = mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				(yyval.type).type_sizeof = this->type->type_sizeof;
				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
				free(name);
			}
			else
			{
				(yyval.type).type_str = name;
				(yyval.type).type_enum = ECPGt_long;
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = mm_strdup("");
				struct_member_list[struct_level] = NULL;
			}
		}
#line 62372 "preproc.c"
    break;

  case 3112: /* enum_type: ENUM_P symbol enum_definition  */
#line 17047 "preproc.y"
                        { (yyval.str) = cat_str(3, mm_strdup("enum"), (yyvsp[-1].str), (yyvsp[0].str)); }
#line 62378 "preproc.c"
    break;

  case 3113: /* enum_type: ENUM_P enum_definition  */
#line 17049 "preproc.y"
                        { (yyval.str) = cat2_str(mm_strdup("enum"), (yyvsp[0].str)); }
#line 62384 "preproc.c"
    break;

  case 3114: /* enum_type: ENUM_P symbol  */
#line 17051 "preproc.y"
                        { (yyval.str) = cat2_str(mm_strdup("enum"), (yyvsp[0].str)); }
#line 62390 "preproc.c"
    break;

  case 3115: /* enum_definition: '{' c_list '}'  */
#line 17055 "preproc.y"
                        { (yyval.str) = cat_str(3, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}")); }
#line 62396 "preproc.c"
    break;

  case 3116: /* $@6: %empty  */
#line 17058 "preproc.y"
                {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
			forward_name = mm_strdup((yyvsp[0].struct_union).symbol);
		}
#line 62407 "preproc.c"
    break;

  case 3117: /* struct_union_type_with_symbol: s_struct_union_symbol $@6 '{' variable_declarations '}'  */
#line 17065 "preproc.y"
                {
			struct typedefs *ptr, *this;
			struct this_type su_type;

			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			if (strncmp((yyvsp[-4].struct_union).su, "struct", sizeof("struct")-1) == 0)
				su_type.type_enum = ECPGt_struct;
			else
				su_type.type_enum = ECPGt_union;
			su_type.type_str = cat2_str((yyvsp[-4].struct_union).su, (yyvsp[-4].struct_union).symbol);
			free(forward_name);
			forward_name = NULL;

			/* This is essentially a typedef but needs the keyword struct/union as well.
			 * So we create the typedef for each struct definition with symbol */
			for (ptr = types; ptr != NULL; ptr = ptr->next)
			{
					if (strcmp(su_type.type_str, ptr->name) == 0)
							/* re-definition is a bug */
							mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", su_type.type_str);
			}

			this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

			/* initial definition */
			this->next = types;
			this->name = mm_strdup(su_type.type_str);
			this->brace_level = braces_open;
			this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
			this->type->type_enum = su_type.type_enum;
			this->type->type_str = mm_strdup(su_type.type_str);
			this->type->type_dimension = mm_strdup("-1"); /* dimension of array */
			this->type->type_index = mm_strdup("-1");	/* length of string */
			this->type->type_sizeof = ECPGstruct_sizeof;
			this->struct_member_list = struct_member_list[struct_level];

			types = this;
			(yyval.str) = cat_str(4, su_type.type_str, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}"));
		}
#line 62453 "preproc.c"
    break;

  case 3118: /* struct_union_type: struct_union_type_with_symbol  */
#line 17108 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62459 "preproc.c"
    break;

  case 3119: /* $@7: %empty  */
#line 17110 "preproc.y"
                {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
		}
#line 62469 "preproc.c"
    break;

  case 3120: /* struct_union_type: s_struct_union $@7 '{' variable_declarations '}'  */
#line 17116 "preproc.y"
                {
			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			(yyval.str) = cat_str(4, (yyvsp[-4].str), mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}"));
		}
#line 62480 "preproc.c"
    break;

  case 3121: /* s_struct_union_symbol: SQL_STRUCT symbol  */
#line 17125 "preproc.y"
                {
			(yyval.struct_union).su = mm_strdup("struct");
			(yyval.struct_union).symbol = (yyvsp[0].str);
			ECPGstruct_sizeof = cat_str(3, mm_strdup("sizeof("), cat2_str(mm_strdup((yyval.struct_union).su), mm_strdup((yyval.struct_union).symbol)), mm_strdup(")"));
		}
#line 62490 "preproc.c"
    break;

  case 3122: /* s_struct_union_symbol: UNION symbol  */
#line 17131 "preproc.y"
                {
			(yyval.struct_union).su = mm_strdup("union");
			(yyval.struct_union).symbol = (yyvsp[0].str);
		}
#line 62499 "preproc.c"
    break;

  case 3123: /* s_struct_union: SQL_STRUCT  */
#line 17138 "preproc.y"
                {
			ECPGstruct_sizeof = mm_strdup(""); /* This must not be NULL to distinguish from simple types. */
			(yyval.str) = mm_strdup("struct");
		}
#line 62508 "preproc.c"
    break;

  case 3124: /* s_struct_union: UNION  */
#line 17143 "preproc.y"
                {
			(yyval.str) = mm_strdup("union");
		}
#line 62516 "preproc.c"
    break;

  case 3125: /* simple_type: unsigned_type  */
#line 17148 "preproc.y"
                                                                { (yyval.type_enum)=(yyvsp[0].type_enum); }
#line 62522 "preproc.c"
    break;

  case 3126: /* simple_type: opt_signed signed_type  */
#line 17149 "preproc.y"
                                                                { (yyval.type_enum)=(yyvsp[0].type_enum); }
#line 62528 "preproc.c"
    break;

  case 3127: /* unsigned_type: SQL_UNSIGNED SQL_SHORT  */
#line 17152 "preproc.y"
                                                { (yyval.type_enum) = ECPGt_unsigned_short; }
#line 62534 "preproc.c"
    break;

  case 3128: /* unsigned_type: SQL_UNSIGNED SQL_SHORT INT_P  */
#line 17153 "preproc.y"
                                                { (yyval.type_enum) = ECPGt_unsigned_short; }
#line 62540 "preproc.c"
    break;

  case 3129: /* unsigned_type: SQL_UNSIGNED  */
#line 17154 "preproc.y"
                                                                        { (yyval.type_enum) = ECPGt_unsigned_int; }
#line 62546 "preproc.c"
    break;

  case 3130: /* unsigned_type: SQL_UNSIGNED INT_P  */
#line 17155 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_unsigned_int; }
#line 62552 "preproc.c"
    break;

  case 3131: /* unsigned_type: SQL_UNSIGNED SQL_LONG  */
#line 17156 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_unsigned_long; }
#line 62558 "preproc.c"
    break;

  case 3132: /* unsigned_type: SQL_UNSIGNED SQL_LONG INT_P  */
#line 17157 "preproc.y"
                                                        { (yyval.type_enum) = ECPGt_unsigned_long; }
#line 62564 "preproc.c"
    break;

  case 3133: /* unsigned_type: SQL_UNSIGNED SQL_LONG SQL_LONG  */
#line 17159 "preproc.y"
                {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		}
#line 62576 "preproc.c"
    break;

  case 3134: /* unsigned_type: SQL_UNSIGNED SQL_LONG SQL_LONG INT_P  */
#line 17167 "preproc.y"
                {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		}
#line 62588 "preproc.c"
    break;

  case 3135: /* unsigned_type: SQL_UNSIGNED CHAR_P  */
#line 17174 "preproc.y"
                                                        { (yyval.type_enum) = ECPGt_unsigned_char; }
#line 62594 "preproc.c"
    break;

  case 3136: /* signed_type: SQL_SHORT  */
#line 17177 "preproc.y"
                                                { (yyval.type_enum) = ECPGt_short; }
#line 62600 "preproc.c"
    break;

  case 3137: /* signed_type: SQL_SHORT INT_P  */
#line 17178 "preproc.y"
                                                        { (yyval.type_enum) = ECPGt_short; }
#line 62606 "preproc.c"
    break;

  case 3138: /* signed_type: INT_P  */
#line 17179 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_int; }
#line 62612 "preproc.c"
    break;

  case 3139: /* signed_type: SQL_LONG  */
#line 17180 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_long; }
#line 62618 "preproc.c"
    break;

  case 3140: /* signed_type: SQL_LONG INT_P  */
#line 17181 "preproc.y"
                                                        { (yyval.type_enum) = ECPGt_long; }
#line 62624 "preproc.c"
    break;

  case 3141: /* signed_type: SQL_LONG SQL_LONG  */
#line 17183 "preproc.y"
                {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		}
#line 62636 "preproc.c"
    break;

  case 3142: /* signed_type: SQL_LONG SQL_LONG INT_P  */
#line 17191 "preproc.y"
                {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		}
#line 62648 "preproc.c"
    break;

  case 3143: /* signed_type: SQL_BOOL  */
#line 17198 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_bool; }
#line 62654 "preproc.c"
    break;

  case 3144: /* signed_type: CHAR_P  */
#line 17199 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_char; }
#line 62660 "preproc.c"
    break;

  case 3145: /* signed_type: DOUBLE_P  */
#line 17200 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_double; }
#line 62666 "preproc.c"
    break;

  case 3148: /* variable_list: variable  */
#line 17208 "preproc.y"
                        { (yyval.str) = (yyvsp[0].str); }
#line 62672 "preproc.c"
    break;

  case 3149: /* variable_list: variable_list ',' variable  */
#line 17210 "preproc.y"
                {
			if (actual_type[struct_level].type_enum == ECPGt_varchar)
				(yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(";"), (yyvsp[0].str));
			else
				(yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str));
		}
#line 62683 "preproc.c"
    break;

  case 3150: /* variable: opt_pointer ECPGColLabel opt_array_bounds opt_bit_field opt_initializer  */
#line 17219 "preproc.y"
                {
			struct ECPGtype * type;
			char *dimension = (yyvsp[-2].index).index1;	/* dimension of array */
			char *length = (yyvsp[-2].index).index2;		/* length of string */
			char *dim_str;
			char *vcn;

			adjust_array(actual_type[struct_level].type_enum, &dimension, &length, actual_type[struct_level].type_dimension, actual_type[struct_level].type_index, strlen((yyvsp[-4].str)), false);

			switch (actual_type[struct_level].type_enum)
			{
				case ECPGt_struct:
				case ECPGt_union:
					if (atoi(dimension) < 0)
						type = ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof);
					else
						type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;

				case ECPGt_varchar:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter), dimension);

					if (strcmp(dimension, "0") == 0 || abs(atoi(dimension)) == 1)
							dim_str=mm_strdup("");
					else
							dim_str=cat_str(3, mm_strdup("["), mm_strdup(dimension), mm_strdup("]"));
					/* cannot check for atoi <= 0 because a defined constant will yield 0 here as well */
					if (atoi(length) < 0 || strcmp(length, "0") == 0)
						mmerror(PARSE_ERROR, ET_ERROR, "pointers to varchar are not implemented");

					/* make sure varchar struct name is unique by adding a unique counter to its definition */
					vcn = (char *) mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
					sprintf(vcn, "%d", varchar_counter);
					if (strcmp(dimension, "0") == 0)
						(yyval.str) = cat_str(7, make2_str(mm_strdup(" struct varchar_"), vcn), mm_strdup(" { int len; char arr["), mm_strdup(length), mm_strdup("]; } *"), mm_strdup((yyvsp[-3].str)), (yyvsp[-1].str), (yyvsp[0].str));
					else
						(yyval.str) = cat_str(8, make2_str(mm_strdup(" struct varchar_"), vcn), mm_strdup(" { int len; char arr["), mm_strdup(length), mm_strdup("]; } "), mm_strdup((yyvsp[-3].str)), dim_str, (yyvsp[-1].str), (yyvsp[0].str));
					varchar_counter++;
					break;

				case ECPGt_char:
				case ECPGt_unsigned_char:
				case ECPGt_string:
					if (atoi(dimension) == -1)
					{
						int i = strlen((yyvsp[0].str));

						if (atoi(length) == -1 && i > 0) /* char <var>[] = "string" */
						{
							/* if we have an initializer but no string size set, let's use the initializer's length */
							free(length);
							length = mm_alloc(i+sizeof("sizeof()"));
							sprintf(length, "sizeof(%s)", (yyvsp[0].str)+2);
						}
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0);
					}
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;

				default:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, mm_strdup("1"), 0);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, mm_strdup("1"), 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;
			}

			if (struct_level == 0)
				new_variable((yyvsp[-3].str), type, braces_open);
			else
				ECPGmake_struct_member((yyvsp[-3].str), type, &(struct_member_list[struct_level - 1]));

			free((yyvsp[-3].str));
		}
#line 62772 "preproc.c"
    break;

  case 3151: /* opt_initializer: %empty  */
#line 17306 "preproc.y"
                        { (yyval.str) = EMPTY; }
#line 62778 "preproc.c"
    break;

  case 3152: /* opt_initializer: '=' c_term  */
#line 17308 "preproc.y"
                {
			initializer = 1;
			(yyval.str) = cat2_str(mm_strdup("="), (yyvsp[0].str));
		}
#line 62787 "preproc.c"
    break;

  case 3153: /* opt_pointer: %empty  */
#line 17314 "preproc.y"
                                                { (yyval.str) = EMPTY; }
#line 62793 "preproc.c"
    break;

  case 3154: /* opt_pointer: '*'  */
#line 17315 "preproc.y"
                                                                { (yyval.str) = mm_strdup("*"); }
#line 62799 "preproc.c"
    break;

  case 3155: /* opt_pointer: '*' '*'  */
#line 17316 "preproc.y"
                                                                { (yyval.str) = mm_strdup("**"); }
#line 62805 "preproc.c"
    break;

  case 3156: /* ECPGDeclare: DECLARE STATEMENT ecpg_ident  */
#line 17323 "preproc.y"
                {
			/* this is only supported for compatibility */
			(yyval.str) = cat_str(3, mm_strdup("/* declare statement"), (yyvsp[0].str), mm_strdup("*/"));
		}
#line 62814 "preproc.c"
    break;

  case 3157: /* ECPGDisconnect: SQL_DISCONNECT dis_name  */
#line 17331 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62820 "preproc.c"
    break;

  case 3158: /* dis_name: connection_object  */
#line 17334 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62826 "preproc.c"
    break;

  case 3159: /* dis_name: CURRENT_P  */
#line 17335 "preproc.y"
                                                { (yyval.str) = mm_strdup("\"CURRENT\""); }
#line 62832 "preproc.c"
    break;

  case 3160: /* dis_name: ALL  */
#line 17336 "preproc.y"
                                                { (yyval.str) = mm_strdup("\"ALL\""); }
#line 62838 "preproc.c"
    break;

  case 3161: /* dis_name: %empty  */
#line 17337 "preproc.y"
                                                { (yyval.str) = mm_strdup("\"CURRENT\""); }
#line 62844 "preproc.c"
    break;

  case 3162: /* connection_object: database_name  */
#line 17340 "preproc.y"
                                                { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 62850 "preproc.c"
    break;

  case 3163: /* connection_object: DEFAULT  */
#line 17341 "preproc.y"
                                                { (yyval.str) = mm_strdup("\"DEFAULT\""); }
#line 62856 "preproc.c"
    break;

  case 3164: /* connection_object: char_variable  */
#line 17342 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62862 "preproc.c"
    break;

  case 3165: /* execstring: char_variable  */
#line 17346 "preproc.y"
                        { (yyval.str) = (yyvsp[0].str); }
#line 62868 "preproc.c"
    break;

  case 3166: /* execstring: CSTRING  */
#line 17348 "preproc.y"
                        { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 62874 "preproc.c"
    break;

  case 3167: /* ECPGFree: SQL_FREE cursor_name  */
#line 17355 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62880 "preproc.c"
    break;

  case 3168: /* ECPGFree: SQL_FREE ALL  */
#line 17356 "preproc.y"
                                { (yyval.str) = mm_strdup("all"); }
#line 62886 "preproc.c"
    break;

  case 3169: /* ECPGOpen: SQL_OPEN cursor_name opt_ecpg_using  */
#line 17363 "preproc.y"
                {
			if ((yyvsp[-1].str)[0] == ':')
				remove_variable_from_list(&argsinsert, find_variable((yyvsp[-1].str) + 1));
			(yyval.str) = (yyvsp[-1].str);
		}
#line 62896 "preproc.c"
    break;

  case 3170: /* opt_ecpg_using: %empty  */
#line 17370 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 62902 "preproc.c"
    break;

  case 3171: /* opt_ecpg_using: ecpg_using  */
#line 17371 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62908 "preproc.c"
    break;

  case 3172: /* ecpg_using: USING using_list  */
#line 17374 "preproc.y"
                                        { (yyval.str) = EMPTY; }
#line 62914 "preproc.c"
    break;

  case 3173: /* ecpg_using: using_descriptor  */
#line 17375 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62920 "preproc.c"
    break;

  case 3174: /* using_descriptor: USING SQL_P SQL_DESCRIPTOR quoted_ident_stringvar  */
#line 17379 "preproc.y"
                {
			add_variable_to_head(&argsinsert, descriptor_variable((yyvsp[0].str),0), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 62929 "preproc.c"
    break;

  case 3175: /* using_descriptor: USING SQL_DESCRIPTOR name  */
#line 17384 "preproc.y"
                {
			add_variable_to_head(&argsinsert, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 62938 "preproc.c"
    break;

  case 3176: /* into_descriptor: INTO SQL_P SQL_DESCRIPTOR quoted_ident_stringvar  */
#line 17391 "preproc.y"
                {
			add_variable_to_head(&argsresult, descriptor_variable((yyvsp[0].str),1), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 62947 "preproc.c"
    break;

  case 3177: /* into_descriptor: INTO SQL_DESCRIPTOR name  */
#line 17396 "preproc.y"
                {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 62956 "preproc.c"
    break;

  case 3178: /* into_sqlda: INTO name  */
#line 17403 "preproc.y"
                {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 62965 "preproc.c"
    break;

  case 3181: /* UsingValue: UsingConst  */
#line 17412 "preproc.y"
                {
			char *length = mm_alloc(32);

			sprintf(length, "%d", (int) strlen((yyvsp[0].str)));
			add_variable_to_head(&argsinsert, new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0), &no_indicator);
		}
#line 62976 "preproc.c"
    break;

  case 3182: /* UsingValue: civar  */
#line 17418 "preproc.y"
                        { (yyval.str) = EMPTY; }
#line 62982 "preproc.c"
    break;

  case 3183: /* UsingValue: civarind  */
#line 17419 "preproc.y"
                           { (yyval.str) = EMPTY; }
#line 62988 "preproc.c"
    break;

  case 3184: /* UsingConst: Iconst  */
#line 17422 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62994 "preproc.c"
    break;

  case 3185: /* UsingConst: '+' Iconst  */
#line 17423 "preproc.y"
                                        { (yyval.str) = cat_str(2, mm_strdup("+"), (yyvsp[0].str)); }
#line 63000 "preproc.c"
    break;

  case 3186: /* UsingConst: '-' Iconst  */
#line 17424 "preproc.y"
                                        { (yyval.str) = cat_str(2, mm_strdup("-"), (yyvsp[0].str)); }
#line 63006 "preproc.c"
    break;

  case 3187: /* UsingConst: ecpg_fconst  */
#line 17425 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63012 "preproc.c"
    break;

  case 3188: /* UsingConst: '+' ecpg_fconst  */
#line 17426 "preproc.y"
                                        { (yyval.str) = cat_str(2, mm_strdup("+"), (yyvsp[0].str)); }
#line 63018 "preproc.c"
    break;

  case 3189: /* UsingConst: '-' ecpg_fconst  */
#line 17427 "preproc.y"
                                        { (yyval.str) = cat_str(2, mm_strdup("-"), (yyvsp[0].str)); }
#line 63024 "preproc.c"
    break;

  case 3190: /* UsingConst: ecpg_sconst  */
#line 17428 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63030 "preproc.c"
    break;

  case 3191: /* UsingConst: ecpg_bconst  */
#line 17429 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63036 "preproc.c"
    break;

  case 3192: /* UsingConst: ecpg_xconst  */
#line 17430 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63042 "preproc.c"
    break;

  case 3193: /* ECPGDescribe: SQL_DESCRIBE INPUT_P prepared_name using_descriptor  */
#line 17437 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[-1].str));
	}
#line 63053 "preproc.c"
    break;

  case 3194: /* ECPGDescribe: SQL_DESCRIBE opt_output prepared_name using_descriptor  */
#line 17444 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);

		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 63069 "preproc.c"
    break;

  case 3195: /* ECPGDescribe: SQL_DESCRIBE opt_output prepared_name into_descriptor  */
#line 17456 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 63079 "preproc.c"
    break;

  case 3196: /* ECPGDescribe: SQL_DESCRIBE INPUT_P prepared_name into_sqlda  */
#line 17462 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[-1].str));
	}
#line 63090 "preproc.c"
    break;

  case 3197: /* ECPGDescribe: SQL_DESCRIBE opt_output prepared_name into_sqlda  */
#line 17469 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 63100 "preproc.c"
    break;

  case 3198: /* opt_output: SQL_OUTPUT  */
#line 17476 "preproc.y"
                                { (yyval.str) = mm_strdup("output"); }
#line 63106 "preproc.c"
    break;

  case 3199: /* opt_output: %empty  */
#line 17477 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 63112 "preproc.c"
    break;

  case 3200: /* ECPGAllocateDescr: SQL_ALLOCATE SQL_DESCRIPTOR quoted_ident_stringvar  */
#line 17490 "preproc.y"
                {
			add_descriptor((yyvsp[0].str),connection);
			(yyval.str) = (yyvsp[0].str);
		}
#line 63121 "preproc.c"
    break;

  case 3201: /* ECPGDeallocateDescr: DEALLOCATE SQL_DESCRIPTOR quoted_ident_stringvar  */
#line 17501 "preproc.y"
                {
			drop_descriptor((yyvsp[0].str),connection);
			(yyval.str) = (yyvsp[0].str);
		}
#line 63130 "preproc.c"
    break;

  case 3202: /* ECPGGetDescriptorHeader: SQL_GET SQL_DESCRIPTOR quoted_ident_stringvar ECPGGetDescHeaderItems  */
#line 17512 "preproc.y"
                        {  (yyval.str) = (yyvsp[-1].str); }
#line 63136 "preproc.c"
    break;

  case 3205: /* ECPGGetDescHeaderItem: cvariable '=' desc_header_item  */
#line 17520 "preproc.y"
                        { push_assignment((yyvsp[-2].str), (yyvsp[0].dtype_enum)); }
#line 63142 "preproc.c"
    break;

  case 3206: /* ECPGSetDescriptorHeader: SET SQL_DESCRIPTOR quoted_ident_stringvar ECPGSetDescHeaderItems  */
#line 17525 "preproc.y"
                        { (yyval.str) = (yyvsp[-1].str); }
#line 63148 "preproc.c"
    break;

  case 3209: /* ECPGSetDescHeaderItem: desc_header_item '=' IntConstVar  */
#line 17533 "preproc.y"
                {
			push_assignment((yyvsp[0].str), (yyvsp[-2].dtype_enum));
		}
#line 63156 "preproc.c"
    break;

  case 3210: /* IntConstVar: Iconst  */
#line 17539 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

			sprintf(length, "%d", (int) strlen((yyvsp[0].str)));
			new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = (yyvsp[0].str);
		}
#line 63168 "preproc.c"
    break;

  case 3211: /* IntConstVar: cvariable  */
#line 17547 "preproc.y"
                {
			(yyval.str) = (yyvsp[0].str);
		}
#line 63176 "preproc.c"
    break;

  case 3212: /* desc_header_item: SQL_COUNT  */
#line 17552 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_count; }
#line 63182 "preproc.c"
    break;

  case 3213: /* ECPGGetDescriptor: SQL_GET SQL_DESCRIPTOR quoted_ident_stringvar VALUE_P IntConstVar ECPGGetDescItems  */
#line 17560 "preproc.y"
                        {  (yyval.descriptor).str = (yyvsp[-1].str); (yyval.descriptor).name = (yyvsp[-3].str); }
#line 63188 "preproc.c"
    break;

  case 3216: /* ECPGGetDescItem: cvariable '=' descriptor_item  */
#line 17567 "preproc.y"
                                                { push_assignment((yyvsp[-2].str), (yyvsp[0].dtype_enum)); }
#line 63194 "preproc.c"
    break;

  case 3217: /* ECPGSetDescriptor: SET SQL_DESCRIPTOR quoted_ident_stringvar VALUE_P IntConstVar ECPGSetDescItems  */
#line 17571 "preproc.y"
                        {  (yyval.descriptor).str = (yyvsp[-1].str); (yyval.descriptor).name = (yyvsp[-3].str); }
#line 63200 "preproc.c"
    break;

  case 3220: /* ECPGSetDescItem: descriptor_item '=' AllConstVar  */
#line 17579 "preproc.y"
                {
			push_assignment((yyvsp[0].str), (yyvsp[-2].dtype_enum));
		}
#line 63208 "preproc.c"
    break;

  case 3221: /* AllConstVar: ecpg_fconst  */
#line 17585 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

			sprintf(length, "%d", (int) strlen((yyvsp[0].str)));
			new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = (yyvsp[0].str);
		}
#line 63220 "preproc.c"
    break;

  case 3222: /* AllConstVar: IntConstVar  */
#line 17594 "preproc.y"
                {
			(yyval.str) = (yyvsp[0].str);
		}
#line 63228 "preproc.c"
    break;

  case 3223: /* AllConstVar: '-' ecpg_fconst  */
#line 17599 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = cat2_str(mm_strdup("-"), (yyvsp[0].str));

			sprintf(length, "%d", (int) strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 63241 "preproc.c"
    break;

  case 3224: /* AllConstVar: '-' Iconst  */
#line 17609 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = cat2_str(mm_strdup("-"), (yyvsp[0].str));

			sprintf(length, "%d", (int) strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 63254 "preproc.c"
    break;

  case 3225: /* AllConstVar: ecpg_sconst  */
#line 17619 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = (yyvsp[0].str) + 1;

			var[strlen(var) - 1] = '\0';
			sprintf(length, "%d", (int) strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 63268 "preproc.c"
    break;

  case 3226: /* descriptor_item: SQL_CARDINALITY  */
#line 17630 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_cardinality; }
#line 63274 "preproc.c"
    break;

  case 3227: /* descriptor_item: DATA_P  */
#line 17631 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_data; }
#line 63280 "preproc.c"
    break;

  case 3228: /* descriptor_item: SQL_DATETIME_INTERVAL_CODE  */
#line 17632 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_di_code; }
#line 63286 "preproc.c"
    break;

  case 3229: /* descriptor_item: SQL_DATETIME_INTERVAL_PRECISION  */
#line 17633 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_di_precision; }
#line 63292 "preproc.c"
    break;

  case 3230: /* descriptor_item: SQL_INDICATOR  */
#line 17634 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_indicator; }
#line 63298 "preproc.c"
    break;

  case 3231: /* descriptor_item: SQL_KEY_MEMBER  */
#line 17635 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_key_member; }
#line 63304 "preproc.c"
    break;

  case 3232: /* descriptor_item: SQL_LENGTH  */
#line 17636 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_length; }
#line 63310 "preproc.c"
    break;

  case 3233: /* descriptor_item: NAME_P  */
#line 17637 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_name; }
#line 63316 "preproc.c"
    break;

  case 3234: /* descriptor_item: SQL_NULLABLE  */
#line 17638 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_nullable; }
#line 63322 "preproc.c"
    break;

  case 3235: /* descriptor_item: SQL_OCTET_LENGTH  */
#line 17639 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_octet; }
#line 63328 "preproc.c"
    break;

  case 3236: /* descriptor_item: PRECISION  */
#line 17640 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_precision; }
#line 63334 "preproc.c"
    break;

  case 3237: /* descriptor_item: SQL_RETURNED_LENGTH  */
#line 17641 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_length; }
#line 63340 "preproc.c"
    break;

  case 3238: /* descriptor_item: SQL_RETURNED_OCTET_LENGTH  */
#line 17642 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_ret_octet; }
#line 63346 "preproc.c"
    break;

  case 3239: /* descriptor_item: SQL_SCALE  */
#line 17643 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_scale; }
#line 63352 "preproc.c"
    break;

  case 3240: /* descriptor_item: TYPE_P  */
#line 17644 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_type; }
#line 63358 "preproc.c"
    break;

  case 3241: /* ECPGSetAutocommit: SET SQL_AUTOCOMMIT '=' on_off  */
#line 17651 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63364 "preproc.c"
    break;

  case 3242: /* ECPGSetAutocommit: SET SQL_AUTOCOMMIT TO on_off  */
#line 17652 "preproc.y"
                                                  { (yyval.str) = (yyvsp[0].str); }
#line 63370 "preproc.c"
    break;

  case 3243: /* on_off: ON  */
#line 17655 "preproc.y"
                                        { (yyval.str) = mm_strdup("on"); }
#line 63376 "preproc.c"
    break;

  case 3244: /* on_off: OFF  */
#line 17656 "preproc.y"
                                        { (yyval.str) = mm_strdup("off"); }
#line 63382 "preproc.c"
    break;

  case 3245: /* ECPGSetConnection: SET CONNECTION TO connection_object  */
#line 17663 "preproc.y"
                                                            { (yyval.str) = (yyvsp[0].str); }
#line 63388 "preproc.c"
    break;

  case 3246: /* ECPGSetConnection: SET CONNECTION '=' connection_object  */
#line 17664 "preproc.y"
                                                       { (yyval.str) = (yyvsp[0].str); }
#line 63394 "preproc.c"
    break;

  case 3247: /* ECPGSetConnection: SET CONNECTION connection_object  */
#line 17665 "preproc.y"
                                                    { (yyval.str) = (yyvsp[0].str); }
#line 63400 "preproc.c"
    break;

  case 3248: /* $@8: %empty  */
#line 17672 "preproc.y"
                {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		}
#line 63410 "preproc.c"
    break;

  case 3249: /* ECPGTypedef: TYPE_P $@8 ECPGColLabelCommon IS var_type opt_array_bounds opt_reference  */
#line 17678 "preproc.y"
                {
			add_typedef((yyvsp[-4].str), (yyvsp[-1].index).index1, (yyvsp[-1].index).index2, (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_dimension, (yyvsp[-2].type).type_index, initializer, *(yyvsp[0].str) ? 1 : 0);

			if (auto_create_c == false)
				(yyval.str) = cat_str(7, mm_strdup("/* exec sql type"), mm_strdup((yyvsp[-4].str)), mm_strdup("is"), mm_strdup((yyvsp[-2].type).type_str), mm_strdup((yyvsp[-1].index).str), (yyvsp[0].str), mm_strdup("*/"));
			else
				(yyval.str) = cat_str(6, mm_strdup("typedef "), mm_strdup((yyvsp[-2].type).type_str), *(yyvsp[0].str)?mm_strdup("*"):mm_strdup(""), mm_strdup((yyvsp[-4].str)), mm_strdup((yyvsp[-1].index).str), mm_strdup(";"));
		}
#line 63423 "preproc.c"
    break;

  case 3250: /* opt_reference: SQL_REFERENCE  */
#line 17688 "preproc.y"
                                        { (yyval.str) = mm_strdup("reference"); }
#line 63429 "preproc.c"
    break;

  case 3251: /* opt_reference: %empty  */
#line 17689 "preproc.y"
                                                                { (yyval.str) = EMPTY; }
#line 63435 "preproc.c"
    break;

  case 3252: /* $@9: %empty  */
#line 17696 "preproc.y"
                {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		}
#line 63445 "preproc.c"
    break;

  case 3253: /* ECPGVar: SQL_VAR $@9 ColLabel IS var_type opt_array_bounds opt_reference  */
#line 17702 "preproc.y"
                {
			struct variable *p = find_variable((yyvsp[-4].str));
			char *dimension = (yyvsp[-1].index).index1;
			char *length = (yyvsp[-1].index).index2;
			struct ECPGtype * type;

			if (((yyvsp[-2].type).type_enum == ECPGt_struct ||
				 (yyvsp[-2].type).type_enum == ECPGt_union) &&
				initializer == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in EXEC SQL VAR command");
			else
			{
				adjust_array((yyvsp[-2].type).type_enum, &dimension, &length, (yyvsp[-2].type).type_dimension, (yyvsp[-2].type).type_index, *(yyvsp[0].str)?1:0, false);

				switch ((yyvsp[-2].type).type_enum)
				{
					case ECPGt_struct:
					case ECPGt_union:
						if (atoi(dimension) < 0)
							type = ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_str, (yyvsp[-2].type).type_sizeof);
						else
							type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_str, (yyvsp[-2].type).type_sizeof), dimension);
						break;

					case ECPGt_varchar:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0), dimension);
						break;

					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0), dimension);
						break;

					default:
						if (atoi(length) >= 0)
							mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

						if (atoi(dimension) < 0)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, mm_strdup("1"), 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, mm_strdup("1"), 0), dimension);
						break;
				}

				ECPGfree_type(p->type);
				p->type = type;
			}

			(yyval.str) = cat_str(7, mm_strdup("/* exec sql var"), mm_strdup((yyvsp[-4].str)), mm_strdup("is"), mm_strdup((yyvsp[-2].type).type_str), mm_strdup((yyvsp[-1].index).str), (yyvsp[0].str), mm_strdup("*/"));
		}
#line 63507 "preproc.c"
    break;

  case 3254: /* ECPGWhenever: SQL_WHENEVER SQL_SQLERROR action  */
#line 17766 "preproc.y"
                {
			when_error.code = (yyvsp[0].action).code;
			when_error.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever sqlerror "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 63517 "preproc.c"
    break;

  case 3255: /* ECPGWhenever: SQL_WHENEVER NOT SQL_FOUND action  */
#line 17772 "preproc.y"
                {
			when_nf.code = (yyvsp[0].action).code;
			when_nf.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever not found "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 63527 "preproc.c"
    break;

  case 3256: /* ECPGWhenever: SQL_WHENEVER SQL_SQLWARNING action  */
#line 17778 "preproc.y"
                {
			when_warn.code = (yyvsp[0].action).code;
			when_warn.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever sql_warning "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 63537 "preproc.c"
    break;

  case 3257: /* action: CONTINUE_P  */
#line 17786 "preproc.y"
                {
			(yyval.action).code = W_NOTHING;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("continue");
		}
#line 63547 "preproc.c"
    break;

  case 3258: /* action: SQL_SQLPRINT  */
#line 17792 "preproc.y"
                {
			(yyval.action).code = W_SQLPRINT;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("sqlprint");
		}
#line 63557 "preproc.c"
    break;

  case 3259: /* action: SQL_STOP  */
#line 17798 "preproc.y"
                {
			(yyval.action).code = W_STOP;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("stop");
		}
#line 63567 "preproc.c"
    break;

  case 3260: /* action: SQL_GOTO name  */
#line 17804 "preproc.y"
                {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = mm_strdup((yyvsp[0].str));
			(yyval.action).str = cat2_str(mm_strdup("goto "), (yyvsp[0].str));
		}
#line 63577 "preproc.c"
    break;

  case 3261: /* action: SQL_GO TO name  */
#line 17810 "preproc.y"
                {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = mm_strdup((yyvsp[0].str));
			(yyval.action).str = cat2_str(mm_strdup("goto "), (yyvsp[0].str));
		}
#line 63587 "preproc.c"
    break;

  case 3262: /* action: DO name '(' c_args ')'  */
#line 17816 "preproc.y"
                {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].str), mm_strdup(")"));
			(yyval.action).str = cat2_str(mm_strdup("do"), mm_strdup((yyval.action).command));
		}
#line 63597 "preproc.c"
    break;

  case 3263: /* action: DO SQL_BREAK  */
#line 17822 "preproc.y"
                {
			(yyval.action).code = W_BREAK;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("break");
		}
#line 63607 "preproc.c"
    break;

  case 3264: /* action: SQL_CALL name '(' c_args ')'  */
#line 17828 "preproc.y"
                {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].str), mm_strdup(")"));
			(yyval.action).str = cat2_str(mm_strdup("call"), mm_strdup((yyval.action).command));
		}
#line 63617 "preproc.c"
    break;

  case 3265: /* action: SQL_CALL name  */
#line 17834 "preproc.y"
                {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat2_str((yyvsp[0].str), mm_strdup("()"));
			(yyval.action).str = cat2_str(mm_strdup("call"), mm_strdup((yyval.action).command));
		}
#line 63627 "preproc.c"
    break;

  case 3266: /* ECPGKeywords: ECPGKeywords_vanames  */
#line 17844 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63633 "preproc.c"
    break;

  case 3267: /* ECPGKeywords: ECPGKeywords_rest  */
#line 17845 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63639 "preproc.c"
    break;

  case 3268: /* ECPGKeywords_vanames: SQL_BREAK  */
#line 17848 "preproc.y"
                                                { (yyval.str) = mm_strdup("break"); }
#line 63645 "preproc.c"
    break;

  case 3269: /* ECPGKeywords_vanames: SQL_CALL  */
#line 17849 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("call"); }
#line 63651 "preproc.c"
    break;

  case 3270: /* ECPGKeywords_vanames: SQL_CARDINALITY  */
#line 17850 "preproc.y"
                                                                { (yyval.str) = mm_strdup("cardinality"); }
#line 63657 "preproc.c"
    break;

  case 3271: /* ECPGKeywords_vanames: SQL_COUNT  */
#line 17851 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("count"); }
#line 63663 "preproc.c"
    break;

  case 3272: /* ECPGKeywords_vanames: SQL_DATETIME_INTERVAL_CODE  */
#line 17852 "preproc.y"
                                                { (yyval.str) = mm_strdup("datetime_interval_code"); }
#line 63669 "preproc.c"
    break;

  case 3273: /* ECPGKeywords_vanames: SQL_DATETIME_INTERVAL_PRECISION  */
#line 17853 "preproc.y"
                                                        { (yyval.str) = mm_strdup("datetime_interval_precision"); }
#line 63675 "preproc.c"
    break;

  case 3274: /* ECPGKeywords_vanames: SQL_FOUND  */
#line 17854 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("found"); }
#line 63681 "preproc.c"
    break;

  case 3275: /* ECPGKeywords_vanames: SQL_GO  */
#line 17855 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("go"); }
#line 63687 "preproc.c"
    break;

  case 3276: /* ECPGKeywords_vanames: SQL_GOTO  */
#line 17856 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("goto"); }
#line 63693 "preproc.c"
    break;

  case 3277: /* ECPGKeywords_vanames: SQL_IDENTIFIED  */
#line 17857 "preproc.y"
                                                                { (yyval.str) = mm_strdup("identified"); }
#line 63699 "preproc.c"
    break;

  case 3278: /* ECPGKeywords_vanames: SQL_INDICATOR  */
#line 17858 "preproc.y"
                                                        { (yyval.str) = mm_strdup("indicator"); }
#line 63705 "preproc.c"
    break;

  case 3279: /* ECPGKeywords_vanames: SQL_KEY_MEMBER  */
#line 17859 "preproc.y"
                                                        { (yyval.str) = mm_strdup("key_member"); }
#line 63711 "preproc.c"
    break;

  case 3280: /* ECPGKeywords_vanames: SQL_LENGTH  */
#line 17860 "preproc.y"
                                                        { (yyval.str) = mm_strdup("length"); }
#line 63717 "preproc.c"
    break;

  case 3281: /* ECPGKeywords_vanames: SQL_NULLABLE  */
#line 17861 "preproc.y"
                                                        { (yyval.str) = mm_strdup("nullable"); }
#line 63723 "preproc.c"
    break;

  case 3282: /* ECPGKeywords_vanames: SQL_OCTET_LENGTH  */
#line 17862 "preproc.y"
                                                        { (yyval.str) = mm_strdup("octet_length"); }
#line 63729 "preproc.c"
    break;

  case 3283: /* ECPGKeywords_vanames: SQL_RETURNED_LENGTH  */
#line 17863 "preproc.y"
                                                { (yyval.str) = mm_strdup("returned_length"); }
#line 63735 "preproc.c"
    break;

  case 3284: /* ECPGKeywords_vanames: SQL_RETURNED_OCTET_LENGTH  */
#line 17864 "preproc.y"
                                                { (yyval.str) = mm_strdup("returned_octet_length"); }
#line 63741 "preproc.c"
    break;

  case 3285: /* ECPGKeywords_vanames: SQL_SCALE  */
#line 17865 "preproc.y"
                                                                { (yyval.str) = mm_strdup("scale"); }
#line 63747 "preproc.c"
    break;

  case 3286: /* ECPGKeywords_vanames: SQL_SECTION  */
#line 17866 "preproc.y"
                                                        { (yyval.str) = mm_strdup("section"); }
#line 63753 "preproc.c"
    break;

  case 3287: /* ECPGKeywords_vanames: SQL_SQLERROR  */
#line 17867 "preproc.y"
                                                        { (yyval.str) = mm_strdup("sqlerror"); }
#line 63759 "preproc.c"
    break;

  case 3288: /* ECPGKeywords_vanames: SQL_SQLPRINT  */
#line 17868 "preproc.y"
                                                        { (yyval.str) = mm_strdup("sqlprint"); }
#line 63765 "preproc.c"
    break;

  case 3289: /* ECPGKeywords_vanames: SQL_SQLWARNING  */
#line 17869 "preproc.y"
                                                        { (yyval.str) = mm_strdup("sqlwarning"); }
#line 63771 "preproc.c"
    break;

  case 3290: /* ECPGKeywords_vanames: SQL_STOP  */
#line 17870 "preproc.y"
                                                                { (yyval.str) = mm_strdup("stop"); }
#line 63777 "preproc.c"
    break;

  case 3291: /* ECPGKeywords_rest: SQL_CONNECT  */
#line 17873 "preproc.y"
                                        { (yyval.str) = mm_strdup("connect"); }
#line 63783 "preproc.c"
    break;

  case 3292: /* ECPGKeywords_rest: SQL_DESCRIBE  */
#line 17874 "preproc.y"
                                                        { (yyval.str) = mm_strdup("describe"); }
#line 63789 "preproc.c"
    break;

  case 3293: /* ECPGKeywords_rest: SQL_DISCONNECT  */
#line 17875 "preproc.y"
                                                        { (yyval.str) = mm_strdup("disconnect"); }
#line 63795 "preproc.c"
    break;

  case 3294: /* ECPGKeywords_rest: SQL_OPEN  */
#line 17876 "preproc.y"
                                                                { (yyval.str) = mm_strdup("open"); }
#line 63801 "preproc.c"
    break;

  case 3295: /* ECPGKeywords_rest: SQL_VAR  */
#line 17877 "preproc.y"
                                                                { (yyval.str) = mm_strdup("var"); }
#line 63807 "preproc.c"
    break;

  case 3296: /* ECPGKeywords_rest: SQL_WHENEVER  */
#line 17878 "preproc.y"
                                                        { (yyval.str) = mm_strdup("whenever"); }
#line 63813 "preproc.c"
    break;

  case 3297: /* ECPGTypeName: SQL_BOOL  */
#line 17882 "preproc.y"
                                                { (yyval.str) = mm_strdup("bool"); }
#line 63819 "preproc.c"
    break;

  case 3298: /* ECPGTypeName: SQL_LONG  */
#line 17883 "preproc.y"
                                                                { (yyval.str) = mm_strdup("long"); }
#line 63825 "preproc.c"
    break;

  case 3299: /* ECPGTypeName: SQL_OUTPUT  */
#line 17884 "preproc.y"
                                                        { (yyval.str) = mm_strdup("output"); }
#line 63831 "preproc.c"
    break;

  case 3300: /* ECPGTypeName: SQL_SHORT  */
#line 17885 "preproc.y"
                                                                { (yyval.str) = mm_strdup("short"); }
#line 63837 "preproc.c"
    break;

  case 3301: /* ECPGTypeName: SQL_STRUCT  */
#line 17886 "preproc.y"
                                                        { (yyval.str) = mm_strdup("struct"); }
#line 63843 "preproc.c"
    break;

  case 3302: /* ECPGTypeName: SQL_SIGNED  */
#line 17887 "preproc.y"
                                                        { (yyval.str) = mm_strdup("signed"); }
#line 63849 "preproc.c"
    break;

  case 3303: /* ECPGTypeName: SQL_UNSIGNED  */
#line 17888 "preproc.y"
                                                        { (yyval.str) = mm_strdup("unsigned"); }
#line 63855 "preproc.c"
    break;

  case 3304: /* symbol: ColLabel  */
#line 17891 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63861 "preproc.c"
    break;

  case 3305: /* ECPGColId: ecpg_ident  */
#line 17894 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63867 "preproc.c"
    break;

  case 3306: /* ECPGColId: unreserved_keyword  */
#line 17895 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63873 "preproc.c"
    break;

  case 3307: /* ECPGColId: col_name_keyword  */
#line 17896 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63879 "preproc.c"
    break;

  case 3308: /* ECPGColId: ECPGunreserved_interval  */
#line 17897 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63885 "preproc.c"
    break;

  case 3309: /* ECPGColId: ECPGKeywords  */
#line 17898 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63891 "preproc.c"
    break;

  case 3310: /* ECPGColId: ECPGCKeywords  */
#line 17899 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63897 "preproc.c"
    break;

  case 3311: /* ECPGColId: CHAR_P  */
#line 17900 "preproc.y"
                                                                { (yyval.str) = mm_strdup("char"); }
#line 63903 "preproc.c"
    break;

  case 3312: /* ECPGColId: VALUES  */
#line 17901 "preproc.y"
                                                                { (yyval.str) = mm_strdup("values"); }
#line 63909 "preproc.c"
    break;

  case 3313: /* ColId: ecpg_ident  */
#line 17914 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63915 "preproc.c"
    break;

  case 3314: /* ColId: all_unreserved_keyword  */
#line 17915 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63921 "preproc.c"
    break;

  case 3315: /* ColId: col_name_keyword  */
#line 17916 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63927 "preproc.c"
    break;

  case 3316: /* ColId: ECPGKeywords  */
#line 17917 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63933 "preproc.c"
    break;

  case 3317: /* ColId: ECPGCKeywords  */
#line 17918 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63939 "preproc.c"
    break;

  case 3318: /* ColId: CHAR_P  */
#line 17919 "preproc.y"
                                                                { (yyval.str) = mm_strdup("char"); }
#line 63945 "preproc.c"
    break;

  case 3319: /* ColId: VALUES  */
#line 17920 "preproc.y"
                                                                { (yyval.str) = mm_strdup("values"); }
#line 63951 "preproc.c"
    break;

  case 3320: /* type_function_name: ecpg_ident  */
#line 17925 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63957 "preproc.c"
    break;

  case 3321: /* type_function_name: all_unreserved_keyword  */
#line 17926 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63963 "preproc.c"
    break;

  case 3322: /* type_function_name: type_func_name_keyword  */
#line 17927 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63969 "preproc.c"
    break;

  case 3323: /* type_function_name: ECPGKeywords  */
#line 17928 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63975 "preproc.c"
    break;

  case 3324: /* type_function_name: ECPGCKeywords  */
#line 17929 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63981 "preproc.c"
    break;

  case 3325: /* type_function_name: ECPGTypeName  */
#line 17930 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63987 "preproc.c"
    break;

  case 3326: /* ColLabel: ECPGColLabel  */
#line 17936 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63993 "preproc.c"
    break;

  case 3327: /* ColLabel: ECPGTypeName  */
#line 17937 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63999 "preproc.c"
    break;

  case 3328: /* ColLabel: CHAR_P  */
#line 17938 "preproc.y"
                                                                { (yyval.str) = mm_strdup("char"); }
#line 64005 "preproc.c"
    break;

  case 3329: /* ColLabel: CURRENT_P  */
#line 17939 "preproc.y"
                                                                { (yyval.str) = mm_strdup("current"); }
#line 64011 "preproc.c"
    break;

  case 3330: /* ColLabel: INPUT_P  */
#line 17940 "preproc.y"
                                                                { (yyval.str) = mm_strdup("input"); }
#line 64017 "preproc.c"
    break;

  case 3331: /* ColLabel: INT_P  */
#line 17941 "preproc.y"
                                                                { (yyval.str) = mm_strdup("int"); }
#line 64023 "preproc.c"
    break;

  case 3332: /* ColLabel: TO  */
#line 17942 "preproc.y"
                                                                { (yyval.str) = mm_strdup("to"); }
#line 64029 "preproc.c"
    break;

  case 3333: /* ColLabel: UNION  */
#line 17943 "preproc.y"
                                                                { (yyval.str) = mm_strdup("union"); }
#line 64035 "preproc.c"
    break;

  case 3334: /* ColLabel: VALUES  */
#line 17944 "preproc.y"
                                                                { (yyval.str) = mm_strdup("values"); }
#line 64041 "preproc.c"
    break;

  case 3335: /* ColLabel: ECPGCKeywords  */
#line 17945 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 64047 "preproc.c"
    break;

  case 3336: /* ColLabel: ECPGunreserved_interval  */
#line 17946 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64053 "preproc.c"
    break;

  case 3337: /* ECPGColLabel: ECPGColLabelCommon  */
#line 17949 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 64059 "preproc.c"
    break;

  case 3338: /* ECPGColLabel: unreserved_keyword  */
#line 17950 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64065 "preproc.c"
    break;

  case 3339: /* ECPGColLabel: reserved_keyword  */
#line 17951 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 64071 "preproc.c"
    break;

  case 3340: /* ECPGColLabel: ECPGKeywords_rest  */
#line 17952 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 64077 "preproc.c"
    break;

  case 3341: /* ECPGColLabel: CONNECTION  */
#line 17953 "preproc.y"
                                                        { (yyval.str) = mm_strdup("connection"); }
#line 64083 "preproc.c"
    break;

  case 3342: /* ECPGColLabelCommon: ecpg_ident  */
#line 17956 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 64089 "preproc.c"
    break;

  case 3343: /* ECPGColLabelCommon: col_name_keyword  */
#line 17957 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 64095 "preproc.c"
    break;

  case 3344: /* ECPGColLabelCommon: type_func_name_keyword  */
#line 17958 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64101 "preproc.c"
    break;

  case 3345: /* ECPGColLabelCommon: ECPGKeywords_vanames  */
#line 17959 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64107 "preproc.c"
    break;

  case 3346: /* ECPGCKeywords: S_AUTO  */
#line 17962 "preproc.y"
                                                { (yyval.str) = mm_strdup("auto"); }
#line 64113 "preproc.c"
    break;

  case 3347: /* ECPGCKeywords: S_CONST  */
#line 17963 "preproc.y"
                                                                { (yyval.str) = mm_strdup("const"); }
#line 64119 "preproc.c"
    break;

  case 3348: /* ECPGCKeywords: S_EXTERN  */
#line 17964 "preproc.y"
                                                                { (yyval.str) = mm_strdup("extern"); }
#line 64125 "preproc.c"
    break;

  case 3349: /* ECPGCKeywords: S_REGISTER  */
#line 17965 "preproc.y"
                                                        { (yyval.str) = mm_strdup("register"); }
#line 64131 "preproc.c"
    break;

  case 3350: /* ECPGCKeywords: S_STATIC  */
#line 17966 "preproc.y"
                                                                { (yyval.str) = mm_strdup("static"); }
#line 64137 "preproc.c"
    break;

  case 3351: /* ECPGCKeywords: S_TYPEDEF  */
#line 17967 "preproc.y"
                                                                { (yyval.str) = mm_strdup("typedef"); }
#line 64143 "preproc.c"
    break;

  case 3352: /* ECPGCKeywords: S_VOLATILE  */
#line 17968 "preproc.y"
                                                        { (yyval.str) = mm_strdup("volatile"); }
#line 64149 "preproc.c"
    break;

  case 3353: /* all_unreserved_keyword: unreserved_keyword  */
#line 17985 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64155 "preproc.c"
    break;

  case 3354: /* all_unreserved_keyword: ECPGunreserved_interval  */
#line 17986 "preproc.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 64161 "preproc.c"
    break;

  case 3355: /* all_unreserved_keyword: CONNECTION  */
#line 17987 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("connection"); }
#line 64167 "preproc.c"
    break;

  case 3356: /* ECPGunreserved_interval: DAY_P  */
#line 17990 "preproc.y"
                                                        { (yyval.str) = mm_strdup("day"); }
#line 64173 "preproc.c"
    break;

  case 3357: /* ECPGunreserved_interval: HOUR_P  */
#line 17991 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("hour"); }
#line 64179 "preproc.c"
    break;

  case 3358: /* ECPGunreserved_interval: MINUTE_P  */
#line 17992 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("minute"); }
#line 64185 "preproc.c"
    break;

  case 3359: /* ECPGunreserved_interval: MONTH_P  */
#line 17993 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("month"); }
#line 64191 "preproc.c"
    break;

  case 3360: /* ECPGunreserved_interval: SECOND_P  */
#line 17994 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("second"); }
#line 64197 "preproc.c"
    break;

  case 3361: /* ECPGunreserved_interval: YEAR_P  */
#line 17995 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("year"); }
#line 64203 "preproc.c"
    break;

  case 3364: /* ecpgstart: SQL_START  */
#line 18002 "preproc.y"
                        {
				reset_variables();
				pacounter = 1;
			}
#line 64212 "preproc.c"
    break;

  case 3365: /* c_args: %empty  */
#line 18008 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 64218 "preproc.c"
    break;

  case 3366: /* c_args: c_list  */
#line 18009 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 64224 "preproc.c"
    break;

  case 3367: /* coutputvariable: cvariable indicator  */
#line 18013 "preproc.y"
                        { add_variable_to_head(&argsresult, find_variable((yyvsp[-1].str)), find_variable((yyvsp[0].str))); }
#line 64230 "preproc.c"
    break;

  case 3368: /* coutputvariable: cvariable  */
#line 18015 "preproc.y"
                        { add_variable_to_head(&argsresult, find_variable((yyvsp[0].str)), &no_indicator); }
#line 64236 "preproc.c"
    break;

  case 3369: /* civarind: cvariable indicator  */
#line 18020 "preproc.y"
                {
			if (find_variable((yyvsp[0].str))->type->type == ECPGt_array)
				mmerror(PARSE_ERROR, ET_ERROR, "arrays of indicators are not allowed on input");

			add_variable_to_head(&argsinsert, find_variable((yyvsp[-1].str)), find_variable((yyvsp[0].str)));
			(yyval.str) = create_questionmarks((yyvsp[-1].str), false);
		}
#line 64248 "preproc.c"
    break;

  case 3370: /* char_civar: char_variable  */
#line 18030 "preproc.y"
                {
			char *ptr = strstr((yyvsp[0].str), ".arr");

			if (ptr) /* varchar, we need the struct name here, not the struct element */
				*ptr = '\0';
			add_variable_to_head(&argsinsert, find_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = (yyvsp[0].str);
		}
#line 64261 "preproc.c"
    break;

  case 3371: /* civar: cvariable  */
#line 18041 "preproc.y"
                {
			add_variable_to_head(&argsinsert, find_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = create_questionmarks((yyvsp[0].str), false);
		}
#line 64270 "preproc.c"
    break;

  case 3372: /* indicator: cvariable  */
#line 18047 "preproc.y"
                                                { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 64276 "preproc.c"
    break;

  case 3373: /* indicator: SQL_INDICATOR cvariable  */
#line 18048 "preproc.y"
                                                { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 64282 "preproc.c"
    break;

  case 3374: /* indicator: SQL_INDICATOR name  */
#line 18049 "preproc.y"
                                                { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 64288 "preproc.c"
    break;

  case 3375: /* cvariable: CVARIABLE  */
#line 18053 "preproc.y"
                {
			/* As long as multidimensional arrays are not implemented we have to check for those here */
			char *ptr = (yyvsp[0].str);
			int brace_open=0, brace = false;

			for (; *ptr; ptr++)
			{
				switch (*ptr)
				{
					case '[':
							if (brace)
								mmfatal(PARSE_ERROR, "multidimensional arrays for simple data types are not supported");
							brace_open++;
							break;
					case ']':
							brace_open--;
							if (brace_open == 0)
								brace = true;
							break;
					case '\t':
					case ' ':
							break;
					default:
							if (brace_open == 0)
								brace = false;
							break;
				}
			}
			(yyval.str) = (yyvsp[0].str);
		}
#line 64323 "preproc.c"
    break;

  case 3376: /* ecpg_param: PARAM  */
#line 18085 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 64329 "preproc.c"
    break;

  case 3377: /* ecpg_bconst: BCONST  */
#line 18087 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 64335 "preproc.c"
    break;

  case 3378: /* ecpg_fconst: FCONST  */
#line 18089 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 64341 "preproc.c"
    break;

  case 3379: /* ecpg_sconst: SCONST  */
#line 18093 "preproc.y"
                {
			/* could have been input as '' or $$ */
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[0].str)) + 3);
			(yyval.str)[0]='\'';
			strcpy((yyval.str)+1, (yyvsp[0].str));
			(yyval.str)[strlen((yyvsp[0].str))+1]='\'';
			(yyval.str)[strlen((yyvsp[0].str))+2]='\0';
			free((yyvsp[0].str));
		}
#line 64355 "preproc.c"
    break;

  case 3380: /* ecpg_sconst: ECONST  */
#line 18103 "preproc.y"
                {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[0].str)) + 4);
			(yyval.str)[0]='E';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[0].str));
			(yyval.str)[strlen((yyvsp[0].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[0].str))+3]='\0';
			free((yyvsp[0].str));
		}
#line 64369 "preproc.c"
    break;

  case 3381: /* ecpg_sconst: NCONST  */
#line 18113 "preproc.y"
                {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[0].str)) + 4);
			(yyval.str)[0]='N';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[0].str));
			(yyval.str)[strlen((yyvsp[0].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[0].str))+3]='\0';
			free((yyvsp[0].str));
		}
#line 64383 "preproc.c"
    break;

  case 3382: /* ecpg_sconst: UCONST  */
#line 18122 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 64389 "preproc.c"
    break;

  case 3383: /* ecpg_sconst: DOLCONST  */
#line 18123 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 64395 "preproc.c"
    break;

  case 3384: /* ecpg_xconst: XCONST  */
#line 18126 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 64401 "preproc.c"
    break;

  case 3385: /* ecpg_ident: IDENT  */
#line 18128 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 64407 "preproc.c"
    break;

  case 3386: /* ecpg_ident: CSTRING  */
#line 18129 "preproc.y"
                                { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 64413 "preproc.c"
    break;

  case 3387: /* ecpg_ident: UIDENT  */
#line 18130 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 64419 "preproc.c"
    break;

  case 3388: /* quoted_ident_stringvar: name  */
#line 18134 "preproc.y"
                        { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 64425 "preproc.c"
    break;

  case 3389: /* quoted_ident_stringvar: char_variable  */
#line 18136 "preproc.y"
                        { (yyval.str) = make3_str(mm_strdup("("), (yyvsp[0].str), mm_strdup(")")); }
#line 64431 "preproc.c"
    break;

  case 3390: /* c_stuff_item: c_anything  */
#line 18143 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64437 "preproc.c"
    break;

  case 3391: /* c_stuff_item: '(' ')'  */
#line 18144 "preproc.y"
                                                { (yyval.str) = mm_strdup("()"); }
#line 64443 "preproc.c"
    break;

  case 3392: /* c_stuff_item: '(' c_stuff ')'  */
#line 18146 "preproc.y"
                        { (yyval.str) = cat_str(3, mm_strdup("("), (yyvsp[-1].str), mm_strdup(")")); }
#line 64449 "preproc.c"
    break;

  case 3393: /* c_stuff: c_stuff_item  */
#line 18149 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 64455 "preproc.c"
    break;

  case 3394: /* c_stuff: c_stuff c_stuff_item  */
#line 18151 "preproc.y"
                        { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 64461 "preproc.c"
    break;

  case 3395: /* c_list: c_term  */
#line 18154 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 64467 "preproc.c"
    break;

  case 3396: /* c_list: c_list ',' c_term  */
#line 18155 "preproc.y"
                                        { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 64473 "preproc.c"
    break;

  case 3397: /* c_term: c_stuff  */
#line 18158 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 64479 "preproc.c"
    break;

  case 3398: /* c_term: '{' c_list '}'  */
#line 18159 "preproc.y"
                                        { (yyval.str) = cat_str(3, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}")); }
#line 64485 "preproc.c"
    break;

  case 3399: /* c_thing: c_anything  */
#line 18162 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 64491 "preproc.c"
    break;

  case 3400: /* c_thing: '('  */
#line 18163 "preproc.y"
                                        { (yyval.str) = mm_strdup("("); }
#line 64497 "preproc.c"
    break;

  case 3401: /* c_thing: ')'  */
#line 18164 "preproc.y"
                                        { (yyval.str) = mm_strdup(")"); }
#line 64503 "preproc.c"
    break;

  case 3402: /* c_thing: ','  */
#line 18165 "preproc.y"
                                        { (yyval.str) = mm_strdup(","); }
#line 64509 "preproc.c"
    break;

  case 3403: /* c_thing: ';'  */
#line 18166 "preproc.y"
                                        { (yyval.str) = mm_strdup(";"); }
#line 64515 "preproc.c"
    break;

  case 3404: /* c_anything: ecpg_ident  */
#line 18169 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64521 "preproc.c"
    break;

  case 3405: /* c_anything: Iconst  */
#line 18170 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64527 "preproc.c"
    break;

  case 3406: /* c_anything: ecpg_fconst  */
#line 18171 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64533 "preproc.c"
    break;

  case 3407: /* c_anything: ecpg_sconst  */
#line 18172 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64539 "preproc.c"
    break;

  case 3408: /* c_anything: '*'  */
#line 18173 "preproc.y"
                                                { (yyval.str) = mm_strdup("*"); }
#line 64545 "preproc.c"
    break;

  case 3409: /* c_anything: '+'  */
#line 18174 "preproc.y"
                                                { (yyval.str) = mm_strdup("+"); }
#line 64551 "preproc.c"
    break;

  case 3410: /* c_anything: '-'  */
#line 18175 "preproc.y"
                                                { (yyval.str) = mm_strdup("-"); }
#line 64557 "preproc.c"
    break;

  case 3411: /* c_anything: '/'  */
#line 18176 "preproc.y"
                                                { (yyval.str) = mm_strdup("/"); }
#line 64563 "preproc.c"
    break;

  case 3412: /* c_anything: '%'  */
#line 18177 "preproc.y"
                                                { (yyval.str) = mm_strdup("%"); }
#line 64569 "preproc.c"
    break;

  case 3413: /* c_anything: NULL_P  */
#line 18178 "preproc.y"
                                                { (yyval.str) = mm_strdup("NULL"); }
#line 64575 "preproc.c"
    break;

  case 3414: /* c_anything: S_ADD  */
#line 18179 "preproc.y"
                                                { (yyval.str) = mm_strdup("+="); }
#line 64581 "preproc.c"
    break;

  case 3415: /* c_anything: S_AND  */
#line 18180 "preproc.y"
                                                { (yyval.str) = mm_strdup("&&"); }
#line 64587 "preproc.c"
    break;

  case 3416: /* c_anything: S_ANYTHING  */
#line 18181 "preproc.y"
                                                { (yyval.str) = make_name(); }
#line 64593 "preproc.c"
    break;

  case 3417: /* c_anything: S_AUTO  */
#line 18182 "preproc.y"
                                                { (yyval.str) = mm_strdup("auto"); }
#line 64599 "preproc.c"
    break;

  case 3418: /* c_anything: S_CONST  */
#line 18183 "preproc.y"
                                                { (yyval.str) = mm_strdup("const"); }
#line 64605 "preproc.c"
    break;

  case 3419: /* c_anything: S_DEC  */
#line 18184 "preproc.y"
                                                { (yyval.str) = mm_strdup("--"); }
#line 64611 "preproc.c"
    break;

  case 3420: /* c_anything: S_DIV  */
#line 18185 "preproc.y"
                                                { (yyval.str) = mm_strdup("/="); }
#line 64617 "preproc.c"
    break;

  case 3421: /* c_anything: S_DOTPOINT  */
#line 18186 "preproc.y"
                                                { (yyval.str) = mm_strdup(".*"); }
#line 64623 "preproc.c"
    break;

  case 3422: /* c_anything: S_EQUAL  */
#line 18187 "preproc.y"
                                                { (yyval.str) = mm_strdup("=="); }
#line 64629 "preproc.c"
    break;

  case 3423: /* c_anything: S_EXTERN  */
#line 18188 "preproc.y"
                                                { (yyval.str) = mm_strdup("extern"); }
#line 64635 "preproc.c"
    break;

  case 3424: /* c_anything: S_INC  */
#line 18189 "preproc.y"
                                                { (yyval.str) = mm_strdup("++"); }
#line 64641 "preproc.c"
    break;

  case 3425: /* c_anything: S_LSHIFT  */
#line 18190 "preproc.y"
                                                { (yyval.str) = mm_strdup("<<"); }
#line 64647 "preproc.c"
    break;

  case 3426: /* c_anything: S_MEMBER  */
#line 18191 "preproc.y"
                                                { (yyval.str) = mm_strdup("->"); }
#line 64653 "preproc.c"
    break;

  case 3427: /* c_anything: S_MEMPOINT  */
#line 18192 "preproc.y"
                                                { (yyval.str) = mm_strdup("->*"); }
#line 64659 "preproc.c"
    break;

  case 3428: /* c_anything: S_MOD  */
#line 18193 "preproc.y"
                                                { (yyval.str) = mm_strdup("%="); }
#line 64665 "preproc.c"
    break;

  case 3429: /* c_anything: S_MUL  */
#line 18194 "preproc.y"
                                                { (yyval.str) = mm_strdup("*="); }
#line 64671 "preproc.c"
    break;

  case 3430: /* c_anything: S_NEQUAL  */
#line 18195 "preproc.y"
                                                { (yyval.str) = mm_strdup("!="); }
#line 64677 "preproc.c"
    break;

  case 3431: /* c_anything: S_OR  */
#line 18196 "preproc.y"
                                                { (yyval.str) = mm_strdup("||"); }
#line 64683 "preproc.c"
    break;

  case 3432: /* c_anything: S_REGISTER  */
#line 18197 "preproc.y"
                                                { (yyval.str) = mm_strdup("register"); }
#line 64689 "preproc.c"
    break;

  case 3433: /* c_anything: S_RSHIFT  */
#line 18198 "preproc.y"
                                                { (yyval.str) = mm_strdup(">>"); }
#line 64695 "preproc.c"
    break;

  case 3434: /* c_anything: S_STATIC  */
#line 18199 "preproc.y"
                                                { (yyval.str) = mm_strdup("static"); }
#line 64701 "preproc.c"
    break;

  case 3435: /* c_anything: S_SUB  */
#line 18200 "preproc.y"
                                                { (yyval.str) = mm_strdup("-="); }
#line 64707 "preproc.c"
    break;

  case 3436: /* c_anything: S_TYPEDEF  */
#line 18201 "preproc.y"
                                                { (yyval.str) = mm_strdup("typedef"); }
#line 64713 "preproc.c"
    break;

  case 3437: /* c_anything: S_VOLATILE  */
#line 18202 "preproc.y"
                                                { (yyval.str) = mm_strdup("volatile"); }
#line 64719 "preproc.c"
    break;

  case 3438: /* c_anything: SQL_BOOL  */
#line 18203 "preproc.y"
                                                { (yyval.str) = mm_strdup("bool"); }
#line 64725 "preproc.c"
    break;

  case 3439: /* c_anything: ENUM_P  */
#line 18204 "preproc.y"
                                                { (yyval.str) = mm_strdup("enum"); }
#line 64731 "preproc.c"
    break;

  case 3440: /* c_anything: HOUR_P  */
#line 18205 "preproc.y"
                                                { (yyval.str) = mm_strdup("hour"); }
#line 64737 "preproc.c"
    break;

  case 3441: /* c_anything: INT_P  */
#line 18206 "preproc.y"
                                                { (yyval.str) = mm_strdup("int"); }
#line 64743 "preproc.c"
    break;

  case 3442: /* c_anything: SQL_LONG  */
#line 18207 "preproc.y"
                                                { (yyval.str) = mm_strdup("long"); }
#line 64749 "preproc.c"
    break;

  case 3443: /* c_anything: MINUTE_P  */
#line 18208 "preproc.y"
                                                { (yyval.str) = mm_strdup("minute"); }
#line 64755 "preproc.c"
    break;

  case 3444: /* c_anything: MONTH_P  */
#line 18209 "preproc.y"
                                                { (yyval.str) = mm_strdup("month"); }
#line 64761 "preproc.c"
    break;

  case 3445: /* c_anything: SECOND_P  */
#line 18210 "preproc.y"
                                                { (yyval.str) = mm_strdup("second"); }
#line 64767 "preproc.c"
    break;

  case 3446: /* c_anything: SQL_SHORT  */
#line 18211 "preproc.y"
                                                { (yyval.str) = mm_strdup("short"); }
#line 64773 "preproc.c"
    break;

  case 3447: /* c_anything: SQL_SIGNED  */
#line 18212 "preproc.y"
                                                { (yyval.str) = mm_strdup("signed"); }
#line 64779 "preproc.c"
    break;

  case 3448: /* c_anything: SQL_STRUCT  */
#line 18213 "preproc.y"
                                                { (yyval.str) = mm_strdup("struct"); }
#line 64785 "preproc.c"
    break;

  case 3449: /* c_anything: SQL_UNSIGNED  */
#line 18214 "preproc.y"
                                                { (yyval.str) = mm_strdup("unsigned"); }
#line 64791 "preproc.c"
    break;

  case 3450: /* c_anything: YEAR_P  */
#line 18215 "preproc.y"
                                                { (yyval.str) = mm_strdup("year"); }
#line 64797 "preproc.c"
    break;

  case 3451: /* c_anything: CHAR_P  */
#line 18216 "preproc.y"
                                                { (yyval.str) = mm_strdup("char"); }
#line 64803 "preproc.c"
    break;

  case 3452: /* c_anything: FLOAT_P  */
#line 18217 "preproc.y"
                                                { (yyval.str) = mm_strdup("float"); }
#line 64809 "preproc.c"
    break;

  case 3453: /* c_anything: TO  */
#line 18218 "preproc.y"
                                                { (yyval.str) = mm_strdup("to"); }
#line 64815 "preproc.c"
    break;

  case 3454: /* c_anything: UNION  */
#line 18219 "preproc.y"
                                                { (yyval.str) = mm_strdup("union"); }
#line 64821 "preproc.c"
    break;

  case 3455: /* c_anything: VARCHAR  */
#line 18220 "preproc.y"
                                                { (yyval.str) = mm_strdup("varchar"); }
#line 64827 "preproc.c"
    break;

  case 3456: /* c_anything: '['  */
#line 18221 "preproc.y"
                                                { (yyval.str) = mm_strdup("["); }
#line 64833 "preproc.c"
    break;

  case 3457: /* c_anything: ']'  */
#line 18222 "preproc.y"
                                                { (yyval.str) = mm_strdup("]"); }
#line 64839 "preproc.c"
    break;

  case 3458: /* c_anything: '='  */
#line 18223 "preproc.y"
                                                { (yyval.str) = mm_strdup("="); }
#line 64845 "preproc.c"
    break;

  case 3459: /* c_anything: ':'  */
#line 18224 "preproc.y"
                                                { (yyval.str) = mm_strdup(":"); }
#line 64851 "preproc.c"
    break;

  case 3460: /* DeallocateStmt: DEALLOCATE prepared_name  */
#line 18227 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 64857 "preproc.c"
    break;

  case 3461: /* DeallocateStmt: DEALLOCATE PREPARE prepared_name  */
#line 18228 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 64863 "preproc.c"
    break;

  case 3462: /* DeallocateStmt: DEALLOCATE ALL  */
#line 18229 "preproc.y"
                                                        { (yyval.str) = mm_strdup("all"); }
#line 64869 "preproc.c"
    break;

  case 3463: /* DeallocateStmt: DEALLOCATE PREPARE ALL  */
#line 18230 "preproc.y"
                                                        { (yyval.str) = mm_strdup("all"); }
#line 64875 "preproc.c"
    break;

  case 3464: /* Iresult: Iconst  */
#line 18233 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64881 "preproc.c"
    break;

  case 3465: /* Iresult: '(' Iresult ')'  */
#line 18234 "preproc.y"
                                                { (yyval.str) = cat_str(3, mm_strdup("("), (yyvsp[-1].str), mm_strdup(")")); }
#line 64887 "preproc.c"
    break;

  case 3466: /* Iresult: Iresult '+' Iresult  */
#line 18235 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("+"), (yyvsp[0].str)); }
#line 64893 "preproc.c"
    break;

  case 3467: /* Iresult: Iresult '-' Iresult  */
#line 18236 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("-"), (yyvsp[0].str)); }
#line 64899 "preproc.c"
    break;

  case 3468: /* Iresult: Iresult '*' Iresult  */
#line 18237 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("*"), (yyvsp[0].str)); }
#line 64905 "preproc.c"
    break;

  case 3469: /* Iresult: Iresult '/' Iresult  */
#line 18238 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("/"), (yyvsp[0].str)); }
#line 64911 "preproc.c"
    break;

  case 3470: /* Iresult: Iresult '%' Iresult  */
#line 18239 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("%"), (yyvsp[0].str)); }
#line 64917 "preproc.c"
    break;

  case 3471: /* Iresult: ecpg_sconst  */
#line 18240 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64923 "preproc.c"
    break;

  case 3472: /* Iresult: ColId  */
#line 18241 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 64929 "preproc.c"
    break;

  case 3473: /* Iresult: ColId '(' var_type ')'  */
#line 18242 "preproc.y"
                                                { if (pg_strcasecmp((yyvsp[-3].str), "sizeof") != 0)
							mmerror(PARSE_ERROR, ET_ERROR, "operator not allowed in variable definition");
						  else
							(yyval.str) = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].type).type_str, mm_strdup(")"));
						}
#line 64939 "preproc.c"
    break;

  case 3474: /* execute_rest: %empty  */
#line 18249 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 64945 "preproc.c"
    break;

  case 3475: /* execute_rest: ecpg_using opt_ecpg_into  */
#line 18250 "preproc.y"
                                    { (yyval.str) = EMPTY; }
#line 64951 "preproc.c"
    break;

  case 3476: /* execute_rest: ecpg_into ecpg_using  */
#line 18251 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 64957 "preproc.c"
    break;

  case 3477: /* execute_rest: ecpg_into  */
#line 18252 "preproc.y"
                                                { (yyval.str) = EMPTY; }
#line 64963 "preproc.c"
    break;

  case 3478: /* ecpg_into: INTO into_list  */
#line 18255 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 64969 "preproc.c"
    break;

  case 3479: /* ecpg_into: into_descriptor  */
#line 18256 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 64975 "preproc.c"
    break;

  case 3480: /* opt_ecpg_into: %empty  */
#line 18259 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 64981 "preproc.c"
    break;

  case 3481: /* opt_ecpg_into: ecpg_into  */
#line 18260 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 64987 "preproc.c"
    break;

  case 3482: /* ecpg_fetch_into: ecpg_into  */
#line 18263 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 64993 "preproc.c"
    break;

  case 3483: /* ecpg_fetch_into: using_descriptor  */
#line 18265 "preproc.y"
        {
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);
		(yyval.str) = (yyvsp[0].str);
	}
#line 65006 "preproc.c"
    break;

  case 3484: /* opt_ecpg_fetch_into: %empty  */
#line 18275 "preproc.y"
                                        { (yyval.str) = EMPTY; }
#line 65012 "preproc.c"
    break;

  case 3485: /* opt_ecpg_fetch_into: ecpg_fetch_into  */
#line 18276 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 65018 "preproc.c"
    break;


#line 65022 "preproc.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 18279 "preproc.y"


void base_yyerror(const char *error)
{
	/* translator: %s is typically the translation of "syntax error" */
	mmerror(PARSE_ERROR, ET_ERROR, "%s at or near \"%s\"",
			_(error), token_start ? token_start : base_yytext);
}

void parser_init(void)
{
 /* This function is empty. It only exists for compatibility with the backend parser right now. */
}
